/* $RCSfile: baseObject.cc,v $  */

/*
$Header: /home/chara/cvsroot/ople/sys/comm/baseObject/baseObject.cc,v 1.1.1.1 1998/06/11 21:36:19 chara Exp $
*/

/*
$log$
*/

#include "baseObject.h"

/****
[[U tBaseObject::tBaseObject ()]]
****/
tBaseObject::tBaseObject () :
  tObjectId ("Old Usage", NULL) ,
  ecInitError (OK),
  bInit (TRUE)
{}


/****
[[U tBaseObject::tBaseObject (sSubName, pParentId )]]
****/
tBaseObject::tBaseObject (const char* sSubName, const tObjectId* pParentId) :
  tObjectId (sSubName, pParentId), 
  ecInitError (OK),
  bInit (TRUE)
{}


/****
[[U tBaseObject::~tBaseObject ()]]
****/
tBaseObject::~tBaseObject () {}


/****
[[U tBaseObject::SetInitError ()]]
****/
void tBaseObject::SetInitError (ERROR_CODE ecErrCode) {
  this->ecInitError = ecErrCode;
}

/****
[[U tBaseObject::GetInitError ()]]
****/
ERROR_CODE tBaseObject::GetInitError () const { 
  return this->ecInitError;
}

/****
[[U tBaseObject::IsOk ()]]
****/
BOOL tBaseObject::IsOk () const { 
  return (this->ecInitError == OK);
}

/****
[[U tBaseObject::IsInit ()]]
****/
BOOL tBaseObject::IsInit () const {
  return this->bInit;
}

/****
[[U tBaseObject::SetInit ()]]
****/
void tBaseObject::SetInit (BOOL bInitToUse) {
  this->bInit = bInitToUse;
}


/****
[[U tBaseObject::Restart ()]]
****/
ERROR_CODE tBaseObject::Restart () { 
  if (this->bInit == TRUE) TraceMsg (tmt_WARN,S_baseObject_ALREADY_INITIALIZED,
     "tBaseObject::Restart()");
  this->bInit = TRUE;
  return OK;
}

/****
[[U tBaseObject::Shutdown ()]]
****/
ERROR_CODE tBaseObject::Shutdown () { 
  if (this->bInit == FALSE) TraceMsg (tmt_WARN,S_baseObject_ALREADY_SHUTDOWN,
     "tBaseObject::Shutdown()");
  this->bInit = FALSE;
  return OK;
}

ostream &operator<< (ostream& stream, const tBaseObject &BaseObject) {
 
   stream << "Initialization Error =" << BaseObject.ecInitError << endl <<
             "Object Initialized ? ";
             
   if (BaseObject.bInit == TRUE) stream << "TRUE" << endl;
   else stream << "FALSE" << endl;
   
   return stream;
}
