/*****
$RCSfile: objectId.cc,v $

$Header: /home/chara/cvsroot/ople/sys/comm/baseObject/objectId.cc,v 1.1.1.1 1998/06/11 21:36:19 chara Exp $

$log$
****/

#include "objectId.h"
#include "string.h"

/*****
* tObjectId::tObjectId
*
[[U5 tObjectId::tObjectId (sSubNameIn, pParentIdIn) ]]
****/
tObjectId::tObjectId (const char* sSubNameIn, const tObjectId* pParentIdIn) :
  pParentId (pParentIdIn) 
{
  // root name add 1 char for null char.
  if (pParentIdIn) {
    this->sSubName = new char [strlen (sSubNameIn) + 1]; 
    
    /****
    [ this->sSubName := deep copy of sSubNameIn ]
    ****/
    strcpy (this->sSubName, sSubNameIn);
  }
  
  // sub name add 1 char for null char & 1 char for "." separator
  else { 
    this->sSubName = new char [strlen (sSubNameIn) + 2];

    /****
    [ this->sSubName := '.' + deep copy of this->sSubNameIn ]
    ****/
    {
      strcpy (this->sSubName, ".");
      strcat (this->sSubName, sSubNameIn);
    }
  }
  
}


/*****
* tObjectId::~tObjectId
*
[[U5 tObjectId::~tObjectId () ]]
****/
tObjectId::~tObjectId ()
{
  delete [] this->sSubName;
}

/*****
* tObjectId::IdDepth
*
[[U5 tObjectId::IdDepth () ]]
****/
int tObjectId::IdDepth () const
{
  if (this->pParentId) {
    /****
    [[U iDepth := this->pParentId->tObjectId::IdDepth () ]]
    [ return := 1 + iDepth ]
    ****/
    return 1 + this->pParentId->IdDepth ();
  }
  else return 1;
}

/*****
* tObjectId::IdLength
*
[[U5 tObjectId::IdLength () ]]
****/
int tObjectId::IdLength () const
{
  if (this->pParentId) {
    /****
    [[U iLength := this->pParentId->tObjectId::IdLength () ]]
    [ return := StringLength (this->sSubName) + iLength ]
    ****/
    return strlen (this->sSubName) + this->pParentId->IdLength ();
  }
  else return strlen (this->sSubName) + 1; // include null char as part of the length
}


/*****
* tObjectId::ObjectId
*
[[U5 tObjectId::ObjectId (sObjectId, iMaxChar) ]]
****/
void tObjectId::ObjectId (char* sObjectId, size_t iMaxChar) const
{

  if (iMaxChar < strlen (this->sSubName) + 1) return;
  
  if (this->pParentId) {
    /****
    [[U this->pParentId->tObjectId::ObjectId (sObjectId, (iMaxChar - 
          StringLength (this->sSubName))) ]]
    ****/
    this->pParentId->ObjectId (sObjectId, iMaxChar - strlen (this->sSubName) );
    
    /****
    [ sObjectId := sObjectId + this->sSubName ]
    ****/
    strcat (sObjectId, this->sSubName);
  }
  
  /****
  [ sObjectId := deep copy of this->sSubName
  ****/
  else strcpy (sObjectId, this->sSubName);
}

