/* $RCSfile: dlActuator.cc,v $  */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/comm/io/dlActuator.cc,v 1.1.1.1 1998/06/11 21:36:18 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */
 
/*
modification history
--------------------
04a,rlj,2Sept97      changed to dlActuator from dlTargetActuator
01a,rlj,18,Apr,97    written
*/

#include "dlActuator.h" 


tDlActuator::tDlActuator (const tIpcDblBufferId& iiId) :
  
  TargetBuffer (iiId) {

  ERROR_CODE ecTemp; 
 
  ecTemp = this->TargetBuffer.GetInitError();
  if (ecTemp != OK) {
    TraceMsg (tmt_ERROR,ecTemp,"tDlTargetActuator::tDlTargetActuator()");
    return;
  }

  /****
  [[U tDlActuator::Reset (void) ]]
  ****/
  this->Reset ();
}
  
void tDlActuator::SetTargetValue (const tDlTarget& NewTarget) {

  this->Target = NewTarget;
}
    
/****
[[U tDlActuator::Output(tUpdateTime) ]]
****/
ERROR_CODE tDlActuator::Output (TIME tUpdateTime) {

  ERROR_CODE ec;
  tDlTarget Temp;

  /****
  [[U return := this->TargetBuffer::tIpcDlbBufferAccessor.Put (this->Target) ]]
  ****/  
  return this->TargetBuffer.Put (this->Target);
}

/****
[[U tDlActuator::OutputValue (tUpdateTime, NewTarget) ]]
****/
ERROR_CODE tDlActuator::OutputValue (TIME tUpdateTime, const tDlTarget& NewTarget) {

  this->Target = NewTarget;

  /****
  [[U return := this->TargetBuffer::tIpcDlbBufferAccessor.Put (NewTarget) ]]
  ****/  
  return this->TargetBuffer.Put (NewTarget);

}


/****
[[U tDlActuator::Reset () ]]
****/
ERROR_CODE tDlActuator::Reset () {

  this->Target = tDlTarget (0.0, 0.0, ::GetTime () );
  /****
  [[U return := this->TargetBuffer::tIpcDlbBufferAccessor.Put (this->Target) ]]
  ****/  
  return this->TargetBuffer.Put (this->Target);
}
