/* $RCSfile: stActuator.cc,v $  */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/comm/io/stActuator.cc,v 1.1.1.1 1998/06/11 21:36:19 chara Exp $
*/
/* Derek Slye - Jet Propulsion Laboratory */
 

#include "stActuator.h" 

/*************************************************************************
 
NAME: tStActuator::tStActuator (int iHSize, int iVSize,
                          const tIpcIndirectionDblBufferId& iiId) 

DESCRIPTION: 
  [[UD this->tStActuator::tStActuator(iHSize,iVSize,iiId)]]

BEHAVIOR: 
  [[U3 this->tStActuator::tStActuator(iHSize,iVSize,iiId) ]]

*************************************************************************/
tStActuator::tStActuator (int iHSize, int iVSize,
                          const tIpcIndirectionDblBufferId& iiId) :
  
  /***
  [[U (this->Image).tImage::tImage_ii(iHSize,iVSize) ]]
  ***/
  Image (iHSize,iVSize),

  /***
  [[U (this->DefaultImage).tImage::tImage_ii(iHSize,iVSize) ]]
  ***/
  DefaultImage (iHSize,iVSize),

  /***
  [[U (this->ImageBuffer).tIpcIndirectionDblBufferAccessor::tIpcIndirectionDblBufferAccessor(iiId) ]]
  ***/
  ImageBuffer (iiId) {

  ERROR_CODE ecTemp; 
  int x,y;

  /***
  [[U  ecTemp := this->ImageBuffer.tIpcIndirectionDblBufferAccessor::GetInitError(void) ]]
  ***/
  ecTemp = this->ImageBuffer.GetInitError();
  if (ecTemp != OK) {
    TraceMsg (tmt_ERROR,ecTemp,"tStTargetActuator::tStTargetActuator()");
    return;
  }
  //  Default CheckerBoard Pattern with four squares

  for (x = 0; x < iHSize/2; x++) 
    for (y = 0; y < iVSize/2; y++ ) 
 
      /****
      [[U this->DefaultImage.tImage::GetPixel (x,y) ]]
      ****/
      this->DefaultImage.GetPixel (x,y) = 255; 

  for (x = iHSize/2 + 1; x < iHSize; x++) 
    for (y = iVSize/2; y < iVSize;  y++ ) 

      /****
      [[U this->DefaultImage.tImage::GetPixel (x,y) ]]
      ****/
      this->DefaultImage.GetPixel (x,y) = 255;
 
  for (x = 0; x < iHSize/2; x++) 
    for (y = iVSize/2; y < iVSize;  y++ ) 

      /****
      [[U this->DefaultImage.tImage::GetPixel (x,y) ]]
      ****/
      this->DefaultImage.GetPixel (x,y) = 0; 

  for (x = iHSize/2 + 1; x < iHSize; x++) 
    for (y = 0; y < iVSize/2; y++ ) 

      /****
      [[U this->DefaultImage.tImage::GetPixel (x,y) ]]
      ****/
      this->DefaultImage.GetPixel (x,y) = 0;
 
  this->Image = this->DefaultImage;

}
  
/*************************************************************************
 
NAME: tStActuator::SetImage (const tImage& NewImage) 

DESCRIPTION: 
  [[UD this->tStActuator::SetImage(NewImage)]]

BEHAVIOR: 
  [[U3 this->tStActuator::SetImage(NewImage) ]]

*************************************************************************/
void tStActuator::SetImage (const tImage& NewImage) {

  /***
  [[U predicate := this->Image.tImage::IsSameSize_t(NewImage) ]]
  ***/
  if ( this->Image.IsSameSize (NewImage) ) 
    this->Image = NewImage;

  else TraceMsg (tmt_ERROR,S_stactuator_INVALID_STAR_IMAGE_SIZE,"tStActuator::SetImage");
}
    
/*************************************************************************
 
NAME: tStActuator::Output (TIME tUpdateTime) 

DESCRIPTION: 
  [[UD this->tStActuator::Output(tUpdateTime)]]

BEHAVIOR: 
  [[U3 this->tStActuator::Output(tUpdateTime) ]]

*************************************************************************/
ERROR_CODE tStActuator::Output (TIME tUpdateTime) {

  /****
  [[U return := this->ImageBuffer.tIpcIndirectionDblBufferAccessor::Put (this->Image) ]]
  ****/  
  return this->ImageBuffer.Put (this->Image);
}

/*************************************************************************
 
NAME: tStActuator::Reset (void) 

DESCRIPTION: 
  [[UD this->tStActuator::Reset(void)]]

BEHAVIOR: 
  [[U3 this->tStActuator::Reset(void) ]]

*************************************************************************/
ERROR_CODE tStActuator::Reset () {

  this->Image = this->DefaultImage;
  /****
  [[U return := this->ImageBuffer.tIpcIndirectionDblBufferAccessor::Put (this->Image) ]]
  ****/  
  return this->ImageBuffer.Put (this->Image);
}
