
#include "tList.h"

tList::tList () {
  lstInit (&this->lListDescriptor);
}

tList::~tList () {
  lstFree (&this->lListDescriptor);
}

void tList::Add (tNode *pNode) {
  lstAdd (&this->lListDescriptor,pNode);
}

void Concat (tList *pDstList, tList *pAddList) {
  lstConcat (&(pDstList->lListDescriptor),
             &(pAddList->lListDescriptor ) );
}

int tList::Count () {
 return lstCount (&this->lListDescriptor);
}
  
void tList::Delete (tNode *pNode) {
  lstDelete (&this->lListDescriptor,pNode);
}

void Extract (tList *pSrcList, 
              tNode *pStartNode, 
              tNode *pEndNode, 
              tList *pExtractList) {
  lstExtract (&(pSrcList->lListDescriptor),
              pStartNode,pEndNode,
              &(pExtractList->lListDescriptor) );
}
              
tNode *tList::First()  {
  return (tNode *) lstFirst (&this->lListDescriptor);
}
  
tNode *tList::Last()  {
  return (tNode *) lstLast (&this->lListDescriptor);
}


tNode *tList::Next (tNode *pNode) {
  return  (tNode *) lstNext (pNode);
}

tNode *tList::Nth (int iNodeNum) {
  return (tNode *) lstNth (&this->lListDescriptor,iNodeNum);
}

tNode *tList::Previous (tNode *pNode) {
  return (tNode *) lstPrevious (pNode);
}


tNode *tList::NStep (tNode *pNode, int iNStep) {
  return (tNode *) lstNStep (pNode,iNStep);
}

int tList::Find (tNode *pNode) {
  return lstFind (&this->lListDescriptor,pNode);
}

void tList::Free () {
  lstFree (&this->lListDescriptor);
};  

