/* $RCSfile: wobbleTarget.cc,v $ */
/* $Header: /home/chara/cvsroot/ople/sys/gizmo/ft/wobbleTarget.cc,v 1.1.1.1 1998/06/11 21:36:24 chara Exp $ */

/*
modification history
--------------------
04c,4Dec97, rlj    written
*/


#include "ft/wobbleTarget.h"


/******************************************************************
*
* tWobbleTarget::tWobbleTarget (int iWobbleMemoryToUse)
*
* DESCRIPTION: 
    Constructs defuult wobble target.
*
[[U tWobbleTarget::tWobbleTarget (iWobbleMemoryToUse) ]]
****/
tWobbleTarget::tWobbleTarget (int iWobbleMemoryToUse) : 

  /****
  [[U tModulation::tModulation (void) ]]
  ****/
  tModulation (),
  
  iWobbleMemory (MAX (0,iWobbleMemoryToUse) ),

  /****
  [[U WobbleTargets.tRingBuffer::tRingBuffer (iWobbleMemory) ]]
  ****/
  WobbleTargets (iWobbleMemory,0.0),
  
  dBadWobbleTarget (0.0)
{
  /****
  [[U tModulation::Enable (void) ]]
  ****/
  this->Enable ();

}



/******************************************************************
*
* tWobbleTarget::tWobbleTarget (int iWobbleMemoryToUse,
     const tModulationParams& ModulationParamaters)
*
* DESCRIPTION: 
    Constructs wobble target with specified parameters.
* 
[[U tWobbleTarget::tWobbleTarget (iWobbleMemoryToUse, ModulationParameters) ]]
****/ 
tWobbleTarget::tWobbleTarget (int iWobbleMemoryToUse,
     const tModulationParams& ModulationParameters) : 

  /****
  [[U tModulation::tModulation () ]]
  ****/
  tModulation (),

  iWobbleMemory (MAX (0,iWobbleMemoryToUse) ),

  /****
  [[U WobbleTargets.tRingBuffer::tRingBuffer (iWobbleMemory) ]]
  ****/
  WobbleTargets (iWobbleMemory,0.0),
 
  dBadWobbleTarget (0.0)
{

  /****
  [[U tModulation::tModulation (ModulationParameters) ]]
  ****/
  this->SetParameters (ModulationParameters);

  /****
  [[U tModulation::Enable (void) ]]
  ****/
  this->Enable ();

}




/******************************************************************
*
* tWobbleTarget::Calculate (TIME tTime)
*
* DESCRIPTION: 
    
*
[[U tWobbleTarget::tWobbleTarget (tTime) ]]
****/
double tWobbleTarget::Calculate (TIME tTime)
{
 
  double dTarget;

  /****
  [[U dTarget := tModulation::ComputeModulation (tTime) ]]
  ****/
  dTarget = this->ComputeModulation (tTime);


  /****
  [[U tRingBuffer::Append (dTarget) ]]
  ****/
  return this->WobbleTargets.Append (dTarget);

}

const double& tWobbleTarget::operator[] (int iWobbleIndex) const
{ 
  // trying to access future values || trying to access 1 element too far in the past.
  if ( iWobbleIndex > 0 || 
       iWobbleIndex <= -this->iWobbleMemory) return this->dBadWobbleTarget; 

  /****
  [[U this->WobbleTargets.tRingBuffer::operator_index (iWobbleIndex) ]]
  ****/
  return this->WobbleTargets [iWobbleIndex];
}



void tWobbleTarget::Reset ()
{
  /****
  [[U this->WobbleTargets.tRingBuffer::Fill (0.0) ]]
  ****/
  this->WobbleTargets.Fill (0.0);
}


