/* $RCSfile: realTimeGizmoInfo.cc,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/gizmo/genericGizmo/realTimeGizmoInfo.cc,v 1.1.1.1 1998/06/11 21:36:24 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a27Aug97,rlj    written
*/

#include "realTimeGizmoInfo.h"

tRealtimeGizmoInfo::tRealtimeGizmoInfo (int iRteId, int iGizmoId,
					int iNumberOfServoModesToUse, 
                                        const tServoInfo& ServoInfoToUse) :
  tGizmoInfo (iRteId, iGizmoId),
  ServoInfo (ServoInfoToUse) {

  this->iNumberOfServoModes = iNumberOfServoModesToUse;

}


tServoInfo tRealtimeGizmoInfo::GetServoInfo () const  {
 
  return tServoInfo (this->ServoInfo);
}

int tRealtimeGizmoInfo::GetNumberOfServoModes () const {

  return this->iNumberOfServoModes;
}

int tRealtimeGizmoInfo::GetNumberOfServoPartitions () const {

  return this->ServoInfo.GetNumberOfPartitions ();
}
