/* $RCSfile: gsuDlIoSet.cc,v $ */

/*
$Header: /home/chara/cvsroot/ople/sys/gsu/gsuDl/gsuDlIoSet.cc,v 1.1.1.1 1998/06/11 21:36:39 chara Exp $
*/

/* Beth McKenney - Jet Propulsion Laboratory */
 
/*
$Log: gsuDlIoSet.cc,v $
Revision 1.1.1.1  1998/06/11 21:36:39  chara
First import of RICST Code

Revision 1.4.2.2  1998/04/30 20:35:49  rbrill
commit before build_5a_008

Revision 1.4.2.1  1998/04/23 16:51:19  rich
changes for build 7

Revision 1.4  1998/04/02 21:01:03  phil
Build I5a near complete; still some configMgr stuff left

Revision 1.3  1998/03/12 17:58:53  rich
*** empty log message ***

*/
 
/*
DESCRIPTION

*/

#include "isit.h"
#include "gsu/gsuDlGizmoInfo.h"
#include "gsu/gsuDlIoSet.h"
#include "dlTargGen.h"
#include "dlDither.h"




/******************************************************************
*
* tGsuDlCompleteIoSet::tGsuDlCompleteIoSet
*
* SPECIFICATION:
[[U5 tGsuDlCompleteIoSet::tGsuDlCompleteIoSet (GizmoInfo) ]]
*****/
tGsuDlCompleteIoSet::tGsuDlCompleteIoSet (const tGsuDlGizmoInfo& GizmoInfo) :

   /***
   [[U tDlCompleteIoSet::tDlCompleteIoSet (GizmoInfo) ]]
   ***/
   tDlCompleteIoSet (GizmoInfo), 
 
   /***
   [[U this->Eddy1.tModulatedSensor::tModulatedSensor_tdtd (*GizmoInfo.pEddy1Channel, 
         GizmoInfo.PhysConst.dEddy1Scale,
          ZERO_MODULATION, GizmoInfo.PhysConst.dEddy1Offset ) ]]
   ***/
   Eddy1 (*GizmoInfo.pEddy1Channel, GizmoInfo.PhysConst.dEddy1Scale,
          tModulationParams (), GizmoInfo.PhysConst.dEddy1Offset),
 
   /***
   [[U this->Eddy2.tModulatedSensor::tModulatedSensor_tdtd (*GizmoInfo.pEddy2Channel, 
         GizmoInfo.PhysConst.dEddy2Scale,
          ZERO_MODULATION, GizmoInfo.PhysConst.dEddy1Offset) ]]
   ***/
   Eddy2 (*GizmoInfo.pEddy2Channel, GizmoInfo.PhysConst.dEddy2Scale,
          tModulationParams (), GizmoInfo.PhysConst.dEddy2Offset),

   /***
   [[U this->Eddy1DiagInput.tSensor::tSensor_td (
        *GizmoInfo.pDiagEddy1InputChannel, 
	GizmoInfo.PhysConst.dDiagEddy1Scale) ]]
   ***/
   Eddy1DiagInput (*GizmoInfo.pDiagEddy1InputChannel, 
			 GizmoInfo.PhysConst.dDiagEddy1Scale),
			 
   /***
   [[U this->Eddy2DiagInput.tSensor::tSensor_td (
         *GizmoInfo.pDiagEddy2InputChannel,
	 GizmoInfo.PhysConst.dDiagEddy2Scale) ]]
   ***/
   Eddy2DiagInput (*GizmoInfo.pDiagEddy2InputChannel,
			 GizmoInfo.PhysConst.dDiagEddy2Scale),
			 
   /***
   [[U this->Vc2.tModulatedAccelerationActuator::
         tModulatedAccelerationActuator_tddtd (*GizmoInfo.pVc2Channel, 
         GizmoInfo.PhysConst.dVc2Scale, GizmoInfo.PhysConst.dVc2MaxAccel,
         ZERO_MODULATION, GizmoInfo.PhysConst.dVc2Offset) ]]
   ***/
   Vc2 (*GizmoInfo.pVc2Channel, GizmoInfo.PhysConst.dVc2Scale,
        GizmoInfo.PhysConst.dVc2MaxAccel, (double)TIME_TICKS_PER_SECOND / (double)GizmoInfo.MediumServoPeriod (),
        tModulationParams (), GizmoInfo.PhysConst.dVc2Offset),
   /***
   [[U this->Vc2ServoErrorDiagOutput.tActuator::tActuator_td (
         *GizmoInfo.pDiagVc2ServoErrorOutputChannel, 
         GizmoInfo.PhysConst.dDiagVc2ServoErrorScale) ]]
   ***/
   Vc2ServoErrorDiagOutput (*GizmoInfo.pDiagVc2ServoErrorOutputChannel, 
                    GizmoInfo.PhysConst.dDiagVc2ServoErrorScale),

   /***
   [[U this->EddyTarget.tZeroTargetSource::tZeroTargetSource (void)]]
   ***/
   Eddy1Target (),

   /***
   [[U this->Eddy2Target.tZeroTargetSource::tZeroTargetSource (void)]]
   ***/
   Eddy2Target ()

{
  // Set eddy sensor gains to give reasonable dynamic range
  
  /****
  [[U GizmoInfo.pEddy1Channel->tInputChannel::SetGain (10) ]]
  ****/
  GizmoInfo.pEddy1Channel->SetGain (10);


  /****
  [[U GizmoInfo.pEddy2Channel->tInputChannel::SetGain (10) ]]
  ****/
  GizmoInfo.pEddy2Channel->SetGain (10);
}


