/* $RCSfile: DlSetDither.cc,v $ - DlSetDither */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/gui/DlSetDither/DlSetDither.cc,v 1.1.1.1 1998/06/11 21:36:27 chara Exp $
*/
/* Kevin Young - Jet Propulsion Laboratory */

/*
DESCRIPTION
  Dl Set Dither command from command line interface  
*/

#include "commonIncludes.h"
#include "mesg.h"
#include "msgq.h"
#include "isitUnix.h"
#include "isitCommand.h"
#include "common.h"
#include <stdlib.h>
main(int argc, char **argv)
{

   FILE *fp;
   int qid;
   Mesg data;
   int retval;

   Data_buf buf;

   if (argc < 3)
   {
      printf("Usage: %s dl_num\n",argv[0]);
      exit(1);
   }
   
   if ( (qid = msgget(MKEY1, 0)) == -1)
   {
	printf("error in getting message queue id with key %d\n",MKEY1);
	exit(1);
   }
   buf.com_cmd.genericCmd.Command = DL_CMD_SET_DITHER;
   buf.gtGenericType = GT_DELAY_LINE;
   buf.iGuiGizmoIndex = atoi(argv[1]);

   if ( (fp = fopen(FILENAME, "a")) == NULL)
   {
	fprintf(stderr,"error opening file\n");
	exit(1);
   }
   fwrite(&buf, sizeof(buf), 1, fp);
   fclose(fp);
   data.mesg_type = 1L;
   msgrcv(qid, &(data.mesg_type), MAXMESGDATA, data.mesg_type, 0);
   printf("%s", data.mesg_data);
}

