#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <X11/StringDefs.h>
#include <Xm/ArrowB.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/DrawingA.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrollBar.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/CascadeBG.h>
#include <Xm/LabelG.h>
#include <Xm/SeparatoG.h>
#include <Xm/ToggleBG.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include "isitUnix.h"
#include "clientClass.h"
#include "isitCommand.h"
#include "clientNet.h"
#include "share/configShare.h"
#include "client.h"
#include "clientInit.h"


#ifdef TBD
void getTextForQuicServo(dl_servo_shell_p servoPtr, 
                         TRACK_SERVO_PARAMS& servoCmd)
{
   double value;
   char *string;

   string =  XmTextGetString (servoPtr->tPztGain);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dPztGain = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tPztLagPole);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dPztLagPole = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tPztLagZero);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dPztLagZero= value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tPztServoRate);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dPztServoRate = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tLagEnabled);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.bLagEnabled = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tPztServoEnabled);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.bPztServoEnabled = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tSlewToTrack);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dSlewToTrackThresholdInMm = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tTrackToSlew);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dTrackToSlewThresholdInMm = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1TrackPidGain);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1TrackPidGain = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1TrackPidZero1);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1TrackPidZero1 = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1TrackPidZero2);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1TrackPidZero2 = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1TrackPidPole);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1TrackPidPole = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1LaserFFGain);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1LaserFeedforwardGain = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1LaserFFFMem);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1LaserFeedforwardFilterMemory = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1TrackServoRate);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1TrackServoRate = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1TrackServoEnabled);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.bVc1TrackServoEnabled = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1SlewPidGain);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1SlewPidGain = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1SlewPidZero1);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1SlewPidZero1 = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1SlewPidZero2);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1SlewPidZero2 = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1SlewPidPole);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1SlewPidPole = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1SlewServoRate);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dVc1SlewServoRate = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tVc1SlewServoEnabled);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.bVc1SlewServoEnabled = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tMotorGain);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dMotorGain = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tMotorFFGain);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dMotorFeedForwardGain = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tMotorServoRate);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.dMotorServoRate = value;
   XtFree(string);

   string =  XmTextGetString (servoPtr->tMotorServoEnabled);
   sscanf(string,"%lf",&value);
   servoCmd.DlQuicServoParams.bMotorServoEnabled = value;
   XtFree(string);

}

void setTextForQuicServo(dl_servo_shell_p servoPtr, 
                         TRACK_SERVO_PARAMS& servoParam)
{
   char buf[BUFSIZ];
   

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dPztGain);
   XmTextSetString(servoPtr->tPztGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dPztLagPole );
   XmTextSetString (servoPtr->tPztLagPole, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dPztLagZero);
   XmTextSetString (servoPtr->tPztLagZero, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dPztServoRate );
   XmTextSetString (servoPtr->tPztServoRate, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.bLagEnabled );
   XmTextSetString (servoPtr->tLagEnabled, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.bPztServoEnabled );
   XmTextSetString (servoPtr->tPztServoEnabled, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dSlewToTrackThresholdInMm );
   XmTextSetString (servoPtr->tSlewToTrack, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dTrackToSlewThresholdInMm );
   XmTextSetString (servoPtr->tTrackToSlew, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1TrackPidGain );
   XmTextSetString (servoPtr->tVc1TrackPidGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1TrackPidZero1 );
   XmTextSetString (servoPtr->tVc1TrackPidZero1, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1TrackPidZero2 );
   XmTextSetString (servoPtr->tVc1TrackPidZero2, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1TrackPidPole );
   XmTextSetString (servoPtr->tVc1TrackPidPole, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1LaserFeedforwardGain );
   XmTextSetString (servoPtr->tVc1LaserFFGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1LaserFeedforwardFilterMemory );
   XmTextSetString (servoPtr->tVc1LaserFFFMem, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1TrackServoRate );
   XmTextSetString (servoPtr->tVc1TrackServoRate, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.bVc1TrackServoEnabled );
   XmTextSetString (servoPtr->tVc1TrackServoEnabled, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1SlewPidGain );
   XmTextSetString (servoPtr->tVc1SlewPidGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1SlewPidZero1 );
   XmTextSetString (servoPtr->tVc1SlewPidZero1, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1SlewPidZero2 );
   XmTextSetString (servoPtr->tVc1SlewPidZero2, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1SlewPidPole );
   XmTextSetString (servoPtr->tVc1SlewPidPole, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dVc1SlewServoRate );
   XmTextSetString (servoPtr->tVc1SlewServoRate, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.bVc1SlewServoEnabled );
   XmTextSetString (servoPtr->tVc1SlewServoEnabled, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dMotorGain );
   XmTextSetString (servoPtr->tMotorGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dMotorFeedForwardGain );
   XmTextSetString (servoPtr->tMotorFFGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.dMotorServoRate );
   XmTextSetString (servoPtr->tMotorServoRate, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.DlQuicServoParams.bMotorServoEnabled );
   XmTextSetString (servoPtr->tMotorServoEnabled, buf);

}

#endif

void setTextForGsuServo(dl_gsu_servo_shell_p servoPtr, 
                         tGuiGsuDlServoParameters& servoParam)
{
   char buf[BUFSIZ];
   


   XmToggleButtonSetState(servoPtr->bPztServoEnabled,
	servoParam.bPztServoEnabled,FALSE);

   XmToggleButtonSetState(servoPtr->bPztLagEnabled,
	servoParam.bPztLagEnabled,FALSE);

   XmToggleButtonSetState(servoPtr->bVc1TrackServoEnabled,
	servoParam.bVc1TrackServoEnabled,FALSE);

   XmToggleButtonSetState(servoPtr->bVc1StabilizeServoEnabled,
	servoParam.bVc1StabilizeServoEnabled,FALSE);

   XmToggleButtonSetState(servoPtr->bVc2TrackServoEnabled,
	servoParam.bVc2TrackServoEnabled,FALSE);

   XmToggleButtonSetState(servoPtr->bVc2StabilizeServoEnabled,
	servoParam.bVc2StabilizeServoEnabled,FALSE);

   XmToggleButtonSetState(servoPtr->bMotorServoEnabled,
	servoParam.bMotorServoEnabled,FALSE);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dPztServoRate);
   XmTextSetString(servoPtr->dPztServoRate, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVcServoRate);
   XmTextSetString(servoPtr->dVcServoRate, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dMotorServoRate);
   XmTextSetString(servoPtr->dMotorServoRate, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dPztGain);
   XmTextSetString(servoPtr->dPztGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dPztLagPole);
   XmTextSetString(servoPtr->dPztLagPole, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dPztLagZero);
   XmTextSetString(servoPtr->dPztLagZero, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc1StabilizePidGain);
   XmTextSetString(servoPtr->dVc1StabilizePidGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc1StabilizePidZero1);
   XmTextSetString(servoPtr->dVc1StabilizePidZero1, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc1StabilizePidZero2);
   XmTextSetString(servoPtr->dVc1StabilizePidZero2, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc1StabilizePidPole);
   XmTextSetString(servoPtr->dVc1StabilizePidPole, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc1TrackPidGain);
   XmTextSetString(servoPtr->dVc1TrackPidGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc1TrackPidZero1);
   XmTextSetString(servoPtr->dVc1TrackPidZero1, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc1TrackPidZero2);
   XmTextSetString(servoPtr->dVc1TrackPidZero2, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc1TrackPidPole);
   XmTextSetString(servoPtr->dVc1TrackPidPole, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc1TrackLaserFeedforwardGain);
   XmTextSetString(servoPtr->dVc1TrackLaserFeedforwardGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc1TrackFilterMemory);
   XmTextSetString(servoPtr->dVc1TrackFilterMemory, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc2StabilizePidGain);
   XmTextSetString(servoPtr->dVc2StabilizePidGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc2StabilizePidZero1);
   XmTextSetString(servoPtr->dVc2StabilizePidZero1, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc2StabilizePidZero2);
   XmTextSetString(servoPtr->dVc2StabilizePidZero2, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc2StabilizePidPole);
   XmTextSetString(servoPtr->dVc2StabilizePidPole, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc2StabilizeMotorAccelerationFeedforwardGain);
   XmTextSetString(servoPtr->dVc2StabilizeMotorAccelerationFeedforwardGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc2TrackPidGain);
   XmTextSetString(servoPtr->dVc2TrackPidGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc2TrackPidZero1);
   XmTextSetString(servoPtr->dVc2TrackPidZero1, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc2TrackPidZero2);
   XmTextSetString(servoPtr->dVc2TrackPidZero2, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc2TrackPidPole);
   XmTextSetString(servoPtr->dVc2TrackPidPole, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dVc2TrackVc1ForceFeedforwardGain);
   XmTextSetString(servoPtr->dVc2TrackVc1ForceFeedforwardGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dMotorSlewVelocity);
   XmTextSetString(servoPtr->dMotorSlewVelocity, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dMotorCreepVelocity);
   XmTextSetString(servoPtr->dMotorCreepVelocity, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dDecelerationAggressiveness);
   XmTextSetString(servoPtr->dDecelerationAggressiveness, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dMotorPidGain);
   XmTextSetString(servoPtr->dMotorPidGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dMotorPidZero1);
   XmTextSetString(servoPtr->dMotorPidZero1, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dMotorPidZero2);
   XmTextSetString(servoPtr->dMotorPidZero2, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dMotorPidPole);
   XmTextSetString(servoPtr->dMotorPidPole, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dMotorFeedForwardGain);
   XmTextSetString(servoPtr->dMotorFeedForwardGain, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dDecelToIdleVelocityThreshold);
   XmTextSetString(servoPtr->dDecelToIdleVelocityThreshold, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dSlewToTrackThresholdInMm);
   XmTextSetString(servoPtr->dSlewToTrackThresholdInMm, buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",servoParam.dTrackToSlewThresholdInMm);
   XmTextSetString(servoPtr->dTrackToSlewThresholdInMm, buf);


}


void getTextForGsuServo(dl_gsu_servo_shell_p servoPtr, 
                         tGuiGsuDlServoParameters& servoCmd)
{
   char *string;

   servoCmd.bPztServoEnabled = 
	XmToggleButtonGetState(servoPtr->bPztServoEnabled);

   servoCmd.bPztLagEnabled = 
	XmToggleButtonGetState(servoPtr->bPztLagEnabled);

   servoCmd.bVc1TrackServoEnabled = 
	XmToggleButtonGetState(servoPtr->bVc1TrackServoEnabled);

   servoCmd.bVc1StabilizeServoEnabled = 
	XmToggleButtonGetState(servoPtr->bVc1StabilizeServoEnabled);

   servoCmd.bVc2TrackServoEnabled = 
	XmToggleButtonGetState(servoPtr->bVc2TrackServoEnabled);

   servoCmd.bVc2StabilizeServoEnabled = 
	XmToggleButtonGetState(servoPtr->bVc2StabilizeServoEnabled);

   servoCmd.bMotorServoEnabled = 
	XmToggleButtonGetState(servoPtr->bMotorServoEnabled);

   string =  XmTextGetString (servoPtr->dPztServoRate);
   sscanf(string,"%lf",&servoCmd.dPztServoRate);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVcServoRate);
   sscanf(string,"%lf",&servoCmd.dVcServoRate);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dMotorServoRate);
   sscanf(string,"%lf",&servoCmd.dMotorServoRate);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dPztGain);
   sscanf(string,"%lf",&servoCmd.dPztGain);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dPztLagPole);
   sscanf(string,"%lf",&servoCmd.dPztLagPole);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dPztLagZero);
   sscanf(string,"%lf",&servoCmd.dPztLagZero);
   XtFree(string);


   string =  XmTextGetString (servoPtr->dVc1StabilizePidGain);
   sscanf(string,"%lf",&servoCmd.dVc1StabilizePidGain);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc1StabilizePidZero1);
   sscanf(string,"%lf",&servoCmd.dVc1StabilizePidZero1);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc1StabilizePidZero2);
   sscanf(string,"%lf",&servoCmd.dVc1StabilizePidZero2);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc1StabilizePidPole);
   sscanf(string,"%lf",&servoCmd.dVc1StabilizePidPole);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc1TrackPidGain);
   sscanf(string,"%lf",&servoCmd.dVc1TrackPidGain);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc1TrackPidZero1);
   sscanf(string,"%lf",&servoCmd.dVc1TrackPidZero1);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc1TrackPidZero2);
   sscanf(string,"%lf",&servoCmd.dVc1TrackPidZero2);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc1TrackPidPole);
   sscanf(string,"%lf",&servoCmd.dVc1TrackPidPole);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc1TrackLaserFeedforwardGain);
   sscanf(string,"%lf",&servoCmd.dVc1TrackLaserFeedforwardGain);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc1TrackFilterMemory);
   sscanf(string,"%lf",&servoCmd.dVc1TrackFilterMemory);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc2StabilizePidGain);
   sscanf(string,"%lf",&servoCmd.dVc2StabilizePidGain);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc2StabilizePidZero1);
   sscanf(string,"%lf",&servoCmd.dVc2StabilizePidZero1);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc2StabilizePidZero2);
   sscanf(string,"%lf",&servoCmd.dVc2StabilizePidZero2);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc2StabilizePidPole);
   sscanf(string,"%lf",&servoCmd.dVc2StabilizePidPole);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc2StabilizeMotorAccelerationFeedforwardGain);
   sscanf(string,"%lf",&servoCmd.dVc2StabilizeMotorAccelerationFeedforwardGain);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc2TrackPidGain);
   sscanf(string,"%lf",&servoCmd.dVc2TrackPidGain);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc2TrackPidZero1);
   sscanf(string,"%lf",&servoCmd.dVc2TrackPidZero1);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc2TrackPidZero2);
   sscanf(string,"%lf",&servoCmd.dVc2TrackPidZero2);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc2TrackPidPole);
   sscanf(string,"%lf",&servoCmd.dVc2TrackPidPole);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dVc2TrackVc1ForceFeedforwardGain);
   sscanf(string,"%lf",&servoCmd.dVc2TrackVc1ForceFeedforwardGain);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dMotorSlewVelocity);
   sscanf(string,"%lf",&servoCmd.dMotorSlewVelocity);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dMotorCreepVelocity);
   sscanf(string,"%lf",&servoCmd.dMotorCreepVelocity);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dDecelerationAggressiveness);
   sscanf(string,"%lf",&servoCmd.dDecelerationAggressiveness);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dMotorPidGain);
   sscanf(string,"%lf",&servoCmd.dMotorPidGain);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dMotorPidZero1);
   sscanf(string,"%lf",&servoCmd.dMotorPidZero1);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dMotorPidZero2);
   sscanf(string,"%lf",&servoCmd.dMotorPidZero2);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dMotorPidPole);
   sscanf(string,"%lf",&servoCmd.dMotorPidPole);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dMotorFeedForwardGain);
   sscanf(string,"%lf",&servoCmd.dMotorFeedForwardGain);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dDecelToIdleVelocityThreshold);
   sscanf(string,"%lf",&servoCmd.dDecelToIdleVelocityThreshold);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dSlewToTrackThresholdInMm);
   sscanf(string,"%lf",&servoCmd.dSlewToTrackThresholdInMm);
   XtFree(string);

   string =  XmTextGetString (servoPtr->dTrackToSlewThresholdInMm);
   sscanf(string,"%lf",&servoCmd.dTrackToSlewThresholdInMm);
   XtFree(string);

}

void getTextForSetDither(dl_set_dither_shell_p setDitherPtr,
                         double& dAmplitude, double& dPeriod)
{
   double value;
   char *string;

   string =  XmTextGetString (setDitherPtr->dl_set_dither_ampl_text);
   sscanf(string,"%lf",&value);
   dAmplitude = value;
   XtFree(string);

   string =  XmTextGetString (setDitherPtr->dl_set_dither_period_text);
   sscanf(string,"%lf",&value);
   dPeriod = value;
   XtFree(string);

}

void setTextForSetDither(dl_set_dither_shell_p setDitherPtr,
                         double& dAmplitude, double& dPeriod)
{
   char buf[BUFSIZ];

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",dAmplitude);
   XmTextSetString(setDitherPtr->dl_set_dither_ampl_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",dPeriod);
   XmTextSetString(setDitherPtr->dl_set_dither_period_text,buf);
}

void getTextForModulation( Widget amp_text,
                           Widget freq_text,
                           Widget meanval_text,
                           Widget sync_time_text,
                           double&   dAmplitude,
                           double&   dFrequency,
                           double&   dMeanVal,
                           TIME&     tSyncTime)

{

   char *string;

   string =  XmTextGetString (amp_text);
   sscanf(string,"%lf",&dAmplitude);
   XtFree(string);

   string =  XmTextGetString (freq_text);
   sscanf(string,"%lf",&dFrequency);
   XtFree(string);

   string =  XmTextGetString (meanval_text);
   sscanf(string,"%lf",&dMeanVal);
   XtFree(string);

   string =  XmTextGetString (sync_time_text);
   sscanf(string,"%lu",&tSyncTime);
   XtFree(string);

}

void getTextForFtModulation( ft_set_param_shell_p FtPtr,
                           tFtSetServoParametersCmd& FtServoParams)

{
   char *string;

   FtServoParams.mtModulationType = (MOD_TYPE)FtPtr->mod_type;

   string = XmTextGetString(FtPtr->ft_sp_amp_text);
   sscanf(string,"%lf",&FtServoParams.dAmplitude);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_freq_text);
   sscanf(string,"%lf",&FtServoParams.dFrequency);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_meanval_text);
   sscanf(string,"%lf",&FtServoParams.dMeanVal);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_sync_time_text);
   sscanf(string,"%lu",&FtServoParams.tSyncTime);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_duty_cycle_text);
   sscanf(string,"%lf",&FtServoParams.dDutyCycle);
   XtFree(string);

   FtServoParams.stSearchType = (SEARCH_TYPE)FtPtr->search_type;

   string = XmTextGetString(FtPtr->ft_sp_spiral_radius_initial);
   sscanf(string,"%lf",&FtServoParams.dSpiralRadiusInitial);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_spiral_radius_limit);
   sscanf(string,"%lf",&FtServoParams.dSpiralRadiusLimit);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_spiral_step);
   sscanf(string,"%lf",&FtServoParams.dSpiralStep);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_progression_constant);
   sscanf(string,"%lf",&FtServoParams.dProgressionConstant);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_semi_lock_lock_timeout);
   sscanf(string,"%lu",&FtServoParams.tSemiLockToLockTimeout);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_total_time_lock_timeout);
   sscanf(string,"%lu",&FtServoParams.tTotalTimeToLockTimeout);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_thresh_search_semi_lock);
   sscanf(string,"%lf",&FtServoParams.dSNRThreshSearchToSemiLock);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_thresh_semi_lock_lock);
   sscanf(string,"%lf",&FtServoParams.dSNRThreshSemiLockToLock);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_v2thresh_semi_lock_lock);
   sscanf(string,"%lf",&FtServoParams.dV2ThreshSemiLockToLock);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_thresh_lock_to_search);
   sscanf(string,"%lf",&FtServoParams.dSNRThreshLockToSearch);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_thresh_for_drop);
   sscanf(string,"%lf",&FtServoParams.dThreshForDrop);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_thresh_for_search);
   sscanf(string,"%lf",&FtServoParams.dThreshForSearch);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_phase_offset);
   sscanf(string,"%lf",&FtServoParams.dPhaseOffset);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_mem_box_car);
   sscanf(string,"%d",&FtServoParams.iMemBoxcar);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_phase_sign);
   sscanf(string,"%d",&FtServoParams.iPhaseSign);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_fringe_servo_gain);
   sscanf(string,"%lf",&FtServoParams.dFringeServoGain);
   XtFree(string);

   string = XmTextGetString(FtPtr->ft_sp_deltav_delta_wobble_to_hop);
   sscanf(string,"%lf",&FtServoParams.dDeltaVDeltaWobbleToHop);
   XtFree(string);
}

void setTextForDlModulation( dl_set_modulation_shell_p DlPtr,
                           MOD_TYPE mtModulationType,
                           double   dAmplitude,
                           double   dFrequency,
                           double   dMeanVal,
                           TIME     tSyncTime)

{
   char buf[BUFSIZ];

   DlPtr->mod_type = mtModulationType;
   switch (mtModulationType)
   {

       case MT_SQUARE:
          XtVaSetValues(DlPtr->dl_sp_option_menu, XmNmenuHistory, 
                 DlPtr->dl_set_mod_mt_square_bt, NULL );
          break;
       case MT_TRIANGLE:
          XtVaSetValues(DlPtr->dl_sp_option_menu, XmNmenuHistory, 
                 DlPtr->dl_set_mod_mt_triangle_bt, NULL );
          break;
       case MT_SINE:
          XtVaSetValues(DlPtr->dl_sp_option_menu, XmNmenuHistory, 
                 DlPtr->dl_set_mod_mt_sine_bt, NULL );
          break;
       case MT_RANDOM:
          XtVaSetValues(DlPtr->dl_sp_option_menu, XmNmenuHistory, 
                 DlPtr->dl_set_mod_mt_random_bt, NULL );
          break;
       case MT_NONE:
          XtVaSetValues(DlPtr->dl_sp_option_menu, XmNmenuHistory, 
                 DlPtr->dl_set_mod_mt_none_bt, NULL );
          break;
       default:
          break;
   }

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",dAmplitude);
   XmTextSetString(DlPtr->dl_set_mod_amp_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",dFrequency);
   XmTextSetString(DlPtr->dl_set_mod_freq_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",dMeanVal);
   XmTextSetString(DlPtr->dl_set_mod_meanval_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lu",tSyncTime);
   XmTextSetString(DlPtr->dl_set_mod_sync_time_text,buf);
}

void setTextForFtModulation( ft_set_param_shell_p FtPtr,
                           tFtSetServoParametersCmd& FtServoParams)

{
   char buf[BUFSIZ];

   FtPtr->mod_type = FtServoParams.mtModulationType;
   switch (FtServoParams.mtModulationType)
   {

       case MT_WOBBLE:
          XtVaSetValues(FtPtr->ft_sp_option_menu, XmNmenuHistory, 
                 FtPtr->ft_sp_mt_wobble_bt, NULL );
          break;
       case MT_SQUARE:
          XtVaSetValues(FtPtr->ft_sp_option_menu, XmNmenuHistory, 
                 FtPtr->ft_sp_mt_square_bt, NULL );
          break;
       case MT_TRIANGLE:
          XtVaSetValues(FtPtr->ft_sp_option_menu, XmNmenuHistory, 
                 FtPtr->ft_sp_mt_triangle_bt, NULL );
          break;
       case MT_SINE:
          XtVaSetValues(FtPtr->ft_sp_option_menu, XmNmenuHistory, 
                 FtPtr->ft_sp_mt_sine_bt, NULL );
          break;
       case MT_RANDOM:
          XtVaSetValues(FtPtr->ft_sp_option_menu, XmNmenuHistory, 
                 FtPtr->ft_sp_mt_random_bt, NULL );
          break;
       case MT_NONE:
          XtVaSetValues(FtPtr->ft_sp_option_menu, XmNmenuHistory, 
                 FtPtr->ft_sp_mt_none_bt, NULL );
          break;
       default:
          break;
   }

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dAmplitude);
   XmTextSetString(FtPtr->ft_sp_amp_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dFrequency);
   XmTextSetString(FtPtr->ft_sp_freq_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dMeanVal);
   XmTextSetString(FtPtr->ft_sp_meanval_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lu",FtServoParams.tSyncTime);
   XmTextSetString(FtPtr->ft_sp_sync_time_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dDutyCycle);
   XmTextSetString(FtPtr->ft_sp_duty_cycle_text,buf);

   FtPtr->search_type = FtServoParams.stSearchType;
   switch ( FtServoParams.stSearchType )
   {

       case SPIRAL_GEOMETRIC:
          XtVaSetValues(FtPtr->ft_sp_search_menu, XmNmenuHistory,
                 FtPtr->ft_sp_spiral_geom_bt, NULL );
          break;
       case SPIRAL_ARITHMETIC:
          XtVaSetValues(FtPtr->ft_sp_search_menu, XmNmenuHistory,
                 FtPtr->ft_sp_spiral_arith_bt, NULL );
          break;
       default:
          break;
   }

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dSpiralRadiusInitial);
   XmTextSetString(FtPtr->ft_sp_spiral_radius_initial,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dSpiralRadiusLimit);
   XmTextSetString(FtPtr->ft_sp_spiral_radius_limit,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dSpiralStep);
   XmTextSetString(FtPtr->ft_sp_spiral_step,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dProgressionConstant);
   XmTextSetString(FtPtr->ft_sp_progression_constant,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lu",FtServoParams.tSemiLockToLockTimeout);
   XmTextSetString(FtPtr->ft_sp_semi_lock_lock_timeout,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lu",FtServoParams.tTotalTimeToLockTimeout);
   XmTextSetString(FtPtr->ft_sp_total_time_lock_timeout,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dSNRThreshSearchToSemiLock);
   XmTextSetString(FtPtr->ft_sp_thresh_search_semi_lock,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dSNRThreshSemiLockToLock);
   XmTextSetString(FtPtr->ft_sp_thresh_semi_lock_lock,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dV2ThreshSemiLockToLock);
   XmTextSetString(FtPtr->ft_sp_v2thresh_semi_lock_lock,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dSNRThreshLockToSearch);
   XmTextSetString(FtPtr->ft_sp_thresh_lock_to_search,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dThreshForDrop);
   XmTextSetString(FtPtr->ft_sp_thresh_for_drop,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dThreshForSearch);
   XmTextSetString(FtPtr->ft_sp_thresh_for_search,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dPhaseOffset);
   XmTextSetString(FtPtr->ft_sp_phase_offset,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%d",FtServoParams.iMemBoxcar);
   XmTextSetString(FtPtr->ft_sp_mem_box_car,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%d",FtServoParams.iPhaseSign);
   XmTextSetString(FtPtr->ft_sp_phase_sign,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dFringeServoGain);
   XmTextSetString(FtPtr->ft_sp_fringe_servo_gain,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",FtServoParams.dDeltaVDeltaWobbleToHop);
   XmTextSetString(FtPtr->ft_sp_deltav_delta_wobble_to_hop,buf);
}


void setTextForEmModulation( em_set_param_shell_p EmPtr,
                           MOD_TYPE mtModulationType,
                           double   dAmplitude,
                           double   dFrequency,
                           double   dMeanVal,
                           TIME     tSyncTime)

{
   char buf[BUFSIZ];

   EmPtr->mod_type = mtModulationType;
   switch (mtModulationType)
   {

       case MT_SQUARE:
          XtVaSetValues(EmPtr->em_sp_option_menu, XmNmenuHistory, 
                 EmPtr->em_sp_mt_square_bt, NULL );
          break;
       case MT_TRIANGLE:
          XtVaSetValues(EmPtr->em_sp_option_menu, XmNmenuHistory, 
                 EmPtr->em_sp_mt_triangle_bt, NULL );
          break;
       case MT_SINE:
          XtVaSetValues(EmPtr->em_sp_option_menu, XmNmenuHistory, 
                 EmPtr->em_sp_mt_sine_bt, NULL );
          break;
       case MT_RANDOM:
          XtVaSetValues(EmPtr->em_sp_option_menu, XmNmenuHistory, 
                 EmPtr->em_sp_mt_random_bt, NULL );
          break;
       case MT_NONE:
          XtVaSetValues(EmPtr->em_sp_option_menu, XmNmenuHistory, 
                 EmPtr->em_sp_mt_none_bt, NULL );
          break;
       default:
          break;
   }

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",dAmplitude);
   XmTextSetString(EmPtr->em_sp_amp_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",dFrequency);
   XmTextSetString(EmPtr->em_sp_freq_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",dMeanVal);
   XmTextSetString(EmPtr->em_sp_meanval_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lu",tSyncTime);
   XmTextSetString(EmPtr->em_sp_sync_time_text,buf);
}

void getTextForTarget( Widget pos_text,
                       Widget rate_text,
                       Widget time_text,
                       tDlTargetBase& Target)

{
   double value;
   TIME   tvalue;
   char *string;

   string =  XmTextGetString (pos_text);
   sscanf(string,"%lf",&value);
   Target.dPosition = value;
   XtFree(string);

   string =  XmTextGetString (rate_text);
   sscanf(string,"%lf",&value);
   Target.dRate = value;
   XtFree(string);

   string =  XmTextGetString (time_text);
   sscanf(string,"%lu",&tvalue);
   Target.tTime = tvalue;
   XtFree(string);

}

void setTextForTarget( Widget& pos_text,
                       Widget& rate_text,
                       Widget& time_text,
                       tDlTargetBase Target)

{
   char buf[BUFSIZ];

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",Target.dPosition);
   XmTextSetString(pos_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",Target.dRate);
   XmTextSetString(rate_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lu",Target.tTime);
   XmTextSetString(time_text,buf);

}

void setTextForTime( Widget& time_text,
                     TIME    tTime)

{
   char buf[BUFSIZ];

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lu",tTime);
   XmTextSetString(time_text,buf);
}

void getTextForStCalibrate(st_calibrate_shell_p CalibratePtr,
                         tStCalibrateCmd& StCalibrate)
{
   char *string;

   string =  XmTextGetString (CalibratePtr->st_calibrate_freq_text);
   sscanf(string,"%lf",&StCalibrate.CalFrequency);
   XtFree(string);

   string =  XmTextGetString (CalibratePtr->st_calibrate_ampl_text);
   sscanf(string,"%lf",&StCalibrate.CalAmplitude);
   XtFree(string);

   string =  XmTextGetString (CalibratePtr->st_calibrate_actuator_text);
   sscanf(string,"%d",&StCalibrate.CalActuator);
   XtFree(string);

}

void setTextForStCalibrate(st_calibrate_shell_p CalibratePtr,
                         tStCalibrateCmd& StCalibrate)
{

   char buf[BUFSIZ];

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StCalibrate.CalFrequency);
   XmTextSetString (CalibratePtr->st_calibrate_freq_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StCalibrate.CalAmplitude);
   XmTextSetString (CalibratePtr->st_calibrate_ampl_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%d",StCalibrate.CalActuator);
   XmTextSetString (CalibratePtr->st_calibrate_actuator_text,buf);

}


void getTextForStSetServo(st_set_servo_shell_p StSetServoPtr,
                         tStSetServoParamsCmd& StServoParams)
{
   char *string;

   string =  XmTextGetString (StSetServoPtr->starTargetX);
   sscanf(string,"%lf",&StServoParams.Params.ControllerParams.StarTarget[0]);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->starTargetY);
   sscanf(string,"%lf",&StServoParams.Params.ControllerParams.StarTarget[1]);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->LagTauPole_text);
   sscanf(string,"%lf",&StServoParams.Params.ControllerParams.LagTauPole);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->LagTauZero_text);
   sscanf(string,"%lf",&StServoParams.Params.ControllerParams.LagTauZero);
   XtFree(string);

   StServoParams.Params.ControllerParams.LagEnabled = StSetServoPtr->lagEnabled;

   string =  XmTextGetString (StSetServoPtr->pidTauZero1);
   sscanf(string,"%lf",&StServoParams.Params.ControllerParams.PidTauZero1);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->pidTauZero2);
   sscanf(string,"%lf",&StServoParams.Params.ControllerParams.PidTauZero2);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->pidTauPole);
   sscanf(string,"%lf",&StServoParams.Params.ControllerParams.PidTauPole);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->Gain);
   sscanf(string,"%lf",&StServoParams.Params.ControllerParams.Gain);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->XFormDetFsmX1);
   sscanf(string,"%lf",&StServoParams.Params.XformDetToFsm[0][0]);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->XFormDetFsmX2);
   sscanf(string,"%lf",&StServoParams.Params.XformDetToFsm[0][1]);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->XFormDetFsmX3);
   sscanf(string,"%lf",&StServoParams.Params.XformDetToFsm[0][2]);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->XFormDetFsmY1);
   sscanf(string,"%lf",&StServoParams.Params.XformDetToFsm[1][0]);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->XFormDetFsmY2);
   sscanf(string,"%lf",&StServoParams.Params.XformDetToFsm[1][1]);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->XFormDetFsmY3);
   sscanf(string,"%lf",&StServoParams.Params.XformDetToFsm[1][2]);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->FsmHome1);
   sscanf(string,"%lf",&StServoParams.Params.FsmHome[0]);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->FsmHome2);
   sscanf(string,"%lf",&StServoParams.Params.FsmHome[1]);
   XtFree(string);

   string =  XmTextGetString (StSetServoPtr->FsmHome3);
   sscanf(string,"%lf",&StServoParams.Params.FsmHome[2]);
   XtFree(string);

}

void setTextForStSetServo(st_set_servo_shell_p StSetServoPtr,
                         tStSetServoParamsCmd& StServoParams)
{

   char buf[BUFSIZ];

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.ControllerParams.StarTarget[0]);
   XmTextSetString (StSetServoPtr->starTargetX,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.ControllerParams.StarTarget[1]);
   XmTextSetString (StSetServoPtr->starTargetY,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.ControllerParams.LagTauPole);
   XmTextSetString (StSetServoPtr->LagTauPole_text,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.ControllerParams.LagTauZero);
   XmTextSetString (StSetServoPtr->LagTauZero_text,buf);

   StSetServoPtr->lagEnabled = StServoParams.Params.ControllerParams.LagEnabled;

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.ControllerParams.PidTauZero1);
   XmTextSetString (StSetServoPtr->pidTauZero1,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.ControllerParams.PidTauZero2);
   XmTextSetString (StSetServoPtr->pidTauZero2,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.ControllerParams.PidTauPole);
   XmTextSetString (StSetServoPtr->pidTauPole,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.ControllerParams.Gain);
   XmTextSetString (StSetServoPtr->Gain,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.XformDetToFsm[0][0]);
   XmTextSetString (StSetServoPtr->XFormDetFsmX1,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.XformDetToFsm[0][1]);
   XmTextSetString (StSetServoPtr->XFormDetFsmX2,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.XformDetToFsm[0][2]);
   XmTextSetString (StSetServoPtr->XFormDetFsmX3,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.XformDetToFsm[1][0]);
   XmTextSetString (StSetServoPtr->XFormDetFsmY1,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.XformDetToFsm[1][1]);
   XmTextSetString (StSetServoPtr->XFormDetFsmY2,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.XformDetToFsm[1][2]);
   XmTextSetString (StSetServoPtr->XFormDetFsmY3,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.FsmHome[0]);
   XmTextSetString (StSetServoPtr->FsmHome1,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.FsmHome[1]);
   XmTextSetString (StSetServoPtr->FsmHome2,buf);

   memset(buf,0,BUFSIZ);
   sprintf(buf,"%lf",StServoParams.Params.FsmHome[2]);
   XmTextSetString (StSetServoPtr->FsmHome3,buf);

}

