/* $RCSfile: gui.cc,v $ -- routines to handle cmd line interfaces */
/*
$Header: /home/chara/cvsroot/ople/sys/gui/client/gui.cc,v 1.1.1.1 1998/06/11 21:36:31 chara Exp $
*/

#include "commonIncludes.h"

#include "isitUnix.h"
#include "clientClass.h"
#include "isitCommand.h"
#include "clientNet.h"
#include "clientUtils.h"

#include "share/configShare.h"
#include "client.h"
#include "common.h"
#include "clientInit.h"
#include "clientReadInput.h"
#include "clientData.h"
#include "clientDlCb.h"
#include "clientFtCb.h"
#include "clientEmCb.h"
#include "clientStCb.h"
#include "clientTextUtils.h"

#include "mesg.h"
#include "msgq.h"


#ifdef TBD
void assign_chng_params_values(Data_buf *buf, int iGizmoId, int iGuiGizmoIndex,
                               GIZMO_TYPE gtSpecificType);


#endif TBD

void process_interface( Data_buf buf)
{
   int rval;
   char cmd[256];
   GIZMO_TYPE gtSpecificType;


   GetEmbeddedSystemGizmoInfo (buf.gtGenericType, buf.iGuiGizmoIndex,
           gtSpecificType, buf.com_cmd.genericCmd.iGizmoId);

   switch (buf.com_cmd.genericCmd.Command)
   {
      case DL_CMD_SELECT_TARGET:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlSelectTarget(<iGuiGizmoIndex=%d>)\n", 
                     buf.iGuiGizmoIndex);

	 switch(buf.com_cmd.dlsatCmd.ttWhichTarget)
         {
            case TT_MANUAL:
               dl_shell[buf.iGuiGizmoIndex]->targetSelectMT =
                  buf.com_cmd.dlsatCmd.bTargetSetActive;
               XmToggleButtonSetState(
                  dl_shell[buf.iGuiGizmoIndex]->dl_mt_toggle,
                  dl_shell[buf.iGuiGizmoIndex]->targetSelectMT, FALSE);
               break;
            case TT_OPEN_LOOP:
               dl_shell[buf.iGuiGizmoIndex]->targetSelectOL =
                  buf.com_cmd.dlsatCmd.bTargetSetActive;
               XmToggleButtonSetState(
                  dl_shell[buf.iGuiGizmoIndex]->dl_ol_toggle,
                  dl_shell[buf.iGuiGizmoIndex]->targetSelectOL, FALSE);
               break;
            case TT_FT:
               dl_shell[buf.iGuiGizmoIndex]->targetSelectFT =
                  buf.com_cmd.dlsatCmd.bTargetSetActive;
               XmToggleButtonSetState(
                  dl_shell[buf.iGuiGizmoIndex]->dl_ft_toggle,
                  dl_shell[buf.iGuiGizmoIndex]->targetSelectFT, FALSE);
               break;
            case TT_EM:
               dl_shell[buf.iGuiGizmoIndex]->targetSelectEM =
                  buf.com_cmd.dlsatCmd.bTargetSetActive;
               XmToggleButtonSetState(
                  dl_shell[buf.iGuiGizmoIndex]->dl_em_toggle,
                  dl_shell[buf.iGuiGizmoIndex]->targetSelectEM, FALSE);
               break;
         } /* switch */
         break;
      case DL_CMD_DITHER_ON:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlDitherOn(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         dl_shell[buf.iGuiGizmoIndex]->ditherOn =
            buf.com_cmd.dldoCmd.bTurnDitherOn;
         XmToggleButtonSetState(
              dl_shell[buf.iGuiGizmoIndex]->dl_dither_toggle,
              dl_shell[buf.iGuiGizmoIndex]->ditherOn, FALSE);

         break;
      case INST_CMD_SET_OPEN_LOOP_TARGET:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-OpenLoopTarget(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);
          switch (buf.value)
          {
             case BAD:
                SetOpenLoopAutoUnreasonable(buf.com_cmd.genericCmd.iGizmoId, 
                                            buf.iGuiGizmoIndex);
                break;
             case GOOD:
                SetOpenLoopAutoReasonable(buf.com_cmd.genericCmd.iGizmoId, 
                                            buf.iGuiGizmoIndex);
                break;
          }
          getTextForTarget( dl_solt_shell[buf.iGuiGizmoIndex]->dl_solt_pos_text,
                       dl_solt_shell[buf.iGuiGizmoIndex]->dl_solt_rate_text,
                       dl_solt_shell[buf.iGuiGizmoIndex]->dl_solt_time_text,
                       buf.com_cmd.instsoltCmd.Target);

          GetEmbeddedSystemGizmoInfo (GT_DELAY_LINE, buf.iGuiGizmoIndex, 
                     gtSpecificType, buf.com_cmd.instsoltCmd.iDlGizmoId);

         break;
      case INST_CMD_SET_MANUAL_TARGET:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-ManualTarget(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);
          switch (buf.value)
          {
             case BAD:
                SetManualAutoUnreasonable(buf.com_cmd.genericCmd.iGizmoId,
                                            buf.iGuiGizmoIndex);
                break;
             case GOOD:
                SetManualAutoReasonable(buf.com_cmd.genericCmd.iGizmoId,
                                            buf.iGuiGizmoIndex);
                break;
          }
          getTextForTarget( dl_smt_shell[buf.iGuiGizmoIndex]->dl_smt_pos_text,
                       dl_smt_shell[buf.iGuiGizmoIndex]->dl_smt_rate_text,
                       dl_smt_shell[buf.iGuiGizmoIndex]->dl_smt_time_text,
                       buf.com_cmd.instsmtCmd.Target);

          GetEmbeddedSystemGizmoInfo (GT_DELAY_LINE, buf.iGuiGizmoIndex, 
                     gtSpecificType, buf.com_cmd.instsmtCmd.iDlGizmoId);
         break;
      case DL_CMD_CLR_LASER_CTR:
         memset(cmd,0,256);
         sprintf(cmd,
            "CmdLineInterface-DlClearLaserCounter(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_OFF:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlOff(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_FRONT:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlFront(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_BACK:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlBack(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_TRACK:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlTrack(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_USER1:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlUser1(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_USER2:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlUser2(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_HOME_CHECK:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlHome Check(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_HOME_SET:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlHome Set(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_DITHER_CALIBRATE:
         memset(cmd,0,256);
         sprintf(cmd,
            "CmdLineInterface-DlDither Calibrate(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_DITHER_CHECK:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlDitherCheck(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_SET_DITHER:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlSetDither(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);
         SetDitherAutoUnreasonable(buf.com_cmd.genericCmd.iGizmoId,
                                   buf.iGuiGizmoIndex);

         getTextForSetDither(dl_set_dither_shell[buf.iGuiGizmoIndex],
                             buf.com_cmd.dlsdCmd.dAmplitude,
                             buf.com_cmd.dlsdCmd.dPeriod);
         break;
      case DL_CMD_PING:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlPing(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case DL_CMD_MODULATE:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlModulate(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

          switch (buf.value)
          {
             case BAD:
                DLSetModulationAutoUnreasonable(buf.com_cmd.genericCmd.iGizmoId,
                                            buf.iGuiGizmoIndex);
                break;
             case GOOD:
                DLSetModulationAutoReasonable(buf.com_cmd.genericCmd.iGizmoId,
                                            buf.iGuiGizmoIndex);
                break;
          }
          
          getTextForModulation(
           dl_set_modulation_shell[buf.iGuiGizmoIndex]->dl_set_mod_amp_text,
           dl_set_modulation_shell[buf.iGuiGizmoIndex]->dl_set_mod_freq_text,
           dl_set_modulation_shell[buf.iGuiGizmoIndex]->dl_set_mod_meanval_text,
           dl_set_modulation_shell[buf.iGuiGizmoIndex]->dl_set_mod_sync_time_text,
           buf.com_cmd.dlsmCmd.dAmplitude,
           buf.com_cmd.dlsmCmd.dFrequency,
           buf.com_cmd.dlsmCmd.dMeanVal,
           buf.com_cmd.dlsmCmd.tSyncTime);

           buf.com_cmd.dlsmCmd.mtModulationType = 
             (MOD_TYPE)dl_set_modulation_shell[buf.iGuiGizmoIndex]->mod_type;

         break;
      case GSUDL_CMD_CHNG_SERVO_PARAM:
#ifdef TBD
         assign_chng_params_values(&buf,
            buf.com_cmd.genericCmd.iGizmoId,
            buf.iGuiGizmoIndex,
            gtSpecificType);
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-DlSetServoParam(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

#endif TBD
         break;

      case FT_CMD_OFF:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-FTOff(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case FT_CMD_TRACK:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-FTTrack(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case FT_CMD_PING:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-FTPing(<iGuiGizmoIndex=%d>)\n",
           buf.iGuiGizmoIndex);

         break;
      case FT_CMD_CHNG_PARAM:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-FTChangeParam(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);
         switch (buf.value)
         {
            case BAD:
               FTSetParamsAutoUnreasonable(buf.com_cmd.genericCmd.iGizmoId,
                                           buf.iGuiGizmoIndex);
               break;
            case GOOD:
               FTSetParamsAutoReasonable(buf.com_cmd.genericCmd.iGizmoId,
                                           buf.iGuiGizmoIndex);
               break;
         }

         getTextForModulation(
           ft_set_param_shell[buf.iGuiGizmoIndex]->ft_sp_amp_text,
           ft_set_param_shell[buf.iGuiGizmoIndex]->ft_sp_freq_text,
           ft_set_param_shell[buf.iGuiGizmoIndex]->ft_sp_meanval_text,
           ft_set_param_shell[buf.iGuiGizmoIndex]->ft_sp_sync_time_text,
           buf.com_cmd.ftcpCmd.dAmplitude,
           buf.com_cmd.ftcpCmd.dFrequency,
           buf.com_cmd.ftcpCmd.dMeanVal,
           buf.com_cmd.ftcpCmd.tSyncTime);

           buf.com_cmd.ftcpCmd.mtModulationType =
             (MOD_TYPE)ft_set_param_shell[buf.iGuiGizmoIndex]->mod_type;


         break;
      case EM_CMD_OFF:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-EMOff(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case EM_CMD_TRACK:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-EMTrack(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case EM_CMD_PING:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-EMPing(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case EM_CMD_CHNG_PARAM:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-EMChangeParam(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         switch (buf.value)
         {
            case BAD:
               EMSetParamsAutoUnreasonable(buf.com_cmd.genericCmd.iGizmoId,
                                           buf.iGuiGizmoIndex);
               break;
            case GOOD:
               EMSetParamsAutoReasonable(buf.com_cmd.genericCmd.iGizmoId,
                                           buf.iGuiGizmoIndex);
               break;
         }

         getTextForModulation(
           em_set_param_shell[buf.iGuiGizmoIndex]->em_sp_amp_text,
           em_set_param_shell[buf.iGuiGizmoIndex]->em_sp_freq_text,
           em_set_param_shell[buf.iGuiGizmoIndex]->em_sp_meanval_text,
           em_set_param_shell[buf.iGuiGizmoIndex]->em_sp_sync_time_text,
           buf.com_cmd.emsspCmd.dAmplitude,
           buf.com_cmd.emsspCmd.dFrequency,
           buf.com_cmd.emsspCmd.dMeanVal,
           buf.com_cmd.emsspCmd.tSyncTime);

           buf.com_cmd.emsspCmd.mtModulationType =
             (MOD_TYPE)em_set_param_shell[buf.iGuiGizmoIndex]->mod_type;


         break;
      case ST_CMD_OFF:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-STOff(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case ST_CMD_TRACK:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-STTrack(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
      case ST_CMD_PING:
         memset(cmd,0,256);
         sprintf(cmd,"CmdLineInterface-STPing(<iGuiGizmoIndex=%d>)\n",
            buf.iGuiGizmoIndex);

         break;
   }
   write_to_log(cmd, strlen(cmd) );
   write_to_error_file(cmd, strlen(cmd) );
   do_command((char *)&(buf.com_cmd), sizeof(ISIT_CMD) );

   write_interface_count++;
}


#ifdef TBD
void assign_chng_params_values(Data_buf *buf, int iGizmoId, int iGuiGizmoIndex,
                               GIZMO_TYPE gtSpecificType)
{
   switch (buf->value)
   {
      case BAD:
         switch ( gtSpecificType )
         {
            case GT_DL_BB1: case GT_DL_BB2: 
               SetQuicServoParamsAutoUnreasonable(iGizmoId,
                         iGuiGizmoIndex,
                         buf->com_cmd.dlsspCmd.ServoParams);
               break;
            case GT_DL_GSU:
               SetGsuServoParamsAutoUnreasonable(iGizmoId, 
                         iGuiGizmoIndex,
                         buf->com_cmd.dlsspCmd.ServoParams);

               break;

         }
      case GOOD:
         switch ( gtSpecificType )
         {
            case GT_DL_BB1: 
               SetBb1ServoParamsAutoReasonable(iGizmoId, 
                         iGuiGizmoIndex,
                         buf->com_cmd.dlsspCmd.ServoParams);
               break;
            case GT_DL_BB2: 
               SetBb2ServoParamsAutoReasonable(iGizmoId, 
                         iGuiGizmoIndex,
                         buf->com_cmd.dlsspCmd.ServoParams);
               break;
            case GT_DL_GSU:
               SetGsuServoParamsAutoReasonable(iGizmoId, 
                         iGuiGizmoIndex,
                         buf->com_cmd.dlsspCmd.ServoParams);
               break;

         }
   }
}
#endif TBD
