/* $RCSfile: errLookup.cc,v $ -- routines to look up text code for vxWorks error number */
/*
$Header: /home/chara/cvsroot/ople/sys/gui/client/errLookup.cc,v 1.1.1.1 1998/06/11 21:36:31 chara Exp $
*/

/* errLookup.c - look up text code for VxWorks error numbers */
/*       sccs info       @(#)errLookup.c	1.3  3/7/94  */
/* Brad Hines - Jet Propulsion Laboratory */

/*
modification history
--------------------
01b,14Oct93,beh      slight mod to detect unknown error codes
01a,17Apr92,beh      written
*/

/*
DESCRIPTION
When the delay line reports an error to the host, the host can make
use of the statTbl.c produced by "make vxWorks" to translate VxWorks
error codes into human-readable strings.
*/

#include "errLookup.h"
#ifndef SPECTOOL
#include "statTbl.c"
#endif

/*****************************************************
* errLookup - looks up the text for a given error code
*
* RETURNS:
* char * to the error string, or "Unknown Error Code" if no match
*/

/*
*
[[U ::errLookup() ]]
*
*/
char *errLookup(int errcode) {
  FAST int i;
  FAST SYMBOL *pTableEntry = statTbl;
  char *errorString = NULL;
  
  for (i=0; i<statTblSize; i++) {
    if ( ((int) (pTableEntry->value)) == errcode) {
      errorString = pTableEntry->name;
      break;
    }
    pTableEntry++;
  }

  if (errorString == NULL)
    errorString = "Unknown Error Code";   
  
  return errorString;
}

#ifdef VXWORKS

#include <stdio.h>
#include <errnoLib.h>

/*************************************************************
* printErrno - a replacement for the VxWorks printErrno
*
* This function operates just like printErrno, but it is also
* capable of printing out JPL-specific error codes from statTbl.c.
*
* RETURNS:
* Nothing.
*/

void printErrno(int errNo)
{
  char *sErr;
  
  if (errNo == 0)
    errNo = errnoGet();

  sErr = errLookup(errNo);

  printf("%s\n", sErr);
}

#endif  /* VXWORKS  */
