#ifndef INC_clienth

#define INC_clienth

#define DELAY_XBM "delay.xbm"
#define HOME_XBM "home.xbm"
#define OFF_XBM "off.xbm"
#define ON_XBM "on.xbm"

#define NETWORK_CONNECTION_TIMEOUT 600 /* in seconds = 10 minutes */
#define  OK (0)

#define  FIELD_WIDTH 15
#define  INT_FIELD_WIDTH 12
#define  DEC_PLACES  3

#define  DEFAULT_ERROR_DIR "/home/isit/build/isit/test/testlogs/incr2/"
#define  DEFAULT_DL_DATA_NAME "DlData"
#define  DEFAULT_SIMU_DATA_NAME "SimuData"
#define  DEFAULT_FT_DATA_NAME "FtData"
#define  DEFAULT_EM_DATA_NAME "EmData"
#define  DEFAULT_ST_DATA_NAME "StData"

#define REMINDER_INTERVAL_SEC  30

typedef void (*VoidProc)(Widget, XtPointer, XtPointer);

typedef int BOOL;

typedef struct GIZMO_MAP{ 
	GIZMO_TYPE gtGenericType;
	GIZMO_TYPE gtSpecificType;
	int	   iGuiIndex;
}GIZMO_MAP;

extern ricst_shell_p ricst_shell;
#ifdef CLIENT

Widget *dl_bt_ptr;
Widget *ft_bt_ptr;
Widget *em_bt_ptr;
Widget *st_bt_ptr;
GIZMO_MAP GizmoMap[NUM_SYS_GIZMOS];

ricst_error_shell_p ricst_error_shell = (ricst_error_shell_p)NULL;
ricst_log_shell_p ricst_log_shell = (ricst_log_shell_p)NULL;
ricst_set_time_shell_p ricst_set_time_shell = (ricst_set_time_shell_p)NULL;

dl_shell_p *dl_shell;
dl_gsu_servo_shell_p *dl_gsu_servo_shell;
dl_servo_shell_p *dl_servo_shell;
dl_smt_shell_p *dl_smt_shell;
dl_solt_shell_p *dl_solt_shell;
dl_set_modulation_shell_p *dl_set_modulation_shell;
dl_set_dither_shell_p *dl_set_dither_shell;
ft_shell_p *ft_shell;
ft_get_image_shell_p *ft_get_image_shell;
ft_set_param_shell_p *ft_set_param_shell;
em_shell_p *em_shell;
em_set_param_shell_p *em_set_param_shell;
st_shell_p *st_shell;
st_calibrate_shell_p *st_calibrate_shell;
st_set_servo_shell_p *st_set_servo_shell;

tDlTargetBase *DLCurrentTarget;
tGuiGsuDlServoParameters *DLServoCmd;
tGuiGsuDlServoParameters *DLServoStatus;
tFtSetServoParametersCmd *FTServoCmd;
Gui_Modulation *DLParams;
Gui_Modulation *FTParams;
Gui_Modulation *EMParams;
TIME *DlTime;
tModulationParams *DLModParams;

Pixmap on, off, delay, home;

char defaultname[256];
char rootdir[256];
char guiname[256];

tClientNet *netObj=NULL;
size_t write_interface_count=0;
size_t read_interface_count=0;

XtInputId socket_id;
char hostname[256];
BOOL networkTimeOut;

#else

extern Widget *dl_bt_ptr;
extern Widget *ft_bt_ptr;
extern Widget *em_bt_ptr;
extern Widget *st_bt_ptr;
extern GIZMO_MAP GizmoMap[];

extern ricst_error_shell_p ricst_error_shell;
extern ricst_log_shell_p ricst_log_shell;
extern ricst_set_time_shell_p ricst_set_time_shell;

extern dl_shell_p *dl_shell;
extern dl_gsu_servo_shell_p *dl_gsu_servo_shell;
extern dl_servo_shell_p *dl_servo_shell;
extern dl_smt_shell_p *dl_smt_shell;
extern dl_solt_shell_p *dl_solt_shell;
extern dl_set_modulation_shell_p *dl_set_modulation_shell;
extern dl_set_dither_shell_p *dl_set_dither_shell;
extern ft_shell_p *ft_shell;
extern ft_get_image_shell_p *ft_get_image_shell;
extern ft_set_param_shell_p *ft_set_param_shell;
extern em_shell_p *em_shell;
extern em_set_param_shell_p *em_set_param_shell;
extern st_shell_p *st_shell;
extern st_calibrate_shell_p *st_calibrate_shell;
extern st_set_servo_shell_p *st_set_servo_shell;

extern tDlTargetBase *DLCurrentTarget;
extern tGuiGsuDlServoParameters *DLServoCmd;
extern tGuiGsuDlServoParameters *DLServoStatus;
extern tFtSetServoParametersCmd *FTServoCmd;
extern Gui_Modulation *DLParams;
extern Gui_Modulation *FTParams;
extern Gui_Modulation *EMParams;
extern TIME *DlTime;
extern tModulationParams *DLModParams;

extern Pixmap on, off, delay, home;

extern char defaultname[256];
extern char rootdir[256];
extern char guiname[256];

extern tClientNet *netObj;
extern size_t write_interface_count;
extern size_t read_interface_count;

extern XtInputId  socket_id;
extern char hostname[256];
extern BOOL networkTimeOut;

#endif

#endif INC_clienth

