#ifndef INC_clientDatah
#define INC_clientDatah

/************************************************************************
[[D ::processDlData (int iGizmoId, size_t szBlockSize) ]
[ iGizmoId invalid || szBlockSize => 
    UNDEFINED
| invalid_pointer (dl_shell[ GizmoMap[iGizmoId].iGuiIndex ]) =>
    UNDEFINED
| Read data with size szBlockSize unsucessfully =>
    console := console + read error message
| true =>
    iGizmoId := use system gizmo id iGizmoId to convert to internal gizmo no.
    : szBlockSize := write data of size szBlockSize to disk if write option is on 
    : return := NONE
]]

[[D ::processFtData (int iGizmoId, size_t szBlockSize) ]
[ iGizmoId invalid || szBlockSize => 
    UNDEFINED
| invalid_pointer (ft_shell[ GizmoMap[iGizmoId].iGuiIndex ]) =>
    UNDEFINED
| Read data with size szBlockSize unsucessfully =>
    console := console + read error message 
| true =>
    iGizmoId := use system gizmo id iGizmoId to convert to internal gizmo no.
    : szBlockSize := write data of size szBlockSize to disk if write option is on
    : return := NONE
]]

[[D ::processEmData (int iGizmoId, size_t szBlockSize) ]
[ iGizmoId invalid || szBlockSize => 
    UNDEFINED
| invalid_pointer (em_shell[ GizmoMap[iGizmoId].iGuiIndex ]) =>
    UNDEFINED
| Read data with size szBlockSize unsucessfully =>
    console := console + read error message 
| true =>
    iGizmoId := use system gizmo id iGizmoId to convert to internal gizmo no.
    : szBlockSize := write data of size szBlockSize to disk if write option is on
    : return := NONE
]]

[[D :: writeData(char *buf, int nbytes, Widget text_w, FILE **fp,
                 int toggle_flag, char *default_file_name ) ]
[ invalid_pointer (buf) || invalid widget text_w ||
  invalid pointer pointer fp || invalid_pointer (default_file_name) =>
    UNDEFINED
| true =>
    buf := when toggle_flag is 1, write data buf to disk with nbytes bytes
    : nbytes := size for data buf 
    : text_w := user text input area for filename, use this filename instead of
                default_file_name
    : fp := file pointer to create, write, or/and close
    : toggle_flag := flag to indicate a data recording is selected
    : default_file_name := default filename used to write if no user text 
                           entered on text_w
    : return := None
]]

************************************************************************/
void processDlData(int iGizmoId, size_t szBlockSize);
void processFtData(int iGizmoId, size_t szBlockSize);
void processEmData(int iGizmoId, size_t szBlockSize);
void writeData(char *buf, int nbytes, Widget text_w, FILE **fp,
                 int toggle_flag, char *default_file_name );

#endif INC_clientDatah

