#ifndef INC_clientDlCbh
#define INC_clientDlCbh

/****************************************************************************

[[D ::TssOpenLoop(int iGizmoId, int iGuiGizmoIndex, BOOL bTargetSetActive) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlsatCmd.iGizmoId := iGizmoId
    : data_send.dlsatCmd.Command := DL_CMD_SELECT_TARGET 
    : data_send.dlsatCmd.bTargetSetActive := bTargetSetActive
    : data_send.dlsatCmd.ttWhichTarget := TT_OPEN_LOOP
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::TssManualTarget(int iGizmoId, int iGuiGizmoIndex, 
                      BOOL bTargetSetActive) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlsatCmd.iGizmoId := iGizmoId
    : data_send.dlsatCmd.Command := DL_CMD_SELECT_TARGET 
    : data_send.dlsatCmd.bTargetSetActive := bTargetSetActive
    : data_send.dlsatCmd.ttWhichTarget := TT_MANUAL 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::TssFringeTracker(int iGizmoId, int iGuiGizmoIndex, 
                      BOOL bTargetSetActive) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlsatCmd.iGizmoId := iGizmoId
    : data_send.dlsatCmd.Command := DL_CMD_SELECT_TARGET 
    : data_send.dlsatCmd.bTargetSetActive := bTargetSetActive
    : data_send.dlsatCmd.ttWhichTarget := TT_FT 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::TssExternalMetrology(int iGizmoId, int iGuiGizmoIndex, 
                      BOOL bTargetSetActive) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlsatCmd.iGizmoId := iGizmoId
    : data_send.dlsatCmd.Command := DL_CMD_SELECT_TARGET 
    : data_send.dlsatCmd.bTargetSetActive := bTargetSetActive
    : data_send.dlsatCmd.ttWhichTarget := TT_EM
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::SetOpenLoopTarget(int iGizmoId, int iGuiGizmoIndex, 
                      tDlTargetBase Target) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.instsoltCmd.iGizmoId := iGizmoId
    : data_send.instsoltCmd.Command := INST_CMD_SET_OPEN_LOOP_TARGET
    : data_send.instsoltCmd.Target.dPosition := Target.dPosition
    : data_send.instsoltCmd.Target.tTime := Target.tTime
    : data_send.instsoltCmd.Target.dRate := Target.dRate
    : data_send.instsoltCmd.iDlGizmoId :=  iGizmoId
    : write to error log with data cmd
    : write to error file with data cmd
    : add Target to DLCurrentTarget[iGuiGizmoIndex]
    : send data data_send to external interface via connected socket
]]

[[D ::SetManualTarget(int iGizmoId, int iGuiGizmoIndex, 
                      tDlTargetBase Target) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.instsmtCmd.Command := INST_CMD_SET_MANUAL_TARGET
    : data_send.instsmtCmd.iGizmoId := iGizmoId
    : data_send.instsmtCmd.Target.dPosition :=  Target.dPosition
    : data_send.instsmtCmd.Target.tTime :=  Target.tTime
    : data_send.instsmtCmd.Target.dRate :=  Target.dRate
    : data_send.instsmtCmd.iDlGizmoId :=  iGizmoId
    : write to error log with data cmd
    : write to error file with data cmd
    : add Target to DLCurrentTarget[iGuiGizmoIndex]
    : send data data_send to external interface via connected socket
]]

[[D ::DitherOn(int iGizmoId, int iGuiGizmoIndex, BOOL bTurnDitherOn) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dldoCmd.Command := DL_CMD_DITHER_ON
    : data_send.dldoCmd.bTurnDitherOn := bTurnDitherOn
    : data_send.dldoCmd.iGizmoId := iGizmoId
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::SetOpenLoopAutoReasonable(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : compute position and rate appropriately
    : data_send.instsoltCmd.Command := INST_CMD_SET_OPEN_LOOP_TARGET
    : data_send.instsoltCmd.iGizmoId :=  iGizmoId
    : data_send.instsoltCmd.Target.dPosition :=  position
    : data_send.instsoltCmd.Target.tTime :=  sysTime
    : data_send.instsoltCmd.Target.dRate :=  rate
    : data_send.instsoltCmd.iDlGizmoId :=  iGizmoId
    : write to error log with data cmd
    : write to error file with data cmd
    : add Target to DLCurrentTarget[iGuiGizmoIndex]
    : send data data_send to external interface via connected socket
]]

[[D ::SetOpenLoopAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : compute position, rate, and ttime appropriately
    : data_send.instsoltCmd.Command := INST_CMD_SET_OPEN_LOOP_TARGET
    : data_send.instsoltCmd.iGizmoId :=  iGizmoId
    : data_send.instsoltCmd.Target.dPosition :=  position
    : data_send.instsoltCmd.Target.tTime :=  ttime
    : data_send.instsoltCmd.Target.dRate :=  rate
    : data_send.instsoltCmd.iDlGizmoId
    : write to error log with data cmd
    : write to error file with data cmd
    : add Target to DLCurrentTarget[iGuiGizmoIndex]
    : send data data_send to external interface via connected socket
]]

[[D ::SetManualAutoReasonable(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : compute position and rate appropriately
    : data_send.instsmtCmd.Command := INST_CMD_SET_MANUAL_TARGET
    : data_send.instsmtCmd.iGizmoId := iGizmoId
    : data_send.instsmtCmd.Target.dPosition :=  position
    : data_send.instsmtCmd.Target.tTime :=  sysTime
    : data_send.instsmtCmd.Target.dRate :=  rate
    : data_send.instsmtCmd.iDlGizmoId :=  iGizmoId
    : write to error log with data cmd
    : write to error file with data cmd
    : add Target to DLCurrentTarget[iGuiGizmoIndex]
    : send data data_send to external interface via connected socket
]]

[[D ::SetManualAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : compute position, rate, and ttime appropriately
    : data_send.instsmtCmd.Command := INST_CMD_SET_MANUAL_TARGET
    : data_send.instsmtCmd.iGizmoId := iGizmoId
    : data_send.instsmtCmd.Target.dPosition :=  position
    : data_send.instsmtCmd.Target.tTime:=  ttime
    : data_send.instsmtCmd.Target.dRate :=  rate
    : data_send.instsmtCmd.iDlGizmoId :=  iGizmoId
    : write to error log with data cmd
    : write to error file with data cmd
    : add Target to DLCurrentTarget[iGuiGizmoIndex]
    : send data data_send to external interface via connected socket
]]

[[D ::SetDither(int iGizmoId, int iGuiGizmoIndex, double dAmplitude, 
                double dPeriod) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlsdCmd.Command := DL_CMD_SET_DITHER
    : data_send.dlsdCmd.iGizmoId := iGizmoId
    : data_send.dlsdCmd.dAmplitude :=  dAmplitude
    : data_send.dlsdCmd.dPeriod := dPeriod 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLHomeCheck(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlhcCmd.iGizmoId := iGizmoId
    : data_send.dlhcCmd.Command := DL_CMD_HOME_CHECK
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLOff(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dloCmd.iGizmoId := iGizmoId
    : data_send.dloCmd.Command := DL_CMD_OFF
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLFront(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlfCmd.iGizmoId := iGizmoId
    : data_send.dlfCmd.Command := DL_CMD_FRONT
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLBack(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlbCmd.iGizmoId := iGizmoId
    : data_send.dlbCmd.Command := DL_CMD_BACK
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLTrack(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dltCmd.iGizmoId := iGizmoId
    : data_send.dltCmd.Command := DL_CMD_TRACK 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLUser1(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlu1Cmd.iGizmoId := iGizmoId
    : data_send.dlu1Cmd.Command := DL_CMD_USER1 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLUser2(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlu2Cmd.iGizmoId := iGizmoId
    : data_send.dlu2Cmd.Command := DL_CMD_USER2 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]


[[D ::DLSetModulation(int iGizmoId, int iGuiGizmoIndex, 
                      MOD_TYPE mtModulationType,
                      double dAmplitude, double dFrequency, double dMeanVal,
                      TIME tSyncTime) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlsmCmd.iGizmoId := iGizmoId
    : data_send.dlsmCmd.Command := DL_CMD_MODULATE
    : data_send.dlsmCmd.dAmplitude :=  dAmplitude
    : data_send.dlsmCmd.dFrequency :=  dFrequency
    : data_send.dlsmCmd.mtModulationType := mtModulationType
    : data_send.dlsmCmd.dMeanVal :=  dMeanVal
    : data_send.dlsmCmd.tSyncTime :=  tSyncTime
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLHomeSet(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlhsCmd.iGizmoId := iGizmoId
    : data_send.dlhsCmd.Command := DL_CMD_HOME_SET 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLDitherCalibrate(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dldcCmd.iGizmoId := iGizmoId
    : data_send.dldcCmd.Command := DL_CMD_DITHER_CALIBRATE
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLDitherCheck(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dldchkCmd.iGizmoId := iGizmoId
    : data_send.dldchkCmd.Command := DL_CMD_DITHER_CHECK
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLPing(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlpCmd.iGizmoId := iGizmoId
    : data_send.dlpCmd.Command := DL_CMD_PING
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLClrLaserCtr(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlclcCmd.iGizmoId := iGizmoId
    : data_send.dlclcCmd.Command := DL_CMD_CLR_LASER_CTR 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::DLSetServoParam(int iGizmoId, int iGuiGizmoIndex,
                      TRACK_SERVO_PARAMS &servoCmd) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.dlsspCmd.iGizmoId := iGizmoId
    : data_send.dlsspCmd.Command := DL_CMD_CHNG_SERVO_PARAM
    : data_send.dlsspCmd.ServoParams := servoCmd
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

****************************************************************************/
void TssOpenLoop(int iGizmoId, int iGuiGizmoIndex, BOOL bTargetSetActive);
void TssManualTarget(int iGizmoId, int iGuiGizmoIndex, BOOL bTargetSetActive);
void TssFringeTracker(int iGizmoId, int iGuiGizmoIndex, BOOL bTargetSetActive);

void TssExternalMetrology(int iGizmoId, int iGuiGizmoIndex, BOOL bTargetSetActive);
void SetOpenLoopTarget(int iGizmoId, int iGuiGizmoIndex, tDlTargetBase Target);

void SetManualTarget(int iGizmoId, int iGuiGizmoIndex, tDlTargetBase Target);

void DitherOn(int iGizmoId, int iGuiGizmoIndex, BOOL bTurnDitherOn);
void DataRecord(int iGizmoId, int iGuiGizmoIndex, BOOL bTurnRecordOn);

void SetOpenLoopAutoReasonable(int iGizmoId, int iGuiGizmoIndex);
void SetOpenLoopAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex);

void SetManualAutoReasonable(int iGizmoId, int iGuiGizmoIndex);

void SetManualAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex);

void SetDither(int iGizmoId, int iGuiGizmoIndex, double dAmplitude, double dPeriod);
     
void DLHomeCheck(int iGizmoId, int iGuiGizmoIndex);
void DLOff(int iGizmoId, int iGuiGizmoIndex);
void DLFront(int iGizmoId, int iGuiGizmoIndex);
void DLBack(int iGizmoId, int iGuiGizmoIndex);
void DLTrack(int iGizmoId, int iGuiGizmoIndex);
void DLUser1(int iGizmoId, int iGuiGizmoIndex);
void DLUser2(int iGizmoId, int iGuiGizmoIndex);
void DLSetModulation(int iGizmoId, int iGuiGizmoIndex, 
                MOD_TYPE mtModulationType,
                double dFrequency, double dAmplitude, double dMeanVal,
                TIME tSyncTime);
void DLSetModulationAutoReasonable(int iGizmoId, int iGuiGizmoIndex);
void DLSetModulationAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex);

void DLHomeSet(int iGizmoId, int iGuiGizmoIndex);

void DLDitherCalibrate(int iGizmoId, int iGuiGizmoIndex);

void DLDitherCheck(int iGizmoId, int iGuiGizmoIndex);

void DLPing(int iGizmoId, int iGuiGizmoIndex);

void DLClrLaserCtr(int iGizmoId, int iGuiGizmoIndex);
void DLSetServoParam(int iGizmoId, int iGuiGizmoIndex, tGuiGsuDlServoParameters&servoCmd);

#ifdef TBD
void SetBb1ServoParamsAutoReasonable(int iGizmoId, int iGuiGizmoIndex,
                                TRACK_SERVO_PARAMS& servoParam);
void SetQuicServoParamsAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex,
                                TRACK_SERVO_PARAMS& servoParam);
void SetBb2ServoParamsAutoReasonable(int iGizmoId, int iGuiGizmoIndex,
                                TRACK_SERVO_PARAMS& servoParam);
void SetGsuServoParamsAutoReasonable(int iGizmoId, int iGuiGizmoIndex,
                                tGuiGsuDlServoParameters& servoParam);
void SetGsuServoParamsAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex,
                                tGuiGsuDlServoParameters& servoParam);

#endif TBD
void
SetDitherAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex);

#endif INC_clientDlCbh

