#ifndef INC_clientEmCbh
#define INC_clientEmCbh

/************************************************************************
[[D ::EMOff(int iGizmoId, int iGuiGizmoIndex) ]
[ GizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.emoCmd.iGizmoId := iGizmoId
    : data_send.emoCmd.Command := EM_CMD_OFF
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]


[[D ::EMTrack(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.emtCmd.iGizmoId := iGizmoId
    : data_send.emtCmd.Command := EM_CMD_TRACK
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::EMPing(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.empCmd.iGizmoId := iGizmoId
    : data_send.empCmd.Command := EM_CMD_PING 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::EMSetParams(int iGizmoId, int iGuiGizmoIndex
            MOD_TYPE  mtModulationType,
            double    dAmplitude,
            double    dFrequency,
            double    dMeanVal,
            TIME      tSyncTime) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.emsspCmd.iGizmoId := iGizmoId
    : data_send.emsspCmd.Command := EM_CMD_CHNG_PARAM
    : data_send.emsspCmd.dAmplitude := dAmplitude
    : data_send.emsspCmd.dFrequency := dFrequency
    : data_send.emsspCmd.dMeanVal := dMeanVal
    : data_send.emsspCmd.mtModulationType := mtModulationType
    : data_send.emsspCmd.tSyncTime := tSyncTime
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::EMSetParamsAutoReasonable(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.emsspCmd.iGizmoId := iGizmoId
    : data_send.emsspCmd.Command := EM_CMD_CHNG_PARAM
    : data_send.emsspCmd.dAmplitude := dAmplitude
    : data_send.emsspCmd.dFrequency := dFrequency
    : data_send.emsspCmd.dMeanVal := dMeanVal
    : data_send.emsspCmd.mtModulationType := mtModulationType
    : data_send.emsspCmd.tSyncTime := tSyncTime
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::EMSetParamsAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.emsspCmd.iGizmoId := iGizmoId
    : data_send.emsspCmd.Command := EM_CMD_CHNG_PARAM
    : data_send.emsspCmd.dAmplitude := dAmplitude
    : data_send.emsspCmd.dFrequency := dFrequency
    : data_send.emsspCmd.dMeanVal := dMeanVal
    : data_send.emsspCmd.mtModulationType := mtModulationType
    : data_send.emsspCmd.tSyncTime := tSyncTime
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]


****************************************************************************/
void EMOff(int iGizmoId, int iGuiGizmoIndex);
void EMTrack(int iGizmoId, int iGuiGizmoIndex);
void EMPing(int iGizmoId, int iGuiGizmoIndex);
void EMSetParams(int iGizmoId, int iGuiGizmoIndex,
            MOD_TYPE  mtModulationType,
            double    dAmplitude,
            double    dFrequency,
            double    dMeanVal,
            TIME      tSyncTime);

void EMSetParamsAutoReasonable(int iGizmoId, int iGuiGizmoIndex);
void EMSetParamsAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex);


#endif INC_clientEmCbh

