#ifndef INC_clientFtCbh
#define INC_clientFtCbh

/************************************************************************
[[D ::FTOff(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.ftoCmd.iGizmoId := iGizmoId
    : data_send.ftoCmd.Command := FT_CMD_OFF
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::FTTrack(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.fttCmd.iGizmoId := iGizmoId
    : data_send.fttCmd.Command := FT_CMD_TRACK 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::FTPing(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.ftpCmd.iGizmoId := iGizmoId
    : data_send.ftpCmd.Command := FT_CMD_PING 
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::FTSetParams(int iGizmoId, int iGuiGizmoIndex
            MOD_TYPE  mtModulationType,
            double    dAmplitude,
            double    dFrequency,
            double    dMeanVal,
            TIME      tSyncTime) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.ftcpCmd.iGizmoId := iGizmoId
    : data_send.ftcpCmd.Command := DL_CMD_HOME_SET 
    : data_send.ftcpCmd.dAmplitude := dAmplitude
    : data_send.ftcpCmd.dFrequency := dFrequency
    : data_send.ftcpCmd.dMeanVal := dMeanVal
    : data_send.ftcpCmd.mtModulationType := mtModulationType
    : data_send.ftcpCmd.tSyncTime := tSyncTime
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::FTSetParamsAutoReasonable(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.ftcpCmd.iGizmoId := iGizmoId
    : data_send.ftcpCmd.Command := DL_CMD_HOME_SET
    : data_send.ftcpCmd.dAmplitude := dAmplitude
    : data_send.ftcpCmd.dFrequency := dFrequency
    : data_send.ftcpCmd.dMeanVal := dMeanVal
    : data_send.ftcpCmd.mtModulationType := mtModulationType
    : data_send.ftcpCmd.tSyncTime := tSyncTime
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::FTSetParamsAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.ftcpCmd.iGizmoId := iGizmoId
    : data_send.ftcpCmd.Command := DL_CMD_HOME_SET
    : data_send.ftcpCmd.dAmplitude := dAmplitude
    : data_send.ftcpCmd.dFrequency := dFrequency
    : data_send.ftcpCmd.dMeanVal := dMeanVal
    : data_send.ftcpCmd.mtModulationType := mtModulationType
    : data_send.ftcpCmd.tSyncTime := tSyncTime
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::FTGetImg(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.ftgiCmd.iGizmoId := iGizmoId
    : data_send.ftgiCmd.Command := FT_CMD_GET_IMAGE
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::FTSetROI(int iGizmoId, int iGuiGizmoIndex
              int iStartXSt0, int iStartYSt0,
              int iStartXSt1, int iStartYSt1,
              int iStartXFringeImage, int iStartYFringeImage) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.ftsroiCmd.iGizmoId := iGizmoId
    : data_send.ftsroiCmd.Command := FT_CMD_SET_ROI
    : data_send.ftsroiCmd.ImageParameters.iStartXSt0 := iStartXSt0
    : data_send.ftsroiCmd.ImageParameters.iStartYSt0 := iStartYSt0
    : data_send.ftsroiCmd.ImageParameters.iStartXSt1 := iStartXSt1
    : data_send.ftsroiCmd.ImageParameters.iStartYSt1 := iStartYSt1
    : data_send.ftsroiCmd.ImageParameters.iStartXFringeImage :=
                                              iStartXFringeImage
    : data_send.ftsroiCmd.ImageParameters.iStartYFringeImage :=
                                              iStartYFringeImage

    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]
************************************************************************/
void FTOff(int iGizmoId, int iGuiGizmoIndex);
void FTTrack(int iGizmoId, int iGuiGizmoIndex);
void FTPing(int iGizmoId, int iGuiGizmoIndex);
void FTSetParams(int iGizmoId, int iGuiGizmoIndex,
            tFtSetServoParametersCmd& FtServoParams);

void FTSetParamsAutoReasonable(int iGizmoId, int iGuiGizmoIndex);
void FTSetParamsAutoUnreasonable(int iGizmoId, int iGuiGizmoIndex);
void FTGetImg(int iGizmoId, int iGuiGizmoIndex);
void FTSetROI(int iGizmoId, int iGuiGizmoIndex,
              int iStartXSt0, int iStartYSt0,
              int iStartXSt1, int iStartYSt1,
              int iStartXFringeImage, int iStartYFringeImage);
void FTSetManualTarget(int iGizmoId, int iGuiGizmoIndex, 
                       FT_TARGET_DIRECTION targetDirection);


#endif INC_clientFtCbh

