#ifndef INC_clientInith
#define INC_clientInith

/**************************************************************************

[[D ::set_dl_pixmap(dl_shell_p dl_shell_ptr) ]
[ invalid_pointer(dl_shell_ptr) => UNDEFINED
| true =>
    create pixmap figures for on and off switch on delay line limits, the
       delay line at home sensor, and one without home sensor.
    : initialize delay line window pixmaps
]]

[[D ::GizmoIntoGuiIndex(GIZMO_TYPE gtGenericType, int iGuiIndex,
                                GIZMO_TYPE gtSpecificType, int iGizmoId) ]
[ invalid iGizmoId || iGizmoId is not in range => UNDEFINED
| invalid GizmoMap[] => UNDEFINED
| true =>
    GizmoMap[iGizmoId].gtGenericType := gtGenericType
    : GizmoMap[iGizmoId].gtSpecificType := gtSpecificType
    : GizmoMap[iGizmoId].iGuiIndex := iGuiIndex

]]

[[D ::popup_dialog(Widget widget, XtPointer client_data, XtPointer call_data) ]
[ invalid widget || invalid client_data || invalid call_data => UNDEFINED
| true =>
    Popup the dialog 

]]

[[D ::show_dialog(Widget dialog) ]
[ invalid dialog => UNDEFINED
| true =>
    Show and raise dialog

]]

[[D ::hide_dialog(Widget dialog) ]
[ invalid dialog => UNDEFINED
| true =>
    Hide and close dialog

]]

[[D ::dl_shell_init(int dl_no, int iGizmoId, GIZMO_TYPE gtSpecificType) ]
[ dl_no < 0 || dl_no >= number of maximum delay line => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create delay line shell and initialize

]]

[[D ::dl_gsu_servo_shell_init (int dl_no, int iGizmoId) ]
[ dl_no < 0 || dl_no >= number of maximum delay line => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create GSU servo parameters shell and initialize

]]

[[D ::dl_servo_shell_init(int dl_no, int iGizmoId) ]
[ dl_no < 0 || dl_no >= number of maximum delay line => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create servo parameters shell and initialize

]]

[[D ::dl_servo_shell_init(int dl_no, int iGizmoId) ]
[ dl_no < 0 || dl_no >= number of maximum delay line => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create servo parameters shell and initialize

]]

[[D ::dl_smt_shell_init(int dl_no, int iGizmoId) ]
[ dl_no < 0 || dl_no >= number of maximum delay line => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create set manual target shell and initialize

]]

[[D ::dl_solt_shell_init (int dl_no, int iGizmoId) ]
[ dl_no < 0 || dl_no >= number of maximum delay line => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create set open loop target shell and initialize

]]

[[D ::dl_set_modulation_shell_init(int dl_no, int iGizmoId) ]
[ dl_no < 0 || dl_no >= number of maximum delay line => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create set modulation shell and initialize

]]

[[D ::dl_set_dither_shell_init (int dl_no, int iGizmoId) ]
[ dl_no < 0 || dl_no >= number of maximum delay line => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create delay line set dither shell and initialize

]]

[[D ::ft_shell_init(int dl_no, int iGizmoId) ]
[ ft_no < 0 || ft_no >= number of maximum fringe tracker => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create fringe tracker shell and initialize

]]

[[D ::ft_get_image_shell_init(int dl_no, int iGizmoId) ]
[ ft_no < 0 || ft_no >= number of maximum fringe tracker => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create fringe tracker get image shell and initialize

]]

[[D ::ft_set_param_shell_init(int dl_no, int iGizmoId) ]
[ ft_no < 0 || ft_no >= number of maximum fringe tracker => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create fringe tracker set parameters shell and initialize

]]

[[D ::em_shell_init(int dl_no, int iGizmoId) ]
[ em_no < 0 || em_no >= number of maximum external metrology => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create external metrology shell and initialize

]]

[[D ::em_get_image_shell_init(int dl_no, int iGizmoId) ]
[ em_no < 0 || em_no >= number of maximum fringe tracker => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create external metrology set parameters shell and initialize

]]

[[D ::st_shell_init(int dl_no, int iGizmoId) ]
[ st_no < 0 || st_no >= number of maximum star tracker => UNDEFINED
| iGizmoId is out of range => UNDEFINED
| true =>
    Create star tracker shell and initialize

]]

*************************************************************************/
void set_dl_pixmap(dl_shell_p dl_shell_ptr);
void GizmoIntoGuiIndex(GIZMO_TYPE gtGenericType, int iGuiIndex,
                                GIZMO_TYPE gtSpecificType, int iGizmoId);

void popup_dialog(Widget widget, XtPointer client_data, XtPointer call_data);
void show_dialog(Widget dialog);
void hide_dialog(Widget dialog);


void dl_shell_init (int dl_no, int iGizmoId, GIZMO_TYPE gtSpecificType);
void dl_gsu_servo_shell_init (int dl_no, int iGizmoId);
void dl_servo_shell_init (int dl_no, int iGizmoId);
void dl_smt_shell_init (int dl_no, int iGizmoId);
void dl_solt_shell_init (int dl_no, int iGizmoId);
void dl_set_modulation_shell_init (int dl_no, int iGizmoId);
void dl_set_dither_shell_init (int dl_no, int iGizmoId);
void ft_shell_init (int ft_no, int iGizmoId);
void ft_get_image_shell_init (int ft_no, int iGizmoId);
void ft_set_param_shell_init (int ft_no, int iGizmoId);
void em_shell_init (int em_no, int iGizmoId);
void em_set_param_shell_init (int em_no, int iGizmoId);
void st_shell_init (int st_no, int iGizmoId);
void st_set_servo_shell_init(int st_no, int iGizmoId);
void st_calibrate_shell_init(int st_no, int iGizmoId);


#endif INC_clientInith
