#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <ctype.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sgtty.h>
#include <sys/param.h>
#include <sys/uio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/file.h>
#include <string.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <errno.h>
#include <X11/Intrinsic.h>
#include "isitUnix.h"


#ifndef INC_CLIENTNETh
#define INC_CLIENTNETh

#define SERVER_PORT_NUM 5001
#define MAXIMUM_PORT_NUM 9001

#define FAILED  -1
#define STOPPED 0
#define SUCCESS 1
#define TIMEOUT 2

/****************************************************************************

[[D tClientNet::tClientNet(void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->bInit := FALSE
    : this->iPortInUse := SERVER_PORT_NUM 
]]

[[D tClientNet::~tClientNet(void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    *this := anything
    : connection with socket this->iSocketInUse is closed
]]

[[D tClientNet::makeConnection(char *hostname) ]
[ invalid_pointer (this) => UNDEFINED
| invalid hostname ||
  Failed to obtain entries for hostname ||
  Unable to create socket ||
  Unable to initiate a connection on socket this->iSocketInUse =>
     return := -1
| true =>
    this->iPortInUse := successful connection port
    : this->bInit := TRUE
    : return := 1 
]]

[[D tClientNet::terminateConnection(void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->bInit := FALSE
    : connection with socket this->iSocketInUse is closed
]]

[[D tClientNet::setInit(BOOL bInitFlag) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->bInit := bInitFlag 
]]

[[D tClientNet::GetInit(void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    return := this->bInit
]]

[[D tClientNet::getSocketHandle(void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    return := this->iSocketInUse
]]

[[D tClientNet::writen(char *ptr,size_t size) ]
[ invalid_pointer (this) ||
  invalid_pointer (ptr) => UNDEFINED
| this->bInit == False =>
    return := 0
| number of bytes return by write() on ptr <= 0  =>
    return := number of bytes written
| true =>
    return := size
]]

[[D tClientNet::readn(char *ptr,size_t size) ]
[ invalid_pointer (this) ||
  invalid_pointer (ptr) => UNDEFINED
| number of bytes return by read() on ptr < 0  =>
    return := number of bytes read
| number of bytes return by read() on ptr == 0  =>
    return := (size -  number of remaining bytes to be read)
| true =>
    return := size
]]

[[D tClientNet::read(char *ptr,size_t size) ]
[ invalid_pointer (this) ||
  invalid_pointer (ptr) => UNDEFINED
| number of bytes return by read() on ptr < 0  =>
    return := number of bytes read
| number of bytes return by read() on ptr == 0  =>
    return := number of bytes read 
| true =>
    return := size
]]

****************************************************************************/
class tClientNet {
  public:
    tClientNet();
    ~tClientNet();
    int makeConnection(char *hostname);
    int terminateConnection(void);
    void setInit(BOOL bInitFlag);
    BOOL GetInit(void) { return bInit; }
    int getSocketHandle(void) { return iSocketInUse; }
    int writen(char *ptr,size_t size);
    int readn(char *ptr,size_t size);
    int readOnce(char *ptr,size_t size);
  protected:
    BOOL bInit;
    int iPortInUse;
    int iSocketInUse;
    char sHostName[MAXHOSTNAMELEN];
};

#endif INC_CLIENTNETh


