#ifndef INC_clientReadInputh
#define INC_clientReadInputh

/**************************************************************************

[[D ::readInput(XtPointer client_data, int *fid, XtInputId *id) ]
[ invalid_pointer(fid) || invalid_pointer(id) => UNDEFINED
| true =>
    fid := a file id to read information over the network. Information
       can be either error stream, data stream, or status stream.
    : process each stream information type 
]]

[[D ::processError(size_t szBlockSize) ]
[ invalid szBlockSize => UNDEFINED
| true =>
    szBlockSize := read error information of size szBlockSize over
       the network, write error information to the log message panel,
       and to disk depending on whether the write option is selected 
]]
**************************************************************************/
void readInput(XtPointer client_data, int *fid, XtInputId *id);
void processError(size_t szBlockSize);

#endif INC_clientReadInputh
