#ifndef INC_clientStCbh
#define INC_clientStCbh

/************************************************************************
[[D ::STOff(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.stoCmd.iGizmoId := iGizmoId
    : data_send.stoCmd.Command := ST_CMD_OFF
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::STTrack(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.sttCmd.iGizmoId := iGizmoId
    : data_send.sttCmd.Command := ST_CMD_TRACK
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]

[[D ::STPing(int iGizmoId, int iGuiGizmoIndex) ]
[ iGizmoId < 0 || iGuiGizmoIndex < 0  => UNDEFINED
| true =>
    sets the first 256 bytes in memory area cmd to 0
    : copy appropriate error message text into cmd
    : data_send.stpCmd.iGizmoId := iGizmoId
    : data_send.stpCmd.Command := ST_CMD_PING
    : write to error log with data cmd
    : write to error file with data cmd
    : send data data_send to external interface via connected socket
]]
************************************************************************/

void STOff(int iGizmoId, int iGuiGizmoIndex);
void STTrack(int iGizmoId, int iGuiGizmoIndex);
void STPing (int iGizmoId, int iGuiGizmoIndex);

void STHome (int iGizmoId, int iGuiGizmoIndex);
void STCalibrate(int iGizmoId, int iGuiGizmoIndex,
            tStCalibrateCmd& StCalibrate);

void STSetParams(int iGizmoId, int iGuiGizmoIndex,
            tStSetServoParamsCmd& StServoParams);

#endif INC_clientStCbh
