#ifndef INC_clientStatush
#define INC_clientStatush


/************************************************************************
[[D ::process_dl_status(dl_shell_p dlShellPtr,int iGizmoId,
                        tDlStatus status_data) ]
[ invalid_pointer(dlShellPtr) || iGizmoId is not in range => UNDEFINED
| invalid status_data => UNDEFINED
| true =>
    dlShellPtr := Pointer to dl shell display that is updated with 
       status_data
    : iGizmoId := use this to map into gizmo type and number
    : status_data := status info used to update the display
]]

[[D ::process_em_status(em_shell_p emShellPtr,int iGizmoId,
                        tEmStatus status_data) ]
[ invalid_pointer(emShellPtr) || iGizmoId is not in range => UNDEFINED
| invalid status_data => UNDEFINED
| true =>
    emShellPtr := Pointer to em shell display that is updated with 
       status_data
    : iGizmoId := use this to map into gizmo type and number
    : status_data := status info used to update the display
]]

[[D ::process_ft_status(ft_shell_p ftShellPtr,int iGizmoId,
                        tFtStatus status_data) ]
[ invalid_pointer(ftShellPtr) || iGizmoId is not in range => UNDEFINED
| invalid status_data => UNDEFINED
| true =>
    ftShellPtr := Pointer to ft shell display that is updated with 
       status_data
    : iGizmoId := use this to map into gizmo type and number
    : status_data := status info used to update the display
]]

[[D ::process_st_status(st_shell_p stShellPtr,int iGizmoId,
                        tStStatus status_data) ]
[ invalid_pointer(stShellPtr) || iGizmoId is not in range => UNDEFINED
| invalid status_data => UNDEFINED
| true =>
    stShellPtr := Pointer to st shell display that is updated with 
       status_data
    : iGizmoId := use this to map into gizmo type and number
    : status_data := status info used to update the display
]]

[[D ::processDlStatus(int iGizmoId, size_t szBlockSize) ]
[ iGizmoId is not in range || invalid szBlockSize => UNDEFINED
| true =>
    iGizmoId := use this to map into gizmo type and delay line number
    : szBlockSize := read szBlockSize bytes over the network
]]

[[D ::processFtStatus(int iGizmoId, size_t szBlockSize) ]
[ iGizmoId is not in range || invalid szBlockSize => UNDEFINED
| true =>
    iGizmoId := use this to map into gizmo type and FT number
    : szBlockSize := read szBlockSize bytes over the network
]]

[[D ::processEmStatus(int iGizmoId, size_t szBlockSize) ]
[ iGizmoId is not in range || invalid szBlockSize => UNDEFINED
| true =>
    iGizmoId := use this to map into gizmo type and EM number
    : szBlockSize := read szBlockSize bytes over the network
]]

[[D ::processStStatus(int iGizmoId, size_t szBlockSize) ]
[ iGizmoId is not in range || invalid szBlockSize => UNDEFINED
| true =>
    iGizmoId := use this to map into gizmo type and ST number
    : szBlockSize := read szBlockSize bytes over the network
]]

************************************************************************/
void process_dl_status(dl_shell_p dlShellPtr,int iGizmoId,tGsuDlStatus status_data);
void process_em_status(em_shell_p emShellPtr,int iGizmoId,tEmStatus status_data);
void process_ft_status(ft_shell_p ftShellPtr,int iGizmoId,tFtStatus status_data);
void process_st_status(st_shell_p stShellPtr,int iGizmoId,tStStatus status_data);
void processDlStatus(int iGizmoId, size_t szBlockSize);
void processFtStatus(int iGizmoId, size_t szBlockSize);
void processEmStatus(int iGizmoId, size_t szBlockSize);
void processFtImageStatus(int iGizmoId, size_t szBlockSize, int &read_header);
void processFtFullImageStatus(int iGizmoId, size_t szBlockSize, 
                              int &read_header);
void processStStatus(int iGizmoId, size_t szBlockSize);
void processStImageStatus(int iGizmoId, size_t szBlockSize);
void processStStarPositionStatus(int iGizmoId, size_t szBlockSize);

#endif INC_clientStatush
