#ifndef INC_clientUtilsh
#define INC_clientUtilsh

#define YES 1
#define NO  2
#define QUESTION \
"Delay Line Dither is NOT turned on.\nDo you still want to track?"

/****************************************************************************

[[D ::write_to_log(char *msg, int len) ]
[ invalid_pointer (msg) => UNDEFINED
| true =>
    append message msg to log message panel
]]

[[D ::write_to_error_file(char *buf, int nbytes) ]
[ invalid_pointer (buf) => UNDEFINED
| error flag disabled  => DO_NOTHING
| filename not entered in text widget =>
    use default filename
    : open and write with default filename of data buf
| true =>
    extract specific filename
    : open and write with specifici filename of data buf
]]

[[D ::do_command(char *pStuff, size_t sSize) ]
[ invalid_pointer (pStuff) => UNDEFINED
| true =>
    send pStuff to external interface thru socket connection
]]

[[D ::compTotalTarget(int iGuiGizmoIndex, tDlTargetBase dtNewTarget) ]
[ iGuiGizmoIndex is < 0 => UNDEFINED
| true =>
   DLCurrentTarget[iGuiGizmoIndex].dPosition := 
      DLCurrentTarget[iGuiGizmoIndex].dPosition +  dtNewTarget.dPosition +
         (dtNewTarget.dRate *
          (DLCurrentTarget[iGuiGizmoIndex].tTime - dtNewTarget.tTime))

   : DLCurrentTarget[iGuiGizmoIndex].dRate := 
      DLCurrentTarget[iGuiGizmoIndex].dRate + dtNewTarget.dRate

]]

[[D ::write_to_interface(char *buf, int nbytes) ]
[ invalid_pointer(buf) || invalid nbytes => UNDEFINED
| true =>
    Write data buf with nbytes bytes to the command line interface 
]]

[[D ::read_interface_input(XtPointer client_data, int *fid, XtInputId *id) ]
[ invalid_pointer(fid) || invalid_pointer(id) => UNDEFINED
| true =>
    Read ommand line interface data  
]]

[[D ::clientCreateConnection(void) ]
[ Cannot allocate memory for a new tClientNet object => UNDEFINED
| Create a new tClientNet object unsucessfully =>
    return := -1
| true =>
    Create a new tClientNet object  
    : return := 1
]]

[[D ::clientDestroyConnection(void) ]
[ Cannot destroy and deallocat memory for a tClientNet object => UNDEFINED
| true =>
    Destroy and deallocate memory for a tClientNet object  
]]

[[D ::clientReadn(char *pStuff, size_t sSize) ]
[ invalid_pointer(pStuff) || invalid size sSize => UNDEFINED
| true =>
    Read over the network into data pStuff with size sSize  
]]

[[D ::clientRead(char *pStuff, size_t sSize) ]
[ invalid_pointer(pStuff) || invalid size sSize => UNDEFINED
| true =>
    Read over the network into data pStuff with size sSize  
]]

[[D ::clientMakeConnection(char *hostname) ]
[ invalid_pointer(hostname) => UNDEFINED
| Cannot create socket and establish connection =>
  return := -1
| true =>
    Create socket and establish connection sucessfully
    : return := 1  
]]

[[D ::clientTerminateConnection(void) ]
[ Cannot close network connection => UNDEFINED
| true =>
    Close network connection  
]]

[[D ::clientGetSocketHandle(void) ]
[ invalid network connection => UNDEFINED
| true =>
    Get the socket handle for network connection  
]]

****************************************************************************/

void write_to_log(char *msg, int len);
void write_to_error_file(char *buf, int nbytes);
void do_command(char *pStuff, size_t sSize);
void compTotalTarget(int iGuiGizmoIndex, tDlTargetBase dtNewTarget);
void write_to_interface(char *buf, int nbytes);
void read_interface_input(XtPointer client_data, int *fid, XtInputId *id);
int clientCreateConnection(void);
void clientDestroyConnection(void);
int clientReadn(char *pStuff, size_t sSize);
int clientRead(char *pStuff, size_t sSize);
int clientMakeConnection(char *hostname);
int clientTerminateConnection(void);
int clientGetSocketHandle(void);
void Quit();
void Reset(Widget w);
double calculateModulation(TIME tTime, int dl_no);
void record_simulation(int dl_no);
int interfaceCreate(void);
int interfaceDestroy(void);
void TimeoutCursors( Boolean on, Boolean interruptable);
void connectServer( XtPointer client_data, XtIntervalId *id);
void delete_window_handler(Widget w);
void del_window_cb( Widget widget, XtPointer client_data, XtPointer call_data);
BOOL clientIsConnected(void);
void response( Widget widget, XtPointer client_data, XtPointer call_data);
int AskUser(Widget parent, char *question);

#endif  INC_clientUtilsh
