/* $RCSfile: vme.cc,v $ - vme-specific calls */

/* 
$Header: /home/chara/cvsroot/ople/sys/hw/hardware/vme.cc,v 1.1.1.1 1998/06/11 21:36:34 chara Exp $
*/

/*
modification history
--------------------
01a,pci,03Jun97     written
*/

#include "isit.h"
#include "hwTypesP.h"
//#include "hwError.h"

/****************************************************************
*
* tVmeAddress::GetLocalAddress(void) - Returns local address of this object 
*
[[U tVmeAddress::GetLocalAddress()]]
*
*****/
volatile uint8_t * tVmeAddress::GetLocalAddress(void)
{
  ERROR_CODE ec;
  volatile uint8_t *vu8ReturnValue = NULL;
 
  if(this->pu8Address==NULL || this->iModifier==0) {
    TraceMsg(tmt_ERROR, S_hw_GET_LOCAL_ADDRESS_ATTEMPTED_ON_NULL_VALUE,
             "GetLocalAddress attempted on NULL value");
  }

  /*
  SYNOPSIS 
       STATUS sysBusToLocalAdrs
           int   adrsSpace,    // bus address space in which busAdrs resides
           char  *busAdrs,     // bus address to convert
           char  **pLocalAdrs  // where to return local address

  DESCRIPTION 
       This routine gets the local address that accesses a specified bus
       memory address. NOTE: This is a generic man page for a BSP-specific
       routine; this description contains general information only. To
       determine if this routine is supported by your BSP, or for information
       specific to your BSP's version of this routine, see the man pages for
       your BSP. 

  RETURNS 
       OK, or ERROR if the address space is unknown or the mapping is not
       possible. 
  */ 
  /*
  [ this is invalid || *this is invalid => UNDEFINED
  | this->pu8Address not reachable by CPU =>
      return VxWorks error code from sysBusToLocalAdrs
  | true =>
      return := local address corresponding to vmeBoardAddress
  ] */
  ec = (ERROR_CODE)sysBusToLocalAdrs(this->iModifier,
                            (char *) this->pu8Address,
                            (char**) &(vu8ReturnValue));
  if(ec!=OK) {
    TraceMsg(tmt_ERROR, ec, "Error during sysBusTo LocalAdrs -- returning NULL");
    return NULL;
  }

  return vu8ReturnValue;
}

