/* $RCSfile: mm6216.h,v $ - MM6216 memory card class definition */

/* 
$Header: /home/chara/cvsroot/ople/sys/hw/include/mm6216.h,v 1.1.1.1 1998/06/11 21:36:35 chara Exp $
*/

/*
* This file contains the black box spec and class definitions necessary to
*  initialize and use the MPV906 A/D board.  
*/

/*
modification history
--------------------
01a,pci,15Apr97               written
*/


#ifndef INC_mm6216h
#define INC_mm6216h

#include "board.h"

/*******************************************************************************
*
* class tMm6216Board
*
*
*
* tMm6216Board::tMm6216Board - constructor for SHMEMory board
*
[[D tMm6216Board::tMm6216Board(int iBoardNum)]
[ this is invalid => UNDEFINED
| true =>
  Set vme address and board name appropriate to iBoardNum
]]
*
*********************************************************
*
* tMm6216Board::SoftInit - initializes class variables
*
[[D tMm6216Board::SoftInit(void)]
[ this is invalid => UNDEFINED
| this->CuiDefaultMemSize % 4 != 0 =>
  return := S_mm6216_MEMORY_SIZE_NOT_4_BYTE_ALIGNED
| true =>
  this->viLocalAddress       := this->vu8LocalAddress
  : this->uiSize             := CuiDefaultMemSize
  : this->uiMemSizeLongWords := CuiDefaultMemSize / 4
  : return := OK
]]
*
*********************************************************
*
* tMm6216Board::HardInit - initializes class variables and all memory locations
*
[[D tMm6216Board::HardInit(void)]
[ this is invalid => UNDEFINED
| true =>
  [[U tMm6216Board::SoftInit()]]
  : Initialize all memory locations to 0
  : return := OK
]]
*
****/
class tMm6216Board : public tBoard {
public:
  tMm6216Board::tMm6216Board(int iBoardNum);
  ERROR_CODE  HardInit(void);
  ERROR_CODE  SoftInit(void);
  tChannel    *CreateChannel(int iChannelNum);

protected:
  const unsigned int CuiDefaultMemSize = 0x1000000;

  volatile int32_t *viLocalAddress;
  unsigned int uiMemSizeLongWords;
};

#endif /* INC_mm6216h */
