/* $RCSfile: baseObject.h,v $  */
/* $Header: /home/chara/cvsroot/ople/sys/include/baseObject.h,v 1.1.1.1 1998/06/11 21:36:10 chara Exp $ */

/*
modification history
--------------------
01a,13Jun97,rlj    written
*/

#ifndef INC_baseObjecth
#define INC_baseObjecth

#include "isit.h"
#include <iostream.h>
#include "objectId.h"

//Errors

//Warnings

#define S_baseObject_ALREADY_INITIALIZED    (M_baseObject | 0x1001)
#define S_baseObject_ALREADY_SHUTDOWN       (M_baseObject | 0x1002)

//Info


/****

[[D tBaseObject::tBaseObject (void) ]
[ this is invalid => UNDEFINED
| true => 
    this->ecInitError := OK
    : this->bInit := TRUE
]]

[[D tBaseObject::~tBaseObject (void) ]
[ this is invalid => UNDEFINED
| true => *this := anything
]]

[[D tBaseObject::SetInitError (ERROR_CODE ecErrCode) ]
[ this is invalid => UNDEFINED
| true => this->ecInitError := ecErrCode
]]

[[D tBaseObject::GetInitError (void) ]
[ this is invalid => UNDEFINED
| true => return := this->ecInitError
]]

[[D tBaseObject::IsOk (void) ]
[ this is invalid => UNDEFINED
| Object is malfunctioning => return FALSE
| true => return := TRUE
]]



[[D tBaseObject::IsInit (void) ]
[ this is invalid => UNDEFINED
| true => return := this->bInit
]]

[[D tBaseObject::SetInit (BOOL bInitToUse) ]
[ this is invalid => UNDEFINED
| true => this->bInit := bInitToUse
]]

[[D tBaseObject::Restart (void) ]
[ this is invalid => UNDEFINED
| this->bInit == TRUE =>
    console := console + appropriate warning message
    : return := OK
| true => 
    this->bInit := TRUE
    : return OK 
]]

[[D tBaseObject::Shutdown (void) ]
[ this is invalid => UNDEFINED
| this->bInit == FALSE =>
    console := console + appropriate warning message
    : return := OK
| true => 
    this->bInit := FALSE
    : return OK 
]]

[[D tBaseObject::operator_extractor (ostream& Stream, 
                                     const tBaseObject& BaseObject) ]
[ invalid_pointer (this) ||
  invalid_reference (Stream) ||
  invalid_reference (BaseObject) => UNDEFINED
| true =>
    Stream := Stream << appropriate text and BaseObject state values
    : return := Stream << appropriate text and BaseObject state values
]]

******/

class tBaseObject : public tObjectId {
  public:
    tBaseObject (); // old usage
    tBaseObject (const char* sSubName, const tObjectId* pParentId);
    virtual ~tBaseObject ();
    ERROR_CODE GetInitError () const;
    BOOL IsInit () const;
    virtual BOOL IsOk () const;
    virtual ERROR_CODE Restart ();
    virtual ERROR_CODE Shutdown ();
    friend ostream &operator<< (ostream& stream,const tBaseObject &BaseObject);
    
  protected:
    void SetInitError (ERROR_CODE ecErrCode); 
    void SetInit (BOOL bInitToUse);

  private:
    ERROR_CODE ecInitError;
    BOOL       bInit;
};

#endif
