/* $RCSfile: dither.h,v $ - Generic Dither Controller */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/include/dither.h,v 1.1.1.1 1998/06/11 21:36:11 chara Exp $
*/
/* Beth McKenney - Jet Propulsion Laboratory */
 
/*
modification history
--------------------
01a,eamck,07May97    broken off from dlDither.h 
*/
 
/*
DESCRIPTION

*/

#ifndef INC_ditherh
#define INC_ditherh


/******************************************************************
*
* double tDither::DoDither(TIME tCurrTime, double dLaserReading)
*    Called by servo that wants to remove dither from sensor reading
*
* SPEC:
*
   [[D tDither::DoDither(in:   this,
                               tCurrTime,
                               dLaserReading,
                               *this.bDithering;
                         out:  return; )]

   [ this invalid => UNDEFINED
   | currently doing a dither calibration =>
        *this := *this updated appropriately with dLaserReading and tCurrTime
   | true =>
        return := dither correction value appropriate to time tCurrTime
                  and current dithering state
   ]]
 
* RETURNS:
*    appropriate dither value for time tCurrTime
*
*/


class tDither {       
   public:
      virtual double DoDither(TIME tCurrTime, double dLaserReading) = 0;
};


#endif  /* INC_ditherh */

