/* $RCSfile: dlDataStore.h,v $*/
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/dl/dlDataStore.h,v 1.2 1998/09/23 23:57:30 phil Exp $
*/

#ifndef INC_dlDataStoreh
#define INC_dlDataStoreh

#include "dataStore.h"
#include "dlTypes.h"

/******

[[D tDlDataStore::tDlDataStore (int iDataDumpPriorityToUse, int iMaxItemsToUse, 
                const tTypeTag& TypeTagToUse, tDlStatus& StatusToUse) ]
[ invalid_pointer (this) ||
  invalid_reference (TypeTagToUse) ||
  invalid_reference (StatusToUse) => UNDEFINED
| iDataDumpPriority < priority st. Time needed to empty this->DataBag < 
  iMaxItemsToUse / (average rate at which tDataStore::StoreData 
  will be called) => anything
| true =>
     this->DataBag := EMPTY
    : this->iMaxItems := iMaxItemsToUse
    : this->iDataDumpPriority := iDataDumpPriorityToUse
    : this->DataTag := TypeTagToUse
    : this->Status := reference to StatusToUse
]]

[[D tDlDataStore::~tDlDataStore (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tDlDataStore::StoreData (tDataType& DataIn) ]
[ invalid_pointer (this) ||
  invalid_pointer (::pThisRteG) ||
  ::DataStream (::pThisRteG).bInit == FALSE => UNDEFINED
| NumberOfItems (this->DataBag)== this->iMaxItems - 1 &&
  ::DataStream (::pThisRteg).bFull == TRUE at some point during the dump => 
    this->DataBag := EMPTY
    : ::DataStream (::pThisRteG) := ::DataStream (::pThisRteG) + anything
    : this->Status := anything
    : console := console + appropriate error messages
| NumberOfItems (this->DataBag)== this->iMaxItems - 1 =>
    this->DataBag := EMPTY
    : ::DataStream (::pThisRteG) := ::DataStream (::pThisRteG) + 
      this->DataBag at priority this->iDataDumpPriority
    : this->Status.dJitter := Jitter (this->DataBag);
    : this->Status.dHighPassJitter := JitterHP (this->DataBag);
| true => this->DataBag := this->DataBag + (this->DataTag + DataIn)
]]

[[D tDlDataStore::CalcDlJitter (void) ]
[ invalid_pointer (this) => UNDEFINED 
| true => return := appropriate jitter calculation based on this->DataBag
]]


[[D tDlDataStore::CalcDlHpJitter (void) ]
[ invalid_pointer (this) => UNDEFINED 
| true => return := appropriate high pass cd cldjitter calculation based on this->DataBag
]]

*************/


class tDlDataStore : public tDataStore <tDlData> {
  public:
    tDlDataStore (int iDataDumpTaskPriority, int iBufferSize,int iHpBlockSizeToUse, 
                  const tTypeTag& TypeTagToUse, tDlStatus& StatusToUse);
    ~tDlDataStore ();
    void SetSuspendData(BOOL bNewSuspendData)
                  { this->bSuspendData = bNewSuspendData; }

  protected:
     void DumpToDataStream ();
     double CalcDlJitter ();
     double CalcDlHpJitter ();
     
     tDlStatus& Status;
     int iHpBlockSize;

  private:
     BOOL bSuspendData;
};

#endif INC_dlDataStoreh
