/* $RCSfile: servoDefaultsP.h,v $  -- structure header for pidLibF.c */
/*
$Header: /home/chara/cvsroot/ople/sys/include/dl/servoDefaultsP.h,v 1.1.1.1 1998/06/11 21:36:16 chara Exp $
*/
/* Brad Hines - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a,22Oct96,beh   Servo parameter default values
*/

/*
DESCRIPTION
Contains values for the servo parameters for the increment 1
delay line.
*/

#include "servoDefaults.h"



#ifndef INC_servoDefaultsPh
#define INC_servoDefaultsPh

#define SERVO_RATE 2500

#define PZT_RANGE  30.0 /* physical range of pzt, amp, and D/A (um) */
                                             /* PI 840.20 + Burleigh 350 */
#define PZT_RATE   0.0019  /* rate constant in fract_of_full_scale/s/lsb */
                                             /* JPL card: 8MHz/65k^2 */
#define PZT_GAIN   (-50.0)                  /* dimensionless gain */

//#define PZT_LIMIT       1.0           /* limit as a fraction of full scale */
//#define PZT_TAUP        0.25            /* lag pole */
//#define PZT_TAUZ        0.0025          /* lag zero */


#define PZT_READBACK_TO_LASER_COUNTS (1.0/16.16)

#define VC_RANGE    (-4.82 * 0.25 * 10.0)  /* VC1: lbs/A * A/V * maxV */
                                           /* measured lbs/A for large VC */



//#define VC_LIMIT    0.5              /* limit as a fraction of full scale */



#define DEFAULT_PZT_GAIN     (PZT_GAIN)

#endif  /* INC_servoDefaultsPh */
