/* $RCSfile: dlCommands.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/dlCommands.h,v 1.2 1998/09/23 23:57:20 phil Exp $
*/
/* Brad Hines - Jet Propulsion Laboratory */
 
/*
modification history
--------------------
01a,beh,05Nov96    extracted from isit.h
*/
 
/*
DESCRIPTION
ISIT DL command-related defines
*/

#ifndef INC_dlCommandsh
#define INC_dlCommandsh

#include "dlTypes.h"
#include "gsu/gsuDlTypes.h"


   

class tDlSetActiveTargetCmd: public tIsitCmd { 
public:
   TARGET_TYPE		ttWhichTarget;
   BOOL			bTargetSetActive;
};

class tDlDitherOnCmd : public tIsitCmd 
{ 
 public:
   BOOL bTurnDitherOn;
};

class tDlDataRecordCmd : public tIsitCmd
{
 public:
   BOOL bSuspendData;
 };

class tDlClearLaserCounterCmd : public tIsitCmd { };

class tDlOffCmd : public tIsitCmd { };

class tDlFrontCmd : public tIsitCmd { };

class tDlBackCmd : public tIsitCmd { };

class tDlTrackCmd : public tIsitCmd { };

class tDlUser1Cmd : public tIsitCmd { };

class tDlUser2Cmd : public tIsitCmd { };

class tDlHomeCheckCmd : public tIsitCmd { };

class tDlHomeSetCmd : public tIsitCmd { };

class tDlDitherCalibrateCmd : public tIsitCmd { };

class tDlDitherCheckCmd : public tIsitCmd { };

class tDlPingCmd : public tIsitCmd { };

class tDlSetModulationCmd : public tIsitCmd {
public:
  MOD_TYPE mtModulationType;
  double   dFrequency;
  double   dAmplitude;
  double   dMeanVal;
  TIME     tSyncTime;

};
 
class tDlSetDitherCmd : public tIsitCmd {
public:
   double               dAmplitude;
   double               dPeriod;
};
 
/***
class tDlSetServoParametersCmd : public tIsitCmd {
public:
  TRACK_SERVO_PARAMS ServoParams;
};
****/ 

class tGsuDlSetServoParametersCmd : public tIsitCmd {
  public:
    tGuiGsuDlServoParameters ServoParams;
};


#endif  /* INC_dlCommandsh */

