/* $RCSfile: dlErrors.h,v $ */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/include/dlErrors.h,v 1.2 1998/09/23 23:57:21 phil Exp $*/
/* Brad Hines - Jet Propulsion Laboratory */
 
/*
modification history
--------------------
01a,beh,4Nov96    written
*/
 
/*
DESCRIPTION
This file contains error code definitions for the delay line.
*/

#ifndef INC_dlErrorsh
#define INC_dlErrorsh

#define S_dlgizmo_GIZMO_INFO_NOT_DL                          (M_dlgizmo |  0x1)
#define S_dlgizmo_INVALID_NUMBER_OF_SERVO_MODES              (M_dlgizmo |  0x2)
#define S_dlgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS         (M_dlgizmo |  0x3)
#define S_dlgizmo_UNRECOGNIZED_COMMAND                       (M_dlgizmo |  0x4)
#define S_dlgizmo_DATA_RECORDING_OFF                         (M_dlgizmo |  0x5)
#define S_dlgizmo_DATA_RECORDING_ON                          (M_dlgizmo |  0x6)


#define S_dlgizmo_DELAY_LINE_ALIVE                           (M_dlgizmo |  0x1001)




#define S_dlLimits_NULL_SCHEDULER_POINTER                    (M_dlLimits | 0x1)
#define S_dlLimits_SCHEDULER_ADJUSTED_LIMITS_TASK_PERIOD     (M_dlLimits | 0x2)
#define S_dlLimits_NULL_GIZMO_POINTER                        (M_dlLimits | 0x3)
#define S_dlLimits_DELAY_LINE_REACHED_LIMIT                  (M_dlLimits | 0x4)

#define S_tDlLimits_ENTERING_CONSTRUCTOR_BODY                (M_dlLimits | 0x1001)
#define S_tDlLimits_EXITING_CONSTRUCTOR                      (M_dlLimits | 0x1002)
#define S_tDlLimits_ENTERING_INITIALIZE                      (M_dlLimits | 0x1003)
#define S_tDlLimits_ADDING_READ_LIMITS_TASK                  (M_dlLimits | 0x1004)
#define S_tDlLimits_INITIALIZE_RETURNED_FROM_ADD_TASK        (M_dlLimits | 0x1005)
#define S_tDlLimits_INITIALIZE_DONE                          (M_dlLimits | 0x1006)
#define S_tDlLimits_ENTERING_UPDATE_CACHED_LIMIT_VALUES      (M_dlLimits | 0x1007)
#define S_tDlLimits_EXITING_UPDATE_CACHED_LIMIT_VALUES       (M_dlLimits | 0x1008)

#define S_dlCommandProcessor_DELAY_LINE_NUMBER_OUT_OF_RANGE    (M_dlCommandProcessor | 0x1)
#define S_dlCommandProcessor_INTERNAL_ERROR__CORRECT_DELAY_LINE_NUMBER_NOT_HANDLED    (M_dlCommandProcessor | 0x2)
#define S_dlCommandProcessor_UNRECOGNIZED_COMMAND              (M_dlCommandProcessor | 0x3)
#define S_dlCommandProcessor_COULD_NOT_CREATE_COMMAND_ENGINE   (M_dlCommandProcessor | 0x4)

#define S_offCommand_OFF_START                                 (M_offCommand | 0x1)
#define S_offCommand_OFF_DONE                                  (M_offCommand | 0x2)

#define S_frontCommand_FRONT_START                             (M_frontCommand | 0x1)
#define S_frontCommand_FRONT_DONE                              (M_frontCommand | 0x2)
#define S_frontCommand_FRONT_ABORTED                           (M_frontCommand | 0x3)

#define S_backCommand_BACK_START                               (M_backCommand | 0x1)
#define S_backCommand_BACK_DONE                                (M_backCommand | 0x2)
#define S_backCommand_BACK_ABORTED                             (M_backCommand | 0x3)

#define S_trackCommand_TRACK_START                             (M_trackCommand | 0x1)
#define S_trackCommand_TRACK_IN_PROGRESS                       (M_trackCommand | 0x2)
#define S_trackCommand_TRACK_ABORTED                           (M_trackCommand | 0x3)

#define S_clearLaserCounterCommand_CLEAR_LASER_COUNTER_START    (M_clearLaserCounterCommand | 0x1)
#define S_clearLaserCounterCommand_CLEAR_LASER_COUNTER_COMPLETE (M_clearLaserCounterCommand | 0x2)

#define S_setModulationCommand_SET_MODULATION_COMPLETE                (M_setModulationCommand | 0x2)

#define S_setServoParametersCommand_SET_SERVO_PARAMETERS_COMPLETE     (M_setServoParametersCommand | 0x2)

#define S_dlServo_INVALID_SERVO_MODE                            (M_dlServo | 0x1)

#define S_dl_NULL_HARDWARE_POINTER                              (M_dl | 0x1)

#define S_homesetCommand_HOMESET_START			(M_homesetCommand | 0x1)
#define S_homesetCommand_HOMESET_BACK_START		(M_homesetCommand | 0x2)
#define S_homesetCommand_HOMESET_FRONT_START		(M_homesetCommand | 0x3)
#define S_homesetCommand_HOMESET_CREEPBACK_START	(M_homesetCommand | 0x4)
#define S_homesetCommand_HOMESET_CREEPFRONT_START	(M_homesetCommand | 0x5)
#define S_homesetCommand_HOMESET_DONE			(M_homesetCommand | 0x6)
#define S_homesetCommand_HOMESET_ABORTED		(M_homesetCommand | 0x7)
#define S_homesetCommand_CANNOT_FIND_HOME_SENSOR 	(M_homesetCommand | 0x8)

#define S_homecheckCommand_HOMECHECK_START		(M_homecheckCommand | 0x1)
#define S_homecheckCommand_HOMECHECK_FRONT_START	(M_homecheckCommand | 0x2)
#define S_homecheckCommand_HOMECHECK_BACK_START		(M_homecheckCommand | 0x3)
#define S_homecheckCommand_HOMECHECK_CREEPFRONT_START	(M_homecheckCommand | 0x4)
#define S_homecheckCommand_HOMECHECK_CREEPBACK_START	(M_homecheckCommand | 0x5)
#define S_homecheckCommand_HOMECHECK_DONE		(M_homecheckCommand | 0x6)
#define S_homecheckCommand_HOMECHECK_ABORTED		(M_homecheckCommand | 0x7)
#define S_homecheckCommand_CANNOT_FIND_HOME_SENSOR 	(M_homecheckCommand | 0x8)

#define S_user1Command_USER1_START			(M_user1Command | 0x1)
#define S_user1Command_USER1_IN_PROGRESS		(M_user1Command | 0x2)
#define S_user1Command_USER1_ABORTED			(M_user1Command | 0x3)

#define S_user2Command_USER2_START			(M_user2Command | 0x1)
#define S_user2Command_USER2_IN_PROGRESS		(M_user2Command | 0x2)
#define S_user2Command_USER2_ABORTED			(M_user2Command | 0x3)

#define S_ditherCalibCommand_CALIB_DITHER_START		(M_ditherCalibCommand | 0x1)
#define S_ditherCalibCommand_CALIB_DITHER_IN_PROGRESS	(M_ditherCalibCommand | 0x2)
#define S_ditherCalibCommand_CALIB_DITHER_DONE		(M_ditherCalibCommand | 0x3)
#define S_ditherCalibCommand_CALIB_DITHER_ABORTED	(M_ditherCalibCommand | 0x4)

#define S_ditherCheckCommand_CHECK_DITHER_START		(M_ditherCheckCommand | 0x1)
#define S_ditherCheckCommand_CHECK_DITHER_IN_PROGRESS	(M_ditherCheckCommand | 0x2)
#define S_ditherCheckCommand_CHECK_DITHER_DONE		(M_ditherCheckCommand | 0x3)
#define S_ditherCheckCommand_CHECK_DITHER_ABORTED	(M_ditherCheckCommand | 0x4)

#define S_setActiveTargetCommand_SELECT_TARGET_COMPLETE	(M_setActiveTargetCommand | 0x2)

#define S_dlPingCommand_DELAY_LINE_ALIVE		(M_dlPingCommand | 0x1)

#define S_dlSetDitheringCommand_TURN_DITHER_ON_DONE	(M_dlSetDitheringCommand | 0x2)
#define S_dlSetDitheringCommand_TURN_DITHER_OFF_DONE	(M_dlSetDitheringCommand | 0x4)
#define S_dlSetDitheringCommand_SET_DITHER_COMPLETE	(M_dlSetDitheringCommand | 0x5)


#define S_dlDither_INVALID_BUFSIZE                         (M_dlDither | 0x0)
#define S_dlDither_INVALID_DITHER_PERIOD                   (M_dlDither | 0x1)
#define S_dlDither_INVALID_OFFSET                          (M_dlDither | 0x2)
#define S_dlDither_DITHER_MEASUREMENT_ERROR                (M_dlDither | 0x3)
#define S_dlDither_CANNOT_DO_DIAGS_WHILE_MEASURING         (M_dlDither | 0x4)
#define S_dlDither_NULL_CHANNEL_POINTER                    (M_dlDither | 0x5)
#define S_dlDither_NULL_BANK_POINTER                       (M_dlDither | 0x6)
#define S_dlDither_INVALID_SAMPLE_FREQ                     (M_dlDither | 0x7)
#define S_dlDither_NULL_GIZMO_POINTER                      (M_dlDither | 0x8)
#define S_dlDither_INVALID_NUMWAVES                        (M_dlDither | 0x9)
#define S_dlDither_INVALID_AMPL_FACTOR                     (M_dlDither | 0xa)
#define S_dlDither_INVALID_DITHER_SAMPLE_RATE              (M_dlDither | 0xb)

#define S_dlDither_ENTERING_DL_DITHER_INIT                 (M_dlDither | 0x1001)
#define S_dlDither_SEM_CREATED                             (M_dlDither | 0x1002)
#define S_dlDither_INITIAL_WAVEFORM_SET                    (M_dlDither | 0x1003)
#define S_dlDither_INITIAL_WAVEFORM_LOADED                 (M_dlDither | 0x1004)
#define S_dlDither_ENTERING_MEASURE_DITHER                 (M_dlDither | 0x1005)
#define S_dlDither_LOADED_WAVEFORM_NOW_WAIT                (M_dlDither | 0x1006)
#define S_dlDither_MEASURED_DITHER_WAVE_SUCCESSFULLY       (M_dlDither | 0x1007)
#define S_dlDither_LEAVING_MEASURE_DITHER                  (M_dlDither | 0x1008)
#define S_dlDither_ENTERING_CALIBRATE_DITHER               (M_dlDither | 0x1009)
#define S_dlDither_COMPLETED_FIRST_MEASURE_DITHER          (M_dlDither | 0x100a)
#define S_dlDither_COMPLETED_ANOTHER_MEASURE_DITHER        (M_dlDither | 0x100b)
#define S_dlDither_SUCCESSFULLY_COMPLETED_CALIBRATE_DITHER (M_dlDither | 0x100c)
#define S_dlDither_ENTERING_CHECK_DITHER                   (M_dlDither | 0x100d)
#define S_dlDither_SUCCESSFULLY_COMPLETED_CHECK_DITHER     (M_dlDither | 0x100e)
#define S_dlDither_DITHER_CALIBRATE_FAILED                 (M_dlDither | 0x100f)

#define S_relayer_INDEX_OUT_OF_RANGE                   (M_relayer | 0x1)
#define S_relayer_DATA_READ_INCOMPLETE                 (M_relayer | 0x2)

#define S_dlRelayer_UNKNOWN_DL_TYPE                    (M_dlRelayer | 0x1)
#define S_dlRelayer_CANT_ALLOCATE_STATUS_STREAM	       (M_dlRelayer | 0x0002)

#define S_dlRelayer_ENTERING_DL_DATA_RELAYER_INIT      (M_dlRelayer | 0x1001)
#define S_dlRelayer_DL_DATA_STREAM_INIT_SUCCESSFUL     (M_dlRelayer | 0x1002)
#define S_dlRelayer_DL_DATA_RELAYER_INIT_SUCCESSFUL    (M_dlRelayer | 0x1003)
#define S_dlRelayer_ENTERING_DL_STATUS_RELAYER_INIT    (M_dlRelayer | 0x1004)
#define S_dlRelayer_DL_STATUS_STREAM_INIT_SUCCESSFUL   (M_dlRelayer | 0x1005)
#define S_dlRelayer_DL_STATUS_RELAYER_INIT_SUCCESSFUL  (M_dlRelayer | 0x1006)
#define S_dlRelayer_IN_DL_DATA_RELAY                   (M_dlRelayer | 0x1007)
#define S_dlRelayer_IN_DL_STATUS_RELAY                 (M_dlRelayer | 0x1008)

#define S_tPidDouble_INIT_USING_POLES_AND_ZEROS_START  (M_tPidDouble | 0x1001)
#define S_tPidDouble_INIT_USING_POLES_AND_ZEROS_EXIT   (M_tPidDouble | 0x1002)
#define S_tPidDouble_INIT_USING_PIDS_START             (M_tPidDouble | 0x1003)
#define S_tPidDouble_INIT_USING_PIDS_EXIT              (M_tPidDouble | 0x1004)
#define S_tPidDouble_INIT_PID_RESET_START              (M_tPidDouble | 0x1005)
#define S_tPidDouble_INIT_PID_RESET_EXIT               (M_tPidDouble | 0x1006)

#define S_dlController_CONTROLLER_DATA_INITIALIZE_START     (M_dlController | 0x1001)
#define S_dlController_CONTROLLER_DATA_INITIALIZE_EXIT      (M_dlController | 0x1002)
#define S_dlController_DL_CONTROLLER_CONSTRUCTOR            (M_dlController | 0x1003)
#define S_dlController_DL_FAST_CTRLR_CONSTRUCTOR            (M_dlController | 0x1004)
#define S_dlController_DL_FAST_SLEW_CTRLR_CONSTRUCTOR       (M_dlController | 0x1005)
#define S_dlController_DL_MED_SLEW_CTRLR_CONSTRUCTOR        (M_dlController | 0x1006)
#define S_dlController_DL_SLOW_CTRLR_CONSTRUCTOR            (M_dlController | 0x1007)
#define S_dlController_DL_SLOW_SLEW_CTRLR_CONSTRUCTOR       (M_dlController | 0x1008)
#define S_dlController_DL_MED_SLEW_CTRLR_CALCULATE_START    (M_dlController | 0x1009)
#define S_dlController_DL_MED_SLEW_CTRLR_CALCULATE_EXIT     (M_dlController | 0x100A)
#define S_dlController_DL_SLOW_SLEW_CTRLR_CALCULATE_START   (M_dlController | 0x100B)
#define S_dlController_DL_SLOW_SLEW_CTRLR_CALCULATE_EXIT    (M_dlController | 0x100C)
#define S_dlController_GET_FAST_INPUT_SET                   (M_dlController | 0x100d)
#define S_dlController_GET_FAST_OUTPUT_SET                  (M_dlController | 0x100e)
#define S_dlController_GET_FAST_TARGET_SET                  (M_dlController | 0x100f)
#define S_dlController_UPDATE_COMPENSATOR_COEFFS_START      (M_dlController | 0x1010)
#define S_dlController_UPDATE_COMPENSATOR_COEFFS_EXIT       (M_dlController | 0x1011)

#define S_dlOffController_SLOW_OFF_CONTROLLER_CONSTRUCTOR      (M_dlOffController | 0x1001)
#define S_dlOffController_OFF_CONTROLLER_SET_CONSTRUCTOR_START (M_dlOffController | 0x1002)
#define S_dlOffController_OFF_CONTROLLER_SET_CONSTRUCTOR_EXIT  (M_dlOffController | 0x1003)

#define S_dlTrackController_FAST_TRK_LIN_CTRLR_CONSTRUCTOR     (M_dlTrackController | 0x1001)
#define S_dlTrackController_MED_TRK_LIN_CTRLR_CONSTRUCTOR      (M_dlTrackController | 0x1002)
#define S_dlTrackController_SLOW_TRK_SLEW_CTRLR_CONSTRUCTOR    (M_dlTrackController | 0x1003)
#define S_dlTrackController_SLOW_TRK_LIN_CTRLR_CONSTRUCTOR     (M_dlTrackController | 0x1004)
#define S_dlTrackController_TRK_CTRLR_SET_CONSTRUCTOR_START    (M_dlTrackController | 0x1005)
#define S_dlTrackController_TRK_CTRLR_SET_CONSTRUCTOR_EXIT     (M_dlTrackController | 0x1006)

#define S_dlFrontBackController_FB_SLOW_CTRLR_CONSTRUCTOR      (M_dlFrontBackController | 0x1001)
#define S_dlFrontBackController_FB_CTRLR_SET_CONSTRUCTOR_START (M_dlFrontBackController | 0x1002)
#define S_dlFrontBackController_FB_CTRLR_SET_CONSTRUCTOR_EXIT  (M_dlFrontBackController | 0x1003)

#define S_dlIoSet_STAB_IO_GROUP_CONSTRUCTOR              (M_dlIoSet | 0x1001)
#define S_dlIoSet_TRK_LIN_IO_GROUP_CONSTRUCTOR           (M_dlIoSet | 0x1002)
#define S_dlIoSet_COMPLETE_IO_SET_CONSTRUCTOR            (M_dlIoSet | 0x1003)

#define S_dlInputSet_FAST_INPUT_SET_CONSTRUCTOR          (M_dlInputSet | 0x1001)
#define S_dlInputSet_MED_TRK_LIN_INPUT_SET_CONSTRUCTOR   (M_dlInputSet | 0x1002)
#define S_dlInputSet_MED_STAB_INPUT_SET_CONSTRUCTOR      (M_dlInputSet | 0x1003)
#define S_dlInputSet_SLOW_INPUT_SET_CONSTRUCTOR          (M_dlInputSet | 0x1004)
#define S_dlInputSet_ENTERING_FAST_INPUT_SET_UPDATE      (M_dlInputSet | 0x1004)

#define S_dlOutputSet_FAST_OUTPUT_SET_CONSTRUCTOR    (M_dlOutputSet | 0x1001)
#define S_dlOutputSet_MED_OUTPUT_SET_CONSTRUCTOR     (M_dlOutputSet | 0x1002)
#define S_dlOutputSet_SLOW_OUTPUT_SET_CONSTRUCTOR    (M_dlOutputSet | 0x1003)

#define S_dlTargetSet_POS_TARG_SRC_CONSTRUCTOR          (M_dlTargetSet | 0x1001)
#define S_dlTargetSet_VEL_TARG_SRC_CONSTRUCTOR          (M_dlTargetSet | 0x1002)
#define S_dlTargetSet_FAST_TARG_SET_CONSTRUCTOR         (M_dlTargetSet | 0x1003)
#define S_dlTargetSet_MED_TRK_LIN_TARG_SET_CONSTRUCTOR  (M_dlTargetSet | 0x1004)
#define S_dlTargetSet_SLOW_TARG_SET_CONSTRUCTOR         (M_dlTargetSet | 0x1005)
#define S_dlTargetSet_MED_STAB_TARG_SET_CONSTRUCTOR     (M_dlTargetSet | 0x1006)

#define S_quicDlController_CONTROLLER_DATA_CONSTRUCTOR_START             (M_quicDlController | 0x1001)
#define S_quicDlController_CONTROLLER_DATA_CONSTRUCTOR_EXIT              (M_quicDlController | 0x1002)
#define S_quicDlController_CTRLR_DATA_SET_SERVO_PARAMS_ENTER             (M_quicDlController | 0x1003)
#define S_quicDlController_CTRLR_DATA_SET_SERVO_PARAMS_EXIT              (M_quicDlController | 0x1004)
#define S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_CONSTRUCTOR_START  (M_quicDlController | 0x1005)
#define S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_CONSTRUCTOR_EXIT   (M_quicDlController | 0x1006)
#define S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_SET_SERVO_PARAMS   (M_quicDlController | 0x1007)

#define S_quicDlFrontController_ENTERING_CONSTRUCTOR_BODY  (M_quicDlFrontController | 0x1001)
#define S_quicDlFrontController_LEAVING_CONSTRUCTOR        (M_quicDlFrontController | 0x1002)


#define S_quicDlTrackController_ENTERING_CONSTRUCTOR_BODY    (M_quicDlTrackController | 0x1001)
#define S_quicDlTrackController_LEAVING_CONSTRUCTOR_BODY     (M_quicDlTrackController | 0x1002)



#endif  /* INC_dlErrorsh */

