 /* $RCSfile: emIoSet.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/em/emIoSet.h,v 1.1.1.1 1998/06/11 21:36:16 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a27Aug97,rlj    written
*/

#include "periodicTargetGen.h"
#include "targetSource.h"

#include "dlActuator.h"


/****
[[D tEmCompleteIoSet::tEmCompleteIoSet (const tEmGizmoInfo& GizmoInfo) ]
[ invalid_pointer (this) ||
  invalid_reference (GizmoInfo) ||
  ::IpcMemoryG.bInit == FALSE => UNDEFINED
| CanAllocateIpcObject (::IpcMemoryG, GizmoInfo.iiDelayLineTargetId) == FALSE => 
    console := console + appropriate error messages
    : *this := anything
| true =>
    this->TargetGenerator.bInit := TRUE
    : this->DelayLineActuator.TargetId := GizmoInfo.iiDelayLineTargetId
    : ::IpcMemoryG.ObjectSet := ::IpcMemoryG.ObjectSet U 
        NewObjectSet (::IpcMemoryG,GizmoInfo.iiDelayLineTargetId) 
]]

[[D tEmCompleteIoSet::~tEmCompleteIoSet (void) ]
[ invalid_pointer (this)  => UNDEFINED
| true => *this := anything
]]

*******************/


class tEmGizmoInfo;

class tEmCompleteIoSet {
  public:
    tEmCompleteIoSet (const tEmGizmoInfo& GizmoInfo);
    ~tEmCompleteIoSet ();
    
    //Sensors
    
    tPeriodicTargetGenerator TargetGenerator;
    
    //Actuators
    
    tDlActuator  DelayLineActuator;
    

};

