/* $RCSfile: emGizmoInfo.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/emGizmoInfo.h,v 1.1.1.1 1998/06/11 21:36:11 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a27Aug97,rlj    written
*/

#ifndef INC_emGizmoInfoh
#define INC_emGizmoInfoh

#include "isit.h"
#include "ipcid.h"
#include "realTimeGizmoInfo.h"


/****
Black Box State Variables

int iRteId
int iGizmoId
tIpcFifoId         iiCommandStreamId 
GIZMO_TYPE         gtGizmoType 
int                iStatusTaskPriority
TIME               tStatusTaskPeriod
TIME               tStatusTaskOffset
int                iCommandTaskPriority
TIME               tCommandTaskPeriod
TIME               tCommandTaskOffset 
int                iNumberOfServoModes
tServoInfo         ServoInfo
int                iDlTargetGizmoId

__________________________
Stimuli

[[D tEmGizmoInfo::tEmGizmoInfo (int iRteIdToUse, int iGizmoIdToUse,
      int iNumberOfServoModesToUse, const tServoInfo ServoInfoToUse,
      int iDlTargetGizmoIdToUse) ]
[ invalid_pointer (this) ||
  invalid_reference (ServoInfo) ||
  IsADelayLineGizmo (iDlTargetGizmoId) == FALSE => UNDEFINED
| true =>
    this->iRteId := iRteIdToUse
    : this->iGizmoId := iGizmoIdToUse
    : this->iiCommandStreamId := appropriate and unique tIpcFifoId
    : this->gtType := GT_EXTERNAL_METROLOGY
    : this->iStatusTaskPriority := CiStatusTaskPriority
    : this->tStatusTaskPeriod := CtStatusTaskPeriod
    : this->tStatusTaskOffset := 0
    : this->iCommandTaskPriority := CiCommandTaskPriority
    : this->tCommandTaskPeriod := CiCommandTaskPeriod
    : this->tCommandTaskOffset := 0   
    : this->iNumberOfServoModes := iNumberOfServoModesToUse
    : this->iDlTargetGizmoId := iDlTargetGizmoIdToUse
]]

[[D tEmGizmoInfo::~tEmGizmoInfo (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tEmGizmoInfo::GetTargetId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return Gizmo (this->iDelayLineTargetGizmoId).EmTargetId
]]

***********/


class tServoInfo;

class tEmGizmoInfo : public tRealtimeGizmoInfo {
  public:
    tEmGizmoInfo(int iRteId, int iGizmoId,int iNumberOfServoModes,
      const tServoInfo& ServoInfo,int iDlTargetGizmoId);
    ~tEmGizmoInfo () {};
    const tIpcDblBufferId& GetTargetId () const;

  protected:
    int iDlGizmoId;
};

#endif INC_emGizmoInfoh

