/* $RCSfile: errLookup.h,v $ -- header include files for lookup text error */
/*
$Header: /home/chara/cvsroot/ople/sys/include/errLookup.h,v 1.1.1.1 1998/06/11 21:36:11 chara Exp $
*/

/* errLookup.h - look up text code for VxWorks error numbers */
/*       sccs info       @(#)errLookup.h	1.1  7/27/93  */
/* Brad Hines - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a,26Jul93,beh       adapted from errLookup.c
*/

/*
DESCRIPTION
When the delay line reports an error to the host, the host can make
use of the statTbl.c produced by "makeStatTbl" to translate VxWorks
error codes into human-readable strings.
*/

#ifndef INC_errLookuph
#define INC_errLookuph

#ifdef __cplusplus
extern "C" {
#endif


/*
*
*
[[D ::errLookup(in: errcode;) ]
[errcode is not in symbol table => 
   return := address of "Unknown Error Code"
| true =>
   return := address of appropriate error string
]]
*
*
*/

char *errLookup(int errcode);

#ifdef __cplusplus
}
#endif


#endif  /* INC_errLookuph */
