/* $RCSfile: errorStream.h,v $  */
/* $Header: /home/chara/cvsroot/ople/sys/include/errorStream.h,v 1.1.1.1 1998/06/11 21:36:11 chara Exp $ */

/*
modification history
--------------------
01a,19Jun97,rlj    written
*/

#ifndef INC_errorStreamh
#define INC_errorStreamh

#include "isit.h"
#include "relayStream.h"

//Errors

//Warnings

//Info

#define S_errorStream_SENDER_CONSTRUCTOR        (M_errorStream | 0x20001)
#define S_errorStream_SENDER_DESTRUCTOR         (M_errorStream | 0x20002)
#define S_errorStream_PUT_EC_START              (M_errorStream | 0x20003)
#define S_errorStream_PUT_EC_COMPLETE           (M_errorStream | 0x20004)
#define S_errorStream_PUT_ECT_START             (M_errorStream | 0x20005)
#define S_errorStream_PUT_ECT_COMPLETE          (M_errorStream | 0x20006)
#define S_errorStream_PUT_NO_WAIT_ECT_START     (M_errorStream | 0x20007)
#define S_errorStream_PUT_NO_WAIT_ECT_COMPLETE  (M_errorStream | 0x20008)
#define S_errorStream_RECEIVER_CONSTRUCTOR      (M_errorStream | 0x20009)
#define S_errorStream_RECEIVER_DESTRUCTOR       (M_errorStream | 0x2000a)


/**********

[[D tErrorStreamSender::tErrorStreamSender  (const tIpcFifoId& iiId) ]
[ invalid_pointer (this) ||
  invalid_reference (iiId) ||
  ::IpcMemoryG.bInit == FALSE => UNDEFINED
| CanAllocateIpcObject (::IpcMemoryG, iiId) == FALSE ||
  Unable to create mutex semaphore =>
    console := console + appropriate messages
    : this->bObjectValid := FALSE
    : this->iiFifoId := anything
    : this->ecInitError := appropriate error code
    : this->bInit := anything
    : this->siPutMutexSemaphore := anything
| true =>
    this->ecInitError := OK
    : this->bInit := TRUE
    : this->bObjectValid := TRUE
    : this->iiFifoId := iiId
    : ::IpcMemoryG.ObjectSet := 
      ::IpcMemoryG.ObjectSet U NewObjectSet (::IpcMemoryG, iiId ) 
    : vxWorks mutex semaphore created with options CiErrorStreamSemaphoreOptions
    : this->siPutMutexSemaphore := new vxWorks mutex semaphore id
]]


[[D tErrorStreamSender::~tErrorStreamSender  (void) ]
[ invalid_pointer (this) => UNDEFINED
| this->bInit == TRUE =>
    console := console + appropriate warning message
    : mutex semaphore this->siPutMutexSemaphore deleted
    : *this := anything
| true =>
    mutex semaphore this->siPutMutexSemaphore deleted
    : *this := anything
]]



[[D tErrorStreamSender::Restart  (void) ]
[ invalid_pointer (this) => UNDEFINED
| this->bInit == TRUE =>
    console := console + appropriate warning message
    : return := OK
| true =>
   this->bInit := TRUE
   : return OK
   
]]

[[D tErrorStreamSender::Shutdown  (void) ]
[ invalid_pointer (this) => UNDEFINED
| this->bInit == FALSE =>
    console := console + appropriate warning message
    : return := OK
| true =>
   this->bInit := FALSE
   : return OK   
]]

[[D tErrorStreamSender::Put_ec (ERROR_CODE ecErrCode) ]
[ invalid_pointer (this) || 
  invalid_pointer (::pThisRteG) ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG.ObjectSet, this->iiFifoId) == FALSE ||
  simultaneous put or flush on GetObject (::IpcMemoryG, 
    this->iiFifoId) => UNDEFINED
| this->bInit == FALSE ||
  invalid_semaphore (this->siPutMutexSemaphore) ||
  semaphore_time_out (this->siPutMutexSemaphore,RELAY_STREAM_SEND_MAX_WAIT) => 
    console := console + appropriate error message
    : return := appropriate error code
| GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue.Length + CiErrorTag.szSize +
  sizeof (CiErrorTag) > GetObject (::IpcMemoryG, this->iiFifoId)->iFifoDepth => 
    return := S_ipc_FIFO_FULL
| true => 
    GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue :=
      GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue with CttErrorTag and ERROR_INFO (ecErrCode,
      ::pThisRteG.tSchedTime, ::pThisRteG->iWhichCpu, and::pThisRteG->iWhichRte) appended to back
    : return := OK 
]]


[[D tErrorStreamSender::Put_ect (ERROR_CODE ecErrCode, TIME tErrTime) ]
[ invalid_pointer (this) || 
  invalid_pointer (::pThisRteG) ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG.ObjectSet, this->iiFifoId) == FALSE ||
  simultaneous put or flush on GetObject (::IpcMemoryG, 
    this->iiFifoId) => UNDEFINED
| this->bInit == FALSE ||
  invalid_semaphore (this->siPutMutexSemaphore) ||
  semaphore_time_out (this->siPutMutexSemaphore,RELAY_STREAM_SEND_MAX_WAIT) => 
    console := console + appropriate error message
    : return := appropriate error code
| GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue.Length + CiErrorTag.szSize +
  sizeof (TypeTagIn) > GetObject (::IpcMemoryG, this->iiFifoId)->iFifoDepth => 
    return := S_ipc_FIFO_FULL
| true => 
    GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue :=
      GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue with TypeTagIn and ERROR_INFO (ecErrCode,
      tErrTime, ::pThisRteG->iWhichCpu, and ::pThisRteG->iWhichRte) appended to back
    : return := OK 
]]



[[D tErrorStreamSender::PutNoWait_ect (ERROR_CODE ecErrCode, TIME tErrTime) ]
[ invalid_pointer (this) || 
  invalid_pointer (::pThisRteG) ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG.ObjectSet, this->iiFifoId) == FALSE ||
  simultaneous put or flush on GetObject (::IpcMemoryG, 
    this->iiFifoId) => UNDEFINED
| this->bInit == FALSE ||
  invalid_semaphore (this->siPutMutexSemaphore) ||
  semaphore_time_out (this->siPutMutexSemaphore,NO_WAIT) => 
    console := console + appropriate error message
    : return := appropriate error code
| GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue.Length + CiErrorTag.szSize +
  sizeof (TypeTagIn) > GetObject (::IpcMemoryG, this->iiFifoId)->iFifoDepth => 
    return := S_ipc_FIFO_FULL
| true => 
    GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue :=
      GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue with TypeTagIn and ERROR_INFO (ecErrCode,
      tErrTime, ::pThisRteG->iWhichCpu, and ::pThisRteG->iWhichRte) appended to back
    : return := OK 
]]

[[D tErrorStreamReceiver::tErrorStreamReceiver  (const tIpcFifoId& iiId) ]
[ invalid_pointer (this) ||
  invalid_reference (iiId) ||
  ::IpcMemoryG.bInit == FALSE => UNDEFINED
| CanAllocateIpcObject (::IpcMemoryG, iiId) == FALSE =>
    console := console + appropriate messages
    : this->bObjectValid := FALSE
    : this->iiFifoId := anything
    : this->ecInitError := appropriate error code
    : this->bInit := anything
| true =>
    this->ecInitError := OK
    : this->bInit := TRUE
    : this->bObjectValid := TRUE
    : this->iiFifoId := iiId
    : ::IpcMemoryG.ObjectSet := 
      ::IpcMemoryG.ObjectSet U NewObjectSet (::IpcMemoryG, iiId ) 
]]



[[D tErrorStreamReceiver::~tErrorStreamReceiver  (void) ]
[ this is invalid => UNDEFINED
| true => *this:=anything
]]

**********/

class tIpcFifoId;

extern const tTypeTag CttErrorTag;

class tErrorStreamSender : public tRelayStreamSender {
  public:
    tErrorStreamSender (const tIpcFifoId &iiId);
    virtual ~tErrorStreamSender ();
    ERROR_CODE Put (ERROR_CODE ecErrCode );
    ERROR_CODE Put (ERROR_CODE ecErrCode, TIME tErrTime );
    ERROR_CODE PutNoWait (ERROR_CODE ecErrCode, TIME tErrTime );      
    
};

class tErrorStreamReceiver : public tRelayStreamReceiver {
  public:
    tErrorStreamReceiver (const tIpcFifoId &iiId);
    virtual ~tErrorStreamReceiver ();
};

    

#endif INC_errorStreamh
