/* $RCSfile*/
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/ft/ftCommandEngine.h,v 1.1.1.1 1998/06/11 21:36:16 chara Exp $
*/

/* Derek Slye - Jet Propulsion Laboratory */



#ifndef INC_ftCommandEngineh
#define INC_ftCommandEngineh

#include "isit.h"
#include "mutex.h"

/****

[[D tFtCommandEngine::tFtCommandEngine_t (tFtGizmo& GizmoToUse) ]
[ invalid_pointer (this) ||
  invalid_reference (GizmoToUse) => UNDEFINED
| true => this->Gizmo := GizmoToUse
]]

[[D tFtCommandEngine::tFtCommandEngine_tts (tMutex& Mutex, tFtGizmo& GizmoToUse,
                                        char *sTaskNameToUse) ]
[ invalid_pointer (this) ||
  invalid_reference (Mutex)  ||
  invalid_reference (GizmoToUse)  ||
  invalid_string (sTaskNameToUse) => UNDEFINED
| true => 
    this->Gizmo := GizmoToUse
    : Mutex stuff occurs
]]


[[D tFtOffCommandEngine::tFtOffCommandEngine (tMutex& Mutex, tFtGizmo& GizmoToUse) ]
[ invalid_pointer (this) ||
  invalid_reference (Mutex)  ||
  invalid_reference (GizmoToUse) => UNDEFINED
| true => 
    this->Gizmo := GizmoToUse
    : Mutex stuff occurs
]]

[[D tFtOffCommandEngine::ExecuteMethod (void) ]
[ invalid_pointer (this) ||
  invalid_reference (GizmoToUse) => UNDEFINED
| true => stuff
]]

[[D tFtTrackCommandEngine::tFtTrackCommandEngine (tMutex& Mutex, tFtGizmo& GizmoToUse) ]
[ invalid_pointer (this) ||
  invalid_reference (Mutex)  ||
  invalid_reference (GizmoToUse) => UNDEFINED
| true => 
    this->Gizmo := GizmoToUse
    : Mutex stuff occurs
]]

[[D tFtTrackCommandEngine::ExecuteMethod (void) ]
[ invalid_pointer (this) ||
  invalid_reference (GizmoToUse) => UNDEFINED
| true => stuff 
]]

[[D tFtTrackCommandEngine::AbortMethod (void) ]
[ invalid_pointer (this) ||
  invalid_reference (GizmoToUse) => UNDEFINED
| true => stuff 
]]

****/

class tFtGizmo;

class tFtCommandEngine : public tMutexUser {
  public:
    tFtCommandEngine (tFtGizmo& GizmoToUse);
    tFtCommandEngine (tMutex& Mutex, tFtGizmo& GizmoToUse,
                      char *sTaskNameToUse);
  protected:
    tFtGizmo& Gizmo;
};                 
                    
class tFtOffCommandEngine : public tFtCommandEngine {
  public:
    tFtOffCommandEngine (tMutex& Mutex, tFtGizmo& Gizmo);
  protected:
    virtual ERROR_CODE ExecuteMethod ();

};


class tFtTrackCommandEngine : public tFtCommandEngine {
  public:
    tFtTrackCommandEngine (tMutex& Mutex, tFtGizmo& Gizmo);
  protected:
    virtual ERROR_CODE ExecuteMethod ();
    virtual ERROR_CODE AbortMethod ();
};

class tFtGetImageCommandEngine : public tFtCommandEngine {
  public:
  	tFtGetImageCommandEngine (tMutex& Mutex, tFtGizmo& Gizmo);
  protected:
  	virtual ERROR_CODE ExecuteMethod ();
};

#endif INC_ftCommandEngineh



