/* $RCSfile: ftControllerSet.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/ft/ftControllerSet.h,v 1.1.1.1 1998/06/11 21:36:16 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a7Nov97,rlj    written
*/

#ifndef ftControllerSeth
#define ftControllerSeth

#include "isit.h"
#include "ftTypes.h"
#include "ft/ftController.h"
#include "ft/ftFastController.h"
#include "ft/ftMediumController.h"
#include "ft/ftSlowController.h"
#include "ft/ftImagingController.h"
#include "ft/ftUpdateMode.h"

/****
[[D tFtCompleteControllerSet::tFtCompleteControllerSet (CompleteIoSet,
          GizmoInfo) ]
[ invalid_pointer (this) ||
  invalid_reference (CompleteIoSet) ||
  invalid_reference (GizmoInfo) => UNDEFINED
| true => 
    this->ControllerParameters := GizmoInfo.ServoParameters.ControllerParameters
    : this->Thresholds := GizmoInfo.ServoParameters.Thresholds

    : this->FastOff.ApdSensor := reference to CompleteIoSet.ApdSensor
    : this->FastOff.Fringe := reference to CompleteIoSet.Fringe

    : this->FastTrack.ApdSensor := reference to CompleteIoSet.ApdSensor
    : this->FastTrack.Fringe := reference to CompleteIoSet.Fringe

    : this->MediumOff.ControllerParameters := reference to this->ControllerParametersToUse
    : this->MediumOff.DataStore := reference to DataStoreToUse
    : this->MediumOff.Fringe := reference to CompleteIoSet.Fringe
    : this->MediumOff.ClosedLoopDl :=  reference to CompleteIoSet.ClosedLoopDl
    : this->MediumOff.dPhaseTarget :=  reference to CompleteIoSet.dPhaseTarget
    : this->MediumOff.dManualTarget := reference to CompleteIoSet.dManualTarget
    : this->MediumOff.dLockTarget := reference to CompleteIoSet.dLockTarget
    : this->MediumOff.dFringeCenterTarget := reference to CompleteIoSet.dFringeCenterTarget
    : this->MediumOff.SearchTarget := reference to CompleteIoSet.SearchTarget
    : this->MediumOff.WobbleTarget := reference to CompleteIoSet.WobbleTarget

    : this->MediumTrackSearch.ControllerParameters := reference to this->ControllerParametersToUse
    : this->MediumTrackSearch.DataStore := reference to DataStoreToUse
    : this->MediumTrackSearch.Fringe := reference to CompleteIoSet.Fringe
    : this->MediumTrackSearch.ClosedLoopDl :=  reference to CompleteIoSet.ClosedLoopDl
    : this->MediumTrackSearch.dPhaseTarget :=  reference to CompleteIoSet.dPhaseTarget
    : this->MediumTrackSearch.dManualTarget := reference to CompleteIoSet.dManualTarget
    : this->MediumTrackSearch.dLockTarget := reference to CompleteIoSet.dLockTarget
    : this->MediumTrackSearch.dFringeCenterTarget := reference to CompleteIoSet.dFringeCenterTarget
    : this->MediumTrackSearch.SearchTarget := reference to CompleteIoSet.SearchTarget
    : this->MediumTrackSearch.WobbleTarget := reference to CompleteIoSet.WobbleTarget

    : this->MediumTrackSemiLock.ControllerParameters := reference to this->ControllerParametersToUse
    : this->MediumTrackSemiLock.DataStore := reference to DataStoreToUse
    : this->MediumTrackSemiLock.Fringe := reference to CompleteIoSet.Fringe
    : this->MediumTrackSemiLock.ClosedLoopDl :=  reference to CompleteIoSet.ClosedLoopDl
    : this->MediumTrackSemiLock.dPhaseTarget :=  reference to CompleteIoSet.dPhaseTarget
    : this->MediumTrackSemiLock.dManualTarget := reference to CompleteIoSet.dManualTarget
    : this->MediumTrackSemiLock.dLockTarget := reference to CompleteIoSet.dLockTarget
    : this->MediumTrackSemiLock.dFringeCenterTarget := reference to CompleteIoSet.dFringeCenterTarget
    : this->MediumTrackSemiLock.dSearchTarget := reference to CompleteIoSet.SearchTarget
    : this->MediumTrackSemiLock.WobbleTarget := reference to CompleteIoSet.WobbleTarget

    : this->MediumTrackLock.ControllerParameters := reference to this->ControllerParametersToUse
    : this->MediumTrackLock.DataStore := reference to DataStoreToUse
    : this->MediumTrackLock.Fringe := reference to CompleteIoSet.Fringe
    : this->MediumTrackLock.ClosedLoopDl :=  reference to CompleteIoSet.ClosedLoopDl
    : this->MediumTrackLock.dPhaseTarget :=  reference to CompleteIoSet.dPhaseTarget
    : this->MediumTrackLock.dManualTarget := reference to CompleteIoSet.dManualTarget
    : this->MediumTrackLock.dLockTarget := reference to CompleteIoSet.dLockTarget
    : this->MediumTrackLock.dFringeCenterTarget := reference to CompleteIoSet.dFringeCenterTarget
    : this->MediumTrackLock.SearchTarget := reference to CompleteIoSet.SearchTarget
    : this->MediumTrackLock.WobbleTarget := reference to CompleteIoSet.WobbleTarget

    : this->SlowOffSearchSemiLock->ControllerParameters := reference to this->ControllerParametersToUse
    : this->SlowOffSearchSemiLock.Fringe := reference to CompleteIoSet.Fringe   
    : this->SlowOffSearchSemiLock.FringeCenterTarget := reference to CompleteIoSet.FringeCenterTarget

    : this->SlowTrackLock->ControllerParameters := reference to this->ControllerParametersToUse
    : this->SlowTrackLock.Fringe := reference to CompleteIoSet.Fringe   
    : this->SlowTrackLock.dFringeCenterTarget := reference to CompleteIoSet.FringeCenterTarget

    : this->ImagingOff.FullFrame := reference to CompleteIoSet.FullFrame
    : this->ImagingOff.DispersedFringe := CompleteIoSet.DispersedFringe
    : this->ImagingOff.StarImage0 := reference to CompleteIoSet.Star0
    : this->ImagingOff.StarImage1 := reference to CompleteIoSet.Star1
    : this->ImagingOff.StarTracker0 := reference to CompleteIoSet.StarTracker0
    : this->ImagingOff.StarTracker1 := reference to CompleteIoSet.StarTracker1

    : this->ImagingTrack.FullFrame := reference to CompleteIoSet.FullFrame
    : this->ImagingTrack.DispersedFringe := CompleteIoSet.DispersedFringe
    : this->ImagingTrack.Star0 := reference to CompleteIoSet.Star0
    : this->ImagingTrack.Star1 := reference to CompleteIoSet.Star1
    : this->ImagingTrack.StarTracker0 := reference to CompleteIoSet.StarTracker0
    : this->ImagingTrack.StarTracker1 := reference to CompleteIoSet.StarTracker1
    
    : this->TrackUpdate.Fringe := reference to CompleteIoSet.Fringe
    : this->TrackUpdate.Thresholds := this->Thresholds
    : iCurrentControllerMode := FTM_SEARCH
  ]]
    
]]   

[[D tFtCompleteControllerSet::~tFtCompleteControllerSet (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tFtCompleteControllerSet::OffControllerGroup (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := reference to a tSimpleControllerGroup with controllers { 
      (FT_FAST_PARTITION, &this->FastOff),
      (FT_MEDIUM_PARTITION, &this->MediumOff),
      (FT_SLOW_PARTITION, &this->SlowOffSearchSemiLock),
      (FT_IMAGING_PARTITION, &this->ImagingOff) }
]]


[[D tFtCompleteControllerSet::TrackControllerGroup (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := reference to a tModedControllerGroup with controllers { 
      (FT_FAST_PARTITION, FT_TRACK_SEARCH_MODE, &this->FastTrack),
      (FT_MEDIUM_PARTITION, FT_TRACK_SEARCH_MODE, &this->MediumTrackSearch),
      (FT_SLOW_PARTITION, FT_TRACK_SEARCH_MODE, &this->SlowOffSearchSemiLock),
      (FT_IMAGING_PARTITION, FT_TRACK_SEARCH_MODE, &this->ImagingTrack),
      (FT_FAST_PARTITION, FT_TRACK_SEMILOCK_MODE, &this->FastTrack),
      (FT_MEDIUM_PARTITION, FT_TRACK_SEMILOCK_MODE, &this->MediumTrackSemiLock),
      (FT_SLOW_PARTITION, FT_TRACK_SEMILOCK_MODE, &this->SlowOffSearchSemiLock),
      (FT_IMAGING_PARTITION, FT_TRACK_SEMILOCK_MODE, &this->ImagingTrack),
      (FT_FAST_PARTITION, FT_TRACK_LOCK_MODE, &this->FastTrack),
      (FT_MEDIUM_PARTITION, FT_TRACK_LOCK_MODE, &this->MediumTrackLock),
      (FT_SLOW_PARTITION, FT_TRACK_LOCK_MODE, &this->SlowTrackLock),
      (FT_IMAGING_PARTITION, FT_TRACK_LOCK_MODE, &this->ImagingTrack) }              
]]

[[D tFtCompleteControllerSet::SetControllerParameters (
       const tFtServoParameters& ControllerParametersToUse) ]
[ invalid_pointer (this) ||
  invalid_reference (ControllerParameters) => UNDEFINED
| true => 
    this->ControllerParameters := ControllerParametersToUse
    : return := OK
]]

[[D tFtCompleteControllerSet::SetThresholds (
       const tFtThresholds& ThresholdsToUse) ]
[ invalid_pointer (this) ||
  invalid_reference (ThresholdsToUse) => UNDEFINED
| true => 
    this->Thresholds := ThresholdsToUse
    : return := OK
]]

[[D tFtCompleteControllerSet::ControllerParameters (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := this->ControllerParameters
]]

[[D tFtCompleteControllerSet::Thresholds (void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>  return := this->Thresholds 
]]
***/

class tFtGizmoInfo;
class tTypeTag;
class tControllerGroup;

class tFtCompleteControllerSet {
  public: 
    tFtCompleteControllerSet (tFtCompleteIoSet& CompleteIoSetToUse,
                              const tFtGizmoInfo& GizmoInfo);
    ~tFtCompleteControllerSet ();
    tControllerGroup&  OffControllerGroup ();
    tControllerGroup&  TrackControllerGroup ();
    ERROR_CODE SetControllerParameters (const tFtControllerParameters& 
      ControllerParametersToUse);
    ERROR_CODE SetThresholds (const tFtThresholdParameters& ThresholdsToUse);
    const tFtControllerParameters& GetControllerParameters () const;
    const tFtThresholdParameters& GetThresholds () const;
    
  private:
    
    tFtControllerParameters           ControllerParameters;
    tFtThresholdParameters            Thresholds;

    tFtFastOffController              FastOff;
    tFtFastTrackSearchController      FastTrackSearch;
    tFtFastController                 FastTrackSemiLock;
    tFtFastTrackLockController        FastTrackLock;
    tFtMediumOffController            MediumOff;
    tFtMediumTrackSearchController    MediumTrackSearch;
    tFtMediumTrackSemiLockController  MediumTrackSemiLock;
    tFtMediumTrackLockController      MediumTrackLock;
    tFtSlowController                 SlowOffSearchSemiLock;
    tFtSlowTrackLockController        SlowTrackLock;
    tFtImagingController              ImagingOff;
    tFtImagingTrackController         ImagingTrack;
    
    tFtTrackGroupUpdate     TrackUpdate;
    tSimpleControllerGroup  OffGroup;
    tModedControllerGroup   TrackGroup;

};


#endif INC_ftControllerSeth
