/* $RCSfile: ftIoSet.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/ft/ftIoSet.h,v 1.1.1.1 1998/06/11 21:36:16 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */

#ifndef INC_ftIoSet_h
#define INC_ftIoSet_h

#include "isit.h"
#include "ftTypes.h"
#include "typeTag.h"
#include "dataStore.h"
#include "inputSource.h"
#include "outputDest.h"
#include "stActuator.h"
#include "dlActuator.h"
#include "imageSensor.h"
#include "imageStatus.h"
#include "fringe.h"
#include "search.h"
#include "integratorSensor.h"
#include "wobbleTarget.h"
#include "phaseTarget.h"

#include "ringBuffer.h"
#include "ftMediumController.h"
#include "ftFastController.h"

/****
[[D tFtCompleteIoSet::tFtCompleteIoSet (const tFtGizmoInfo& GizmoInfo) ]
[ invalid_pointer (this) ||
  invalid_reference (GizmoInfo) ||
  ::IpcMemory.bInit == FALSE => UNDEFINED
| CanAllocateIpcObject (::IpcMemoryG, GizmoInfo.iiDelayLineTargetId) == FALSE => 
    console := console + appropriate error messages
    : *this := anything
| true =>
    this->Apd.pChannel := GizmoInfo.pApdChannel
    : this->Star0.pFullImageChannel := GizmoInfo.pFullImageChannel
    : this->Star0.ImageParameters := GizmoInfo.ImageParameters.Star0Parameters
    : this->Star.pFullImageChannel := GizmoInfo.pFullImageChannel
    : this->Star.ImageParameters := GizmoInfo.ImageParameters.Star1Parameters

    : this->DispersedFringe.pFullImageChannel := GizmoInfo.pFullImageChannel
    : this->DispersedFringe.ImageParameters := GizmoInfo.ImageParameters.DispersedFringeParameters

    : this->FullFrame.pFullImageChannel := GizmoInfo.pFullImageChannel
   
    : this->ApdDiagOutput.pChannel := GizmoInfo.pApdDiagChannel
    : this->ApdDiagOutput.dValue := 0.0

    : this->ClosedLoopDl.TargetId := GizmoInfo.iiDelayLineTargetId
    : this->StarTracker0.iiBufferId := GizmoInfo.iiStarTracker0ImageBufferId
    : this->StarTracker1.iiBufferId := GizmoInfo.iiStarTracker1ImageBufferId
    : ::IpcMemoryG.ObjectSet := ::IpcMemoryG.ObjectSet U {
        IpcObject (::IpcMemory, GizmoInfo.iiDelayLineTargetId),
        IpcObject (::IpcMemory, GizmoInfo.iiStarTracker0ImageBufferId),
        IpcObject (::IpcMemory, GizmoInfo.iiStarTracker1ImageBufferId) }
        
    : this->DataStore.DataBag := EMPTY
    
    : this->Fringe.PhotonLog := CLEARED
    : this->Fringe.Parameters := GizmoInfo.ServoParameters.FringeParameters

    : this->dManualTarget := ZERO_TARGET
    : this->dLockTarget := ZERO_TARGET
    : this->dTotalGain := -1.0 * 
      GizmoInfo.ServoParameters.ControllerParameters.iPhaseSign * 
      GizmoInfo.ServoParameters.ControllerParameters.dServoGain * 
      GizmoInfo.PhysicalConstants.lvWhiteLightLambda / PI
    : this->tServoPeriod := GizmoInfo.ServoInfo.ServoTaskArray[FSP_MEDIUM].tTaskPeriod
    : this->PhaseTarget.dPosition := 0.0
    : this->PhaseTarget.dVelocity := 0.0
    : this->PhaseTarget.tTime := 0
    : this->PhaseTarget.dErrorSum := 0.0
    : this->dFringeCenterTarget := ZERO_TARGET
    : this->SearchTarget.iCounter := 0
    : this->SearchTarget.SearchParameters := GizmoInfo.ServoParameters.SearchParameters
    : this->WobbleTarget.bEnabled := TRUE
    : this->WobbleTarget.bInit := TRUE
    : this->WobbleTarget.WobbleTargets := RING_BUFFER<double,3> filled with 0.0
    : this->WobbleTarget.ModParams := GizmoInfo.ServoParameters.WobbleParameters

    : this->CFullImageTag.stType := ST_STATUS
    : this->CFullImageTag.tnName := TN_FT_FULL_IMAGE
    : this->CFullImageTag.iGizmoId := GizmoInfo.iGizmoId
    : this->CFullImageTag.szBlockSize := sizeof (PIXEL) * 
      GizmoInfo.FullImage.iHSize * GizmoInfo.FullImage.iVSize

    : this->CDispersedFringeTag.stType := ST_STATUS
    : this->CDispersedFringeTag.tnName := TN_FT_IMAGE
    : this->CDispersedFringeTag.iGizmoId := GizmoInfo.iGizmoId
    : this->CDispersedFringeTag.szBlockSize := sizeof (PIXEL) * 
      GizmoInfo.FringeImage.iHSize * GizmoInfo.FringeImage.iVSize

    : this->CDataTag.stType := ST_DATA
    : this->CDataTag.tnName := TN_FT_DATA
    : this->CDispersedFringeTag.iGizmoId := GizmoInfo.iGizmoId
    : this->CDispersedFringeTag.szBlockSize := sizeof (tFtData) 

    : this->FullFrameImage.iHSize := FULL_FRAME_H_SIZE
    : this->FullFrameImage.iVSize := FULL_FRAME_V_SIZE

    : this->DispersedFringeImage.Image.iHSize := 
      GizmoInfo.ImageParameters.iFringeImageHSize
    : this->DispersedFringeImage.Image.iVSize := 
      GizmoInfo.ImageParameters.iFringeImageVSize
    : this->dUnwrappedPhase := 0.0
    : this->dManualTarget := 0.0
    : this->dLockTarget := 0.0
    : this->dPhaseTarget := 0.0
    : this->dFringeCenterTarget := 0.0
    : this->dServoErrorSum := 0.0
    : this->lvWhiteLightLambda := GizmoInfo.PhysicalConstants.lvWhiteLightLambda
]]


[[D tFtCompleteIoSet::~tFtCompleteIoSet (void) ]
[ invalid_pointer (this)  => UNDEFINED
| true => *this := anything
]]

[[D tFtCompleteIoSet::SetSearchParameters (
      const tSearchParameters& SearchParameters) ]
[ invalid_pointer (this) ||
  invalid_reference (SearchParameters) => UNDEFINED
| true =>
    this->SearchTarget.dR0 := SearchParameters.dR0
    : this->SerachTarget.dDeltaR := SearchParameters.dDeltaR
    : this->SearchTarget.dProggressionConstant := dProggessionConstant
    : this->SearchTarget.stSearchType := SearchParameters.stSearchType
]]

[[D tFtCompleteIoSet::SetWobbleParameters (
      const tModulationParam& WobbleParameters) ]
[ invalid_pointer (this) ||
  invalid_reference (WobbleParameters) => UNDEFINED
| true => this->WobbleTarget.ModParams := WobbleParameters
]]


[[D tFtCompleteIoSet::SetRegionOfInterest (const tFtImageParameters& ImageParameters) ]
[ invalid_pointer (this) ||
  invalid_reference (ImageParameters) => UNDEFINED
| ImageParameters.iStartXSt0 < 0 || 
  ImageParameters.iStartXSt0 >= this->FullFrame.iHSize ||
  ImageParameters.iStartYSt0 < 0 ||
  ImageParameters.iStartYSt0 >= this->FullFrame.iHSize ||
  ImageParameters.iStartXSt1 < 0 ||
  ImageParameters.iStartXSt1 >= this->FullFrame.iHSize || 
  ImageParameters.iStartYSt1 < 0 ||
  ImageParameters.iStartYSt1 >= this->FullFrame.iHSize ||
  ImageParameters.iStartXFringeImage < 0 ||
  ImageParameters.iStartXFringeImage >= this->FullFrame.iHSize ||
  ImageParameters.iStartYFringeImage < 0 ||
  ImageParameters.iStartYFringeImage >= this->FullFrame.iHSize =>
    StarImage0.iStartX := anything
    : StarImage0.iStartY := anything
    : StarImage1.iStartY := anything
    : StarImage1.iStartY := anything
    : DispersedFringe.iStartX := anything
    : DispersedFringe.iStartY := anything
    : return := appropriate error code
| true => 
    StarImage0.iStartX := ImageParameters.iStartXSt0
    : StarImage0.iStartY := ImageParameters.iStartYSt0
    : StarImage1.iStartY := ImageParameters.iStartYSt1
    : StarImage1.iStartY := ImageParameters.iStartYSt1
    : DispersedFringe.iStartX := ImageParameters.iStartXFringeImage
    : DispersedFringe.iStartY := ImageParameters.iStartYFringeImage
    : return := OK
]]


[[D tFtCompleteIoSet::SetManualTarget (FT_TARGET_DIRECTION ftdTargetDirection) ]
[ invalid_pointer (this) ||
  invalid_reference (this->dManualTarget) => UNDEFINED
| ftdTargetDirection == FTD_POSITIVE => 
    this->dManualTarget := this->dManualTarget + this->lvWhiteLightLamda
    : return := OK
| ftdTargetDirection == FTD_NEGATIVE => 
    this->dManualTarget := this->dManualTarget - this->lvWhiteLightLamda
    : return := OK
| true => return := appropriate error code
]]


[[D tFtCompleteIoSet::SendFullFrameImage (void) ]
[ invalid_pointer (this) ||
  invalid_reference (this->FullFrame.pFullImageChannel) => UNDEFINED
| IsFull (::StatusStream) => return := appropriate error code
| true => 
    ::StatusStream := ::StatusStream + this->CFullFrameTag +
      this->FullFrame.Image
    : return := OK
]]


[[D tFtCompleteIoSet::SendAtomicFullFrameImage (void) ]
[ invalid_pointer (this) ||
  invalid_pointer (this->FullFrame.pFullImageChannel) => UNDEFINED
| IsFull (::StatusStream) => return := appropriate error code
| true => 
    ::StatusStream := ::StatusStream + this->CFullFrameTag +
      atomic this->FullFrame.Image
     : return := OK
]]


[[D tFtCompleteIoSet::SendDispersedFringeImage (void) ]
[ invalid_pointer (this) ||
  ::StatusStream.bInit == FALSE ||
  invalid_pointer (this->DispersedFringe.pFullImageChannel) => UNDEFINED
| IsFull (::StatusStream) => return := appropriate error code
| true => 
    ::StatusStream := ::StatusStream + this->CDispersedFringeTag +
      this->DispersedFringe.Image
    : return := OK
]]

*******************/




class tFtGizmoInfo;
class tFtSearchParameters;
class tModulationParams;
class tFtImageParameters;

class tFtCompleteIoSet {
  public:
    tFtCompleteIoSet (const tFtGizmoInfo& GizmoInfo);
    ~tFtCompleteIoSet ();
    ERROR_CODE  SetSearchParameters (const tFtSearchParameters& SearchParameters);
    ERROR_CODE SetWobbleParameters (const tModulationParams& WobbleParameters);
    ERROR_CODE SetRegionOfInterest (const tFtImageParameters& ImageParameters);
    ERROR_CODE SetManualTarget (FT_TARGET_DIRECTION ftdTargetDirection);
    ERROR_CODE SendFullFrameImage ();
    ERROR_CODE SendAtomicFullFrameImage ();
    ERROR_CODE SendDispersedFringeImage ();
    tFtTargetStatus Targets () const;
    tFtImageParameters ImageParameters () const;
    const tModulationParams& WobbleParameters () const;
    tFtSearchParameters SearchParameters () const;
    tFringeStatus FringeStatus () const;
        
  private:
    const tTypeTag CDataTag;
    const tTypeTag CDispersedFringeTag;
    const tTypeTag CFullFrameTag;
    
    tImage FullFrameImage;
 
 
  public:
    
    //inputs
    tIntegratorSensor  Apd;             // Avalanche Photo Diode sensor
    tImageSensor       Star0;     
    tImageSensor       Star1;
    tImageSensor       DispersedFringe;
    tFullFrameSensor   FullFrame;
    
    //outputs
    
    tActuator    ApdDiagOutput;
    tDlActuator  ClosedLoopDl;  
    tStActuator  StarTracker0;
    tStActuator  StarTracker1;
    tDataStore<tFtData> DataStore;
    
    // inputs/outputs
   
    tFringe Fringe;
    tImageStatus DispersedFringeImage;

    //targets
    
    double  dUnwrappedPhase;
    double  dManualTarget;
    double  dLockTarget;
    double  dFringeCenterTarget;
    tPhaseTarget  PhaseTarget;
    tSearch SearchTarget;
    tWobbleTarget WobbleTarget;
    
    tRingBuffer<dum> TestDump;
    tRingBuffer<tCount> PhotonDiag;
   
  private:
    LASER_VALUE lvWhiteLightLambda;
};


#endif INC_ftIoSet_h
