/* $RCSfile: phaseTarget.h,v $ */
/* $Header: /home/chara/cvsroot/ople/sys/include/ft/phaseTarget.h,v 1.1.1.1 1998/06/11 21:36:16 chara Exp $ */

/*
modification history
--------------------
04c,4Dec97, rlj    written
*/

#ifndef INC_phaseTargeth
#define INC_phaseTargeth

#include "isit.h"
#include "ftTypes.h"

/*****
[[D tPhaseTarget::tPhaseTarget (void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    : this->dPosition := 0.0
    : this->dVelocity := 0.0
    : this->tTime := 0
    : this->dErrorSum := 0.0
]]


[[D tPhaseTarget::~tPhaseTarget (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]



[[D tPhaseTarget::Reset (void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->dPosition := 0.0
    : this->dVelocity := 0.0
    : this->tTime := 0
    : this->dErrorSum := 0.0
]]

[[D tPhaseTarget::Calculate (const tFtControllerParameters&  
      ControllerParameters,TIME tServoTime, double dPhaseError) ]
[ invalid_pointer (this) => UNDEFINED
| ControllerParameters.tServoPeriod == 0 => return := tDlTarget with 
     dPosition = 0.0
     dRate = 0.0
     tTime = 0
| true =>
    this->dPosition := this->dPosition + 
      this->dVelocity * ControllerParameters.tFtServoPeriod / T
      IME_TICKS_PER_SECOND 
    : this->dVelocity := -1 * ControllerParameters.iPhaseSign * 
      ControllerParameters.dFringeServoGain * 
      ControllerParameters.lvWhiteLightLambda * 
      TIME_TICKS_PER_SECOND *
      this->dErrorSum / ( PI * ControllerParameters.tFtServoPeriod)
    : this->tTime := tServoTime + ControllerParameters.tFtServoPeriod
    : this->dErrorSum := this->dErrorSum + dPhaseError
    : return := tDlTarget with 
      dPosition =  this->dPosition + 
      this->dVelocity * ControllerParameters.tFtServoPeriod / 
      TIME_TICKS_PER_SECOND

      dRate = -1 * ControllerParameters.iPhaseSign * 
      ControllerParameters.dFringeServoGain * 
      ControllerParameters.lvWhiteLightLambda *      
      TIME_TICKS_PER_SECOND *
      this->dErrorSum / ( PI * ControllerParameters.tFtServoPeriod)
      tTime = tServoTime + ControllerParameters.tFtServoPeriod
]]


[[D tPhaseTarget::Position (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := this->dPosition
]]

[[D tPhaseTarget::Velocity (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := this->dVelocity
]]

[[D tPhaseTarget::Time (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := this->tTime
]]

[[D tPhaseTarget::ErrorSum (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := this->dErrorSum
]]

*****/

class tPhaseTarget {
  public:
    tPhaseTarget ();
    ERROR_CODE Reset ();
    tDlTarget Calculate (const tFtControllerParameters& ControllerParameters, 
      TIME tServoTime, double dPhaseError);
    double Position () const;
    double Velocity () const;
    TIME Time () const;
    double ErrorSum () const;
  private:
    double dPosition;
    double dVelocity;
    TIME tTime;
    double dErrorSum;
};

#endif INC_phaseTargeth

