/* $RCSfile: wobbleTarget.h,v $ */
/* $Header: /home/chara/cvsroot/ople/sys/include/ft/wobbleTarget.h,v 1.1.1.1 1998/06/11 21:36:16 chara Exp $ */

/*
modification history
--------------------
04c,4Dec97, rlj    written
*/

#ifndef INC_wobbleTargeth
#define INC_wobbleTargeth

#include "isit.h"
#include "modLib.h"
#include "ringBuffer.h"

/****
[[D tWobbleTarget::tWobbleTarget (int iWobbleMemoryToUse) ]
[ invalid_pointer (this) => UNDEFINED
| iWobbleMemoryToUse < 0 => *this := anything
| true => 
    this->iWobbleMemory := iWobbleMemoryToUse 
    : this->WobbleTargets = RING_BUFFER<double,iWobblMemoryToUse> filled with 0.0
    : this->dBadWobbleTarget := 0.0
    : this->ModParams := defalt parameters
    : this->bActive := TRUE
    : this->bInit := TRUE
]]



[[D tWobbleTarget::tWobbleTarget (int iWobbleMemoryToUse, const tModulationParams&
      ModulationParameters) ]
[ invalid_pointer (this) ||
  invalid_reference (ModulationParameters) => UNDEFINED
| iWobbleMemoryToUse < 0 => *this := anything
| true => 
    this->iWobbleMemory := iWobbleMemoryToUse 
    : this->WobbleTargets = RING_BUFFER<double,iWobblMemoryToUse> filled with 0.0
    : this->ModParams := ModulationParameters
    : this->bEnable := TRUE
    : this->bActive := TRUE
]]


[[D tWobbleTarget::~tWobbleTarget (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]



[[D tWobbleTarget::Calculate (TIME tTime) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->WobbleTargets := this->WobbleTargets + modulation value computed at tTime
    : return :=  modulation value computed at tTime
]]

[[D tWobbleTarget::operator_index (int iWobbleIndex) ]
[ invalid_pointer (this) => UNDEFINED
| iWobbleIndex > 0 ||
  iWobbleIndex < -this->iWobbleMemory => return := this->dBadWobbleTarget
| true => return :=  this->WobbleTargets [iWobbleIndex]
]]

[[D tWobbleTarget::Reset (void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
   this->WobbleTargets filled with 0.0
]]

*****/


class tWobbleTarget : public tModulation {
  public:
    tWobbleTarget (int iWobbleMemoryToUse);
    tWobbleTarget (int iWobbleMemoryToUse, 
      const tModulationParams& ModulationParamaters);
    double Calculate (TIME tTime);
    const double& operator[] (int iWobbleIndex) const;
    void Reset ();
  private:
    int iWobbleMemory;
    tRingBuffer<double> WobbleTargets;
    double dBadWobbleTarget;
};

#endif INC_wobbleTargeth

