/* $RCSfile: ftCommands.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/ftCommands.h,v 1.1.1.1 1998/06/11 21:36:11 chara Exp $*/

/* Derek Slye - Jet Propulsion Laboratory */


#ifndef INC_ftCommandsh
#define INC_ftCommandsh

#include "ftTypes.h"

class tFtOffCmd   : public tIsitCmd {};
class tFtTrackCmd : public tIsitCmd {};
class tFtPingCmd  : public tIsitCmd {};
class tFtGetImage : public tIsitCmd {};

class tFtSetManualTargetCmd : public tIsitCmd {
  public:
    FT_TARGET_DIRECTION ftdTargetDirection;
};

class tFtSetServoParametersCmd : public tIsitCmd {
  public:
    double    dAmplitude;
    double    dFrequency;
    double    dMeanVal;
    double    dDutyCycle;
    MOD_TYPE  mtModulationType;
    TIME      tSyncTime;
    
    
    double        dSpiralRadiusInitial;
    double        dSpiralRadiusLimit;
    double        dSpiralStep;
    double        dProgressionConstant;
    SEARCH_TYPE   stSearchType;

    TIME    tSemiLockToLockTimeout;
    TIME    tTotalTimeToLockTimeout;
    double  dSNRThreshSearchToSemiLock;
    double  dSNRThreshSemiLockToLock;
    double  dV2ThreshSemiLockToLock;
    double  dSNRThreshLockToSearch;
    double  dThreshForDrop;
    double  dThreshForSearch;
    double  dPhaseOffset;

    BOOL    bOnCenterFringe;
    int     iMemBoxcar;
    int     iPhaseSign;
    double  dFringeServoGain;
    double  dDeltaVDeltaWobbleToHop;
};

class tFtSetRegionOfInterestCmd : public tIsitCmd {
  public:
    tFtImageParameters ImageParameters;
};


#endif INC_ftCommandsh
