/* $RCSfile: gsuDlControllerData.h,v $  */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/include/gsu/gsuDlControllerData.h,v 1.1.1.1 1998/06/11 21:36:16 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */
 
/*
modification history
--------------------
*/
 
/*
DESCRIPTION

*/

#ifndef INC_gsuDlControllerDatah
#define INC_gsuDlControllerDatah

#include "dl/dlControllerData.h"

/****
[[D tGsuDlControllerData::tGsuDlControllerData (void) ]
Constructs this with default values.
[ invalid_pointer (this) => UNDEFINED 
| true => 
    this->dServoError := 0.0
    : this->dMotorVelocity := 0.0
    : this->dVc1Error := 0.0
    : this->dVc2Error := 0.0
    : this->dVc1Output := 0.0
    : this->dVc2Output := 0.0
    : this->dMotorAcceleration := 0.0
]]

[[D tGsuDlControllerData::~tGsuDlControllerData (void) ]
[ invalid_pointer (this) => UNDEFINED 
| true => *this := anything
]]

[[D tGsuDlControllerData::Vc1Error (void) ]
[ invalid_pointer (this) => UNDEFINED 
| const_pointer (this) => return this->dVc1Error
| true => return := reference to this->dVc1Error
]]


[[D tGsuDlControllerData::Vc2Error (void) ]
[ invalid_pointer (this) => UNDEFINED 
| const_pointer (this) => return this->dVc2Error
| true => return := reference to this->dVc2Error
]]

[[D tGsuDlControllerData::Vc1Output (void) ]
[ invalid_pointer (this) => UNDEFINED 
| const_pointer (this) => return this->dVc1Output
| true => return := reference to this->dVc1Output
]]

[[D tGsuDlControllerData::Vc2Output (void) ]
[ invalid_pointer (this) => UNDEFINED 
| const_pointer (this) => return this->dVc2Output
| true => return := reference to this->dVc2Output
]]
[[D tGsuDlControllerData::MotorAcceleration (void) ]
[ invalid_pointer (this) => UNDEFINED 
| const_pointer (this) => return this->dMotorAcceleration
| true => return := reference to this->dMotorAcceleration
]]

[[D tGsuDlControllerData::ServoError (void) ] = tDlControllerData::ServoError ]]

[[D tGsuDlControllerData::MotorVelocity (void) ] = tDlControllerData::MotorVelocity ]]


*****/


class tGsuDlControllerData : public tDlControllerData {
  public:
    tGsuDlControllerData (const tTypeTag& DlDataTag,
        tGsuDlStatus& DlStatus, double dLinearCartErrorPerLaserError) : 
          tDlControllerData (DlDataTag, DlStatus, dLinearCartErrorPerLaserError),
        dVc1Error (0.0), dVc2Error (0.0),
      dVc1Output (0.0), dVc2Output (0.0), dMotorAcceleration (0.0) {}
    double& Vc1Error () { return this->dVc1Error;}
    double Vc1Error () const { return this->dVc1Error;}
    double& Vc2Error () { return this->dVc2Error;}
    double Vc2Error () const { return this->dVc2Error;}
    double& Vc1Output () { return this->dVc1Output;}
    double Vc1Output () const { return this->dVc1Output;}
    double& Vc2Output () { return this->dVc2Output;}
    double Vc2Output () const { return this->dVc2Output;}
    double MotorAcceleration () const { return this->dMotorAcceleration;}
    double& MotorAcceleration () { return this->dMotorAcceleration;}
  private:
    double dVc1Error;
    double dVc2Error;
    double dVc1Output;
    double dVc2Output;
    double dMotorAcceleration;
};



#endif  
