/* $RCSfile: gsuDlGizmoInfo.h,v $ */
/* CM Info: */   
/*$Header: /home/chara/cvsroot/ople/sys/include/gsu/gsuDlGizmoInfo.h,v 1.1.1.1 1998/06/11 21:36:16 chara Exp $ */

/* Richard Johnson - Jet Propulsion Laboratory */

/* modification history
--------------------
*/

#ifndef INC_gsuDlGizmoInfoh
#define INC_gsuDlGizmoInfoh

#include "isit.h"
#include "gsu/gsuDlTypes.h"
#include "dlGizmoInfo.h"

/****************************************************************
*
* tGsuDlGizmoInfo class spec
* 
[[D tGsuDlGizmoInfo::tGsuDlGizmoInfo_params(void)]
[ invalid_pointer(this) => UNDEFINED
| true =>
  set state variables to corresponding parameters
  : FE BOARD_NAME/ChannelNum pair,
     corresponding this->channelPointer := appropriate channel pointer
]]
*
*/

class tGsuDlGizmoInfo : public tDlGizmoInfo {
public:
  tGsuDlGizmoInfo (int iWhichRteToUse,int iGizmoIdToUse,
       const int iTargetSourceArray [NUM_DELAY_LINE_TARGETS],
       TIME tDitherPeriodToUse,
       DlPhysicalConstants PhysConstToUse, int iNumServoModesToUse,
       const tServoInfo& ServoInfoToUse,
       const tGsuDlServoParameters& ServoParametersToUse,
       BOARD_NAME bnVc1BoardToUse, int iVc1ChannelToUse,
       BOARD_NAME bnVc2BoardToUse, int iVc2ChannelToUse,
       BOARD_NAME bnServoPztBoardToUse, int iServoPztChannelToUse,
       BOARD_NAME bnMotorBoardToUse, int iMotorChannelToUse,
       BOARD_NAME bnDitherPztBoardToUse, int iDitherPztChannelToUse,
       BOARD_NAME bnEddy1BoardToUse, int iEddy1ChannelToUse,
       BOARD_NAME bnEddy2BoardToUse, int iEddy2ChannelToUse,
       BOARD_NAME bnFrontSoftLimitBoardToUse, int iFrontSoftLimitChannelToUse,
       BOARD_NAME bnFrontHardLimitBoardToUse, int iFrontHardLimitChannelToUse,
       BOARD_NAME bnBackSoftLimitBoardToUse, int iBackSoftLimitChannelToUse,
       BOARD_NAME bnBackHardLimitBoardToUse, int iBackHardLimitChannelToUse,
       BOARD_NAME bnLaserBoardToUse, int iLaserChannelToUse,
       BOARD_NAME bnHomeSensorBoardToUse, int iHomeSensorChannelToUse,
       BOARD_NAME bnServoPztReadbackBoardToUse, int iServoPztReadbackChannelToUse,
       BOARD_NAME bnMotorReadbackBoardToUse, int iMotorReadbackChannelToUse,
       BOARD_NAME bnDiagLaserInputBoardToUse, int iDiagLaserInputChannelToUse,
       BOARD_NAME bnDiagPztPositionInputBoardToUse, int iDiagPztPositionChannelToUse,
       BOARD_NAME bnDiagEddy1BoardToUse, int iDiagEddy1ChannelToUse,
       BOARD_NAME bnDiagEddy2BoardToUse, int iDiagEddy2ChannelToUse,
       BOARD_NAME bnDiagLaserOutputBoardToUse, int iDiagLaserOutputChannelToUse,
       BOARD_NAME bnDiagLaserServoErrorOutputBoardToUse,
              int iDiagLaserServoErrorOutputChannelToUse,
       BOARD_NAME bnDiagVc1ServoErrorOutputBoardToUse,
              int iDiagVc1ServoErrorOutputChannelToUse,
       BOARD_NAME bnDiagVc2ServoErrorOutputBoardToUse,
              int iDiagVc2ServoErrorOutputChannelToUse,
       BOARD_NAME bnDiagMotorServoErrorOutputBoardToUse,
              int iDiagMotorServoErrorOutputChannelToUse);

  virtual ~tGsuDlGizmoInfo();
  TIME DitherPeriod () const {return CtGsuDitherPeriod;}
  tDlPztParameters PztTrackParameters () const { return this->ServoParameters.PztParameters ();}
  tGsuDlVcStabilizeParameters VcIdleParameters () const { return this->ServoParameters.VcOffParameters ();}
  tGsuDlVcStabilizeParameters VcStabilizeParameters () const { return this->ServoParameters.VcStabilizeParameters ();}
  tGsuDlVcTrackParameters VcTrackParameters () const { return this->ServoParameters.VcTrackParameters ();}
  tDlMotorParameters MotorIdleParameters () const { return this->ServoParameters.MotorOffParameters ();}
  tDlMotorParameters MotorFrontParameters () const { return this->ServoParameters.MotorFrontParameters ();}
  tDlMotorParameters MotorBackParameters () const { return this->ServoParameters.MotorBackParameters ();}
  tDlMotorParameters MotorFrontCreepParameters () const { return this->ServoParameters.MotorFrontCreepParameters ();}
  tDlMotorParameters MotorBackCreepParameters () const { return this->ServoParameters.MotorBackCreepParameters ();}
  tDlMotorParameters MotorTrackSlewParameters () const { return this->ServoParameters.MotorTrackSlewParameters ();}
  tGsuDlMotorParameters MotorTrackParameters () const { return this->ServoParameters.MotorTrackParameters ();}
  tGsuDlThresholds Thresholds () const { return this->ServoParameters.Thresholds ();}
  
  tGsuDlServoParameters      ServoParameters;

  tOutputChannel         *pVc2Channel;
  tInputChannel          *pEddy1Channel;
  tInputChannel          *pEddy2Channel;
  tInputChannel          *pDiagEddy1InputChannel;
  tInputChannel          *pDiagEddy2InputChannel;
  tOutputChannel         *pDiagVc2ServoErrorOutputChannel;
};

#endif INC_gsuDlGizmoInfoh
