/* $RCSfile: hwError.h,v $ - Header file for hardware error codes */

/*
$Header: /home/chara/cvsroot/ople/sys/include/hwError.h,v 1.2 1998/08/17 21:01:13 phil Exp $
*/
 
/*
modification history
--------------------
01a,pci,31Oct96    written
*/
 
/*
DESCRIPTION
ISIT error number definitions for hardware.
*/

#ifndef INC_hwErrorh
#define INC_hwErrorh

/* Hardware */
#define S_hw_E_INVALID_BOARD_NUMBER                        (M_hw | 0x1)
#define S_hw_E_ERROR_DURING_HARD_INIT                      (M_hw | 0x2)
#define S_hw_E_ERROR_DURING_SOFT_INIT                      (M_hw | 0x3)
#define S_hw_E_VIRTUAL_FUNCTION_HARD_INIT_RAN              (M_hw | 0x4)
#define S_hw_E_VIRTUAL_FUNCTION_SOFT_INIT_RAN              (M_hw | 0x5)
#define S_hw_E_INVALID_BOARD_TYPE                          (M_hw | 0x6)
#define S_hw_RETURNING_NULL_BOARD_POINTER                  (M_hw | 0x7)
#define S_hw_GET_LOCAL_ADDRESS_ATTEMPTED_ON_NULL_VALUE     (M_hw | 0x8)
#define S_hw_LOCAL_ADDRESS_SET_TO_ZERO                     (M_hw | 0x9)
#define S_hw_CALLING_HARDINIT                              (M_hw | 0xa)
#define S_hw_BACK_FROM_HARDINIT                            (M_hw | 0xb)
#define S_hw_CALLING_SOFTINIT                              (M_hw | 0xc)
#define S_hw_BACK_FROM_SOFTINIT                            (M_hw | 0xd)
#define S_hw_RETURNING_NULL_CHANNEL_POINTER                (M_hw | 0xe)
#define S_hw_BUS_LOCK_TIMEOUT                              (M_hw | 0xf)
#define S_hw_ENTERING_HARDWARE_CONSTRUCTOR                 (M_hw | 0x1000)
#define S_hw_DONE_CONSTRUCTING_HARDWARE                    (M_hw | 0x1001)
#define S_hw_ENTERING_HARDWARE_DESTRUCTOR                  (M_hw | 0x1002)
#define S_hw_DONE_DESTRUCTING_HARDWARE                     (M_hw | 0x1003)
#define S_hw_ENTERING_HARDWARE_HARDINIT                    (M_hw | 0x1004)
#define S_hw_HARDWARE_INITIALIZED_HARDLY                   (M_hw | 0x1005)
#define S_hw_ENTERING_HARDWARE_SOFTINIT                    (M_hw | 0x1006)
#define S_hw_HARDWARE_INITIALIZED_SOFTLY                   (M_hw | 0x1007)



/* Board */
#define S_board_BOARD_ALREADY_INITIALIZED                  (M_board | 0x1)
#define S_board_INIT_ATTEMPTED_WITH_NULL_ADDRESS           (M_board | 0x2)

/* Clock */
#define S_clock_E_CLOCK_ALREADY_INITIALIZED                (M_clock | 0x1)
#define S_clock_E_BOARD_NOT_INITIALIZED                    (M_clock | 0x2)
#define S_clock_E_BOARD_HAS_NO_CLOCK                       (M_clock | 0x3)

/* Interrupt */
#define S_interrupt_INTERRUPT_ALREADY_INITIALIZED        (M_interrupt | 0x1)
#define S_interrupt_BOARD_HAS_NO_INTERRUPT               (M_interrupt | 0x2)
#define S_interrupt_BOARD_NOT_INITIALIZED                (M_interrupt | 0x3)
#define S_interrupt_W_INVALID_RATE                       (M_interrupt | 0x4)
#define S_interrupt_INT_NOT_INITIALIZED                  (M_interrupt | 0x5)
#define S_interrupt_NULL_FUNCTION_POINTER                (M_interrupt | 0x6)
#define S_interrupt_INT_ALREADY_CONNECTED                (M_interrupt | 0x7)
#define S_interrupt_INT_ALREADY_ENABLED                  (M_interrupt | 0x8)
#define S_interrupt_INT_NOT_CONNECTED                    (M_interrupt | 0x9)
#define S_interrupt_INT_RATE_NOT_SET                     (M_interrupt | 0xa)
#define S_interrupt_INT_NOT_ENABLED                      (M_interrupt | 0xb)
#define S_interrupt_INVALID_INTERRUPT_PRIORITY           (M_interrupt | 0xc)
#define S_interrupt_INVALID_INTERRUPT_VECTOR             (M_interrupt | 0xd)
#define S_interrupt_RATE_SET_CALLED_USING_BASE_CLASS     (M_interrupt | 0xe)

/* Channel */
#define S_tOutputChannel_CHANNEL_NOT_INITIALIZED           (M_channel | 0x1)
#define S_inputChannel_INVALID_CALL_TO_RESET               (M_channel | 0x2)
#define S_channel_INVALID_CALL_TO_RESET                    (M_channel | 0x3)
#define S_counterChannel_INVALID_CALL_TO_RESET             (M_channel | 0x4)

/* Image Channel */
#define S_tImageChannel_CHANNEL_NOT_INITIALIZED            (M_imageChannel | 0x1)
#define S_tFullImageChannel_CHANNEL_NOT_INITIALIZED        (M_imageChannel | 0x2)
#define S_tSubImageChannel_CHANNEL_NOT_INITIALIZED         (M_imageChannel | 0x3)
#define S_tSubImageChannel_CHANNEL_REGION_OUT_OF_RANGE     (M_imageChannel | 0x4)
#define S_tSubImageChannel_INVALID_FULL_IMAGE_CHANNEL      (M_imageChannel | 0x5)

/* Device */
#define S_device_DEVICE_ALREADY_INITIALIZED                (M_device | 0x1)

/* Actuator */
#define S_actuator_ACTUATOR_ALREADY_INITIALIZED            (M_actuator | 0x1)
#define S_actuator_ACTUATOR_NOT_INITIALIZED                (M_actuator | 0x2)

/* Sensor */
#define S_sensor_SENSOR_ALREADY_INITIALIZED                (M_sensor | 0x1)
#define S_sensor_SENSOR_NOT_INITIALIZED                    (M_sensor | 0x2)
#define S_sensor_CHANNEL_OUT_OF_RANGE                      (M_sensor | 0x3)
#define S_sensor_NULL_POINTER                              (M_sensor | 0x4)

/* dt1401 Card */
#define S_dt1401_BOARD_ALREADY_INITIALIZED                 (M_dt1401 | 0x1)
#define S_dt1401_INVALID_DA_CHANNEL                        (M_dt1401 | 0x2)

/* pc03v Card */
#define S_pc03v_BOARD_ALREADY_INITIALIZED                  (M_pc03v | 0x1)
#define S_pc03v_E_BOARD_NOT_INITIALIZED                    (M_pc03v | 0x2)
#define S_pc03v_E_INTERRUPT_ALREADY_INITIALIZED            (M_pc03v | 0x3)
#define S_pc03v_E_BOARD_HAS_NO_INTERRUPT                   (M_pc03v | 0x4)
#define S_pc03v_E_NULL_FUNCTION_POINTER                    (M_pc03v | 0x5)
#define S_pc03v_E_INVALID_INT_SOURCE                       (M_pc03v | 0x6)
#define S_pc03v_E_INVALID_INTERRUPT_NUMBER                 (M_pc03v | 0x7)
#define S_pc03v_CREATE_CHANNEL_ATTEMPTED                   (M_pc03v | 0x8)
#define S_pc03v_ENTERING_CONSTRUCTOR                       (M_pc03v | 0x1001)
#define S_pc03v_DONE_CONSTRUCTING                          (M_pc03v | 0x1002)
#define S_pc03v_ENTERING_SOFTINIT                          (M_pc03v | 0x1003)
#define S_pc03v_INITIALIZED_SOFTLY                         (M_pc03v | 0x1004)
#define S_pc03v_ENTERING_HARDINIT                          (M_pc03v | 0x1005)
#define S_pc03v_INITIALIZED_HARDLY                         (M_pc03v | 0x1006)

/* laser Card */
#define S_laser_INVALID_COUNTER                  (M_laser | 0x01)
#define S_laser_NO_REFERENCE                     (M_laser | 0x02)
#define S_laser_NO_64_MHZ                        (M_laser | 0x03)
#define S_laser_NO_16_MHZ                        (M_laser | 0x04)
#define S_laser_NO_2_MHZ                         (M_laser | 0x05)
#define S_laser_NO_EXTERNAL_CLOCK                (M_laser | 0x06)
#define S_laser_UNKNOWN_CLOCK_ERROR              (M_laser | 0x07)
#define S_laser_UNKNOWN_NOT_PRESENT              (M_laser | 0x08)
#define S_laser_INIT_INVALID_ARGUMENT            (M_laser | 0x09)
#define S_laser_INVALID_SYNC_MODE                (M_laser | 0x0a)
#define S_laser_COUNTER_FAILED_POS_SLEW_TEST     (M_laser | 0x0b)
#define S_laser_COUNTER_FAILED_RET_TO_ZERO_TEST  (M_laser | 0x0c)
#define S_laser_COUNTER_FAILED_NEG_SLEW_TEST     (M_laser | 0x0d)
#define S_laser_COUNTER_FAILED_CLEAR_TEST        (M_laser | 0x0e)
#define S_laser_COUNTER_FAILED_FRACTION_TEST     (M_laser | 0x0f)
#define S_laser_INVALID_BOOL_VALUE               (M_laser | 0x10)
#define S_laser_BOARD_NOT_INITIALIZED            (M_laser | 0x11)
#define S_laser_NULL_POINTER_ARGUMENT            (M_laser | 0x12)
#define S_laser_PLL_OUT_OF_LOCK                  (M_laser | 0x13)
#define S_laser_INIT_INVALID_NUM_COUNTERS        (M_laser | 0x14)
#define S_laser_ERROR_IN_CLEAR_OR_LOAD           (M_laser | 0x15)
#define S_laser_RETURNING_NULL_CHANNEL_POINTER   (M_laser | 0x16)
#define S_laser_REF_CHANNEL_POINTER_SET_TO_NULL  (M_laser | 0x17)
#define S_laser_ENTERING_CONSTRUCTOR             (M_laser | 0x1001)
#define S_laser_DONE_CONSTRUCTING                (M_laser | 0x1002)
#define S_laser_ENTERING_SOFTINIT                (M_laser | 0x1003)
#define S_laser_INITIALIZED_SOFTLY               (M_laser | 0x1004)
#define S_laser_ENTERING_HARDTINIT               (M_laser | 0x1005)
#define S_laser_INITIALIZED_HARDLY               (M_laser | 0x1006)
#define S_laser_CHECKING_CLOCKS                  (M_laser | 0x1007)
#define S_laser_ENTERING_CHANNEL_INITIALIZE      (M_laser | 0x1008)
#define S_laser_CHANNEL_INITIALIZED              (M_laser | 0x1009)

/* pztMotor Card */
#define S_pztMotor_INIT_INVALID_ARGUMENT                   (M_pztMotor | 0x1)
#define S_pztMotor_BOARD_NOT_INITIALIZED                   (M_pztMotor | 0x2)
#define S_pztMotor_INVALID_PZT                             (M_pztMotor | 0x3)
#define S_pztMotor_INVALID_MOTOR                           (M_pztMotor | 0x4)
#define S_pztMotor_INVALID_VELOCITY                        (M_pztMotor | 0x5)
#define S_pztMotor_INVALID_PRESCALE                        (M_pztMotor | 0x6)
#define S_pztMotor_INVALID_PZT_POSITION                    (M_pztMotor | 0x7)
#define S_pztMotor_INIT_PZT_CONFIGURATION_MISMATCH         (M_pztMotor | 0x8)
#define S_pztMotor_INIT_MOTOR_CONFIGURATION_MISMATCH       (M_pztMotor | 0x9)
#define S_pztMotor_E_INVALID_NUMBER_OF_PZTS                (M_pztMotor | 0x0a)
#define S_pztMotor_E_INVALID_NUMBER_OF_MOTORS              (M_pztMotor | 0x0b)
#define S_pztMotor_INVALID_LIMIT_TYPE                      (M_pztMotor | 0x0c)
#define S_pztMotor_CHANNEL_NOT_INITIALIZED                 (M_pztMotor | 0x0d)
#define S_pztMotor_E_INVALID_NUMBER_OF_LIMITS              (M_pztMotor | 0x0e)
#define S_pztMotor_CHANNEL_NUM_OUT_OF_RANGE                (M_pztMotor | 0x0f)
#define S_pztMotor_PZT_CHANNEL_NUM_OUT_OF_RANGE            (M_pztMotor | 0x10)
#define S_pztMotor_MOTOR_CHANNEL_NUM_OUT_OF_RANGE          (M_pztMotor | 0x11)
#define S_pztMotor_PZT_READBACK_CHANNEL_NUM_OUT_OF_RANGE   (M_pztMotor | 0x12)
#define S_pztMotor_MOTOR_READBACK_CHANNEL_NUM_OUT_OF_RANGE (M_pztMotor | 0x13)
#define S_pztMotor_LIMIT_CHANNEL_NUM_OUT_OF_RANGE          (M_pztMotor | 0x14)
#define S_pztMotor_INVALID_CHANNEL_NUM                     (M_pztMotor | 0x15)
#define S_pztMotor_CALLING_SOFT_INIT                       (M_pztMotor | 0x16)
#define S_pztMotor_ENTERING_CONSTRUCTOR              (M_pztMotor | 0x1000)
#define S_pztMotor_DONE_CONSTRUCTING                 (M_pztMotor | 0x1001)
#define S_pztMotor_ENTERING_SOFTINIT                 (M_pztMotor | 0x1002)
#define S_pztMotor_INITIALIZING_DA_CHANNEL_ARRAY     (M_pztMotor | 0x1003)
#define S_pztMotor_INITIALIZING_MOTOR_CHANNEL_ARRAY  (M_pztMotor | 0x1004)
#define S_pztMotor_INITIALIZING_LIMIT_CHANNEL_ARRAY  (M_pztMotor | 0x1005)
#define S_pztMotor_INITIALIZED_SOFTLY                (M_pztMotor | 0x1006)
#define S_pztMotor_ENTERING_HARDINIT                 (M_pztMotor | 0x1007)
#define S_pztMotor_INITIALIZED_HARDLY                (M_pztMotor | 0x1008)
#define S_pztMotor_ENTERING_RAMP_CHANNEL_CONSTRUCTOR (M_pztMotor | 0x1009)
#define S_pztMotor_DONE_CONSTRUCTING_RAMP_CHANNEL    (M_pztMotor | 0x100a)
#define S_pztMotor_ENTERING_RAMP_CHANNEL_INITIALIZE  (M_pztMotor | 0x100b)
#define S_pztMotor_CALLING_DA_CHANNEL_INITIALIZE     (M_pztMotor | 0x100c)
#define S_pztMotor_DONE_INITIALIZING_RAMP_CHANNEL    (M_pztMotor | 0x100d)
#define S_pztMotor_ENTERING_DA_CHANNEL_CONSTRUCTOR   (M_pztMotor | 0x100e)
#define S_pztMotor_DONE_CONSTRUCTING_DA_CHANNEL      (M_pztMotor | 0x100f)
#define S_pztMotor_ENTERING_DA_CHANNEL_INITIALIZE    (M_pztMotor | 0x1010)
#define S_pztMotor_DONE_INITIALIZING_DA_CHANNEL      (M_pztMotor | 0x1011)
#define S_pztMotor_ENTERING_MOTOR_READBACK_CHANNEL_CONSTRUCTOR (M_pztMotor | 0x1012)
#define S_pztMotor_DONE_CONSTRUCTING_MOTOR_READBACK_CHANNEL    (M_pztMotor | 0x1013)
#define S_pztMotor_ENTERING_MOTOR_READBACK_CHANNEL_INITIALIZE  (M_pztMotor | 0x1014)
#define S_pztMotor_DONE_INITIALIZING_MOTOR_READBACK_CHANNEL    (M_pztMotor | 0x1015)
#define S_pztMotor_ENTERING_MOTOR_CHANNEL_CONSTRUCTOR (M_pztMotor | 0x1016)
#define S_pztMotor_DONE_CONSTRUCTING_MOTOR_CHANNEL    (M_pztMotor | 0x1017)
#define S_pztMotor_ENTERING_MOTOR_CHANNEL_INITIALIZE  (M_pztMotor | 0x1018)
#define S_pztMotor_DONE_INITIALIZING_MOTOR_CHANNEL    (M_pztMotor | 0x1019)
#define S_pztMotor_ENTERING_DI_CHANNEL_CONSTRUCTOR    (M_pztMotor | 0x101a)
#define S_pztMotor_DONE_CONSTRUCTING_DI_CHANNEL       (M_pztMotor | 0x101b)
#define S_pztMotor_ENTERING_DI_CHANNEL_INITIALIZE     (M_pztMotor | 0x101c)
#define S_pztMotor_DONE_INITIALIZING_DI_CHANNEL       (M_pztMotor | 0x101d)

/* MPV955 Board, ChannelBank, and Channel */
#define S_mpv955_CHANNEL_BANK_NOT_INITIALIZED    (M_mpv955 | 0x1)
#define S_mpv955_INVALID_TRIGGER_SELECT_VALUE    (M_mpv955 | 0x2)
#define S_mpv955_INVALID_TRIGGER_TYPE_VALUE      (M_mpv955 | 0x3)
#define S_mpv955_INVALID_SCAN_MODE_VALUE         (M_mpv955 | 0x4)
#define S_mpv955_INVALID_TIMEOUT_VALUE           (M_mpv955 | 0x5)
#define S_mpv955_INVALID_NUMBER_OF_CHANNELS      (M_mpv955 | 0x6)
#define S_mpv955_INVALID_WAVEFORM_SIZE           (M_mpv955 | 0x7)
#define S_mpv955_RETURNING_NULL_CHANNEL_POINTER  (M_mpv955 | 0x8)
#define S_mpv955_ZERO_OR_NEGATIVE_PERIOD         (M_mpv955 | 0x9)
#define S_mpv955_PERIOD_ADJUSTED                 (M_mpv955 | 0xa)
#define S_mpv955_ENTERING_CONSTRUCTOR            (M_mpv955 | 0x1000)
#define S_mpv955_DONE_CONSTRUCTING               (M_mpv955 | 0x1001)
#define S_mpv955_ENTERING_SOFTINIT               (M_mpv955 | 0x1002)
#define S_mpv955_INITIALIZED_SOFTLY              (M_mpv955 | 0x1003)
#define S_mpv955_ENTERING_HARDINIT               (M_mpv955 | 0x1004)
#define S_mpv955_INITIALIZED_HARDLY              (M_mpv955 | 0x1005)
#define S_mpv955_ENTERING_CHANNELBANK_INITIALIZE (M_mpv955 | 0x1006)
#define S_mpv955_CHANNELBANK_INITIALIZED         (M_mpv955 | 0x1007)
#define S_mpv955_ENTERING_CHANNEL_INITIALIZE     (M_mpv955 | 0x1008)
#define S_mpv955_CHANNEL_INITIALIZED             (M_mpv955 | 0x1009)
#define S_mpv955_SETTING_SAMPLE_PERIOD           (M_mpv955 | 0x100a)
#define S_mpv955_SAMPLE_PERIOD_SET               (M_mpv955 | 0x100b)
#define S_mpv955_START_STOP_ADDRESSES_SET        (M_mpv955 | 0x100c)

/* MPV906 Board, ChannelBank, and Channel */
#define S_mpv906_CHANNEL_BANK_NOT_INITIALIZED     (M_mpv906 | 0x1)
#define S_mpv906_CHANNEL_NUMBER_OUT_OF_RANGE      (M_mpv906 | 0x2)
#define S_mpv906_INVALID_GAIN                     (M_mpv906 | 0x3)
#define S_mpv906_INVALID_START_CHANNEL_VALUE      (M_mpv906 | 0x4)
#define S_mpv906_INVALID_SCAN_MODE                (M_mpv906 | 0x5)
#define S_mpv906_INVALID_TRIGGER_SELECT_VALUE     (M_mpv906 | 0x6)
#define S_mpv906_CANNOT_STOP_MPV906_SCAN          (M_mpv906 | 0x7)
#define S_mpv906_INVALID_NUMBER_OF_CHANNELS       (M_mpv906 | 0x8)
#define S_mpv906_ENTERING_CONSTRUCTOR             (M_mpv906 | 0x1001)
#define S_mpv906_DONE_CONSTRUCTING                (M_mpv906 | 0x1002)
#define S_mpv906_ENTERING_SOFTINIT                (M_mpv906 | 0x1003)
#define S_mpv906_INITIALIZED_SOFTLY               (M_mpv906 | 0x1004)
#define S_mpv906_ENTERING_HARDINIT                (M_mpv906 | 0x1005)
#define S_mpv906_INITIALZED_HARDLY                (M_mpv906 | 0x1006)
#define S_mpv906_ENTERING_CHANNELBANK_INITIALIZE  (M_mpv906 | 0x1007)
#define S_mpv906_DONE_INITIALIZING_CHANNELBANK    (M_mpv906 | 0x1008)
#define S_mpv906_ENTERING_CHANNEL_INITIALIZE      (M_mpv906 | 0x1009)
#define S_mpv906_DONE_INITIALIZING_CHANNEL        (M_mpv906 | 0x100a)

/* DVME626 Board, and Channel */
#define S_dvme626_RETURNING_NULL_CHANNEL_POINTER  (M_dvme626 | 0x1)
#define S_dvme626_ENTERING_CONSTRUCTOR            (M_dvme626 | 0x1000)
#define S_dvme626_FINISHED_CONSTRUCTING           (M_dvme626 | 0x1001)
#define S_dvme626_ENTERING_SOFTINIT               (M_dvme626 | 0x1002)
#define S_dvme626_INITIALIZED_SOFTLY              (M_dvme626 | 0x1003)
#define S_dvme626_ENTERING_HARDINIT               (M_dvme626 | 0x1004)
#define S_dvme626_INITIALIZED_HARDLY              (M_dvme626 | 0x1005)
#define S_dvme626_ENTERING_CHANNEL_INITIALIZE     (M_dvme626 | 0x1006)
#define S_dvme626_CHANNEL_INITIALIZED             (M_dvme626 | 0x1007)
#define S_dvme626_INVALID_NUMBER_OF_CHANNELS      (M_dvme626 | 0x1008)

/* MM6216 Board */
#define S_mm6216_MEMORY_SIZE_NOT_4_BYTE_ALIGNED   (M_mm6216 | 0x1)
#define S_mm6216_ENTERING_CONSTRUCTOR             (M_mm6216 | 0x1001)
#define S_mm6216_DONE_CONSTRUCING                 (M_mm6216 | 0x1002)
#define S_mm6216_ENTERING_SOFTINIT                (M_mm6216 | 0x1003)
#define S_mm6216_INITIALIZED_SOFTLY               (M_mm6216 | 0x1004)
#define S_mm6216_ENTERING_HARDINIT                (M_mm6216 | 0x1005)
#define S_mm6216_INITIALZED_HARDLY                (M_mm6216 | 0x1006)

/* VIP640A Board */
#define S_tVip640aFullImageChannel_CHANNEL_ALREADY_INITIALIZED   (M_vip640a | 0x1)
#define S_tVip640aFullImageChannel_CHANNEL_NOT_INITIALIZED       (M_vip640a | 0x2)
#define S_tVip640aFullImageChannel_CHANNEL_CAPTURE_NOT_STARTED   (M_vip640a | 0x3)
#define S_tVip640aFullImageChannel_CHANNEL_CAPTURE_TIMEOUT       (M_vip640a | 0x4)
#define S_tVip640aBoard_BOARD_NOT_INITIALIZED                    (M_vip640a | 0x5)
#define S_tVip640aBoard_RETURNING_NULL_CHANNEL_POINTER           (M_vip640a | 0x6)

/* tImage */
#define S_tImage_BUFFER_SIZE_DOES_NOT_MATCH                      (M_tImage | 0x1)
#define S_tImage_IMAGE_NOT_YET_LOADED                            (M_tImage | 0x2)
#define S_tImage_IMAGE_MEMORY_ALLOCATION_FAILED                  (M_tImage | 0x3)
#define S_tImage_INVALID_DIMENSIONS                              (M_tImage | 0x4)
#define S_tImage_INVALID_POINT                                   (M_tImage | 0x5)
#define S_tImage_DONE_CONSTRUCTING                               (M_tImage | 0x1001)
#define S_tImage_DONE_DESTRUCTING                                (M_tImage | 0x1002)
#define S_tImage_IMAGE_LOADED                                    (M_tImage | 0x1003)
#define S_tImage_RESIZING_IMAGE                                  (M_tImage | 0x1004)
#define S_tImage_IMAGE_COPIED                                    (M_tImage | 0x1005)
#define S_tImage_ENSURING_IMAGE_BUFFER_EXIST                     (M_tImage | 0x1006)

/* IP-QUADRATURE Board */
#define S_ipQuad_INVALID_NUMBER_OF_CHANNELS                      (M_ipQuad | 0x1)
#define S_ipQuad_RETURNING_NULL_CHANNEL_POINTER                  (M_ipQuad | 0x2)
#define S_ipQuad_INVALID_BOARD_NUM                               (M_ipQuad | 0x3)

#define S_ipQuad_ENTERING_CONSTRUCTOR                            (M_ipQuad | 0x1001)
#define S_ipQuad_FINISHED_CONSTRUCTING                           (M_ipQuad | 0x1002)
#define S_ipQuad_ENTERING_SOFTINIT                               (M_ipQuad | 0x1003)
#define S_ipQuad_INITIALIZED_SOFTLY                              (M_ipQuad | 0x1004)
#define S_ipQuad_ENTERING_HARDINIT                               (M_ipQuad | 0x1005)
#define S_ipQuad_INITIALIZED_HARDLY                              (M_ipQuad | 0x1006)
#define S_ipQuad_ENTERING_CHANNEL_INITIALIZE                     (M_ipQuad | 0x1007)
#define S_ipQuad_CHANNEL_INITIALIZED                             (M_ipQuad | 0x1008)

/* IP-16DAC Board, and Channel */
#define S_ip16Dac_INVALID_NUMBER_OF_CHANNELS                     (M_ip16Dac | 0x1)
#define S_ip16Dac_RETURNING_NULL_CHANNEL_POINTER                 (M_ip16Dac | 0x2)
#define S_ip16Dac_INVALID_BOARD_NUM                              (M_ip16Dac | 0x3)
#define S_ip16Dac_INVALID_BOARD_ID                               (M_ip16Dac | 0x4)

#define S_ip16Dac_ENTERING_CONSTRUCTOR                           (M_ip16Dac | 0x1000)
#define S_ip16Dac_FINISHED_CONSTRUCTING                          (M_ip16Dac | 0x1001)
#define S_ip16Dac_ENTERING_SOFTINIT                              (M_ip16Dac | 0x1002)
#define S_ip16Dac_INITIALIZED_SOFTLY                             (M_ip16Dac | 0x1003)
#define S_ip16Dac_ENTERING_HARDINIT                              (M_ip16Dac | 0x1004)
#define S_ip16Dac_INITIALIZED_HARDLY                             (M_ip16Dac | 0x1005)
#define S_ip16Dac_ENTERING_CHANNEL_INITIALIZE                    (M_ip16Dac | 0x1006)
#define S_ip16Dac_CHANNEL_INITIALIZED                            (M_ip16Dac | 0x1007)
#define S_ip16Dac_ENTERING_VERIFIER                              (M_ip16Dac | 0x1008)
#define S_ip16Dac_FINISHED_VERIFYING                             (M_ip16Dac | 0x1009)

#define S_ip16Dac_BOARD_ID                                       (M_ip16Dac | 0x1100)

/* TIM Card */
#define S_tim_BOARD_ALREADY_INITIALIZED                  (M_tim | 0x0001)
#define S_tim_CHANNEL_NOT_INITIALIZED                    (M_tim | 0x0002)
#define S_tim_RETURNING_NULL_CHANNEL_POINTER             (M_tim | 0x0003)
#define S_tim_CREATE_CHANNEL_ATTEMPTED                   (M_tim | 0x0008)
#define S_tim_TIME_IS_JUMPING_BY_MORE_THAN_ONE_SEC       (M_tim | 0x0009)
#define S_tim_NULL_BOARD_POINTER_PASSED_TO_INITIALIZE    (M_tim | 0x000a)
#define S_tim_ENTERING_CONSTRUCTOR                       (M_tim | 0x1001)
#define S_tim_DONE_CONSTRUCTING                          (M_tim | 0x1002)
#define S_tim_ENTERING_SOFTINIT                          (M_tim | 0x1003)
#define S_tim_INITIALIZED_SOFTLY                         (M_tim | 0x1004)
#define S_tim_ENTERING_HARDINIT                          (M_tim | 0x1005)
#define S_tim_INITIALIZED_HARDLY                         (M_tim | 0x1006)

#endif  /* INC_hwErrorh */

