 /* $RCSfile: imageSensor.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/imageSensor.h,v 1.1.1.1 1998/06/11 21:36:12 chara Exp $
*/
/* Derek Slye - Jet Propulsion Laboratory */

#ifndef INC_imageSensorh
#define INC_imageSensorh

#include "isit.h"
#include "imageChannel.h"
#include "ftTypes.h"

class tFtGizmoInfo;
class tImage;
class tFtGizmoInfo;

class tImageSensor {
  public:
    tImageSensor (tFullImageChannel* pFullImageChannel,
                  int iXStart, int iYStart, int iHSizeToUse, int iVSizeToUse);
    ERROR_CODE GetImage (tImage& StarImage);
    ERROR_CODE SetRegionOfInterest (int iXStart, int iYStart);
    void ImageParameters (int &iXStart, int &iYStart, int& iHSize, 
                          int& iVSize) const;
  
  protected:
    tSubImageChannel     ImageChannel;
    int iHSize, iVSize;
};



class tFullFrameSensor {
  public:
    tFullFrameSensor (tFullImageChannel* pFullImageChannelToUse);
    ERROR_CODE StartCapture ();
    ERROR_CODE GetImage (tImage& FullFrameImage);
    ERROR_CODE AtomicGetImage (tImage& FullFrameImage);
    ERROR_CODE Update ();
    void ImageParameters (int& iHSize, int& iVSize);
    
  protected:
    tFullImageChannel *pFullImageChannel;
};

#endif /* INC_imageSensorh */

