
/* $RCSfile: instrumentCdsGizmoInfo.h,v $ */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/include/instrumentCdsGizmoInfo.h,v 1.2 1998/07/13 22:01:17 phil Exp $
*/
/* Richard Johnson - Jet Propulstion Laboratory */
 
/*
modification history
--------------------
04a,2Sept97,rlj      written
*/

#include "isit.h"
#include "gizmoInfo.h"
#include "hwTypes.h"
#include "board.h"
 
 
/*******
Instrument Gizmo Info


[[D tInstrumentCDSGizmoInfo::tInstrumentCDSGizmoInfo (int iRteIdToUse,
        int iGizmoIdToUse) ]
[ invalid_pointer (this) => UNDEFINED
| true => 
    this->iRteId := iRteIdToUse
    : this->iGizmoId := iGizmoIdToUse
    : this->gtType := GT_INSTRUMENT
]]

[[D tInstrumentCDSGizmoInfo::~tInstrumentCDSGizmoInfo (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tInstrumentCDSGizmoInfo::GetManualTargetId (int iWhichDl) ]
[ invalid_pointer (this) ||
  iWhichDl valid delay line number => UNDEFINED
| true => return appropriate tIpcDoubleBufferId for manual target
]]

[[D tInstrumentCDSGizmoInfo::GetOpenLoopTargetId (int iWhichDl) ]
[ invalid_pointer (this) ||
  iWhichDl valid delay line number => UNDEFINED
| true => return appropriate tIpcDoubleBufferId for open loop target
]]
*********/

class tIpcDblBufferId;

class tInstrumentCDSGizmoInfo : public tGizmoInfo {
  public:
    tInstrumentCDSGizmoInfo (int iRteId,int iGizmoId,
                             const BOARD_NAME bnClockBoardToUse);
    virtual ~tInstrumentCDSGizmoInfo ();

    const tIpcDblBufferId& GetManualTargetId (int iWhichDl) const;
    const tIpcDblBufferId& GetOpenLoopTargetId (int iWhichDl) const;
    tClockBoard *pClockBoard;
};  
 
