/* $RCSfile: int64.h,v $ */
/* this file contains class definitions for signed and unsigned 64bit integers*/
/* CM Info:
   $Header: /home/chara/cvsroot/ople/sys/include/int64.h,v 1.1.1.1 1998/06/11 21:36:12 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */

/* modification history:
------------------------
10/17/96 - added intended functions
10/10/96 - added conditional compilation directives
10/4/96 - written

*/

#ifndef INC_int64
#define INC_int64
//#include <iostream.h>
//#include "isit.h"

//typedef unsigned long int uint32_t;

class int64_t;

class uint64_t {
  public:

// constructors and destructor

           /* 
	   [ this invalid -> UNDEFINED
	   | true -> *this.value := 0 ]
	   */
	 
         uint64_t() {value = 0;};

           /* 
           [ this or uint64 invalid -> UNDEFINED
	   | true -> *this.value := uint64.value ]
	   */	
	 uint64_t(const uint64_t &uint64) {value = uint64.value;};

           /* 
	   [ this invalid -> UNDEFINED
	   | true -> this := NULL ]
	   */
	 ~uint64_t(){};

	   /*
	   [ this invalid -> UNDEFINED
	   | true -> *this.value := ulli ]
	   */
	 uint64_t (unsigned long long int ulli) { value = ulli;};

	   /*
	   [ this invalid -> UNDEFINED
	   | true -> *this.value := hi << 32 + lo ]
	   */
	 uint64_t (uint32_t hi, uint32_t lo) {
	   value = ((unsigned long long int)hi << 32) | lo; };

// type cast operators

           /* 
	   [ this invalid -> UNDEFINED
	   | true -> return *this.value]
	   */
      	 operator int64_t();
	 
         operator double () {return (double) value;};
       
// assignment operators

           /* 
	   [ this or &uint64 invalid -> UNDEFINED 
	   | true -> *this.value := uint64.value ]
	   */
         void operator= (const uint64_t &uint64) {
		value = uint64.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 + op2 ]
	   */
	 friend uint64_t operator+= (uint64_t &op1,uint64_t &op2) {
		return op1.value += op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 - op2 ]
	   */
	 friend uint64_t operator-= (uint64_t &op1,uint64_t &op2) {
		return op1.value -= op2.value;};
           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 * op2 ]
	   */
	 friend uint64_t operator*= (uint64_t &op1,uint64_t &op2) {
		return op1.value *= op2.value;};
           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 / op2 ]
	   */
	 friend uint64_t operator/= (uint64_t &op1,uint64_t &op2) {
		return op1.value /= op2.value;};
           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 modulo op2 ]
	   */
	 friend uint64_t operator%= (uint64_t &op1,uint64_t &op2) {
		return op1.value %= op2.value;};
           /* 
	   [  &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 & op2 ]
	   */
	 friend uint64_t operator&= (uint64_t &op1,uint64_t &op2) {
		return op1.value &= op2.value;};
           /* 
	   [ &op1 or &op2 invalid ->UNDEFINED 
	   | true -> op1 := op1 | op2 ]
	   */
	 friend uint64_t operator|= (uint64_t &op1,uint64_t &op2) {
		return op1.value |= op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 XOR op2 ]
	   */
	 friend uint64_t operator^= (uint64_t &op1,uint64_t &op2) {
		return op1.value ^= op2.value;};

           /* 
	   [ &op1 invalid -> UNDEFINED 
	   | true -> op1 := op1 << ui ]
	   */
         friend uint64_t operator<<= (uint64_t &op1,unsigned int ui) {
		return op1.value <<= ui;};

           /* 
	   [ &op1 invalid -> UNDEFINED 
	   | true -> op1 := op1 >> ui ]
	   */
	 friend uint64_t operator>>= (uint64_t &op1,unsigned int ui) {
		return op1.value >>= ui;};

// arithmetic operators

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 + op2 ]
	   */
	 friend uint64_t operator+ (uint64_t &op1,uint64_t &op2) {
		return op1.value + op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 - op2 ]
	   */
	 friend uint64_t operator- (uint64_t &op1,uint64_t &op2) {
		return op1.value - op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 * op2 ]
	   */
	 friend uint64_t operator* (uint64_t &op1,uint64_t &op2) {
		return op1.value * op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 / op2 ]
	   */
	 friend uint64_t operator/ (uint64_t &op1,uint64_t &op2) {
		return op1.value / op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 % op2 ]
	   */
	 friend uint64_t operator% (uint64_t &op1,uint64_t &op2) {
		return op1.value % op2.value;};

           /* 
	   [ &op1 invalid -> UNDEFINED 
	   | true -> return op1 + 1 ]
	   */
	 friend uint64_t operator++ (uint64_t &op1) {
		 return ++op1.value;}

           /* 
	   [ &op1 invalid -> UNDEFINED 
	   | true -> return op1 - 1]
	   */
	 friend  uint64_t operator--(uint64_t &op1) {
		 return --op1.value;}

// conditional operators

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 == op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator== (uint64_t &op1,uint64_t &op2) {
		return (op1.value == op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 != op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator!= (uint64_t &op1,uint64_t &op2) {
		return (op1.value != op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 < op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator< (uint64_t &op1,uint64_t &op2) {
		return (op1.value < op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 > op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator> (uint64_t &op1,uint64_t &op2) {
		return (op1.value > op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 <= op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator<= (uint64_t &op1,uint64_t &op2) {
		return (op1.value <= op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 >= op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator>= (uint64_t &op1,uint64_t &op2) {
		return (op1.value >= op2.value);};

// bitwise operators

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 & op2 ]
	   */
	 friend uint64_t operator& (uint64_t &op1,uint64_t &op2) {
		return (op1.value & op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 XOR op2 ]
	   */
	 friend uint64_t operator^ (uint64_t &op1,uint64_t &op2) {
		return (op1.value^op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 | op2 ]
	   */
	 friend uint64_t operator| (uint64_t &op1,uint64_t &op2) {
		return (op1.value | op2.value);};

	   /*
	   [ &op1 invalid -> UNDEFINED 
	   | true -> return !op1]
	   */
	 friend uint64_t operator! (uint64_t &op1) {
		return !op1.value;};

	   /*
	   [ &op1 invalid  -> UNDEFINED 
	   | true -> return op1 << ui ]
	   */
	 friend uint64_t operator<< (uint64_t &op1,unsigned int ui) {
		return op1.value << ui;}

	   /*
	   [ &op1 invalid  -> UNDEFINED 
	   | true -> return op1 >> ui ]
	   */
	 friend uint64_t operator>> (uint64_t &op1, unsigned int ui) {
		return op1.value >> ui;};
	
// stream operators
    
	   /*
	   [ &stream or &uint64 invalid -> UNDEFINED 
	   | true -> 
	       : stream := stream + uint64
	       : return stream]
	   */
	// friend ostream &operator<< (ostream &stream,uint64_t &uint64) {
	//	stream << uint64.value; return stream;};

	   /*
	   [ &stream or &uint64 invalid -> UNDEFINED 
	   | true ->
	       : uint64 := stream head
	       : stream := stream - stream head
	       : return stream ]
	   */
	// friend istream &operator>> (istream &stream, uint64_t &uint64) {
	//	stream >> uint64.value; return stream; };
  protected:
    unsigned long long int value;
};


class int64_t {
  public:
// contstructors and destructors

           /* 
	   [ this invalid -> UNDEFINED
	   | true -> *this.value := 0 ]
	   */
	 int64_t() {value = 0;};

           /* 
           [ this or uint64 invalid -> UNDEFINED
	   | true -> *this.value := uint64.value ]
	   */	 
	 int64_t(const int64_t &int64) {value = int64.value;};

           /* 
	   [ this invalid -> UNDEFINED
	   | true -> this := NULL ]
	   */
	 ~int64_t(){};

           /*
	   [ this invalid -> UNDEFINED
	   | true -> *this.value := lli ]
	   */
	 int64_t (long long int lli) { value = lli;};

	   /*
	   [ this invalid -> UNDEFINED
	   | true -> *this.value := hi << 32 + lo ]
	   */
	 int64_t (uint32_t hi, uint32_t lo) {
	   value = ((long long int)hi <<  32) | lo; };

// type cast operator
           /* 
	   [ this invalid -> UNDEFINED
	   | true -> return *this.value converted from unsigned int to int]
	   */
	 operator uint64_t() {return value;};

         operator double() { return (double) value;};

// assignment operators
           /* 
	   [ this or &int64 invalid -> UNDEFINED 
	   | true -> *this.value := int64.value ]
	   */
         void operator= (const int64_t &int64) {
	        value = int64.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 + op2 ]
	   */
	 friend int64_t operator+= (int64_t &op1,int64_t &op2) {
		return op1.value += op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 - op2 ]
	   */
	 friend int64_t operator-= (int64_t &op1,int64_t &op2) {
		return  op1.value -= op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 * op2 ]
	   */
	 friend int64_t operator*= (int64_t &op1,int64_t &op2) {
		return op1.value *= op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 / op2 ]
	   */
	 friend int64_t operator/= (int64_t &op1,int64_t &op2) {
		return op1.value /= op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 modulo op2 ]
	   */
	 friend int64_t operator%= (int64_t &op1,int64_t &op2) {
		return op1.value %= op2.value;};

           /* 
	   [  &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 & op2 ]
	   */
	 friend int64_t operator&= (int64_t &op1,int64_t &op2) {
		return op1.value &= op2.value;};

           /* 
	   [ &op1 or &op2 invalid ->UNDEFINED 
	   | true -> op1 := op1 | op2 ]
	   */
	 friend int64_t operator|= (int64_t &op1,int64_t &op2) {
		return op1.value |= op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> op1 := op1 XOR op2 ]
	   */
	 friend int64_t operator^= (int64_t &op1,int64_t &op2) {
		return op1.value ^= op2.value;};

           /* 
	   [ &op1 invalid -> UNDEFINED 
	   | true -> op1 := op1 << ui ]
	   */
         friend int64_t operator<<= (int64_t &op1,unsigned int ui) {
		return op1.value <<= ui;};

           /* 
	   [ &op1 invalid -> UNDEFINED 
	   | true -> op1 := op1 >> i ]
	   */
	 friend int64_t operator>>= (int64_t &op1,unsigned int ui) {
		return op1.value >>= ui;};

// arithmetic operators

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 + op2 ]
	   */
	 friend int64_t operator+ (int64_t &op1,int64_t &op2) {
		return op1.value + op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 - op2 ]
	   */
	 friend int64_t operator- (int64_t &op1,int64_t &op2) {
		return op1.value - op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 * op2 ]
	   */
	 friend int64_t operator* (int64_t &op1,int64_t &op2) {
		return  op1.value * op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 / op2 ]
	   */
	 friend int64_t operator/ (int64_t &op1,int64_t &op2) {
		return op1.value / op2.value;};

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 % op2 ]
	   */
	 friend int64_t operator% (int64_t &op1,int64_t &op2) {
		return op1.value % op2.value;};

           /* 
	   [ &op1 invalid -> UNDEFINED 
	   | true -> return op1 + 1 ]
	   */
	 friend int64_t operator++ (int64_t &op1) {
		 return  ++op1.value;}

           /* 
	   [ &op1 invalid -> UNDEFINED 
	   | true -> return op1 - 1]
	   */
	 friend  int64_t operator--(int64_t &op1) {
		 return --op1.value;}

// conditional operators

           /* 
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 == op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator== (int64_t &op1,int64_t &op2) {
		return (op1.value == op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 != op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator!= (int64_t &op1,int64_t &op2) {
		return (op1.value != op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 < op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator< (int64_t &op1,int64_t &op2) {
		return (op1.value < op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 > op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator> (int64_t &op1,int64_t &op2) {
		return (op1.value > op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 <= op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator<= (int64_t &op1,int64_t &op2) {
		return (op1.value <= op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | op1 >= op2 -> return 1
	   | true -> 0) ]
	   */
	 friend int operator>= (int64_t &op1,int64_t &op2) {
		return (op1.value >= op2.value);};

// bitwise operators
	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 & op2 ]
	   */
	 friend int64_t operator& (int64_t &op1,int64_t &op2) {
		return (op1.value & op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 XOR op2 ]
	   */
	 friend uint64_t operator^ (int64_t &op1,int64_t &op2) {
		return (op1.value^op2.value);};

	   /*
	   [ &op1 or &op2 invalid -> UNDEFINED 
	   | true -> return op1 | op2 ]
	   */
	 friend int64_t operator| (int64_t &op1,int64_t &op2) {
		return (op1.value | op2.value);};

	   /*
	   [ &op1 invalid -> UNDEFINED 
	   | true -> return !op1]
	   */
	 friend int64_t operator! (int64_t &op1) {
		return !op1.value;};

	   /*
	   [ &op1 invalid  -> UNDEFINED 
	   | true -> return op1 << ui ]
	   */
	 friend int64_t operator<< (int64_t &op1,unsigned int ui) {
		return op1.value << ui;}

	   /*
	   [ &op1 invalid  -> UNDEFINED 
	   | true -> return op1 >> ui ]
	   */
	 friend int64_t operator>> (int64_t &op1, unsigned int ui) {
		return op1.value >> ui;};

// stream operators

	   /*
	   [ &stream or &uint64 invalid -> UNDEFINED 
	   | true -> 
	       : stream := stream + int64
	       : return stream]
	   */
	// friend ostream &operator<< (ostream &stream,int64_t &int64) {
	//	stream << int64.value; return stream;};

	   /*
	   [ &stream or &int64 invalid -> UNDEFINED 
	   | true ->
	       : int64 := stream head
	       : stream := stream - stream head
	       : return stream ]
	   */
	// friend istream &operator>> (istream &stream, int64_t &int64) {
	//	stream >> int64.value; return stream; };
  protected:
    long long int value;
};

// type cast operator

  /* 
  [ this invalid -> UNDEFINED
  | true -> return *this.value converted from int to unsigned int]
  */
inline uint64_t::operator int64_t() { return value;};

#endif









