/* $RCSfile: ipcError.h,v $  */
/* $Header: /home/chara/cvsroot/ople/sys/include/ipcError.h,v 1.1.1.1 1998/06/11 21:36:12 chara Exp $ */
/*
modification history
--------------------
01a,16Jun97,rlj    written
*/

#ifndef INC_ipc2Errorh
#define INC_ipc2Errorh

#include "rtModNum.h"

//ERRORS
#define S_ipc_CANT_CREATE_LOCAL_MEMORY_POOL        (M_ipc | 0x1)
#define S_ipc_CANT_CREATE_SHARED_MEMORY_POOL       (M_ipc | 0x2)
#define S_ipc_CANT_CREATE_TOKEN_CLIENT             (M_ipc | 0x3 )
#define S_ipc_UNKNOWN_MEMORY_TYPE                  (M_ipc | 0x4)
#define S_ipc_CANT_ALLOCATE_LOCAL_OBJECT           (M_ipc | 0x5)
#define S_ipc_CANT_ALLOCATE_SHARED_MEMORY_OBJECT   (M_ipc | 0x6)
#define S_ipc_INSUFFICIENT_LOCAL_MEMORY            (M_ipc | 0x7)
#define S_ipc_INSUFFICIENT_SHARED_MEMORY           (M_ipc | 0x8)
#define S_ipc_LOCAL_MEMORY_NOT_INITIALIZED         (M_ipc | 0x9)
#define S_ipc_OBJECT_MISMATCH                      (M_ipc | 0xa)
#define S_ipc_TOKEN_SERVER_SPAWN_FAILED            (M_ipc | 0xb)
#define S_ipc_UNTYPED_GET_INTERNAL_ERROR           (M_ipc | 0xc)
#define S_ipc_MULTI_TYPE_FIFO_GET_NO_DATA          (M_ipc | 0xd)
#define S_ipc_INTERNAL_PUT_ERROR		   (M_ipc | 0xe)
#define S_ipc_OBJECT_NOT_ENABLED		   (M_ipc | 0xf)
#define S_ipc_UNSUPPORTED_GET_OPERATION            (M_ipc | 0x10)
#define S_ipc_UNSUPPORTED_PUT_OPERATION            (M_ipc | 0x11)

//WARNINGS

#define S_ipc_BUFFER_EMPTY                         (M_ipc | 0x1001)
#define S_ipc_FIFO_EMPTY                           (M_ipc | 0x1002)
#define S_ipc_FIFO_FULL                            (M_ipc | 0x1003)
#define S_ipc_TOO_FEW_ELEMENTS_IN_FIFO             (M_ipc | 0x1004)
#define S_ipc_TOO_MANY_ELEMENTS_IN_FIFO            (M_ipc | 0x1005)
#define S_ipc_LOCAL_MEMORY_ALREADY_INTIALIZED      (M_ipc | 0x1006)
#define S_ipc_SHUTTING_DOWN_MEMORY                 (M_ipc | 0x10007)

//MESSAGES

#define S_object_CREATING_ATOM                     (M_ipc | 0x2001)
#define S_object_CREATING_DOUBLE_BUFFER            (M_ipc | 0x2002)
#define S_object_CREATING_FIFO                     (M_ipc | 2003)

#define S_ipc_LOCAL_OBJECT_ALLOCATE_START          (M_ipc | 0x2004)
#define S_ipc_LOCAL_OBJECT_ALLOCATE_DONE           (M_ipc | 0x2005)
#define S_ipc_SHARED_OBJECT_ALLOCATE_START         (M_ipc | 0x2006)
#define S_ipc_SHARED_OBJECT_ALLOCATION_DONE        (M_ipc | 0x2007)


#endif INC_ipc2Errorh 
