/* $RCSfile: ipcFifoAccessor.h,v $ */
/* $Header: /home/chara/cvsroot/ople/sys/include/ipcFifoAccessor.h,v 1.2 1998/08/17 21:01:15 phil Exp $ */

#ifndef INC_ipcFifoAccessorh
#define INC_ipcFifoAccessorh

#include "isit.h"
#include "ipcid.h"
#include "ipcError.h"
#include "ipcObjectAccessor.h"
#include "ipcFifo.h"


/****************************************************************************

tIpcFifoAccessor Black Box State

BOOL        bInit
ERROR_CODE  ecInitError
tIpcFifoId iiFifoId

------------------------------------------------------------------------------
[[D tIpcFifoAccessor::tIpcFifoAccessor (const tIpcFifoId &iiId) ]
[ invalid_pointer (this) || 
  ::IpcMemoryG.bInit == FALSE => UNDEFINED
| CanAllocateIpcObject (::IpcMemoryG,iiId) == FALSE => 
    this->ecInitError:=appropriate error code
    : this->bInit := anything
    : console := console + appropriate messages
    : this->bObjectValid := FALSE
    : this->iiFifoId := anything
| true =>
    this->ecInitError := OK
    : this->bInit := TRUE
    : this->bObjectValid := TRUE
    : this->iiFifoId := iiId
    : ::IpcMemoryG.ObjectSet := ::IpcMemoryG U 
      NewObjectSet (::IpcMemoryG, iiId)
]]

[[D tIpcFifoAccessor::~tIpcFifoAccessor (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tIpcFifoAccessor::Get (tDataType &DataOut) ]
[ invalid_pointer (this) || 
  invalid_reference (DataOut) ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG, this->iiObjectId) == FALSE ||
  simultaneous Get or GetSeveral on GetObject (::IpcMemoryG, 
    this->iiFifoId) => UNDEFINED
| this->bInit == FALSE => return := appropriate error code
| GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue.Length == 0 => 
    return := S_ipc_FIFO_EMPTY
| true =>
    DataOut := front element of 
      GetObject (::IpcMemoryG, this->ObjectId)->dtQueue
    : GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue := 
      GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue 
      with front element removed
    : return := OK 
]]

[[D tIpcFifoAccessor::GetSeveral (tDataType *pDataOutArray, int iNumElements) ]
[ invalid_pointer (this) || 
  DataOutArray is invalid ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG, this->iiObjectId) == FALSE ||
  simultaneous Get or GetSeveral on 
    GetObject (::IpcMemoryG, this->iiFifoId)=> UNDEFINED
| this->bInit == FALSE => return := appropriate error code
| GetObject (::IpcMemoryG.ObjectSet, 
    this->iiFifoId)->dtQueue.Length < 
  iNumElements => return := S_ipc_TOO_FEW_ELEMENTS_IN_FIFOS
| true =>
    DataOutArray[] := first iNumElements elements from front of  
      GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue
    : GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue := 
      GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue with 
      first iNumElements element removed
    : return := OK 
]]

    
[[D tIpcFifoAccessor::Put (const tDataType &DataIn) ]
[ invalid_pointer (this) || 
  invalid_reference (DataIn) ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG,
    this->iiObjectId) == FALSE ||
  simultaneous Put or PutSeveral on 
    GetObject (::IpcMemoryG, this->iiFifoId)=> UNDEFINED
| this->bInit == FALSE => return := appropriate error code
| GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue.Length == 
  GetObject (::IpcMemoryG, this->iiFifoId)->iFifoDepth => 
    return := S_ipc_FIFO_FULL
| true => 
    GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue := 
      GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue 
      with DataIn appended to back
    : return := OK 
]]
 

[[D tIpcFifoAccessor::PutSeveral (tDataType *pDataInArray, int iNumElements) ]
[ invalid_pointer (this) || 
  DataInArray is invalid ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG, this->iiObjectId) == FALSE ||
  simultaneous Put or PutSeveral or flush on 
    GetObject (::IpcMemoryGt, this->iiDblFifoId)=> UNDEFINED
| this->bInit == FALSE => return := appropriate error code
| GetObject (::IpcMemoryG, this->iiFifoId)->iFifoDepth -
  GetObject (::IpcMemoryGt, this->iiFifoId)->dtQueue.Length < iNumElements => 
      return := S_ipc_TOO_MANY_ELEMENTS_IN_FIFO
| true => 
    GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue :=
      GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue 
        with iNumElements elements of DataInArray[] appended to back
    : return := OK 
]]

[[D tIpcFifoAccessor::IsEmpty (void) ]
[ invalid_pointer (this) ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG, this->iiObjectId) == FALSE => UNDEFINED
| GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue.Length == 0 => 
    return := TRUE
| true => return := FALSE
]]

[[D tIpcFifoAccessor::IsFull (void) ]
[ invalid_pointer (this) ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG, this->iiObjectId) == FALSE => UNDEFINED
| GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue.Length == 
  GetObject (::IpcMemoryG, this->iiFifoId)->iFifoDepth => return := TRUE
| true => return := FALSE
]]

[[D tIpcFifoAccessor::ElementsFree (void) ]
[ invalid_pointer (this) ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG, this->iiObjectId) == FALSE => UNDEFINED
| true => return := GetObject (::IpcMemoryG, this->iiFifoId)->iFifoDepth -
    GetObject (::IpcMemoryG, this->iiFifoId)->dtQueue.Length 
]]
 
[[D tIpcFifoAccessor::Flush (void) ]
[ invalid_pointer (this) ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG, this->iiObjectId) == FALSE ||
  simultaneous Put or PutSeveral on 
    GetObject (::IpcMemoryG, this->iiFifoId)=> UNDEFINED
| this->bInit == FALSE => return := appropriate error code
| true =>
    GetObject (::IpcMemoryG, this->ObjectId)->dtQueue := Empty queue
    : return := OK
]]

********************************************************/

template <class tDataType> class tIpcFifoAccessor : public tIpcObjectAccessor<tDataType> {
  public:
    tIpcFifoAccessor (const tIpcFifoId &iiId);
    virtual ~tIpcFifoAccessor ();
    virtual ERROR_CODE Get (tDataType &DataOut);
    ERROR_CODE GetSeveral (tDataType *pDataOutArray, int iNumElements);
    virtual ERROR_CODE Put (const tDataType &DataIn);
    ERROR_CODE PutSeveral (const tDataType *pDataInArray, int iNumElements);
    ERROR_CODE Flush ();
    BOOL IsEmpty () const;
    BOOL IsFull () const;
    virtual BOOL IsOk () const;
    unsigned int ElementsFree () const;
    int Length () const;
  protected:
    volatile tIpcFifo<tDataType> *vFifo;
};


/*******************************
Template Method Definitions
********************************/

/**************************************************************
Representation Mapping

StateBox 					    Black Box

invalid_pointer (::pThisRteG)                       ::IpcMemory.bInit := FALSE
invalid_pointer (::pThisRteG->Ipc.pLocalMemory)     ::IpcMemory.bInit := FALSE
invalid_pointer (::pThisRteG->Ipc.pSharedMemory)    ::IpcMemory.bInit := FALSE
invalid_pointer (::pThisRteG->Ipc.pTokenClient)     ::IpcMemory.bInit := FALSE
::pThisRteG->Ipc.pSharedMemory::GlobalInit(..)      ::IpcMemory.bInit := FALSE
  not executed    

this->vFifo                      this->iiFifoId
invalid_pointer (this->Fifo )    this->bValidObject == FALSE || DoesObjectExist (..) == FALSE 
this->vFifo->iFifoDepth          GetObject (...)->iFifoDepth
this->vFifo->iFree               GetObject (...)->iFifoDepth - GetObject (...)->dtQueue.Length
this->vFifo->iFront              front element of GetObject (...)->dtQueue
this->vFifo->iBack               back of GetObject (...)->dtQueue
this->vFifo->dtQueueStart	 GetObject (...)->dtQueue
this->ecInitError		 this->ecInitError
this->bInit		         this->bInit


		
******************************************************************************
			tIpcFifoAccessor Method Definitions
******************************************************************************/

/****
[[U tIpcFifoAccessor::tIpcFifoAccessor(iiId) ]]
****/
template <class tDataType> tIpcFifoAccessor<tDataType>:: 
  tIpcFifoAccessor (const tIpcFifoId &iiId) : 
  
  /****
  [[U tIpcObjectAccessor::tIpcObjectAccessor(void) ]]
  ****/
  tIpcObjectAccessor<tDataType> () 
{
    ERROR_CODE ec;
       
    /****
    [[U this->vFifo := tIpcFifo::operator_new (appropriate_size,iiId,this->ecInitError)]]

    [[U this->vFifo->tIpcFifo::tIpcFifo(iiId.Depth() )]]
    ****/
    this->vFifo = 
      new (iiId,ec) tIpcFifo<tDataType> (iiId.Depth() );

    this->SetInitError(ec);
    
}


/****
[[U tIpcFifoAccessor::~tIpcFifoAccessor(void) ]]
****/
template <class tDataType> tIpcFifoAccessor<tDataType>:: 
  ~tIpcFifoAccessor () {
  
  /****
  [[U tIpcObjectAccessor::~tIpcObjectAccessor(void) ]]
  ****/
}

/****
[[U tIpcFifoAccessor::Get(DataOut) ]]
****/
template <class tDataType> ERROR_CODE tIpcFifoAccessor<tDataType>::
  Get(tDataType &DataOut) {
  
  if (tBaseObject::IsInit () == TRUE) {
  
    /****
    [[U return := this->vFifo.tIpcFifo::Get(DataOut) ]]
    ****/
    return this->vFifo->Get(DataOut);
  }
  
  else return S_ipc_OBJECT_NOT_ENABLED;
}

/****
[[U tIpcFifoAccessor::GetSeveral(pDataOutArray,iNumElements) ]]
****/
template <class tDataType> ERROR_CODE tIpcFifoAccessor<tDataType>::
  GetSeveral (tDataType *pDataOutArray, int iNumElements) {
  
  if (tBaseObject::IsInit () == TRUE) {
   
    /****
    [[U return := this->vFifo.tIpcFifo::GetSeveral(pDataOutArray,iNumElements) ]]
    ****/
    return this->vFifo->GetSeveral(pDataOutArray,iNumElements);
  }
  
  else return S_ipc_OBJECT_NOT_ENABLED;
}

/****
[[U tIpcFifoAccessor::Put(DataIn) ]]
****/
template <class tDataType> ERROR_CODE tIpcFifoAccessor<tDataType>:: 
  Put(const tDataType &DataIn) {

  if (tBaseObject::IsInit () == TRUE) {  
  
    /****
    [[U return := this->vFifo.tIpcFifo::Put(DataIn) ]]
    ****/
    return this->vFifo->Put (DataIn);
  }
  
  else return S_ipc_OBJECT_NOT_ENABLED;
}


/****
[[U tIpcFifoAccessor::PutSeveral(pDataInArray, iNumElements) ]]
****/
template <class tDataType> ERROR_CODE tIpcFifoAccessor<tDataType>::
  PutSeveral(const tDataType *pDataInArray, int iNumElements)  {

  if (tBaseObject::IsInit () == TRUE) {
  
    /****
    [[U return := this-vFifo.tIpcFifo::PutSeveral(pDataInArray,iNumElements) ]]
    ****/
    return this->vFifo->PutSeveral(pDataInArray,iNumElements);
  }
  
  else return S_ipc_OBJECT_NOT_ENABLED;
}

/****
[[U tIpcObjectAccessor::IsOk(void) ]]
****/
template <class tDataType> BOOL tIpcFifoAccessor<tDataType>::IsOk () const {
  return (this->vFifo != NULL);
}


/****
[[U tIpcFifoAccessor::IsEmpty(void) ]]
****/
template <class tDataType> BOOL tIpcFifoAccessor<tDataType>::IsEmpty () const {


  /****
  [[U return := this->vFifo.tIpcFifo::IsEmpty(void) ]]
  ****/
  return ( this->vFifo->IsEmpty() );
}

/****
[[U tIpcFifoAccessor::IsFull(void) ]]
****/
template <class tDataType> BOOL tIpcFifoAccessor<tDataType>::IsFull () const {

  /****
  [[U return := this->vFifo.tIpcFifo::IsFull(void) ]]
  ****/
  return ( this->vFifo->IsFull() );
}

template <class tDataType> unsigned int tIpcFifoAccessor<tDataType>::
  ElementsFree () const {

  return (this->vFifo->ElementsFree () );
}


template <class tDataType> int tIpcFifoAccessor<tDataType>::
  Length () const {

  return (this->vFifo->Length () );
}



/****
[[U tIpcFifoAccessor::Flush (void) ]]
****/
template <class tDataType> ERROR_CODE tIpcFifoAccessor<tDataType>::Flush () {

  if (tBaseObject::IsInit () == TRUE) {
  
    /****
    [[U this->vFifo->tIpcFifo::Flush (void) ]]
    ****/
    return (this->vFifo->ElementsFree () );
  }
  else return S_ipc_OBJECT_NOT_ENABLED;

}



#endif INC_ipcFifoAccessorh





