/* $RCSfile: ipcIndirectionDblBuffer.h,v $ - Header file for class tIpcIndirectionDblBuffer */

/*
$Header: /home/chara/cvsroot/ople/sys/include/ipcIndirectionDblBuffer.h,v 1.1.1.1 1998/06/11 21:36:12 chara Exp $
*/

#ifndef INC_ipcIndirectionDblBufferh
#define INC_ipcIndirectionDblBufferh

#include "ipcDblBuffer.h"
#include "ipcMemPointer.h"

/** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **
*
* Header file for RICST.  This file define the following classes:
*
* tIpcIndirectionDblBuffer
*
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **/

// Foward declaration
class tBuffer;

/*****************************************************************************************
class tIpcIndirectionDblBuffer

DESCRIPTION:
   tIpcIndirectionDblBuffer is a class for passing objects derived from tBuffer accross IPC.
  
METHODS:
  tIpcIndirectionDblBuffer::tIpcIndirectonDblBuffer (tIpcElementId &iiId1, tIpcElementId &iiId2);
     Contructor for tIpcIndirectionDblBuffer.

[[D tIpcIndirectionDblBuffer::tIpcIndirectionDblBuffer (const tIpcIndirectionDblBufferId &iiId) ]
[ invalid_pointer (this) ||
  invalid_reference (iiId) ||
  ::IpcMemoryG.bInit == FALSE => UNDEFINED
| CanAllocateIpcObject (::IpcMemoryG, Id for Buffer1) == FALSE ||
  CanAllocateIpcObject (::IpcMemoryG, Id for Buffer2) == FALSE => 
    ecErrCode := appropriate error code
    : appropriate messages printed on console
    : this->iiIndirectionDblBuffer1Id := anything
    : this->iiIndirectionDblBuffer2Id := anything
| true =>
    ecErrCode := OK
    : ::IpcMemoryG.ObjectSet := ::IpcMemoryG.ObjectSet U 
      NewObjectSet (::IpcMemoryG, Id for Buffer1) U 
      NewObjectSet (::IpcMemoryG, Id for Buffer2)
    : this->dtBuffer := address of the buffer
    : this->bEmpty := TRUE
    : this->iiIndirecctionDblBuffer1Id := iiId1
    : this->iiIndirecctionDblBuffer2Id := iiId2
]]

  ERROR_CODE tIpcIndirectionDblBuffer::Get (tBuffer &OutBuffer);
     This method gets data from the current read buffer in the IPC memory area and 
     puts it into the buffer class using the tBuffer method Put.

[[D tIpcIndirectionDblBuffer::Get (tBuffer& DataOut) ]
[ invalid_pointer (this) ||
  invalid_reference (DataOut) => UNDEFINED
| this->bEmpty == TRUE => return S_ipc_BUFFER_EMPTY
| this->szBufferSize != DataOut.szBufferSize => return := appropriate error code
| true =>
    DataOut.Buffer := this->Buffer
    : return := OK
]]

  ERROR_CODE tIpcIndirectionDblBuffer::Put (const tBuffer &InBuffer);
     This method puts data into the IPC memory area that is not current set for read
     and then sets the new data to be the current read buffer.

[[D tIpcIndirectionDblBuffer::Put (const tBuffer& DataIn) ]
[ invalid_pointer (this) ||
  invalid_reference (DataIn) => UNDEFINED
| this->szBufferSize != DataIn.szBufferSize => return := appropriate error code
| true =>
    this->Buffer := DataIn.Buffer
    : return := OK
]]     

  void* tIpcIndirectionDblBuffer::operator new (size_t szSize, 
                                  const tIpcInderectionDblBufferId &iiId, 
                                  ERROR_CODE& ecErrCode);
     Operator for making a new tIpcIndirectionDblBuffer.

[[D tIpcIndirectionDblBuffer::operator_new (
    const tIpcDblBufferId &iiId, ERROR_CODE &ecErrCode) ]
[ invalid_reference (iiId) ||
  ::IpcMemoryG.bInit == FALSE => UNDEFINED
| CanAllocateIpcObject (::IpcMemoryG, iiId) == FALSE => 
    ecErrCode := appropriate error code
    : appropriate messages printed on console
    : return := NULL
| true =>
    ecErrCode := OK
    : ::IpcMemoryG.ObjectSet := ::IpcMemoryG.ObjectSet U 
      NewObjectSet (::IpcMemoryG, iiId)
    : return := address of appropriate tIpcDblBuffer
]]

*****************************************************************************************/


class tIpcIndirectionDblBuffer : public tIpcDblBuffer <tIpcMemoryBytePointer> {
public:
  tIpcIndirectionDblBuffer (const tIpcIndirectionDblBufferId &iiId);
  ERROR_CODE Get (tBuffer& DataOut) volatile const;
  ERROR_CODE Put (const tBuffer& DataIn) volatile;
  void* operator new (size_t szSize, const tIpcIndirectionDblBufferId &iiId, 
                      ERROR_CODE& ecErrCode);
protected:
  size_t szBufferSize;
  };

#endif
