/* $RCSfile: ipcUntypedObjectAccessor.h,v $ */
/* $Header: /home/chara/cvsroot/ople/sys/include/ipcUntypedObjectAccessor.h,v 1.1.1.1 1998/06/11 21:36:13 chara Exp $*/

#include "isit.h"
#include "baseObject.h"
#include "ipcError.h"

#ifndef INC_ipcUntypedObjectAccessorh
#define INC_ipcUntypedObjectAccessorh



/****************************************************************************

tUntypedIpcObjectAccessor Black Box State

BOOL        bInit
ERROR_CODE  ecInitError

------------------------------------------------------------------------------


[[D tUntypedIpcObjectAccessor::tUntypedIpcObjectAccessor (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => 
    this->bInit := TRUE
    : this->ecInitError := OK
]]


[[D tUntypedIpcObjectAccessor::~tUntypedIpcObjectAccessor (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tUntypedIpcObjectAccessor::UntypedGet (void* pDataOut, size_t &szDataSize) ]
[ invalid_pointer (this) ||
  invalid_pointer (pDataOut) || 
  pData doesn't point to memory block of appropriate size ||
  this->bObjectValid == FALSE ||
  DoesObjectExist (::IpcMemoryG.ObjectSet, this->iiObjectId) == FALSE => 
    UNDEFINED
| Unable to get data from object => 
    console := console + appropriate error messages
    : pDataOut := anything
    : szDataOut := anything
    : return := appropriate error code
| true =>
    szDataOut := approprate data size for GetObject (::IpcMemoryG.ObjectSet, 
      this->iiId->iiObjectId)->(appropriate data from tIpcObject)
    : *pDataOut := GetObject (::IpcMemoryG.ObjectSet, 
      this->iiId->iiObjectId)->(appropriate data from tIpcObject)
    : return := OK
]]

[[ tUntypedIpcObjectAccessor::GetInitError (void) ] = 
      tBaseObject::GetInitError ]

[[ tUntypedIpcObjectAccessor::SetInitError (ERROR_CODE ec)] = 
      tBaseObject::SetInitError ]

[[ tUntypedIpcObjectAccessor::IsInit (void) ] = 
      tBaseObject::IsInit ]

[[ tUntypedIpcObjectAccessor::SetInit (BOOL bInitToUse) ] = 
      tBaseObject::SetInit ]

[[ tUntypedIpcObjectAccessor::IsOk (void) ] = 
      tBaseObject::IsOk ]

****/



class tUntypedIpcObjectAccessor : public tBaseObject {
  public:
    tUntypedIpcObjectAccessor ();
    virtual ~tUntypedIpcObjectAccessor ();
    virtual ERROR_CODE UntypedGet (void* pDataOut, size_t &szDataSize) = 0;
};

#endif INC_ipcUntypedObjectAccessorh
