/* $RCSfile: ipcid.h,v $ */
/*$Header: /home/chara/cvsroot/ople/sys/include/ipcid.h,v 1.1.1.1 1998/06/11 21:36:12 chara Exp $
*/
#ifndef INC_ipcIdh
#define INC_ipcIdh

#include "isit.h"
#include <iostream.h>

/******************************************************************************
Class tIpcId 
Description: Base class for IPC object identification information

Black Box State

IPC_NAME inObjectName
IPC_TYPE itObjectType
MEM_TYPE mtObjectMemType

*******************************************************************************

[[D tIpcId::tIpcId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := IPC_NULL_NAME
    : this->mtObjectMemType := MT_UNKNOWN 
    : this->itObjectType := IPC_UKNNOWN
]]

[[D tIpcId::tIpcId_INMT (IPC_NAME inName, MEM_TYPE mtMemType) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := inName
    : this->mtObjectMemType := mtMemType 
    : this->itObjectType := IPC_UKNNOWN
]]


[[D tIpcId::~tIpcId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tIpcId::Name (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := this->inObjectName 
]]

[[D tIpcId::Memory (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := this->mtObjectMemType 
]]

[[D tIpcId::Type (void) ]
[ invalid_pointer (this) ||
  this is not a derived class of tIpcId => UNDEFINED
| true => return this->itObjectType
]]


*******************************************************************************
* Class tIpcAtomId 

Black Box State

IPC_NAME inObjectName
IPC_TYPE itObjectType
MEM_TYPE mtObjectMemType


*******************************************************************************


[[D tIpcAtomId::tIpcAtomId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := IPC_NULL_NAME
    : this->mtObjectMemType := MT_UNKNOWN 
    : this->itObjectType := IPC_ATOM
]]



[[D tIpcAtomId::tIpcAtomId_INMT (IPC_NAME inName, MEM_TYPE mtMemType) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := inName
    : this->mtObjectMemType := mtMemType 
    : this->itObjectType := IPC_ATOM
]]

[[D tIpcAtomId::~tIpcAtomId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tIpcAtomId::Type (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := IPC_ATOM
]]
*******************************************************************************
* Class tIpcDblBufferId 


Black Box State

IPC_NAME inObjectName
IPC_TYPE itObjectType
MEM_TYPE mtObjectMemType

*******************************************************************************
 
[[D tIpcDblBufferId::tIpcDblBufferId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := IPC_NULL_NAME
    : this->mtObjectMemType := MT_UNKNOWN 
    : this->itObjectType := IPC_DBL_BUFFER
]]
 
[[D tIpcDblBufferId::tIpcDblBufferId_INMT (IPC_NAME inName, MEM_TYPE mtMemType) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := inName
    : this->mtObjectMemType := mtMemType 
    : this->itObjectType := IPC_DBL_BUFFER
]]

[[D tIpcDblBufferId::~tIpcDblBufferId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tIpcDblBufferId::Type (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := IPC_DBL_BUFFER
]]


*******************************************************************************
* Class tIpcFifoId 

Black Box State

IPC_NAME inObjectName
IPC_TYPE itObjectType
MEM_TYPE mtObjectMemType
int      iFifoDepth
*******************************************************************************

[[D tIpcFifoId::tIpcFifoId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := IPC_NULL_NAME
    : this->mtObjectMemType := MT_UNKNOWN 
    : this->itObjectType := IPC_FIFO
    : this->iFifoDepth := 0
]]
 

[[D tIpcFifoId::tIpcFifoId_INMTi (IPC_NAME inName, MEM_TYPE mtMemType, int iDepth) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := inName
    : this->mtObjectMemType := mtMemType
    : this->itObjectType := IPC_FIFO 
    : this->iFifoDepth := iDepth
]]

[[D tIpcFifoId::~tIpcFifoId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tIpcFifoId::Type (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := IPC_FIFO
]]

[[D tIpcFifoId::Depth (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := this->iFifoDepth 
]]
 
[[D tIpcMultiTypeFifoId::tIpcMultiTypeFifoId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := IPC_NULL_NAME
    : this->mtObjectMemType := MT_UNKNOWN 
    : this->itObjectType := IPC_FIFO
    : this->iFifoDepth := 0
    : this->inHeaderName := IPC_NULL_NAME
]]
 

[[D tIpcMultiTypeFifoId::tIpcMultiTypeFifoId_ININMTi (IPC_NAME inDataNameToUse, 
    IPC_NAME inHeaderNameToUse, MEM_TYPE mtMemType, int iFifoDepthToUse) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := inDataNameToUse
    : this->mtObjectMemType := mtMemType
    : this->itObjectType := IPC_FIFO 
    : this->iFifoDepth := iFifoDepthToUse
    : this->inHeaderName := inHeaderNameToUse
]]

[[D tIpcFifoMultiTypeId::~tIpcMultiTypeFifoId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tIpcMultiTypeFifoId::Type (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := IPC__MULTI_TYPE_FIFO
]]

[[D tIpcMultiTypeFifoId::Depth (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := this->iFifoDepth 
]]

[[D tIpcMultiTypeFifoId::HeaderId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := copy of tIpcFifoId with
     : inObjectName := this->inHeaderName
     : itObjectType := IPC_FIFO
     : iFifoDepth := this->iFifoDepth
]]

[[D tIpcMultiTypeFifoId::DataId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := copy of tIpcFifoId with
     : inObjectName := this->inObjectName
     : itObjectType := IPC_FIFO
     : iFifoDepth := this->iFifoDepth
]]

*******************************************************************************
* Class tIpcIndirectionDblBufferId 

Black Box State

IPC_NAME inObjectName
IPC_NAME inBuf1Name;
IPC_NAME inBuf2Name;
IPC_TYPE itObjectType
MEM_TYPE mtObjectMemType
size_t szBufferSize;
*******************************************************************************

[[D tIpcIndirectionDblBufferId::tIpcIndirectionDblBufferId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := IPC_NULL_NAME
    : this->inBuf1Name := IPC_NULL_NAME
    : this->inBuf2Name := IPC_NULL_NAME
    : this->mtObjectMemType := MT_UNKNOWN 
    : this->itObjectType := IPC_INDIRECTION_DBL_BUFFER
    : this->szBufferSize := 0
]]
 

[[D tIpcIndirectionDblBufferId::tIpcIndirectionDblBufferId_InInInMtSz
                               (IPC_NAME inName, 
                                IPC_NAME inBuf1Name, IPC_NAME inBuf2Name, 
                                MEM_TYPE mtMemType, size_t szBufSize) ]
[ invalid_pointer (this) => UNDEFINED
| true =>
    this->inObjectName := inName
    : this->inBuf1Name := inBuf1Name
    : this->inBuf2Name := inBuf2Name
    : this->mtObjectMemType := mtMemType
    : this->itObjectType := IPC_INDIRECTION_DBL_BUFFER
    : this->szBufferSize := szBufSize
]]

[[D tIpcFifoId::~tIpcFifoId (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => *this := anything
]]

[[D tIpcIndirectionDblBufferId::Type (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := IPC_INDIRECTION_DBL_BUFFER
]]

[[D tIpcIndirectionDblBufferId::BufferSize (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := this->szBufferSize
]]

[[D tIpcIndirectionDblBufferId::Buf1Id (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => 
    return.inName := this->inBuf1Name
    : return.mtObjectMemType := this->mtObjectMemType
    : return.itObjectType := IPC_ATOM
]]

[[D tIpcIndirectionDblBufferId::Buf2Id (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => 
    return.inName := this->inBuf2Name
    : return.mtObjectMemType := this->mtObjectMemType
    : return.itObjectType := IPC_ATOM
]]

*************************/

const IPC_NAME IPC_NULL_NAME = 0;

class ostream;

class tIpcId {
  public:
    tIpcId(void);
    tIpcId (IPC_NAME inName, MEM_TYPE mtMemType);
    IPC_NAME Name(void) const;
    MEM_TYPE Memory(void) const;
    virtual IPC_TYPE Type(void) const = 0;
    friend ostream &operator<< (ostream& stream,const tIpcId& iiId); 

  protected:
    IPC_NAME inObjectName;
    MEM_TYPE mtObjectMemType;
};

class tIpcAtomId : public tIpcId {
  public: 
    tIpcAtomId(void);
    tIpcAtomId (IPC_NAME inName, MEM_TYPE mtMemType);
    virtual IPC_TYPE Type(void) const;
};

class tIpcDblBufferId : public tIpcId {
  public: 
    tIpcDblBufferId (void);
    tIpcDblBufferId (IPC_NAME inName, MEM_TYPE mtMemType);
    virtual IPC_TYPE Type(void) const;
};

class tIpcFifoId : public tIpcId {
  public: 
    tIpcFifoId (void);
    tIpcFifoId (IPC_NAME inName, MEM_TYPE mtMemType, int iDepth);
    int Depth (void) const;
    virtual IPC_TYPE Type(void) const;
    friend ostream &operator<< (ostream& stream,const tIpcFifoId& iiId); 
  protected:
    int iFifoDepth;
};

class tIpcIndirectionDblBufferId : public tIpcId {
  public: 
    tIpcIndirectionDblBufferId (void);
    tIpcIndirectionDblBufferId (IPC_NAME inName, IPC_NAME inBuf1Name, IPC_NAME inBuf2Name, 
                                MEM_TYPE mtMemType, size_t szBufSize);
    size_t BufferSize (void) const;
    tIpcAtomId Buf1Id (void) const;
    tIpcAtomId Buf2Id (void) const;
    virtual IPC_TYPE Type(void) const;
    friend ostream &operator<< (ostream& stream,const tIpcIndirectionDblBufferId& iiId); 
  protected:
    IPC_NAME inBuf1Name;
    IPC_NAME inBuf2Name;
    size_t szBufferSize;
};


#endif
