/* $RCSfile: isitCommand.h,v $ - isit commands structure */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/include/isitCommand.h,v 1.3 1998/09/23 23:57:27 phil Exp $
*/
/* Kevin Young - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a,09May97,ky   written 
*/

/*
>DESCRIPTION
isit commands definition
*/

#ifndef INC_isitCommandh
#define INC_isitCommandh

#include "Commands.h"

typedef union ISIT_CMD {
   tIsitCmd                     genericCmd;
   tDlSetActiveTargetCmd        dlsatCmd;    /* DL Target src - */
   tDlDitherOnCmd               dldoCmd;     /* DL Dither On command */
   tDlDataRecordCmd             dldrCmd;     /* DL Data Record by KY 9/21/98 */
   tDlClearLaserCounterCmd      dlclcCmd;    /* DL clear laser ctr */
   tDlOffCmd                    dloCmd;      /* DL Off command */
   tDlFrontCmd                  dlfCmd;      /* DL Front command */
   tDlBackCmd                   dlbCmd;      /* DL Back command */
   tDlTrackCmd                  dltCmd;      /* DL Track command */
   tDlUser1Cmd                  dlu1Cmd;     /* DL User 1 command */
   tDlUser2Cmd                  dlu2Cmd;     /* DL User 2 command */
   tDlHomeCheckCmd              dlhcCmd;     /* DL Home Check command */
   tDlHomeSetCmd                dlhsCmd;     /* DL Home Set command */
   tDlDitherCalibrateCmd        dldcCmd;     /* DL Dither Calibrate command */
   tDlDitherCheckCmd            dldchkCmd;   /* DL Dither Check command */
   tDlSetDitherCmd          	dlsdCmd;     /* DL Set Dither command */
   tDlPingCmd                   dlpCmd;      /* DL Ping command */
   tDlSetModulationCmd          dlsmCmd;     /* DL Set Modulation command */
//   tDlSetServoParametersCmd     dlsspCmd;    /* DL Set Servo Params */
   tGsuDlSetServoParametersCmd  gsudlsspCmd;    /* GSU DL Set Servo Params */
   tInstSetOpenLoopTargetCmd    instsoltCmd; /* Set Open Loop Target command*/
   tInstSetManualTargetCmd      instsmtCmd;  /* Set Manual Target command */
   tFtOffCmd                    ftoCmd;      /* Fringe Tracker Off command */
   tFtTrackCmd                  fttCmd;      /* Fringe Tracker Track command*/
   tFtPingCmd                   ftpCmd;      /* Fringe Tracker Ping command */
   tFtSetManualTargetCmd        ftsmtCmd;    /* Fringe Tracker Set Manual Tar */
   tFtSetServoParametersCmd     ftcpCmd;     /* Fringe Tracker Set servo */
   tFtGetImage                  ftgiCmd;     /* Fringe Tracker Get Image */
   tFtSetRegionOfInterestCmd    ftsroiCmd;   /* Fringe Tracker Set ROI */
   tEmOffCmd                    emoCmd;      /* External Met. Off command */
   tEmTrackCmd                  emtCmd;      /* External Met. Track command*/
   tEmPingCmd                   empCmd;      /* External Met. Ping command */
   tEmSetServoParametersCmd     emsspCmd;    /* External Met. Set Servo */
   tStOffCmd                    stoCmd;      /* ST Off command */
   tStTrackCmd                  sttCmd;      /* ST Track command */
   tStPingCmd                   stpCmd;      /* ST Ping command */
   tStHomeCmd                   sthCmd;      /* ST Home command */
   tStCalibrateCmd              stcCmd;      /* ST Calibrate command */
   tStSetServoParamsCmd         stsCmd;      /* ST SetServoParams command */
   tInstSetTimeCmd              inststCmd;   /* Instrument Set Time command */
   tExtintSetDataRecordingCmd   extsdrCmd;   /* Extint Set Data Recording */
} ISIT_CMD;

#endif  /* INC_isitCommandh */

