/* $RCSfile: quicDlController.h,v $ - QuicDlController base class definitions */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/include/quic/quicDlController.h,v 1.1.1.1 1998/06/11 21:36:17 chara Exp $
*/
/* Brad Hines - Jet Propulsion Laboratory */
 
/*
modification history
--------------------
02a,beh,11May97    Completely new for increment 2
01a,beh,23Oct96    written
*/
 
/*
DESCRIPTION

*/

#ifndef INC_QuicDlControllerh
#define INC_QuicDlControllerh

#include "dlTypes.h"
#include "quicDlGizmoInfo.h"
#include "dl/dlController.h"
#include "quicDlIoSet.h"
#include "controlLaw.h"

/*******************************************************************/
/***********************  tQuicDlControllerData *********************/
/*******************************************************************/

class tQuicDlControllerData : public tDlControllerData {
public:
  tQuicDlControllerData (const tQuicDlGizmoInfo &GizmoInfo,
                         tDlLimits &DlLimits,
                         tModulatedVelocityActuator &Motor,
                         tModulatedPositionActuator &Vc1,
                         tModulatedSensor &PztReadback,
                         tLaserMetrologySensor &Laser,
                         double dDecelerationAggressiveness,
                         int iMotorServoRate,
                         const tTypeTag& DataTag, tDlStatus& DlStatusToUse);
  ERROR_CODE SetServoParams(const tQuicDlServoParams &NewServoParams);
  virtual const tDlServoParams &GetServoParams() const;
  const tQuicDlServoParams &GetQuicServoParams() const;
  virtual ERROR_CODE UpdateCompensatorCoefficients();
  
  tQuicDlServoParams ServoParams;

  tPztController   PztController;
  tVcController    VcController;
  tMotorController MotorController;
};


#endif  /* INC_QuicDlControllerh */
