/* $RCSfile: quicDlControllerSet.h,v $ */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/include/quic/quicDlControllerSet.h,v 1.1.1.1 1998/06/11 21:36:17 chara Exp $
*/
/* Brad Hines - Jet Propulsion Laboratory */
 
/*
modification history
--------------------
01a,beh,18May97    Adapted from QuicDlController.h
*/
 
/*
DESCRIPTION

*/

#ifndef INC_QuicDlControllerSeth
#define INC_QuicDlControllerSeth

#include "dl/dlController.h"
#include "dl/dlFastController.h"
#include "dl/dlMediumController.h"
#include "dl/dlSlowController.h"
#include "quicDlTrackController.h"
#include "quicDlIoSet.h"
#include "controllerSet.h"

class tQuicDlTrackGroupUpdate : public tUpdateModeDecision {
  public:
    tQuicDlTrackGroupUpdate (tQuicDlControllerData& ControllerDataToUse);
    int GetNewMode (TIME tUpdateTime);
  protected:
    tQuicDlControllerData& ControllerData;
};


/*******************************************************************/
/***************  tQuicDlCompleteControllerSet  ***************/
/*******************************************************************/

class tQuicDlCompleteControllerSet : public tDlCompleteControllerSet {
public:
  tQuicDlCompleteControllerSet (const tQuicDlGizmoInfo &GizmoInfo,
                                tQuicDlCompleteIoSet &CompleteIoSet,
                                const tTypeTag& DataTag, tDlStatus& DlStatusToUse);
  
  ERROR_CODE SetServoParams(const TRACK_SERVO_PARAMS &ServoParams);
  virtual const TRACK_SERVO_PARAMS &GetServoParams() const;
  virtual tDlControllerData &GetControllerData()
    {return this->ControllerData;}
  virtual tControllerGroup &GetOffControllerGroup ()
    {return OffControllerGroup;}
  virtual tControllerGroup &GetFrontControllerGroup ()
    {return FrontControllerGroup;}
  virtual tControllerGroup &GetBackControllerGroup ()
    {return BackControllerGroup;}
  virtual tControllerGroup &GetFrontCreepControllerGroup ()
    {return FrontCreepControllerGroup;}
  virtual tControllerGroup &GetBackCreepControllerGroup ()
    {return BackCreepControllerGroup;}
  virtual tControllerGroup &GetTrackControllerGroup ()
    {return TrackControllerGroup;}
  virtual tControllerGroup &GetUser1ControllerGroup ()
    {return TrackControllerGroup;}
  virtual tControllerGroup &GetUser2ControllerGroup ()
    {return TrackControllerGroup;}

protected:

  tQuicDlControllerData         ControllerData;
  tQuicDlTrackGroupUpdate       TrackGroupUpdate;

  tSimpleControllerGroup  OffControllerGroup;
  tSimpleControllerGroup  FrontControllerGroup;
  tSimpleControllerGroup  BackControllerGroup;
  tSimpleControllerGroup  FrontCreepControllerGroup;
  tSimpleControllerGroup  BackCreepControllerGroup;
  tModedControllerGroup   TrackControllerGroup;


  tDlFastSlewController          FastSlewController;
  tDlMediumSlewController        MediumSlewController;
  tDlSlowFrontBackController     SlowFrontController;
  tDlSlowFrontBackController     SlowBackController;
  tDlSlowFrontBackController     SlowFrontCreepController;
  tDlSlowFrontBackController     SlowBackCreepController;

  tDlSlowOffController           SlowOffController;
  tDlSlowTrackSlewController     SlowSlewController;

  tQuicDlFastTrackLinearController   FastLinearController;
  tQuicDlMediumTrackLinearController MediumLinearController;
  tQuicDlSlowTrackLinearController   SlowLinearController;
  
};



#endif  /* INC_QuicDlControllerSeth */





