/* $RCSfile: quicDlGizmo.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/quic/quicDlGizmo.h,v 1.1.1.1 1998/06/11 21:36:17 chara Exp $
*/
/* Brad Hines - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a,14May97,beh    written
*/
 
/*
DESCRIPTION
  Delay line Gizmo defines and types
*/
   

#ifndef INC_quicDlGizmoh
#define INC_quicDlGizmoh

#include "isit.h"
#include "dlGizmo.h"
#include "dlTypes.h"
#include "typeTag.h"
#include "quic/quicDlIoSet.h"
#include "quic/quicDlControllerSet.h"

/*******************************************************************/
/*************************  tQuicDlGizmo  ***************************/
/*******************************************************************/

class tQuicDlGizmoInfo;

class tQuicDlGizmo : public tDlGizmo {
  public:
    tQuicDlGizmo(const tQuicDlGizmoInfo &GizmoInfo);

  private: // these must be constructed before using in other member constructors
    tTypeTag CQuicDlStatusTag;
    tTypeTag CQuicDlDataTag;

  protected:
    virtual ERROR_CODE CollectStatus ();
    virtual tDlCompleteIoSet& GetCompleteIoSet ();
    virtual tDlCompleteControllerSet& GetCompleteControllerSet ();
    virtual tDlStatus& GetStatus ();

    tDlStatus                     Status;
    tQuicDlCompleteIoSet          CompleteIoSet; 
    tQuicDlCompleteControllerSet  CompleteControllerSet;
};

#define S_quicDlGizmo_ENTERING_QUIC_DL_GIZMO_CONSTRUCTOR_BODY (M_quicDlGizmo| 0x1)
#define S_quicDlGizmo_EXITING_QUIC_DL_GIZMO_CONSTRUCTOR     (M_quicDlGizmo | 0x2)
#define S_quicDlGizmo_GIZMO_INIT_SUCCEEDED                 (M_quicDlGizmo | 0x3)


#endif INC_quicDlGizmoh


