/* $RCSfile: quicDlGizmoInfo.h,v $ */
/* CM Info: */   
/*$Header: /home/chara/cvsroot/ople/sys/include/quic/quicDlGizmoInfo.h,v 1.1.1.1 1998/06/11 21:36:17 chara Exp $ */

/* Richard Johnson - Jet Propulsion Laboratory */

/* modification history
--------------------
*/


#ifndef INC_quicDlGizmoInfo_h
#define INC_quicDlGizmoInfo_h

#include "channel.h"
#include "dlGizmoInfo.h"


/****************************************************************
*
* tQuicDlGizmoInfo class spec
*
[[D tQuicDlGizmoInfo::tQuicDlGizmoInfo_params(void)]
[ invalid_pointer(this) => UNDEFINED
| true =>
  set all state variables to corresponding parameters
  : FE BOARD_NAME/ChannelNum pair,
     corresponding this->channelPointer := appropriate channel pointer
]]
*
*/

class tQuicDlGizmoInfo : public tDlGizmoInfo {
public:
  tQuicDlGizmoInfo(int iWhichRteToUse,int iGizmoIdToUse, GIZMO_TYPE gtType,
       const int iTargetSourceArray[NUM_DELAY_LINE_TARGETS],
       TIME tDitherPeriodToUse,
       DlPhysicalConstants PhysConstToUse, int iNumServoModesToUse,
       const tServoInfo& ServoInfoToUse,
       tQuicDlServoParams ServoParamsToUse,
       BOARD_NAME bnVc1BoardToUse, int iVc1ChannelToUse,
       BOARD_NAME bnServoPztBoardToUse, int iServoPztChannelToUse,
       BOARD_NAME bnMotorBoardToUse, int iMotorChannelToUse,
       BOARD_NAME bnDitherPztBoardToUse, int iDitherPztChannelToUse,
       BOARD_NAME bnFrontSoftLimitBoardToUse, int iFrontSoftLimitChannelToUse,
       BOARD_NAME bnFrontHardLimitBoardToUse, int iFrontHardLimitChannelToUse,
       BOARD_NAME bnBackSoftLimitBoardToUse, int iBackSoftLimitChannelToUse,
       BOARD_NAME bnBackHardLimitBoardToUse, int iBackHardLimitChannelToUse,
       BOARD_NAME bnLaserBoardToUse , int iLaserChannelToUse,
       BOARD_NAME bnHomeBoardToUse , int iHomeChannelToUse,
       BOARD_NAME bnServoPztReadbackBoardToUse, int iServoPztReadbackChannelToUse,
       BOARD_NAME bnMotorReadbackBoardToUse, int iMotorReadbackChannelToUse,
       BOARD_NAME bnDiagLaserInputBoardToUse, int iDiagLaserInputChannelToUse,
       BOARD_NAME bnDiagPztPositionInputBoardToUse, int iDiagPztPositionChannelToUse,
       BOARD_NAME bnDiagLaserOutputBoardToUse, int iDiagLaserOutputChannelToUse,
       BOARD_NAME bnDiagLaserServoErrorOutputBoardToUse,
              int iDiagLaserServoErrorOutputChannelToUse,
       BOARD_NAME bnDiagVc1ServoErrorOutputBoardToUse,
              int iDiagVc1ServoErrorOutputChannelToUse,
       BOARD_NAME bnDiagMotorServoErrorOutputBoardToUse,
              int iDiagMotorServoErrorOutputChannelToUse,
       BOARD_NAME bnDiagVc1PositionInputBoardToUse,
              int iDiagVc1PositionInputChannelToUse);


  virtual ~tQuicDlGizmoInfo ();

  tQuicDlServoParams ServoParams;

  tInputChannel      *pDiagVc1PositionInputChannel;
};


#endif INC_quicDlGizmoInfo_h
