/* $RCSfile: realTimeGizmoInfo.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/realTimeGizmoInfo.h,v 1.1.1.1 1998/06/11 21:36:13 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a27Aug97,rlj    written
*/

#ifndef INC_realTimeGizmoInfoh
#define INC_realTimeGizmoInfoh

#include "isit.h"
#include "gizmoInfo.h"
#include "servoInfo.h"

/************

[[D tRealtimeGizmoInfo::tRealtimeGizmoInfo (int iRteId, int iGizmoId,
       int iNumberOfServoModesToUse, const tServoInfo& ServoInfoToUse) ]
[ invalid_pointer (this) ||
  invalid_reference (ServoInfoToUse) => UNDEFINED
| true =>
    this->iRteId := iRteIdToUse
    : this->iGizmoId := iGizmoIdToUse
    : this->iiCommandStreamId := appropriate and unique tIpcFifoId
    : this->gtGizmoType := GT_UNKNOWN
    : this->iStatusTaskPriority := CiStatusTaskPriority
    : this->tStatusTaskPeriod := CtStatusTaskPeriod
    : this->tStatusTaskOffset := 0
    : this->iCommandTaskPriority := CiCommandTaskPriority
    : this->tCommandTaskPeriod := CiCommandTaskPeriod
    : this->tCommandTaskOffset := 0
    : this->iNumberOfServoModes := iNumberOfServoModesToUse,
    : this->ServoInfo := ServoInfoToUse
]]      

[[D tRealtimeGizmoInfo::GetServoInfo (void) ]
[ invalid_pointer (this)  => UNDEFINED
| true => return := this->ServoInfo
]]

[[D tRealtimeGizmoInfo::GetNumberOfServoModes (void) ]
[ invalid_pointer (this)  => UNDEFINED
| true => return := this->iNumberOfServoModes
]]

[[D tRealtimeGizmoInfo::GetNumberOfServoPartitions (void) ]
[ invalid_pointer (this)  => UNDEFINED
| true => return := this->ServoInfo.iNumberOfServoPartitions
]]

******/

class tServoInfo;

class tRealtimeGizmoInfo : public tGizmoInfo {
  public:
    tRealtimeGizmoInfo (int iRteId, int iGizmoId,
       int iNumberOfServoModesToUse, const tServoInfo& ServoInfoToUse);
    tServoInfo GetServoInfo () const;
    int GetNumberOfServoModes () const;
    int GetNumberOfServoPartitions () const;
  protected:
    int iNumberOfServoModes;
    tServoInfo ServoInfo;
};

#endif INC_realTimeGizmoInfo
