/* $RCSfile: rtModNum.h,v $ - Module number definition for use with makeStatTbl */
/* CM info:
Header: /home/isit/cvsroot/isit/sys/include/rtModNum.h,v 1.53 1997/09/18 00:23:24 rich Exp $*/
/* Brad Hines - Jet Propulsion Laboratory */
 
/*
modification history
--------------------
01b,pci,31Oct96    added hardware modules
01a,beh,25Sep96    written
*/
 
/*
DESCRIPTION
ISIT module number definitions for error codes, IPC names.
*/

#ifndef INC_rtModNumh
#define INC_rtModNumh

#define M_initmgr                     (0x401 << 16)
#define M_rte                         (0x402 << 16)
#define M_instRte                     (0x403 << 16)
#define M_dlRte                       (0x404 << 16)
#define M_watchDog                    (0x405 << 16)
#define M_ipc                         (0x406 << 16)
#define M_ts                          (0x407 << 16)
#define M_tc                          (0x408 << 16)
#define M_board                       (0x409 << 16)
#define M_clock                       (0x40a << 16)
#define M_interrupt                   (0x40b << 16)
#define M_device                      (0x40c << 16)
#define M_actuator                    (0x40d << 16)
#define M_sensor                      (0x40e << 16)
#define M_dt1401                      (0x40f << 16)
#define M_pc03v                       (0x410 << 16)
#define M_laser                       (0x411 << 16)
#define M_pztMotor                    (0x412 << 16)
#define M_dvme626                     (0x413 << 16)
//#define M_pztIntegratingActuator    (0x414 << 16)
//#define M_pztNonintegratingActuator (0x415 << 16)
//#define M_dt1401DiSensor            (0x416 << 16)
//#define M_fastLaserSensor           (0x417 << 16)
#define M_dlLimits                    (0x418 << 16)
#define M_dlCommandProcessor          (0x419 << 16)
#define M_offCommand                  (0x41a << 16)
#define M_frontCommand                (0x41b << 16)
#define M_backCommand                 (0x41c << 16)
#define M_trackCommand                (0x41d << 16)
#define M_clearLaserCounterCommand    (0x41e << 16)
//#define M_setTargetCommand          (0x41f << 16)	
//#define M_setTargetCurrentPositionCommand (0x420 << 16)	
#define M_setModulationCommand        (0x421 << 16)
#define M_setServoParametersCommand   (0x422 << 16)
#define M_dl                          (0x423 << 16)
#define M_dlServo                     (0x424 << 16)
#define M_mutex                       (0x425 << 16)
#define M_sched                       (0x426 << 16)
#define M_relayer                     (0x427 << 16)
#define M_hw                          (0x428 << 16)
#define M_cmd                         (0x429 << 16)
#define M_general                     (0x42a << 16)
#define M_dlDither                    (0x42b << 16)
#define M_dlTargGen                   (0x42c << 16)

#define M_mpv955                      (0x42e << 16)
#define M_mpv906                      (0x42f << 16)
#define M_dlRelayer                   (0x430 << 16)
#define M_gui                         (0x431 << 16)
#define M_relayStreams                (0x432 << 16)

#define M_channel                     (0x438 << 16)
#define M_servo                       (0x439 << 16)
#define M_homesetCommand              (0x43a << 16)
#define M_homecheckCommand            (0x43b << 16)
#define M_user1Command                (0x43c << 16)
#define M_user2Command                (0x43d << 16)
#define M_ditherCalibCommand          (0x43e << 16)
#define M_ditherCheckCommand          (0x43f << 16)
#define M_setActiveTargetCommand      (0x440 << 16)
#define M_dlPingCommand               (0x441 << 16)
#define M_dlSetDitheringCommand       (0x442 << 16)
#define M_trace                       (0x443 << 16)
#define M_ft			      (0x444 << 16)
#define M_inst			      (0x445 << 16)
#define M_dlGizmo                     (0x446 << 16)
#define M_gsuDlGizmo                  (0x447 << 16)
#define M_quicDlGizmo                 (0x448 << 16)
#define M_gizmoInfo                   (0x449 << 16)
#define M_mm6216                      (0x44a << 16)
#define M_rteConfig		      (0x44b << 16)
#define M_ipcName                     (0x44c << 16)
#define M_inputSource                 (0x44d << 16)
#define M_targetSource                (0x44e << 16)
#define M_outputDest                  (0x44f << 16)
#define M_controller                  (0x450 << 16)
#define M_configMgr                   (0x451 << 16)
#define M_tPidDouble                  (0x452 << 16)
#define M_dlController                (0x453 << 16)
#define M_dlTrackController           (0x454 << 16)
#define M_dlOffController             (0x455 << 16)
#define M_dlFrontBackController       (0x456 << 16)
#define M_dlIoSet                     (0x457 << 16)
#define M_dlInputSet                  (0x458 << 16)
#define M_dlOutputSet                 (0x459 << 16)
#define M_dlTargetSet                 (0x45a << 16)
#define M_quicDlController            (0x45b << 16)
#define M_quicDlFrontController       (0x45c << 16)
#define M_quicDlTrackController       (0x45d << 16)
#define M_modLib                      (0x45e << 16)
#define M_imageChannel                (0x45f << 16)
#define M_vip640a                     (0x460 << 16)
#define M_tImage                      (0x461 << 16)
#define M_relayStream                 (0x462 << 16)
#define M_errorStream                 (0x463 << 16)
#define M_commandStream               (0x464 << 16)
#define M_extInt                      (0x465 << 16)
#define M_baseObject                  (0x466 << 16)
#define M_cmdHdlr                     (0x467 << 16)
#define M_emgizmo                     (0x468 << 16)
#define M_servoinfo		      (0x469 << 16)

#define M_stgizmo                     (0x470 << 16)
#define M_rtgizmo                     (0x471 << 16)
#define M_datastore                   (0x472 << 16)
#define M_imagestatus                 (0x473 << 16)
#define M_dlgizmo                     (0x474 << 16)
#define M_stactuator                  (0x475 << 16)
#define M_gizmo                       (0x476 << 16)
#define M_ipQuad                      (0x477 << 16)
#define M_vector                      (0x478 << 16)
#define M_ip16Dac                     (0x479 << 16)
#define M_wapgizmo                    (0x480 << 16)
#define M_tim                         (0x481 << 16)

#endif  /* INC_rtModNumh */
