
/* $RCSfile: rte.h,v $ - Type definitions for generic RTE stuff  */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/rte.h,v 1.1.1.1 1998/06/11 21:36:14 chara Exp $*/
/* Richard Johnson - Jet Propulsion Laboratory */

/*
modification history
--------------------
03a,18July97,rlj     First I3c version
02a,24Apr97,rlj      made pIpc public to make compatible with fringe tracker
01d,24Oct96,eamck    moved members to protected block; corrected a few
01c,17Oct96,eamck    added TIME and tErrorStreamClient members
01b,25Sep96,beh      improved upon
01a,25Sep96,eamck    written
*/
 
/*
DESCRIPTION
  Generic RTE defines and types
*/
   

#ifndef INC_rteh
#define INC_rteh

#include "baseObject.h"
#include "interrupt.h"
//#include "clock.h"


extern tRte *pThisRteG;         /* global pointer to whichever Rte we are */

    
#define S_rte_GIZMO_CREATION_ERROR             (M_rte | 0x2)
#define S_rte_GIZMO_NOT_ON_THIS_RTE            (M_rte | 0x3)
#define S_rte_INVALID_GIZMO_NUMBER             (M_rte | 0x4)

#define S_rte_UNABLE_TO_CREATE_IPC             (M_rte | 0x5)
#define S_rte_UNABLE_TO_CREATE_SCHEDULER       (M_rte | 0x6)
#define S_rte_UNABLE_TO_CREATE_ERROR_STREAM    (M_rte | 0x7)
#define S_rte_UNABLE_TO_CREATE_DATA_STREAM     (M_rte | 0x8)
#define S_rte_UNABLE_TO_CREATE_STATUS_STREAM   (M_rte | 0x9)
#define S_rte_INVALID_RTE_GIZMO_INDEX          (M_rte | 0xa)

#define S_rte_ENTERING_TRTE_INIT               (M_rte | 0x1001)
#define S_rte_IPC_INITIALIZED                  (M_rte | 0x1002)
#define S_rte_INTERRUPT_INITIALIZED            (M_rte | 0x1003)
#define S_rte_SCHEDULER_INITIALIZED            (M_rte | 0x1004)
#define S_rte_HB_EKG_EMT_TASKS_SCHEDULED       (M_rte | 0x1005)
#define S_rte_CREATING_NEW_GIZMO               (M_rte | 0x1006)
#define S_rte_TRTE_INIT_COMPLETED              (M_rte | 0x1007)
#define S_rte_ENTERING_RTEINIT                 (M_rte | 0x1008)
#define S_rte_EXITING_RTEINIT                  (M_rte | 0x1009)
#define S_rte_HEARTBEAT_TICKED                 (M_rte | 0x100a)
#define S_rte_EKG_TICKED                       (M_rte | 0x100b)
#define S_rte_EMT_TICKED                       (M_rte | 0x100c)
#define S_rte_ERROR_STREAM_INITIALIZED         (M_rte | 0x100d)
#define S_rte_DATA_STREAM_INITIALIZED          (M_rte | 0x100e)
#define S_rte_STATUS_STREAM_INITIALIZED        (M_rte | 0x100f)


/************

Black Box State

set of tGizmo GizmoSet - gizmos owned by the RTE 



[[D tRte::tRte (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => 
    this->ecInitError := OK
    : this->bInit := TRUE
]]

[[D tRte::Init (int iWhichCPU, int iWhichRTE,
    volatile SHMEM_WORD* vswIpcShmemStart, int iIpcBytes,
    volatile HEARTBEAT* vHbLocation, volatile HEALTH* vRteHealth, 
    volatile INIT_TYPE* vRteInitType) ]
[ ::ConfigManager.bInit == FALSE ||
  invalid_pointer (this) ||
  invalid_pointer (vswIpcShmemStart) ||
  invalid_pointer (vHbLocation) ||
  invalid_pointer (vRteHealth) ||
  invalid_pointer (vRteInitType) ||
  (BYTE*) vswIpcShmemStart + iIpcBytes > 
    one address past the last legal address of shared memory ||
  invalid_pointer (::ConfigManager.Hardware.ppPc03vBoard[iWhichRTE] ) ||
  invalid_pointer (::ConfigManager.Hardware.ppPc03vBoard[iWhichRTE].pFunc) ||
  ::IpcMemory.bInit == FALSE ||
  ::EventDrivenTaskSet.bInit == FALSE ||
  ALL_GIZMO_INFO_FOR_RTE.iRteId != iWhichRte ||
  ALL_GIZMO_INFO_FOR_RTE.iGizmoId != id associated with appropriate gizmo ||
  IsADelayLine (ANY_FT_GIZMO_INFO_FOR_RTE.iDlTargetGizmoId) == FALSE ||
  IsADelayLine (ANY_EM_GIZMO_INFO_FOR_RTE.iDlTargetGizmoId) == FALSE ||
  IsAFringeTracker (ANY_ST_GIZMO_INFO_FOR_RTE.iFtGizmoId) == FALSE ||
  IsAStarTracker (ANY_FT_GIZMO_INFO_FOR_RTE.iSt0GizmoId) == FALSE ||
  IsAStarTracker (ANY_FT_GIZMO_INFO_FOR_RTE.iSt1GizmoId) == FALSE => UNDEFINED 
| CanAllocateIpcObject (::ConfigManager.iiErrorStreamId [iWhichRte]) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.iiDataStreamId [iWhichRte]) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.iiStatusStreamId [iWhichRte]) == FALSE ||
  (! (0 <= iWhichRte < CiNumRte) ) ||
  *ConfigManager.Hardware.ppPc03vBoard[iWhichRTE] does not have interrupt capabilities ||
  *ConfigManager.Hardware.ppPc03vBoard[iWhichRTE] does not have clock function ||
  ConfigManager.iSchedMaxTasks < 1 ||
  unable to allocate memory for array of tTask of dimension iSchedMaxTasks ||
  unable to allocate memory for array of (tTask *) of dimension iSchedMaxTasks ||
  1 is not valid interrupt source on 
    *ConfigManager.Hardware.ppPc03vBoard[iWhichRTE] || 
  1 is not clock-driven interrupt source for 
    *ConfigManager.Hardware.ppPc03vBoard[iWhichRTE]  ||
  this->RteInterruptServer.bConnected == TRUE ||
  this->RteInterruptServer.bEnabled ||
  RteIntNum[iWhichRTE] < MIN_BUS_INTERRUPT ||
  RteIntNum[iWhichRTE] > MAX_BUS_INTERRUPT ||
  CanAllocateIpcObject (::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.
    iiCommandStreamId) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiErrorStreamArray [0..CiNumberOfRtes]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiStatusStreamArray [0..CiNumberOfRtes]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiDataStreamArray [0..CiNumberOfRtes]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiCommandStreamArray [0..CiNumberOfSystemGizmos]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiOpenLoopTargetIdArray [0..CiNumberOfDelayLines-1]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiManualTargetIdArray [0..CiNumberOfDelayLines-1]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiCommandStreamArray [0..CiNumberOfSystemGizmos]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_EM_GIZMO_INFO_FOR_RTE.
    iiDlTargetId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.
    iiDlTargetId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.
    iiStarImage0BufferId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.
    iiStarImage1BufferId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_ST_GIZMO_INFO_FOR_RTE.
    iiStarImageBufferId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.
    iiOpenLoopTargetId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.
    iiManualTargetId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.
    iiEmTargetId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.
    iiFtTargetId) == FALSE ||
  unable to add Heartbeat task ||
  unable to add Ekg Task ||
  unable to add Emt Task ||
  ALL_GIZMOS_ON_RTE unable to add Command Processing Task ||
  ALL_GIZMOS_ON_RTE unable to add Status Processing Task ||
  ALL_INSTRUMENT_CDS_GIZMOS_ON_RTE unable to add Relayer Task ||
  ALL_EM_GIZMOS_ON_RTE unable to add periodic Servo Task ||
  ALL_FT_GIZMOS_ON_RTE unable to add periodic Servo Task ||
  ALL_ST_GIZMOS_ON_RTE unable to add periodic Servo Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic Fast Servo Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic Medium Servo Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic Slow Servo Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic Update Track Mode Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic Limit Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic TargetGen Task ||
  ALL_EM_GIZMOS_ON_RTE unable to add event driven EM Data Dump Task ||
  ALL_FT_GIZMOS_ON_RTE unable to add event driven Fringe Image Data Dump Task ||
  ALL_FT_GIZMOS_ON_RTE unable to add event driven Data Dump Task ||
  ALL_ST_GIZMOS_ON_RTE unable to add event driven Star Image Data Dump Task ||
  ALL_ST_GIZMOS_ON_RTE unable to add event driven Data Dump Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add event driven Data Dump Task =>
     console:= console + appropriate error message
     : return:= appropriate error code
| task "tTelnetd" not found || 
  task "tRlogind" not found ||
  task "tShell" not found ||
  task "tWdbTask" not found => 
    appropriate error sent to *(this->pRteErrorStream)
    : return := appropriate error code
| true =>
    Time function set to GetTime
    : ::ErrorStream (this).bInit := TRUE
    : ::DataStream (this).bInit := TRUE
    : ::StatusStream (this).bInit := TRUE
    : ::PeriodicTaskSet.bInit := TRUE
    : ::IpcMemory.ObjectSet := ::IpcMemory.ObjectSet U 
        { (::ConfigManager.iiErrorStreamId [iWhichRte], tIpcFifo<BYTE>),
          (::ConfigManager.iiStatusStreamId [iWhichRte], tIpcFifo<BYTE>),
          (::ConfigManager.iiDataStreamId [iWhichRte], tIpcFifo<BYTE>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiErrorStreamArray [0..CiNumberOfRtes], tIpcFifo<BYTE>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiStatusStreamArray [0..CiNumberOfRtes], tIpcFifo<BYTE>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiDataStreamArray [0..CiNumberOfRtes], tIpcFifo<BYTE>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiDataStreamArray [0..CiNumberOfSystemGizmos], tIpcFifo<ISIT_CMD>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiOpenLoopTargetArray [0..CiNumberOfDelayLines],
	     tIpcDblBuffer<tDlTarget>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiManualTargetArray [0..CiNumberOfDelayLines],
	     tIpcDblBuffer<tDlTarget>),	     
          (::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.iiCommandStreamId,
             tIpcFifo<ISIT_CMD> ),
          (::ConfigManager.ALL_EM_GIZMO_INFO_FOR_RTE.iiDlTargetId,
             tIpcDblBuffer<tDlTarget>),
          (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.iiDlTargetId,
             tIpcDblBuffer<tDlTarget>),
          (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.iiStarImage0BufferId,
             tIpcIndirectionDblBuffer),
          (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.iiStarImage1BufferId,
             tIpcIndirectionDblBuffer),
          (::ConfigManager.ALL_ST_GIZMO_INFO_FOR_RTE.iiStarImageBufferId,
             tIpcIndirectionDblBuffer),
          (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.iiOpenLoopTargetId,
             tIpcDblBuffer<tDlTarget>),
          (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.iiManualTargetId,
             tIpcDblBuffer<tDlTarget>),
          (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.iiEmTargetId,
             tIpcDblBuffer<tDlTarget>),
          (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.iiFtTargetId,
             tIpcDblBuffer<tDlTarget>) }         
    : ::PeriodicTaskSet := ::PeriodicTaskSet U {
      PeriodicTask ("HbTask", ::ConfigManager.HbTaskPriority, 
        ::ConfigManager.HbTaskPeriod, ::ConfigManager.HbTaskOffset, 
        tRte::HbGen) ,
      PeriodicTask ("EkgTask", ::ConfigManager.EkgTaskPriority, 
        ::ConfigManager.EkgTaskPeriod, ::ConfigManager.EkgTaskOffset, 
        tRte::EKG),
      PeriodicTask ("EmtTask", ::ConfigManager.EmtTaskPriority, 
        ::ConfigManager.EmtTaskPeriod, ::ConfigManager.EmtTaskOffset, 
        tRte::EMT),
      PeriodicTask ("ProcessoCommand", 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.iCommandTaskPriority, 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.tCommandTaskPeriod, 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.tCommandTaskOffset, 
        tGizmo::ProcessCommand),
      PeriodicTask ("ProcessStatus", 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.iStatusTaskPriority, 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.tStatusTaskPeriod, 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.tStatusTaskOffset, 
        tGizmo::ProcessStatus),
      PeriodicTask ("Relay", 
        ::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.iRelayTaskPriority, 
        ::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.tRelayTaskPeriod, 
        ::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.tSRelayTaskOffset, 
        tInstrumentCdsGizmo::Relay),
      PeriodicTask ("DoServo", 
        ::ConfigManager.ALL_EM_INFO_FOR_RTE.ServoTaskArray[0].iPriority, 
        ::ConfigManager.ALL_EM_INFO_FOR_RTE.ServoTaskArray[0].tStatusTaskPeriod, 
        ::ConfigManager.ALL_EM_INFO_FOR_RTE.ServoTaskArray[0].tStatusTaskOffset, 
        tServo::DoServo),
      PeriodicTask ("DoServo", 
        ::ConfigManager.ALL_FT_INFO_FOR_RTE.ServoTaskArray[0].iPriority, 
        ::ConfigManager.ALL_FTINFO_FOR_RTE.ServoTaskArray[0].tStatusTaskPeriod, 
        ::ConfigManager.ALL_FT_INFO_FOR_RTE.ServoTaskArray[0].tStatusTaskOffset, 
        tServo::DoServo),
      PeriodicTask ("DoServo", 
        ::ConfigManager.ALL_ST_INFO_FOR_RTE.ServoTaskArray[0].iPriority, 
        ::ConfigManager.ALL_ST_INFO_FOR_RTE.ServoTaskArray[0].tStatusTaskPeriod, 
        ::ConfigManager.ALL_ST_INFO_FOR_RTE.ServoTaskArray[0].tStatusTaskOffset, 
        tServo::DoServo),
      PeriodicTask ("DoServo", 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.ServoTaskArray[0..2].iPriority, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.ServoTaskArray[0..2].tStatusTaskPeriod, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.ServoTaskArray[0..2].tStatusTaskOffset, 
        tServo::DoServo),
      PeriodicTask ("UpdateMode", 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.i??Priority, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskPeriod, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskOffset, 
        tServo::DoServo),
      PeriodicTask ("ReadLimitsTask", 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.i??Priority, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskPeriod, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskOffset, 
        tDlLimits::UpdateCachedLimitValues),
      PeriodicTask ("TargGenTask", 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.i??Priority, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskPeriod, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskOffset, 
        tDlTargGen;:ComputeTotalTarget),
    : ::EventDrivenTaskSet := ::EventDrivenTaskSet U {
        ALL_EM_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiEmDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream),
        ALL_FT_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiFtDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream),
        ALL_FT_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiFtDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream),
        ALL_ST_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiStDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream),
        ALL_ST_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiStDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream),
        ALL_DL_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiDlDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream) }
    : this->GizmoBag := appropriate gizmos as per ::ConfigManager
    : this->iMyRteNum := iWhichRTE
    : this->tidHbTask := new task id of Heartbeat task
    : this->tidEkgTask := new task id of Ekg task
    : this->tidEmtTask := new task id of Emt task
    : this->vHeartbeat := vHbLocation;
    : this->vHealth := vRteHealth
    : this->bInit := TRUE
    : return := OK
]]       


[[D tRte::Restart (void) ]
[ true => UNDEFINED  
| invalid_pointer (this) ||
  invalid_pointer (vHeartbeat) ||
  invalid_pointer (vHealth) ||
  invalid_pointer (pIpc) ||
  invalid_pointer (pRteErrorStream) || 
  invalid_pointer (pRteStatusStream) ||
  invalid_pointer (pRteDataStream) ||
  invalid_pointer (pScheduler) ||
  invalid_pointer (pRteGizmoArray) ||
  invalid_pointer (pRteGizmoArray[0..CiNumSystemGizmos]) => UNDEFINED
| this->bInit == TRUE =>
    console := console + appropriate warning messages 
    : return := OK
| Can't resume periodic HbGen, Ekg or Emt Tasks =>
    console := console + appropriate error message
    : return := appropriate error code
| true => 
    this->bInit := TRUE
    : this->pRteErrorStream->bInit := TRUE
    : this->pRteStatusStream->bInit := TRUE
    : this->pRteDataStream->bInit := TRUE
    : this->pScheduler->bInit := TRUE
    : this->pRteGizmoArray[0..this->iNRteGizmos]->bInit := TRUE
    : task (this->tidHbTask) resumed 
    : task (this->tidEkgTask) resumed
    : task (this->tidEmtTask) resumed
    : this->tSchedTime := periodically updated with current time when 
      this->pScheduler runs
    : this->RteInterruptServer.bInit := TRUE
]]     

 
[[D tRte::Shutdown (void) ]
[ true => UNDEFINED
|  invalid_pointer (this) ||
  invalid_pointer (vHeartbeat) ||
  invalid_pointer (vHealth) ||
  invalid_pointer (pIpc) ||
  invalid_pointer (pRteErrorStream) || 
  invalid_pointer (pRteStatusStream) ||
  invalid_pointer (pRteDataStream) ||
  invalid_pointer (pScheduler) ||
  invalid_pointer (pRteGizmoArray) ||
  invalid_pointer (pRteGizmoArray [0..this->iNRteGizmos]) => UNDEFINED
| Can't suspend periodic HbGen, Ekg or Emt Tasks =>
    console := console + appropriate error message
    : return := appropriate error code
| this->bInit == FALSE =>
    console := console + appropriate warning messages 
    : return := OK
| true => 
    this->bInit := FALSE
    : this->pRteErrorStream->bInit := FALSE
    : this->pRteStatusStream->bInit := FALSE
    : this->pRteDataStream->bInit := FALSE
    : this->pScheduler->bInit := FALSE
    : this->pRteGizmoArray[0..this->iNRteGizmos]->bInit := FALSE
    : task (this->tidHbTask) suspended
    : task (this->tidEkgTask) suspended
    : task (this->tidEmtTask) suspended
    : this->RteInterruptServer.bInit := FALSE
]]     

[[D tRte::IsOk (void) ]
[ true => UNDEFINED
|  invalid_pointer (this) ||
  invalid_pointer (vHeartbeat) ||
  invalid_pointer (vHealth) ||
  invalid_pointer (pIpc) ||
  invalid_pointer (pRteErrorStream) || 
  invalid_pointer (pRteStatusStream) ||
  invalid_pointer (pRteDataStream) ||
  invalid_pointer (pScheduler) ||
  invalid_pointer (pRteGizmoArray) ||
  invalid_pointer (pRteGizmoArray[0..this->iNRteGizmos]) => UNDEFINED
| *this->pRteErrorStream malfunctioning ||
  *this->pRteStatusStream malfunctioning ||
  *this->pRteDataStream malfunctioning ||
  *this->pScheduler malfunctioning ||
  *this->pRteGizmoArray[0..this->iNRteGizmos] malfunctioning ||
  task (this->tidHbTask) doesn't exist ||
  task (this->tidEkgTask) doesn't exist ||
  task (this->tidEmtTask) doesn't exist => return := FALSE
| true => return := TRUE
]]

[[D tRte::~tRte (void) ]
[ true => UNDEFINED
| invalid_pointer (this) ||
  invalid_pointer (vHeartbeat) ||
  invalid_pointer (vHealth) ||
  invalid_pointer (pIpc) ||
  invalid_pointer (pRteErrorStream) || 
  invalid_pointer (pRteStatusStream) ||
  invalid_pointer (pRteDataStream) ||
  invalid_pointer (pScheduler) ||
  invalid_pointer (pRteGizmoArray) ||
  invalid_pointer (pRteGizmoArray[0..this->iNRteGizmos]) => UNDEFINED
| true =>
    this->pRteErrorStream deleted
    : this->pRteStatusStream deleted
    : this->pRteDataStream deleted
    : this->pIpc deleted 
    : this->pScheduler deleted
    : this->pRteGizmoArray deleted
    : this->pRteGizmoArray[0..this->iNRteGizmos] deleted
    : *this := anything
]]

[[D tRte::HbGen (void) ]
[ invalid_pointer (this) || 
  invalid_pointer (this->vHeartbeat) ||
  this->iMyRteNum >= dimension of this->vHeartbeat array => UNDEFINED
| true => this->vHeartbeat [this->iMyRteNum] := 
	  this->vHeartbeat [this->iMyRteNum] + 1
]]

* tRte::EKG - check on the health of other RTEs
*
* 	Called at every (?) Scheduler interrupt; checks to see whether value of
*	each of the Heartbeat pointers increments within two (?) Scheduler interrupt
*	cycles; if not, then it marks that RTE's health flag as NO_HB_PRESENT.
*
*       (BEH idea 8/9): Two locations, one is "official" health of RTE and one is 
*	"working" value.  At each execution of EKG, it copies "working" value
*	to "official" (i.e. global) health location, then writes an UNHEALTHY 
*	flag to the "working" (i.e. local) location.  Meanwhile, the HBgen task 
*	writes a HEALTHY flag into the "working" location before the next time 
*	the EKG task does its bit.  Thus if the HBgen ever stops, the EKG knows 
*	immediately rather than having to wait.  (?)  
*
*		This seems to require rather precise timing, tho...?
*	(would it be enough just to use Scheduler "offset" parameter?)
*
*			For Incr. 1: Just return OK.

[[D tRte::EKG (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := OK
]]


* tRte::EMT - Takes action if another RTE appears dead
*
* 	Called at every (?) Scheduler interrupt; checks to see whether value of
*	each of the health flag pointers is not HEALTHY.  If so, then it takes
*	appropriate action if any.
*
*       For Incr. 1: Just return OK.

[[D tRte::EMT (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => return := OK
]]


[[D tRte::CreateGizmo (int iGizmoId) ]
[ invalid_pointer (this) || 
  iGizmoId < 0 ||
  iGizmoId > CiNumberOfSystemGizmos ||
  ::IpcMemory.bInit == FALSE ||
  ::PeriodicTaskSet.bInit == FALSE ||
  ::EventDrivenTaskSet.bInit == FALSE  => UNDEFINED
| Unable to allocate new gizmo => return := NULL
| Initialization errors => 
    console := console + appropriate error code
    : ::IpcMemory.ObjectSet := ::IpcMemory.ObjectSet U anything
    : ::PeriodicTaskSet := ::PeriodicTaskSet U anything
    : ::EventDrivenTaskSet := ::EventDrivenTaskSet U anything
    : new gizmo.ecInitError := appropriate error code
    : new gizmo.everything else := anything
    : return := addess of new gizmo
| true => 
    ::IpcMemory.ObjectSet := ::IpcMemory.ObjectSet U appropriate IpcObject 
      for Gizmo (iGizmoId)
    : ::PeriodicTaskSet := ::PeriodicTaskSet U appropriate periodic tasks 
      for Gizmo (iGizmoId)
    : ::EventDrivenTaskSet := ::EventDrivenTaskSet U appropriate event 
      driven task for Gizmo (iGizmoId)
    : return := address of new intialized gizmo
]]

***************/

/*********
* C-language function declarations
* extern "C" { RteInit() } keeps C++ from mangling symbol name for RteInit
*/

extern "C"
{
   ERROR_CODE RteInit (int iWhichCPU, int iWhichRTE, 
     volatile SHMEM_WORD* viwIpcShmemStart, 
     int iIpcBytes, volatile HEARTBEAT* vHbLocation, 
     volatile HEALTH* vRteHealth, volatile INIT_TYPE* vRteInitType );
}


class tGizmo;
class tIpc;
class tErrorStreamSender;
class tRelayStreamSender;
class tScheduler;
class tBoard;

class tRte : public tBaseObject {
  public:
    tRte ();
    ERROR_CODE Init (int iWhichCPU,
        int iWhichRTE, volatile SHMEM_WORD* vswIpcShmemStart, 
        int iIpcBytes, volatile HEARTBEAT* vHbLocation, 
        volatile HEALTH* vRteHealth, 
        volatile INIT_TYPE* vRteInitType,
        BOARD_NAME bnInterruptBoard, int iInterruptPriority);
    virtual ~tRte();
    ERROR_CODE Restart ();
    ERROR_CODE Shutdown ();
    BOOL IsOk ();
    friend ostream& operator<< (ostream& stream, tRte& Rte);
    friend tGizmo *GetGizmoPointer(int iGlobalGizmoIndex);    // eamck
    friend tErrorStreamSender& GetErrorStream ();
    friend tRelayStreamSender& GetStatusStream ();
    friend tRelayStreamSender& GetDataStream ();
    friend tScheduler& GetScheduler ();
    friend TIME GetTime ();
    friend tIpc& GetIpc ();
  
    int WhatsMyCPU();
    int WhatsMyRTE();
    TIME LastIntTime();
  
  protected:

    ERROR_CODE HbGen(void);
    ERROR_CODE EKG(void);
    ERROR_CODE EMT(void);
    tGizmo* CreateGizmo (int iGimzoId);

    int   iMyRteNum;
    int   iMyCpuNum;
    int   tidHbTask;      /* task id for HBgen task for this RTE */
    int   tidEkgTask;     /* task id for EKG task for this RTE */
    int   tidEmtTask;     /* task id for EMT task for this RTE */
    int   iNumberOfGizmos;
    TIME  tSchedTime;     /* updated each time tScheduler::SchedIsr() runs */
 
    volatile HEARTBEAT      *vHeartbeat;
    volatile HEALTH         *vHealth;
    tPeriodicTimeInterrupt  *pRteInterruptServer;
    // tClock class removed - PCI 5/8/98
    //tClock                  RteClock; 
    //tBoard                  *pRteClockBoard;

    tIpc                    *pIpc;
    tErrorStreamSender      *pErrorStream; 
    tRelayStreamSender      *pStatusStream;
    tRelayStreamSender 	    *pDataStream;
    tScheduler              *pScheduler;
    tGizmo                  **pGizmoArray;


  
};     /* class tRte */



/**********************************************************
*************** Global object accessor functions **********
********************** moved to rte.cc ********************
***********************************************************
*/

#endif INC_rteh


