/* $RCSfile: servoDefaults.h,v $  -- structure header for pidLibF.c */
/*
$Header: /home/chara/cvsroot/ople/sys/include/servoDefaults.h,v 1.1.1.1 1998/06/11 21:36:14 chara Exp $
*/
/* Brad Hines - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a,22Oct96,beh   Servo parameter default values
*/

/*
DESCRIPTION
Contains values for the servo parameters for the increment 1
delay line.
*/


#ifndef INC_servoDefaultsh
#define INC_servoDefaultsh

                                             /* JPL card: 8MHz/65k^2 */
#define PZT_GAIN   (-50.0)                  /* dimensionless gain */


#define VC_FF_GAIN     (-0.3)    /* scale factor for PZT feed forward value */

#define VC_PID_GAIN (10.0)              /* dimensionless gain */
#define VC_TAU1     0.06               /* servo time constants in seconds */
#define VC_TAU2     0.06
#define VC_TAUD     0.0001

#define MOTOR_GAIN  (0.15)


#define DEFAULT_VC_FF_GAIN   (VC_FF_GAIN)  /* scale factor for PZT feed fwd value */
#define DEFAULT_MOTOR_GAIN   (MOTOR_GAIN)
#define DEFAULT_VC_PID_GAIN  (VC_PID_GAIN)
#define DEFAULT_VC_PID_ZERO1 (VC_TAU1)
#define DEFAULT_VC_PID_ZERO2 (VC_TAU2)
#define DEFAULT_VC_PID_POLE  (VC_TAUD)

#endif  /* INC_servoDefaultsh */
