/* $RCSfile: configShare.h,v $ - shared config constants header file */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/include/share/configShare.h,v 1.3 1998/08/17 21:01:21 phil Exp $
*/
/* Kevin Young - Jet Propulsion Laboratory */


#ifndef INC_rteConfigShareh
#define INC_rteConfigShareh

/*************************************************************************
*  This file defines constants that are shared between the embedded system
*  and the UNIX system.  All definitions here are extern because they are 
*  defined in configShare.cc.  This prevents multiple copies of constants
*  in the object file.  Similar constants for embedded system only are
*  defined in configMgr.h and configConsts.cc
****/

#define NUM_RTE0_GIZMOS (2)
#define NUM_RTE1_GIZMOS (2)
#define NUM_RTE2_GIZMOS (2)
#define NUM_RTE3_GIZMOS (0)
#define NUM_RTE4_GIZMOS (0)
#define NUM_SYS_GIZMOS ((NUM_RTE0_GIZMOS) + (NUM_RTE1_GIZMOS) + \
                        (NUM_RTE2_GIZMOS) + (NUM_RTE3_GIZMOS) + \
                        (NUM_RTE4_GIZMOS))
#define NUM_DELAY_LINE_TARGETS (2)
#define NUM_DELAY_LINES (5)


extern const int CiNumInstruments;
extern const int CiNumFringeTrackers;
extern const int CiNumExtMets;
extern const int CiNumStarTrackers;

extern const int CiStarImageHSize;
extern const int CiStarImageVSize;
extern const int CiFringeImageHSize;
extern const int CiFringeImageVSize;

// SYSTEM GIZMO INDICES - every gizmo has a unique integer identifier that
// corresponds to the position in the system gizmo info array of a particular
// gizmo`s configuration information  IMPORTANT:: THESE NUMBERS MUST MATCH THE
// INDEX OF THE CORRECT GIZMO INFO IN THE SYSTEM GIZMO TYPE ARRAY

extern const int INVALID_GIZMO;
extern const int CiInst;
extern const int CiDlGsu0;
extern const int CiDlGsu1;
extern const int CiDlGsu2;
extern const int CiDlGsu3;
extern const int CiDlGsu4;
//extern const int CiFt0;
//extern const int CiEm0;
//extern const int CiSt0;
//extern const int CiSt1;

//extern const int CiDlBrassBoard1;
//extern const int CiDlBrassBoard2;
//extern const int CiFt1;
//extern const int CiEm1;
//extern const int CiFt2;
//extern const int CiEm2;



// RTE GIZMO CONFIGURATION 

// RTE0 has the instrument, FT0, and EM0 gizmos referenced by its index in 
// the system wide gizmo array
// RTE1 has the other gizmos

extern const int CiRte0Gizmos [];

extern const int CiRte1Gizmos [];

extern const int CiRte2Gizmos [];

extern const int CiRte3Gizmos [];

extern const int CiRte4Gizmos [];


// GUI GIZMOs - the GUI numbers gizmos by type so that
// if there are n delay lines DL0 = 0 and DLn = n etc
// These gui indexes are mapped into system wide gizmo id numbers using the
// constant arrays below

extern const int CiGuiDls[];
extern const int CiGuiFts[];
extern const int CiGuiEms[];


/*******
Make sure that Delay lines are paired correctly with the FTs and Ems for the
current configuration

Target Source order = {Manual,OpenLoop,FT,EM}
*********/


extern const int CiDlGsuTargetSourceArray[];

//extern const int CiDlBb2TargetSourceArray[];
//extern const int CiDlBb1TargetSourceArray[];

 

extern const GIZMO_TYPE CgtSystemGizmoTypes[];
extern const int CiGizmoSubindexArray[];


GIZMO_TYPE PubGetGizmoType (int iGizmoId);

void GetEmbeddedSystemGizmoInfo (GIZMO_TYPE gtGenericType, int iGuiIndex,
                                 GIZMO_TYPE& gtSpecificType, int& iGizmoId);

#endif INC_rteConfigShareh
