 /* $RCSfile: stIoSet.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/st/stIoSet.h,v 1.1.1.1 1998/06/11 21:36:17 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */

/*
modification history
--------------------
01b  22Sep97,eamck  taken over
01a  27Aug97,rlj    written
*/

#ifndef INC_stIoSeth
#define INC_stIoSeth


#include "st/starSensor.h"
#include "matrix.h"
#include "multiActuator.h"

/***********************

[[D tStCompleteIoSet::tStCompleteIoSet(const tStGizmoInfo& GizmoInfo) ]
[ invalid_pointer(this) ||
      invalid_reference(GizmoInfo.iiStarImageId) ||
           ::IpcMemory.bInit == FALSE => UNDEFINED
| CanAllocateIpcObject(::IpcMemory,GizmoInfo.iiStarImageId) == FALSE ||
       CanAllocateIpcObject(::IpcMemory, 
           GizmoInfo.iiStarImageId.iiBuffer1Id) == FALSE ||
       CanAllocateIpcObject(::IpcMemory,
           GizmoInfo.iiStarImageId.iiBuffer2Id) == FALSE ||
       CanAllocateIpcObject(::IpcMemory,
         ConfigManager.GetGizmoInfo(GizmoInfo.WapGizmoId()).GetStBufferId())
         == FALSE 
       => *this := anything
| true =>
    this->StarSensor.dValue := 0.0
    : this->StarSensor.dOffset := 0.0
    : this->StarSensor.StarImageBuffer.ecInitError := OK
    : this->StarSensor.StarImageBuffer.bInit := TRUE
    : this->StarSensor.StarImageBuffer.bObjectValid := TRUE
    : this->StarSensor.StarImageBuffer.iiIndirectionDblBufferId :=
                                                  GizmoInfo.iiStarImageId
    : ::IpcMemory.ObjectSet := ::IpcMemory.ObjectSet U
          NewObjectSet(::IpcMemory,GizmoInfo.iiStarImageId) U
          NewObjectSet(::IpcMemory,GizmoInfo.iiStarImageId.iiBuffer1Id) U
          NewObjectSet(::IpcMemory,GizmoInfo.iiStarImageId.iiBuffer2Id)
    : this->StarSensor.StarImage.GizmoInfo.iStarImageHSize :=
                                                  GizmoInfo.iStarImageHSize
    : this->StarSensor.StarImage.GizmoInfo.iStarImageVSize :=
                                                  GizmoInfo.iStarImageVSize
    : this->StarSensor.StarImage.Image := NULL Image 
]]


[[D tStCompleteIoSet::~tStCompleteIoSet(void) ]
[ invalid_pointer(this)  => UNDEFINED
| true => *this := anything
]]

[[D tStCompleteIoSet::GetStarImage(void) ]
[ invalid_pointer(this)  => UNDEFINED
| true => 
    return := reference to this->StarSensor.StarImage
]]

[[D tStCompleteIoSet::SetXformParams(const tMatrix& Xform,const tVector& Home) ]
set detector-to-FSM transfrom matrix
[ invalid_pointer(this) ||
  invalid_reference(Xform) ||
  invalid_reference(Home) => UNDEFINED
| Xform not 3x2 matrix => 
   console := console + appropriate error message
| Home not vector of length 3 =>
   console := console + appropriate error message
| true =>
   this->Fsm.XformDetToAct := Xform
   : this->Fsm.HomePosition := Home
]]

[[D tStCompleteIoSet::SetCalParams(const tCalibrateCmd& Params) ]
set calibration parameters
[ invalid_pointer(this)  => UNDEFINED
| invalid_reference(Params) => UNDEFINED
| true =>
    this->Fsm.DitherParameters := Params
]]

*******************/


class tStGizmoInfo;


class tStCompleteIoSet {
  public:
    tStCompleteIoSet(const tStGizmoInfo& GizmoInfo);
    ~tStCompleteIoSet(void);
    tImage& GetStarImage(void);
    void SetXformParams(const tMatrix& Xform,const tVector& Home);
    void SetCalParams(const tStCalibrateCmd& Params);

    tStarSensor StarSensor;
    tPositionMultiActuator Fsm;
    ///tIpcDblBufferAccessor<tIpcPoint> Wap; FOR 5B
};

#endif
