/* $RCSfile: stError.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/stError.h,v 1.1.1.1 1998/06/11 21:36:14 chara Exp $
*/
/* Richard Johnson - Jet Propulsion Laboratory */

/*
modification history
--------------------
01b  22Sep97,eamck  taken over
01a  29Aug97,rlj    written
*/

#ifndef INC_stErrorh
#define INC_stErrorh




//Errors

#define S_stgizmo_COULD_NOT_CREATE_COMMAND_ENGINE      (M_stgizmo | 0x01)
#define S_stgizmo_UNRECOGNIZED_COMMAND                 (M_stgizmo | 0x02)
#define S_stgizmo_UNABLE_TO_SEND_STATUS                (M_stgizmo | 0x03)
#define S_stgizmo_GIZMO_INFO_NOT_ST                    (M_stgizmo | 0x04)
#define S_stgizmo_INVALID_NUMBER_OF_SERVO_MODES        (M_stgizmo | 0x05)
#define S_stgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS   (M_stgizmo | 0x06)
#define S_stgizmo_CANT_CONSTRUCT_IO_OR_CTLR_SET        (M_stgizmo | 0x07)
#define S_stgizmo_ERROR_UPDATING_STAR_SENSOR           (M_stgizmo | 0x08)
#define S_stgizmo_TRANSFORM_UNDEFINED                  (M_stgizmo | 0x09)


//TraceMarks
#define S_stgizmo_ENTERING_ST_GIZMO_CONSTRUCTOR        (M_stgizmo | 0x1001)
#define S_stgizmo_ASSIGNING_CTLR_GROUPS_TO_MODES       (M_stgizmo | 0x1002)
#define S_stgizmo_ASSIGNING_CTLRS_TO_PARTITIONS        (M_stgizmo | 0x1003)
#define S_stgizmo_ENABLING_BASE_CLASS_TASKS            (M_stgizmo | 0x1004)
#define S_stgizmo_LEAVING_ST_GIZMO_CONSTRUCTOR         (M_stgizmo | 0x1005)
#define S_stgizmo_ST_GIZMO_DESTRUCTOR                  (M_stgizmo | 0x1006)
#define S_stgizmo_RESTART                              (M_stgizmo | 0x1007)
#define S_stgizmo_SHUTDOWN                             (M_stgizmo | 0x1008)
#define S_stgizmo_ENTERING_COLLECTSTATUS               (M_stgizmo | 0x1009)
#define S_stgizmo_GETTING_IMAGE_STATUS                 (M_stgizmo | 0x100a)
#define S_stgizmo_SENDING_STATUS_BLOCK                 (M_stgizmo | 0x100b)
#define S_stgizmo_SENDING_STATUS_IMAGE                 (M_stgizmo | 0x100c)
#define S_stgizmo_LEAVING_COLLECTSTATUS                (M_stgizmo | 0x100d)
#define S_stgizmo_ENTERING_DISPATCH                    (M_stgizmo | 0x100e)
#define S_stgizmo_LEAVING_DISPATCH                     (M_stgizmo | 0x100f)
#define S_stgizmo_PING                                 (M_stgizmo | 0x1010)
#define S_stgizmo_ENTERING_OFF_METHOD                  (M_stgizmo | 0x1011)
#define S_stgizmo_LEAVING_OFF_METHOD                   (M_stgizmo | 0x1012)
#define S_stgizmo_ENTERING_TRACK_METHOD                (M_stgizmo | 0x1013)
#define S_stgizmo_LEAVING_TRACK_METHOD                 (M_stgizmo | 0x1014)
#define S_stgizmo_ST_COMPLETE_IO_SET_CONSTRUCTOR       (M_stgizmo | 0x1015)
#define S_stgizmo_ST_COMPLETE_IO_SET_DESTRUCTOR        (M_stgizmo | 0x1016)
#define S_stgizmo_ENTERING_ST_GIZMOINFO_CONSTRUCTOR    (M_stgizmo | 0x1017)
#define S_stgizmo_LEAVING_ST_GIZMOINFO_CONSTRUCTOR     (M_stgizmo | 0x1018)
#define S_stgizmo_STAR_SENSOR_CONSTRUCTOR              (M_stgizmo | 0x1019)
#define S_stgizmo_STAR_SENSOR_UPDATE                   (M_stgizmo | 0x101a)
#define S_stgizmo_ST_CONTROLLER_DATA_CONSTRUCTOR       (M_stgizmo | 0x101b)
#define S_stgizmo_ST_CONTROLLER_CONSTRUCTOR            (M_stgizmo | 0x101c)
#define S_stgizmo_ST_CONTROLLER_DESTRUCTOR             (M_stgizmo | 0x101d)
#define S_stgizmo_ST_OFF_CONTROLLER_CONSTRUCTOR        (M_stgizmo | 0x101e)
#define S_stgizmo_ENTERING_ST_OFF_CONTROLLER_INIT      (M_stgizmo | 0x101f)
#define S_stgizmo_LEAVING_ST_OFF_CONTROLLER_INIT       (M_stgizmo | 0x1020)
#define S_stgizmo_ST_TRACK_CONTROLLER_CONSTRUCTOR      (M_stgizmo | 0x1021)
#define S_stgizmo_ST_TRACK_CONTROLLER_DESTRUCTOR       (M_stgizmo | 0x1022)
#define S_stgizmo_ENTERING_ST_TRACK_CONTROLLER_CALCULATE (M_stgizmo | 0x1023)
#define S_stgizmo_UPDATE_STAR_SENSOR                   (M_stgizmo | 0x1024)
#define S_stgizmo_CALCULATE_CENTROID                   (M_stgizmo | 0x1025)
#define S_stgizmo_UPDATE_CONTROLLER_DATA_BLOCK         (M_stgizmo | 0x1026)
#define S_stgizmo_LEAVING_ST_TRACK_CONTROLLER_CALCULATE (M_stgizmo | 0x1027)
#define S_stgizmo_ENTERING_CALCULATE_CENTROID          (M_stgizmo | 0x1028)
#define S_stgizmo_LEAVING_CALCULATE_CENTROID           (M_stgizmo | 0x1029)
#define S_stgizmo_ST_COMPLETE_CONTROLLER_SET_CONSTRUCTOR (M_stgizmo | 0x102a)

#define S_stgizmo_ENTERING_CALIBRATE_METHOD              (M_stgizmo | 0x102b)
#define S_stgizmo_LEAVING_CALIBRATE_METHOD               (M_stgizmo | 0x102c)
#define S_stgizmo_ENTERING_HOME_METHOD                   (M_stgizmo | 0x102d)
#define S_stgizmo_LEAVING_HOME_METHOD                    (M_stgizmo | 0x102e)
#define S_stgizmo_ENTERING_SSP_METHOD                    (M_stgizmo | 0x102f)
#define S_stgizmo_LEAVING_SSP_METHOD                     (M_stgizmo | 0x1030)
#define S_stgizmo_ENTERING_ST_CONTROLLER_CALCULATE       (M_stgizmo | 0x1031)
#define S_stgizmo_LEAVING_ST_CONTROLLER_CALCULATE        (M_stgizmo | 0x1032)
#define S_stgizmo_ST_COMPLETE_CONTROLLER_SET_DESTRUCTOR  (M_stgizmo | 0x1033)

//Messages

#define S_stgizmo_STAR_TRACKER_ALIVE             (M_stgizmo | 0x2001)
#define S_stgizmo_SETTING_SERVO_PARAMETERS       (M_stgizmo | 0x2002)
#define S_stgizmo_SERVO_PARAMETERS_SET           (M_stgizmo | 0x2003)
#define S_stgizmo_OFF_START                      (M_stgizmo | 0x2004)
#define S_stgizmo_OFF_COMPLETE                   (M_stgizmo | 0x2005)
#define S_stgizmo_TRACK_START                    (M_stgizmo | 0x2006)
#define S_stgizmo_TRACK_IN_PROGRESS              (M_stgizmo | 0x2007)
#define S_stgizmo_TRACK_ABORTED                  (M_stgizmo | 0x2008)
#define S_stgizmo_CALIBRATE_IN_PROGRESS          (M_stgizmo | 0x2009)




#endif INC_stErrorh
