/* $RCSfile: tasks.h,v $ - Type definitions for system-wide stuff */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/tasks.h,v 1.2 1999/01/21 00:35:33 theo Exp $
*/
/* Brad Hines - Jet Propulsion Laboratory */
 
/*
modification history
--------------------
01a,beh,25Sep96    written
*/
 
/*
DESCRIPTION
VxWorks task periods, priorities, stack sizes, options, etc.
*/

#ifndef INC_tasksh
#define INC_tasksh


/***  DL-specific defines: *****/

#define DL_READ_LIMIT_TASK_PRIORITY (34)
#define DL_READ_LIMIT_TASK_PERIOD   (1600)
#define DL_READ_LIMIT_TASK_OFFSET   (0)


#define DL_RELAY_PRIO             (65)
#define DL_RELAY_TASK_OPTIONS     (VX_FP_TASK)
#define DL_RELAY_STKSZ            (16384)



extern const   TIME CtRelayerPeriod;
extern const   TIME CtRelayerOffset;
extern const   int  CiRelayerPriority;

#define SCHED_TELNETD_PRIORITY    (49)
#define SCHED_RLOGIND_PRIORITY    (49)
#define SCHED_SHELL_PRIORITY      (48)

#define MUTEX_TASK_OPTIONS      (VX_FP_TASK)
#define MUTEX_TASK_STACK_SIZE   (16384)
#define MUTEX_TASK_PRIORITY     (140)
/*****************************************************************
 *Changed by Theo..... this is not long enough for our delaylines.
 *****************************************************************/
// #define MUTEX_DEFAULT_TIMEOUT   (300*sysClkRateGet())         /* 5 minutes */
#define MUTEX_DEFAULT_TIMEOUT   (600*sysClkRateGet())         /* 7 minutes */

#define WATCHDOG_HANDLER_DEFAULT_PRIORITY      (80)
#define WATCHDOG_HANDLER_DEFAULT_TASK_OPTIONS  (VX_FP_TASK)
#define WATCHDOG_HANDLER_DEFAULT_STACK_SIZE    (16384)

#ifdef INCR1
// These should be properties of the tTask class
#define SCHED_INIT_PRIORITY     (150)
#define SCHED_PANIC_PRIORITY    (250)
#define SCHED_TASK_OPTIONS      (VX_FP_TASK)
#define SCHED_STACK_SIZE        (32768)
   /* other sched constants in instRte and dlRte files */
#endif


/* Assuming for now that these values will be the same for all RTEs: */
 
#define HB_TASK_NAME            "HbTask"
extern const   TIME CtHbgenPeriod;
extern const   TIME CtHbgenOffset;
extern const   int  CiHbgenPriority;
  
#define EKG_TASK_NAME           "EkgTask"
extern const   TIME CtEkgPeriod;
extern const   TIME CtEkgOffset;
extern const   int  CiEkgPriority;

   
#define EMT_TASK_NAME           "EmtTask"
extern const   TIME CtEmtPeriod;
extern const   TIME CtEmtOffset;
extern const   int  CiEmtPriority;

#endif  /* INC_tasksh */

