/* $RCSfile: telemetryEvent.h,v $*/
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/include/telemetryEvent.h,v 1.1.1.1 1998/06/11 21:36:14 chara Exp $
*/
/* Richard L. Johnson - Jet Propulsion Laboratory */
 
/*
$log$
*/

/*
DESCRIPTION

Class definition for telemetry events.
*/


#ifndef INC_telemetryEventh
#define INC_telemetryEventh

#include <msgQLib.h>

/************

[[D tTelemetryEvent::tTelemetryEvent_t (const tTelemetryEvent& Event) ]
Copy constructor: This is the only constructor that is public. This allowing 
the copying of a telemetry event constructed by the telemetry mananger.
[ invalid_pointer (this) ||
  invalid_reference (Event) => UNDEFINED
| true =>
    this->EventId = Event.EventId;
    : this->iEventMsgQId = Event.iEventMsgQId;
]]
  
[[D tTelemetryEvent::Trigger (void) ]
Triggers a telemetry event notifying the telemetry mananger by sending it's
event id on the appropriate message queue.
[ invalid_pointer (this) => UNDEFINED
| error conditions => appropriate action
| true => this->EventId put on VxWorksMsgQ (this->iEventMsgQId)
]]

*********/

class tTelemetryManager;
class tTelemetryItemBase ;

enum DELTA_TYPE { DT_LINEAR, DT_PERCENT };

class tTelemetryEvent {
   public:
     virtual void Trigger (); 
     tTelemetryEvent (const tTelemetryItemBase& EventIdIn, MSG_Q_ID miQid);
   private:
     friend tTelemetryManager;
     tTelemetryEvent (int iId, MSG_Q_ID iMsgQ);
     virtual ~tTelemetryEvent ();
    
     tTelemetryItemBase& EventId;
     int iEventMsgQId;
};

#endif INC_telemetryEventh