/* $RCSfile: wapIoSet.h,v $ */
/* CM Info: $Header: /home/chara/cvsroot/ople/sys/include/wap/wapIoSet.h,v 1.1.1.1 1998/06/11 21:36:18 chara Exp $
*/
/* Russ Brill - Jet Propulsion Laboratory */

#ifndef INC_wapIoSeth
#define INC_wapIoSeth


#include "ipcDblBufferAccessor.h"
#include "matrix.h"
#include "paddle.h"
#include "wap/stepperMultiActuator.h"
#include "st/starSensor.h"

/***********************

[[D tWapCompleteIoSet::tWapCompleteIoSet(const tWapGizmoInfo& GizmoInfo) ]
[ invalid_pointer(this) ||
      invalid_reference(GizmoInfo.iiStarImageId) ||
           ::IpcMemory.bInit == FALSE => UNDEFINED
| CanAllocateIpcObject(::IpcMemory,GizmoInfo.iiStarImageId) == FALSE ||
  CanAllocateIpcObject(::IpcMemory,GizmoInfo.iiStarImageId.iiBuffer1Id) == FALSE ||
  CanAllocateIpcObject(::IpcMemory,GizmoInfo.iiStarImageId.iiBuffer2Id) == FALSE ||
  CanAllocateIpcObject(::IpcMemory,
   ConfigManager.GetGizmoInfo(GizmoInfo.StGizmoId()).GetStBufferId())
   == FALSE
   => *this := anything
| true =>
    this->AcquisitionSensor.dValue := 0.0
    : this->AcquisitionSensor.dOffset := 0.0
    : this->AcquisitionSensor.StarImageBuffer.ecInitError := OK
    : this->AcquisitionSensor.StarImageBuffer.bInit := TRUE
    : this->AcquisitionSensor.StarImageBuffer.bObjectValid := TRUE
    : this->AcquisitionSensor.StarImageBuffer.iiIndirectionDblBufferId :=
                                                  GizmoInfo.iiStarImageId
    : ::IpcMemory.ObjectSet := ::IpcMemory.ObjectSet U
          NewObjectSet(::IpcMemory,GizmoInfo.iiStarImageId) U
          NewObjectSet(::IpcMemory,GizmoInfo.iiStarImageId.iiBuffer1Id) U
          NewObjectSet(::IpcMemory,GizmoInfo.iiStarImageId.iiBuffer2Id)
    : this->AcquisitionSensor.StarImage.GizmoInfo.iStarImageHSize :=
                                                  GizmoInfo.iStarImageHSize
    : this->AcquisitionSensor.StarImage.GizmoInfo.iStarImageVSize :=
                                                  GizmoInfo.iStarImageVSize
    : this->AcquisitionSensor.StarImage.Image := NULL Image 
]]


[[D tWapCompleteIoSet::~tWapCompleteIoSet(void) ]
[ invalid_pointer(this)  => UNDEFINED
| true => *this := anything
]]

[[D tWapCompleteIoSet::GetStarImage(void) ]
[ invalid_pointer(this)  => UNDEFINED
| true => 
    return := reference to this->AcquisitionSensor.StarImage
]]

[[D tWapCompleteIoSet::SetXformParams(const tMatrix& Xform,const tVector& Home) ]
set detector-to-FSM transfrom matrix
[ invalid_pointer(this) ||
  invalid_reference(Xform) ||
  invalid_reference(Home) => UNDEFINED
| Xform not 2x3 matrix => 
   console := console + appropriate error message
| Home not vector of length 3 =>
   console := console + appropriate error message
| true =>
   this->Collector.XformDetToAct := Xform
   : this->Collector.HomePosition := Home
]]

[[D tWapCompleteIoSet::SetCalParams(const tCalibrateCmd& Params) ]
set calibration parameters
[ invalid_pointer(this)  => UNDEFINED
| invalid_reference(Params) => UNDEFINED
| true =>
    this->Collector.dFrequency := Params.dFrequency
  : this->Collector.dAmplitude := 2 * PI * Params.dFrequency * Params.dAmplitude
]]

*******************/


class tWapGizmoInfo;
class tWapCalibrateCmd;

class tWapCompleteIoSet {
  public:
    tWapCompleteIoSet(const tWapGizmoInfo& GizmoInfo);
    ~tWapCompleteIoSet(void);
    tImage& GetStarImage(void);
    void SetXformParams(const tMatrix& Xform,const tVector& Home);
    void SetCalParams(const tWapCalibrateCmd& Params);

    tStarSensor AcquisitionSensor;
    tPaddle Paddle;
    tIpcDblBufferAccessor<tIpcPoint> Fsm;
    tStepperMultiActuator Collector;
};

#endif
