/* $RCSfile: wapCommands.h,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/include/wapCommands.h,v 1.1.1.1 1998/06/11 21:36:15 chara Exp $
*/
/* Russ Brill - Jet Propulsion Laboratory */
 
#ifndef INC_wapCommandsh
#define INC_wapCommandsh

#include "wapTypes.h"

class tWapPingCmd : public tIsitCmd {};
class tWapOffCmd : public tIsitCmd {};
class tWapTrackCmd : public tIsitCmd {};
class tWapHomeCmd : public tIsitCmd {};
class tWapCalibrateCmd : public tIsitCmd {
   public:
      double dCalFrequency;    //Calibration dither frequency (Hz)
      double dCalAmplitude;    //Calibration dither amplitude (steps)
      int iCalActuator;        //Actuator to dither (1,2,3)
};

struct tWapControllerParams {
   double dGain;
};

struct tWapServoParams {
      tWapControllerParams ControllerParams;
      double XformDetToFsm[2][2];//detector to Collector transform (steps/pixel)
      double Home[2];            //home position (steps)
};

class tWapSetServoParamsCmd : public tIsitCmd {
   public:
      tWapServoParams Params;
};

class tWapMoveCmd : public tIsitCmd {
   public:
      tPoint Delta;
};

#endif INC_ftCommandsh
