/* $RCSfile: connectionP.h,v $ - External Interface routines -  */
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/inst/include/connectionP.h,v 1.1.1.1 1998/06/11 21:36:36 chara Exp $
*/
/* Kevin Young - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a,14Aug97,ky       Initial creation
*/

/*
DESCRIPTION
  External Interface header
*/

/****************************************************************************

[[D tConnection::CommandLoop  (void) ]
[ invalid_pointer (this) ||
  invalid_reference (CommandHandler) ||
  invalid iSocketInUse => UNDEFINED
| OS cannot successfully perform read() =>
  this->bDisconnected := TRUE
  : close(this->iSocketInUse)
| command from this->iSocketInUse == RESET ||
  command from this->iSocketInUse == DISCONNECT =>
    this->bDisconnected := TRUE
    : close(this->iSocketInUse)
| true => command from this->iSocketInUse sent to this->CommandHandler
]]

[[D tConnection::readn(int sd,char *ptr,int size) ]
[ invalid_pointer (this) ||
  invalid_pointer (ptr) ||
  invalid sd => UNDEFINED
| number of bytes return by read() on Tag < 0  =>
    return := number of bytes read 
| number of bytes return by read() on Tag == 0  =>
    return := (size -  number of remaining bytes to be read)
| true =>
    return := size
]]

[[D tConnection::writen(int sd,char *ptr,int size) ]
[ invalid_pointer (this) ||
  invalid_pointer (ptr) ||
  invalid sd => UNDEFINED
| number of bytes return by write() on Tag <= 0  =>
    return := number of bytes written 
| true =>
    return := size
]]

[[D tConnection::TerminateConnection(int signo) ]
[ invalid_pointer (this) => UNDEFINED
| Task id iCommandLoopTaskId does not exist =>
  *this := anything
| true =>
  *this := anything
  : this->bDisconnected := TRUE
  : close socket this->iSocketInUse
  : Command Loop task deleted
]]

****************************************************************************/

