/* $RCSfile: configConsts.cc,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/inst/initMgr/configConsts.cc,v 1.7 1998/12/08 23:10:31 chara Exp $
*/

/* Beth McKenney - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a,27Jun97,eamck    compiled from consts in various header files 
*/


#include "isit.h"
#include "dlGizmoInfo.h"
#include "share/configShare.cc"    /* Shared System Config Info */
#include "stCommands.h"
#include "stTypes.h"

/*******************************************************************/
/****************  constants from isit.h  **************************/
/*******************************************************************/



const   TIME CtRelayerPeriod  = 10000;
const   TIME CtRelayerOffset  = 0;
const   int  CiRelayerPriority = 40;

const   TIME CtHbgenPeriod = 12000;
const   TIME CtHbgenOffset = 0;
const   int  CiHbgenPriority = 48;

const   TIME CtEkgPeriod = 12000;
const   TIME CtEkgOffset = 0;
const   int  CiEkgPriority = 47;

const   TIME CtEmtPeriod = 12000;
const   TIME CtEmtOffset = 0;
const   int  CiEmtPriority = 60;


/*******************************************************************/
/******************* System Configuration **************************/
/*******************************************************************/

const int CiRte0SchedPriority = 10;
const int CiRte0SchedMaxTasks = 32;
const int CiRte0SchedRate = 5000;

const int CiRte1SchedPriority = 10;
const int CiRte1SchedMaxTasks = 32;
const int CiRte1SchedRate = 5000;

const int CiRte2SchedPriority = 10;
const int CiRte2SchedMaxTasks = 32;
const int CiRte2SchedRate = 5000;

const int CiRteSchedPriority [NRTES] = {CiRte0SchedPriority,
                                        CiRte1SchedPriority,
                                        CiRte2SchedPriority};

const int CiRteSchedMaxTasks [NRTES] = {CiRte0SchedMaxTasks,
                                        CiRte1SchedMaxTasks,
                                        CiRte2SchedMaxTasks};

const int CiRteSchedRate [NRTES] = {CiRte0SchedRate,
                                    CiRte1SchedRate,
                                    CiRte2SchedRate};




/*******************************************************************/
/*******************  Config Manager Constants *********************/
/*******************************************************************/

// Fifo Depths

const int CiCommandFifoDepth = 100;                       // FIFO <ISIT_CMD>
const int CiDataFifoDepth = 0x80000;                      // FIFO <BYTE>
const int CiStatusFifoDepth = 0x80000;                    // FIFO <BYTE>
const int CiRteErrorFifoDepth = (256*sizeof(ERROR_INFO)); // FIFO <BYTE>

const int ERROR_Q_MAXMSGS = 256;


/*******
Make sure that Delay lines are paired correctly with the FTs and Ems for the
current configuration

Target Source order = {Manual,OpenLoop,FT,EM}
*********/


const int CiDlGsuTargetSourceArray[NUM_DELAY_LINE_TARGETS] = {
    CiInst,CiInst};

//const int CiDlBb2TargetSourceArray[NUM_DELAY_LINE_TARGETS] = {
//    CiInst,CiInst,CiFt0,CiEm0};
//    
//const int CiDlBb1TargetSourceArray[NUM_DELAY_LINE_TARGETS] = {
//    CiInst,CiInst,CiFt0,CiEm0};


/*******************************************************************/
/************************ DL SERVO MODES ***************************/
/*******************************************************************/

//const int CiBb1NumServoModes = 8;
//const int CiBb2NumServoModes = 8;
const int CiGsuNumServoModes = 8;


/*******************************************************************/
/************************ DL SERVO PARAMS **************************/
/*******************************************************************/

/********************** tQuicDlServoParams, BB1 ********************/
//const tQuicDlServoParams CspBb1ServoParams(
//                  1.0,       // dPztGain
//                  0.25,      // dPztLagPole
//                  0.0025,    // dPztLagZero
//                  5000.0,    // dPztServoRate
//                  TRUE,      // bLagEnabled
//                  TRUE,      // bPztServoEnabled
//
//                  1.0,       // dSlewToTrackThresholdInMm
//                  7.5,       // dTrackToSlewThresholdInMm
//
//                  0.008,     // dVc1TrackPidGain
//                  0.5,       // dVc1TrackPidZero1
//                  0.05,      // dVc1TrackPidZero2
//                  0.005,     // dVc1TrackPidPole
//                  -1.65,     // dVc1LaserFeedforwardGain
//                  1.0,       // dVc1LaserFeedforwardFilterMemory
//                  1000.0,    // dVc1TrackServoRate
//                  TRUE,      // bVc1TrackServoEnabled
//
//                  0.035,     // dVc1SlewPidGain
//                  0.0,       // dVc1SlewPidZero1
//                  0.05,      // dVc1SlewPidZero2
//                  0.005,     // dVc1SlewPidPole
//                  1000.0,    // dVc1SlewServoRate
//                  TRUE,      // bVc1SlewServoEnabled
//
//                  0.0000975, // dMotorGain
//                  1.0,       // dMotorFeedForwardGain
//                  100.0,     // dMotorServoRate
//                  TRUE,      // bMotorServoEnabled
//                  0.0,       // dMotorErrorGain
//                  1.0        // dDiagLaserScale
//                  );
//
//*************************  tQuicDlServoParams, BB2  *******************/
//const tQuicDlServoParams CspBb2ServoParams(
//                  1.0,       // dPztGain
//                  1.0,       // dPztLagPole
//                  1.0,       // dPztLagZero
//                  5000.0,    // dPztServoRate
//                  TRUE,      // bLagEnabled
//                  TRUE,      // bPztServoEnabled;
//  
//                  1.0,       // dSlewToTrackThresholdInMm
//                  7.5,       // dTrackToSlewThresholdInMm
//  
//                  1.0,       // dVc1TrackPidGain
//                  1.0,       // dVc1TrackPidZero1
//                  1.0,       // dVc1TrackPidZero2
//                  1.0,       // dVc1TrackPidPole
//                  1.0,       // dVc1LaserFeedforwardGain
//                  1.0,       // dVc1LaserFeedforwardFilterMemory
//                  1000.0,    // dVc1TrackServoRate
//                  TRUE,      // bVc1TrackServoEnabled
//  
//                  1.0,       // dVc1SlewPidGain
//                  1.0,       // dVc1SlewPidZero1
//                  1.0,       // dVc1SlewPidZero2
//                  1.0,       // dVc1SlewPidPole
//                  1000.0,    // dVc1SlewServoRate
//                  TRUE,      // bVc1SlewServoEnabled
//  
//                  1.0,       // dMotorGain
//                  1.0,       // dMotorFeedForwardGain
//                  100.0,     // dMotorServoRate
//                  TRUE,      // bMotorServoEnabled
//                  0.0,       // dMotorErrorGain
//                  1.0        // dDiagLaserScale
//                  );
  
/************************  tGsuDlServoParameters ***********************/
const tGuiGsuDlServoParameters CgspGuiGsuServoParams = {
                  5000.0,    // dPztServoRate
                  1000.0,    // dVcServoRate
                  100.0,     // dMotorServoRate

                  TRUE,      // bPztServoEnabled
                  TRUE,      // bLagEnabled
                  TRUE,      // bVc1TrackServoEnabled
                  TRUE,      // bVc1StabilizeServoEnabled
                  TRUE,      // bVc2TrackServoEnabled
                  TRUE,      // bVc2StabilizeServoEnabled
                  TRUE,      // bMotorServoEnabled

                  -160.0,     // dPztGain
                  0.05,      // dPztLagPole
                  0.005,     // dPztLagZero

                  -25.0,      // dVc1StabilizePidGain
                  0.0,       // dVc1StabilizePidZero1
                  0.05,      // dVc1StabilizePidZero2
                  0.005,     // dVc1StabilizePidPole
 
                  -0.0025,    // dVc1TrackPidGain
                  0.5,       // dVc1TrackPidZero1
                  0.05,      // dVc1TrackPidZero2
                  0.005,     // dVc1TrackPidPole
                  -11.2,      // dVc1TrackLaserFeedforwardGain
                  1.0,       // dVc1TrackFilterMemory

                  20.0,     // dVc2StabilizePidGain
                  0.0,       // dVc2StabilizePidZero1
                  0.25,      // dVc2StabilizePidZero2
                  0.02,      // dVc2StabilizePidPole
                  5.0,       // dVc2StabilizeMotorAccelerationFeedforwardGain

                  20.0,     // dVc2TrackPidGain
                  0.2,       // dVc2TrackPidZero1
                  0.2,       // dVc2TrackPidZero2
                  0.01,      // dVc2TrackPidPole
                  0.0,       // dVc2TrackVc1ForceFeedforwardGain
  
                  0.15,      // dMotorSlewVelocity
                  0.015,     // dMotorCreepVelocity
                  0.5,       // dDecelerationAggressiveness
                  -0.1,       // dMotorPidGain
                  1.0,       // dMotorPidZero1
                  1.0,       // dMotorPidZero2
                  1.0,       // dMotorPidPole
                  -1.0,      // dMotorFeedForwardGain

                  0.01,       // dDecelToIdleVelocityThreshold
                  0.05,       // dSlewToTrackThresholdInMm
                  1.0        // dTrackToSlewThresholdInMm
};

const tGsuDlServoParameters CspGsuServoParams(CgspGuiGsuServoParams);



/*******************************************************************/
/******************** DL PHYSICAL CONSTANTS ************************/
/*******************************************************************/

//const DlPhysicalConstants CpcBb1PhysConst = {
//  1.0, 4, -1, 2, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
//  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
//  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0
//};


//const DlPhysicalConstants CpcBb2PhysConst = {
//   0.632850e-6, //dLaserScale             (meters/wave)
//   4,           //iLaserNumPasses
//   -1,          //iLaserSign
//   2,           //iStellarNumPasses
//   0.15e-6,     //dPztScale            (meters/V) (15um/100V)
//   0.015e-6,    //dDitherPztScale         (meters/V) (1.5um/100V)
//   (3.14 * 1.15 * .0254 / 50000.0),
//                // dMotorPosScale  (meters/step)
//                        //  pi * d in inches * .0254 m/in / 50000 steps/rev
//   0.632850e-6, //dDiagLaserScale
//   0.15e-6,     //dDiagPztPosScale
//   1.0,         //dFrontHLimitScale
//   1.0,         //dFrontSLimitScale
//   1.0,         //dBackHLimitScale
//   1.0,         //dBackSLimitScale
//   1.0,         //dHomeScale
//   0.0,         //dEddy1Scale             (no eddy current sensors)
//   0.0,         //dEddy1Offset
//   0.0,         //dDiagEddy1Scale
//   0.0,         //dEddy2Scale
//   0.0,         //dEddy2Offset
//   0.0,         //dDiagEddy2Scale
//   9999.0,      //dPztMaxAccel
//   9999.0,      //dPztMaxVelocity
////   (4.82*.25/1000.0),
//   1.0,             //dVc1Scale               lbs/A * A/V / lbs/m
//                                          /* measured lbs/A for large VC */
//                                          /* Spring constant (lb/m) is a WAG */
//   0.0,         //dVc1Offset
//   9999.0,      //dVc1MaxAccel
//   9999.0,      //dVc1MaxVelocity
//   -4.82*.25/1000.0*10,        //dVc1MinPosition
//   4.82*.25/1000.0*10,         //dVc1MaxPosition
//   0.0,         //dVc2Scale                (no VC2)
//   0.0,         //dVc2Offset
//   0.0,         //dVc2MaxAccel
//   0.0,         //dVc2MaxVelocity
//   0.0,         //dVc2MinPosition
//   0.0,         //dVc2MaxPosition
//   (3.14 * 2.0 * 0.0254 / 99692.31), // dMotorScale
//                //   pi * d in inches * .0254 m/in / 39876923.08 steps/rev
//                //  changed to 99692.31 (motor box adj, Ask Phil)
//   0.125,       //dMotorMaxAccel                   m/s^2
//   0.10,        //dMotorMaxVelocity                m/s
//   1.0,         //dDiagLaserServoErrorScale
//   1.0,         //dDiagVc1ServoErrorScale
//   1.0,         //dDiagVc2ServoErrorScale
//   (4.82*.25/1000.0),   //dDiagMotorServoErrorScale (same as dVc1Scale)
//   0.005,       //dCreepVelocity                   m/s
//   1.0          //dDecelerationAggressiveness    -- MADEUP number
//};

const DlPhysicalConstants CpcGsuPhysConst = {
   1.319e-6,    //dLaserScale             (meters/wave)
   4,           //iLaserNumPasses
   1,           //iLaserSign
/********************************
Note that the iLaserSign value is now set in the switch statement
in the file configMgr.cc so do not change it here!!
********************************/
   2,           //iStellarNumPasses
   0.15e-6,     // dPztScale (meters/V) (15um/100V)
   0.07e-6,     //dDitherPztScale        (m/V) (7um/1000V * 10x amp)
   (3.14 * 1.15 * .0254 / 50000.0),
                // dMotorPosScale  (meters/step)
                   //  pi * d in inches * .0254 m/in / 50000 steps/rev
   1.319e-6,    //dDiagLaserScale
   0.15e-6,     //dDiagPztPosScale
   1.0,         //dFrontHLimitScale
   1.0,         //dFrontSLimitScale
   1.0,         //dBackHLimitScale
   1.0,         //dBackSLimitScale
   1.0,         //dHomeScale
   (.006/2.5),  //dEddy1Scale             (m/V) (6000um/2.5V)
   800.0,      //dEddy1Offset
   (.006/2.5),  //dDiagEddy1Scale
   (.0127/1.0), //dEddy2Scale             (m/V) (12700um/1.0V)
   800.0,      //dEddy2Offset
   (.0127/1.0), //dDiagEddy2Scale
              
   60000.0,  // dPztMaxAccel (m/s^2) allows full velocity +- swing in 2ms
   24.0,  // dPztMaxVelocity (m/s) 
   (4.82*.25/1000.0),  //dVc1Scale        lbs/A * A/V / lbs/m
                                          /* measured lbs/A for large VC */
                                          /* Spring constant (lb/m) is a WAG */
   0.0,         //dVc1Offset
   1500.0,       //dVc1MaxAccel     m/s^2  
   1.5,        //dVc1MaxVelocity  (m/s) 
   -4.82*.25/1000.0*10,        //dVc1MinPosition m
   4.82*.25/1000.0*10,         //dVc1MaxPosition m 
   (4.82*.25),  //dVc2Scale               lbs/A * A/V
   0.0,         //dVc2Offset
   1500.0,      //dVc2MaxAccel m/s^2  
   1.5,    //dVc2MaxVelocity m/(V s) this is not 
   -(4.82*.25/1000.0),     //dVc2MinPosition  this is not needed
   (4.82*.25/1000.0),      //dVc2MaxPosition this is not needed
   (3.14 * 1.15 * 0.0254 / 50000.0),
                // dMotorScale
                        //   pi * d in inches * .0254 m/in / 50000 steps/rev
   0.125,       //dMotorMaxAccel                   m/s^2
   0.15,        //dMotorMaxVelocity                m/s
   1.0,         //dDiagLaserServoErrorScale
   1.0,         //dDiagVc1ServoErrorScale
   1.0,         //dDiagVc2ServoErrorScale
   1.0,         //dDiagMotorServoErrorScale
   0.005,       //dCreepVelocity                   m/s
   1.0        //dDecelerationAggressiveness
};


/*******************************************************************/
/************************ DL SERVO INFO ****************************/
/*******************************************************************/

const TIME CtDlFastServoPeriod = TIME_TICKS_PER_SECOND / 5000;
const int CiDlFastServoPriority = 25;
const TIME CtDlMedServoPeriod = TIME_TICKS_PER_SECOND / 1000;
const int CiDlMedServoPriority = 27;
const TIME CtDlSlowServoPeriod = TIME_TICKS_PER_SECOND / 100;
const int CiDlSlowServoPriority = 32;
const TIME CtDlTargetGeneratorPeriod = TIME_TICKS_PER_SECOND / 1000;
const TIME CtDlTargetGeneratorOffset = 0;
const int CiDlTargetGeneratorPriority = 28;


/*******************************************************************/
/************************ EM SERVO INFO ****************************/
/*******************************************************************/

//const TIME CtEmServoPeriod = TIME_TICKS_PER_SECOND / 10;
//const int CiEmServoPriority = 32;


/*******************************************************************/
/************************ FT SERVO INFO ****************************/
/*******************************************************************/

//const TIME CtFtFastServoPeriod = TIME_TICKS_PER_SECOND / 4000;
//const int CiFtFastServoPriority = 26;
const TIME CtFtMediumServoPeriod = TIME_TICKS_PER_SECOND / 1000;
//const int CiFtMediumServoPriority = 28;
//const TIME CtFtSlowServoPeriod = TIME_TICKS_PER_SECOND / 2;
//const int CiFtSlowServoPriority = 75;
//const TIME CtFtImagingServoPeriod = TIME_TICKS_PER_SECOND / 10;;
//const int CiFtImagingServoPriority = 90;
//const TIME CtFtTrackUpdatePeriod = TIME_TICKS_PER_SECOND / 1000;
//const int CiFtTrackUpdatePriority = 30;


/*******************************************************************/
/********************** DL DITHER PERIODS **************************/
/*******************************************************************/

//const TIME CtBb1DitherPeriod = CtFtMediumServoPeriod * 2; 
//const TIME CtBb2DitherPeriod =  CtFtMediumServoPeriod * 2;
const TIME CtGsuDitherPeriod =  CtFtMediumServoPeriod * 2;


/*******************************************************************/
/************************ ST SERVO INFO ****************************/
/*******************************************************************/

//const TIME CtStServoPeriod = TIME_TICKS_PER_SECOND / 1000;
//const int CiStServoPriority = 29;


/*******************************************************************/
/******************** ST PHYSICAL CONSTANTS ************************/
/*******************************************************************/

//const tStPhysicalConstants Cst0PhysConst = {
//  10.0  /* Actuator Scale Factor */
//};
//const tStPhysicalConstants Cst1PhysConst = {
//  10.0  /* Actuator Scale Factor */
//};


/*******************************************************************/
/********************** ST CONTROLLER PARAMS ***********************/
/*******************************************************************/

//const tStControllerParams Cst0ControllerParams  = {
//  {0.0, 0.0},  /* Target Position for Star Centroid (pixels) */
//  1.0,         /* Lag Pole T (sec) */
//  1.0,         /* Lag Zero T (sec) */
//  FALSE,       /* Lag Enabled? */
//  .000001,     /* PID Zero #1 T (sec) */
//  0.0,         /* PID Zero #2 T (sec) */
//  0.0,         /* PID Pole T (sec) */
//  .1           /* Gain */
//}; 
//const tStControllerParams Cst1ControllerParams  = {
//  {0.0, 0.0},  /* Target Position for Star Centroid (pixels) */
//  1.0,         /* Lag Pole T (sec) */
//  1.0,         /* Lag Zero T (sec) */
//  FALSE,       /* Lag Enabled? */
//  .000001,     /* PID Zero #1 T (sec) */
//  0.0,         /* PID Zero #2 T (sec) */
//  0.0,         /* PID Pole T (sec) */
//  .1           /* Gain */
//}; 
//
//
///*******************************************************************/
///************************ ST SERVO PARAMS **************************/
///*******************************************************************/
//
//const tStServoParams Cst0ServoParams = {
//  Cst0ControllerParams,
//  { {-.07,-.72, .79},
//    {-.89,.47,.43} }, /* Detector to FSM Transform (uV/pixel) 2x3 Array */
//  {0.0, 0.0, 0.0}  /* FSM Home position (mV) */
//};
//const tStServoParams Cst1ServoParams = {
//  Cst1ControllerParams,
//  { {-.07,-.72, .79},
//    {-.89, .47, .43} }, /* Detector to FSM Transform (uV/pixel) 2x3 Array */
//  {0.0, 0.0, 0.0}  /* FSM Home position (mV) */
//};
//
//
///*******************************************************************/
///********************* ST BOARD/CHANNEL INFO ***********************/
///*******************************************************************/
//
//const BOARD_NAME CbnSt0FsmBoardArray[NUM_FSM_CHANNELS] = {
//  IP16DAC_BOARD_NAME, IP16DAC_BOARD_NAME, IP16DAC_BOARD_NAME 
//};
//
//const BOARD_NAME CbnSt1FsmBoardArray[NUM_FSM_CHANNELS] = {
//  IP16DAC_BOARD_NAME + 1, IP16DAC_BOARD_NAME + 1, IP16DAC_BOARD_NAME + 1 
//};
//
//const int CiSt0FsmChannelArray[NUM_FSM_CHANNELS] = { 0, 1, 2 };
//const int CiSt1FsmChannelArray[NUM_FSM_CHANNELS] = { 0, 1, 2 };
