/* $RCSfile: initMgr.h,v $ - Type definitions for InitMgr stuff */

/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/inst/initMgr/initMgr.h,v 1.1.1.1 1998/06/11 21:36:36 chara Exp $
*/


/* Beth McKenney - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a,eamck,25Sep96    written
*/
  
/*
DESCRIPTION
  ISIT InitMgr defines and types.  
*/
   

#ifndef INC_initMgrh
#define INC_initMgrh

#include "isit.h"
#include "configMgr.h"
#include <taskLib.h>

#define INIT_SERVER_CPU 100
#define INIT_SERVER_RTE 0
#define IM_NCLIENTS             NRTES
#define IM_HB_WAIT_LIMIT        30    /* <-- while using period() instead of Scheduler */


extern volatile SYS_INIT_INFO  *vSysInitInfoG;

#define S_initmgr_SHMEM_BOARD_HAS_NO_MEMORY           (M_initmgr | 0x0001)
#define S_initmgr_INVALID_SHMEM_START_ADDRESS         (M_initmgr | 0x0002)
#define S_initmgr_INSUFFICIENT_SHMEM_FOR_INIT_HEADERS (M_initmgr | 0x0003)

#define S_initmgr_ENTERING_POWERON                  (M_initmgr | 0x1001)
#define S_initmgr_HARDWARE_HARDINIT_SUCCESSFUL      (M_initmgr | 0x1002)
#define S_initmgr_TOKEN_SERVER_STARTED              (M_initmgr | 0x1003)
#define S_initmgr_HARDWARE_SOFTINIT_SUCCESSFUL      (M_initmgr | 0x1004)
#define S_initmgr_ABOUT_TO_CALL_WAITFORHB           (M_initmgr | 0x1005)
#define S_initmgr_ABOUT_TO_CALL_CLIENTPOWERON       (M_initmgr | 0x1006)
#define S_initmgr_POWERON_COMPLETED_SUCCESSFULLY    (M_initmgr | 0x1007)
#define S_initmgr_ENTERING_CLIENTPOWERON            (M_initmgr | 0x1008)
#define S_initmgr_EXITING_CLIENTPOWERON             (M_initmgr | 0x1009)
#define S_initmgr_ENTERING_LOADANDINITRTES          (M_initmgr | 0x100a)
#define S_initmgr_LOADING_RTE_EXECUTABLE            (M_initmgr | 0x100b)
#define S_initmgr_SPAWNING_RTEINIT_TASK             (M_initmgr | 0x100c)
#define S_initmgr_ENTERING_DOSPAWN                  (M_initmgr | 0x100d)
#define S_initmgr_DOSPAWN_COMPLETED_SUCCESSFULLY    (M_initmgr | 0x100e)
#define S_initmgr_CANT_CREATE_SHARED_MEMORY         (M_initmgr | 0x100f)

/* constants for use when spawning RTE Init tasks... */

#define RTE_INIT_PRIO           100
#define RTE_INIT_OPTS           (VX_FP_TASK)
#define RTE_INIT_STKSZ          32768

extern "C" {
  ERROR_CODE PowerOn( /* system configuration */ );
}



/*************
Specification Functions

int CPUNumber (int EEPROMNumber) :== 
[ EEPROMNumber == INIT_SERVER_CPU = > return := 0
| true => return EEPROMNumber
]

volatile HEART_BEAT* HeartBeat (volatile BYTE* vShmemStart,int iWhichCPU) :==
[ true => return := (volatile HEARTBEAT *) (vShmemStart + 
   sizeof (SYS_INIT_INFO) + iWhichCPU * sizeof (HEARTBEAT) )
]

volatile HEART_BEAT* Health (volatile BYTE* vShmemStart,int iWhichCPU) :==
[ true => return := (volatile HEALTH *) (vShmemStart + 
    sizeof (SYS_INIT_INFO) + NRTES * sizeof (HEARTBEAT) + 
    iWhichCPU * sizeof (HEALTH) )
]

volatile HEART_BEAT* InitType (volatile BYTE* vShmemStart,int iWhichCPU) :==
[ true => return := (volatile INIT_TYPE *) (vShmemStart + 
    sizeof (SYS_INIT_INFO) + NRTES * sizeof (HEARTBEAT) + 
    NRTES * sizeof (HEALTH) + iWhichCPU * sizeof (INIT_TYPE) )
]

[[D ::PowerOn (void) ]
[ VxWorks CPU number stored in EEPROM not in { INIT_SERVER_CPU, 1 } ||
  VxWorks system clock disabled ||
  ::ConfigManager.bInit == FALSE ||
  Periods, and priorities of system tasks 
  invalid_array (::ConfigManager.Hardware.pBoardArray)
  invalid_pointer (::ConfigManager.Hardware.pBoardArray [0..
    ::ConfigManager.Hardware.iArraySize - 1] ) || 
  InvalidIndex (sRteExecFile,CPUNumber (VxWorks CPU number stored in EEPROM)) ||
  invalid_string (sRteExecFile [CPUNumber (VxWorks CPU number stored in EEPROM) ])  || 
  sRteExecFile [CPUNumber (VxWorks CPU number stored in EEPROM) ]  is not the 
    name of an object file which contains a valid global C function named
    "RteInit" whose prototype is RteInit (int, int,volatile SHMEM_WORD*, 
    int, volatile HEARTBEAT*,volatile HEALTH*, volatile INIT_TYPE*)  ||
  sRteExecFile [CPUNumber (VxWorks CPU number stored in EEPROM) ] is not the name
    of a valid object file that can be successfully loaded by ld || 
  VxWorks CPU number stored in EEPROM == INIT_SERVER_CPU && ::IpcMemory.bInit == TRUE ||
  invalid_pointer (::ConfigManager.Hardware.LocalSharedMemoryAddress) ||
  ALL_GIZMO_INFO_FOR_RTE.iRteId != CPUNumber (VxWorks CPU number stored in EEPROM) ||
  ALL_GIZMO_INFO_FOR_RTE.iGizmoId != id associated with appropriate gizmo ||
  IsADelayLine (ANY_FT_GIZMO_INFO_FOR_RTE.iDlTargetGizmoId) == FALSE ||
  IsADelayLine (ANY_EM_GIZMO_INFO_FOR_RTE.iDlTargetGizmoId) == FALSE ||
  IsAFringeTracker (ANY_ST_GIZMO_INFO_FOR_RTE.iFtGizmoId) == FALSE ||
  IsAStarTracker (ANY_FT_GIZMO_INFO_FOR_RTE.iSt0GizmoId) == FALSE ||
  IsAStarTracker (ANY_FT_GIZMO_INFO_FOR_RTE.iSt1GizmoId) == FALSE ||
  Number of InstrumentCDSGizmos != 1 => UNDEFINED 
| T.E. board in ::ConfigManager.HardWare.pBoardArray [0..
     ::ConfigManager.Hardware.iArraySize - 1] st. board.bInit == FALSE ||
   MM6216_BOARD_NAME in not a board in ::ConfigManager.Hardware.pBoardArray ||
   total number of bytes on shared memory board < sizeof(SYS_INIT_INFO)
            + IM_NCLIENTS * sizeof(HEARTBEAT) + IM_NCLIENTS * sizeof(HEALTH)
            + IM_NCLIENTS * sizeof(INIT_TYPE) ||
   VxWorks CPU number stored in EEPROM == INIT_SERVER_CPU &&  
     unable to add Token Polling task ||
   VxWorks CPU number stored in EEPROM != INIT_SERVER_CPU && 
     *HeartBeat (VxWorks CPU number stored in EEPROM) not increased within 
     IM_HB_WAIT_LIMIT ||
  *ConfigManager.Hardware.ppPc03vBoard [CPUNumber (
    VxWorks CPU number stored in EEPROM) ] does not have interrupt capabilities ||
  *ConfigManager.Hardware.ppPc03vBoard [CPUNumber (
    VxWorks CPU number stored in EEPROM)  ] does not have clock function ||
  ConfigManager.iSchedMaxTasks < 1 ||
  unable to allocate memory for array of tTask of dimension iSchedMaxTasks ||
  unable to allocate memory for array of (tTask *) of dimension iSchedMaxTasks ||
  1 is not valid interrupt source on 
    *ConfigManager.Hardware.ppPc03vBoard [CPUNumber (
    VxWorks CPU number stored in EEPROM) ] || 
  1 is not clock-driven interrupt source for 
    *ConfigManager.Hardware.ppPc03vBoard [CPUNumber (
    VxWorks CPU number stored in EEPROM) ]  ||
  ThisRteG.RteInterruptServer.bConnected == TRUE ||
  ThisRteG.RteInterruptServer.bEnabled == TRUE ||
  RteIntNum [CPUNumber (VxWorks CPU number stored in EEPROM) ] < 0||
  RteIntNum[CPUNumber (VxWorks CPU number stored in EEPROM) ] > MAX_BUS_INTERRUPT ||
  CanAllocateIpcObject (::ConfigManager.iiErrorStreamId [ CPUNumber (
    VxWorks CPU number stored in EEPROM) ] ) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.iiDataStreamId [ CPUNumber (
    VxWorks CPU number stored in EEPROM) ] ) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.iiStatusStreamId [CPUNumber (
    VxWorks CPU number stored in EEPROM) ] ) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.
    iiCommandStreamId) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiErrorStreamArray [0..CiNumberOfRtes]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiStatusStreamArray [0..CiNumberOfRtes]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiDataStreamArray [0..CiNumberOfRtes]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiCommandStreamArray [0..CiNumberOfSystemGizmos]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiOpenLoopTargetIdArray [0..CiNumberOfDelayLines-1]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiManualTargetIdArray [0..CiNumberOfDelayLines-1]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
    iiCommandStreamArray [0..CiNumberOfSystemGizmos]) == FALSE ||  
  CanAllocateIpcObject (::ConfigManager.ALL_EM_GIZMO_INFO_FOR_RTE.
    iiDlTargetId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.
    iiDlTargetId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.
    iiStarImage0BufferId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.
    iiStarImage1BufferId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_ST_GIZMO_INFO_FOR_RTE.
    iiStarImageBufferId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.
    iiOpenLoopTargetId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.
    iiManualTargetId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.
    iiEmTargetId) == FALSE ||
  CanAllocateIpcObject (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.
    iiFtTargetId) == FALSE ||
  unable to add Heartbeat task ||
  unable to add Ekg Task ||
  unable to add Emt Task ||
  ALL_GIZMOS_ON_RTE unable to add Command Processing Task ||
  ALL_GIZMOS_ON_RTE unable to add Status Processing Task ||
  ALL_INSTRUMENT_CDS_GIZMOS_ON_RTE unable to add Relayer Task ||
  ALL_EM_GIZMOS_ON_RTE unable to add periodic Servo Task ||
  ALL_FT_GIZMOS_ON_RTE unable to add periodic Servo Task ||
  ALL_ST_GIZMOS_ON_RTE unable to add periodic Servo Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic Fast Servo Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic Medium Servo Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic Slow Servo Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic Update Track Mode Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic Limit Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add periodic TargetGen Task ||
  ALL_EM_GIZMOS_ON_RTE unable to add event driven EM Data Dump Task ||
  ALL_FT_GIZMOS_ON_RTE unable to add event driven Fringe Image Data Dump Task ||
  ALL_FT_GIZMOS_ON_RTE unable to add event driven Data Dump Task ||
  ALL_ST_GIZMOS_ON_RTE unable to add event driven Star Image Data Dump Task ||
  ALL_ST_GIZMOS_ON_RTE unable to add event driven Data Dump Task ||
  ALL_DL_GIZMOS_ON_RTE unable to add event driven Data Dump Task =>
       console := console + appropriate error code
       : return := appropriate error code
| task "tTelnetd" not found || 
  task "tRlogind" not found ||
  task "tShell" not found ||
  task "tWdbTask" not found => 
    appropriate error sent to User Interface if connected
    : return := appropriate error code
| FOR_ALL_DEFINED_NON_ERROR_CASES =>   
    Time function set to GetTime
    : ::pThisRteG := &::ThisRteG;       
    ::ConfigManager.HardWare.pBoardArray [0..
      ::ConfigManager.Hardware.iArraySize - 1]->bInit == TRUE
    : ::OS.LoadedModules:= ::OS.LoadedModules U
       { sRteExecFile [VxWorks CPU number stored in EEPROM] }
    : ::OS.SymbolTable:= ::OS.SymbolTable U { symbols in
       sRteExecFile [VxWorks CPU number stored in EEPROM] }
    : ::OS.SpawnedTasks := ::OS.SpawnedTasks U
       { (RteInit from file sRteExecFile [CPUNumber (VxWorks CPU number stored in EEPROM) ] )
         (CPUNumber (VxWorks CPU number stored in EEPROM)), 
         (CPUNumber (VxWorks CPU number stored in EEPROM)), 
         ::ConfigManager.Hardware.LocalSharedMemoryAddress  +
           sizeof(SYS_INIT_INFO) + IM_NCLIENTS * sizeof(HEARTBEAT) + 
           IM_NCLIENTS * sizeof(HEALTH) + IM_NCLIENTS * sizeof(INIT_TYPE), 
         ::ConfigManager.Hardware.SharedMemorySize -
           sizeof(SYS_INIT_INFO) + IM_NCLIENTS * sizeof(HEARTBEAT) + 
           IM_NCLIENTS * sizeof(HEALTH) + IM_NCLIENTS * 
           sizeof(INIT_TYPE), 
         HeartBeat (::ConfigManager.Hardware.LocalSharedMemoryAddress,
          CPUNumber (VxWorks CPU number stored in EEPROM)), 
         Health (::ConfigManager.Hardware.LocalSharedMemoryAddress,
          CPUNumber (VxWorks CPU number stored in EEPROM) ), 
         InitType (::ConfigManager.Hardware.LocalSharedMemoryAddress,
          CPUNumber (VxWorks CPU number stored in EEPROM))  }
    : ::ErrorStream (CPUNumber (VxWorks CPU number stored in EEPROM)).bInit := TRUE
    : ::DataStream (CPUNumber (VxWorks CPU number stored in EEPROM)).bInit := TRUE
    : ::StatusStream (CPUNumber (VxWorks CPU number stored in EEPROM)).bInit := TRUE
    : ::PeriodicTaskSet.bInit := TRUE
    : ::IpcMemory.ObjectSet := ::IpcMemory.ObjectSet U 
        { (::ConfigManager.iiErrorStreamId [CPUNumber (VxWorks CPU number stored in 
             EEPROM) ], tIpcFifo<BYTE>),
          (::ConfigManager.iiStatusStreamId [CPUNumber (VxWorks CPU number stored in 
             EEPROM) ], tIpcFifo<BYTE>),
          (::ConfigManager.iiDataStreamId [CPUNumber (VxWorks CPU number stored in EEPROM) ],
             tIpcFifo<BYTE>),
    	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiErrorStreamArray [0..NRTES], tIpcFifo<BYTE>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiStatusStreamArray [0..NRTES], tIpcFifo<BYTE>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiDataStreamArray [0..NRTES], tIpcFifo<BYTE>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiDataStreamArray [0..CiNumberOfSystemGizmos], tIpcFifo<ISIT_CMD>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiOpenLoopTargetArray [0..NUM_DELAY_LINES],
	     tIpcDblBuffer<tDlTarget>),
	  (::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.
	     iiManualTargetArray [0..NUM_DELAY_LINES],
	     tIpcDblBuffer<tDlTarget>),	     
          (::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.iiCommandStreamId,
             tIpcFifo<ISIT_CMD> ),
          (::ConfigManager.ALL_EM_GIZMO_INFO_FOR_RTE.iiDlTargetId,
             tIpcDblBuffer<tDlTarget>),
          (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.iiDlTargetId,
             tIpcDblBuffer<tDlTarget>),
          (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.iiStarImage0BufferId,
             tIpcIndirectionDblBuffer),
          (::ConfigManager.ALL_FT_GIZMO_INFO_FOR_RTE.iiStarImage1BufferId,
             tIpcIndirectionDblBuffer),
          (::ConfigManager.ALL_ST_GIZMO_INFO_FOR_RTE.iiStarImageBufferId,
             tIpcIndirectionDblBuffer),
          (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.iiOpenLoopTargetId,
             tIpcDblBuffer<tDlTarget>),
          (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.iiManualTargetId,
             tIpcDblBuffer<tDlTarget>),
          (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.iiEmTargetId,
             tIpcDblBuffer<tDlTarget>),
          (::ConfigManager.ALL_DL_GIZMO_INFO_FOR_RTE.iiFtTargetId,
             tIpcDblBuffer<tDlTarget>) }  
    : ::PeriodicTaskSet := ::PeriodicTaskSet U {
      PeriodicTask ("HbTask", ::ConfigManager.HbTaskPriority, 
        ::ConfigManager.HbTaskPeriod, ::ConfigManager.HbTaskOffset, 
        tRte::HbGen) ,
      PeriodicTask ("EkgTask", ::ConfigManager.EkgTaskPriority, 
        ::ConfigManager.EkgTaskPeriod, ::ConfigManager.EkgTaskOffset, 
        tRte::EKG),
      PeriodicTask ("EmtTask", ::ConfigManager.EmtTaskPriority, 
        ::ConfigManager.EmtTaskPeriod, ::ConfigManager.EmtTaskOffset, 
        tRte::EMT),
      PeriodicTask ("ProcessoCommand", 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.iCommandTaskPriority,  
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.tCommandTaskPeriod, 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.tCommandTaskOffset, 
        tGizmo::ProcessCommand),
      PeriodicTask ("ProcessStatus", 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.iStatusTaskPriority, 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.tStatusTaskPeriod, 
        ::ConfigManager.ALL_GIZMO_INFO_FOR_RTE.tStatusTaskOffset, 
        tGizmo::ProcessStatus),
      PeriodicTask ("Relay", 
        ::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.iRelayTaskPriority, 
        ::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.tRelayTaskPeriod, 
        ::ConfigManager.ALL_INSTRUMENT_CDS_GIZMO_INFO_FOR_RTE.tSRelayTaskOffset, 
        tInstrumentCdsGizmo::Relay),
      PeriodicTask ("DoServo", 
        ::ConfigManager.ALL_EM_INFO_FOR_RTE.ServoTaskArray[0].iPriority, 
        ::ConfigManager.ALL_EM_INFO_FOR_RTE.ServoTaskArray[0].tStatusTaskPeriod, 
        ::ConfigManager.ALL_EM_INFO_FOR_RTE.ServoTaskArray[0].tStatusTaskOffset, 
        tServo::DoServo),
      PeriodicTask ("DoServo", 
        ::ConfigManager.ALL_FT_INFO_FOR_RTE.ServoTaskArray[0].iPriority, 
        ::ConfigManager.ALL_FTINFO_FOR_RTE.ServoTaskArray[0].tStatusTaskPeriod, 
        ::ConfigManager.ALL_FT_INFO_FOR_RTE.ServoTaskArray[0].tStatusTaskOffset, 
        tServo::DoServo),
      PeriodicTask ("DoServo", 
        ::ConfigManager.ALL_ST_INFO_FOR_RTE.ServoTaskArray[0].iPriority, 
        ::ConfigManager.ALL_ST_INFO_FOR_RTE.ServoTaskArray[0].tStatusTaskPeriod, 
        ::ConfigManager.ALL_ST_INFO_FOR_RTE.ServoTaskArray[0].tStatusTaskOffset, 
        tServo::DoServo),
      PeriodicTask ("DoServo", 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.ServoTaskArray[0..2].iPriority, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.ServoTaskArray[0..2].tStatusTaskPeriod, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.ServoTaskArray[0..2].tStatusTaskOffset, 
        tServo::DoServo),
      PeriodicTask ("UpdateMode", 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.i??Priority, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskPeriod, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskOffset, 
        tServo::DoServo),
      PeriodicTask ("ReadLimitsTask", 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.i??Priority, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskPeriod, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskOffset, 
        tDlLimits::UpdateCachedLimitValues),
      PeriodicTask ("TargGenTask", 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.i??Priority, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskPeriod, 
        ::ConfigManager.ALL_DL_INFO_FOR_RTE.t??TaskOffset, 
        tDlTargGen::ComputeTotalTarget),
    : ::EventDrivenTaskSet := ::EventDrivenTaskSet U {
        ALL_EM_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiEmDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream),
        ALL_FT_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiFtDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream),
        ALL_FT_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiFtDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream),
        ALL_ST_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiStDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream),
        ALL_ST_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiStDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream),
        ALL_DL_GIZMOS_ON_RTE.EventDrivenTask ("DataStoreDump", 
          CiDlDataDumpTaskPriority, DATA_DUMP_OPTIONS, DATA_DUMP_STACK_SIZE, 
          tDataStore::ProcessDumpToDataStream) }
    : ::ThisRteG.GizmoSet := appropriate set of gizmos as per ::ConfigManager
    : ::ThisRteG.iMyRteNum := CPUNumber (VxWorks CPU Number from EEPROM)
    : ::ThisRteG.tidHbTask := new task id of Heartbeat task
    : ::ThisRteG.tidEkgTask := new task id of Ekg task
    : ::ThisRteG.tidEmtTask := new task id of Emt task
    : ::ThisRteG.vHeartbeat := HeartBeat (::ConfigManager.Hardware.LocalSharedMemoryAddress,
          CPUNumber (VxWorks CPU Number from EEPROM))
    : ::ThisRteGvHealth := Health (::ConfigManager.Hardware.LocalSharedMemoryAddress,
          CPUNumber (VxWorks CPU Number from EEPROM))
    : ::ThisRteGbInit := TRUE
| VxWorks CPU number stored in EEPROM == INIT_SERVER_CPU =>
    all registers in *::ConfigManager.HardWare.pBoardArray [0..
      ::ConfigManager.Hardware.iArraySize - 1] initialized
    : ::IpcMemory.bInit := TRUE
    : HeartBeat (0..NRTES) := 0
    : Health (0..NRTES) := H_NOT_INIT
    : InitType (0..NRTES) := IT_POWER_ON_INIT    
    : return := OK 
| true =>        
    return := OK
]]


[[D ::WaitForHB (volatile HEARTBEAT* vHbLoc, int iTimeLimit) ]
[ invalid_pointer (vHbLoc) ||
  VxWorks system clock disabled => UNDEFINED 
| within iTimeLimit seconds, *vHbLoc increases => return := OK
| true => return := S_initmgr_HB_TIMEOUT
]]



[[D ::ClientPowerOn (vswIpcShmemStart, iIpcBytes, vHbLocation, 
                     vRteHealth, vRteInitType ) ]
[ invalid_pointer (vswIpcShmemStart) ||
  invalid_pointer (vHbLocation) ||
  invalid_pointer (vRteHealth) ||
  invalid_pointer (vRteInitType) ||
  RteListForCPUiWhichCpu is an array of dimension < NRTES_ON_CPUiWhichCpu ||
  Value of any of the elements of 
  RteListForCPUiWhichCpu [0..NRTES_ON_CPUiWhichCpu-1] >=
  dimension of sRteExecFile array ||
  For any i in { 0..NRTES_ON_CPUiWhichCpu-1 }, sRteExecFile[i] is not the name
  of an object file which contains a valid global C function named 
  "RteInit" whose prototype is 
  RteInit (int, int,volatile SHMEM_WORD*, int, volatile HEARTBEAT*,
           volatile HEALTH*, volatile INIT_TYPE*) ||
  iIpcBytes != size of memory board (in bytes) -
     ( SizeOfInitMgrShmemStuff (IM_NCLIENTS) +
       SizeOfTokenMgrShmemStuff (NRTES) ) ||
  Value of any of the elements of
      RteListForCPUiWhichCpu[0..NRTES_ON_CPUiWhichCpu-1] >=
        the dimension of vHbLocation or vRteHealth or vRteInitType => UNDEFINED
| VxWorks CPU number stored in EEPROM not in { 0, 1 } ||
  For any i in { 0..NRTES_ON_CPUiWhichCpu-1 }, sRteExecFile[i] is not the name 
             of a valid object file that can be successfully loaded by ld ||
  task ?? cannot be created => return := appropriate error code
| true => 
  OS.LoadedModules := OS.LoadedModules U
    { sRteExecFile [RteListForCPUiWhichCpu [0..NRTES_ON_CPUiWhichCpu-1] ] }
  : OS.SymbolTable := OS.SymbolTable U { symbols in 
    sRteExecFile [RteListForCPUiWhichCpu [0..NRTES_ON_CPUiWhichCpu-1] ] }
  : OS.SpawnedTasks := OS.SpawnedTasks U
    { (RteInit from file sRteExecFile [0..NRTES_ON_CPUiWhichCpu-1] )
         (iWhichCpu, i, vswIpcShmemStart, iIpcBytes, vHbLocation, 
          vRteHealth, vRteInitType) }
]]


[[D ::LoadAndInitRtes (int iWhichCPU, volatile SHMEM_WORD*  vswIpcShmemStart, 
                       int iIpcBytes, volatile HEARTBEAT* vHbLocation, 
                       volatile HEALTH* vRteHealth, 
                       volatile INIT_TYPE* vRteInitType) ]
[ invalid_pointer (vswIpcShmemStart) ||
  invalid_pointer (vHbLocation) ||
  invalid_pointer (vRteHealth) ||
  invalid_pointer (vRteInitType) ||
  InvalidIndex (sRteExecFile,iWhichCPU) ||
  invalid_string (sRteExecFile [iWhichCPU] ) ||
  *sRteExecFile [iWhichCPU] is not the name of an object file which contains a 
    valid global C function named "RteInit" whose prototype is 
    RteInit (int, int,volatile SHMEM_WORD*, int, volatile HEARTBEAT*,
           volatile HEALTH*, volatile INIT_TYPE*) ||
  (BYTE*) vswIpcShmemStart + iIpcBytes > Last Address of Shared Memory + 1 => UNDEFINED
| sRteExecFile [iWhichCPU] is not the name of a valid
    object file that can be successfully loaded by ld ||
  RteInit task cannot be created => return := appropriate error code
| true => 
  OS.LoadedModules := OS.LoadedModules U
    { sRteExecFile [iWhichCPU] }
  : OS.SymbolTable := OS.SymbolTable U { symbols in 
    sRteExecFile [iWhichCPU] }
  : OS.SpawnedTasks := OS.SpawnedTasks U
    { (RteInit from file sRteExecFile [iWhichCPU] )
         (iWhichCPU, vswIpcShmemStart, iIpcBytes, vHbLocation, 
          vRteHealth, vRteInitType) }
]]

[[D ::doSpawn (char* taskName, int priority, int options, 
               int stackSize, char* funcName, int arg1, int arg2, 
               int arg3, int arg4, int arg5, int arg6, int arg7, 
               int arg8, int arg9, int arg10) ]
[ invalid_c_function_pointer (funcname) => UNDEFINED 
| funcName not in sysSymTbl -> ||
  Insufficient memory to spawn task ||
  Task cannot be created (invalid args, etc.) => 
    return := appropriate error code
| true =>
    OS.SpawnedTasks := OS.SpawnedTasks U
       { (C function whose symbol name is funcName)(arg1, ...) }
   : return OK
]]

*********/
/******************************************************************************
*
* Private function prototypes
*/


ERROR_CODE WaitForHB( volatile HEARTBEAT *vHbLoc, int iTimeLimit );
ERROR_CODE ClientPowerOn( volatile SHMEM_WORD   *vswIpcShmemStart, 
                          int                   iIpcBytes,
                          volatile HEARTBEAT    *vHbLocation, 
                          volatile HEALTH       *vRteHealth, 
                          volatile INIT_TYPE    *vRteInitType );
ERROR_CODE   LoadAndInitRtes(   int             iWhichCpu,
                                volatile SHMEM_WORD     *vswIpcShmemStart, 
                                int                     iIpcBytes,
                                volatile HEARTBEAT      *vHbLocation, 
                                volatile HEALTH         *vRteHealth, 
                                volatile INIT_TYPE      *vRteInitType );
ERROR_CODE doSpawn(char *taskName, int priority, int options, int stackSize, 
                        char *funcName, int arg1, int arg2, int arg3, int arg4, 
                        int arg5, int arg6, int arg7, int arg8, int arg9, int arg10);

#ifdef CROSSWIND
extern "C" {
ERROR_CODE RteInit( int                      iWhichCPU,
                    int                      iWhichRTE, 
                    volatile SHMEM_WORD      *vswIpcShmemStart, 
                    int                      iIpcBytes,
                    volatile HEARTBEAT       *vHbLocation, 
                    volatile HEALTH          *vRteHealth, 
                    volatile INIT_TYPE       *vRteInitType );
}
#endif
  
#endif INC_initMgrh


