

#include "ppcFpExceptions.h"
#include "isit.h"
#include <vxLib.h>

#if (( CPU == PPC603) || (CPU == PPC604) )

void DisableFpExceptionHandler ()
{
  UINT32 uiMsr = vxMsrGet ();
  
  // clear MSR bits FE0 and FE1 to disable exception handler
  uiMsr = uiMsr & (~(_PPC_MSR_FE0 | _PPC_MSR_FE1));
  
  vxMsrSet (uiMsr);
}


void DisableFpInvalid ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Disable invalid exception
uiFpScr = uiFpScr & (~_PPC_FPSCR_VE);

// Set status control register to new value
vxFpscrSet (uiFpScr);

}

void DisableFpOverflow ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Disable overflow exception
uiFpScr = uiFpScr & (~_PPC_FPSCR_OE);

// Set status control register to new value
vxFpscrSet (uiFpScr);

}

void DisableFpUnderflow ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Disable underflow exception
uiFpScr = uiFpScr & (~_PPC_FPSCR_UE);

// Set status control register to new value
vxFpscrSet (uiFpScr);

}

void DisableFpDivideByZero ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Disable overflow exception
uiFpScr = uiFpScr & (~_PPC_FPSCR_ZE);

// Set status control register to new value
vxFpscrSet (uiFpScr);

}

void DisableFpInexact ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Disable inexact exception
uiFpScr = uiFpScr & (~_PPC_FPSCR_XE);

// Set status control register to new value
vxFpscrSet (uiFpScr);

}


#include "ppcFpExceptions.h"

void DisableNonIEEE ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Disable non-IEEE exception
uiFpScr = uiFpScr & (~_PPC_FPSCR_NI);

// Set status control register to new value
vxFpscrSet (uiFpScr);

}



void DisableFpExceptions ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Disable all exceptions
uiFpScr = uiFpScr & (~_PPC_FPSCR_CTRL_MASK);

// Set status control register to new value
vxFpscrSet (uiFpScr);

}


void EnableFpInvalid ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Enable invalid exception
uiFpScr = uiFpScr | _PPC_FPSCR_VE;

// Set status control register to new value
vxFpscrSet (uiFpScr);

}

void EnableFpOverflow ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Enable overflow exception
uiFpScr = uiFpScr | _PPC_FPSCR_OE;

// Set status control register to new value
vxFpscrSet (uiFpScr);

}

void EnableFpUnderflow ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Enable underflow exception
uiFpScr = uiFpScr | _PPC_FPSCR_UE;
// Set status control register to new value
vxFpscrSet (uiFpScr);

}

void EnableFpDivideByZero ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Enable overflow exception
uiFpScr = uiFpScr | _PPC_FPSCR_ZE;

// Set status control register to new value
vxFpscrSet (uiFpScr);

}

void EnableFpInexact ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Enable inexact exception
uiFpScr = uiFpScr | _PPC_FPSCR_XE;

// Set status control register to new value
vxFpscrSet (uiFpScr);

}



void EnableNonIEEE ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Enable non-IEEE exception
uiFpScr =uiFpScr | _PPC_FPSCR_NI;

// Set status control register to new value
vxFpscrSet (uiFpScr);

}



void EnableFpExceptions ()
{

// Get floating point status control register
UINT32 uiFpScr = vxFpscrGet ();

// Enable all exceptions
uiFpScr = uiFpScr | _PPC_FPSCR_CTRL_MASK;

// Set status control register to new value
vxFpscrSet (uiFpScr);

}



void SetFpRoundMode (VX_FP_ROUND_MODE Mode)
{
  UINT32 uiFpScr = vxFpscrGet ();
  
  // clear rounding bits
  uiFpScr = uiFpScr & (~_PPC_FPSCR_RN_MSK);
  // set rounding bits to new mode
  uiFpScr = uiFpScr | _PPC_FPSCR_RN(Mode);
  
  vxFpscrSet (uiFpScr);
  
}


#else

#error "Floating point exception functions not defined for platform"

#endif