/* $RCSfile: instrumentCdsGizmoInfo.cc,v $*/
/* CM Info:
$Header: /home/chara/cvsroot/ople/sys/inst/instGizmo/instrumentCdsGizmoInfo.cc,v 1.2 1998/07/13 22:01:01 phil Exp $
*/
/* Richard Johsnon - Jet Propulsion Laboratory */
 
/*
modification history
--------------------
04a,rlj,2Sept97  written
*/
 

#include "instrumentCdsGizmoInfo.h"
#include "dlGizmoInfo.h"
#include "ipcid.h"

/****
[[U tInstrumentCDSGizmoInfo::tInstrumentCDSGizmoInfo (iRteId,iGizmoId) ]]
****/      
tInstrumentCDSGizmoInfo::tInstrumentCDSGizmoInfo (int iRteId, int iGizmoId,
                                                  BOARD_NAME bnClockBoard) : 

  /****
  [[U tGizmoInfo::tGizmoInfo (iRteId,iGizmoId) ]]
  ****/      
  tGizmoInfo(iRteId, iGizmoId)  {
 
  this->gtGizmoType = GT_INSTRUMENT;

  this->pClockBoard = D_CAST(tClockBoard *) ConfigManager.Hardware.GetBoard(bnClockBoard);
}

/****
[[U tInstrumentCDSGizmoInfo::~tInstrumentCDSGizmoInfo (void) ]]
****/      
tInstrumentCDSGizmoInfo::~tInstrumentCDSGizmoInfo () {}

/****
[[U tInstrumentCDSGizmoInfo::GetManualTargetId (iWhichDl) ]]
****/      
const tIpcDblBufferId& tInstrumentCDSGizmoInfo::GetManualTargetId (int iWhichDl) const {
  
  int        iDlId;
  GIZMO_TYPE gtTemp;
  /****
  [[U ::GetEmbeddedSystemGizmoInfo (GT_DELAY_LINE,iWhichDl,iDlId) ]]
  ****/
  ::GetEmbeddedSystemGizmoInfo (GT_DELAY_LINE,iWhichDl,gtTemp,iDlId);
  
  /****
  [[U DlInfo := ConfigManager.tConfig::GetGizmoInfo_i (iDlId) ]]
  ****/      
  tDlGizmoInfo &DlInfo = (tDlGizmoInfo &) *ConfigManager.GetGizmoInfo(iDlId);

  /****
  [[U tDlGizmoInfo::GetManualTargetId (void) ]]
  ****/      
  return DlInfo.GetManualTargetId ();
}

/****
[[U tInstrumentCDSGizmoInfo::GetOpenLoopTargetId (iWhichDl) ]]
****/      
const tIpcDblBufferId& tInstrumentCDSGizmoInfo::GetOpenLoopTargetId (int iWhichDl) const  {
  
  int        iDlId;
  GIZMO_TYPE gtTemp;
  /****
  [[U ::GetEmbeddedSystemGizmoInfo (GT_DELAY_LINE,iWhichDl,iDlId) ]]
  ****/
  ::GetEmbeddedSystemGizmoInfo (GT_DELAY_LINE,iWhichDl,gtTemp,iDlId);
  /****
  [[U DlInfo := ConfigManager.tConfig::GetGizmoInfo_i (iDlId) ]]
  ****/      
  tDlGizmoInfo &DlInfo = (tDlGizmoInfo &) *ConfigManager.GetGizmoInfo(iDlId);

  /****
  [[U tDlGizmoInfo::GetOpenLoopTargetId (void) ]]
  ****/      
  return DlInfo.GetOpenLoopTargetId ();
}
