/* $RCSfile: rteConfig.cc,v $ */
/* CM Info:   
$Header: /home/chara/cvsroot/ople/sys/inst/rte/rteConfig.cc,v 1.2 1998/08/17 21:01:29 phil Exp $*/
/* Richard Johnson - Jet Propulsion Laboratory */

/*
modification history
--------------------
01a,25Apr97,rlj    written 
*/

#include "isit.h"

#include "ftTypes.h"
#include "configMgr.h" 

#include "ipcid.h"
#include "ipcObjectAccessor.h"
#include "ipcDblBufferAccessor.h"
#include "ipcFifoAccessor.h"


 
/**** 
[[U tConfig::GetRteSchedPriority () ]]
****/
int tConfig::GetRteSchedPriority (int iWhichRte) const { 
  return CiRteSchedPriority[iWhichRte];
}

/**** 
[[U tConfig::GetRteSchedMaxTasks () ]]
****/
int tConfig::GetRteSchedMaxTasks (int iWhichRte) const { 
  return CiRteSchedMaxTasks[iWhichRte];
}
 
/**** 
[[U tConfig::GetRteSchedRate () ]]
****/
int tConfig::GetRteSchedRate (int iWhichRte) const { 
  return CiRteSchedRate[iWhichRte];
}


GIZMO_TYPE tConfig::GetGizmoType (int iGizmoId) const{
  return PubGetGizmoType( iGizmoId );
}


const tIpcFifoId& tConfig::GetErrorStreamId (int iWhichRte) const {

  if (iWhichRte < 0 || iWhichRte >= NRTES) return *new tIpcFifoId ();
  
  return this->iiRteErrorStreamIdArray[iWhichRte];
}

const tIpcFifoId& tConfig::GetDataStreamId (int iWhichRte) const {

  if (iWhichRte < 0 || iWhichRte >= NRTES) return *new tIpcFifoId ();
  
  return this->iiRteDataStreamIdArray[iWhichRte];
}

const tIpcFifoId& tConfig::GetStatusStreamId (int iWhichRte) const {

  if (iWhichRte < 0 || iWhichRte >= NRTES) return *new tIpcFifoId ();
  
  return this->iiRteStatusStreamIdArray[iWhichRte];
}

/****
[[U tConfig::GetGizmoId (iRteId,iRteGizmoIndex) ]]
****/
int tConfig::GetGizmoId (int iRteId,int iRteGizmoIndex) const  {

  switch (iRteId) {
    case 0 : return CiRte0Gizmos[iRteGizmoIndex];
    case 1 : return CiRte1Gizmos[iRteGizmoIndex];
    case 2 : return CiRte2Gizmos[iRteGizmoIndex];
    case 3 : return CiRte3Gizmos[iRteGizmoIndex];
    case 4 : return CiRte4Gizmos[iRteGizmoIndex];
    default : return INVALID_GIZMO;
   };
}
