/* $RCSfile: localMem.h,v $  */
/* $Header: /home/chara/cvsroot/ople/sys/ipc/include/localMem.h,v 1.1.1.1 1998/06/11 21:36:37 chara Exp $ */

/*
modification history
--------------------
01a,2Jun97,rlj    written
*/

#ifndef INC_localMemh
#define INC_localMemh

#include "isit.h"
#include "ipcMem.h"
#include "memHeader.h"
#include "tList.h"
#include <semLib.h>

/******************************************************************************
Class: tLocalMemory 
*****************************************************************************

[[D tLocalMemory::tLocalMemory (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => 
    this->bInit := TRUE
    : this->ObjectSet := NullSet 
]]

[[D tLocalMemory::~tLocalMemory (void) ]
[ invalid_pointer (this) => UNDEFINED
| true => 
    *this := anything
    : this := NULL
]]  

[[D tLocalMemory::Allocate (IPC_NAME inName, IPC_TYPE itType, 
           size_t szSize, ERROR_CODE &recErrCode) ]
[ invalid_pointer (this) => UNDEFINED
| CanAllocateObject (this->ObjectSet, inName,itType,szSize + overhead) == FALSE =>
    console := console + appropriate error messages
    : recErrCode := appropriate error code
    : return := NULL
| true =>
    recErrCode := OK
    : this->ObjectSet := this->ObjectSet U 
      NewObjectSet (this->ObjectSet,MT_LOCAL,inName,itType)
    : this->szHeapFree := this->szHeapFree - 
      AllocationSize (this->ObjectSet,inName,szSize)
    : return := address of appropriate tIpcObject 
]]

**********************************************/


const int CiAllocationTimeOutInSeconds = 5; 

class tLocalMemory : public tMemory {
  public:
    tLocalMemory ();
    virtual ~tLocalMemory ();
    virtual ERROR_CODE Restart ();
    virtual ERROR_CODE Shutdown ();
    virtual void *Allocate (IPC_NAME inName, IPC_TYPE itType, 
    				  size_t szSize, ERROR_CODE &recErrCode);
    friend ostream &operator<< (ostream &stream, tLocalMemory &LocalMem);				  
  protected:
    tList lHeaderList;
    SEM_ID siAllocationMutex;
   };

#endif INC_localMemh
