/* $RCSfile: memHeader.cc,v $  */
/*
$Header: /home/chara/cvsroot/ople/sys/ipc/memory/memHeader.cc,v 1.1.1.1 1998/06/11 21:36:38 chara Exp $
*/
/*
modification history
--------------------
01a,16Jun97,rlj    written
*/


#include "memHeader.h"

/****
[[U tObjectHeader::tObjectHeader (void) ]]
****/
tObjectHeader::tObjectHeader () {}

/****
[[U tObjectHeader::tObjectHeader_INITsz (inName,itType,Size) ]]
****/
tObjectHeader::tObjectHeader (IPC_NAME inName, IPC_TYPE itType, size_t Size) {
  this->inObjectName = inName;
  this->itObjectType = itType;
  this->szObjectSize = Size;
}

ostream& operator<< (ostream& stream, const IPC_TYPE& itType) {

  switch (itType) {
    case IPC_ATOM : stream << "IPC_ATOM ";break;
    case IPC_DBL_BUFFER : stream << "IPC_DBL_BUFFER ";break;
    case IPC_INDIRECTION_DBL_BUFFER : stream << "IPC_INDIRECTION_DBL_BUFFER ";
                                      break;
    case IPC_FIFO : stream <<  "IPC_FIFO ";break;
    default : stream << "UNKNOWN";break;
  }
  
  return stream;
}

ostream& operator<< (ostream& stream, const MEM_TYPE& itType) {

  switch (itType) {
    case MT_LOCAL : stream << "Local Memory ";break;
    case MT_SHARED : stream << "Shared Memory ";break;
    default : stream << "UNKNOWN";break;
  }
  
  return stream;
}

ostream& operator<< (ostream& stream, const tObjectHeader& ObjHeader) {

  stream << "Object Name = " << hex << ObjHeader.inObjectName << endl <<
            "Object Type = " << (IPC_TYPE) ObjHeader.itObjectType << endl <<
            "Object Size = " << ObjHeader.szObjectSize << endl;
  return stream;
}

/****
[[U tLocalHeader::tLocalHeader (void) ]]
****/
tLocalHeader::tLocalHeader () {}

/****
[[U tLocalHeader::tLocalHeader_INITszp (inName,itType,Size,pLoc) ]]
****/
tLocalHeader::tLocalHeader (IPC_NAME inName,IPC_TYPE itType, 
			    size_t Size, void *pLoc) :
  /****
  [[U tObjectHeader::tObjectHeader_INITsz (inName,itType,Size) ]]
  ****/		
  tObjectHeader (inName,itType,Size)

{
  this->pObjectLoc = pLoc;
}

ostream& operator<< (ostream& stream, const tLocalHeader& LocalHeader) {

  stream << "Local Object Header : " << endl <<
            (tObjectHeader) LocalHeader << 
            "Object Adress = " << LocalHeader.pObjectLoc << endl <<
            "End of Local Object Header" << endl;
            
  return stream;
}


/****
[[U tSharedHeader::tSharedHeader (void) ]]
****/
tSharedHeader::tSharedHeader () :
  /****
  [[U tObjectHeader::tObjectHeader (void) ]]
  ****/
  tObjectHeader () {}


/****
[[U tSharedHeader::tSharedHeader_INITszi (inName,itType,Size,iOffset) ]]
****/
tSharedHeader::tSharedHeader (IPC_NAME inName,IPC_TYPE itType,
  					  size_t Size, int iOffset) : 
  /****
  [[U tObjectHeader::tObjectHeader_INITsz (inName,itType,Size) ]]
  ****/		
  tObjectHeader (inName,itType,Size) {
  
  this->iObjectLoc = iOffset;
}
    
ostream& operator<< (ostream& stream, const tSharedHeader& SharedHeader) {

  stream << "Shared Object Header : " << endl <<
            (tObjectHeader) SharedHeader << 
            "Object Offset = " << SharedHeader.iObjectLoc << endl <<
            "End of Shared Object Header" << endl;
            
  return stream;
}
