/* $RCSfile: ipcIndirectionDblBuffer.cc,v $ - Functions for tIpcIndirectionDblBuffer */

/*
$Header: /home/chara/cvsroot/ople/sys/ipc/object/ipcIndirectionDblBuffer.cc,v 1.1.1.1 1998/06/11 21:36:38 chara Exp $
*/

#include "buffer.h"
#include "ipcElement.h"
#include "ipcIndirectionDblBuffer.h"

/*****************************************************************************************
class tIpcIndirectionDblBuffer

DESCRIPTION:
   tIpcIndirectionDblBuffer is a class for passing objects derived from tBuffer accross IPC.

*****************************************************************************************/
  
/*****************************************************************************************
  tIpcIndirectionDblBuffer::tIpcIndirectonDblBuffer (const tIpcIndirectionDblBufferId &iiId);
     Contructor for tIpcIndirectionDblBuffer.

[[U tIpcIndirectionDblBuffer::tIpcIndirectionDblBuffer (iiId) ]]
*/
tIpcIndirectionDblBuffer::tIpcIndirectionDblBuffer(const tIpcIndirectionDblBufferId &iiId) {
  ERROR_CODE ec;

  this->bsWhich = BS_EMPTY_BUFFER; 
  this->szBufferSize = iiId.BufferSize();

  /****
  [[U this->dtBuffer1 := tIpcElement::operator_array_new (iiId.Buf1Id,this->ecInitError) ]]
  ****
  [[U *this->dtBuffer1->tIpcElement::tIpcElement()]]
  ****/    
  this->dtBuffer1 = (volatile BYTE *)new (iiId.Buf1Id(),ec) tIpcElement<BYTE>[iiId.BufferSize()];

  /****
  [[U this->dtBuffer2 := tIpcElement::operator_array_new (iiId.Buf1Id,this->ecInitError) ]]
  ****
  [[U *this->dtBuffer2->tIpcElement::tIpcElement()]]
  ****/    
  this->dtBuffer2 = (volatile BYTE *)new (iiId.Buf2Id(),ec) tIpcElement<BYTE>[iiId.BufferSize()];
  }

/*****************************************************************************************
  ERROR_CODE tIpcIndirectionDblBuffer::Get (tBuffer &OutBuffer);
     This method gets data from the current read buffer in the IPC memory area and 
     puts it into the buffer class using the tBuffer method Put.

[[U IndirectionDblBuffer::Get (OutBuffer) ]]
*/
ERROR_CODE tIpcIndirectionDblBuffer::Get(tBuffer &OutBuffer) const volatile {
  ERROR_CODE ec;

  if (this->bsWhich == BS_EMPTY_BUFFER) 
    return S_ipc_BUFFER_EMPTY;
  else if (this->bsWhich == BS_BUFFER1) 
    /****
    [[U ec := OutBuffer.tBuffer::Put(this->szBufferSize, this->dtBuffer1) ]]
    ****/
    ec = OutBuffer.Put(this->szBufferSize, this->dtBuffer1);
  else if (this->bsWhich == BS_BUFFER2) 
    /****
    [[U ec := OutBuffer.tBuffer::Put(this->szBufferSize, this->dtBuffer2) ]]
    ****/
    ec = OutBuffer.Put(this->szBufferSize, this->dtBuffer2);
  return ec;
  }

/*****************************************************************************************
  ERROR_CODE tIpcIndirectionDblBuffer::Put (const tBuffer &InBuffer);
     This method puts data into the IPC memory area that is not current set for read
     and then sets the new data to be the current read buffer.

[[U IndirectionDblBuffer::Put (InBuffer) ]]     
*/
ERROR_CODE tIpcIndirectionDblBuffer::Put(const tBuffer &InBuffer) volatile {
  ERROR_CODE ec;

  if ((this->bsWhich == BS_EMPTY_BUFFER) || (this->bsWhich == BS_BUFFER2)) {
    /****
    [[U ec := InBuffer.tBuffer::Get(this->szBufferSize, this->dtBuffer1) ]]
    ****/
    ec = InBuffer.Get(this->szBufferSize, this->dtBuffer1);
    this->bsWhich = BS_BUFFER1;
    }
  else if (bsWhich == BS_BUFFER1) {
    /****
    [[U ec := InBuffer.tBuffer::Get(this->szBufferSize, this->dtBuffer2) ]]
    ****/
    ec = InBuffer.Get(this->szBufferSize, this->dtBuffer2);
    this->bsWhich = BS_BUFFER2;
    }
  return ec;
  }

/*****************************************************************************************
  void* tIpcIndirectionDblBuffer::operator new (size_t szSize, 
                                  const tIpcInderectionDblBufferId &iiId, 
                                  ERROR_CODE& ecErrCode);
     Operator for making a new tIpcIndirectionDblBuffer.

[[U tIpcIndirectionDblBuffer::operator_new (iiId, ecErrCode) ]]
*/
void *tIpcIndirectionDblBuffer::operator new (size_t szSize, const tIpcIndirectionDblBufferId &iiId, 
                ERROR_CODE &ecErrCode) {
  TraceMark (S_object_CREATING_DOUBLE_BUFFER);

  /****
  [[U return := (::pThisRteG)->pIpc.tIpc::Allocate (iiId,szSize,ecErrCode) ]]
  ****/
  return GetIpc().Allocate(iiId,szSize,ecErrCode);
  }
