/* $RCSfile: ipcIndirectionDblBufferAccessor.cc,v $ - Functions for tIpcIndirectionDblBufferAccessor */

/*
$Header: /home/chara/cvsroot/ople/sys/ipc/objectAccessor/ipcIndirectionDblBufferAccessor.cc,v 1.1.1.1 1998/06/11 21:36:38 chara Exp $
*/

#include "buffer.h"
#include "ipcIndirectionDblBufferAccessor.h"
#include "ipcIndirectionDblBuffer.h"

/*****************************************************************************************
class tIpcIndirectionDblBufferAccessor

DESCRIPTION:
   tIpcIndirectionDblBufferAccessor controls access to the tIpcIndirectionDblBuffer.
tIpcIndirectionDblBuffer is a class for passing objects derived from tBuffer accross IPC.
  
Black Box State
---------------
BOOL bEmpty - TRUE if buffer has never been written to FALSE otherwise
szBufferSize - # of bytes stored in the buffer
BYTE[szBufferSize] Buffer - data array storage for indirection buffer
*****************************************************************************************/

/*****************************************************************************************
  tIpcIndirectionDblBufferAccessor::tIpcIndirectonDblBufferAccessor (tIpcIndirectionDblBufferId &iiId);
     Contructor for tIpcIndirectionDblBufferAccessor.  Constructs Buffer to store iiId.szBufferSize 
     bytes in a simultaneous read-write buffer.

[[U tIpcIndirectionDblBufferAccessor::tIpcIndirectionDblBufferAccessor (iiId) ]]
*/
tIpcIndirectionDblBufferAccessor::tIpcIndirectionDblBufferAccessor(const tIpcIndirectionDblBufferId &iiId) :
  
  /****
  [[U tIpcObjectAccessor::tIpcObjectAccessor(void) ]]
  ****/
  tIpcObjectAccessor<tIpcMemoryBytePointer>() 
{
  ERROR_CODE ec;

  /****
  [[U this->vIndBuffer := tIpcIndirectionDblBuffer::operator_new (iiId,this->ecInitError) ]]
  [[U *this->vIndBuffer->tIpcIndirectionDblBuffer::tIpcIndirectionDblBuffer(iiId)]]
  ****/ 
  this->vIndBuffer = new (iiId,ec) tIpcIndirectionDblBuffer(iiId);
  this->SetInitError(ec);
  }

/*****************************************************************************************
  tIpcIndirectionDblBufferAccessor::~tIpcIndirectonDblBufferAccessor ();
     Destructor for tIpcIndirectionDblBufferAccessor.

[[U tIpcIndirectionDblBufferAccessor::~tIpcIndirectionDblBufferAccessor(void) ]]
*/
tIpcIndirectionDblBufferAccessor::~tIpcIndirectionDblBufferAccessor() {

  /****
  [[U tIpcObjectAccessor::~tIpcObjectAccessor(void) ]]
  ****/
}




/*****************************************************************************************
  ERROR_CODE tIpcIndirectionDblBufferAccessor::Get (tBuffer &OutBuffer);
     This method gets data from the current read buffer in the IPC memory area and 
     puts it into the buffer class using the tBuffer method Put.  Copies contents 
     of buffer into the DataOut.Buffer if size of buffers are the same.  If buffer 
     is empty or the buffer sizes are inconsistent, Get returns an error code.

[[U tIpcIndirectonDblBufferAccessor::Get (OutBuffer) ]]
*/
ERROR_CODE tIpcIndirectionDblBufferAccessor::Get(tBuffer &OutBuffer) const
{
  if (tBaseObject::IsInit () == TRUE) {
    /****
    [[U return := this->vIndBuffer->tIpcIndirectionDblBuffer::Get(OutBuffer) ]]
    ****/
    return this->vIndBuffer->Get(OutBuffer);
    }

  return S_ipc_OBJECT_NOT_ENABLED;
  }
 


/*****************************************************************************************
  ERROR_CODE tIpcIndirectionDblBufferAccessor::Put (const tBuffer &InBuffer);
     This method puts data into the IPC memory area that is not current set for read
     and then sets the new data to be the current read buffer.  Copies contents of 
     DataOut.Buffer into the buffer if size of buffers are the same.  If buffer sizes 
     are inconsistent, Put returns an error code.

[[U tIpcIndirectionDblBufferAccessor::Put (DataIn) ]] 
*/
ERROR_CODE tIpcIndirectionDblBufferAccessor::Put(const tBuffer &InBuffer) {
  if (tBaseObject::IsInit () == TRUE) {
    /****
    [[U this->vDlbBuffer->tIpcIndirectionDblBuffer::Put(InBuffer) ]]
    ****/
    return this->vIndBuffer->Put(InBuffer);
    }
  return S_ipc_OBJECT_NOT_ENABLED;
  }

/*****************************************************************************************
[[U tIpcObjectAccessor::IsOk(void) ]]
*/
BOOL tIpcIndirectionDblBufferAccessor::IsOk () const {
  return (this->vIndBuffer != NULL);
  }



ERROR_CODE tIpcIndirectionDblBufferAccessor::Get (
   tIpcMemoryBytePointer& DataIn) 
{
  return Traceback (S_ipc_UNSUPPORTED_GET_OPERATION,
                    "tIpcIndirectionDblBuffer::Get");
}


ERROR_CODE tIpcIndirectionDblBufferAccessor::Put (
   const tIpcMemoryBytePointer& DataIn) 
{
  return Traceback (S_ipc_UNSUPPORTED_GET_OPERATION,
                    "tIpcIndirectionDblBuffer::Put");
}






