/* $RCSfile: errorStream.cc,v $  */
/* $Header: /home/chara/cvsroot/ople/sys/ipc/stream/errorStream.cc,v 1.1.1.1 1998/06/11 21:36:38 chara Exp $ */
/*
modification history
--------------------
01a,19Jun97,rlj    written
*/

#include "ipcFifoAccessor.h"
#include "ipc.h"
#include "ipcid.h"
#include "rte.h"
#include "errorStream.h"
#include "typeTag.h"


const CiErrorStreamSemaphoreOptions = SEM_Q_FIFO;

/****
[[U CttErrorTag.tTypeTag::tTypeTag_STTNisz (ST_ERROR,TN_ERROR_INFO,-1,
      sizeof(ERROR_INFO) ) ]]
****/
const tTypeTag CttErrorTag (ST_ERROR,TN_ERROR_INFO,-1,sizeof(ERROR_INFO) );


/****
[[U tErrorStreamSender::tErrorStreamSender (iiId)]]
****/
tErrorStreamSender::tErrorStreamSender (const tIpcFifoId &iiId) :


  /****
  [[U tRelayStreamSender::tRelayStreamSender (iiId,
                      CiErrorStreamSemaphoreOptions)]]
  ****/
  tRelayStreamSender(iiId,CiErrorStreamSemaphoreOptions) {

  TraceMark (S_errorStream_SENDER_CONSTRUCTOR);
}

/****
[[U tErrorStreamSender::~tErrorStreamSender (void)]]
****/
tErrorStreamSender::~tErrorStreamSender () {

  TraceMark (S_errorStream_SENDER_DESTRUCTOR);
  
}

/****
[[U tErrorStreamSender::Put_ec (ecErrorCode)]]
****/
ERROR_CODE tErrorStreamSender::Put (ERROR_CODE ecErrCode ) {
 
  ERROR_CODE ec;
  ERROR_INFO eiInfo;
  
  TraceMark (S_errorStream_PUT_EC_START);
  
  eiInfo.iWhichRte  = GetRte().WhatsMyRTE();
  eiInfo.iWhichCpu   = GetRte().WhatsMyCPU();
  eiInfo.tTimeStamp = GetTime();
  eiInfo.ecErrCode  = ecErrCode;
  
  /****
  [[U ecErrCode := this->tRelayStreamSender::Put (CttErrorTag,eiInfo) ]]
  ****/
  ec = tRelayStreamSender::Put (CttErrorTag,(BYTE *) &eiInfo);
  
  if (ec != OK) return ec;
  
  TraceMark (S_errorStream_PUT_EC_COMPLETE);
  return OK;   
}

/****
[[U tErrorStreamSender::Put_ect (ecErrCode, tErrTime)]]
****/
ERROR_CODE tErrorStreamSender::Put( ERROR_CODE ecErrCode, TIME tErrTime ) {

 
  ERROR_CODE ec;
  ERROR_INFO eiInfo;
  
  TraceMark (S_errorStream_PUT_ECT_START);

  eiInfo.iWhichRte  = GetRte().WhatsMyRTE();
  eiInfo.iWhichCpu   = GetRte().WhatsMyCPU();
  eiInfo.tTimeStamp = tErrTime;
  eiInfo.ecErrCode  = ecErrCode;
  
  /****
  [[U ec := this->tRelayStreamSender::Put (CttErrorTag,eiInfo)]]
  ****/
  ec = tRelayStreamSender::Put (CttErrorTag,(BYTE *) &eiInfo);
  
  if (ec != OK)
    return ec;
  
  TraceMark (S_errorStream_PUT_ECT_COMPLETE);
  return OK;   
     
}


/****
[[U tErrorStreamSender::PutNoWait_ect (ecErrCode,tErrTime)]]
****/
ERROR_CODE tErrorStreamSender::PutNoWait( ERROR_CODE ecErrCode, 
                                          TIME tErrTime ) {     
 
  ERROR_CODE ec;
  ERROR_INFO eiInfo;
  
  TraceMark (S_errorStream_PUT_NO_WAIT_ECT_START);

  eiInfo.iWhichRte  = GetRte().WhatsMyRTE();
  eiInfo.iWhichCpu   = GetRte().WhatsMyCPU();
  eiInfo.tTimeStamp = tErrTime;
  eiInfo.ecErrCode  = ecErrCode;
  
  /****
  [[U ec := this->tRelayStreamSender::PutNoWait (CttErrorTag, (BYTE *) &eiInfo)]]
  ****/
  ec = tRelayStreamSender::PutNoWait (CttErrorTag,(BYTE *) &eiInfo);
  
  if (ec != OK)
    return ec;
  
  TraceMark (S_errorStream_PUT_NO_WAIT_ECT_COMPLETE);
   return OK;   
    
}

/****
[[U tErrorStreamReceiver::tErrorStreamReceiver (iiId)]]
****/
tErrorStreamReceiver::tErrorStreamReceiver (const tIpcFifoId &iiId) :  
  
  /****  
  [[U tRelayStreamReceiver::tRelayStreamReceiver (iiId) ]]
  ****/
  tRelayStreamReceiver(iiId) {

  TraceMark (S_errorStream_RECEIVER_CONSTRUCTOR);
}
  
/****
[[U tErrorStreamReceiver::~tErrorStreamReceiver (void)]]
****/
tErrorStreamReceiver::~tErrorStreamReceiver () {

  TraceMark (S_errorStream_RECEIVER_DESTRUCTOR);

  /****
  [[U tRelayStreamReceiver::~tRelayStreamReceiver (void) ]]
  ****/
  
}




