/*
 * Reads a byinary file of a series of integers and spits them
 * out of stdout as ascii numbers one per line.
 */

/* Theo ten Brummelaar August 1998 */

#include <stdio.h>

#define CONVERT_TO_MICRONS

main(int argc, char **argv)
{
	FILE	*input;
	int	i;
	float	error;
	float	mean,mean2,varriance;
	float	n;

	/* Check the command line */

	if (argc < 2)
	{
		fprintf(stderr,"usage: %s file\n",argv[0]);
		exit(-1);
	}

	/* Open the file for reading */

	if ((input = fopen(argv[1],"rb")) == NULL)
	{
		fprintf(stderr,"%s: Failed to open file %s for reading.\n",
			argv[0], argv[1]);
		exit(-2);
	}

	/* OK, red in the data and to your thing */

	mean = 0;
	varriance = 0;
	n = 0;
	while(fread(&i, sizeof(i) , 1, input) == 1)
	{

#ifdef CONVERT_TO_MICRONS
		error = (float)i * 1.319 / (256.0 * 4.0);
		printf("%e\n",error);
#else
		error = i;
		printf("%d\n",i);
#endif
		mean += error;
		mean2 += (error*error);
		n += 1.0;
	}
	mean /= n;
	mean2 /= n;

	varriance = mean2 - mean*mean;

	fprintf(stderr,"N = %f\nMean = %f\nSD = %f\n",n,mean,sqrt(varriance));
	printf("#N = %f\tMean = %f\tSD = %f\n",n,mean,sqrt(varriance));
	
	fclose(input);

	exit(0);

} 
