/* adcLib.h - type definitions for adcLib.c */
/* sccs info:	@(#)adcLib.h	1.2	17 Apr 1995 */

/*
modification history
--------------------
02c,17Apr95,beh  ANSI-fied
02b,16Jul91,grw  added adcFullInit declaration
02a,18Sep90,arg  part removed to make adcConfig.h.
01a,09Mar90,arg  written.
*/

/*
DESCRIPTION
Function prototypes of adcLib.c.
*/

#ifndef INCadcLibh
#define INCadcLibh

#include "rtTypes.h"
#include "rtModNum.h"

#define S_adc_ADDRESS_UNAVAILABLE    (M_adcLib | 1)
#define S_adc_INVALID_BOARD          (M_adcLib | 2)
#define S_adc_INVALID_CHANNEL        (M_adcLib | 3)
#define S_adc_INVALID_GAIN           (M_adcLib | 4)

STATUS adcFullInit(void);
STATUS adcInit(void);
int adcRead(int channel);
void adcSetGain(int channel, int gain);

#if (DEBUG >= 40)
void adcStatus(int board);
void adcShowData(int board);
#endif

#endif INCadcLibh
