#include <vxWorks.h>
#include <memLib.h>
#include <logLib.h>
#include <taskLib.h>
#include <sysLib.h>

void checkMem()
{
   unsigned long ulBiggestBlockNow, ulBiggestBlockFirst,
                 ulMemFreeNow, ulMemFreeFirst;
   long          lBiggestBlockDiff, lMemFreeDiff;
   MEM_PART_STATS memStats;
   
   memPartInfoGet(memSysPartId, &memStats);
   ulBiggestBlockFirst = memStats.maxBlockSizeFree;
   ulMemFreeFirst      = memStats.numBytesFree;

   FOREVER
   {
      memPartInfoGet(memSysPartId, &memStats);
      ulBiggestBlockNow = memStats.maxBlockSizeFree;
      ulMemFreeNow      = memStats.numBytesFree;

/*
      if (ulBiggestBlockNow != ulBiggestBlockFirst)
      {
         lBiggestBlockDiff = ulBiggestBlockNow - ulBiggestBlockFirst;
	 logMsg("Size of biggest block changed from %lu to %lu\t%ld\n",
                              ulBiggestBlockFirst,ulBiggestBlockNow,
                              lBiggestBlockDiff);
	 ulBiggestBlockFirst = ulBiggestBlockNow;
      }
*/

      if (ulMemFreeNow != ulMemFreeFirst)
      {
         lMemFreeDiff = ulMemFreeNow - ulMemFreeFirst;
	 logMsg("Size of free memory changed from %lu to %lu\t%ld\n",
                              ulMemFreeFirst, ulMemFreeNow,
                              lMemFreeDiff);
	 ulMemFreeFirst = ulMemFreeNow;
      }

      taskDelay(sysClkRateGet());   /* pause a sec */

   }   /* FOREVER */

}   /* checkMem() */
