#include <vxWorks.h>
#include <vme.h>
#include <usrLib.h>
#include <taskLib.h>
#include <logLib.h>
#include <recLibB.h>
#ifdef VW_502
#include <vxProto.h>
#endif
#include <stdio.h>
/*#include <iv68k.h>*/

typedef VOID BLOCKFUNC(int *address, int value);
typedef BLOCKFUNC *PBLOCKFUNC;

VOID glitchPatrol(int *lasaddr);
VOID rlaserN(int *lasaddr);
VOID rlaser(int *lasaddr);
VOID wlaser(int *lasaddr, int value);
VOID fill(int *startaddress, int blocksize, int value);
VOID ramp(int *startaddress, int blocksize, int value);
VOID ramTest(int *startaddress, int blocksize);
VOID blockTest(int *startaddress, int blocksize, PBLOCKFUNC test, int value);
VOID putValue(int *address, int value);
VOID checkValue(int *address, int value);

BOOL q = FALSE;
 
VOID glitchPatrol(int *lasaddr)
{
  int iLastValue , iCurrentValue;
  iLastValue = iCurrentValue = *lasaddr;

  FOREVER { 
    iCurrentValue = *lasaddr;
    recInt(iCurrentValue);
    if((iLastValue & 0xffff0000) > (iCurrentValue & 0xffff0000)) {
      printf("Glitch found:\tiLastValue = 0x%x\n\t\tiCurrValue = 0x%x\n", 
              iLastValue, iCurrentValue);
    }
    iLastValue = iCurrentValue;
    if(q) { q=FALSE; break; }
  }
}

int numN = 25;
VOID rlaserN(int *lasaddr)
{
  int lo, hi, i;
  for (;;) {
    for (i=0; i<numN; i++) {
      lo=*(lasaddr+1);
      hi=(*lasaddr) & 0xff;
      logMsg("0x%x%x\n", hi, lo,0,0,0,0);
    }
  taskDelay(60);
  }
}

VOID rlaser(int *lasaddr)
{
int dummy;
	for(;;){
	  dummy=*lasaddr;
	  printf("Register: 0x%x\n", dummy);
	  /*printf(".");*/
	}
}

VOID wlaser(int *lasaddr, int value)
{
	for(;;){
		*lasaddr = value;
	}
}

VOID fill(int *startaddress, int blocksize, int value)
{
    int *address;
    for(address=startaddress;address<(startaddress+blocksize);address++){
      *address=value;
    }
}

VOID ramp(int *startaddress, int blocksize, int startvalue)
{
    int *address;
    for(address=startaddress;address<(startaddress+blocksize);address++){
      *address=startvalue++;
    }
}


VOID ramTest(int *startaddress, int blocksize)
{
blockTest(startaddress, blocksize, putValue, 0);
blockTest(startaddress, blocksize, checkValue, 0);
blockTest(startaddress, blocksize, putValue, -1);
blockTest(startaddress, blocksize, checkValue, -1);
blockTest(startaddress, blocksize, putValue, 0xa5a5a5a5);
blockTest(startaddress, blocksize, checkValue, 0xa5a5a5a5);
blockTest(startaddress, blocksize, putValue, 0x5a5a5a5a);
blockTest(startaddress, blocksize, checkValue, 0x5a5a5a5a);
}

VOID blockTest(int *startaddress, int blocksize, PBLOCKFUNC test, int value)
{
  int *address;
  for(address=startaddress;(char *)address<((char *)startaddress)+blocksize;address++){
    (*test) (address, value);
  }
}

VOID putValue(int *address, int value)
{
  *address=value;
}

VOID checkValue(int *address, int value)
{
  int readvalue;
  readvalue=*address;
  if (readvalue!=value){
    printf("ERROR!  Address 0x%x: Wrote 0x%x, Read 0x%x, XOR 0x%x\n",
           (int)address,value,readvalue,value^readvalue);
  }
}



