/* dt1401Lib.h - function prototypes for dt1401 i/o card */
/*		sccs info:	@(#)dt1401Lib.h	1.4  9/1/94  */

/*
modification history
--------------------
01c,16Jul91,grw    added dt1401FullInit declaration 
01b,11May90,beh    added #ifndef INCdt1401Libh
01a,08May90,beh	written	
*/

/*
DESCRIPTION
This module contains function prototypes for the dt1401 library.
*/

#ifndef INCdt1401Libh
#define INCdt1401Libh

#include "rtModNum.h"

#define S_dt1401_NEGATIVE_RATE       (M_dt1401Lib | 1)
#define S_dt1401_NULL_FUNC_POINTER   (M_dt1401Lib | 2)

STATUS dt1401FullInit (void);
STATUS dt1401Init (void);
void dt1401DA0 (WORD value);
void dt1401DA1 (WORD value);
void dt1401DA  (int channel, WORD value);
void dt1401AD (WORD *pvalue);
UWORD dt1401DI(void);
void dt1401DO(UWORD value);
int dt1401ClkRateSet(int rate);
int dt1401ClkRateGet(void);
STATUS dt1401ClkEnable(void);
STATUS dt1401ClkDisable(void);
void dt1401ClkInt(void);
STATUS dt1401ClkConnect(void);
STATUS dt1401ClkDisconnect(void);
void dt1401IntHand(void);
void dt1401BackTask(void);
STATUS dt1401IsPresent (void);

#endif INCdt1401Libh

