/* dvme626_test.cc */

#include "dvme626_test.h"
#include "rtTypes.h"
#include <vme.h>
#include <stdio.h>

/* register address pointers */
static volatile UWORD *dacChannels[DAC_CHANNELS];	/* channel addresses */
static volatile UWORD *pdvme626BaseAdr;			/* board addresses */

static char *localAdrs;	/* convert bus to local addresses */


STATUS DVME626Init (void)
{
  int channel;
  
  if ( sysBusToLocalAdrs((int)DVME626_AM, (char *)DVME626_ADRS, &localAdrs) == ERROR)
    return ERROR;

  printf ("busAdrs: %xH, localAdrs: %xH \n", DVME626_ADRS, localAdrs);

  pdvme626BaseAdr = 	   (UWORD *) localAdrs;
  
  for (channel = 0; channel < DAC_CHANNELS; channel++)
    {
    /* finding address of each channel on the board */
    dacChannels[channel] = (UWORD *) (localAdrs + 0xA0 + (channel << 1));
    *dacChannels[channel] = (WORD) 0x0000;
    }
    
  return OK;
}


/*****************/
/* test function */


  void test_ch(int channel)
    {
    *dacChannels[channel] = 0x7FFF ;
    }



  void test1(int channel)
    {
    int i,k;
    DVME626Init();
    printf("DVME626 Init done. \n");
    for (i=0;i<0x1000000;i++)
      {
      *dacChannels[channel] = (WORD) i;
      for (k=0;k<10;k++);
      }
    }
   
   
  void test_vc(int channel)
    {
    int i,j;
    int attenuat=10;
    int offset=0;
    
    if (channel==0) offset=-400;
    if (channel==1) offset= 250;    
    if (channel==1) attenuat= 32;       
    
    DVME626Init();
    printf("DVME626 Init done. \n");
    while (1)
    for (i = -0x8000; i < 0x17FFF; i+=1) 
      {
      for (j = 0; j < 2; j++) 
      if (i < 0x8000)  *dacChannels[channel] = ((WORD) i)/attenuat + offset;
      else *dacChannels[channel] = ((WORD) (0xFFFF - i))/attenuat + offset;
      }
    }
    
     
  void dvme_tri(int channel, int attenuat, int speed, int offset)
    {
    int i,j;
    
    DVME626Init();
    printf("DVME626 Init done. \n");
    while (1)
    for (i = -0x8000; i < 0x17FFF; i+=speed) 
      {
      for (j = 0; j < 5; j++) 
      if (i < 0x8000)  *dacChannels[channel] = ((WORD) i)/attenuat + offset;
      else *dacChannels[channel] = ((WORD) (0xFFFF - i))/attenuat + offset;
      }
    }

  

