/* irigLib.h - typedefs for irigLib.c */
/*		sccs info:	@(#)irigLib.h	1.2  11/1/93  */

/*
 modification history
 --------------------
 01e,09sep91,mmc    Added RATE_IRIG,  changed to 50 usec tics
 01d,16Jul91,grw    Added irigFullInit declaration
 01c,11May90,beh    Added #ifndef INC...
 01b,08May90,beh    Added function prototypes and error codes
 01a,?????90,mmc    written
*/

/*
DESCRIPTION
Structure definitions and function prototypes for irigLib.c
*/

#ifndef INCirigLibh
#define INCirigLibh

#include "rtModNum.h"

#define RATE_IRIG	20000 /* equivalent rate of irigGetTime, ie, 50's usec */

typedef struct {		/* structure for irigGetTimeStruct */
	int day;
	int hour;
	int minute;
	int second;
	int msecond;
	int usecond;
} IrigTime;

#define S_irig_BOARD_NOT_INTIALIZED   (M_irigLib | 1)
#define S_irig_NULL_FUNC_POINTER      (M_irigLib | 2)
#define S_irig_NULL_POINTER_ARGUMENT  (M_irigLib | 2)

STATUS irigFullInit (void);
STATUS irigInit (void);
int irigClkRateSet(int rate);
int irigClkRateGet(void);
STATUS irigClkEnable(void);
STATUS irigClkDisable(void);
STATUS irigClkConnect(FUNCPTR routine, int arg);
STATUS irigClkDisconnect(void);
int irigGetTime (void);
int irigGetTimeNow (void);
int irigGetTimeUSec (void);
int irigGetTimeUSecNow (void);
STATUS irigGetTimeStruct (IrigTime *ptime);
STATUS irigGetTimeStructNow (IrigTime *ptime);

#endif INCirigLibh
