
#include <vxWorks.h>
#include <intLib.h>
#include <semLib.h>
#include <sysLib.h>
#include <stdio.h>
#include <taskLib.h>
#include <iv.h>

int iVec3 = 0x93;
int iLevel3=3;
int iVec4 = 0x9c;
int iLevel4=4;

SEM_ID sSem3, sSem4;
int cnt3, cnt4;
unsigned int *pBoard = (unsigned int *)0x81220000;

int tid3, tid4;

STATUS intAction3(void)
{
  cnt3=0;

  FOREVER {
    semTake(sSem3, WAIT_FOREVER);
    printf("%d(0x%08x)\n",iLevel3, *(pBoard + 0x08 + iLevel3) );
  }

  return ERROR;
}

void isr3(int iArg)
{
  semGive(sSem3);
}


STATUS intAction4(void)
{
  cnt4=0;

  FOREVER {
    semTake(sSem4, WAIT_FOREVER);
    printf("\t%d(0x%08x)\n",iLevel4, *(pBoard + 0x08 + iLevel4) );
  }

  return ERROR;
}

void isr4(int iArg)
{
  semGive(sSem4);
}


STATUS isrSetup(void)
{
  sSem3 = semBCreate(SEM_Q_FIFO, SEM_EMPTY);
  if (sSem3 == NULL) {
    printf("semBCreate Failed for int 3\n");
    return ERROR;
  }
  
  tid3 = taskSpawn("intAction3",50,0,2048,(FUNCPTR) &intAction3,
               0,0,0,0,0,0,0,0,0,0);
  if (tid3==ERROR) {
     printf("taskSpawn Failed for int 3\n");
     return ERROR;
  }
  
  if (intConnect((VOIDFUNCPTR *) INUM_TO_IVEC(iVec3), &isr3, 0) != OK) {
     printf("intConnect Failed for int 3\n");
     return ERROR;
  }

  sSem4 = semBCreate(SEM_Q_FIFO, SEM_EMPTY);
  if (sSem4 == NULL) {
    printf("semBCreate Failed for int 4\n");
    return ERROR;
  }
  
  tid4 = taskSpawn("intAction4",50,0,2048,(FUNCPTR) &intAction4,
               0,0,0,0,0,0,0,0,0,0);
  if (tid4==ERROR) {
     printf("taskSpawn Failed for int 4\n");
     return ERROR;
  }
  
  if (intConnect((VOIDFUNCPTR *) INUM_TO_IVEC(iVec4), &isr4, 0) != OK) {
     printf("intConnect Failed for int 4\n");
     return ERROR;
  }

  if (intEnable(iVec3) != OK) {
     printf ("Error enabling int 3\n");
     return ERROR;
    }
//  if (sysIntEnable(iLevel4) != OK) {
//     printf ("Error enabling int 4\n");
//     return ERROR;
//  }
//
  printf("Setting up chip...\n");
  taskDelay(60);

  *pBoard = 0x10;
  *(pBoard + 0x20 + iLevel3) = 0x800ff7cfU;
  *(pBoard + 0x10 + iLevel3) = 0x8000 + iVec3;
//   *(pBoard + 0x20 + iLevel4) = 0x801ff7cfU;
//  *(pBoard + 0x10 + iLevel4) = 0x8000 + iVec4;
//  
  return OK;
}

STATUS isrStop(void)
{
  printf("Disconnecting interrupts...\n");
  taskDelay(60);

  *(pBoard + 0x20 + iLevel4) = 0x01000000U;
  *(pBoard + 0x10 + iLevel4) = 0x0000 + iVec4;
  *(pBoard + 0x20 + iLevel3) = 0x00800000U;
  *(pBoard + 0x10 + iLevel3) = 0x0000 + iVec3;
  
  sysIntDisable(iLevel4);
  sysIntDisable(iLevel3);

  taskDelete(tid4);
  semDelete(sSem4);
  
  taskDelete(tid3);
  semDelete(sSem3);

  return OK;
}

