/* laserBoard_test.c */

#include <vxWorks.h>
#include <logLib.h>
#include <rtTypes.h>
#include "laserLib.h"
#include <stdio.h>
#include <string.h>
#include "recLibB.h"
#include "irigLib.h"



/*****************/
/* test function */

void full_init(int n)
    {
    irigFullInit();               /* init irig board PC03V */
    irigClkRateSet(10000);        /* irig ext clock = 10 kHz */
    if (laserFullInit(n) == ERROR) printf("error in laserFullInit\n");
    laserSetSyncMode(1,1);        /* synchro sur Ref input */
    }
    
void counter(int n)
    {
    LWORD *pvalue;
    laserCprLo(n,pvalue);
    printf("Counter %i value : %lxh\n", n, *pvalue);
    }
    
void countLoop(int n)
    {
    LWORD *pvalue, *poldValue;
    do
      {
      laserCprLo(n,pvalue);
      printf("Counter %i value : %08lX\n", n, (*pvalue - *poldValue));
      *poldValue = *pvalue;
      }
    while(n==n);
    }
    
    
void CPRLoop(int n)
    {
    LWORD *pvalue, *pvalue2;
    do
      {
      laserCprInt(n,pvalue);
      laserCprFrac(n,pvalue2);
      printf("Counter %i value : %lX,%02lX\n", n, *pvalue, *pvalue2 );
      }
    while(n==n);
    }
  
void CPRLoLoop(int n)
    {
    LWORD *pvalue;
    do
      {
      laserCprLo(n,pvalue);
      printf("%lX\n", *pvalue );
      }
    while(n==n);
    }
 
void CPRaccess(int n)
    {
    LWORD *pvalue,i;
    do 
      {
      laserCprLo(n,pvalue);
      for(i=0;i<500;i++) i=i;
      }
    while(1);
    }
void FPRLoop(int n)
    {
    LWORD *pvalue;
    do
      {
      laserFprInt(n,pvalue);
      printf("Counter %i value : %li\n", n, *pvalue );
      }
    while(n==n);
    }

/*
void store(int n)
    {
    LWORD *pvalue;
    char name[12];
    
    strcpy("renaud.dat",name);
  recOpen(name);
    } */