/* laserConfig.h  -  configuration header file for laserLib.c library */
/* sccs info:       @(#)laserConfig.h	1.1  11/4/93  */

/*
modification history
--------------------
01d,beh,01Jun90     Enabled Heurikon-specific bus locking stuff
01c,beh,23May90     Added 64-bit locking, NO_EXT_SYNC option
01b,beh,05May90     Changed LBOARD to LASER, changed to A24
01a,beh,19Feb90     created from laserLib.h
*/

#ifndef INC_laserConfigh
#define INC_laserConfigh

/* The following defines assume that you've configured the card for
 * A24 addressing at address 0xffff00.	*/

#define LASER_ADDRESS 0xfc0000
#define LASER_AM VME_AM_STD_SUP_DATA

/* #define LASER_ADDRESS 0xE80000 */


/* The following defines would be used if you've configured the card for
 * A16 addressing at address 0x8000.	*/
/* #define LASER_ADDRESS 0x8000 */
/* #define LASER_AM VME_AM_SUP_SHORT_IO */

/* If you don't have an External Sync input, you should include the following line */
/* #define LASER_NO_EXT_SYNC TRUE */

/* Define the following if you have written a bus-locked 64-bit read routine for
   your CPU board */


/* You should include one of these two lines, controlling whether you want
 * to bus lock your 64-bit laser counter accesses (strongly recommended) */
/* If you include the second, you need to also compile
 * laserRead64.c and load it in before laserLib.o       */

#define LASER_READ64LOCKED(fromAddress,p64bitNum) \
                  laserRead64Unlocked(fromAddress,p64bitNum)
/* #include "laserRead64.h" */

/* Include hardware-specific defines needed by laserRead64.c */
#if defined(THEMIS)
#include "/usr/local/realtime/archive/config/ts133/tsvme133.h"
#elif defined(HKV30)
#include <../config/hkv30/hkv30.h>
#elif defined(HKV3E)
#include <../config/hkv3e/hkv2e.h>
#elif defined(SV34)
#include <../config/syn/config.h>
#endif


#endif  /* INC_laserConfigh */
