/* mm6216_test.c */

#include "rtTypes.h"
#include <vme.h>
#include <stdio.h>

#define MM6216_ADRS	0x08000000               /* board address */
#define MM6216_AM	VME_AM_EXT_SUP_DATA      /* address space (in vme.h) */

/* register address pointers */
static char *baseAdrs;	/* convert bus to base addresses */

STATUS MM6216Init(void)
{
  if ( sysBusToLocalAdrs((int) MM6216_AM, (char *)MM6216_ADRS, &baseAdrs) == ERROR)
    return ERROR;

  printf ("busAdrs: %xH, baseAdrs: %lxH \n", MM6216_ADRS, baseAdrs);

  return OK;
}


/*****************/
/* test function */

  void test(void)
    {
    static volatile ULWORD *pvariable1, *pvariable2, *pvariable3, *pvariable4;
    
    MM6216Init();
    printf("MM6216 Init done. \n");
 
    pvariable1 = (ULWORD *)	( baseAdrs + 0);
    pvariable2 = (ULWORD *)	( baseAdrs + 0x8000);
    pvariable3 = (ULWORD *)	( baseAdrs + 0x800000);
    pvariable4 = (ULWORD *)	( baseAdrs + 0xFFFFF0);
  
    *pvariable1 = (ULWORD) (0x1234); 
    *pvariable2 = (ULWORD) (0x12345678); 
    *pvariable3 = (ULWORD) (0x89ab); 
    *pvariable4 = (ULWORD) (0xcdef);     
  
    printf("base           : 1234 = %lxH\n", *pvariable1);
    printf("base +   8000h : 12345678 = %lxH\n", *pvariable2);
    printf("base + 800000h : 89AB = %lxH\n", *pvariable3);
    printf("base + FFFFF0h : CDEF = %lxH\n", *pvariable4);
 
    }
 