/*

*/


#include <vxWorks.h>
#include <iv.h>
#include <intLib.h>
#include "/home/phil/palomar/rtTypes.h"
#include "/home/phil/palomar/drivers/dt1401Lib.h"


#define PC03V_INT_VEC   0xc0
#define PC03V_HB_PERIOD 400

#define CAPTR (0x00/2)
#define TIME0 (0x02/2)
#define TIME1 (0x04/2)
#define TIME2 (0x06/2)
#define TIME3 (0x08/2)
#define CLRIG (0x0a/2)
#define CR0   (0x0c/2)
#define CR1   (0x0e/2)
#define BIMCR0  (0x20/2)
#define BIMCR1  (0x22/2)
#define BIMCR2  (0x24/2)
#define BIMCR3  (0x26/2)
#define BIMV0 (0x28/2)
#define BIMV1 (0x2a/2)
#define BIMV2 (0x2c/2)
#define BIMV3 (0x2e/2)
#define RELFR (0x30/2)
#define CTC0  (0x80/2)
#define CTC1  (0x82/2)
#define CTC2  (0x84/2)
#define CTCCR (0x86/2)

uint16_t *pvAddress[2]={0xefffaa00,0xefffab00};

void itpLaserRead(void);

STATUS goIrig(int iWhichCpu)
{
  STATUS status;
  static uint16_t pIntNum[2]={3,4};
  static int      pDaValue[2]={0,0x400};

  if(iWhichCpu>1 || iWhichCpu<0) {
    return ERROR;
  }

  /* initialize dt1401 card */
  dt1401FullInit();

  /* set up board registers */
  *(pvAddress[iWhichCpu]+CR0)=0;
  *(pvAddress[iWhichCpu]+CR1)=0x0015;
  *(pvAddress[iWhichCpu]+BIMCR1)=pIntNum[iWhichCpu];
  *(pvAddress[iWhichCpu]+BIMV1)=PC03V_INT_VEC;
  *(pvAddress[iWhichCpu]+CTCCR)=0x34;
  *(pvAddress[iWhichCpu]+CTC0)=0x00ff & (PC03V_HB_PERIOD);
  *(pvAddress[iWhichCpu]+CTC0)=0x00ff & ((PC03V_HB_PERIOD)>>8);

  /* connect interrupt */
/*
  status = intConnect ((VOIDFUNCPTR *)INUM_TO_IVEC(PC03V_INT_VEC),
              (VOIDFUNCPTR) dt1401DA0, pDaValue[iWhichCpu]);
*/
  status = intConnect ((VOIDFUNCPTR *)INUM_TO_IVEC(PC03V_INT_VEC),
              (VOIDFUNCPTR) itpLaserRead, 0);
  if(status == ERROR) {
    return ERROR;
  }

  /*enable this bus interrupt level */
  status = sysIntEnable ((int) pIntNum[iWhichCpu]);
  if(status == ERROR) {
    return ERROR;
  }

  *(pvAddress[iWhichCpu]+BIMCR1) |= 0x0010;

  return OK;
}

 
STATUS stopIrig(int iWhichCpu)
{

  if(iWhichCpu>1 || iWhichCpu<0) {
    return ERROR;
  }

  *(pvAddress[iWhichCpu]+BIMCR1) &= ~0x0010;
  return OK;
}  
