/* pztMotor_test.c */

#include <vxWorks.h>
#include <rtTypes.h>
#include "pztMotorLib.h"
#include <stdio.h>
#include <string.h>
#include "recItpDlineF.h"
#include "recLibB.h"



/*****************/
/* test function */

void init(void)
    {
    if (pztMotorFullInit(6,6) == ERROR) printf("error in pztMotorFullInit\n");
    }
    
void go(int motor)
    {
    motorVelocitySet(motor,20);
    }
    
void go_back(int motor)
    {
    motorVelocitySet(motor,-20);
    }
    
void stop(int motor)
    {
    motorVelocitySet(motor,0);
    }

void go_at(int motor, int v)
    {
    motorVelocitySet(motor,v);
    }

                
void limit_switch(int motor)
    {
    while (1)  
      {
      if (motorStatusCwHardLimit(motor)==TRUE) printf("CW HARD"); 
      if (motorStatusCCwHardLimit(motor)==TRUE) printf("CCW HARD");
      if (motorStatusCwSoftLimit(motor)==TRUE) printf("CW Soft");
      if (motorStatusCCwSoftLimit(motor)==TRUE) printf("CCW SOFT");
      printf("\n");
      }
    }
 

void pzt2_tri(LWORD f, LWORD d) 
    /* f value d delay */
    {
    LWORD i;
    while (1)
      {
      pztReset(2);
      pztVelocitySet(2, f);
      for (i=0;i<d;i++);
      pztVelocitySet(2, -f);
      for (i=0;i<d;i++);
      }
    }


void pzt_check(int pzt) 
    {
    LWORD i;
    while (1)
      {
      pztReset(pzt);
      pztVelocitySet(pzt, 0x80);
      for (i=0;i<0x500000;i++);
      pztVelocitySet(pzt, -0x80);
      for (i=0;i<0x500000;i++);
      }
    }

void pzt1_tri(LWORD f, LWORD att) 
    /* f frequency (hertz) att attenuation (times) */
    {
    LWORD i,j;
    
    while (1)
    
    for (i=-0x8000;i<0x18000;i+=f) /* for (j=0;j<0xA;j++) */
      
       if (i<0x8000) pztVelocitySet(1, 0x4000 + i/att);
         else pztVelocitySet(1, 0x4000 + (0x10000 - i)/att);
    }


/* void save_tri1(LWORD f,LWORD att) 
    /* f frequency (hertz) att attenuation (times) */
/*    {
    LWORD i,j,k;
    recItpDlineInit(1000);
    recOpen("Ren_test");

    for (k=0;k<200;k++)
    
     for (i=-0x8000;i<0x18000;i+=f) /* for (j=0;j<0xA;j++) */
/*      if (i<0x8000) pztVelocitySet(1, 0x4000 + i/att);
      else pztVelocitySet(1, 0x4000 + (0x10000 - i)/att);

    recClose();
    }
*/
/* void save_tri2(LWORD f, LWORD d) 
    /* f value d delay */
/*    {
    LWORD i,k;
    
    recItpDlineInit(1000);
    recOpen("Ren_test");

    for (k=0;k<100;k++)
      {
      pztReset(2);
      pztVelocitySet(2, f);
      for (i=0;i<d;i++);
      pztVelocitySet(2, -f);
      for (i=0;i<d;i++);
      }      
    recClose();
    }
*/
