/* statTbl.c - status code symbol table */

/* CREATED BY makeStatTbl
 *       FROM /home/chara/ople/sys/include
 *       FROM /opt/wind/target/h
 *         ON Wed Jan 27 08:59:54 PST 1999
 */

#include "vxWorks.h"
#include "symbol.h"
#include "rpc/rpctypes.h"
#include "rpc/xdr.h"
#include "xdr_nfs.h"
#include "rpc/auth.h"
#include "rpc/clnt.h"

#include "rtModNum.h"
#include "vwModNum.h"

#define  S_sched_SCHEDULER_NOT_INITIALIZED        (M_sched | 0x01)
#define  S_sched_NULL_TASK_EXEC_FUNCTION_POINTER  (M_sched | 0x02)
#define  S_sched_ILLEGAL_TASK_PERIOD              (M_sched | 0x03)
#define  S_sched_SCHEDULER_ALREADY_INITIALIZED    (M_sched | 0x04)
#define  S_sched_MAX_TASKS_EXCEEDED               (M_sched | 0x05)
#define  S_sched_INVALID_PRIORITY                 (M_sched | 0x06)
#define  S_sched_ILLEGAL_TASK_OFFSET              (M_sched | 0x07)
#define  S_sched_OUT_OF_TCB_POINTERS              (M_sched | 0x08)
#define  S_sched_INVALID_VALUE_FOR_MAXTASKS       (M_sched | 0x09)
#define  S_sched_INSUFFICIENT_MEMORY              (M_sched | 0x0a)
#define  S_sched_NOT_ENABLED                      (M_sched | 0x0b)
#define  S_sched_INVALID_TASK_MODE                (M_sched | 0x0c)
#define  S_sched_INVALID_TASK_ID                  (M_sched | 0x0d)
#define  S_sched_TASK_STARVING                    (M_sched | 0x0e)
#define  S_sched_UNEXPECTED_TASK_MODE             (M_sched | 0x0f)
#define  S_sched_TASK_HAS_PANICKED                (M_sched | 0x10)
#define S_sched_ENTERING_ADD_TASK                 (M_sched | 0x1001)
#define S_sched_PERIOD_AND_OFFSET_SET             (M_sched | 0x1002)
#define S_sched_JUST_ISSUED_TASK_LOCK             (M_sched | 0x1003)
#define S_sched_JUST_INSERTED_NEW_TCB             (M_sched | 0x1004)
#define S_sched_JUST_SPAWNED_NEW_TASKSKEL         (M_sched | 0x1005)
#define S_sched_LEAVING_ADD_TASK                  (M_sched | 0x1006)
#define S_sched_ENTERING_INIT                     (M_sched | 0x1007)
#define S_sched_ADJUSTED_VXWORKS_TASK_PRIOS       (M_sched | 0x1008)
#define S_sched_TASK_SET_INITIALIZED              (M_sched | 0x1009)
#define S_sched_CONNECTED_INTERRUPT_TO_SCHEDISR   (M_sched | 0x100a)
#define S_sched_LEAVING_INIT                      (M_sched | 0x100b)
#define S_sched_IN_TASKSKEL                       (M_sched | 0x100c)
#define S_sched_ENTERING_REMOVETASK               (M_sched | 0x100d)
#define S_sched_TASK_PERIOD_SET                   (M_sched | 0x100e)
#define S_sched_TASK_OFFSET_SET                   (M_sched | 0x100f)
#define S_sched_FOUND_EMPTY_TASK_PTR_TO_USE       (M_sched | 0x1010)
#define S_sched_DISABLED_SCHEDULER_IN_ADDTASK     (M_sched | 0x1011)
#define S_sched_FOUND_WHERE_TO_INSERT_TCB         (M_sched | 0x1012)
#define S_sched_MADE_SPACE_TO_INSERT_TCB          (M_sched | 0x1013)
#define S_sched_ABOUT_TO_DISABLE_SCHEDULER        (M_sched | 0x1014)
#define S_sched_ABOUT_TO_ENABLE_SCHEDULER         (M_sched | 0x1015)
#define S_sched_ABOUT_TO_DISABLE_A_TASK           (M_sched | 0x1016)
#define S_sched_ABOUT_TO_ENABLE_A_TASK            (M_sched | 0x1017)
#define S_sched_ABOUT_TO_DELETE_A_TASK            (M_sched | 0x1018)
#define S_baseObject_ALREADY_INITIALIZED    (M_baseObject | 0x1001)
#define S_baseObject_ALREADY_SHUTDOWN       (M_baseObject | 0x1002)
#define S_cmdhdlr_CANT_ALLOCATE_COMMAND_STREAMS  (M_cmdHdlr | 0x1)
#define S_cmdhdlr_INVALID_CMD_STREAM             (M_cmdHdlr | 0x2)
#define S_cmdhdlr_INVALID_GIZMO_ID               (M_cmdHdlr | 0x3)
#define S_cmdhdlr_ALREADY_INITIALIZED            (M_cmdHdlr | 0x1001)
#define S_cmdhdlr_ALREADY_SHUTDOWN               (M_cmdHdlr | 0x1002)
#define S_cmdHdlr_ENTERING_CMD_PROC_INIT             (M_cmdHdlr | 0x2001)
#define S_cmdHdlr_COMMAND_STREAM_INITIALIZED         (M_cmdHdlr | 0x2002)
#define S_cmdHdlr_LEAVING_CMD_PROC_INIT              (M_cmdHdlr | 0x2003)
#define S_cmdHdlr_GETTING_A_CMD_TO_PROCESS           (M_cmdHdlr | 0x2004)
#define S_cmdhdlr_ENTERING_CMDHDLR_CONSTRUCTOR       (M_cmdHdlr | 0x2005)
#define S_cmdHdlr_LEAVING_CMDHDLR_INIT               (M_cmdHdlr | 0x2006)
#define S_cmdHdlr_PUT                                (M_cmdHdlr | 0x2007)
#define S_cmdHdlr_CHECKING_FOR_NEW_CMD               (M_cmdHdlr | 0x2008)
#define S_cmdHdlr_LEAVING_CMDHDLR_DESTRUCTOR         (M_cmdHdlr | 0x2009)
#define S_cmdHdlr_ENTERING_CMDHDLR_DESTRUCTOR        (M_cmdHdlr | 0x200a)
#define S_cmdHdlr_RESTART                            (M_cmdHdlr | 0x2009)
#define S_cmdHdlr_SHUTDOWN                           (M_cmdHdlr | 0x200a)
#define S_cmdHdlr_ISOK                               (M_cmdHdlr | 0x2009)
#define S_commandStream_SENDER_CONSTRUCTOR     (M_commandStream | 0x2001)
#define S_commandStream_SENDER_DESTRUCTOR      (M_commandStream | 0x2002)
#define S_commandStream_RECEIVER_CONSTRUCTOR   (M_commandStream | 0x2003)
#define S_commandStream_RECEIVER_DESTRUCTOR    (M_commandStream | 0x2004)
#define S_configMgr_CHANNEL_INFO                          (M_configMgr | 0x0001)
#define S_configMgr_INVALID_GIZMO_TYPE                    (M_configMgr | 0x0002)
#define S_configMgr_INVALID_RTE_NUM                       (M_configMgr | 0x0003)
#define S_configMgr_ENTERING_CONFIG_MANAGER_CONSTRUCTOR   (M_configMgr | 0x1001)
#define S_configMgr_CONSTRUCTING_INST_GIZMO_INFO          (M_configMgr | 0x1002)
#define S_configMgr_CONSTRUCTING_BB1_DL_GIZMO             (M_configMgr | 0x1003)
#define S_configMgr_CONSTRUCTING_BB2_DL_GIZMO             (M_configMgr | 0x1004)
#define S_configMgr_CONSTRUCTING_GSU_DL_GIZMO             (M_configMgr | 0x1005)
#define S_configMgr_CONSTRUCTING_FT_GIZMO                 (M_configMgr | 0x1006)
#define S_configMgr_CONSTRUCTING_EM_GIZMO                 (M_configMgr | 0x1007)
#define S_configMgr_CONSTRUCTING_ST_GIZMO                 (M_configMgr | 0x1008)
#define S_configMgr_DONE_CONSTRUCTING_CONFIG_MANAGER      (M_configMgr | 0x1009)
#define S_configMgr_CONSTRUCTING_INST_GIZMO_0             (M_configMgr | 0x1009)
#define S_configMgr_UNKNOWN_INSTRUMENT_GIZMO_NUMBER       (M_configMgr | 0x100b)
#define S_configMgr_CONSTRUCTING_BB1_DL_GIZMO_0           (M_configMgr | 0x100c)
#define S_configMgr_UNKNOWN_BB1_DL_GIZMO_NUMBER           (M_configMgr | 0x100d)
#define S_configMgr_CONSTRUCTING_BB2_DL_GIZMO_0           (M_configMgr | 0x100e)
#define S_configMgr_CONSTRUCTING_GSU_DL_GIZMO_0           (M_configMgr | 0x100f)
#define S_configMgr_UNKNOWN_GSU_DL_GIZMO_NUMBER           (M_configMgr | 0x1010)
#define S_configMgr_CONSTRUCTING_FT_GIZMO_0               (M_configMgr | 0x1011)
#define S_configMgr_UNKNOWN_FT_GIZMO_NUMBER               (M_configMgr | 0x1012)
#define S_configMgr_CONSTRUCTING_EM_GIZMO_0               (M_configMgr | 0x1013)
#define S_configMgr_UNKNOWN_EM_GIZMO_NUMBER               (M_configMgr | 0x1014)
#define S_rteConfig_CREATE_NEW_INSTRUMENT         (M_rteConfig | 0x1000)
#define S_rteConfig_CREATE_NEW_DELAY_LINE         (M_rteConfig | 0x1001)
#define S_rteConfig_CREATE_NEW_GSU_DELAY_LINE     (M_rteConfig | 0x1002)
#define S_rteConfig_CREATE_NEW_QUIC_DELAY_LINE    (M_rteConfig | 0x1003)
#define S_rteConfig_CREATE_NEW_FRINGE_TRACKER     (M_rteConfig | 0x1004)
#define S_rteConfig_CREATE_NEW_EXTERNAL_METROLOGY (M_rteConfig | 0x1005)
#define S_rteConfig_CREATE_NEW_STAR_TRACKER       (M_rteConfig | 0x1006)
#define S_rteConfig_CANNOT_CREATE_GENERIC_DELAY_LINE   (M_rteConfig | 0x1007)
#define S_controller_UNABLE_TO_ALLOCATE_MODED_CONTROLLER   (M_controller | 0x1)
#define S_controller_INVALID_CONTROLLER_MODE               (M_controller | 0x2)
#define S_controller_UNASSIGNED_CONTROLLER_MODE            (M_controller | 0x3)
#define S_controller_INVALID_CONTROLLER                    (M_controller | 0x4)
#define S_controller_INVALID_MODED_CONTROLLER              (M_controller | 0x5)
#define S_controllergroup_UNABLE_TO_ALLOCATE_CONTROLLER_GROUP   (M_controller | 0x1)
#define S_controllergroup_INVALID_PARTITION                     (M_controller | 0x2)
#define S_controllergroup_INVALID_CONTROLLER_MODE               (M_controller | 0x3)
#define S_controllergroup_INVALID_CONTROLLER_GROUP              (M_controller | 0x4)
#define S_controllergroup_INVALID_CONTROLLER_MODE_FROM_UPDATE   (M_controller | 0x5)
#define S_controllerset_UNABLE_TO_ALLOCATE_CONTROLLER_SET       (M_controller | 0x6)
#define S_controllergroup_INVALID_MODED_CONTROLLER              (M_controller | 0x7)
#define S_controllergroup_GROUP_NOT_SAME_SIZE                   (M_controller | 0x8)
#define S_controllergroup_UNASSIGNED_CONTROLLER_GROUP           (M_controller | 0x9) 
#define S_datastore_UNABLE_TO_CREATE_DATA_BUFFERS (M_datastore | 0x01)
#define S_dataStore_DATA_SEND_INCOMPLETE          (M_datastore | 0x02)
#define S_dlgizmo_GIZMO_INFO_NOT_DL                          (M_dlgizmo |  0x1)
#define S_dlgizmo_INVALID_NUMBER_OF_SERVO_MODES              (M_dlgizmo |  0x2)
#define S_dlgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS         (M_dlgizmo |  0x3)
#define S_dlgizmo_UNRECOGNIZED_COMMAND                       (M_dlgizmo |  0x4)
#define S_dlgizmo_DATA_RECORDING_OFF                         (M_dlgizmo |  0x5)
#define S_dlgizmo_DATA_RECORDING_ON                          (M_dlgizmo |  0x6)
#define S_dlgizmo_DELAY_LINE_ALIVE                           (M_dlgizmo |  0x1001)
#define S_dlLimits_NULL_SCHEDULER_POINTER                    (M_dlLimits | 0x1)
#define S_dlLimits_SCHEDULER_ADJUSTED_LIMITS_TASK_PERIOD     (M_dlLimits | 0x2)
#define S_dlLimits_NULL_GIZMO_POINTER                        (M_dlLimits | 0x3)
#define S_dlLimits_DELAY_LINE_REACHED_LIMIT                  (M_dlLimits | 0x4)
#define S_tDlLimits_ENTERING_CONSTRUCTOR_BODY                (M_dlLimits | 0x1001)
#define S_tDlLimits_EXITING_CONSTRUCTOR                      (M_dlLimits | 0x1002)
#define S_tDlLimits_ENTERING_INITIALIZE                      (M_dlLimits | 0x1003)
#define S_tDlLimits_ADDING_READ_LIMITS_TASK                  (M_dlLimits | 0x1004)
#define S_tDlLimits_INITIALIZE_RETURNED_FROM_ADD_TASK        (M_dlLimits | 0x1005)
#define S_tDlLimits_INITIALIZE_DONE                          (M_dlLimits | 0x1006)
#define S_tDlLimits_ENTERING_UPDATE_CACHED_LIMIT_VALUES      (M_dlLimits | 0x1007)
#define S_tDlLimits_EXITING_UPDATE_CACHED_LIMIT_VALUES       (M_dlLimits | 0x1008)
#define S_dlCommandProcessor_DELAY_LINE_NUMBER_OUT_OF_RANGE    (M_dlCommandProcessor | 0x1)
#define S_dlCommandProcessor_INTERNAL_ERROR__CORRECT_DELAY_LINE_NUMBER_NOT_HANDLED    (M_dlCommandProcessor | 0x2)
#define S_dlCommandProcessor_UNRECOGNIZED_COMMAND              (M_dlCommandProcessor | 0x3)
#define S_dlCommandProcessor_COULD_NOT_CREATE_COMMAND_ENGINE   (M_dlCommandProcessor | 0x4)
#define S_offCommand_OFF_START                                 (M_offCommand | 0x1)
#define S_offCommand_OFF_DONE                                  (M_offCommand | 0x2)
#define S_frontCommand_FRONT_START                             (M_frontCommand | 0x1)
#define S_frontCommand_FRONT_DONE                              (M_frontCommand | 0x2)
#define S_frontCommand_FRONT_ABORTED                           (M_frontCommand | 0x3)
#define S_backCommand_BACK_START                               (M_backCommand | 0x1)
#define S_backCommand_BACK_DONE                                (M_backCommand | 0x2)
#define S_backCommand_BACK_ABORTED                             (M_backCommand | 0x3)
#define S_trackCommand_TRACK_START                             (M_trackCommand | 0x1)
#define S_trackCommand_TRACK_IN_PROGRESS                       (M_trackCommand | 0x2)
#define S_trackCommand_TRACK_ABORTED                           (M_trackCommand | 0x3)
#define S_clearLaserCounterCommand_CLEAR_LASER_COUNTER_START    (M_clearLaserCounterCommand | 0x1)
#define S_clearLaserCounterCommand_CLEAR_LASER_COUNTER_COMPLETE (M_clearLaserCounterCommand | 0x2)
#define S_setModulationCommand_SET_MODULATION_COMPLETE                (M_setModulationCommand | 0x2)
#define S_setServoParametersCommand_SET_SERVO_PARAMETERS_COMPLETE     (M_setServoParametersCommand | 0x2)
#define S_dlServo_INVALID_SERVO_MODE                            (M_dlServo | 0x1)
#define S_dl_NULL_HARDWARE_POINTER                              (M_dl | 0x1)
#define S_homesetCommand_HOMESET_START			(M_homesetCommand | 0x1)
#define S_homesetCommand_HOMESET_BACK_START		(M_homesetCommand | 0x2)
#define S_homesetCommand_HOMESET_FRONT_START		(M_homesetCommand | 0x3)
#define S_homesetCommand_HOMESET_CREEPBACK_START	(M_homesetCommand | 0x4)
#define S_homesetCommand_HOMESET_CREEPFRONT_START	(M_homesetCommand | 0x5)
#define S_homesetCommand_HOMESET_DONE			(M_homesetCommand | 0x6)
#define S_homesetCommand_HOMESET_ABORTED		(M_homesetCommand | 0x7)
#define S_homesetCommand_CANNOT_FIND_HOME_SENSOR 	(M_homesetCommand | 0x8)
#define S_homecheckCommand_HOMECHECK_START		(M_homecheckCommand | 0x1)
#define S_homecheckCommand_HOMECHECK_FRONT_START	(M_homecheckCommand | 0x2)
#define S_homecheckCommand_HOMECHECK_BACK_START		(M_homecheckCommand | 0x3)
#define S_homecheckCommand_HOMECHECK_CREEPFRONT_START	(M_homecheckCommand | 0x4)
#define S_homecheckCommand_HOMECHECK_CREEPBACK_START	(M_homecheckCommand | 0x5)
#define S_homecheckCommand_HOMECHECK_DONE		(M_homecheckCommand | 0x6)
#define S_homecheckCommand_HOMECHECK_ABORTED		(M_homecheckCommand | 0x7)
#define S_homecheckCommand_CANNOT_FIND_HOME_SENSOR 	(M_homecheckCommand | 0x8)
#define S_user1Command_USER1_START			(M_user1Command | 0x1)
#define S_user1Command_USER1_IN_PROGRESS		(M_user1Command | 0x2)
#define S_user1Command_USER1_ABORTED			(M_user1Command | 0x3)
#define S_user2Command_USER2_START			(M_user2Command | 0x1)
#define S_user2Command_USER2_IN_PROGRESS		(M_user2Command | 0x2)
#define S_user2Command_USER2_ABORTED			(M_user2Command | 0x3)
#define S_ditherCalibCommand_CALIB_DITHER_START		(M_ditherCalibCommand | 0x1)
#define S_ditherCalibCommand_CALIB_DITHER_IN_PROGRESS	(M_ditherCalibCommand | 0x2)
#define S_ditherCalibCommand_CALIB_DITHER_DONE		(M_ditherCalibCommand | 0x3)
#define S_ditherCalibCommand_CALIB_DITHER_ABORTED	(M_ditherCalibCommand | 0x4)
#define S_ditherCheckCommand_CHECK_DITHER_START		(M_ditherCheckCommand | 0x1)
#define S_ditherCheckCommand_CHECK_DITHER_IN_PROGRESS	(M_ditherCheckCommand | 0x2)
#define S_ditherCheckCommand_CHECK_DITHER_DONE		(M_ditherCheckCommand | 0x3)
#define S_ditherCheckCommand_CHECK_DITHER_ABORTED	(M_ditherCheckCommand | 0x4)
#define S_setActiveTargetCommand_SELECT_TARGET_COMPLETE	(M_setActiveTargetCommand | 0x2)
#define S_dlPingCommand_DELAY_LINE_ALIVE		(M_dlPingCommand | 0x1)
#define S_dlSetDitheringCommand_TURN_DITHER_ON_DONE	(M_dlSetDitheringCommand | 0x2)
#define S_dlSetDitheringCommand_TURN_DITHER_OFF_DONE	(M_dlSetDitheringCommand | 0x4)
#define S_dlSetDitheringCommand_SET_DITHER_COMPLETE	(M_dlSetDitheringCommand | 0x5)
#define S_dlDither_INVALID_BUFSIZE                         (M_dlDither | 0x0)
#define S_dlDither_INVALID_DITHER_PERIOD                   (M_dlDither | 0x1)
#define S_dlDither_INVALID_OFFSET                          (M_dlDither | 0x2)
#define S_dlDither_DITHER_MEASUREMENT_ERROR                (M_dlDither | 0x3)
#define S_dlDither_CANNOT_DO_DIAGS_WHILE_MEASURING         (M_dlDither | 0x4)
#define S_dlDither_NULL_CHANNEL_POINTER                    (M_dlDither | 0x5)
#define S_dlDither_NULL_BANK_POINTER                       (M_dlDither | 0x6)
#define S_dlDither_INVALID_SAMPLE_FREQ                     (M_dlDither | 0x7)
#define S_dlDither_NULL_GIZMO_POINTER                      (M_dlDither | 0x8)
#define S_dlDither_INVALID_NUMWAVES                        (M_dlDither | 0x9)
#define S_dlDither_INVALID_AMPL_FACTOR                     (M_dlDither | 0xa)
#define S_dlDither_INVALID_DITHER_SAMPLE_RATE              (M_dlDither | 0xb)
#define S_dlDither_ENTERING_DL_DITHER_INIT                 (M_dlDither | 0x1001)
#define S_dlDither_SEM_CREATED                             (M_dlDither | 0x1002)
#define S_dlDither_INITIAL_WAVEFORM_SET                    (M_dlDither | 0x1003)
#define S_dlDither_INITIAL_WAVEFORM_LOADED                 (M_dlDither | 0x1004)
#define S_dlDither_ENTERING_MEASURE_DITHER                 (M_dlDither | 0x1005)
#define S_dlDither_LOADED_WAVEFORM_NOW_WAIT                (M_dlDither | 0x1006)
#define S_dlDither_MEASURED_DITHER_WAVE_SUCCESSFULLY       (M_dlDither | 0x1007)
#define S_dlDither_LEAVING_MEASURE_DITHER                  (M_dlDither | 0x1008)
#define S_dlDither_ENTERING_CALIBRATE_DITHER               (M_dlDither | 0x1009)
#define S_dlDither_COMPLETED_FIRST_MEASURE_DITHER          (M_dlDither | 0x100a)
#define S_dlDither_COMPLETED_ANOTHER_MEASURE_DITHER        (M_dlDither | 0x100b)
#define S_dlDither_SUCCESSFULLY_COMPLETED_CALIBRATE_DITHER (M_dlDither | 0x100c)
#define S_dlDither_ENTERING_CHECK_DITHER                   (M_dlDither | 0x100d)
#define S_dlDither_SUCCESSFULLY_COMPLETED_CHECK_DITHER     (M_dlDither | 0x100e)
#define S_dlDither_DITHER_CALIBRATE_FAILED                 (M_dlDither | 0x100f)
#define S_relayer_INDEX_OUT_OF_RANGE                   (M_relayer | 0x1)
#define S_relayer_DATA_READ_INCOMPLETE                 (M_relayer | 0x2)
#define S_dlRelayer_UNKNOWN_DL_TYPE                    (M_dlRelayer | 0x1)
#define S_dlRelayer_CANT_ALLOCATE_STATUS_STREAM	       (M_dlRelayer | 0x0002)
#define S_dlRelayer_ENTERING_DL_DATA_RELAYER_INIT      (M_dlRelayer | 0x1001)
#define S_dlRelayer_DL_DATA_STREAM_INIT_SUCCESSFUL     (M_dlRelayer | 0x1002)
#define S_dlRelayer_DL_DATA_RELAYER_INIT_SUCCESSFUL    (M_dlRelayer | 0x1003)
#define S_dlRelayer_ENTERING_DL_STATUS_RELAYER_INIT    (M_dlRelayer | 0x1004)
#define S_dlRelayer_DL_STATUS_STREAM_INIT_SUCCESSFUL   (M_dlRelayer | 0x1005)
#define S_dlRelayer_DL_STATUS_RELAYER_INIT_SUCCESSFUL  (M_dlRelayer | 0x1006)
#define S_dlRelayer_IN_DL_DATA_RELAY                   (M_dlRelayer | 0x1007)
#define S_dlRelayer_IN_DL_STATUS_RELAY                 (M_dlRelayer | 0x1008)
#define S_tPidDouble_INIT_USING_POLES_AND_ZEROS_START  (M_tPidDouble | 0x1001)
#define S_tPidDouble_INIT_USING_POLES_AND_ZEROS_EXIT   (M_tPidDouble | 0x1002)
#define S_tPidDouble_INIT_USING_PIDS_START             (M_tPidDouble | 0x1003)
#define S_tPidDouble_INIT_USING_PIDS_EXIT              (M_tPidDouble | 0x1004)
#define S_tPidDouble_INIT_PID_RESET_START              (M_tPidDouble | 0x1005)
#define S_tPidDouble_INIT_PID_RESET_EXIT               (M_tPidDouble | 0x1006)
#define S_dlController_CONTROLLER_DATA_INITIALIZE_START     (M_dlController | 0x1001)
#define S_dlController_CONTROLLER_DATA_INITIALIZE_EXIT      (M_dlController | 0x1002)
#define S_dlController_DL_CONTROLLER_CONSTRUCTOR            (M_dlController | 0x1003)
#define S_dlController_DL_FAST_CTRLR_CONSTRUCTOR            (M_dlController | 0x1004)
#define S_dlController_DL_FAST_SLEW_CTRLR_CONSTRUCTOR       (M_dlController | 0x1005)
#define S_dlController_DL_MED_SLEW_CTRLR_CONSTRUCTOR        (M_dlController | 0x1006)
#define S_dlController_DL_SLOW_CTRLR_CONSTRUCTOR            (M_dlController | 0x1007)
#define S_dlController_DL_SLOW_SLEW_CTRLR_CONSTRUCTOR       (M_dlController | 0x1008)
#define S_dlController_DL_MED_SLEW_CTRLR_CALCULATE_START    (M_dlController | 0x1009)
#define S_dlController_DL_MED_SLEW_CTRLR_CALCULATE_EXIT     (M_dlController | 0x100A)
#define S_dlController_DL_SLOW_SLEW_CTRLR_CALCULATE_START   (M_dlController | 0x100B)
#define S_dlController_DL_SLOW_SLEW_CTRLR_CALCULATE_EXIT    (M_dlController | 0x100C)
#define S_dlController_GET_FAST_INPUT_SET                   (M_dlController | 0x100d)
#define S_dlController_GET_FAST_OUTPUT_SET                  (M_dlController | 0x100e)
#define S_dlController_GET_FAST_TARGET_SET                  (M_dlController | 0x100f)
#define S_dlController_UPDATE_COMPENSATOR_COEFFS_START      (M_dlController | 0x1010)
#define S_dlController_UPDATE_COMPENSATOR_COEFFS_EXIT       (M_dlController | 0x1011)
#define S_dlOffController_SLOW_OFF_CONTROLLER_CONSTRUCTOR      (M_dlOffController | 0x1001)
#define S_dlOffController_OFF_CONTROLLER_SET_CONSTRUCTOR_START (M_dlOffController | 0x1002)
#define S_dlOffController_OFF_CONTROLLER_SET_CONSTRUCTOR_EXIT  (M_dlOffController | 0x1003)
#define S_dlTrackController_FAST_TRK_LIN_CTRLR_CONSTRUCTOR     (M_dlTrackController | 0x1001)
#define S_dlTrackController_MED_TRK_LIN_CTRLR_CONSTRUCTOR      (M_dlTrackController | 0x1002)
#define S_dlTrackController_SLOW_TRK_SLEW_CTRLR_CONSTRUCTOR    (M_dlTrackController | 0x1003)
#define S_dlTrackController_SLOW_TRK_LIN_CTRLR_CONSTRUCTOR     (M_dlTrackController | 0x1004)
#define S_dlTrackController_TRK_CTRLR_SET_CONSTRUCTOR_START    (M_dlTrackController | 0x1005)
#define S_dlTrackController_TRK_CTRLR_SET_CONSTRUCTOR_EXIT     (M_dlTrackController | 0x1006)
#define S_dlFrontBackController_FB_SLOW_CTRLR_CONSTRUCTOR      (M_dlFrontBackController | 0x1001)
#define S_dlFrontBackController_FB_CTRLR_SET_CONSTRUCTOR_START (M_dlFrontBackController | 0x1002)
#define S_dlFrontBackController_FB_CTRLR_SET_CONSTRUCTOR_EXIT  (M_dlFrontBackController | 0x1003)
#define S_dlIoSet_STAB_IO_GROUP_CONSTRUCTOR              (M_dlIoSet | 0x1001)
#define S_dlIoSet_TRK_LIN_IO_GROUP_CONSTRUCTOR           (M_dlIoSet | 0x1002)
#define S_dlIoSet_COMPLETE_IO_SET_CONSTRUCTOR            (M_dlIoSet | 0x1003)
#define S_dlInputSet_FAST_INPUT_SET_CONSTRUCTOR          (M_dlInputSet | 0x1001)
#define S_dlInputSet_MED_TRK_LIN_INPUT_SET_CONSTRUCTOR   (M_dlInputSet | 0x1002)
#define S_dlInputSet_MED_STAB_INPUT_SET_CONSTRUCTOR      (M_dlInputSet | 0x1003)
#define S_dlInputSet_SLOW_INPUT_SET_CONSTRUCTOR          (M_dlInputSet | 0x1004)
#define S_dlInputSet_ENTERING_FAST_INPUT_SET_UPDATE      (M_dlInputSet | 0x1004)
#define S_dlOutputSet_FAST_OUTPUT_SET_CONSTRUCTOR    (M_dlOutputSet | 0x1001)
#define S_dlOutputSet_MED_OUTPUT_SET_CONSTRUCTOR     (M_dlOutputSet | 0x1002)
#define S_dlOutputSet_SLOW_OUTPUT_SET_CONSTRUCTOR    (M_dlOutputSet | 0x1003)
#define S_dlTargetSet_POS_TARG_SRC_CONSTRUCTOR          (M_dlTargetSet | 0x1001)
#define S_dlTargetSet_VEL_TARG_SRC_CONSTRUCTOR          (M_dlTargetSet | 0x1002)
#define S_dlTargetSet_FAST_TARG_SET_CONSTRUCTOR         (M_dlTargetSet | 0x1003)
#define S_dlTargetSet_MED_TRK_LIN_TARG_SET_CONSTRUCTOR  (M_dlTargetSet | 0x1004)
#define S_dlTargetSet_SLOW_TARG_SET_CONSTRUCTOR         (M_dlTargetSet | 0x1005)
#define S_dlTargetSet_MED_STAB_TARG_SET_CONSTRUCTOR     (M_dlTargetSet | 0x1006)
#define S_quicDlController_CONTROLLER_DATA_CONSTRUCTOR_START             (M_quicDlController | 0x1001)
#define S_quicDlController_CONTROLLER_DATA_CONSTRUCTOR_EXIT              (M_quicDlController | 0x1002)
#define S_quicDlController_CTRLR_DATA_SET_SERVO_PARAMS_ENTER             (M_quicDlController | 0x1003)
#define S_quicDlController_CTRLR_DATA_SET_SERVO_PARAMS_EXIT              (M_quicDlController | 0x1004)
#define S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_CONSTRUCTOR_START  (M_quicDlController | 0x1005)
#define S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_CONSTRUCTOR_EXIT   (M_quicDlController | 0x1006)
#define S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_SET_SERVO_PARAMS   (M_quicDlController | 0x1007)
#define S_quicDlFrontController_ENTERING_CONSTRUCTOR_BODY  (M_quicDlFrontController | 0x1001)
#define S_quicDlFrontController_LEAVING_CONSTRUCTOR        (M_quicDlFrontController | 0x1002)
#define S_quicDlTrackController_ENTERING_CONSTRUCTOR_BODY    (M_quicDlTrackController | 0x1001)
#define S_quicDlTrackController_LEAVING_CONSTRUCTOR_BODY     (M_quicDlTrackController | 0x1002)
#define S_dlGizmo_COULD_NOT_CREATE_DL_SERVO_OBJECT  (M_dlGizmo | 0x1)
#define S_dlGizmo_NUMBER_OF_CONTROLLERS_DOES_NOT_MATCH_NUMBER_OF_SERVO_MODES  (M_dlGizmo | 0x2)
#define S_dlGizmo_COULD_NOT_CREATE_DLLIMITS_OBJECT  (M_dlGizmo | 0x3)
#define  S_dlGizmo_CANT_ALLOCAT_COMMAND_PROCESSOR    (M_dlGizmo | 0x4)
#define S_dlGizmo_ENTERING_DL_GIZMO_CONSTRUCTOR       (M_dlGizmo | 0x1000)
#define S_dlGizmo_DATA_RELAYER_INITIALIZED            (M_dlGizmo | 0x1001)
#define S_dlGizmo_TARGET_GENERATOR_INITIALIZED        (M_dlGizmo | 0x1002)
#define S_dlGizmo_DL_DITHER_OBJECT_INITIALIZED        (M_dlGizmo | 0x1003)
#define S_dlGizmo_ENTERING_DL_GIZMO_INITIALIZE        (M_dlGizmo | 0x1004)
#define S_dlGizmo_DL_LIMITS_CONSTRUCTED               (M_dlGizmo | 0x1005)
#define S_dlGizmo_CONTROLLER_SET_ARRAY_INITIALIZED    (M_dlGizmo | 0x1006)
#define S_dlGizmo_DL_SERVO_INITIALIZED                (M_dlGizmo | 0x1007)
#define S_dlGizmo_DL_STATUS_INITIALIZED               (M_dlGizmo | 0x1008)
#define S_dlGizmo_DL_STATUS_RELAYER_INITIALIZED       (M_dlGizmo | 0x1009)
#define S_dlGizmo_DL_COMMAND_PROCESSOR_INITIALIZED    (M_dlGizmo | 0x100A)
#define S_dlGizmo_INITIALIZE_COMPLETE                 (M_dlGizmo | 0x100B)
#define S_dlGizmo_ENTERING_DL_GIZMO_DESTRUCTOR        (M_dlGizmo | 0x100C)
#define S_dlGizmo_DL_LIMITS_DESTROYED                 (M_dlGizmo | 0x100D)
#define S_dlGizmo_EXITING_DL_GIZMO_DESTRUCTOR         (M_dlGizmo | 0x100E)
#define S_dlGizmo_ENTERING_SET_SERVO_MODE             (M_dlGizmo | 0x100F)
#define S_dlGizmo_ENTERING_SET_LASER_MODULATION       (M_dlGizmo | 0x1010)
#define S_dlGizmo_ENTERING_SET_SERVO_PARAMS           (M_dlGizmo | 0x1011)
#define S_dlGizmo_ENTERING_GET_LASER_MODULATION       (M_dlGizmo | 0x1012)
#define S_dlGizmo_ENTERING_GET_SERVO_PARAMS           (M_dlGizmo | 0x1013)
#define S_dlGizmo_ENTERING_GET_CONTROLLER_DATA        (M_dlGizmo | 0x1014)
#define S_dlGizmo_NULL_COMPLETE_CTRL_SET_POINTER      (M_dlGizmo | 0x1015)
#define S_dlGizmo_ENTERING_GET_SERVO_MODE             (M_dlGizmo | 0x1016)
#define S_dlTargGen_CANT_ALLOCATE_TARGETS_STREAMS (M_dlTargGen | 0x0001)
#define S_dlTargGen_ENTERING_DL_TARGGEN_INIT     (M_dlTargGen | 0x1001)
#define S_dlTargGen_ALL_TARGET_SOURCES_INITED    (M_dlTargGen | 0x1002)
#define S_dlTargGen_LEAVING_DL_TARGGEN_INIT      (M_dlTargGen | 0x1003)
#define S_dlTargGen_COMPUTE_TOTAL_TARGET_TASK    (M_dlTargGen | 0x1004)
#define S_emgizmo_COULD_NOT_CREATE_COMMAND_ENGINE      (M_emgizmo | 0x01)
#define S_emgizmo_UNRECOGNIZED_COMMAND                 (M_emgizmo | 0x02)
#define S_emgizmo_UNABLE_TO_SEND_STATUS                (M_emgizmo | 0x03)
#define S_emgizmo_GIZMO_INFO_NOT_EM                    (M_emgizmo | 0x04)
#define S_emgizmo_INVALID_NUMBER_OF_SERVO_MODES        (M_emgizmo | 0x05)
#define S_emgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS   (M_emgizmo | 0x06)
#define S_emgizmo_EXTERNAL_METROLOGY_ALIVE  (M_emgizmo | 0x2001)
#define S_emgizmo_SETTING_SERVO_PARAMETERS  (M_emgizmo | 0x2002)
#define S_emgizmo_SERVO_PARAMETERS_SET      (M_emgizmo | 0x2003)
#define S_em_OFF_START                      (M_emgizmo | 0x2004)
#define S_em_OFF_COMPLETE                   (M_emgizmo | 0x2005)
#define S_em_TRACK_START                    (M_emgizmo | 0x2006)
#define S_em_TRACK_IN_PROGRESS              (M_emgizmo | 0x2007)
#define S_em_TRACK_ABORTED                  (M_emgizmo | 0x2008)
#define S_errorStream_SENDER_CONSTRUCTOR        (M_errorStream | 0x20001)
#define S_errorStream_SENDER_DESTRUCTOR         (M_errorStream | 0x20002)
#define S_errorStream_PUT_EC_START              (M_errorStream | 0x20003)
#define S_errorStream_PUT_EC_COMPLETE           (M_errorStream | 0x20004)
#define S_errorStream_PUT_ECT_START             (M_errorStream | 0x20005)
#define S_errorStream_PUT_ECT_COMPLETE          (M_errorStream | 0x20006)
#define S_errorStream_PUT_NO_WAIT_ECT_START     (M_errorStream | 0x20007)
#define S_errorStream_PUT_NO_WAIT_ECT_COMPLETE  (M_errorStream | 0x20008)
#define S_errorStream_RECEIVER_CONSTRUCTOR      (M_errorStream | 0x20009)
#define S_errorStream_RECEIVER_DESTRUCTOR       (M_errorStream | 0x2000a)
#define S_extInt_ALREADY_RESTART    (M_extInt | 0x1001)
#define S_extInt_ALREADY_SHUTDOWN   (M_extInt | 0x1002)
#define S_ft_UNABLE_TO_SEND_STATUS              (M_ft | 0x01)
#define S_ft_UNRECOGNIZED_COMMAND               (M_ft | 0x02)
#define S_ft_COULD_NOT_CREATE_COMMAND_ENGINE    (M_ft | 0x03)
#define S_ft_GIZMO_INFO_NOT_FT                  (M_ft | 0x04)
#define S_ft_INVALID_NUMBER_OF_SERVO_MODES      (M_ft | 0x05)
#define S_ft_INVALID_NUMBER_OF_SERVO_PARTITIONS (M_ft | 0x06)
#define S_ft_ARRAY_TOO_SMALL                    (M_ft | 0x07)
#define S_ft_INVALID_TRACK_CONTROLLER_MODE      (M_ft | 0x08)
#define S_ft_TOO_FEW_PHOTONS_TO_CONTINUE_SEARCH (M_ft | 0x09)
#define S_ft_TOO_FEW_PHOTONS_FOR_SEARCH         (M_ft | 0x0a)
#define S_ft_SEARCH_TIME_OUT                    (M_ft | 0x0b)
#define S_ft_INVALID_TARGET_DIRECTION           (M_ft | 0x0c)
#define S_ft_UNABLE_TO_SEND_IMAGE               (M_ft | 0x0d)
#define S_ft_MISSING_APD_DATA                   (M_ft | 0x0e)
#define S_ft_UNPROCESSED_SWEEP                  (M_ft | 0x0f)
#define S_ft_OVERPROCESSED_SWEEP                (M_ft | 0x10)
#define S_ft_FRINGE_TRACKER_ALIVE               (M_ft | 0x2001)
#define S_ft_OFF                                (M_ft | 0x2002)
#define S_ft_TRACK_START                        (M_ft | 0x2003)
#define S_ft_TRACK_IN_PROGRESS                  (M_ft | 0x2004)
#define S_ft_TRACK_ABORTED                      (M_ft | 0x2005)
#define S_ft_GET_IMAGE                          (M_ft | 0x2006)
#define S_ft_SERVO_PARAMETERS_SET               (M_ft | 0x2007)
#define S_ft_REGION_OF_INTEREST_SET             (M_ft | 0x2008)
#define S_ft_WOBBLE_PARAMETERS_SET              (M_ft | 0x2009)
#define S_ft_SEARCH_PARAMETERS_SET              (M_ft | 0x200a)
#define S_ft_THRESHOLD_PARAMETERS_SET           (M_ft | 0x200b)
#define S_ft_CONTROLLER_PARAMETERS_SET          (M_ft | 0x200c)
#define S_gizmo_SHUTDOWN_ERROR    (M_gizmo | 0x1)
#define S_gizmo_SHUTTING_DOWN_GIZMO     (M_gizmo | 0x1001)
#define S_gizmo_ALREADY_INITIALIZED     (M_gizmo | 0x1002)
#define S_gizmo_ALREADY_SHUTDOWN        (M_gizmo | 0x1003)
#define S_gizmo_INIT_START            (M_gizmo | 0x2001)
#define S_gizmo_INIT_COMPLETE         (M_gizmo | 0x2002)
#define S_gizmo_DESTRUCT_START        (M_gizmo | 0x2003)
#define S_gizmo_DESTRUCT_COMPLETE     (M_gizmo | 0x2004)
#define S_gizmo_RESTART_START         (M_gizmo | 0x2005)
#define S_gizmo_RESTART_COMPLETE      (M_gizmo | 0x2006)
#define S_gizmo_SHUTDOWN_START        (M_gizmo | 0x2007)
#define S_gizmo_SHUTDOWN_COMPLETE     (M_gizmo | 0x2008)
#define S_hw_E_INVALID_BOARD_NUMBER                        (M_hw | 0x1)
#define S_hw_E_ERROR_DURING_HARD_INIT                      (M_hw | 0x2)
#define S_hw_E_ERROR_DURING_SOFT_INIT                      (M_hw | 0x3)
#define S_hw_E_VIRTUAL_FUNCTION_HARD_INIT_RAN              (M_hw | 0x4)
#define S_hw_E_VIRTUAL_FUNCTION_SOFT_INIT_RAN              (M_hw | 0x5)
#define S_hw_E_INVALID_BOARD_TYPE                          (M_hw | 0x6)
#define S_hw_RETURNING_NULL_BOARD_POINTER                  (M_hw | 0x7)
#define S_hw_GET_LOCAL_ADDRESS_ATTEMPTED_ON_NULL_VALUE     (M_hw | 0x8)
#define S_hw_LOCAL_ADDRESS_SET_TO_ZERO                     (M_hw | 0x9)
#define S_hw_CALLING_HARDINIT                              (M_hw | 0xa)
#define S_hw_BACK_FROM_HARDINIT                            (M_hw | 0xb)
#define S_hw_CALLING_SOFTINIT                              (M_hw | 0xc)
#define S_hw_BACK_FROM_SOFTINIT                            (M_hw | 0xd)
#define S_hw_RETURNING_NULL_CHANNEL_POINTER                (M_hw | 0xe)
#define S_hw_BUS_LOCK_TIMEOUT                              (M_hw | 0xf)
#define S_hw_ENTERING_HARDWARE_CONSTRUCTOR                 (M_hw | 0x1000)
#define S_hw_DONE_CONSTRUCTING_HARDWARE                    (M_hw | 0x1001)
#define S_hw_ENTERING_HARDWARE_DESTRUCTOR                  (M_hw | 0x1002)
#define S_hw_DONE_DESTRUCTING_HARDWARE                     (M_hw | 0x1003)
#define S_hw_ENTERING_HARDWARE_HARDINIT                    (M_hw | 0x1004)
#define S_hw_HARDWARE_INITIALIZED_HARDLY                   (M_hw | 0x1005)
#define S_hw_ENTERING_HARDWARE_SOFTINIT                    (M_hw | 0x1006)
#define S_hw_HARDWARE_INITIALIZED_SOFTLY                   (M_hw | 0x1007)
#define S_board_BOARD_ALREADY_INITIALIZED                  (M_board | 0x1)
#define S_board_INIT_ATTEMPTED_WITH_NULL_ADDRESS           (M_board | 0x2)
#define S_clock_E_CLOCK_ALREADY_INITIALIZED                (M_clock | 0x1)
#define S_clock_E_BOARD_NOT_INITIALIZED                    (M_clock | 0x2)
#define S_clock_E_BOARD_HAS_NO_CLOCK                       (M_clock | 0x3)
#define S_interrupt_INTERRUPT_ALREADY_INITIALIZED        (M_interrupt | 0x1)
#define S_interrupt_BOARD_HAS_NO_INTERRUPT               (M_interrupt | 0x2)
#define S_interrupt_BOARD_NOT_INITIALIZED                (M_interrupt | 0x3)
#define S_interrupt_W_INVALID_RATE                       (M_interrupt | 0x4)
#define S_interrupt_INT_NOT_INITIALIZED                  (M_interrupt | 0x5)
#define S_interrupt_NULL_FUNCTION_POINTER                (M_interrupt | 0x6)
#define S_interrupt_INT_ALREADY_CONNECTED                (M_interrupt | 0x7)
#define S_interrupt_INT_ALREADY_ENABLED                  (M_interrupt | 0x8)
#define S_interrupt_INT_NOT_CONNECTED                    (M_interrupt | 0x9)
#define S_interrupt_INT_RATE_NOT_SET                     (M_interrupt | 0xa)
#define S_interrupt_INT_NOT_ENABLED                      (M_interrupt | 0xb)
#define S_interrupt_INVALID_INTERRUPT_PRIORITY           (M_interrupt | 0xc)
#define S_interrupt_INVALID_INTERRUPT_VECTOR             (M_interrupt | 0xd)
#define S_interrupt_RATE_SET_CALLED_USING_BASE_CLASS     (M_interrupt | 0xe)
#define S_tOutputChannel_CHANNEL_NOT_INITIALIZED           (M_channel | 0x1)
#define S_inputChannel_INVALID_CALL_TO_RESET               (M_channel | 0x2)
#define S_channel_INVALID_CALL_TO_RESET                    (M_channel | 0x3)
#define S_counterChannel_INVALID_CALL_TO_RESET             (M_channel | 0x4)
#define S_tImageChannel_CHANNEL_NOT_INITIALIZED            (M_imageChannel | 0x1)
#define S_tFullImageChannel_CHANNEL_NOT_INITIALIZED        (M_imageChannel | 0x2)
#define S_tSubImageChannel_CHANNEL_NOT_INITIALIZED         (M_imageChannel | 0x3)
#define S_tSubImageChannel_CHANNEL_REGION_OUT_OF_RANGE     (M_imageChannel | 0x4)
#define S_tSubImageChannel_INVALID_FULL_IMAGE_CHANNEL      (M_imageChannel | 0x5)
#define S_device_DEVICE_ALREADY_INITIALIZED                (M_device | 0x1)
#define S_actuator_ACTUATOR_ALREADY_INITIALIZED            (M_actuator | 0x1)
#define S_actuator_ACTUATOR_NOT_INITIALIZED                (M_actuator | 0x2)
#define S_sensor_SENSOR_ALREADY_INITIALIZED                (M_sensor | 0x1)
#define S_sensor_SENSOR_NOT_INITIALIZED                    (M_sensor | 0x2)
#define S_sensor_CHANNEL_OUT_OF_RANGE                      (M_sensor | 0x3)
#define S_sensor_NULL_POINTER                              (M_sensor | 0x4)
#define S_dt1401_BOARD_ALREADY_INITIALIZED                 (M_dt1401 | 0x1)
#define S_dt1401_INVALID_DA_CHANNEL                        (M_dt1401 | 0x2)
#define S_pc03v_BOARD_ALREADY_INITIALIZED                  (M_pc03v | 0x1)
#define S_pc03v_E_BOARD_NOT_INITIALIZED                    (M_pc03v | 0x2)
#define S_pc03v_E_INTERRUPT_ALREADY_INITIALIZED            (M_pc03v | 0x3)
#define S_pc03v_E_BOARD_HAS_NO_INTERRUPT                   (M_pc03v | 0x4)
#define S_pc03v_E_NULL_FUNCTION_POINTER                    (M_pc03v | 0x5)
#define S_pc03v_E_INVALID_INT_SOURCE                       (M_pc03v | 0x6)
#define S_pc03v_E_INVALID_INTERRUPT_NUMBER                 (M_pc03v | 0x7)
#define S_pc03v_CREATE_CHANNEL_ATTEMPTED                   (M_pc03v | 0x8)
#define S_pc03v_ENTERING_CONSTRUCTOR                       (M_pc03v | 0x1001)
#define S_pc03v_DONE_CONSTRUCTING                          (M_pc03v | 0x1002)
#define S_pc03v_ENTERING_SOFTINIT                          (M_pc03v | 0x1003)
#define S_pc03v_INITIALIZED_SOFTLY                         (M_pc03v | 0x1004)
#define S_pc03v_ENTERING_HARDINIT                          (M_pc03v | 0x1005)
#define S_pc03v_INITIALIZED_HARDLY                         (M_pc03v | 0x1006)
#define S_laser_INVALID_COUNTER                  (M_laser | 0x01)
#define S_laser_NO_REFERENCE                     (M_laser | 0x02)
#define S_laser_NO_64_MHZ                        (M_laser | 0x03)
#define S_laser_NO_16_MHZ                        (M_laser | 0x04)
#define S_laser_NO_2_MHZ                         (M_laser | 0x05)
#define S_laser_NO_EXTERNAL_CLOCK                (M_laser | 0x06)
#define S_laser_UNKNOWN_CLOCK_ERROR              (M_laser | 0x07)
#define S_laser_UNKNOWN_NOT_PRESENT              (M_laser | 0x08)
#define S_laser_INIT_INVALID_ARGUMENT            (M_laser | 0x09)
#define S_laser_INVALID_SYNC_MODE                (M_laser | 0x0a)
#define S_laser_COUNTER_FAILED_POS_SLEW_TEST     (M_laser | 0x0b)
#define S_laser_COUNTER_FAILED_RET_TO_ZERO_TEST  (M_laser | 0x0c)
#define S_laser_COUNTER_FAILED_NEG_SLEW_TEST     (M_laser | 0x0d)
#define S_laser_COUNTER_FAILED_CLEAR_TEST        (M_laser | 0x0e)
#define S_laser_COUNTER_FAILED_FRACTION_TEST     (M_laser | 0x0f)
#define S_laser_INVALID_BOOL_VALUE               (M_laser | 0x10)
#define S_laser_BOARD_NOT_INITIALIZED            (M_laser | 0x11)
#define S_laser_NULL_POINTER_ARGUMENT            (M_laser | 0x12)
#define S_laser_PLL_OUT_OF_LOCK                  (M_laser | 0x13)
#define S_laser_INIT_INVALID_NUM_COUNTERS        (M_laser | 0x14)
#define S_laser_ERROR_IN_CLEAR_OR_LOAD           (M_laser | 0x15)
#define S_laser_RETURNING_NULL_CHANNEL_POINTER   (M_laser | 0x16)
#define S_laser_REF_CHANNEL_POINTER_SET_TO_NULL  (M_laser | 0x17)
#define S_laser_ENTERING_CONSTRUCTOR             (M_laser | 0x1001)
#define S_laser_DONE_CONSTRUCTING                (M_laser | 0x1002)
#define S_laser_ENTERING_SOFTINIT                (M_laser | 0x1003)
#define S_laser_INITIALIZED_SOFTLY               (M_laser | 0x1004)
#define S_laser_ENTERING_HARDTINIT               (M_laser | 0x1005)
#define S_laser_INITIALIZED_HARDLY               (M_laser | 0x1006)
#define S_laser_CHECKING_CLOCKS                  (M_laser | 0x1007)
#define S_laser_ENTERING_CHANNEL_INITIALIZE      (M_laser | 0x1008)
#define S_laser_CHANNEL_INITIALIZED              (M_laser | 0x1009)
#define S_pztMotor_INIT_INVALID_ARGUMENT                   (M_pztMotor | 0x1)
#define S_pztMotor_BOARD_NOT_INITIALIZED                   (M_pztMotor | 0x2)
#define S_pztMotor_INVALID_PZT                             (M_pztMotor | 0x3)
#define S_pztMotor_INVALID_MOTOR                           (M_pztMotor | 0x4)
#define S_pztMotor_INVALID_VELOCITY                        (M_pztMotor | 0x5)
#define S_pztMotor_INVALID_PRESCALE                        (M_pztMotor | 0x6)
#define S_pztMotor_INVALID_PZT_POSITION                    (M_pztMotor | 0x7)
#define S_pztMotor_INIT_PZT_CONFIGURATION_MISMATCH         (M_pztMotor | 0x8)
#define S_pztMotor_INIT_MOTOR_CONFIGURATION_MISMATCH       (M_pztMotor | 0x9)
#define S_pztMotor_E_INVALID_NUMBER_OF_PZTS                (M_pztMotor | 0x0a)
#define S_pztMotor_E_INVALID_NUMBER_OF_MOTORS              (M_pztMotor | 0x0b)
#define S_pztMotor_INVALID_LIMIT_TYPE                      (M_pztMotor | 0x0c)
#define S_pztMotor_CHANNEL_NOT_INITIALIZED                 (M_pztMotor | 0x0d)
#define S_pztMotor_E_INVALID_NUMBER_OF_LIMITS              (M_pztMotor | 0x0e)
#define S_pztMotor_CHANNEL_NUM_OUT_OF_RANGE                (M_pztMotor | 0x0f)
#define S_pztMotor_PZT_CHANNEL_NUM_OUT_OF_RANGE            (M_pztMotor | 0x10)
#define S_pztMotor_MOTOR_CHANNEL_NUM_OUT_OF_RANGE          (M_pztMotor | 0x11)
#define S_pztMotor_PZT_READBACK_CHANNEL_NUM_OUT_OF_RANGE   (M_pztMotor | 0x12)
#define S_pztMotor_MOTOR_READBACK_CHANNEL_NUM_OUT_OF_RANGE (M_pztMotor | 0x13)
#define S_pztMotor_LIMIT_CHANNEL_NUM_OUT_OF_RANGE          (M_pztMotor | 0x14)
#define S_pztMotor_INVALID_CHANNEL_NUM                     (M_pztMotor | 0x15)
#define S_pztMotor_CALLING_SOFT_INIT                       (M_pztMotor | 0x16)
#define S_pztMotor_ENTERING_CONSTRUCTOR              (M_pztMotor | 0x1000)
#define S_pztMotor_DONE_CONSTRUCTING                 (M_pztMotor | 0x1001)
#define S_pztMotor_ENTERING_SOFTINIT                 (M_pztMotor | 0x1002)
#define S_pztMotor_INITIALIZING_DA_CHANNEL_ARRAY     (M_pztMotor | 0x1003)
#define S_pztMotor_INITIALIZING_MOTOR_CHANNEL_ARRAY  (M_pztMotor | 0x1004)
#define S_pztMotor_INITIALIZING_LIMIT_CHANNEL_ARRAY  (M_pztMotor | 0x1005)
#define S_pztMotor_INITIALIZED_SOFTLY                (M_pztMotor | 0x1006)
#define S_pztMotor_ENTERING_HARDINIT                 (M_pztMotor | 0x1007)
#define S_pztMotor_INITIALIZED_HARDLY                (M_pztMotor | 0x1008)
#define S_pztMotor_ENTERING_RAMP_CHANNEL_CONSTRUCTOR (M_pztMotor | 0x1009)
#define S_pztMotor_DONE_CONSTRUCTING_RAMP_CHANNEL    (M_pztMotor | 0x100a)
#define S_pztMotor_ENTERING_RAMP_CHANNEL_INITIALIZE  (M_pztMotor | 0x100b)
#define S_pztMotor_CALLING_DA_CHANNEL_INITIALIZE     (M_pztMotor | 0x100c)
#define S_pztMotor_DONE_INITIALIZING_RAMP_CHANNEL    (M_pztMotor | 0x100d)
#define S_pztMotor_ENTERING_DA_CHANNEL_CONSTRUCTOR   (M_pztMotor | 0x100e)
#define S_pztMotor_DONE_CONSTRUCTING_DA_CHANNEL      (M_pztMotor | 0x100f)
#define S_pztMotor_ENTERING_DA_CHANNEL_INITIALIZE    (M_pztMotor | 0x1010)
#define S_pztMotor_DONE_INITIALIZING_DA_CHANNEL      (M_pztMotor | 0x1011)
#define S_pztMotor_ENTERING_MOTOR_READBACK_CHANNEL_CONSTRUCTOR (M_pztMotor | 0x1012)
#define S_pztMotor_DONE_CONSTRUCTING_MOTOR_READBACK_CHANNEL    (M_pztMotor | 0x1013)
#define S_pztMotor_ENTERING_MOTOR_READBACK_CHANNEL_INITIALIZE  (M_pztMotor | 0x1014)
#define S_pztMotor_DONE_INITIALIZING_MOTOR_READBACK_CHANNEL    (M_pztMotor | 0x1015)
#define S_pztMotor_ENTERING_MOTOR_CHANNEL_CONSTRUCTOR (M_pztMotor | 0x1016)
#define S_pztMotor_DONE_CONSTRUCTING_MOTOR_CHANNEL    (M_pztMotor | 0x1017)
#define S_pztMotor_ENTERING_MOTOR_CHANNEL_INITIALIZE  (M_pztMotor | 0x1018)
#define S_pztMotor_DONE_INITIALIZING_MOTOR_CHANNEL    (M_pztMotor | 0x1019)
#define S_pztMotor_ENTERING_DI_CHANNEL_CONSTRUCTOR    (M_pztMotor | 0x101a)
#define S_pztMotor_DONE_CONSTRUCTING_DI_CHANNEL       (M_pztMotor | 0x101b)
#define S_pztMotor_ENTERING_DI_CHANNEL_INITIALIZE     (M_pztMotor | 0x101c)
#define S_pztMotor_DONE_INITIALIZING_DI_CHANNEL       (M_pztMotor | 0x101d)
#define S_mpv955_CHANNEL_BANK_NOT_INITIALIZED    (M_mpv955 | 0x1)
#define S_mpv955_INVALID_TRIGGER_SELECT_VALUE    (M_mpv955 | 0x2)
#define S_mpv955_INVALID_TRIGGER_TYPE_VALUE      (M_mpv955 | 0x3)
#define S_mpv955_INVALID_SCAN_MODE_VALUE         (M_mpv955 | 0x4)
#define S_mpv955_INVALID_TIMEOUT_VALUE           (M_mpv955 | 0x5)
#define S_mpv955_INVALID_NUMBER_OF_CHANNELS      (M_mpv955 | 0x6)
#define S_mpv955_INVALID_WAVEFORM_SIZE           (M_mpv955 | 0x7)
#define S_mpv955_RETURNING_NULL_CHANNEL_POINTER  (M_mpv955 | 0x8)
#define S_mpv955_ZERO_OR_NEGATIVE_PERIOD         (M_mpv955 | 0x9)
#define S_mpv955_PERIOD_ADJUSTED                 (M_mpv955 | 0xa)
#define S_mpv955_ENTERING_CONSTRUCTOR            (M_mpv955 | 0x1000)
#define S_mpv955_DONE_CONSTRUCTING               (M_mpv955 | 0x1001)
#define S_mpv955_ENTERING_SOFTINIT               (M_mpv955 | 0x1002)
#define S_mpv955_INITIALIZED_SOFTLY              (M_mpv955 | 0x1003)
#define S_mpv955_ENTERING_HARDINIT               (M_mpv955 | 0x1004)
#define S_mpv955_INITIALIZED_HARDLY              (M_mpv955 | 0x1005)
#define S_mpv955_ENTERING_CHANNELBANK_INITIALIZE (M_mpv955 | 0x1006)
#define S_mpv955_CHANNELBANK_INITIALIZED         (M_mpv955 | 0x1007)
#define S_mpv955_ENTERING_CHANNEL_INITIALIZE     (M_mpv955 | 0x1008)
#define S_mpv955_CHANNEL_INITIALIZED             (M_mpv955 | 0x1009)
#define S_mpv955_SETTING_SAMPLE_PERIOD           (M_mpv955 | 0x100a)
#define S_mpv955_SAMPLE_PERIOD_SET               (M_mpv955 | 0x100b)
#define S_mpv955_START_STOP_ADDRESSES_SET        (M_mpv955 | 0x100c)
#define S_mpv906_CHANNEL_BANK_NOT_INITIALIZED     (M_mpv906 | 0x1)
#define S_mpv906_CHANNEL_NUMBER_OUT_OF_RANGE      (M_mpv906 | 0x2)
#define S_mpv906_INVALID_GAIN                     (M_mpv906 | 0x3)
#define S_mpv906_INVALID_START_CHANNEL_VALUE      (M_mpv906 | 0x4)
#define S_mpv906_INVALID_SCAN_MODE                (M_mpv906 | 0x5)
#define S_mpv906_INVALID_TRIGGER_SELECT_VALUE     (M_mpv906 | 0x6)
#define S_mpv906_CANNOT_STOP_MPV906_SCAN          (M_mpv906 | 0x7)
#define S_mpv906_INVALID_NUMBER_OF_CHANNELS       (M_mpv906 | 0x8)
#define S_mpv906_ENTERING_CONSTRUCTOR             (M_mpv906 | 0x1001)
#define S_mpv906_DONE_CONSTRUCTING                (M_mpv906 | 0x1002)
#define S_mpv906_ENTERING_SOFTINIT                (M_mpv906 | 0x1003)
#define S_mpv906_INITIALIZED_SOFTLY               (M_mpv906 | 0x1004)
#define S_mpv906_ENTERING_HARDINIT                (M_mpv906 | 0x1005)
#define S_mpv906_INITIALZED_HARDLY                (M_mpv906 | 0x1006)
#define S_mpv906_ENTERING_CHANNELBANK_INITIALIZE  (M_mpv906 | 0x1007)
#define S_mpv906_DONE_INITIALIZING_CHANNELBANK    (M_mpv906 | 0x1008)
#define S_mpv906_ENTERING_CHANNEL_INITIALIZE      (M_mpv906 | 0x1009)
#define S_mpv906_DONE_INITIALIZING_CHANNEL        (M_mpv906 | 0x100a)
#define S_dvme626_RETURNING_NULL_CHANNEL_POINTER  (M_dvme626 | 0x1)
#define S_dvme626_ENTERING_CONSTRUCTOR            (M_dvme626 | 0x1000)
#define S_dvme626_FINISHED_CONSTRUCTING           (M_dvme626 | 0x1001)
#define S_dvme626_ENTERING_SOFTINIT               (M_dvme626 | 0x1002)
#define S_dvme626_INITIALIZED_SOFTLY              (M_dvme626 | 0x1003)
#define S_dvme626_ENTERING_HARDINIT               (M_dvme626 | 0x1004)
#define S_dvme626_INITIALIZED_HARDLY              (M_dvme626 | 0x1005)
#define S_dvme626_ENTERING_CHANNEL_INITIALIZE     (M_dvme626 | 0x1006)
#define S_dvme626_CHANNEL_INITIALIZED             (M_dvme626 | 0x1007)
#define S_dvme626_INVALID_NUMBER_OF_CHANNELS      (M_dvme626 | 0x1008)
#define S_mm6216_MEMORY_SIZE_NOT_4_BYTE_ALIGNED   (M_mm6216 | 0x1)
#define S_mm6216_ENTERING_CONSTRUCTOR             (M_mm6216 | 0x1001)
#define S_mm6216_DONE_CONSTRUCING                 (M_mm6216 | 0x1002)
#define S_mm6216_ENTERING_SOFTINIT                (M_mm6216 | 0x1003)
#define S_mm6216_INITIALIZED_SOFTLY               (M_mm6216 | 0x1004)
#define S_mm6216_ENTERING_HARDINIT                (M_mm6216 | 0x1005)
#define S_mm6216_INITIALZED_HARDLY                (M_mm6216 | 0x1006)
#define S_tVip640aFullImageChannel_CHANNEL_ALREADY_INITIALIZED   (M_vip640a | 0x1)
#define S_tVip640aFullImageChannel_CHANNEL_NOT_INITIALIZED       (M_vip640a | 0x2)
#define S_tVip640aFullImageChannel_CHANNEL_CAPTURE_NOT_STARTED   (M_vip640a | 0x3)
#define S_tVip640aFullImageChannel_CHANNEL_CAPTURE_TIMEOUT       (M_vip640a | 0x4)
#define S_tVip640aBoard_BOARD_NOT_INITIALIZED                    (M_vip640a | 0x5)
#define S_tVip640aBoard_RETURNING_NULL_CHANNEL_POINTER           (M_vip640a | 0x6)
#define S_tImage_BUFFER_SIZE_DOES_NOT_MATCH                      (M_tImage | 0x1)
#define S_tImage_IMAGE_NOT_YET_LOADED                            (M_tImage | 0x2)
#define S_tImage_IMAGE_MEMORY_ALLOCATION_FAILED                  (M_tImage | 0x3)
#define S_tImage_INVALID_DIMENSIONS                              (M_tImage | 0x4)
#define S_tImage_INVALID_POINT                                   (M_tImage | 0x5)
#define S_tImage_DONE_CONSTRUCTING                               (M_tImage | 0x1001)
#define S_tImage_DONE_DESTRUCTING                                (M_tImage | 0x1002)
#define S_tImage_IMAGE_LOADED                                    (M_tImage | 0x1003)
#define S_tImage_RESIZING_IMAGE                                  (M_tImage | 0x1004)
#define S_tImage_IMAGE_COPIED                                    (M_tImage | 0x1005)
#define S_tImage_ENSURING_IMAGE_BUFFER_EXIST                     (M_tImage | 0x1006)
#define S_ipQuad_INVALID_NUMBER_OF_CHANNELS                      (M_ipQuad | 0x1)
#define S_ipQuad_RETURNING_NULL_CHANNEL_POINTER                  (M_ipQuad | 0x2)
#define S_ipQuad_INVALID_BOARD_NUM                               (M_ipQuad | 0x3)
#define S_ipQuad_ENTERING_CONSTRUCTOR                            (M_ipQuad | 0x1001)
#define S_ipQuad_FINISHED_CONSTRUCTING                           (M_ipQuad | 0x1002)
#define S_ipQuad_ENTERING_SOFTINIT                               (M_ipQuad | 0x1003)
#define S_ipQuad_INITIALIZED_SOFTLY                              (M_ipQuad | 0x1004)
#define S_ipQuad_ENTERING_HARDINIT                               (M_ipQuad | 0x1005)
#define S_ipQuad_INITIALIZED_HARDLY                              (M_ipQuad | 0x1006)
#define S_ipQuad_ENTERING_CHANNEL_INITIALIZE                     (M_ipQuad | 0x1007)
#define S_ipQuad_CHANNEL_INITIALIZED                             (M_ipQuad | 0x1008)
#define S_ip16Dac_INVALID_NUMBER_OF_CHANNELS                     (M_ip16Dac | 0x1)
#define S_ip16Dac_RETURNING_NULL_CHANNEL_POINTER                 (M_ip16Dac | 0x2)
#define S_ip16Dac_INVALID_BOARD_NUM                              (M_ip16Dac | 0x3)
#define S_ip16Dac_INVALID_BOARD_ID                               (M_ip16Dac | 0x4)
#define S_ip16Dac_ENTERING_CONSTRUCTOR                           (M_ip16Dac | 0x1000)
#define S_ip16Dac_FINISHED_CONSTRUCTING                          (M_ip16Dac | 0x1001)
#define S_ip16Dac_ENTERING_SOFTINIT                              (M_ip16Dac | 0x1002)
#define S_ip16Dac_INITIALIZED_SOFTLY                             (M_ip16Dac | 0x1003)
#define S_ip16Dac_ENTERING_HARDINIT                              (M_ip16Dac | 0x1004)
#define S_ip16Dac_INITIALIZED_HARDLY                             (M_ip16Dac | 0x1005)
#define S_ip16Dac_ENTERING_CHANNEL_INITIALIZE                    (M_ip16Dac | 0x1006)
#define S_ip16Dac_CHANNEL_INITIALIZED                            (M_ip16Dac | 0x1007)
#define S_ip16Dac_ENTERING_VERIFIER                              (M_ip16Dac | 0x1008)
#define S_ip16Dac_FINISHED_VERIFYING                             (M_ip16Dac | 0x1009)
#define S_ip16Dac_BOARD_ID                                       (M_ip16Dac | 0x1100)
#define S_tim_BOARD_ALREADY_INITIALIZED                  (M_tim | 0x0001)
#define S_tim_CHANNEL_NOT_INITIALIZED                    (M_tim | 0x0002)
#define S_tim_RETURNING_NULL_CHANNEL_POINTER             (M_tim | 0x0003)
#define S_tim_CREATE_CHANNEL_ATTEMPTED                   (M_tim | 0x0008)
#define S_tim_TIME_IS_JUMPING_BY_MORE_THAN_ONE_SEC       (M_tim | 0x0009)
#define S_tim_NULL_BOARD_POINTER_PASSED_TO_INITIALIZE    (M_tim | 0x000a)
#define S_tim_ENTERING_CONSTRUCTOR                       (M_tim | 0x1001)
#define S_tim_DONE_CONSTRUCTING                          (M_tim | 0x1002)
#define S_tim_ENTERING_SOFTINIT                          (M_tim | 0x1003)
#define S_tim_INITIALIZED_SOFTLY                         (M_tim | 0x1004)
#define S_tim_ENTERING_HARDINIT                          (M_tim | 0x1005)
#define S_tim_INITIALIZED_HARDLY                         (M_tim | 0x1006)
#define S_imagestatus_INCORRECT_IMAGE_SIZE (M_imagestatus | 0x0001)
#define S_inputSource_TSENSOR_CONSTRUCTOR              (M_inputSource | 0x1001)
#define S_inputSource_TSENSOR_PHYSICAL_UNITS_PER_COUNT (M_inputSource | 0x1002)
#define S_inputSource_TSENSOR_RESET 		       (M_inputSource | 0x1003)
#define S_inputSource_TMODULATIONSOURCE_CONSTRUCTOR    (M_inputSource | 0x1004)
#define S_inputSource_TMODULATIONSOURCE_SET_MODULATION_PARAMETERS  (M_inputSource | 0x1005)
#define S_inputSource_TMODULATIONSOURCE_GET_MODULATION_PARAMETERS  (M_inputSource | 0x1006)
#define S_inputSource_TMODULATIONSOURCE_RESET          (M_inputSource | 0x1007)
#define S_inputSource_TMODULATEDSENSOR_CONSTRUCTOR     (M_inputSource | 0x1008)
#define S_inputSource_TMODULATEDSENSOR_SET_MODULATION  (M_inputSource | 0x1009)
#define S_inputSource_TMODULATEDSENSOR_GET_MODULATION  (M_inputSource | 0x100A)
#define S_instcds_UNRECOGNIZED_COMMAND         (M_inst | 0x1)
#define S_instcds_CANT_ALLOCATE_TARGET_BUFFERS (M_inst | 0x2)
#define S_instcds_GIZMO_NOT_INITIALIZED        (M_inst | 0x3)
#define S_instcds_INVALID_DELAY_LINE_ID        (M_inst | 0x4)
#define S_instcds_GIZMO_NOT_SHUT_DOWN          (M_inst | 0x1000)
#define S_instcds_GIZMO_ALREADY_SHUTDOWN      (M_inst | 0x1001)
#define S_instcds_GIZMO_ALREADY_INITIALIZED    (M_inst | 0x1002)
#define S_instcds_MANUAL_TARGET_SET            (M_inst | 0x2000)
#define S_instcds_OPEN_LOOP_TARGET_SET         (M_inst | 0x2001)
#define S_ping_INSTRUMENT_CDS_ALIVE            (M_inst | 0x2002)
#define S_instcds_TIME_SET                     (M_inst | 0x2003)
#define S_gizmoInfo_BAD_DYNAMIC_DOWNCAST   (M_gizmoInfo | 0x1)
#define S_ipc_CANT_CREATE_LOCAL_MEMORY_POOL        (M_ipc | 0x1)
#define S_ipc_CANT_CREATE_SHARED_MEMORY_POOL       (M_ipc | 0x2)
#define S_ipc_CANT_CREATE_TOKEN_CLIENT             (M_ipc | 0x3 )
#define S_ipc_UNKNOWN_MEMORY_TYPE                  (M_ipc | 0x4)
#define S_ipc_CANT_ALLOCATE_LOCAL_OBJECT           (M_ipc | 0x5)
#define S_ipc_CANT_ALLOCATE_SHARED_MEMORY_OBJECT   (M_ipc | 0x6)
#define S_ipc_INSUFFICIENT_LOCAL_MEMORY            (M_ipc | 0x7)
#define S_ipc_INSUFFICIENT_SHARED_MEMORY           (M_ipc | 0x8)
#define S_ipc_LOCAL_MEMORY_NOT_INITIALIZED         (M_ipc | 0x9)
#define S_ipc_OBJECT_MISMATCH                      (M_ipc | 0xa)
#define S_ipc_TOKEN_SERVER_SPAWN_FAILED            (M_ipc | 0xb)
#define S_ipc_UNTYPED_GET_INTERNAL_ERROR           (M_ipc | 0xc)
#define S_ipc_MULTI_TYPE_FIFO_GET_NO_DATA          (M_ipc | 0xd)
#define S_ipc_INTERNAL_PUT_ERROR		   (M_ipc | 0xe)
#define S_ipc_OBJECT_NOT_ENABLED		   (M_ipc | 0xf)
#define S_ipc_UNSUPPORTED_GET_OPERATION            (M_ipc | 0x10)
#define S_ipc_UNSUPPORTED_PUT_OPERATION            (M_ipc | 0x11)
#define S_ipc_BUFFER_EMPTY                         (M_ipc | 0x1001)
#define S_ipc_FIFO_EMPTY                           (M_ipc | 0x1002)
#define S_ipc_FIFO_FULL                            (M_ipc | 0x1003)
#define S_ipc_TOO_FEW_ELEMENTS_IN_FIFO             (M_ipc | 0x1004)
#define S_ipc_TOO_MANY_ELEMENTS_IN_FIFO            (M_ipc | 0x1005)
#define S_ipc_LOCAL_MEMORY_ALREADY_INTIALIZED      (M_ipc | 0x1006)
#define S_ipc_SHUTTING_DOWN_MEMORY                 (M_ipc | 0x10007)
#define S_object_CREATING_ATOM                     (M_ipc | 0x2001)
#define S_object_CREATING_DOUBLE_BUFFER            (M_ipc | 0x2002)
#define S_object_CREATING_FIFO                     (M_ipc | 2003)
#define S_ipc_LOCAL_OBJECT_ALLOCATE_START          (M_ipc | 0x2004)
#define S_ipc_LOCAL_OBJECT_ALLOCATE_DONE           (M_ipc | 0x2005)
#define S_ipc_SHARED_OBJECT_ALLOCATE_START         (M_ipc | 0x2006)
#define S_ipc_SHARED_OBJECT_ALLOCATION_DONE        (M_ipc | 0x2007)
#define S_ipc_MEMORY_ALREADY_INITIALIZED 1
#define S_ipc_MEMORY_ALREADY_SHUTDOWN 2
#define S_rte_INSUFFICIENT_MEMORY          (M_rte | 0x1)
#define S_initmgr_HB_TIMEOUT               (M_initmgr | 0x1)
#define S_initmgr_CPU_NUMBER_OUT_OF_RANGE  (M_initmgr | 0x2)
#define S_initmgr_RTE_NUMBER_OUT_OF_RANGE  (M_initmgr | 0x3)
#define S_general_NOT_IMPLEMENTED          (M_general | 0x1)
#define S_inputSource_LASERMETROLOGYSENSOR_OPD_UNITS_PER_COUNT   (M_inputSource | 0x100D)
#define S_modLib_INVALID_MOD_TYPE               (M_modLib | 0x1)
#define S_modLib_INVALID_MOD_FREQ               (M_modLib | 0x2)
#define S_mutexUser_MUTEX_TASK_PRIORITY_TOO_HIGH                  (M_mutex | 0x1)
#define S_mutexUser_ABORT_ATTEMPTED_ON_INACTIVE_MUTEX_USER_OBJECT (M_mutex | 0x2)
#define S_outputDest_TACTUATOR_CONSTRUCTOR              (M_outputDest | 0x1001)
#define S_outputDest_TACTUATOR_PHYSICAL_UNITS_PER_COUNT (M_outputDest | 0x1002)
#define S_outputDest_TMODULATEDACTUATOR_CONSTRUCTOR     (M_outputDest | 0x1003)
#define S_outputDest_TMODULATEDACTUATOR_RESET_MODULATION   (M_outputDest | 0x1004)
#define S_outputDest_TMODULATEDACTUATOR_SET_MODULATION  (M_outputDest | 0x1005)
#define S_outputDest_TMOD_ACCEL_ACTUATOR_CONSTRUCTOR    (M_outputDest | 0x1006)
#define S_outputDest_GET_MAX_ACCEL                      (M_outputDest | 0x1007)
#define S_outputDest_TMOD_VEL_ACTUATOR_CONSTRUCTOR      (M_outputDest | 0x1008)
#define S_outputDest_GET_MAX_VEL                        (M_outputDest | 0x1009)
#define S_outputDest_TMOD_POSITION_ACTUATOR_CONSTRUCTOR (M_outputDest | 0x100A)
#define S_outputDest_GET_MIN_POSITION                   (M_outputDest | 0x100B)
#define S_outputDest_GET_MAX_POSITION                   (M_outputDest | 0x100C)
#define S_realtime_gizmo_SHUTTING_DOWN_GIZMO  (M_rtgizmo | 0x1001)
#define S_realtime_gizmo_ALREADY_SHUTDOWN     (M_rtgizmo | 0x1002)
#define S_realtime_gizmo_ALREADY_RUNNING      (M_rtgizmo | 0x1003)
#define S_realtime_gizmo_CONSTRUCTOR_START    (M_rtgizmo | 0x2001)
#define S_realtime_gizmo_CONTRUCTOR_COMPLETE  (M_rtgizmo | 0x2002)
#define S_realtime_gizmo_START_TASKS_COMPLETE (M_rtgizmo | 0x2003)
#define S_realtime_gizmo_DESTRUCTOR_START     (M_rtgizmo | 0x2004)
#define S_realtime_gizmo_DESTRUCTOR_COMPLETE  (M_rtgizmo | 0x2005)
#define S_realtime_gizmo_RESTART_START        (M_rtgizmo | 0x2006)
#define S_realtime_gizmo_RESTART_COMPLETE     (M_rtgizmo | 0x2007)
#define S_realtime_gizmo_SHUTDOWN_START       (M_rtgizmo | 0x2008)
#define S_realtime_gizmo_SHUTDOWN_COMPLETE    (M_rtgizmo | 0x2009)
#define S_relayStream_SENDER_NOT_INITIALIZED       (M_relayStream | 0x1)
#define S_relayStream_RECEIVER_NOT_INITIALIZED     (M_relayStream | 0x2)
#define S_relayStream_ALREADY_INITIALIZED          (M_relayStream | 0x1000)
#define S_relayStream_ALREADY_SHUTDOWN             (M_relayStream | 0x1001)
#define S_relayStream_SENDER_ALREADY_INITIALIZED   (M_relayStream | 0x1002)
#define S_relayStream_SENDER_ALREADY_SHUTDOWN      (M_relayStream | 0x1003)
#define S_relayStream_RECEIVER_ALREADY_INITIALIZED (M_relayStream | 0x1004)
#define S_relayStream_RECEIVER_ALREADY_SHUTDOWN    (M_relayStream | 0x1005)
#define S_relayStream_SHUTTING_DOWN                (M_relayStream | 0x1006)
#define S_relayStream_SHUTTING_DOWN_SENDER         (M_relayStream | 0x1007)
#define S_relayStream_SHUTTING_DOWN_RECEIVER       (M_relayStream | 0x1008)
#define S_relayStream_INIT_COMPLETE                (M_relayStream | 0x2001)
#define S_relayStream_REINIT_COMPLETE              (M_relayStream | 0x2002)
#define S_relayStream_SHUTDOWN_COMPLETE            (M_relayStream | 0x2003)
#define S_relayStream_SENDER_INIT_COMPLETE         (M_relayStream | 0x2004)
#define S_relayStream_SENDER_REINIT_COMPLETE       (M_relayStream | 0x2005)
#define S_relayStream_SENDER_SHUTDOWN_COMPLETE     (M_relayStream | 0x2006)
#define S_relayStream_RECEIVER_INIT_COMPLETE       (M_relayStream | 0x2007)
#define S_relayStream_RECEIVER_REINIT_COMPLETE     (M_relayStream | 0x2008)
#define S_relayStream_RECEIVER_SHUTDOWN_COMPLETE   (M_relayStream | 0x2009)
#define S_relayer_CANT_ALLOCATE_ERROR_STREAMS           (M_relayer | 0x0001)
#define S_relayer_CANT_ALLOCATE_DATA_STREAMS            (M_relayer | 0x0002)
#define S_relayer_CANT_ALLOCATE_STATUS_STREAMS          (M_relayer | 0x0003)
#define S_relayer_CANT_ALLOCATE_DATA_HEADERS            (M_relayer | 0x0004)
#define S_relayer_CANT_ALLOCATE_STATUS_HEADERS          (M_relayer | 0x0005)
#define S_relayer_UI_NOT_ATTACHED	                (M_relayer | 0x0006)
#define S_relayer_INITIALIZED_ERROR_DATA_AND_STATUS_STREAMS (M_relayer | 0x0007)
#define S_relayer_INTERNAL_ERROR                        (M_relayer | 0x0008)
#define S_setcallback_INVALID_GIZMO                        (M_relayer | 0x0009)
#define S_relayer_ALREADY_INITIALIZED                   (M_relayer | 0x1001)
#define S_relayer_ALREADY_SHUTDOWN                      (M_relayer | 0x1002)
#define  S_relayer_NOT_SHUTDOWN                         (M_relayer | 0x1003)
#define S_relayer_SENDING_ERROR_TO_UI                   (M_relayer | 0x2001)
#define S_relayer_SENDING_DATA_TO_UI                    (M_relayer | 0x2002)
#define S_relayer_SENDING_STATUS_TO_UI                  (M_relayer | 0x2003)
#define S_relayer_ENTERING_RELAYER_INIT                 (M_relayer | 0x2004)
#define S_relayer_INITIALIZED_ERROR_STREAMS             (M_relayer | 0x2005)
#define S_relayer_INITIALIZED_DATA_AND_STATUS_STREAMS   (M_relayer | 0x2006)
#define S_relayer_CREATED_MSGQS_AND_SPAWNED_MSGQ_TASKS  (M_relayer | 0x2007)
#define S_relayer_LEAVING_RELAYER_INIT                  (M_relayer | 0x2008)
#define S_relayer_TRELAYER_RELAY                        (M_relayer | 0x2009)
#define S_rte_GIZMO_CREATION_ERROR             (M_rte | 0x2)
#define S_rte_GIZMO_NOT_ON_THIS_RTE            (M_rte | 0x3)
#define S_rte_INVALID_GIZMO_NUMBER             (M_rte | 0x4)
#define S_rte_UNABLE_TO_CREATE_IPC             (M_rte | 0x5)
#define S_rte_UNABLE_TO_CREATE_SCHEDULER       (M_rte | 0x6)
#define S_rte_UNABLE_TO_CREATE_ERROR_STREAM    (M_rte | 0x7)
#define S_rte_UNABLE_TO_CREATE_DATA_STREAM     (M_rte | 0x8)
#define S_rte_UNABLE_TO_CREATE_STATUS_STREAM   (M_rte | 0x9)
#define S_rte_INVALID_RTE_GIZMO_INDEX          (M_rte | 0xa)
#define S_rte_ENTERING_TRTE_INIT               (M_rte | 0x1001)
#define S_rte_IPC_INITIALIZED                  (M_rte | 0x1002)
#define S_rte_INTERRUPT_INITIALIZED            (M_rte | 0x1003)
#define S_rte_SCHEDULER_INITIALIZED            (M_rte | 0x1004)
#define S_rte_HB_EKG_EMT_TASKS_SCHEDULED       (M_rte | 0x1005)
#define S_rte_CREATING_NEW_GIZMO               (M_rte | 0x1006)
#define S_rte_TRTE_INIT_COMPLETED              (M_rte | 0x1007)
#define S_rte_ENTERING_RTEINIT                 (M_rte | 0x1008)
#define S_rte_EXITING_RTEINIT                  (M_rte | 0x1009)
#define S_rte_HEARTBEAT_TICKED                 (M_rte | 0x100a)
#define S_rte_EKG_TICKED                       (M_rte | 0x100b)
#define S_rte_EMT_TICKED                       (M_rte | 0x100c)
#define S_rte_ERROR_STREAM_INITIALIZED         (M_rte | 0x100d)
#define S_rte_DATA_STREAM_INITIALIZED          (M_rte | 0x100e)
#define S_rte_STATUS_STREAM_INITIALIZED        (M_rte | 0x100f)
#define S_servo_COULD_NOT_ALLOCATE_SERVO_TASK_ARRAY      (M_servo | 0x1)
#define S_servo_INVALID_SERVO_MODE_REQUESTED             (M_servo | 0x2)
#define S_servo_REQUESTED_TASK_PERIOD_MODIFIED           (M_servo | 0x3)
#define S_servo_UNABLE_TO_ALLOCATE_SERVO_TASK_INFO_ARRAY (M_servo | 0x4)
#define S_servo_INVALID_PARTITION                        (M_servo | 0x5)
#define S_tservotask_TASK_ALREADY_RUNNING                (M_servo | 0x1001)
#define S_tservotask_TASK_ALREADY_SHUTDOWN               (M_servo | 0x1002)
#define S_tservo_ALREADY_RUNNING                         (M_servo | 0x1003)
#define S_tservo_ALREADY_SHUTDOWN                        (M_servo | 0x1004)
#define S_servotask_CONSTRUCTOR                          (M_servo | 0x2001)
#define S_servotask_ADDED_SERVO_TASK                     (M_servo | 0x2002)
#define S_servotask_DESTRUCTOR                           (M_servo | 0x2003)
#define S_servotask_DOSERVO                              (M_servo | 0x2004)
#define S_servotask_EXITING_DOSERVO                      (M_servo | 0x2005)
#define S_servo_CONSTRUCTOR_BEGIN                        (M_servo | 0x2006)
#define S_servo_TASK_ARRAY_CONSTRUCTOR_COMPLETE          (M_servo | 0x2007)
#define S_servo_SELECT_MODE                              (M_servo | 0x2008)
#define S_servotask_DELETED_SERVO_TASK                   (M_servo | 0x2009)
#define S_servo_TASK_ARRAY_ALLOCATED                     (M_servo | 0x2008)
#define S_servoinfo_UNABLE_TO_ALLOCATE_SERVO_TASK_INFO_ARRAY  (M_servoinfo | 0x1)
#define S_servoinfo_INVALID_PARTITION                         (M_servoinfo | 0x2)
#define S_ipc_TOKEN_SERVER_COULD_NOT_BE_CREATED 1
#define S_gui_STARTING_TCPSERVER (M_gui | 0x1001)
#define S_gui_PROCESSING_CMD     (M_gui | 0x1002)
#define S_stactuator_INVALID_STAR_IMAGE_SIZE      (M_stactuator | 0x01)
#define S_stgizmo_COULD_NOT_CREATE_COMMAND_ENGINE      (M_stgizmo | 0x01)
#define S_stgizmo_UNRECOGNIZED_COMMAND                 (M_stgizmo | 0x02)
#define S_stgizmo_UNABLE_TO_SEND_STATUS                (M_stgizmo | 0x03)
#define S_stgizmo_GIZMO_INFO_NOT_ST                    (M_stgizmo | 0x04)
#define S_stgizmo_INVALID_NUMBER_OF_SERVO_MODES        (M_stgizmo | 0x05)
#define S_stgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS   (M_stgizmo | 0x06)
#define S_stgizmo_CANT_CONSTRUCT_IO_OR_CTLR_SET        (M_stgizmo | 0x07)
#define S_stgizmo_ERROR_UPDATING_STAR_SENSOR           (M_stgizmo | 0x08)
#define S_stgizmo_TRANSFORM_UNDEFINED                  (M_stgizmo | 0x09)
#define S_stgizmo_ENTERING_ST_GIZMO_CONSTRUCTOR        (M_stgizmo | 0x1001)
#define S_stgizmo_ASSIGNING_CTLR_GROUPS_TO_MODES       (M_stgizmo | 0x1002)
#define S_stgizmo_ASSIGNING_CTLRS_TO_PARTITIONS        (M_stgizmo | 0x1003)
#define S_stgizmo_ENABLING_BASE_CLASS_TASKS            (M_stgizmo | 0x1004)
#define S_stgizmo_LEAVING_ST_GIZMO_CONSTRUCTOR         (M_stgizmo | 0x1005)
#define S_stgizmo_ST_GIZMO_DESTRUCTOR                  (M_stgizmo | 0x1006)
#define S_stgizmo_RESTART                              (M_stgizmo | 0x1007)
#define S_stgizmo_SHUTDOWN                             (M_stgizmo | 0x1008)
#define S_stgizmo_ENTERING_COLLECTSTATUS               (M_stgizmo | 0x1009)
#define S_stgizmo_GETTING_IMAGE_STATUS                 (M_stgizmo | 0x100a)
#define S_stgizmo_SENDING_STATUS_BLOCK                 (M_stgizmo | 0x100b)
#define S_stgizmo_SENDING_STATUS_IMAGE                 (M_stgizmo | 0x100c)
#define S_stgizmo_LEAVING_COLLECTSTATUS                (M_stgizmo | 0x100d)
#define S_stgizmo_ENTERING_DISPATCH                    (M_stgizmo | 0x100e)
#define S_stgizmo_LEAVING_DISPATCH                     (M_stgizmo | 0x100f)
#define S_stgizmo_PING                                 (M_stgizmo | 0x1010)
#define S_stgizmo_ENTERING_OFF_METHOD                  (M_stgizmo | 0x1011)
#define S_stgizmo_LEAVING_OFF_METHOD                   (M_stgizmo | 0x1012)
#define S_stgizmo_ENTERING_TRACK_METHOD                (M_stgizmo | 0x1013)
#define S_stgizmo_LEAVING_TRACK_METHOD                 (M_stgizmo | 0x1014)
#define S_stgizmo_ST_COMPLETE_IO_SET_CONSTRUCTOR       (M_stgizmo | 0x1015)
#define S_stgizmo_ST_COMPLETE_IO_SET_DESTRUCTOR        (M_stgizmo | 0x1016)
#define S_stgizmo_ENTERING_ST_GIZMOINFO_CONSTRUCTOR    (M_stgizmo | 0x1017)
#define S_stgizmo_LEAVING_ST_GIZMOINFO_CONSTRUCTOR     (M_stgizmo | 0x1018)
#define S_stgizmo_STAR_SENSOR_CONSTRUCTOR              (M_stgizmo | 0x1019)
#define S_stgizmo_STAR_SENSOR_UPDATE                   (M_stgizmo | 0x101a)
#define S_stgizmo_ST_CONTROLLER_DATA_CONSTRUCTOR       (M_stgizmo | 0x101b)
#define S_stgizmo_ST_CONTROLLER_CONSTRUCTOR            (M_stgizmo | 0x101c)
#define S_stgizmo_ST_CONTROLLER_DESTRUCTOR             (M_stgizmo | 0x101d)
#define S_stgizmo_ST_OFF_CONTROLLER_CONSTRUCTOR        (M_stgizmo | 0x101e)
#define S_stgizmo_ENTERING_ST_OFF_CONTROLLER_INIT      (M_stgizmo | 0x101f)
#define S_stgizmo_LEAVING_ST_OFF_CONTROLLER_INIT       (M_stgizmo | 0x1020)
#define S_stgizmo_ST_TRACK_CONTROLLER_CONSTRUCTOR      (M_stgizmo | 0x1021)
#define S_stgizmo_ST_TRACK_CONTROLLER_DESTRUCTOR       (M_stgizmo | 0x1022)
#define S_stgizmo_ENTERING_ST_TRACK_CONTROLLER_CALCULATE (M_stgizmo | 0x1023)
#define S_stgizmo_UPDATE_STAR_SENSOR                   (M_stgizmo | 0x1024)
#define S_stgizmo_CALCULATE_CENTROID                   (M_stgizmo | 0x1025)
#define S_stgizmo_UPDATE_CONTROLLER_DATA_BLOCK         (M_stgizmo | 0x1026)
#define S_stgizmo_LEAVING_ST_TRACK_CONTROLLER_CALCULATE (M_stgizmo | 0x1027)
#define S_stgizmo_ENTERING_CALCULATE_CENTROID          (M_stgizmo | 0x1028)
#define S_stgizmo_LEAVING_CALCULATE_CENTROID           (M_stgizmo | 0x1029)
#define S_stgizmo_ST_COMPLETE_CONTROLLER_SET_CONSTRUCTOR (M_stgizmo | 0x102a)
#define S_stgizmo_ENTERING_CALIBRATE_METHOD              (M_stgizmo | 0x102b)
#define S_stgizmo_LEAVING_CALIBRATE_METHOD               (M_stgizmo | 0x102c)
#define S_stgizmo_ENTERING_HOME_METHOD                   (M_stgizmo | 0x102d)
#define S_stgizmo_LEAVING_HOME_METHOD                    (M_stgizmo | 0x102e)
#define S_stgizmo_ENTERING_SSP_METHOD                    (M_stgizmo | 0x102f)
#define S_stgizmo_LEAVING_SSP_METHOD                     (M_stgizmo | 0x1030)
#define S_stgizmo_ENTERING_ST_CONTROLLER_CALCULATE       (M_stgizmo | 0x1031)
#define S_stgizmo_LEAVING_ST_CONTROLLER_CALCULATE        (M_stgizmo | 0x1032)
#define S_stgizmo_ST_COMPLETE_CONTROLLER_SET_DESTRUCTOR  (M_stgizmo | 0x1033)
#define S_stgizmo_STAR_TRACKER_ALIVE             (M_stgizmo | 0x2001)
#define S_stgizmo_SETTING_SERVO_PARAMETERS       (M_stgizmo | 0x2002)
#define S_stgizmo_SERVO_PARAMETERS_SET           (M_stgizmo | 0x2003)
#define S_stgizmo_OFF_START                      (M_stgizmo | 0x2004)
#define S_stgizmo_OFF_COMPLETE                   (M_stgizmo | 0x2005)
#define S_stgizmo_TRACK_START                    (M_stgizmo | 0x2006)
#define S_stgizmo_TRACK_IN_PROGRESS              (M_stgizmo | 0x2007)
#define S_stgizmo_TRACK_ABORTED                  (M_stgizmo | 0x2008)
#define S_stgizmo_CALIBRATE_IN_PROGRESS          (M_stgizmo | 0x2009)
#define S_telemetry_UNKNOWN_ITEM 1
#define S_telemetry_UNKNOWN_TELEMETRY_TYPE 2
#define S_token_CLIENT_DOESNT_OWN_TOKEN                  (M_ts | 0x1)
#define S_token_CLIENT_ALREADY_OWNS_TOKEN                (M_ts | 0x2)
#define S_token_CLIENT_TIME_OUT                          (M_ts | 0x3)
#define S_token_CLIENT_OUT_OF_RANGE                      (M_ts | 0x4)
#define S_token_SERVER_TIME_OUT			 (M_ts | 0x5)
#define S_token_SERVER_ALREADY_RUNNING                   (M_ts | 0x1001)
#define S_token_SERVER_NOT_RUNNING                       (M_ts | 0x1002)
#define S_token_CLIENT_NOT_INITIALIZED                   (M_ts | 0x1003)
#define S_token_CLIENT_ALREADY_INITIALIZED               (M_ts | 0x1004)
#define S_token_CLIENT_ALREADY_SHUTDOWN			 (M_ts | 0x1005)
#define S_ts_SUCCESSFULLY_COMPLETED_SERVER_INIT          (M_ts | 0x2001)
#define S_ts_SUCCESSFULLY_COMPLETED_SERVER_DESTRUCTOR    (M_ts | 0x2002)
#define S_ts_SUCCESSFULLY_COMPLETED_SERVER_REINIT        (M_ts | 0x2003)
#define S_ts_SUCCESSFULLY_COMPLETED_SERVER_SHUTDOWN      (M_ts | 0x2004)
#define S_ts_START_OF_POLL                               (M_ts | 0x2005)
#define S_ts_END_OF_POLL                                 (M_ts | 0x2006)
#define S_ts_REQUEST_GRANTED                             (M_ts | 0x2007)
#define S_ts_RETURN_ACCEPTED                             (M_ts | 0x2008)
#define S_tc_SUCCESSFULLY_COMPLETED_CLIENT_INIT          (M_ts | 0x1009)
#define S_tc_SUCCESSFULLY_COMPLETED_CLIENT_REINIT        (M_ts | 0x100a)
#define S_tc_SUCCESSFULLY_COMPLETED_CLIENT_SHUTDOWN      (M_ts | 0x100b)
#define S_tc_SUCCESSFULLY_COMPLETED_TOKEN_REQUEST        (M_ts | 0x100c)
#define S_tc_SUCCESSFULLY_COMPLETED_TOKEN_RETURN         (M_ts | 0x100d)
#define S_tracedump_QUEUE_ERROR         (M_trace | 1)
#define S_vector_BAD_VECTOR_OPERATION      (M_vector | 0x01)
#define S_vector_BAD_MATRIX_OPERATION      (M_vector | 0x02)
#define S_wapgizmo_COULD_NOT_CREATE_COMMAND_ENGINE      (M_wapgizmo | 0x01)
#define S_wapgizmo_UNRECOGNIZED_COMMAND                 (M_wapgizmo | 0x02)
#define S_wapgizmo_UNABLE_TO_SEND_STATUS                (M_wapgizmo | 0x03)
#define S_wapgizmo_GIZMO_INFO_NOT_WAP                   (M_wapgizmo | 0x04)
#define S_wapgizmo_INVALID_NUMBER_OF_SERVO_MODES        (M_wapgizmo | 0x05)
#define S_wapgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS   (M_wapgizmo | 0x06)
#define S_wapgizmo_CANT_CONSTRUCT_IO_OR_CTLR_SET        (M_wapgizmo | 0x07)
#define S_wapgizmo_ERROR_UPDATING_STAR_SENSOR           (M_wapgizmo | 0x08)
#define S_wapgizmo_TRANSFORM_UNDEFINED                  (M_wapgizmo | 0x09)
#define S_wapgizmo_TASK_DELAY_FAILED                    (M_wapgizmo | 0x0a)
#define S_wapgizmo_DIVIDE_BY_ZERO                       (M_wapgizmo | 0x0b)
#define S_wapgizmo_ENTERING_WAP_GIZMO_CONSTRUCTOR       (M_wapgizmo | 0x1001)
#define S_wapgizmo_ASSIGNING_CTLR_GROUPS_TO_MODES       (M_wapgizmo | 0x1002)
#define S_wapgizmo_ASSIGNING_CTLRS_TO_PARTITIONS        (M_wapgizmo | 0x1003)
#define S_wapgizmo_ENABLING_BASE_CLASS_TASKS            (M_wapgizmo | 0x1004)
#define S_wapgizmo_LEAVING_WAP_GIZMO_CONSTRUCTOR        (M_wapgizmo | 0x1005)
#define S_wapgizmo_WAP_GIZMO_DESTRUCTOR                 (M_wapgizmo | 0x1006)
#define S_wapgizmo_RESTART                              (M_wapgizmo | 0x1007)
#define S_wapgizmo_SHUTDOWN                             (M_wapgizmo | 0x1008)
#define S_wapgizmo_ENTERING_COLLECTSTATUS               (M_wapgizmo | 0x1009)
#define S_wapgizmo_GETTING_IMAGE_STATUS                 (M_wapgizmo | 0x100a)
#define S_wapgizmo_SENDING_STATUS_BLOCK                 (M_wapgizmo | 0x100b)
#define S_wapgizmo_SENDING_STATUS_IMAGE                 (M_wapgizmo | 0x100c)
#define S_wapgizmo_LEAVING_COLLECTSTATUS                (M_wapgizmo | 0x100d)
#define S_wapgizmo_ENTERING_DISPATCH                    (M_wapgizmo | 0x100e)
#define S_wapgizmo_LEAVING_DISPATCH                     (M_wapgizmo | 0x100f)
#define S_wapgizmo_PING                                 (M_wapgizmo | 0x1010)
#define S_wapgizmo_ENTERING_OFF_METHOD                  (M_wapgizmo | 0x1011)
#define S_wapgizmo_LEAVING_OFF_METHOD                   (M_wapgizmo | 0x1012)
#define S_wapgizmo_ENTERING_TRACK_METHOD                (M_wapgizmo | 0x1013)
#define S_wapgizmo_LEAVING_TRACK_METHOD                 (M_wapgizmo | 0x1014)
#define S_wapgizmo_WAP_COMPLETE_IO_SET_CONSTRUCTOR       (M_wapgizmo | 0x1015)
#define S_wapgizmo_WAP_COMPLETE_IO_SET_DESTRUCTOR        (M_wapgizmo | 0x1016)
#define S_wapgizmo_ENTERING_WAP_GIZMOINFO_CONSTRUCTOR    (M_wapgizmo | 0x1017)
#define S_wapgizmo_LEAVING_WAP_GIZMOINFO_CONSTRUCTOR     (M_wapgizmo | 0x1018)
#define S_wapgizmo_STAR_SENSOR_CONSTRUCTOR              (M_wapgizmo | 0x1019)
#define S_wapgizmo_STAR_SENSOR_UPDATE                   (M_wapgizmo | 0x101a)
#define S_wapgizmo_WAP_CONTROLLER_DATA_CONSTRUCTOR       (M_wapgizmo | 0x101b)
#define S_wapgizmo_WAP_CONTROLLER_CONSTRUCTOR            (M_wapgizmo | 0x101c)
#define S_wapgizmo_WAP_CONTROLLER_DESTRUCTOR             (M_wapgizmo | 0x101d)
#define S_wapgizmo_WAP_OFF_CONTROLLER_CONSTRUCTOR        (M_wapgizmo | 0x101e)
#define S_wapgizmo_ENTERING_WAP_OFF_CONTROLLER_INIT      (M_wapgizmo | 0x101f)
#define S_wapgizmo_LEAVING_WAP_OFF_CONTROLLER_INIT       (M_wapgizmo | 0x1020)
#define S_wapgizmo_WAP_TRACK_CONTROLLER_CONSTRUCTOR      (M_wapgizmo | 0x1021)
#define S_wapgizmo_WAP_TRACK_CONTROLLER_DESTRUCTOR       (M_wapgizmo | 0x1022)
#define S_wapgizmo_ENTERING_WAP_TRACK_CONTROLLER_CALCULATE (M_wapgizmo | 0x1023)
#define S_wapgizmo_UPDATE_STAR_SENSOR                   (M_wapgizmo | 0x1024)
#define S_wapgizmo_CALCULATE_CENTROID                   (M_wapgizmo | 0x1025)
#define S_wapgizmo_UPDATE_CONTROLLER_DATA_BLOCK         (M_wapgizmo | 0x1026)
#define S_wapgizmo_LEAVING_WAP_TRACK_CONTROLLER_CALCULATE (M_wapgizmo | 0x1027)
#define S_wapgizmo_ENTERING_CALCULATE_CENTROID          (M_wapgizmo | 0x1028)
#define S_wapgizmo_LEAVING_CALCULATE_CENTROID           (M_wapgizmo | 0x1029)
#define S_wapgizmo_WAP_COMPLETE_CONTROLLER_SET_CONSTRUCTOR (M_wapgizmo | 0x102a)
#define S_wapgizmo_ENTERING_CALIBRATE_METHOD              (M_wapgizmo | 0x102b)
#define S_wapgizmo_LEAVING_CALIBRATE_METHOD               (M_wapgizmo | 0x102c)
#define S_wapgizmo_ENTERING_HOME_METHOD                   (M_wapgizmo | 0x102d)
#define S_wapgizmo_LEAVING_HOME_METHOD                    (M_wapgizmo | 0x102e)
#define S_wapgizmo_ENTERING_SSP_METHOD                    (M_wapgizmo | 0x102f)
#define S_wapgizmo_LEAVING_SSP_METHOD                     (M_wapgizmo | 0x1030)
#define S_wapgizmo_ENTERING_WAP_CONTROLLER_CALCULATE       (M_wapgizmo | 0x1031)
#define S_wapgizmo_LEAVING_WAP_CONTROLLER_CALCULATE        (M_wapgizmo | 0x1032)
#define S_wapgizmo_WAP_COMPLETE_CONTROLLER_SET_DESTRUCTOR  (M_wapgizmo | 0x1033)
#define S_wapgizmo_ENTERING_SLEW_METHOD                    (M_wapgizmo | 0x1034)
#define S_wapgizmo_LEAVING_SLEW_METHOD                     (M_wapgizmo | 0x1035)
#define S_wapgizmo_ENTERING_MOVE_METHOD                    (M_wapgizmo | 0x1036)
#define S_wapgizmo_LEAVING_MOVE_METHOD                     (M_wapgizmo | 0x1037)
#define S_wapgizmo_WAP_CONTROLLER_RESET                    (M_wapgizmo | 0x1038)
#define S_wapgizmo_WAP_ALIVE             (M_wapgizmo | 0x2001)
#define S_wapgizmo_SETTING_SERVO_PARAMETERS       (M_wapgizmo | 0x2002)
#define S_wapgizmo_SERVO_PARAMETERS_SET           (M_wapgizmo | 0x2003)
#define S_wapgizmo_SLEW_START                     (M_wapgizmo | 0x2004)
#define S_wapgizmo_SLEW_COMPLETE                  (M_wapgizmo | 0x2005)
#define S_wapgizmo_OFF_COMPLETE                   (M_wapgizmo | 0x2006)
#define S_wapgizmo_TRACK_START                    (M_wapgizmo | 0x2007)
#define S_wapgizmo_TRACK_IN_PROGRESS              (M_wapgizmo | 0x2008)
#define S_wapgizmo_TRACK_ABORTED                  (M_wapgizmo | 0x2009)
#define S_wapgizmo_CALIBRATE_IN_PROGRESS          (M_wapgizmo | 0x200a)
#define S_watchDog_ALREADY_INITIALIZED     (M_watchDog | 0x1)
#define S_watchDog_NULL_FUNCTION_POINTER   (M_watchDog | 0x2)
#define S_watchDog_INVALID_TIMEOUT_VALUE   (M_watchDog | 0x3)
#define S_watchDog_NOT_INITIALIZED         (M_watchDog | 0x4)
#define S_arpLib_INVALID_ARGUMENT		(M_arpLib | 1)
#define S_arpLib_INVALID_ENET_ADDRESS 		(M_arpLib | 2)
#define S_arpLib_INVALID_FLAG			(M_arpLib | 3)
#define S_bootLoadLib_ROUTINE_NOT_INSTALLED		(M_bootLoadLib | 1)
#define S_bootpLib_INVALID_ARGUMENT	(M_bootpLib | 1)
#define S_bootpLib_INVALID_COOKIE	(M_bootpLib | 2)
#define S_bootpLib_NO_BROADCASTS	(M_bootpLib | 3)
#define S_bootpLib_PARSE_ERROR		(M_bootpLib | 4)
#define S_bootpLib_INVALID_TAG		(M_bootpLib | 5)
#define S_bootpLib_TIME_OUT		(M_bootpLib | 6)
#define S_cacheLib_INVALID_CACHE	(M_cacheLib | 1)
#define S_classLib_CLASS_ID_ERROR		(M_classLib | 1)
#define S_classLib_NO_CLASS_DESTROY		(M_classLib | 2)
#define S_dosFsLib_VOLUME_NOT_AVAILABLE		(M_dosFsLib | 1)
#define S_dosFsLib_DISK_FULL			(M_dosFsLib | 2)
#define S_dosFsLib_FILE_NOT_FOUND		(M_dosFsLib | 3)
#define S_dosFsLib_NO_FREE_FILE_DESCRIPTORS	(M_dosFsLib | 4)
#define S_dosFsLib_INVALID_NUMBER_OF_BYTES	(M_dosFsLib | 5)
#define S_dosFsLib_FILE_ALREADY_EXISTS		(M_dosFsLib | 6)
#define S_dosFsLib_ILLEGAL_NAME			(M_dosFsLib | 7)
#define	S_dosFsLib_CANT_DEL_ROOT		(M_dosFsLib | 8)
#define S_dosFsLib_NOT_FILE			(M_dosFsLib | 9)
#define	S_dosFsLib_NOT_DIRECTORY		(M_dosFsLib | 10)
#define	S_dosFsLib_NOT_SAME_VOLUME		(M_dosFsLib | 11)
#define S_dosFsLib_READ_ONLY			(M_dosFsLib | 12)
#define S_dosFsLib_ROOT_DIR_FULL		(M_dosFsLib | 13)
#define S_dosFsLib_DIR_NOT_EMPTY		(M_dosFsLib | 14)
#define S_dosFsLib_BAD_DISK			(M_dosFsLib | 15)
#define S_dosFsLib_NO_LABEL			(M_dosFsLib | 16)
#define S_dosFsLib_INVALID_PARAMETER		(M_dosFsLib | 17)
#define S_dosFsLib_NO_CONTIG_SPACE		(M_dosFsLib | 18)
#define S_dosFsLib_CANT_CHANGE_ROOT		(M_dosFsLib | 19)
#define S_dosFsLib_FD_OBSOLETE			(M_dosFsLib | 20)
#define S_dosFsLib_DELETED			(M_dosFsLib | 21)
#define S_dosFsLib_NO_BLOCK_DEVICE		(M_dosFsLib | 22)
#define S_dosFsLib_BAD_SEEK			(M_dosFsLib | 23)
#define S_dosFsLib_INTERNAL_ERROR		(M_dosFsLib | 24)
#define S_dosFsLib_WRITE_ONLY			(M_dosFsLib | 25)
#define S_errnoLib_NO_STAT_SYM_TBL      (M_errnoLib | 1)
#define S_hashLib_KEY_CLASH		(M_hashLib | 1)
#define S_hostLib_UNKNOWN_HOST			(M_hostLib | 1)
#define S_hostLib_HOST_ALREADY_ENTERED		(M_hostLib | 2)
#define S_icmpLib_TIMEOUT		(M_icmpLib | 1)
#define S_icmpLib_NO_BROADCAST		(M_icmpLib | 2)
#define S_icmpLib_INVALID_INTERFACE	(M_icmpLib | 3)
#define S_if_sl_INVALID_UNIT_NUMBER			(M_if_sl | 1)
#define S_if_sl_UNIT_UNINITIALIZED			(M_if_sl | 2)
#define S_if_sl_UNIT_ALREADY_INITIALIZED		(M_if_sl | 3)
#define S_inetLib_ILLEGAL_INTERNET_ADDRESS		(M_inetLib | 1)
#define S_inetLib_ILLEGAL_NETWORK_NUMBER		(M_inetLib | 2)
#define S_intLib_NOT_ISR_CALLABLE		(M_intLib | 1)
#define S_intLib_VEC_TABLE_WP_UNAVAILABLE	(M_intLib | 2)
#define S_ioLib_NO_DRIVER		(M_ioLib | 1)
#define S_ioLib_UNKNOWN_REQUEST		(M_ioLib | 2)
#define S_ioLib_DEVICE_ERROR		(M_ioLib | 3)
#define S_ioLib_DEVICE_TIMEOUT		(M_ioLib | 4)
#define S_ioLib_WRITE_PROTECTED		(M_ioLib | 5)
#define S_ioLib_DISK_NOT_PRESENT	(M_ioLib | 6)
#define S_ioLib_NO_FILENAME		(M_ioLib | 7)
#define S_ioLib_CANCELLED		(M_ioLib | 8)
#define S_ioLib_NO_DEVICE_NAME_IN_PATH	(M_ioLib | 9)
#define S_ioLib_NAME_TOO_LONG		(M_ioLib | 10)
#define S_ioLib_UNFORMATED		(M_ioLib | 11)
#define S_iosLib_DEVICE_NOT_FOUND		(M_iosLib | 1)
#define S_iosLib_DRIVER_GLUT			(M_iosLib | 2)
#define S_iosLib_INVALID_FILE_DESCRIPTOR	(M_iosLib | 3)
#define S_iosLib_TOO_MANY_OPEN_FILES		(M_iosLib | 4)
#define S_iosLib_CONTROLLER_NOT_PRESENT		(M_iosLib | 5)
#define S_iosLib_DUPLICATE_DEVICE_NAME		(M_iosLib | 6)
#define S_iosLib_INVALID_ETHERNET_ADDRESS	(M_iosLib | 7)
#define S_loadAoutLib_TOO_MANY_SYMBOLS		(M_loadAoutLib | 1)
#define S_loadLib_FILE_READ_ERROR               (M_loadCoffLib | 1)
#define S_loadLib_REALLOC_ERROR                 (M_loadCoffLib | 2)
#define S_loadLib_JMPADDR_ERROR                 (M_loadCoffLib | 3)
#define S_loadLib_NO_REFLO_PAIR                 (M_loadCoffLib | 4)
#define S_loadLib_GPREL_REFERENCE               (M_loadCoffLib | 5)
#define S_loadLib_UNRECOGNIZED_RELOCENTRY       (M_loadCoffLib | 6)
#define S_loadLib_REFHALF_OVFL                  (M_loadCoffLib | 7)
#define S_loadLib_FILE_ENDIAN_ERROR             (M_loadCoffLib | 8)
#define S_loadLib_UNEXPECTED_SYM_CLASS          (M_loadCoffLib | 9)
#define S_loadLib_UNRECOGNIZED_SYM_CLASS        (M_loadCoffLib | 10)
#define S_loadLib_HDR_READ                      (M_loadCoffLib | 11)
#define S_loadLib_OPTHDR_READ                   (M_loadCoffLib | 12)
#define S_loadLib_SCNHDR_READ                   (M_loadCoffLib | 13)
#define S_loadLib_READ_SECTIONS                 (M_loadCoffLib | 14)
#define S_loadLib_LOAD_SECTIONS                 (M_loadCoffLib | 15)
#define S_loadLib_RELOC_READ                    (M_loadCoffLib | 16)
#define S_loadLib_SYMHDR_READ                   (M_loadCoffLib | 17)
#define S_loadLib_EXTSTR_READ                   (M_loadCoffLib | 18)
#define S_loadLib_EXTSYM_READ                   (M_loadCoffLib | 19)
#define S_loadEcoffLib_HDR_READ			(M_loadEcoffLib | 1)
#define S_loadEcoffLib_OPTHDR_READ		(M_loadEcoffLib | 2)
#define S_loadEcoffLib_SCNHDR_READ		(M_loadEcoffLib | 3)
#define S_loadEcoffLib_READ_SECTIONS		(M_loadEcoffLib | 4)
#define S_loadEcoffLib_LOAD_SECTIONS		(M_loadEcoffLib | 5)
#define S_loadEcoffLib_RELOC_READ		(M_loadEcoffLib | 6)
#define S_loadEcoffLib_SYMHDR_READ		(M_loadEcoffLib | 7)
#define S_loadEcoffLib_EXTSTR_READ		(M_loadEcoffLib | 8)
#define S_loadEcoffLib_EXTSYM_READ		(M_loadEcoffLib | 9)
#define S_loadEcoffLib_GPREL_REFERENCE		(M_loadEcoffLib | 10)
#define S_loadEcoffLib_JMPADDR_ERROR		(M_loadEcoffLib | 11)
#define S_loadEcoffLib_NO_REFLO_PAIR		(M_loadEcoffLib | 12)
#define S_loadEcoffLib_UNRECOGNIZED_RELOCENTRY	(M_loadEcoffLib | 13)
#define S_loadEcoffLib_REFHALF_OVFL		(M_loadEcoffLib | 14)
#define S_loadEcoffLib_UNEXPECTED_SYM_CLASS	(M_loadEcoffLib | 15)
#define S_loadEcoffLib_UNRECOGNIZED_SYM_CLASS	(M_loadEcoffLib | 16)
#define S_loadEcoffLib_FILE_READ_ERROR		(M_loadEcoffLib | 17)
#define S_loadEcoffLib_FILE_ENDIAN_ERROR	(M_loadEcoffLib | 18)
#define S_loadElfLib_HDR_READ			(M_loadElfLib | 1)
#define S_loadElfLib_HDR_ERROR			(M_loadElfLib | 2)
#define S_loadElfLib_PHDR_MALLOC		(M_loadElfLib | 3)
#define S_loadElfLib_PHDR_READ			(M_loadElfLib | 4)
#define S_loadElfLib_SHDR_MALLOC		(M_loadElfLib | 5)
#define S_loadElfLib_SHDR_READ			(M_loadElfLib | 6)
#define S_loadElfLib_READ_SECTIONS		(M_loadElfLib | 7)
#define S_loadElfLib_LOAD_SECTIONS		(M_loadElfLib | 8)
#define S_loadElfLib_LOAD_PROG			(M_loadElfLib | 9)
#define S_loadElfLib_SYMTAB			(M_loadElfLib | 10)
#define S_loadElfLib_RELA_SECTION		(M_loadElfLib | 11)
#define S_loadElfLib_SCN_READ			(M_loadElfLib | 12)
#define S_loadElfLib_SDA_MALLOC			(M_loadElfLib | 13)
#define S_loadElfLib_SST_READ			(M_loadElfLib | 15)
#define S_loadElfLib_JMPADDR_ERROR		(M_loadElfLib | 20)
#define S_loadElfLib_GPREL_REFERENCE		(M_loadElfLib | 21)
#define S_loadElfLib_UNRECOGNIZED_RELOCENTRY	(M_loadElfLib | 22)
#define S_loadElfLib_RELOC			(M_loadElfLib | 23)
#define S_loadElfLib_UNSUPPORTED		(M_loadElfLib | 24)
#define S_loadElfLib_REL_SECTION		(M_loadElfLib | 25)
#define S_loadLib_ROUTINE_NOT_INSTALLED		(M_loadLib | 1)
#define S_loadLib_TOO_MANY_SYMBOLS		(M_loadLib | 2)
#define S_loginLib_UNKNOWN_USER			(M_loginLib | 1)
#define S_loginLib_USER_ALREADY_EXISTS		(M_loginLib | 2)
#define S_loginLib_INVALID_PASSWORD		(M_loginLib | 3)
#define S_m2Lib_INVALID_PARAMETER               (M_m2Lib | 1)
#define S_m2Lib_ENTRY_NOT_FOUND			(M_m2Lib | 2)
#define S_m2Lib_TCPCONN_FD_NOT_FOUND		(M_m2Lib | 3)
#define S_m2Lib_INVALID_VAR_TO_SET		(M_m2Lib | 4)
#define S_m2Lib_CANT_CREATE_SYS_SEM		(M_m2Lib | 5)
#define S_m2Lib_CANT_CREATE_IF_SEM		(M_m2Lib | 6)
#define S_m2Lib_CANT_CREATE_ROUTE_SEM		(M_m2Lib | 7)
#define S_m2Lib_ARP_PHYSADDR_NOT_SPECIFIED	(M_m2Lib | 8)
#define S_m2Lib_IF_TBL_IS_EMPTY			(M_m2Lib | 9)
#define S_m2Lib_IF_CNFG_CHANGED			(M_m2Lib | 10)
#define	S_mbufLib_ID_INVALID		(M_mbufLib | 1)
#define	S_mbufLib_ID_EMPTY		(M_mbufLib | 2)
#define	S_mbufLib_SEGMENT_NOT_FOUND	(M_mbufLib | 3)
#define	S_mbufLib_LENGTH_INVALID	(M_mbufLib | 4)
#define	S_mbufLib_OFFSET_INVALID	(M_mbufLib | 5)
#define S_memLib_NOT_ENOUGH_MEMORY		(M_memLib | 1)
#define S_memLib_INVALID_NBYTES			(M_memLib | 2)
#define S_memLib_BLOCK_ERROR			(M_memLib | 3)
#define S_memLib_NO_PARTITION_DESTROY		(M_memLib | 4)
#define S_memLib_PAGE_SIZE_UNAVAILABLE		(M_memLib | 5)
#define	S_mmuLib_INVALID_PAGE_SIZE		(M_mmuLib | 1)
#define	S_mmuLib_NO_DESCRIPTOR			(M_mmuLib | 2)
#define	S_mmuLib_INVALID_DESCRIPTOR		(M_mmuLib | 3)
#define	S_mmuLib_OUT_OF_PMEGS			(M_mmuLib | 5)
#define	S_mmuLib_VIRT_ADDR_OUT_OF_BOUNDS	(M_mmuLib | 6)
#define S_moduleLib_MODULE_NOT_FOUND             (M_moduleLib | 1)
#define S_moduleLib_HOOK_NOT_FOUND               (M_moduleLib | 2)
#define S_moduleLib_BAD_CHECKSUM                 (M_moduleLib | 3)
#define S_moduleLib_MAX_MODULES_LOADED           (M_moduleLib | 4)
#define S_mountLib_ILLEGAL_MODE             (M_mountLib | 1)
#define S_msgQLib_INVALID_MSG_LENGTH		(M_msgQLib | 1)
#define S_msgQLib_NON_ZERO_TIMEOUT_AT_INT_LEVEL	(M_msgQLib | 2)
#define S_msgQLib_INVALID_QUEUE_TYPE		(M_msgQLib | 3)
#define S_netDrv_INVALID_NUMBER_OF_BYTES	(M_netDrv | 1)
#define S_netDrv_SEND_ERROR			(M_netDrv | 2)
#define S_netDrv_RECV_ERROR			(M_netDrv | 3)
#define S_netDrv_UNKNOWN_REQUEST		(M_netDrv | 4)
#define S_netDrv_BAD_SEEK			(M_netDrv | 5)
#define S_netDrv_SEEK_PAST_EOF_ERROR		(M_netDrv | 6)
#define S_netDrv_BAD_EOF_POSITION		(M_netDrv | 7)
#define S_netDrv_SEEK_FATAL_ERROR		(M_netDrv | 8)
#define	S_netDrv_WRITE_ONLY_CANNOT_READ		(M_netDrv | 9)
#define	S_netDrv_READ_ONLY_CANNOT_WRITE		(M_netDrv | 10)
#define	S_netDrv_READ_ERROR			(M_netDrv | 11)
#define S_netDrv_WRITE_ERROR			(M_netDrv | 12)
#define S_netDrv_NO_SUCH_FILE_OR_DIR		(M_netDrv | 13)
#define S_netDrv_PERMISSION_DENIED		(M_netDrv | 14)
#define S_netDrv_IS_A_DIRECTORY			(M_netDrv | 15)
#define S_netDrv_UNIX_FILE_ERROR		(M_netDrv | 16)
#define S_nfsDrv_INVALID_NUMBER_OF_BYTES	(M_nfsDrv | 1)
#define S_nfsDrv_BAD_FLAG_MODE			(M_nfsDrv | 2)
#define S_nfsDrv_CREATE_NO_FILE_NAME		(M_nfsDrv | 3)
#define	S_nfsDrv_FATAL_ERR_FLUSH_INVALID_CACHE	(M_nfsDrv | 4)
#define	S_nfsDrv_WRITE_ONLY_CANNOT_READ		(M_nfsDrv | 5)
#define	S_nfsDrv_READ_ONLY_CANNOT_WRITE		(M_nfsDrv | 6)
#define	S_nfsDrv_NOT_AN_NFS_DEVICE		(M_nfsDrv | 7)
#define	S_nfsDrv_NO_HOST_NAME_SPECIFIED		(M_nfsDrv | 8)
#define	S_nfsLib_NFS_AUTH_UNIX_FAILED		(M_nfsLib | 1)
#define	S_nfsLib_NFS_INAPPLICABLE_FILE_TYPE	(M_nfsLib | 2)
#define S_nfsLib_NFS_OK			(M_nfsStat | (int) NFS_OK)
#define S_nfsLib_NFSERR_PERM		(M_nfsStat | (int) NFSERR_PERM)
#define S_nfsLib_NFSERR_NOENT		(M_nfsStat | (int) NFSERR_NOENT)
#define S_nfsLib_NFSERR_IO		(M_nfsStat | (int) NFSERR_IO)
#define S_nfsLib_NFSERR_NXIO		(M_nfsStat | (int) NFSERR_NXIO)
#define S_nfsLib_NFSERR_ACCES		(M_nfsStat | (int) NFSERR_ACCES)
#define S_nfsLib_NFSERR_EXIST		(M_nfsStat | (int) NFSERR_EXIST)
#define S_nfsLib_NFSERR_NODEV		(M_nfsStat | (int) NFSERR_NODEV)
#define S_nfsLib_NFSERR_NOTDIR		(M_nfsStat | (int) NFSERR_NOTDIR)
#define S_nfsLib_NFSERR_ISDIR		(M_nfsStat | (int) NFSERR_ISDIR)
#define S_nfsLib_NFSERR_FBIG		(M_nfsStat | (int) NFSERR_FBIG)
#define S_nfsLib_NFSERR_NOSPC		(M_nfsStat | (int) NFSERR_NOSPC)
#define S_nfsLib_NFSERR_ROFS		(M_nfsStat | (int) NFSERR_ROFS)
#define S_nfsLib_NFSERR_NAMETOOLONG	(M_nfsStat | (int) NFSERR_NAMETOOLONG)
#define S_nfsLib_NFSERR_NOTEMPTY	(M_nfsStat | (int) NFSERR_NOTEMPTY)
#define S_nfsLib_NFSERR_DQUOT		(M_nfsStat | (int) NFSERR_DQUOT)
#define S_nfsLib_NFSERR_STALE		(M_nfsStat | (int) NFSERR_STALE)
#define S_nfsLib_NFSERR_WFLUSH		(M_nfsStat | (int) NFSERR_WFLUSH)
#define S_objLib_OBJ_ID_ERROR			(M_objLib | 1)
#define S_objLib_OBJ_UNAVAILABLE		(M_objLib | 2)
#define S_objLib_OBJ_DELETED			(M_objLib | 3)
#define S_objLib_OBJ_TIMEOUT			(M_objLib | 4)
#define S_objLib_OBJ_NO_METHOD			(M_objLib | 5)
#define	S_pingLib_NOT_INITIALIZED		(M_pingLib | 1)
#define	S_pingLib_TIMEOUT			(M_pingLib | 2)
#define	S_proxyArpLib_INVALID_PARAMETER		(M_proxyArpLib | 1)
#define S_proxyArpLib_INVALID_INTERFACE		(M_proxyArpLib | 2)
#define	S_proxyArpLib_INVALID_PROXY_NET		(M_proxyArpLib | 3)
#define	S_proxyArpLib_INVALID_CLIENT		(M_proxyArpLib | 4)
#define S_proxyArpLib_INVALID_ADDRESS		(M_proxyArpLib | 5)
#define S_proxyArpLib_TIMEOUT			(M_proxyArpLib | 6)
#define S_qLib_Q_CLASS_ID_ERROR			(M_qLib | 1)
#define S_qPriBMapLib_NULL_BMAP_LIST		(M_qPriBMapLib | 1)
#define S_qPriHeapLib_NULL_HEAP_ARRAY		(M_qPriHeapLib | 1)
#define S_rawFsLib_VOLUME_NOT_AVAILABLE		(M_rawFsLib | 1)
#define S_rawFsLib_END_OF_DEVICE		(M_rawFsLib | 2)
#define S_rawFsLib_NO_FREE_FILE_DESCRIPTORS	(M_rawFsLib | 3)
#define S_rawFsLib_INVALID_NUMBER_OF_BYTES	(M_rawFsLib | 4)
#define S_rawFsLib_ILLEGAL_NAME			(M_rawFsLib | 5)
#define S_rawFsLib_NOT_FILE			(M_rawFsLib | 6)
#define S_rawFsLib_READ_ONLY			(M_rawFsLib | 7)
#define S_rawFsLib_FD_OBSOLETE			(M_rawFsLib | 8)
#define S_rawFsLib_NO_BLOCK_DEVICE		(M_rawFsLib | 9)
#define S_rawFsLib_BAD_SEEK			(M_rawFsLib | 10)
#define S_remLib_ALL_PORTS_IN_USE		(M_remLib | 1)
#define S_remLib_RSH_ERROR			(M_remLib | 2)
#define S_remLib_IDENTITY_TOO_BIG		(M_remLib | 3)
#define S_routeLib_ILLEGAL_INTERNET_ADDRESS		(M_routeLib | 1)
#define S_routeLib_ILLEGAL_NETWORK_NUMBER		(M_routeLib | 2)
#define S_rpcLib_RPC_SUCCESS		(M_rpcClntStat | (int) RPC_SUCCESS)
#define S_rpcLib_RPC_CANTENCODEARGS	(M_rpcClntStat | (int) RPC_CANTENCODEARGS)
#define S_rpcLib_RPC_CANTDECODERES	(M_rpcClntStat | (int) RPC_CANTDECODERES)
#define S_rpcLib_RPC_CANTSEND		(M_rpcClntStat | (int) RPC_CANTSEND)
#define S_rpcLib_RPC_CANTRECV		(M_rpcClntStat | (int) RPC_CANTRECV)
#define S_rpcLib_RPC_TIMEDOUT		(M_rpcClntStat | (int) RPC_TIMEDOUT)
#define S_rpcLib_RPC_VERSMISMATCH	(M_rpcClntStat | (int) RPC_VERSMISMATCH)
#define S_rpcLib_RPC_AUTHERROR		(M_rpcClntStat | (int) RPC_AUTHERROR)
#define S_rpcLib_RPC_PROGUNAVAIL	(M_rpcClntStat | (int) RPC_PROGUNAVAIL)
#define S_rpcLib_RPC_PROGVERSMISMATCH	(M_rpcClntStat | (int) RPC_PROGVERSMISMATCH)
#define S_rpcLib_RPC_PROCUNAVAIL	(M_rpcClntStat | (int) RPC_PROCUNAVAIL)
#define S_rpcLib_RPC_CANTDECODEARGS	(M_rpcClntStat | (int) RPC_CANTDECODEARGS)
#define S_rpcLib_RPC_SYSTEMERROR	(M_rpcClntStat | (int) RPC_SYSTEMERROR)
#define S_rpcLib_RPC_UNKNOWNHOST	(M_rpcClntStat | (int) RPC_UNKNOWNHOST)
#define S_rpcLib_RPC_PMAPFAILURE	(M_rpcClntStat | (int) RPC_PMAPFAILURE)
#define S_rpcLib_RPC_PROGNOTREGISTERED	(M_rpcClntStat | (int) RPC_PROGNOTREGISTERED)
#define S_rpcLib_RPC_FAILED		(M_rpcClntStat | (int) RPC_FAILED)
#define S_rt11FsLib_VOLUME_NOT_AVAILABLE		(M_rt11FsLib | 1)
#define S_rt11FsLib_DISK_FULL				(M_rt11FsLib | 2)
#define S_rt11FsLib_FILE_NOT_FOUND			(M_rt11FsLib | 3)
#define S_rt11FsLib_NO_FREE_FILE_DESCRIPTORS		(M_rt11FsLib | 4)
#define S_rt11FsLib_INVALID_NUMBER_OF_BYTES		(M_rt11FsLib | 5)
#define S_rt11FsLib_FILE_ALREADY_EXISTS			(M_rt11FsLib | 6)
#define S_rt11FsLib_BEYOND_FILE_LIMIT			(M_rt11FsLib | 7)
#define S_rt11FsLib_INVALID_DEVICE_PARAMETERS		(M_rt11FsLib | 8)
#define S_rt11FsLib_NO_MORE_FILES_ALLOWED_ON_DISK	(M_rt11FsLib | 9)
#define	S_rt11FsLib_ENTRY_NUMBER_TOO_BIG		(M_rt11FsLib | 10)
#define	S_rt11FsLib_NO_BLOCK_DEVICE			(M_rt11FsLib | 11)
#define S_scsiLib_DEV_NOT_READY		(M_scsiLib | 1)
#define S_scsiLib_WRITE_PROTECTED	(M_scsiLib | 2)
#define S_scsiLib_MEDIUM_ERROR		(M_scsiLib | 3)
#define S_scsiLib_HARDWARE_ERROR	(M_scsiLib | 4)
#define S_scsiLib_ILLEGAL_REQUEST	(M_scsiLib | 5)
#define S_scsiLib_BLANK_CHECK		(M_scsiLib | 6)
#define S_scsiLib_ABORTED_COMMAND	(M_scsiLib | 7)
#define S_scsiLib_VOLUME_OVERFLOW	(M_scsiLib | 8)
#define S_scsiLib_UNIT_ATTENTION	(M_scsiLib | 9)
#define S_scsiLib_SELECT_TIMEOUT	(M_scsiLib | 10)
#define S_scsiLib_LUN_NOT_PRESENT	(M_scsiLib | 11)
#define S_scsiLib_ILLEGAL_BUS_ID	(M_scsiLib | 12)
#define S_scsiLib_NO_CONTROLLER		(M_scsiLib | 13)
#define S_scsiLib_REQ_SENSE_ERROR	(M_scsiLib | 14)
#define S_scsiLib_DEV_UNSUPPORTED	(M_scsiLib | 15)
#define S_scsiLib_ILLEGAL_PARAMETER	(M_scsiLib | 16)
#define S_scsiLib_EARLY_PHASE_CHANGE	(M_scsiLib | 17)
#define S_scsiLib_PHASE_CHANGE_TIMEOUT	(M_scsiLib | 18)
#define S_scsiLib_ILLEGAL_OPERATION	(M_scsiLib | 19)
#define S_scsiLib_DEVICE_EXIST          (M_scsiLib | 20)
#define S_scsiLib_SYNC_UNSUPPORTED      (M_scsiLib | 21)
#define S_scsiLib_SYNC_VAL_UNSUPPORTED  (M_scsiLib | 22)
#define	S_scsiLib_DATA_TRANSFER_TIMEOUT	(M_scsiLib | 23)
#define	S_scsiLib_UNKNOWN_PHASE		(M_scsiLib | 24)
#define S_scsiLib_DEV_NOT_READY		(M_scsiLib | 1)
#define S_scsiLib_WRITE_PROTECTED	(M_scsiLib | 2)
#define S_scsiLib_MEDIUM_ERROR		(M_scsiLib | 3)
#define S_scsiLib_HARDWARE_ERROR	(M_scsiLib | 4)
#define S_scsiLib_ILLEGAL_REQUEST	(M_scsiLib | 5)
#define S_scsiLib_BLANK_CHECK		(M_scsiLib | 6)
#define S_scsiLib_ABORTED_COMMAND	(M_scsiLib | 7)
#define S_scsiLib_VOLUME_OVERFLOW	(M_scsiLib | 8)
#define S_scsiLib_UNIT_ATTENTION	(M_scsiLib | 9)
#define S_scsiLib_SELECT_TIMEOUT	(M_scsiLib | 10)
#define S_scsiLib_LUN_NOT_PRESENT	(M_scsiLib | 11)
#define S_scsiLib_ILLEGAL_BUS_ID	(M_scsiLib | 12)
#define S_scsiLib_NO_CONTROLLER		(M_scsiLib | 13)
#define S_scsiLib_REQ_SENSE_ERROR	(M_scsiLib | 14)
#define S_scsiLib_DEV_UNSUPPORTED	(M_scsiLib | 15)
#define S_scsiLib_ILLEGAL_PARAMETER	(M_scsiLib | 16)
#define S_scsiLib_INVALID_PHASE		(M_scsiLib | 17)
#define S_scsiLib_ABORTED   		(M_scsiLib | 18)
#define S_scsiLib_ILLEGAL_OPERATION	(M_scsiLib | 19)
#define S_scsiLib_DEVICE_EXIST	    	(M_scsiLib | 20)
#define S_scsiLib_DISCONNECTED	    	(M_scsiLib | 21)
#define S_scsiLib_BUS_RESET	    	(M_scsiLib | 22)
#define	S_scsiLib_INVALID_TAG_TYPE  	(M_scsiLib | 23)
#define	S_scsiLib_SOFTWARE_ERROR    	(M_scsiLib | 24)
#define	S_scsiLib_NO_MORE_THREADS   	(M_scsiLib | 25)
#define	S_scsiLib_UNKNOWN_SENSE_DATA	(M_scsiLib | 26)
#define	S_scsiLib_INVALID_BLOCK_SIZE	(M_scsiLib | 27)
#define S_selectLib_NO_SELECT_SUPPORT_IN_DRIVER  (M_selectLib | 1)
#define S_semLib_INVALID_STATE			(M_semLib | 101)
#define S_semLib_INVALID_OPTION			(M_semLib | 102)
#define S_semLib_INVALID_QUEUE_TYPE		(M_semLib | 103)
#define S_semLib_INVALID_OPERATION		(M_semLib | 104)
#define S_smLib_MEMORY_ERROR			(M_smLib | 1)
#define S_smLib_INVALID_CPU_NUMBER		(M_smLib | 2)
#define S_smLib_NOT_ATTACHED			(M_smLib | 3)
#define S_smLib_NO_REGIONS			(M_smLib | 4)
#define S_smNameLib_NOT_INITIALIZED           (M_smNameLib | 1)
#define S_smNameLib_NAME_TOO_LONG             (M_smNameLib | 2)
#define S_smNameLib_NAME_NOT_FOUND            (M_smNameLib | 3)
#define S_smNameLib_VALUE_NOT_FOUND           (M_smNameLib | 4)
#define S_smNameLib_NAME_ALREADY_EXIST        (M_smNameLib | 5)
#define S_smNameLib_DATABASE_FULL             (M_smNameLib | 6)
#define S_smNameLib_INVALID_WAIT_TYPE         (M_smNameLib | 7)
#define S_smObjLib_NOT_INITIALIZED        (M_smObjLib | 1)
#define S_smObjLib_NOT_A_GLOBAL_ADRS      (M_smObjLib | 2)
#define S_smObjLib_NOT_A_LOCAL_ADRS       (M_smObjLib | 3)
#define S_smObjLib_SHARED_MEM_TOO_SMALL   (M_smObjLib | 4)
#define S_smObjLib_TOO_MANY_CPU           (M_smObjLib | 5)
#define S_smObjLib_LOCK_TIMEOUT           (M_smObjLib | 6)
#define S_smObjLib_NO_OBJECT_DESTROY      (M_smObjLib | 7)
#define S_smPktLib_SHARED_MEM_TOO_SMALL		(M_smPktLib | 1)
#define S_smPktLib_MEMORY_ERROR			(M_smPktLib | 2)
#define S_smPktLib_DOWN				(M_smPktLib | 3)
#define S_smPktLib_NOT_ATTACHED			(M_smPktLib | 4)
#define S_smPktLib_INVALID_PACKET		(M_smPktLib | 5)
#define S_smPktLib_PACKET_TOO_BIG		(M_smPktLib | 6)
#define S_smPktLib_INVALID_CPU_NUMBER		(M_smPktLib | 7)
#define S_smPktLib_DEST_NOT_ATTACHED		(M_smPktLib | 8)
#define S_smPktLib_INCOMPLETE_BROADCAST		(M_smPktLib | 9)
#define S_smPktLib_LIST_FULL			(M_smPktLib | 10)
#define S_smPktLib_LOCK_TIMEOUT			(M_smPktLib | 11)
#define S_snmpdLib_VIEW_CREATE_FAILURE    (M_snmpdLib | 1)
#define S_snmpdLib_VIEW_INSTALL_FAILURE   (M_snmpdLib | 2)
#define S_snmpdLib_VIEW_MASK_FAILURE      (M_snmpdLib | 3)
#define S_snmpdLib_VIEW_DEINSTALL_FAILURE (M_snmpdLib | 4)
#define S_snmpdLib_VIEW_LOOKUP_FAILURE    (M_snmpdLib | 5)
#define S_snmpdLib_MIB_ADDITION_FAILURE   (M_snmpdLib | 6)
#define S_snmpdLib_NODE_NOT_FOUND         (M_snmpdLib | 7)
#define S_snmpdLib_INVALID_SNMP_VERSION   (M_snmpdLib | 8)
#define S_snmpdLib_TRAP_CREATE_FAILURE    (M_snmpdLib | 9)
#define S_snmpdLib_TRAP_BIND_FAILURE      (M_snmpdLib | 10)
#define S_snmpdLib_TRAP_ENCODE_FAILURE    (M_snmpdLib | 11)
#define S_snmpdLib_INVALID_OID_SYNTAX     (M_snmpdLib | 12)
#define S_strmLib_DUPLICATE_PROVIDER      	         (M_strmLib | 1)
#define S_strmLib_INVALID_OPEN_STYLE      	         (M_strmLib | 2)
#define S_strmLib_INVALID_SYNC_LEVEL      	         (M_strmLib | 3)
#define S_symLib_SYMBOL_NOT_FOUND	(M_symLib | 1)
#define S_symLib_NAME_CLASH		(M_symLib | 2)
#define S_symLib_TABLE_NOT_EMPTY	(M_symLib | 3)
#define S_symLib_SYMBOL_STILL_IN_TABLE	(M_symLib | 4)
#define S_tapeFsLib_NO_SEQ_DEV 			(M_tapeFsLib | 1)
#define S_tapeFsLib_ILLEGAL_TAPE_CONFIG_PARM 	(M_tapeFsLib | 2)
#define S_tapeFsLib_SERVICE_NOT_AVAILABLE	(M_tapeFsLib | 3)
#define S_tapeFsLib_INVALID_BLOCK_SIZE		(M_tapeFsLib | 4)
#define S_tapeFsLib_ILLEGAL_FILE_SYSTEM_NAME	(M_tapeFsLib | 5)
#define S_tapeFsLib_ILLEGAL_FLAGS		(M_tapeFsLib | 6)
#define S_tapeFsLib_FILE_DESCRIPTOR_BUSY	(M_tapeFsLib | 7)
#define S_tapeFsLib_VOLUME_NOT_AVAILABLE	(M_tapeFsLib | 8)
#define S_tapeFsLib_BLOCK_SIZE_MISMATCH		(M_tapeFsLib | 9)
#define S_tapeFsLib_INVALID_NUMBER_OF_BYTES	(M_tapeFsLib | 10)
#define S_taskLib_NAME_NOT_FOUND		(M_taskLib | 101)
#define S_taskLib_TASK_HOOK_TABLE_FULL		(M_taskLib | 102)
#define S_taskLib_TASK_HOOK_NOT_FOUND		(M_taskLib | 103)
#define S_taskLib_TASK_SWAP_HOOK_REFERENCED	(M_taskLib | 104)
#define S_taskLib_TASK_SWAP_HOOK_SET		(M_taskLib | 105)
#define S_taskLib_TASK_SWAP_HOOK_CLEAR		(M_taskLib | 106)
#define S_taskLib_TASK_VAR_NOT_FOUND		(M_taskLib | 107)
#define S_taskLib_TASK_UNDELAYED		(M_taskLib | 108)
#define S_taskLib_ILLEGAL_PRIORITY		(M_taskLib | 109)
#define S_tftpLib_INVALID_ARGUMENT	(M_tftpLib | 1)
#define S_tftpLib_INVALID_DESCRIPTOR	(M_tftpLib | 2)
#define S_tftpLib_INVALID_COMMAND	(M_tftpLib | 3)
#define S_tftpLib_INVALID_MODE		(M_tftpLib | 4)
#define S_tftpLib_UNKNOWN_HOST		(M_tftpLib | 5)
#define S_tftpLib_NOT_CONNECTED		(M_tftpLib | 6)
#define S_tftpLib_TIMED_OUT		(M_tftpLib | 7)
#define S_tftpLib_TFTP_ERROR		(M_tftpLib | 8)
#define S_unldLib_MODULE_NOT_FOUND             (M_unldLib | 1)
#define S_unldLib_TEXT_IN_USE                  (M_unldLib | 2)
#define S_usrLib_NOT_ENOUGH_ARGS	(M_usrLib | 1)
#define S_vmLib_NOT_PAGE_ALIGNED		(M_vmLib | 1)
#define S_vmLib_BAD_STATE_PARAM			(M_vmLib | 2)
#define S_vmLib_BAD_MASK_PARAM			(M_vmLib | 3)
#define S_vmLib_ADDR_IN_GLOBAL_SPACE		(M_vmLib | 4)
#define S_vmLib_TEXT_PROTECTION_UNAVAILABLE	(M_vmLib | 5)
#define	EPERM		1		/* Not owner */
#define	ENOENT		2		/* No such file or directory */
#define	ESRCH		3		/* No such process */
#define	EINTR		4		/* Interrupted system call */
#define	EIO		5		/* I/O error */
#define	ENXIO		6		/* No such device or address */
#define	E2BIG		7		/* Arg list too long */
#define	ENOEXEC		8		/* Exec format error */
#define	EBADF		9		/* Bad file number */
#define	ECHILD		10		/* No children */
#define	EAGAIN		11		/* No more processes */
#define	ENOMEM		12		/* Not enough core */
#define	EACCES		13		/* Permission denied */
#define	EFAULT		14		/* Bad address */
#define	ENOTEMPTY	15		/* Directory not empty */
#define	EBUSY		16		/* Mount device busy */
#define	EEXIST		17		/* File exists */
#define	EXDEV		18		/* Cross-device link */
#define	ENODEV		19		/* No such device */
#define	ENOTDIR		20		/* Not a directory*/
#define	EISDIR		21		/* Is a directory */
#define	EINVAL		22		/* Invalid argument */
#define	ENFILE		23		/* File table overflow */
#define	EMFILE		24		/* Too many open files */
#define	ENOTTY		25		/* Not a typewriter */
#define	ENAMETOOLONG	26		/* File name too long */
#define	EFBIG		27		/* File too large */
#define	ENOSPC		28		/* No space left on device */
#define	ESPIPE		29		/* Illegal seek */
#define	EROFS		30		/* Read-only file system */
#define	EMLINK		31		/* Too many links */
#define	EPIPE		32		/* Broken pipe */
#define	EDEADLK		33		/* Resource deadlock avoided */
#define	ENOLCK		34		/* No locks available */
#define	ENOTSUP		35		/* Unsupported value */
#define	EMSGSIZE	36		/* Message size */
#define	EDOM		37		/* Argument too large */
#define	ERANGE		38		/* Result too large */
#define	EDESTADDRREQ	40		/* Destination address required */
#define	EPROTOTYPE	41		/* Protocol wrong type for socket */
#define	ENOPROTOOPT	42		/* Protocol not available */
#define	EPROTONOSUPPORT	43		/* Protocol not supported */
#define	ESOCKTNOSUPPORT	44		/* Socket type not supported */
#define	EOPNOTSUPP	45		/* Operation not supported on socket */
#define	EPFNOSUPPORT	46		/* Protocol family not supported */
#define	EAFNOSUPPORT	47		/* Addr family not supported */
#define	EADDRINUSE	48		/* Address already in use */
#define	EADDRNOTAVAIL	49		/* Can't assign requested address */
#define	ENOTSOCK	50		/* Socket operation on non-socket */
#define	ENETUNREACH	51		/* Network is unreachable */
#define	ENETRESET	52		/* Network dropped connection on reset*/
#define	ECONNABORTED	53		/* Software caused connection abort */
#define	ECONNRESET	54		/* Connection reset by peer */
#define	ENOBUFS		55		/* No buffer space available */
#define	EISCONN		56		/* Socket is already connected */
#define	ENOTCONN	57		/* Socket is not connected */
#define	ESHUTDOWN	58		/* Can't send after socket shutdown */
#define	ETOOMANYREFS	59		/* Too many references: can't splice */
#define	ETIMEDOUT	60		/* Connection timed out */
#define	ECONNREFUSED	61		/* Connection refused */
#define	ENETDOWN	62		/* Network is down */
#define	ETXTBSY		63		/* Text file busy */
#define	ELOOP		64		/* Too many levels of symbolic links */
#define	EHOSTUNREACH	65		/* No route to host */
#define	ENOTBLK		66		/* Block device required */
#define	EHOSTDOWN	67		/* Host is down */
#define	EINPROGRESS	68		/* Operation now in progress */
#define	EALREADY	69		/* Operation already in progress */
#define	EWOULDBLOCK	70		/* Operation would block */
#define	ENOSYS		71		/* Function not implemented */
#define	ECANCELED	72		/* Operation canceled */
#define	ERRMAX		73
#define ENOSR		74
#define ENOSTR		75
#define EPROTO		76
#define EBADMSG		77
#define ENODATA		78
#define ETIME		79
#define ENOMSG		80

SYMBOL statTbl [] =
    {
    {{NULL},"S_errno_EPERM", (char *) (M_errno | EPERM),0},
    {{NULL},"S_errno_ENOENT", (char *) (M_errno | ENOENT),0},
    {{NULL},"S_errno_ESRCH", (char *) (M_errno | ESRCH),0},
    {{NULL},"S_errno_EINTR", (char *) (M_errno | EINTR),0},
    {{NULL},"S_errno_EIO", (char *) (M_errno | EIO),0},
    {{NULL},"S_errno_ENXIO", (char *) (M_errno | ENXIO),0},
    {{NULL},"S_errno_E2BIG", (char *) (M_errno | E2BIG),0},
    {{NULL},"S_errno_ENOEXEC", (char *) (M_errno | ENOEXEC),0},
    {{NULL},"S_errno_EBADF", (char *) (M_errno | EBADF),0},
    {{NULL},"S_errno_ECHILD", (char *) (M_errno | ECHILD),0},
    {{NULL},"S_errno_EAGAIN", (char *) (M_errno | EAGAIN),0},
    {{NULL},"S_errno_ENOMEM", (char *) (M_errno | ENOMEM),0},
    {{NULL},"S_errno_EACCES", (char *) (M_errno | EACCES),0},
    {{NULL},"S_errno_EFAULT", (char *) (M_errno | EFAULT),0},
    {{NULL},"S_errno_ENOTEMPTY", (char *) (M_errno | ENOTEMPTY),0},
    {{NULL},"S_errno_EBUSY", (char *) (M_errno | EBUSY),0},
    {{NULL},"S_errno_EEXIST", (char *) (M_errno | EEXIST),0},
    {{NULL},"S_errno_EXDEV", (char *) (M_errno | EXDEV),0},
    {{NULL},"S_errno_ENODEV", (char *) (M_errno | ENODEV),0},
    {{NULL},"S_errno_ENOTDIR", (char *) (M_errno | ENOTDIR),0},
    {{NULL},"S_errno_EISDIR", (char *) (M_errno | EISDIR),0},
    {{NULL},"S_errno_EINVAL", (char *) (M_errno | EINVAL),0},
    {{NULL},"S_errno_ENFILE", (char *) (M_errno | ENFILE),0},
    {{NULL},"S_errno_EMFILE", (char *) (M_errno | EMFILE),0},
    {{NULL},"S_errno_ENOTTY", (char *) (M_errno | ENOTTY),0},
    {{NULL},"S_errno_ENAMETOOLONG", (char *) (M_errno | ENAMETOOLONG),0},
    {{NULL},"S_errno_EFBIG", (char *) (M_errno | EFBIG),0},
    {{NULL},"S_errno_ENOSPC", (char *) (M_errno | ENOSPC),0},
    {{NULL},"S_errno_ESPIPE", (char *) (M_errno | ESPIPE),0},
    {{NULL},"S_errno_EROFS", (char *) (M_errno | EROFS),0},
    {{NULL},"S_errno_EMLINK", (char *) (M_errno | EMLINK),0},
    {{NULL},"S_errno_EPIPE", (char *) (M_errno | EPIPE),0},
    {{NULL},"S_errno_EDEADLK", (char *) (M_errno | EDEADLK),0},
    {{NULL},"S_errno_ENOLCK", (char *) (M_errno | ENOLCK),0},
    {{NULL},"S_errno_ENOTSUP", (char *) (M_errno | ENOTSUP),0},
    {{NULL},"S_errno_EMSGSIZE", (char *) (M_errno | EMSGSIZE),0},
    {{NULL},"S_errno_EDOM", (char *) (M_errno | EDOM),0},
    {{NULL},"S_errno_ERANGE", (char *) (M_errno | ERANGE),0},
    {{NULL},"S_errno_EDESTADDRREQ", (char *) (M_errno | EDESTADDRREQ),0},
    {{NULL},"S_errno_EPROTOTYPE", (char *) (M_errno | EPROTOTYPE),0},
    {{NULL},"S_errno_ENOPROTOOPT", (char *) (M_errno | ENOPROTOOPT),0},
    {{NULL},"S_errno_EPROTONOSUPPORT", (char *) (M_errno | EPROTONOSUPPORT),0},
    {{NULL},"S_errno_ESOCKTNOSUPPORT", (char *) (M_errno | ESOCKTNOSUPPORT),0},
    {{NULL},"S_errno_EOPNOTSUPP", (char *) (M_errno | EOPNOTSUPP),0},
    {{NULL},"S_errno_EPFNOSUPPORT", (char *) (M_errno | EPFNOSUPPORT),0},
    {{NULL},"S_errno_EAFNOSUPPORT", (char *) (M_errno | EAFNOSUPPORT),0},
    {{NULL},"S_errno_EADDRINUSE", (char *) (M_errno | EADDRINUSE),0},
    {{NULL},"S_errno_EADDRNOTAVAIL", (char *) (M_errno | EADDRNOTAVAIL),0},
    {{NULL},"S_errno_ENOTSOCK", (char *) (M_errno | ENOTSOCK),0},
    {{NULL},"S_errno_ENETUNREACH", (char *) (M_errno | ENETUNREACH),0},
    {{NULL},"S_errno_ENETRESET", (char *) (M_errno | ENETRESET),0},
    {{NULL},"S_errno_ECONNABORTED", (char *) (M_errno | ECONNABORTED),0},
    {{NULL},"S_errno_ECONNRESET", (char *) (M_errno | ECONNRESET),0},
    {{NULL},"S_errno_ENOBUFS", (char *) (M_errno | ENOBUFS),0},
    {{NULL},"S_errno_EISCONN", (char *) (M_errno | EISCONN),0},
    {{NULL},"S_errno_ENOTCONN", (char *) (M_errno | ENOTCONN),0},
    {{NULL},"S_errno_ESHUTDOWN", (char *) (M_errno | ESHUTDOWN),0},
    {{NULL},"S_errno_ETOOMANYREFS", (char *) (M_errno | ETOOMANYREFS),0},
    {{NULL},"S_errno_ETIMEDOUT", (char *) (M_errno | ETIMEDOUT),0},
    {{NULL},"S_errno_ECONNREFUSED", (char *) (M_errno | ECONNREFUSED),0},
    {{NULL},"S_errno_ENETDOWN", (char *) (M_errno | ENETDOWN),0},
    {{NULL},"S_errno_ETXTBSY", (char *) (M_errno | ETXTBSY),0},
    {{NULL},"S_errno_ELOOP", (char *) (M_errno | ELOOP),0},
    {{NULL},"S_errno_EHOSTUNREACH", (char *) (M_errno | EHOSTUNREACH),0},
    {{NULL},"S_errno_ENOTBLK", (char *) (M_errno | ENOTBLK),0},
    {{NULL},"S_errno_EHOSTDOWN", (char *) (M_errno | EHOSTDOWN),0},
    {{NULL},"S_errno_EINPROGRESS", (char *) (M_errno | EINPROGRESS),0},
    {{NULL},"S_errno_EALREADY", (char *) (M_errno | EALREADY),0},
    {{NULL},"S_errno_EWOULDBLOCK", (char *) (M_errno | EWOULDBLOCK),0},
    {{NULL},"S_errno_ENOSYS", (char *) (M_errno | ENOSYS),0},
    {{NULL},"S_errno_ECANCELED", (char *) (M_errno | ECANCELED),0},
    {{NULL},"S_errno_ERRMAX", (char *) (M_errno | ERRMAX),0},
    {{NULL},"S_errno_ENOSR", (char *) (M_errno | ENOSR),0},
    {{NULL},"S_errno_ENOSTR", (char *) (M_errno | ENOSTR),0},
    {{NULL},"S_errno_EPROTO", (char *) (M_errno | EPROTO),0},
    {{NULL},"S_errno_EBADMSG", (char *) (M_errno | EBADMSG),0},
    {{NULL},"S_errno_ENODATA", (char *) (M_errno | ENODATA),0},
    {{NULL},"S_errno_ETIME", (char *) (M_errno | ETIME),0},
    {{NULL},"S_errno_ENOMSG", (char *) (M_errno | ENOMSG),0},
    {{NULL},"S_sched_SCHEDULER_NOT_INITIALIZED", (char *) S_sched_SCHEDULER_NOT_INITIALIZED,0},
    {{NULL},"S_sched_NULL_TASK_EXEC_FUNCTION_POINTER", (char *) S_sched_NULL_TASK_EXEC_FUNCTION_POINTER,0},
    {{NULL},"S_sched_ILLEGAL_TASK_PERIOD", (char *) S_sched_ILLEGAL_TASK_PERIOD,0},
    {{NULL},"S_sched_SCHEDULER_ALREADY_INITIALIZED", (char *) S_sched_SCHEDULER_ALREADY_INITIALIZED,0},
    {{NULL},"S_sched_MAX_TASKS_EXCEEDED", (char *) S_sched_MAX_TASKS_EXCEEDED,0},
    {{NULL},"S_sched_INVALID_PRIORITY", (char *) S_sched_INVALID_PRIORITY,0},
    {{NULL},"S_sched_ILLEGAL_TASK_OFFSET", (char *) S_sched_ILLEGAL_TASK_OFFSET,0},
    {{NULL},"S_sched_OUT_OF_TCB_POINTERS", (char *) S_sched_OUT_OF_TCB_POINTERS,0},
    {{NULL},"S_sched_INVALID_VALUE_FOR_MAXTASKS", (char *) S_sched_INVALID_VALUE_FOR_MAXTASKS,0},
    {{NULL},"S_sched_INSUFFICIENT_MEMORY", (char *) S_sched_INSUFFICIENT_MEMORY,0},
    {{NULL},"S_sched_NOT_ENABLED", (char *) S_sched_NOT_ENABLED,0},
    {{NULL},"S_sched_INVALID_TASK_MODE", (char *) S_sched_INVALID_TASK_MODE,0},
    {{NULL},"S_sched_INVALID_TASK_ID", (char *) S_sched_INVALID_TASK_ID,0},
    {{NULL},"S_sched_TASK_STARVING", (char *) S_sched_TASK_STARVING,0},
    {{NULL},"S_sched_UNEXPECTED_TASK_MODE", (char *) S_sched_UNEXPECTED_TASK_MODE,0},
    {{NULL},"S_sched_TASK_HAS_PANICKED", (char *) S_sched_TASK_HAS_PANICKED,0},
    {{NULL},"S_sched_ENTERING_ADD_TASK", (char *) S_sched_ENTERING_ADD_TASK,0},
    {{NULL},"S_sched_PERIOD_AND_OFFSET_SET", (char *) S_sched_PERIOD_AND_OFFSET_SET,0},
    {{NULL},"S_sched_JUST_ISSUED_TASK_LOCK", (char *) S_sched_JUST_ISSUED_TASK_LOCK,0},
    {{NULL},"S_sched_JUST_INSERTED_NEW_TCB", (char *) S_sched_JUST_INSERTED_NEW_TCB,0},
    {{NULL},"S_sched_JUST_SPAWNED_NEW_TASKSKEL", (char *) S_sched_JUST_SPAWNED_NEW_TASKSKEL,0},
    {{NULL},"S_sched_LEAVING_ADD_TASK", (char *) S_sched_LEAVING_ADD_TASK,0},
    {{NULL},"S_sched_ENTERING_INIT", (char *) S_sched_ENTERING_INIT,0},
    {{NULL},"S_sched_ADJUSTED_VXWORKS_TASK_PRIOS", (char *) S_sched_ADJUSTED_VXWORKS_TASK_PRIOS,0},
    {{NULL},"S_sched_TASK_SET_INITIALIZED", (char *) S_sched_TASK_SET_INITIALIZED,0},
    {{NULL},"S_sched_CONNECTED_INTERRUPT_TO_SCHEDISR", (char *) S_sched_CONNECTED_INTERRUPT_TO_SCHEDISR,0},
    {{NULL},"S_sched_LEAVING_INIT", (char *) S_sched_LEAVING_INIT,0},
    {{NULL},"S_sched_IN_TASKSKEL", (char *) S_sched_IN_TASKSKEL,0},
    {{NULL},"S_sched_ENTERING_REMOVETASK", (char *) S_sched_ENTERING_REMOVETASK,0},
    {{NULL},"S_sched_TASK_PERIOD_SET", (char *) S_sched_TASK_PERIOD_SET,0},
    {{NULL},"S_sched_TASK_OFFSET_SET", (char *) S_sched_TASK_OFFSET_SET,0},
    {{NULL},"S_sched_FOUND_EMPTY_TASK_PTR_TO_USE", (char *) S_sched_FOUND_EMPTY_TASK_PTR_TO_USE,0},
    {{NULL},"S_sched_DISABLED_SCHEDULER_IN_ADDTASK", (char *) S_sched_DISABLED_SCHEDULER_IN_ADDTASK,0},
    {{NULL},"S_sched_FOUND_WHERE_TO_INSERT_TCB", (char *) S_sched_FOUND_WHERE_TO_INSERT_TCB,0},
    {{NULL},"S_sched_MADE_SPACE_TO_INSERT_TCB", (char *) S_sched_MADE_SPACE_TO_INSERT_TCB,0},
    {{NULL},"S_sched_ABOUT_TO_DISABLE_SCHEDULER", (char *) S_sched_ABOUT_TO_DISABLE_SCHEDULER,0},
    {{NULL},"S_sched_ABOUT_TO_ENABLE_SCHEDULER", (char *) S_sched_ABOUT_TO_ENABLE_SCHEDULER,0},
    {{NULL},"S_sched_ABOUT_TO_DISABLE_A_TASK", (char *) S_sched_ABOUT_TO_DISABLE_A_TASK,0},
    {{NULL},"S_sched_ABOUT_TO_ENABLE_A_TASK", (char *) S_sched_ABOUT_TO_ENABLE_A_TASK,0},
    {{NULL},"S_sched_ABOUT_TO_DELETE_A_TASK", (char *) S_sched_ABOUT_TO_DELETE_A_TASK,0},
    {{NULL},"S_baseObject_ALREADY_INITIALIZED", (char *) S_baseObject_ALREADY_INITIALIZED,0},
    {{NULL},"S_baseObject_ALREADY_SHUTDOWN", (char *) S_baseObject_ALREADY_SHUTDOWN,0},
    {{NULL},"S_cmdhdlr_CANT_ALLOCATE_COMMAND_STREAMS", (char *) S_cmdhdlr_CANT_ALLOCATE_COMMAND_STREAMS,0},
    {{NULL},"S_cmdhdlr_INVALID_CMD_STREAM", (char *) S_cmdhdlr_INVALID_CMD_STREAM,0},
    {{NULL},"S_cmdhdlr_INVALID_GIZMO_ID", (char *) S_cmdhdlr_INVALID_GIZMO_ID,0},
    {{NULL},"S_cmdhdlr_ALREADY_INITIALIZED", (char *) S_cmdhdlr_ALREADY_INITIALIZED,0},
    {{NULL},"S_cmdhdlr_ALREADY_SHUTDOWN", (char *) S_cmdhdlr_ALREADY_SHUTDOWN,0},
    {{NULL},"S_cmdHdlr_ENTERING_CMD_PROC_INIT", (char *) S_cmdHdlr_ENTERING_CMD_PROC_INIT,0},
    {{NULL},"S_cmdHdlr_COMMAND_STREAM_INITIALIZED", (char *) S_cmdHdlr_COMMAND_STREAM_INITIALIZED,0},
    {{NULL},"S_cmdHdlr_LEAVING_CMD_PROC_INIT", (char *) S_cmdHdlr_LEAVING_CMD_PROC_INIT,0},
    {{NULL},"S_cmdHdlr_GETTING_A_CMD_TO_PROCESS", (char *) S_cmdHdlr_GETTING_A_CMD_TO_PROCESS,0},
    {{NULL},"S_cmdhdlr_ENTERING_CMDHDLR_CONSTRUCTOR", (char *) S_cmdhdlr_ENTERING_CMDHDLR_CONSTRUCTOR,0},
    {{NULL},"S_cmdHdlr_LEAVING_CMDHDLR_INIT", (char *) S_cmdHdlr_LEAVING_CMDHDLR_INIT,0},
    {{NULL},"S_cmdHdlr_PUT", (char *) S_cmdHdlr_PUT,0},
    {{NULL},"S_cmdHdlr_CHECKING_FOR_NEW_CMD", (char *) S_cmdHdlr_CHECKING_FOR_NEW_CMD,0},
    {{NULL},"S_cmdHdlr_LEAVING_CMDHDLR_DESTRUCTOR", (char *) S_cmdHdlr_LEAVING_CMDHDLR_DESTRUCTOR,0},
    {{NULL},"S_cmdHdlr_ENTERING_CMDHDLR_DESTRUCTOR", (char *) S_cmdHdlr_ENTERING_CMDHDLR_DESTRUCTOR,0},
    {{NULL},"S_cmdHdlr_RESTART", (char *) S_cmdHdlr_RESTART,0},
    {{NULL},"S_cmdHdlr_SHUTDOWN", (char *) S_cmdHdlr_SHUTDOWN,0},
    {{NULL},"S_cmdHdlr_ISOK", (char *) S_cmdHdlr_ISOK,0},
    {{NULL},"S_commandStream_SENDER_CONSTRUCTOR", (char *) S_commandStream_SENDER_CONSTRUCTOR,0},
    {{NULL},"S_commandStream_SENDER_DESTRUCTOR", (char *) S_commandStream_SENDER_DESTRUCTOR,0},
    {{NULL},"S_commandStream_RECEIVER_CONSTRUCTOR", (char *) S_commandStream_RECEIVER_CONSTRUCTOR,0},
    {{NULL},"S_commandStream_RECEIVER_DESTRUCTOR", (char *) S_commandStream_RECEIVER_DESTRUCTOR,0},
    {{NULL},"S_configMgr_CHANNEL_INFO", (char *) S_configMgr_CHANNEL_INFO,0},
    {{NULL},"S_configMgr_INVALID_GIZMO_TYPE", (char *) S_configMgr_INVALID_GIZMO_TYPE,0},
    {{NULL},"S_configMgr_INVALID_RTE_NUM", (char *) S_configMgr_INVALID_RTE_NUM,0},
    {{NULL},"S_configMgr_ENTERING_CONFIG_MANAGER_CONSTRUCTOR", (char *) S_configMgr_ENTERING_CONFIG_MANAGER_CONSTRUCTOR,0},
    {{NULL},"S_configMgr_CONSTRUCTING_INST_GIZMO_INFO", (char *) S_configMgr_CONSTRUCTING_INST_GIZMO_INFO,0},
    {{NULL},"S_configMgr_CONSTRUCTING_BB1_DL_GIZMO", (char *) S_configMgr_CONSTRUCTING_BB1_DL_GIZMO,0},
    {{NULL},"S_configMgr_CONSTRUCTING_BB2_DL_GIZMO", (char *) S_configMgr_CONSTRUCTING_BB2_DL_GIZMO,0},
    {{NULL},"S_configMgr_CONSTRUCTING_GSU_DL_GIZMO", (char *) S_configMgr_CONSTRUCTING_GSU_DL_GIZMO,0},
    {{NULL},"S_configMgr_CONSTRUCTING_FT_GIZMO", (char *) S_configMgr_CONSTRUCTING_FT_GIZMO,0},
    {{NULL},"S_configMgr_CONSTRUCTING_EM_GIZMO", (char *) S_configMgr_CONSTRUCTING_EM_GIZMO,0},
    {{NULL},"S_configMgr_CONSTRUCTING_ST_GIZMO", (char *) S_configMgr_CONSTRUCTING_ST_GIZMO,0},
    {{NULL},"S_configMgr_DONE_CONSTRUCTING_CONFIG_MANAGER", (char *) S_configMgr_DONE_CONSTRUCTING_CONFIG_MANAGER,0},
    {{NULL},"S_configMgr_CONSTRUCTING_INST_GIZMO_0", (char *) S_configMgr_CONSTRUCTING_INST_GIZMO_0,0},
    {{NULL},"S_configMgr_UNKNOWN_INSTRUMENT_GIZMO_NUMBER", (char *) S_configMgr_UNKNOWN_INSTRUMENT_GIZMO_NUMBER,0},
    {{NULL},"S_configMgr_CONSTRUCTING_BB1_DL_GIZMO_0", (char *) S_configMgr_CONSTRUCTING_BB1_DL_GIZMO_0,0},
    {{NULL},"S_configMgr_UNKNOWN_BB1_DL_GIZMO_NUMBER", (char *) S_configMgr_UNKNOWN_BB1_DL_GIZMO_NUMBER,0},
    {{NULL},"S_configMgr_CONSTRUCTING_BB2_DL_GIZMO_0", (char *) S_configMgr_CONSTRUCTING_BB2_DL_GIZMO_0,0},
    {{NULL},"S_configMgr_CONSTRUCTING_GSU_DL_GIZMO_0", (char *) S_configMgr_CONSTRUCTING_GSU_DL_GIZMO_0,0},
    {{NULL},"S_configMgr_UNKNOWN_GSU_DL_GIZMO_NUMBER", (char *) S_configMgr_UNKNOWN_GSU_DL_GIZMO_NUMBER,0},
    {{NULL},"S_configMgr_CONSTRUCTING_FT_GIZMO_0", (char *) S_configMgr_CONSTRUCTING_FT_GIZMO_0,0},
    {{NULL},"S_configMgr_UNKNOWN_FT_GIZMO_NUMBER", (char *) S_configMgr_UNKNOWN_FT_GIZMO_NUMBER,0},
    {{NULL},"S_configMgr_CONSTRUCTING_EM_GIZMO_0", (char *) S_configMgr_CONSTRUCTING_EM_GIZMO_0,0},
    {{NULL},"S_configMgr_UNKNOWN_EM_GIZMO_NUMBER", (char *) S_configMgr_UNKNOWN_EM_GIZMO_NUMBER,0},
    {{NULL},"S_rteConfig_CREATE_NEW_INSTRUMENT", (char *) S_rteConfig_CREATE_NEW_INSTRUMENT,0},
    {{NULL},"S_rteConfig_CREATE_NEW_DELAY_LINE", (char *) S_rteConfig_CREATE_NEW_DELAY_LINE,0},
    {{NULL},"S_rteConfig_CREATE_NEW_GSU_DELAY_LINE", (char *) S_rteConfig_CREATE_NEW_GSU_DELAY_LINE,0},
    {{NULL},"S_rteConfig_CREATE_NEW_QUIC_DELAY_LINE", (char *) S_rteConfig_CREATE_NEW_QUIC_DELAY_LINE,0},
    {{NULL},"S_rteConfig_CREATE_NEW_FRINGE_TRACKER", (char *) S_rteConfig_CREATE_NEW_FRINGE_TRACKER,0},
    {{NULL},"S_rteConfig_CREATE_NEW_EXTERNAL_METROLOGY", (char *) S_rteConfig_CREATE_NEW_EXTERNAL_METROLOGY,0},
    {{NULL},"S_rteConfig_CREATE_NEW_STAR_TRACKER", (char *) S_rteConfig_CREATE_NEW_STAR_TRACKER,0},
    {{NULL},"S_rteConfig_CANNOT_CREATE_GENERIC_DELAY_LINE", (char *) S_rteConfig_CANNOT_CREATE_GENERIC_DELAY_LINE,0},
    {{NULL},"S_controller_UNABLE_TO_ALLOCATE_MODED_CONTROLLER", (char *) S_controller_UNABLE_TO_ALLOCATE_MODED_CONTROLLER,0},
    {{NULL},"S_controller_INVALID_CONTROLLER_MODE", (char *) S_controller_INVALID_CONTROLLER_MODE,0},
    {{NULL},"S_controller_UNASSIGNED_CONTROLLER_MODE", (char *) S_controller_UNASSIGNED_CONTROLLER_MODE,0},
    {{NULL},"S_controller_INVALID_CONTROLLER", (char *) S_controller_INVALID_CONTROLLER,0},
    {{NULL},"S_controller_INVALID_MODED_CONTROLLER", (char *) S_controller_INVALID_MODED_CONTROLLER,0},
    {{NULL},"S_controllergroup_UNABLE_TO_ALLOCATE_CONTROLLER_GROUP", (char *) S_controllergroup_UNABLE_TO_ALLOCATE_CONTROLLER_GROUP,0},
    {{NULL},"S_controllergroup_INVALID_PARTITION", (char *) S_controllergroup_INVALID_PARTITION,0},
    {{NULL},"S_controllergroup_INVALID_CONTROLLER_MODE", (char *) S_controllergroup_INVALID_CONTROLLER_MODE,0},
    {{NULL},"S_controllergroup_INVALID_CONTROLLER_GROUP", (char *) S_controllergroup_INVALID_CONTROLLER_GROUP,0},
    {{NULL},"S_controllergroup_INVALID_CONTROLLER_MODE_FROM_UPDATE", (char *) S_controllergroup_INVALID_CONTROLLER_MODE_FROM_UPDATE,0},
    {{NULL},"S_controllerset_UNABLE_TO_ALLOCATE_CONTROLLER_SET", (char *) S_controllerset_UNABLE_TO_ALLOCATE_CONTROLLER_SET,0},
    {{NULL},"S_controllergroup_INVALID_MODED_CONTROLLER", (char *) S_controllergroup_INVALID_MODED_CONTROLLER,0},
    {{NULL},"S_controllergroup_GROUP_NOT_SAME_SIZE", (char *) S_controllergroup_GROUP_NOT_SAME_SIZE,0},
    {{NULL},"S_controllergroup_UNASSIGNED_CONTROLLER_GROUP", (char *) S_controllergroup_UNASSIGNED_CONTROLLER_GROUP,0},
    {{NULL},"S_datastore_UNABLE_TO_CREATE_DATA_BUFFERS", (char *) S_datastore_UNABLE_TO_CREATE_DATA_BUFFERS,0},
    {{NULL},"S_dataStore_DATA_SEND_INCOMPLETE", (char *) S_dataStore_DATA_SEND_INCOMPLETE,0},
    {{NULL},"S_dlgizmo_GIZMO_INFO_NOT_DL", (char *) S_dlgizmo_GIZMO_INFO_NOT_DL,0},
    {{NULL},"S_dlgizmo_INVALID_NUMBER_OF_SERVO_MODES", (char *) S_dlgizmo_INVALID_NUMBER_OF_SERVO_MODES,0},
    {{NULL},"S_dlgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS", (char *) S_dlgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS,0},
    {{NULL},"S_dlgizmo_UNRECOGNIZED_COMMAND", (char *) S_dlgizmo_UNRECOGNIZED_COMMAND,0},
    {{NULL},"S_dlgizmo_DATA_RECORDING_OFF", (char *) S_dlgizmo_DATA_RECORDING_OFF,0},
    {{NULL},"S_dlgizmo_DATA_RECORDING_ON", (char *) S_dlgizmo_DATA_RECORDING_ON,0},
    {{NULL},"S_dlgizmo_DELAY_LINE_ALIVE", (char *) S_dlgizmo_DELAY_LINE_ALIVE,0},
    {{NULL},"S_dlLimits_NULL_SCHEDULER_POINTER", (char *) S_dlLimits_NULL_SCHEDULER_POINTER,0},
    {{NULL},"S_dlLimits_SCHEDULER_ADJUSTED_LIMITS_TASK_PERIOD", (char *) S_dlLimits_SCHEDULER_ADJUSTED_LIMITS_TASK_PERIOD,0},
    {{NULL},"S_dlLimits_NULL_GIZMO_POINTER", (char *) S_dlLimits_NULL_GIZMO_POINTER,0},
    {{NULL},"S_dlLimits_DELAY_LINE_REACHED_LIMIT", (char *) S_dlLimits_DELAY_LINE_REACHED_LIMIT,0},
    {{NULL},"S_tDlLimits_ENTERING_CONSTRUCTOR_BODY", (char *) S_tDlLimits_ENTERING_CONSTRUCTOR_BODY,0},
    {{NULL},"S_tDlLimits_EXITING_CONSTRUCTOR", (char *) S_tDlLimits_EXITING_CONSTRUCTOR,0},
    {{NULL},"S_tDlLimits_ENTERING_INITIALIZE", (char *) S_tDlLimits_ENTERING_INITIALIZE,0},
    {{NULL},"S_tDlLimits_ADDING_READ_LIMITS_TASK", (char *) S_tDlLimits_ADDING_READ_LIMITS_TASK,0},
    {{NULL},"S_tDlLimits_INITIALIZE_RETURNED_FROM_ADD_TASK", (char *) S_tDlLimits_INITIALIZE_RETURNED_FROM_ADD_TASK,0},
    {{NULL},"S_tDlLimits_INITIALIZE_DONE", (char *) S_tDlLimits_INITIALIZE_DONE,0},
    {{NULL},"S_tDlLimits_ENTERING_UPDATE_CACHED_LIMIT_VALUES", (char *) S_tDlLimits_ENTERING_UPDATE_CACHED_LIMIT_VALUES,0},
    {{NULL},"S_tDlLimits_EXITING_UPDATE_CACHED_LIMIT_VALUES", (char *) S_tDlLimits_EXITING_UPDATE_CACHED_LIMIT_VALUES,0},
    {{NULL},"S_dlCommandProcessor_DELAY_LINE_NUMBER_OUT_OF_RANGE", (char *) S_dlCommandProcessor_DELAY_LINE_NUMBER_OUT_OF_RANGE,0},
    {{NULL},"S_dlCommandProcessor_INTERNAL_ERROR__CORRECT_DELAY_LINE_NUMBER_NOT_HANDLED", (char *) S_dlCommandProcessor_INTERNAL_ERROR__CORRECT_DELAY_LINE_NUMBER_NOT_HANDLED,0},
    {{NULL},"S_dlCommandProcessor_UNRECOGNIZED_COMMAND", (char *) S_dlCommandProcessor_UNRECOGNIZED_COMMAND,0},
    {{NULL},"S_dlCommandProcessor_COULD_NOT_CREATE_COMMAND_ENGINE", (char *) S_dlCommandProcessor_COULD_NOT_CREATE_COMMAND_ENGINE,0},
    {{NULL},"S_offCommand_OFF_START", (char *) S_offCommand_OFF_START,0},
    {{NULL},"S_offCommand_OFF_DONE", (char *) S_offCommand_OFF_DONE,0},
    {{NULL},"S_frontCommand_FRONT_START", (char *) S_frontCommand_FRONT_START,0},
    {{NULL},"S_frontCommand_FRONT_DONE", (char *) S_frontCommand_FRONT_DONE,0},
    {{NULL},"S_frontCommand_FRONT_ABORTED", (char *) S_frontCommand_FRONT_ABORTED,0},
    {{NULL},"S_backCommand_BACK_START", (char *) S_backCommand_BACK_START,0},
    {{NULL},"S_backCommand_BACK_DONE", (char *) S_backCommand_BACK_DONE,0},
    {{NULL},"S_backCommand_BACK_ABORTED", (char *) S_backCommand_BACK_ABORTED,0},
    {{NULL},"S_trackCommand_TRACK_START", (char *) S_trackCommand_TRACK_START,0},
    {{NULL},"S_trackCommand_TRACK_IN_PROGRESS", (char *) S_trackCommand_TRACK_IN_PROGRESS,0},
    {{NULL},"S_trackCommand_TRACK_ABORTED", (char *) S_trackCommand_TRACK_ABORTED,0},
    {{NULL},"S_clearLaserCounterCommand_CLEAR_LASER_COUNTER_START", (char *) S_clearLaserCounterCommand_CLEAR_LASER_COUNTER_START,0},
    {{NULL},"S_clearLaserCounterCommand_CLEAR_LASER_COUNTER_COMPLETE", (char *) S_clearLaserCounterCommand_CLEAR_LASER_COUNTER_COMPLETE,0},
    {{NULL},"S_setModulationCommand_SET_MODULATION_COMPLETE", (char *) S_setModulationCommand_SET_MODULATION_COMPLETE,0},
    {{NULL},"S_setServoParametersCommand_SET_SERVO_PARAMETERS_COMPLETE", (char *) S_setServoParametersCommand_SET_SERVO_PARAMETERS_COMPLETE,0},
    {{NULL},"S_dlServo_INVALID_SERVO_MODE", (char *) S_dlServo_INVALID_SERVO_MODE,0},
    {{NULL},"S_dl_NULL_HARDWARE_POINTER", (char *) S_dl_NULL_HARDWARE_POINTER,0},
    {{NULL},"S_homesetCommand_HOMESET_START", (char *) S_homesetCommand_HOMESET_START,0},
    {{NULL},"S_homesetCommand_HOMESET_BACK_START", (char *) S_homesetCommand_HOMESET_BACK_START,0},
    {{NULL},"S_homesetCommand_HOMESET_FRONT_START", (char *) S_homesetCommand_HOMESET_FRONT_START,0},
    {{NULL},"S_homesetCommand_HOMESET_CREEPBACK_START", (char *) S_homesetCommand_HOMESET_CREEPBACK_START,0},
    {{NULL},"S_homesetCommand_HOMESET_CREEPFRONT_START", (char *) S_homesetCommand_HOMESET_CREEPFRONT_START,0},
    {{NULL},"S_homesetCommand_HOMESET_DONE", (char *) S_homesetCommand_HOMESET_DONE,0},
    {{NULL},"S_homesetCommand_HOMESET_ABORTED", (char *) S_homesetCommand_HOMESET_ABORTED,0},
    {{NULL},"S_homesetCommand_CANNOT_FIND_HOME_SENSOR", (char *) S_homesetCommand_CANNOT_FIND_HOME_SENSOR,0},
    {{NULL},"S_homecheckCommand_HOMECHECK_START", (char *) S_homecheckCommand_HOMECHECK_START,0},
    {{NULL},"S_homecheckCommand_HOMECHECK_FRONT_START", (char *) S_homecheckCommand_HOMECHECK_FRONT_START,0},
    {{NULL},"S_homecheckCommand_HOMECHECK_BACK_START", (char *) S_homecheckCommand_HOMECHECK_BACK_START,0},
    {{NULL},"S_homecheckCommand_HOMECHECK_CREEPFRONT_START", (char *) S_homecheckCommand_HOMECHECK_CREEPFRONT_START,0},
    {{NULL},"S_homecheckCommand_HOMECHECK_CREEPBACK_START", (char *) S_homecheckCommand_HOMECHECK_CREEPBACK_START,0},
    {{NULL},"S_homecheckCommand_HOMECHECK_DONE", (char *) S_homecheckCommand_HOMECHECK_DONE,0},
    {{NULL},"S_homecheckCommand_HOMECHECK_ABORTED", (char *) S_homecheckCommand_HOMECHECK_ABORTED,0},
    {{NULL},"S_homecheckCommand_CANNOT_FIND_HOME_SENSOR", (char *) S_homecheckCommand_CANNOT_FIND_HOME_SENSOR,0},
    {{NULL},"S_user1Command_USER1_START", (char *) S_user1Command_USER1_START,0},
    {{NULL},"S_user1Command_USER1_IN_PROGRESS", (char *) S_user1Command_USER1_IN_PROGRESS,0},
    {{NULL},"S_user1Command_USER1_ABORTED", (char *) S_user1Command_USER1_ABORTED,0},
    {{NULL},"S_user2Command_USER2_START", (char *) S_user2Command_USER2_START,0},
    {{NULL},"S_user2Command_USER2_IN_PROGRESS", (char *) S_user2Command_USER2_IN_PROGRESS,0},
    {{NULL},"S_user2Command_USER2_ABORTED", (char *) S_user2Command_USER2_ABORTED,0},
    {{NULL},"S_ditherCalibCommand_CALIB_DITHER_START", (char *) S_ditherCalibCommand_CALIB_DITHER_START,0},
    {{NULL},"S_ditherCalibCommand_CALIB_DITHER_IN_PROGRESS", (char *) S_ditherCalibCommand_CALIB_DITHER_IN_PROGRESS,0},
    {{NULL},"S_ditherCalibCommand_CALIB_DITHER_DONE", (char *) S_ditherCalibCommand_CALIB_DITHER_DONE,0},
    {{NULL},"S_ditherCalibCommand_CALIB_DITHER_ABORTED", (char *) S_ditherCalibCommand_CALIB_DITHER_ABORTED,0},
    {{NULL},"S_ditherCheckCommand_CHECK_DITHER_START", (char *) S_ditherCheckCommand_CHECK_DITHER_START,0},
    {{NULL},"S_ditherCheckCommand_CHECK_DITHER_IN_PROGRESS", (char *) S_ditherCheckCommand_CHECK_DITHER_IN_PROGRESS,0},
    {{NULL},"S_ditherCheckCommand_CHECK_DITHER_DONE", (char *) S_ditherCheckCommand_CHECK_DITHER_DONE,0},
    {{NULL},"S_ditherCheckCommand_CHECK_DITHER_ABORTED", (char *) S_ditherCheckCommand_CHECK_DITHER_ABORTED,0},
    {{NULL},"S_setActiveTargetCommand_SELECT_TARGET_COMPLETE", (char *) S_setActiveTargetCommand_SELECT_TARGET_COMPLETE,0},
    {{NULL},"S_dlPingCommand_DELAY_LINE_ALIVE", (char *) S_dlPingCommand_DELAY_LINE_ALIVE,0},
    {{NULL},"S_dlSetDitheringCommand_TURN_DITHER_ON_DONE", (char *) S_dlSetDitheringCommand_TURN_DITHER_ON_DONE,0},
    {{NULL},"S_dlSetDitheringCommand_TURN_DITHER_OFF_DONE", (char *) S_dlSetDitheringCommand_TURN_DITHER_OFF_DONE,0},
    {{NULL},"S_dlSetDitheringCommand_SET_DITHER_COMPLETE", (char *) S_dlSetDitheringCommand_SET_DITHER_COMPLETE,0},
    {{NULL},"S_dlDither_INVALID_BUFSIZE", (char *) S_dlDither_INVALID_BUFSIZE,0},
    {{NULL},"S_dlDither_INVALID_DITHER_PERIOD", (char *) S_dlDither_INVALID_DITHER_PERIOD,0},
    {{NULL},"S_dlDither_INVALID_OFFSET", (char *) S_dlDither_INVALID_OFFSET,0},
    {{NULL},"S_dlDither_DITHER_MEASUREMENT_ERROR", (char *) S_dlDither_DITHER_MEASUREMENT_ERROR,0},
    {{NULL},"S_dlDither_CANNOT_DO_DIAGS_WHILE_MEASURING", (char *) S_dlDither_CANNOT_DO_DIAGS_WHILE_MEASURING,0},
    {{NULL},"S_dlDither_NULL_CHANNEL_POINTER", (char *) S_dlDither_NULL_CHANNEL_POINTER,0},
    {{NULL},"S_dlDither_NULL_BANK_POINTER", (char *) S_dlDither_NULL_BANK_POINTER,0},
    {{NULL},"S_dlDither_INVALID_SAMPLE_FREQ", (char *) S_dlDither_INVALID_SAMPLE_FREQ,0},
    {{NULL},"S_dlDither_NULL_GIZMO_POINTER", (char *) S_dlDither_NULL_GIZMO_POINTER,0},
    {{NULL},"S_dlDither_INVALID_NUMWAVES", (char *) S_dlDither_INVALID_NUMWAVES,0},
    {{NULL},"S_dlDither_INVALID_AMPL_FACTOR", (char *) S_dlDither_INVALID_AMPL_FACTOR,0},
    {{NULL},"S_dlDither_INVALID_DITHER_SAMPLE_RATE", (char *) S_dlDither_INVALID_DITHER_SAMPLE_RATE,0},
    {{NULL},"S_dlDither_ENTERING_DL_DITHER_INIT", (char *) S_dlDither_ENTERING_DL_DITHER_INIT,0},
    {{NULL},"S_dlDither_SEM_CREATED", (char *) S_dlDither_SEM_CREATED,0},
    {{NULL},"S_dlDither_INITIAL_WAVEFORM_SET", (char *) S_dlDither_INITIAL_WAVEFORM_SET,0},
    {{NULL},"S_dlDither_INITIAL_WAVEFORM_LOADED", (char *) S_dlDither_INITIAL_WAVEFORM_LOADED,0},
    {{NULL},"S_dlDither_ENTERING_MEASURE_DITHER", (char *) S_dlDither_ENTERING_MEASURE_DITHER,0},
    {{NULL},"S_dlDither_LOADED_WAVEFORM_NOW_WAIT", (char *) S_dlDither_LOADED_WAVEFORM_NOW_WAIT,0},
    {{NULL},"S_dlDither_MEASURED_DITHER_WAVE_SUCCESSFULLY", (char *) S_dlDither_MEASURED_DITHER_WAVE_SUCCESSFULLY,0},
    {{NULL},"S_dlDither_LEAVING_MEASURE_DITHER", (char *) S_dlDither_LEAVING_MEASURE_DITHER,0},
    {{NULL},"S_dlDither_ENTERING_CALIBRATE_DITHER", (char *) S_dlDither_ENTERING_CALIBRATE_DITHER,0},
    {{NULL},"S_dlDither_COMPLETED_FIRST_MEASURE_DITHER", (char *) S_dlDither_COMPLETED_FIRST_MEASURE_DITHER,0},
    {{NULL},"S_dlDither_COMPLETED_ANOTHER_MEASURE_DITHER", (char *) S_dlDither_COMPLETED_ANOTHER_MEASURE_DITHER,0},
    {{NULL},"S_dlDither_SUCCESSFULLY_COMPLETED_CALIBRATE_DITHER", (char *) S_dlDither_SUCCESSFULLY_COMPLETED_CALIBRATE_DITHER,0},
    {{NULL},"S_dlDither_ENTERING_CHECK_DITHER", (char *) S_dlDither_ENTERING_CHECK_DITHER,0},
    {{NULL},"S_dlDither_SUCCESSFULLY_COMPLETED_CHECK_DITHER", (char *) S_dlDither_SUCCESSFULLY_COMPLETED_CHECK_DITHER,0},
    {{NULL},"S_dlDither_DITHER_CALIBRATE_FAILED", (char *) S_dlDither_DITHER_CALIBRATE_FAILED,0},
    {{NULL},"S_relayer_INDEX_OUT_OF_RANGE", (char *) S_relayer_INDEX_OUT_OF_RANGE,0},
    {{NULL},"S_relayer_DATA_READ_INCOMPLETE", (char *) S_relayer_DATA_READ_INCOMPLETE,0},
    {{NULL},"S_dlRelayer_UNKNOWN_DL_TYPE", (char *) S_dlRelayer_UNKNOWN_DL_TYPE,0},
    {{NULL},"S_dlRelayer_CANT_ALLOCATE_STATUS_STREAM", (char *) S_dlRelayer_CANT_ALLOCATE_STATUS_STREAM,0},
    {{NULL},"S_dlRelayer_ENTERING_DL_DATA_RELAYER_INIT", (char *) S_dlRelayer_ENTERING_DL_DATA_RELAYER_INIT,0},
    {{NULL},"S_dlRelayer_DL_DATA_STREAM_INIT_SUCCESSFUL", (char *) S_dlRelayer_DL_DATA_STREAM_INIT_SUCCESSFUL,0},
    {{NULL},"S_dlRelayer_DL_DATA_RELAYER_INIT_SUCCESSFUL", (char *) S_dlRelayer_DL_DATA_RELAYER_INIT_SUCCESSFUL,0},
    {{NULL},"S_dlRelayer_ENTERING_DL_STATUS_RELAYER_INIT", (char *) S_dlRelayer_ENTERING_DL_STATUS_RELAYER_INIT,0},
    {{NULL},"S_dlRelayer_DL_STATUS_STREAM_INIT_SUCCESSFUL", (char *) S_dlRelayer_DL_STATUS_STREAM_INIT_SUCCESSFUL,0},
    {{NULL},"S_dlRelayer_DL_STATUS_RELAYER_INIT_SUCCESSFUL", (char *) S_dlRelayer_DL_STATUS_RELAYER_INIT_SUCCESSFUL,0},
    {{NULL},"S_dlRelayer_IN_DL_DATA_RELAY", (char *) S_dlRelayer_IN_DL_DATA_RELAY,0},
    {{NULL},"S_dlRelayer_IN_DL_STATUS_RELAY", (char *) S_dlRelayer_IN_DL_STATUS_RELAY,0},
    {{NULL},"S_tPidDouble_INIT_USING_POLES_AND_ZEROS_START", (char *) S_tPidDouble_INIT_USING_POLES_AND_ZEROS_START,0},
    {{NULL},"S_tPidDouble_INIT_USING_POLES_AND_ZEROS_EXIT", (char *) S_tPidDouble_INIT_USING_POLES_AND_ZEROS_EXIT,0},
    {{NULL},"S_tPidDouble_INIT_USING_PIDS_START", (char *) S_tPidDouble_INIT_USING_PIDS_START,0},
    {{NULL},"S_tPidDouble_INIT_USING_PIDS_EXIT", (char *) S_tPidDouble_INIT_USING_PIDS_EXIT,0},
    {{NULL},"S_tPidDouble_INIT_PID_RESET_START", (char *) S_tPidDouble_INIT_PID_RESET_START,0},
    {{NULL},"S_tPidDouble_INIT_PID_RESET_EXIT", (char *) S_tPidDouble_INIT_PID_RESET_EXIT,0},
    {{NULL},"S_dlController_CONTROLLER_DATA_INITIALIZE_START", (char *) S_dlController_CONTROLLER_DATA_INITIALIZE_START,0},
    {{NULL},"S_dlController_CONTROLLER_DATA_INITIALIZE_EXIT", (char *) S_dlController_CONTROLLER_DATA_INITIALIZE_EXIT,0},
    {{NULL},"S_dlController_DL_CONTROLLER_CONSTRUCTOR", (char *) S_dlController_DL_CONTROLLER_CONSTRUCTOR,0},
    {{NULL},"S_dlController_DL_FAST_CTRLR_CONSTRUCTOR", (char *) S_dlController_DL_FAST_CTRLR_CONSTRUCTOR,0},
    {{NULL},"S_dlController_DL_FAST_SLEW_CTRLR_CONSTRUCTOR", (char *) S_dlController_DL_FAST_SLEW_CTRLR_CONSTRUCTOR,0},
    {{NULL},"S_dlController_DL_MED_SLEW_CTRLR_CONSTRUCTOR", (char *) S_dlController_DL_MED_SLEW_CTRLR_CONSTRUCTOR,0},
    {{NULL},"S_dlController_DL_SLOW_CTRLR_CONSTRUCTOR", (char *) S_dlController_DL_SLOW_CTRLR_CONSTRUCTOR,0},
    {{NULL},"S_dlController_DL_SLOW_SLEW_CTRLR_CONSTRUCTOR", (char *) S_dlController_DL_SLOW_SLEW_CTRLR_CONSTRUCTOR,0},
    {{NULL},"S_dlController_DL_MED_SLEW_CTRLR_CALCULATE_START", (char *) S_dlController_DL_MED_SLEW_CTRLR_CALCULATE_START,0},
    {{NULL},"S_dlController_DL_MED_SLEW_CTRLR_CALCULATE_EXIT", (char *) S_dlController_DL_MED_SLEW_CTRLR_CALCULATE_EXIT,0},
    {{NULL},"S_dlController_DL_SLOW_SLEW_CTRLR_CALCULATE_START", (char *) S_dlController_DL_SLOW_SLEW_CTRLR_CALCULATE_START,0},
    {{NULL},"S_dlController_DL_SLOW_SLEW_CTRLR_CALCULATE_EXIT", (char *) S_dlController_DL_SLOW_SLEW_CTRLR_CALCULATE_EXIT,0},
    {{NULL},"S_dlController_GET_FAST_INPUT_SET", (char *) S_dlController_GET_FAST_INPUT_SET,0},
    {{NULL},"S_dlController_GET_FAST_OUTPUT_SET", (char *) S_dlController_GET_FAST_OUTPUT_SET,0},
    {{NULL},"S_dlController_GET_FAST_TARGET_SET", (char *) S_dlController_GET_FAST_TARGET_SET,0},
    {{NULL},"S_dlController_UPDATE_COMPENSATOR_COEFFS_START", (char *) S_dlController_UPDATE_COMPENSATOR_COEFFS_START,0},
    {{NULL},"S_dlController_UPDATE_COMPENSATOR_COEFFS_EXIT", (char *) S_dlController_UPDATE_COMPENSATOR_COEFFS_EXIT,0},
    {{NULL},"S_dlOffController_SLOW_OFF_CONTROLLER_CONSTRUCTOR", (char *) S_dlOffController_SLOW_OFF_CONTROLLER_CONSTRUCTOR,0},
    {{NULL},"S_dlOffController_OFF_CONTROLLER_SET_CONSTRUCTOR_START", (char *) S_dlOffController_OFF_CONTROLLER_SET_CONSTRUCTOR_START,0},
    {{NULL},"S_dlOffController_OFF_CONTROLLER_SET_CONSTRUCTOR_EXIT", (char *) S_dlOffController_OFF_CONTROLLER_SET_CONSTRUCTOR_EXIT,0},
    {{NULL},"S_dlTrackController_FAST_TRK_LIN_CTRLR_CONSTRUCTOR", (char *) S_dlTrackController_FAST_TRK_LIN_CTRLR_CONSTRUCTOR,0},
    {{NULL},"S_dlTrackController_MED_TRK_LIN_CTRLR_CONSTRUCTOR", (char *) S_dlTrackController_MED_TRK_LIN_CTRLR_CONSTRUCTOR,0},
    {{NULL},"S_dlTrackController_SLOW_TRK_SLEW_CTRLR_CONSTRUCTOR", (char *) S_dlTrackController_SLOW_TRK_SLEW_CTRLR_CONSTRUCTOR,0},
    {{NULL},"S_dlTrackController_SLOW_TRK_LIN_CTRLR_CONSTRUCTOR", (char *) S_dlTrackController_SLOW_TRK_LIN_CTRLR_CONSTRUCTOR,0},
    {{NULL},"S_dlTrackController_TRK_CTRLR_SET_CONSTRUCTOR_START", (char *) S_dlTrackController_TRK_CTRLR_SET_CONSTRUCTOR_START,0},
    {{NULL},"S_dlTrackController_TRK_CTRLR_SET_CONSTRUCTOR_EXIT", (char *) S_dlTrackController_TRK_CTRLR_SET_CONSTRUCTOR_EXIT,0},
    {{NULL},"S_dlFrontBackController_FB_SLOW_CTRLR_CONSTRUCTOR", (char *) S_dlFrontBackController_FB_SLOW_CTRLR_CONSTRUCTOR,0},
    {{NULL},"S_dlFrontBackController_FB_CTRLR_SET_CONSTRUCTOR_START", (char *) S_dlFrontBackController_FB_CTRLR_SET_CONSTRUCTOR_START,0},
    {{NULL},"S_dlFrontBackController_FB_CTRLR_SET_CONSTRUCTOR_EXIT", (char *) S_dlFrontBackController_FB_CTRLR_SET_CONSTRUCTOR_EXIT,0},
    {{NULL},"S_dlIoSet_STAB_IO_GROUP_CONSTRUCTOR", (char *) S_dlIoSet_STAB_IO_GROUP_CONSTRUCTOR,0},
    {{NULL},"S_dlIoSet_TRK_LIN_IO_GROUP_CONSTRUCTOR", (char *) S_dlIoSet_TRK_LIN_IO_GROUP_CONSTRUCTOR,0},
    {{NULL},"S_dlIoSet_COMPLETE_IO_SET_CONSTRUCTOR", (char *) S_dlIoSet_COMPLETE_IO_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlInputSet_FAST_INPUT_SET_CONSTRUCTOR", (char *) S_dlInputSet_FAST_INPUT_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlInputSet_MED_TRK_LIN_INPUT_SET_CONSTRUCTOR", (char *) S_dlInputSet_MED_TRK_LIN_INPUT_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlInputSet_MED_STAB_INPUT_SET_CONSTRUCTOR", (char *) S_dlInputSet_MED_STAB_INPUT_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlInputSet_SLOW_INPUT_SET_CONSTRUCTOR", (char *) S_dlInputSet_SLOW_INPUT_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlInputSet_ENTERING_FAST_INPUT_SET_UPDATE", (char *) S_dlInputSet_ENTERING_FAST_INPUT_SET_UPDATE,0},
    {{NULL},"S_dlOutputSet_FAST_OUTPUT_SET_CONSTRUCTOR", (char *) S_dlOutputSet_FAST_OUTPUT_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlOutputSet_MED_OUTPUT_SET_CONSTRUCTOR", (char *) S_dlOutputSet_MED_OUTPUT_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlOutputSet_SLOW_OUTPUT_SET_CONSTRUCTOR", (char *) S_dlOutputSet_SLOW_OUTPUT_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlTargetSet_POS_TARG_SRC_CONSTRUCTOR", (char *) S_dlTargetSet_POS_TARG_SRC_CONSTRUCTOR,0},
    {{NULL},"S_dlTargetSet_VEL_TARG_SRC_CONSTRUCTOR", (char *) S_dlTargetSet_VEL_TARG_SRC_CONSTRUCTOR,0},
    {{NULL},"S_dlTargetSet_FAST_TARG_SET_CONSTRUCTOR", (char *) S_dlTargetSet_FAST_TARG_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlTargetSet_MED_TRK_LIN_TARG_SET_CONSTRUCTOR", (char *) S_dlTargetSet_MED_TRK_LIN_TARG_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlTargetSet_SLOW_TARG_SET_CONSTRUCTOR", (char *) S_dlTargetSet_SLOW_TARG_SET_CONSTRUCTOR,0},
    {{NULL},"S_dlTargetSet_MED_STAB_TARG_SET_CONSTRUCTOR", (char *) S_dlTargetSet_MED_STAB_TARG_SET_CONSTRUCTOR,0},
    {{NULL},"S_quicDlController_CONTROLLER_DATA_CONSTRUCTOR_START", (char *) S_quicDlController_CONTROLLER_DATA_CONSTRUCTOR_START,0},
    {{NULL},"S_quicDlController_CONTROLLER_DATA_CONSTRUCTOR_EXIT", (char *) S_quicDlController_CONTROLLER_DATA_CONSTRUCTOR_EXIT,0},
    {{NULL},"S_quicDlController_CTRLR_DATA_SET_SERVO_PARAMS_ENTER", (char *) S_quicDlController_CTRLR_DATA_SET_SERVO_PARAMS_ENTER,0},
    {{NULL},"S_quicDlController_CTRLR_DATA_SET_SERVO_PARAMS_EXIT", (char *) S_quicDlController_CTRLR_DATA_SET_SERVO_PARAMS_EXIT,0},
    {{NULL},"S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_CONSTRUCTOR_START", (char *) S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_CONSTRUCTOR_START,0},
    {{NULL},"S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_CONSTRUCTOR_EXIT", (char *) S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_CONSTRUCTOR_EXIT,0},
    {{NULL},"S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_SET_SERVO_PARAMS", (char *) S_quicDlController_COMPLETE_SET_OF_CTRLR_SETS_SET_SERVO_PARAMS,0},
    {{NULL},"S_quicDlFrontController_ENTERING_CONSTRUCTOR_BODY", (char *) S_quicDlFrontController_ENTERING_CONSTRUCTOR_BODY,0},
    {{NULL},"S_quicDlFrontController_LEAVING_CONSTRUCTOR", (char *) S_quicDlFrontController_LEAVING_CONSTRUCTOR,0},
    {{NULL},"S_quicDlTrackController_ENTERING_CONSTRUCTOR_BODY", (char *) S_quicDlTrackController_ENTERING_CONSTRUCTOR_BODY,0},
    {{NULL},"S_quicDlTrackController_LEAVING_CONSTRUCTOR_BODY", (char *) S_quicDlTrackController_LEAVING_CONSTRUCTOR_BODY,0},
    {{NULL},"S_dlGizmo_COULD_NOT_CREATE_DL_SERVO_OBJECT", (char *) S_dlGizmo_COULD_NOT_CREATE_DL_SERVO_OBJECT,0},
    {{NULL},"S_dlGizmo_NUMBER_OF_CONTROLLERS_DOES_NOT_MATCH_NUMBER_OF_SERVO_MODES", (char *) S_dlGizmo_NUMBER_OF_CONTROLLERS_DOES_NOT_MATCH_NUMBER_OF_SERVO_MODES,0},
    {{NULL},"S_dlGizmo_COULD_NOT_CREATE_DLLIMITS_OBJECT", (char *) S_dlGizmo_COULD_NOT_CREATE_DLLIMITS_OBJECT,0},
    {{NULL},"S_dlGizmo_CANT_ALLOCAT_COMMAND_PROCESSOR", (char *) S_dlGizmo_CANT_ALLOCAT_COMMAND_PROCESSOR,0},
    {{NULL},"S_dlGizmo_ENTERING_DL_GIZMO_CONSTRUCTOR", (char *) S_dlGizmo_ENTERING_DL_GIZMO_CONSTRUCTOR,0},
    {{NULL},"S_dlGizmo_DATA_RELAYER_INITIALIZED", (char *) S_dlGizmo_DATA_RELAYER_INITIALIZED,0},
    {{NULL},"S_dlGizmo_TARGET_GENERATOR_INITIALIZED", (char *) S_dlGizmo_TARGET_GENERATOR_INITIALIZED,0},
    {{NULL},"S_dlGizmo_DL_DITHER_OBJECT_INITIALIZED", (char *) S_dlGizmo_DL_DITHER_OBJECT_INITIALIZED,0},
    {{NULL},"S_dlGizmo_ENTERING_DL_GIZMO_INITIALIZE", (char *) S_dlGizmo_ENTERING_DL_GIZMO_INITIALIZE,0},
    {{NULL},"S_dlGizmo_DL_LIMITS_CONSTRUCTED", (char *) S_dlGizmo_DL_LIMITS_CONSTRUCTED,0},
    {{NULL},"S_dlGizmo_CONTROLLER_SET_ARRAY_INITIALIZED", (char *) S_dlGizmo_CONTROLLER_SET_ARRAY_INITIALIZED,0},
    {{NULL},"S_dlGizmo_DL_SERVO_INITIALIZED", (char *) S_dlGizmo_DL_SERVO_INITIALIZED,0},
    {{NULL},"S_dlGizmo_DL_STATUS_INITIALIZED", (char *) S_dlGizmo_DL_STATUS_INITIALIZED,0},
    {{NULL},"S_dlGizmo_DL_STATUS_RELAYER_INITIALIZED", (char *) S_dlGizmo_DL_STATUS_RELAYER_INITIALIZED,0},
    {{NULL},"S_dlGizmo_DL_COMMAND_PROCESSOR_INITIALIZED", (char *) S_dlGizmo_DL_COMMAND_PROCESSOR_INITIALIZED,0},
    {{NULL},"S_dlGizmo_INITIALIZE_COMPLETE", (char *) S_dlGizmo_INITIALIZE_COMPLETE,0},
    {{NULL},"S_dlGizmo_ENTERING_DL_GIZMO_DESTRUCTOR", (char *) S_dlGizmo_ENTERING_DL_GIZMO_DESTRUCTOR,0},
    {{NULL},"S_dlGizmo_DL_LIMITS_DESTROYED", (char *) S_dlGizmo_DL_LIMITS_DESTROYED,0},
    {{NULL},"S_dlGizmo_EXITING_DL_GIZMO_DESTRUCTOR", (char *) S_dlGizmo_EXITING_DL_GIZMO_DESTRUCTOR,0},
    {{NULL},"S_dlGizmo_ENTERING_SET_SERVO_MODE", (char *) S_dlGizmo_ENTERING_SET_SERVO_MODE,0},
    {{NULL},"S_dlGizmo_ENTERING_SET_LASER_MODULATION", (char *) S_dlGizmo_ENTERING_SET_LASER_MODULATION,0},
    {{NULL},"S_dlGizmo_ENTERING_SET_SERVO_PARAMS", (char *) S_dlGizmo_ENTERING_SET_SERVO_PARAMS,0},
    {{NULL},"S_dlGizmo_ENTERING_GET_LASER_MODULATION", (char *) S_dlGizmo_ENTERING_GET_LASER_MODULATION,0},
    {{NULL},"S_dlGizmo_ENTERING_GET_SERVO_PARAMS", (char *) S_dlGizmo_ENTERING_GET_SERVO_PARAMS,0},
    {{NULL},"S_dlGizmo_ENTERING_GET_CONTROLLER_DATA", (char *) S_dlGizmo_ENTERING_GET_CONTROLLER_DATA,0},
    {{NULL},"S_dlGizmo_NULL_COMPLETE_CTRL_SET_POINTER", (char *) S_dlGizmo_NULL_COMPLETE_CTRL_SET_POINTER,0},
    {{NULL},"S_dlGizmo_ENTERING_GET_SERVO_MODE", (char *) S_dlGizmo_ENTERING_GET_SERVO_MODE,0},
    {{NULL},"S_dlTargGen_CANT_ALLOCATE_TARGETS_STREAMS", (char *) S_dlTargGen_CANT_ALLOCATE_TARGETS_STREAMS,0},
    {{NULL},"S_dlTargGen_ENTERING_DL_TARGGEN_INIT", (char *) S_dlTargGen_ENTERING_DL_TARGGEN_INIT,0},
    {{NULL},"S_dlTargGen_ALL_TARGET_SOURCES_INITED", (char *) S_dlTargGen_ALL_TARGET_SOURCES_INITED,0},
    {{NULL},"S_dlTargGen_LEAVING_DL_TARGGEN_INIT", (char *) S_dlTargGen_LEAVING_DL_TARGGEN_INIT,0},
    {{NULL},"S_dlTargGen_COMPUTE_TOTAL_TARGET_TASK", (char *) S_dlTargGen_COMPUTE_TOTAL_TARGET_TASK,0},
    {{NULL},"S_emgizmo_COULD_NOT_CREATE_COMMAND_ENGINE", (char *) S_emgizmo_COULD_NOT_CREATE_COMMAND_ENGINE,0},
    {{NULL},"S_emgizmo_UNRECOGNIZED_COMMAND", (char *) S_emgizmo_UNRECOGNIZED_COMMAND,0},
    {{NULL},"S_emgizmo_UNABLE_TO_SEND_STATUS", (char *) S_emgizmo_UNABLE_TO_SEND_STATUS,0},
    {{NULL},"S_emgizmo_GIZMO_INFO_NOT_EM", (char *) S_emgizmo_GIZMO_INFO_NOT_EM,0},
    {{NULL},"S_emgizmo_INVALID_NUMBER_OF_SERVO_MODES", (char *) S_emgizmo_INVALID_NUMBER_OF_SERVO_MODES,0},
    {{NULL},"S_emgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS", (char *) S_emgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS,0},
    {{NULL},"S_emgizmo_EXTERNAL_METROLOGY_ALIVE", (char *) S_emgizmo_EXTERNAL_METROLOGY_ALIVE,0},
    {{NULL},"S_emgizmo_SETTING_SERVO_PARAMETERS", (char *) S_emgizmo_SETTING_SERVO_PARAMETERS,0},
    {{NULL},"S_emgizmo_SERVO_PARAMETERS_SET", (char *) S_emgizmo_SERVO_PARAMETERS_SET,0},
    {{NULL},"S_em_OFF_START", (char *) S_em_OFF_START,0},
    {{NULL},"S_em_OFF_COMPLETE", (char *) S_em_OFF_COMPLETE,0},
    {{NULL},"S_em_TRACK_START", (char *) S_em_TRACK_START,0},
    {{NULL},"S_em_TRACK_IN_PROGRESS", (char *) S_em_TRACK_IN_PROGRESS,0},
    {{NULL},"S_em_TRACK_ABORTED", (char *) S_em_TRACK_ABORTED,0},
    {{NULL},"S_errorStream_SENDER_CONSTRUCTOR", (char *) S_errorStream_SENDER_CONSTRUCTOR,0},
    {{NULL},"S_errorStream_SENDER_DESTRUCTOR", (char *) S_errorStream_SENDER_DESTRUCTOR,0},
    {{NULL},"S_errorStream_PUT_EC_START", (char *) S_errorStream_PUT_EC_START,0},
    {{NULL},"S_errorStream_PUT_EC_COMPLETE", (char *) S_errorStream_PUT_EC_COMPLETE,0},
    {{NULL},"S_errorStream_PUT_ECT_START", (char *) S_errorStream_PUT_ECT_START,0},
    {{NULL},"S_errorStream_PUT_ECT_COMPLETE", (char *) S_errorStream_PUT_ECT_COMPLETE,0},
    {{NULL},"S_errorStream_PUT_NO_WAIT_ECT_START", (char *) S_errorStream_PUT_NO_WAIT_ECT_START,0},
    {{NULL},"S_errorStream_PUT_NO_WAIT_ECT_COMPLETE", (char *) S_errorStream_PUT_NO_WAIT_ECT_COMPLETE,0},
    {{NULL},"S_errorStream_RECEIVER_CONSTRUCTOR", (char *) S_errorStream_RECEIVER_CONSTRUCTOR,0},
    {{NULL},"S_errorStream_RECEIVER_DESTRUCTOR", (char *) S_errorStream_RECEIVER_DESTRUCTOR,0},
    {{NULL},"S_extInt_ALREADY_RESTART", (char *) S_extInt_ALREADY_RESTART,0},
    {{NULL},"S_extInt_ALREADY_SHUTDOWN", (char *) S_extInt_ALREADY_SHUTDOWN,0},
    {{NULL},"S_ft_UNABLE_TO_SEND_STATUS", (char *) S_ft_UNABLE_TO_SEND_STATUS,0},
    {{NULL},"S_ft_UNRECOGNIZED_COMMAND", (char *) S_ft_UNRECOGNIZED_COMMAND,0},
    {{NULL},"S_ft_COULD_NOT_CREATE_COMMAND_ENGINE", (char *) S_ft_COULD_NOT_CREATE_COMMAND_ENGINE,0},
    {{NULL},"S_ft_GIZMO_INFO_NOT_FT", (char *) S_ft_GIZMO_INFO_NOT_FT,0},
    {{NULL},"S_ft_INVALID_NUMBER_OF_SERVO_MODES", (char *) S_ft_INVALID_NUMBER_OF_SERVO_MODES,0},
    {{NULL},"S_ft_INVALID_NUMBER_OF_SERVO_PARTITIONS", (char *) S_ft_INVALID_NUMBER_OF_SERVO_PARTITIONS,0},
    {{NULL},"S_ft_ARRAY_TOO_SMALL", (char *) S_ft_ARRAY_TOO_SMALL,0},
    {{NULL},"S_ft_INVALID_TRACK_CONTROLLER_MODE", (char *) S_ft_INVALID_TRACK_CONTROLLER_MODE,0},
    {{NULL},"S_ft_TOO_FEW_PHOTONS_TO_CONTINUE_SEARCH", (char *) S_ft_TOO_FEW_PHOTONS_TO_CONTINUE_SEARCH,0},
    {{NULL},"S_ft_TOO_FEW_PHOTONS_FOR_SEARCH", (char *) S_ft_TOO_FEW_PHOTONS_FOR_SEARCH,0},
    {{NULL},"S_ft_SEARCH_TIME_OUT", (char *) S_ft_SEARCH_TIME_OUT,0},
    {{NULL},"S_ft_INVALID_TARGET_DIRECTION", (char *) S_ft_INVALID_TARGET_DIRECTION,0},
    {{NULL},"S_ft_UNABLE_TO_SEND_IMAGE", (char *) S_ft_UNABLE_TO_SEND_IMAGE,0},
    {{NULL},"S_ft_MISSING_APD_DATA", (char *) S_ft_MISSING_APD_DATA,0},
    {{NULL},"S_ft_UNPROCESSED_SWEEP", (char *) S_ft_UNPROCESSED_SWEEP,0},
    {{NULL},"S_ft_OVERPROCESSED_SWEEP", (char *) S_ft_OVERPROCESSED_SWEEP,0},
    {{NULL},"S_ft_FRINGE_TRACKER_ALIVE", (char *) S_ft_FRINGE_TRACKER_ALIVE,0},
    {{NULL},"S_ft_OFF", (char *) S_ft_OFF,0},
    {{NULL},"S_ft_TRACK_START", (char *) S_ft_TRACK_START,0},
    {{NULL},"S_ft_TRACK_IN_PROGRESS", (char *) S_ft_TRACK_IN_PROGRESS,0},
    {{NULL},"S_ft_TRACK_ABORTED", (char *) S_ft_TRACK_ABORTED,0},
    {{NULL},"S_ft_GET_IMAGE", (char *) S_ft_GET_IMAGE,0},
    {{NULL},"S_ft_SERVO_PARAMETERS_SET", (char *) S_ft_SERVO_PARAMETERS_SET,0},
    {{NULL},"S_ft_REGION_OF_INTEREST_SET", (char *) S_ft_REGION_OF_INTEREST_SET,0},
    {{NULL},"S_ft_WOBBLE_PARAMETERS_SET", (char *) S_ft_WOBBLE_PARAMETERS_SET,0},
    {{NULL},"S_ft_SEARCH_PARAMETERS_SET", (char *) S_ft_SEARCH_PARAMETERS_SET,0},
    {{NULL},"S_ft_THRESHOLD_PARAMETERS_SET", (char *) S_ft_THRESHOLD_PARAMETERS_SET,0},
    {{NULL},"S_ft_CONTROLLER_PARAMETERS_SET", (char *) S_ft_CONTROLLER_PARAMETERS_SET,0},
    {{NULL},"S_gizmo_SHUTDOWN_ERROR", (char *) S_gizmo_SHUTDOWN_ERROR,0},
    {{NULL},"S_gizmo_SHUTTING_DOWN_GIZMO", (char *) S_gizmo_SHUTTING_DOWN_GIZMO,0},
    {{NULL},"S_gizmo_ALREADY_INITIALIZED", (char *) S_gizmo_ALREADY_INITIALIZED,0},
    {{NULL},"S_gizmo_ALREADY_SHUTDOWN", (char *) S_gizmo_ALREADY_SHUTDOWN,0},
    {{NULL},"S_gizmo_INIT_START", (char *) S_gizmo_INIT_START,0},
    {{NULL},"S_gizmo_INIT_COMPLETE", (char *) S_gizmo_INIT_COMPLETE,0},
    {{NULL},"S_gizmo_DESTRUCT_START", (char *) S_gizmo_DESTRUCT_START,0},
    {{NULL},"S_gizmo_DESTRUCT_COMPLETE", (char *) S_gizmo_DESTRUCT_COMPLETE,0},
    {{NULL},"S_gizmo_RESTART_START", (char *) S_gizmo_RESTART_START,0},
    {{NULL},"S_gizmo_RESTART_COMPLETE", (char *) S_gizmo_RESTART_COMPLETE,0},
    {{NULL},"S_gizmo_SHUTDOWN_START", (char *) S_gizmo_SHUTDOWN_START,0},
    {{NULL},"S_gizmo_SHUTDOWN_COMPLETE", (char *) S_gizmo_SHUTDOWN_COMPLETE,0},
    {{NULL},"S_hw_E_INVALID_BOARD_NUMBER", (char *) S_hw_E_INVALID_BOARD_NUMBER,0},
    {{NULL},"S_hw_E_ERROR_DURING_HARD_INIT", (char *) S_hw_E_ERROR_DURING_HARD_INIT,0},
    {{NULL},"S_hw_E_ERROR_DURING_SOFT_INIT", (char *) S_hw_E_ERROR_DURING_SOFT_INIT,0},
    {{NULL},"S_hw_E_VIRTUAL_FUNCTION_HARD_INIT_RAN", (char *) S_hw_E_VIRTUAL_FUNCTION_HARD_INIT_RAN,0},
    {{NULL},"S_hw_E_VIRTUAL_FUNCTION_SOFT_INIT_RAN", (char *) S_hw_E_VIRTUAL_FUNCTION_SOFT_INIT_RAN,0},
    {{NULL},"S_hw_E_INVALID_BOARD_TYPE", (char *) S_hw_E_INVALID_BOARD_TYPE,0},
    {{NULL},"S_hw_RETURNING_NULL_BOARD_POINTER", (char *) S_hw_RETURNING_NULL_BOARD_POINTER,0},
    {{NULL},"S_hw_GET_LOCAL_ADDRESS_ATTEMPTED_ON_NULL_VALUE", (char *) S_hw_GET_LOCAL_ADDRESS_ATTEMPTED_ON_NULL_VALUE,0},
    {{NULL},"S_hw_LOCAL_ADDRESS_SET_TO_ZERO", (char *) S_hw_LOCAL_ADDRESS_SET_TO_ZERO,0},
    {{NULL},"S_hw_CALLING_HARDINIT", (char *) S_hw_CALLING_HARDINIT,0},
    {{NULL},"S_hw_BACK_FROM_HARDINIT", (char *) S_hw_BACK_FROM_HARDINIT,0},
    {{NULL},"S_hw_CALLING_SOFTINIT", (char *) S_hw_CALLING_SOFTINIT,0},
    {{NULL},"S_hw_BACK_FROM_SOFTINIT", (char *) S_hw_BACK_FROM_SOFTINIT,0},
    {{NULL},"S_hw_RETURNING_NULL_CHANNEL_POINTER", (char *) S_hw_RETURNING_NULL_CHANNEL_POINTER,0},
    {{NULL},"S_hw_BUS_LOCK_TIMEOUT", (char *) S_hw_BUS_LOCK_TIMEOUT,0},
    {{NULL},"S_hw_ENTERING_HARDWARE_CONSTRUCTOR", (char *) S_hw_ENTERING_HARDWARE_CONSTRUCTOR,0},
    {{NULL},"S_hw_DONE_CONSTRUCTING_HARDWARE", (char *) S_hw_DONE_CONSTRUCTING_HARDWARE,0},
    {{NULL},"S_hw_ENTERING_HARDWARE_DESTRUCTOR", (char *) S_hw_ENTERING_HARDWARE_DESTRUCTOR,0},
    {{NULL},"S_hw_DONE_DESTRUCTING_HARDWARE", (char *) S_hw_DONE_DESTRUCTING_HARDWARE,0},
    {{NULL},"S_hw_ENTERING_HARDWARE_HARDINIT", (char *) S_hw_ENTERING_HARDWARE_HARDINIT,0},
    {{NULL},"S_hw_HARDWARE_INITIALIZED_HARDLY", (char *) S_hw_HARDWARE_INITIALIZED_HARDLY,0},
    {{NULL},"S_hw_ENTERING_HARDWARE_SOFTINIT", (char *) S_hw_ENTERING_HARDWARE_SOFTINIT,0},
    {{NULL},"S_hw_HARDWARE_INITIALIZED_SOFTLY", (char *) S_hw_HARDWARE_INITIALIZED_SOFTLY,0},
    {{NULL},"S_board_BOARD_ALREADY_INITIALIZED", (char *) S_board_BOARD_ALREADY_INITIALIZED,0},
    {{NULL},"S_board_INIT_ATTEMPTED_WITH_NULL_ADDRESS", (char *) S_board_INIT_ATTEMPTED_WITH_NULL_ADDRESS,0},
    {{NULL},"S_clock_E_CLOCK_ALREADY_INITIALIZED", (char *) S_clock_E_CLOCK_ALREADY_INITIALIZED,0},
    {{NULL},"S_clock_E_BOARD_NOT_INITIALIZED", (char *) S_clock_E_BOARD_NOT_INITIALIZED,0},
    {{NULL},"S_clock_E_BOARD_HAS_NO_CLOCK", (char *) S_clock_E_BOARD_HAS_NO_CLOCK,0},
    {{NULL},"S_interrupt_INTERRUPT_ALREADY_INITIALIZED", (char *) S_interrupt_INTERRUPT_ALREADY_INITIALIZED,0},
    {{NULL},"S_interrupt_BOARD_HAS_NO_INTERRUPT", (char *) S_interrupt_BOARD_HAS_NO_INTERRUPT,0},
    {{NULL},"S_interrupt_BOARD_NOT_INITIALIZED", (char *) S_interrupt_BOARD_NOT_INITIALIZED,0},
    {{NULL},"S_interrupt_W_INVALID_RATE", (char *) S_interrupt_W_INVALID_RATE,0},
    {{NULL},"S_interrupt_INT_NOT_INITIALIZED", (char *) S_interrupt_INT_NOT_INITIALIZED,0},
    {{NULL},"S_interrupt_NULL_FUNCTION_POINTER", (char *) S_interrupt_NULL_FUNCTION_POINTER,0},
    {{NULL},"S_interrupt_INT_ALREADY_CONNECTED", (char *) S_interrupt_INT_ALREADY_CONNECTED,0},
    {{NULL},"S_interrupt_INT_ALREADY_ENABLED", (char *) S_interrupt_INT_ALREADY_ENABLED,0},
    {{NULL},"S_interrupt_INT_NOT_CONNECTED", (char *) S_interrupt_INT_NOT_CONNECTED,0},
    {{NULL},"S_interrupt_INT_RATE_NOT_SET", (char *) S_interrupt_INT_RATE_NOT_SET,0},
    {{NULL},"S_interrupt_INT_NOT_ENABLED", (char *) S_interrupt_INT_NOT_ENABLED,0},
    {{NULL},"S_interrupt_INVALID_INTERRUPT_PRIORITY", (char *) S_interrupt_INVALID_INTERRUPT_PRIORITY,0},
    {{NULL},"S_interrupt_INVALID_INTERRUPT_VECTOR", (char *) S_interrupt_INVALID_INTERRUPT_VECTOR,0},
    {{NULL},"S_interrupt_RATE_SET_CALLED_USING_BASE_CLASS", (char *) S_interrupt_RATE_SET_CALLED_USING_BASE_CLASS,0},
    {{NULL},"S_tOutputChannel_CHANNEL_NOT_INITIALIZED", (char *) S_tOutputChannel_CHANNEL_NOT_INITIALIZED,0},
    {{NULL},"S_inputChannel_INVALID_CALL_TO_RESET", (char *) S_inputChannel_INVALID_CALL_TO_RESET,0},
    {{NULL},"S_channel_INVALID_CALL_TO_RESET", (char *) S_channel_INVALID_CALL_TO_RESET,0},
    {{NULL},"S_counterChannel_INVALID_CALL_TO_RESET", (char *) S_counterChannel_INVALID_CALL_TO_RESET,0},
    {{NULL},"S_tImageChannel_CHANNEL_NOT_INITIALIZED", (char *) S_tImageChannel_CHANNEL_NOT_INITIALIZED,0},
    {{NULL},"S_tFullImageChannel_CHANNEL_NOT_INITIALIZED", (char *) S_tFullImageChannel_CHANNEL_NOT_INITIALIZED,0},
    {{NULL},"S_tSubImageChannel_CHANNEL_NOT_INITIALIZED", (char *) S_tSubImageChannel_CHANNEL_NOT_INITIALIZED,0},
    {{NULL},"S_tSubImageChannel_CHANNEL_REGION_OUT_OF_RANGE", (char *) S_tSubImageChannel_CHANNEL_REGION_OUT_OF_RANGE,0},
    {{NULL},"S_tSubImageChannel_INVALID_FULL_IMAGE_CHANNEL", (char *) S_tSubImageChannel_INVALID_FULL_IMAGE_CHANNEL,0},
    {{NULL},"S_device_DEVICE_ALREADY_INITIALIZED", (char *) S_device_DEVICE_ALREADY_INITIALIZED,0},
    {{NULL},"S_actuator_ACTUATOR_ALREADY_INITIALIZED", (char *) S_actuator_ACTUATOR_ALREADY_INITIALIZED,0},
    {{NULL},"S_actuator_ACTUATOR_NOT_INITIALIZED", (char *) S_actuator_ACTUATOR_NOT_INITIALIZED,0},
    {{NULL},"S_sensor_SENSOR_ALREADY_INITIALIZED", (char *) S_sensor_SENSOR_ALREADY_INITIALIZED,0},
    {{NULL},"S_sensor_SENSOR_NOT_INITIALIZED", (char *) S_sensor_SENSOR_NOT_INITIALIZED,0},
    {{NULL},"S_sensor_CHANNEL_OUT_OF_RANGE", (char *) S_sensor_CHANNEL_OUT_OF_RANGE,0},
    {{NULL},"S_sensor_NULL_POINTER", (char *) S_sensor_NULL_POINTER,0},
    {{NULL},"S_dt1401_BOARD_ALREADY_INITIALIZED", (char *) S_dt1401_BOARD_ALREADY_INITIALIZED,0},
    {{NULL},"S_dt1401_INVALID_DA_CHANNEL", (char *) S_dt1401_INVALID_DA_CHANNEL,0},
    {{NULL},"S_pc03v_BOARD_ALREADY_INITIALIZED", (char *) S_pc03v_BOARD_ALREADY_INITIALIZED,0},
    {{NULL},"S_pc03v_E_BOARD_NOT_INITIALIZED", (char *) S_pc03v_E_BOARD_NOT_INITIALIZED,0},
    {{NULL},"S_pc03v_E_INTERRUPT_ALREADY_INITIALIZED", (char *) S_pc03v_E_INTERRUPT_ALREADY_INITIALIZED,0},
    {{NULL},"S_pc03v_E_BOARD_HAS_NO_INTERRUPT", (char *) S_pc03v_E_BOARD_HAS_NO_INTERRUPT,0},
    {{NULL},"S_pc03v_E_NULL_FUNCTION_POINTER", (char *) S_pc03v_E_NULL_FUNCTION_POINTER,0},
    {{NULL},"S_pc03v_E_INVALID_INT_SOURCE", (char *) S_pc03v_E_INVALID_INT_SOURCE,0},
    {{NULL},"S_pc03v_E_INVALID_INTERRUPT_NUMBER", (char *) S_pc03v_E_INVALID_INTERRUPT_NUMBER,0},
    {{NULL},"S_pc03v_CREATE_CHANNEL_ATTEMPTED", (char *) S_pc03v_CREATE_CHANNEL_ATTEMPTED,0},
    {{NULL},"S_pc03v_ENTERING_CONSTRUCTOR", (char *) S_pc03v_ENTERING_CONSTRUCTOR,0},
    {{NULL},"S_pc03v_DONE_CONSTRUCTING", (char *) S_pc03v_DONE_CONSTRUCTING,0},
    {{NULL},"S_pc03v_ENTERING_SOFTINIT", (char *) S_pc03v_ENTERING_SOFTINIT,0},
    {{NULL},"S_pc03v_INITIALIZED_SOFTLY", (char *) S_pc03v_INITIALIZED_SOFTLY,0},
    {{NULL},"S_pc03v_ENTERING_HARDINIT", (char *) S_pc03v_ENTERING_HARDINIT,0},
    {{NULL},"S_pc03v_INITIALIZED_HARDLY", (char *) S_pc03v_INITIALIZED_HARDLY,0},
    {{NULL},"S_laser_INVALID_COUNTER", (char *) S_laser_INVALID_COUNTER,0},
    {{NULL},"S_laser_NO_REFERENCE", (char *) S_laser_NO_REFERENCE,0},
    {{NULL},"S_laser_NO_64_MHZ", (char *) S_laser_NO_64_MHZ,0},
    {{NULL},"S_laser_NO_16_MHZ", (char *) S_laser_NO_16_MHZ,0},
    {{NULL},"S_laser_NO_2_MHZ", (char *) S_laser_NO_2_MHZ,0},
    {{NULL},"S_laser_NO_EXTERNAL_CLOCK", (char *) S_laser_NO_EXTERNAL_CLOCK,0},
    {{NULL},"S_laser_UNKNOWN_CLOCK_ERROR", (char *) S_laser_UNKNOWN_CLOCK_ERROR,0},
    {{NULL},"S_laser_UNKNOWN_NOT_PRESENT", (char *) S_laser_UNKNOWN_NOT_PRESENT,0},
    {{NULL},"S_laser_INIT_INVALID_ARGUMENT", (char *) S_laser_INIT_INVALID_ARGUMENT,0},
    {{NULL},"S_laser_INVALID_SYNC_MODE", (char *) S_laser_INVALID_SYNC_MODE,0},
    {{NULL},"S_laser_COUNTER_FAILED_POS_SLEW_TEST", (char *) S_laser_COUNTER_FAILED_POS_SLEW_TEST,0},
    {{NULL},"S_laser_COUNTER_FAILED_RET_TO_ZERO_TEST", (char *) S_laser_COUNTER_FAILED_RET_TO_ZERO_TEST,0},
    {{NULL},"S_laser_COUNTER_FAILED_NEG_SLEW_TEST", (char *) S_laser_COUNTER_FAILED_NEG_SLEW_TEST,0},
    {{NULL},"S_laser_COUNTER_FAILED_CLEAR_TEST", (char *) S_laser_COUNTER_FAILED_CLEAR_TEST,0},
    {{NULL},"S_laser_COUNTER_FAILED_FRACTION_TEST", (char *) S_laser_COUNTER_FAILED_FRACTION_TEST,0},
    {{NULL},"S_laser_INVALID_BOOL_VALUE", (char *) S_laser_INVALID_BOOL_VALUE,0},
    {{NULL},"S_laser_BOARD_NOT_INITIALIZED", (char *) S_laser_BOARD_NOT_INITIALIZED,0},
    {{NULL},"S_laser_NULL_POINTER_ARGUMENT", (char *) S_laser_NULL_POINTER_ARGUMENT,0},
    {{NULL},"S_laser_PLL_OUT_OF_LOCK", (char *) S_laser_PLL_OUT_OF_LOCK,0},
    {{NULL},"S_laser_INIT_INVALID_NUM_COUNTERS", (char *) S_laser_INIT_INVALID_NUM_COUNTERS,0},
    {{NULL},"S_laser_ERROR_IN_CLEAR_OR_LOAD", (char *) S_laser_ERROR_IN_CLEAR_OR_LOAD,0},
    {{NULL},"S_laser_RETURNING_NULL_CHANNEL_POINTER", (char *) S_laser_RETURNING_NULL_CHANNEL_POINTER,0},
    {{NULL},"S_laser_REF_CHANNEL_POINTER_SET_TO_NULL", (char *) S_laser_REF_CHANNEL_POINTER_SET_TO_NULL,0},
    {{NULL},"S_laser_ENTERING_CONSTRUCTOR", (char *) S_laser_ENTERING_CONSTRUCTOR,0},
    {{NULL},"S_laser_DONE_CONSTRUCTING", (char *) S_laser_DONE_CONSTRUCTING,0},
    {{NULL},"S_laser_ENTERING_SOFTINIT", (char *) S_laser_ENTERING_SOFTINIT,0},
    {{NULL},"S_laser_INITIALIZED_SOFTLY", (char *) S_laser_INITIALIZED_SOFTLY,0},
    {{NULL},"S_laser_ENTERING_HARDTINIT", (char *) S_laser_ENTERING_HARDTINIT,0},
    {{NULL},"S_laser_INITIALIZED_HARDLY", (char *) S_laser_INITIALIZED_HARDLY,0},
    {{NULL},"S_laser_CHECKING_CLOCKS", (char *) S_laser_CHECKING_CLOCKS,0},
    {{NULL},"S_laser_ENTERING_CHANNEL_INITIALIZE", (char *) S_laser_ENTERING_CHANNEL_INITIALIZE,0},
    {{NULL},"S_laser_CHANNEL_INITIALIZED", (char *) S_laser_CHANNEL_INITIALIZED,0},
    {{NULL},"S_pztMotor_INIT_INVALID_ARGUMENT", (char *) S_pztMotor_INIT_INVALID_ARGUMENT,0},
    {{NULL},"S_pztMotor_BOARD_NOT_INITIALIZED", (char *) S_pztMotor_BOARD_NOT_INITIALIZED,0},
    {{NULL},"S_pztMotor_INVALID_PZT", (char *) S_pztMotor_INVALID_PZT,0},
    {{NULL},"S_pztMotor_INVALID_MOTOR", (char *) S_pztMotor_INVALID_MOTOR,0},
    {{NULL},"S_pztMotor_INVALID_VELOCITY", (char *) S_pztMotor_INVALID_VELOCITY,0},
    {{NULL},"S_pztMotor_INVALID_PRESCALE", (char *) S_pztMotor_INVALID_PRESCALE,0},
    {{NULL},"S_pztMotor_INVALID_PZT_POSITION", (char *) S_pztMotor_INVALID_PZT_POSITION,0},
    {{NULL},"S_pztMotor_INIT_PZT_CONFIGURATION_MISMATCH", (char *) S_pztMotor_INIT_PZT_CONFIGURATION_MISMATCH,0},
    {{NULL},"S_pztMotor_INIT_MOTOR_CONFIGURATION_MISMATCH", (char *) S_pztMotor_INIT_MOTOR_CONFIGURATION_MISMATCH,0},
    {{NULL},"S_pztMotor_E_INVALID_NUMBER_OF_PZTS", (char *) S_pztMotor_E_INVALID_NUMBER_OF_PZTS,0},
    {{NULL},"S_pztMotor_E_INVALID_NUMBER_OF_MOTORS", (char *) S_pztMotor_E_INVALID_NUMBER_OF_MOTORS,0},
    {{NULL},"S_pztMotor_INVALID_LIMIT_TYPE", (char *) S_pztMotor_INVALID_LIMIT_TYPE,0},
    {{NULL},"S_pztMotor_CHANNEL_NOT_INITIALIZED", (char *) S_pztMotor_CHANNEL_NOT_INITIALIZED,0},
    {{NULL},"S_pztMotor_E_INVALID_NUMBER_OF_LIMITS", (char *) S_pztMotor_E_INVALID_NUMBER_OF_LIMITS,0},
    {{NULL},"S_pztMotor_CHANNEL_NUM_OUT_OF_RANGE", (char *) S_pztMotor_CHANNEL_NUM_OUT_OF_RANGE,0},
    {{NULL},"S_pztMotor_PZT_CHANNEL_NUM_OUT_OF_RANGE", (char *) S_pztMotor_PZT_CHANNEL_NUM_OUT_OF_RANGE,0},
    {{NULL},"S_pztMotor_MOTOR_CHANNEL_NUM_OUT_OF_RANGE", (char *) S_pztMotor_MOTOR_CHANNEL_NUM_OUT_OF_RANGE,0},
    {{NULL},"S_pztMotor_PZT_READBACK_CHANNEL_NUM_OUT_OF_RANGE", (char *) S_pztMotor_PZT_READBACK_CHANNEL_NUM_OUT_OF_RANGE,0},
    {{NULL},"S_pztMotor_MOTOR_READBACK_CHANNEL_NUM_OUT_OF_RANGE", (char *) S_pztMotor_MOTOR_READBACK_CHANNEL_NUM_OUT_OF_RANGE,0},
    {{NULL},"S_pztMotor_LIMIT_CHANNEL_NUM_OUT_OF_RANGE", (char *) S_pztMotor_LIMIT_CHANNEL_NUM_OUT_OF_RANGE,0},
    {{NULL},"S_pztMotor_INVALID_CHANNEL_NUM", (char *) S_pztMotor_INVALID_CHANNEL_NUM,0},
    {{NULL},"S_pztMotor_CALLING_SOFT_INIT", (char *) S_pztMotor_CALLING_SOFT_INIT,0},
    {{NULL},"S_pztMotor_ENTERING_CONSTRUCTOR", (char *) S_pztMotor_ENTERING_CONSTRUCTOR,0},
    {{NULL},"S_pztMotor_DONE_CONSTRUCTING", (char *) S_pztMotor_DONE_CONSTRUCTING,0},
    {{NULL},"S_pztMotor_ENTERING_SOFTINIT", (char *) S_pztMotor_ENTERING_SOFTINIT,0},
    {{NULL},"S_pztMotor_INITIALIZING_DA_CHANNEL_ARRAY", (char *) S_pztMotor_INITIALIZING_DA_CHANNEL_ARRAY,0},
    {{NULL},"S_pztMotor_INITIALIZING_MOTOR_CHANNEL_ARRAY", (char *) S_pztMotor_INITIALIZING_MOTOR_CHANNEL_ARRAY,0},
    {{NULL},"S_pztMotor_INITIALIZING_LIMIT_CHANNEL_ARRAY", (char *) S_pztMotor_INITIALIZING_LIMIT_CHANNEL_ARRAY,0},
    {{NULL},"S_pztMotor_INITIALIZED_SOFTLY", (char *) S_pztMotor_INITIALIZED_SOFTLY,0},
    {{NULL},"S_pztMotor_ENTERING_HARDINIT", (char *) S_pztMotor_ENTERING_HARDINIT,0},
    {{NULL},"S_pztMotor_INITIALIZED_HARDLY", (char *) S_pztMotor_INITIALIZED_HARDLY,0},
    {{NULL},"S_pztMotor_ENTERING_RAMP_CHANNEL_CONSTRUCTOR", (char *) S_pztMotor_ENTERING_RAMP_CHANNEL_CONSTRUCTOR,0},
    {{NULL},"S_pztMotor_DONE_CONSTRUCTING_RAMP_CHANNEL", (char *) S_pztMotor_DONE_CONSTRUCTING_RAMP_CHANNEL,0},
    {{NULL},"S_pztMotor_ENTERING_RAMP_CHANNEL_INITIALIZE", (char *) S_pztMotor_ENTERING_RAMP_CHANNEL_INITIALIZE,0},
    {{NULL},"S_pztMotor_CALLING_DA_CHANNEL_INITIALIZE", (char *) S_pztMotor_CALLING_DA_CHANNEL_INITIALIZE,0},
    {{NULL},"S_pztMotor_DONE_INITIALIZING_RAMP_CHANNEL", (char *) S_pztMotor_DONE_INITIALIZING_RAMP_CHANNEL,0},
    {{NULL},"S_pztMotor_ENTERING_DA_CHANNEL_CONSTRUCTOR", (char *) S_pztMotor_ENTERING_DA_CHANNEL_CONSTRUCTOR,0},
    {{NULL},"S_pztMotor_DONE_CONSTRUCTING_DA_CHANNEL", (char *) S_pztMotor_DONE_CONSTRUCTING_DA_CHANNEL,0},
    {{NULL},"S_pztMotor_ENTERING_DA_CHANNEL_INITIALIZE", (char *) S_pztMotor_ENTERING_DA_CHANNEL_INITIALIZE,0},
    {{NULL},"S_pztMotor_DONE_INITIALIZING_DA_CHANNEL", (char *) S_pztMotor_DONE_INITIALIZING_DA_CHANNEL,0},
    {{NULL},"S_pztMotor_ENTERING_MOTOR_READBACK_CHANNEL_CONSTRUCTOR", (char *) S_pztMotor_ENTERING_MOTOR_READBACK_CHANNEL_CONSTRUCTOR,0},
    {{NULL},"S_pztMotor_DONE_CONSTRUCTING_MOTOR_READBACK_CHANNEL", (char *) S_pztMotor_DONE_CONSTRUCTING_MOTOR_READBACK_CHANNEL,0},
    {{NULL},"S_pztMotor_ENTERING_MOTOR_READBACK_CHANNEL_INITIALIZE", (char *) S_pztMotor_ENTERING_MOTOR_READBACK_CHANNEL_INITIALIZE,0},
    {{NULL},"S_pztMotor_DONE_INITIALIZING_MOTOR_READBACK_CHANNEL", (char *) S_pztMotor_DONE_INITIALIZING_MOTOR_READBACK_CHANNEL,0},
    {{NULL},"S_pztMotor_ENTERING_MOTOR_CHANNEL_CONSTRUCTOR", (char *) S_pztMotor_ENTERING_MOTOR_CHANNEL_CONSTRUCTOR,0},
    {{NULL},"S_pztMotor_DONE_CONSTRUCTING_MOTOR_CHANNEL", (char *) S_pztMotor_DONE_CONSTRUCTING_MOTOR_CHANNEL,0},
    {{NULL},"S_pztMotor_ENTERING_MOTOR_CHANNEL_INITIALIZE", (char *) S_pztMotor_ENTERING_MOTOR_CHANNEL_INITIALIZE,0},
    {{NULL},"S_pztMotor_DONE_INITIALIZING_MOTOR_CHANNEL", (char *) S_pztMotor_DONE_INITIALIZING_MOTOR_CHANNEL,0},
    {{NULL},"S_pztMotor_ENTERING_DI_CHANNEL_CONSTRUCTOR", (char *) S_pztMotor_ENTERING_DI_CHANNEL_CONSTRUCTOR,0},
    {{NULL},"S_pztMotor_DONE_CONSTRUCTING_DI_CHANNEL", (char *) S_pztMotor_DONE_CONSTRUCTING_DI_CHANNEL,0},
    {{NULL},"S_pztMotor_ENTERING_DI_CHANNEL_INITIALIZE", (char *) S_pztMotor_ENTERING_DI_CHANNEL_INITIALIZE,0},
    {{NULL},"S_pztMotor_DONE_INITIALIZING_DI_CHANNEL", (char *) S_pztMotor_DONE_INITIALIZING_DI_CHANNEL,0},
    {{NULL},"S_mpv955_CHANNEL_BANK_NOT_INITIALIZED", (char *) S_mpv955_CHANNEL_BANK_NOT_INITIALIZED,0},
    {{NULL},"S_mpv955_INVALID_TRIGGER_SELECT_VALUE", (char *) S_mpv955_INVALID_TRIGGER_SELECT_VALUE,0},
    {{NULL},"S_mpv955_INVALID_TRIGGER_TYPE_VALUE", (char *) S_mpv955_INVALID_TRIGGER_TYPE_VALUE,0},
    {{NULL},"S_mpv955_INVALID_SCAN_MODE_VALUE", (char *) S_mpv955_INVALID_SCAN_MODE_VALUE,0},
    {{NULL},"S_mpv955_INVALID_TIMEOUT_VALUE", (char *) S_mpv955_INVALID_TIMEOUT_VALUE,0},
    {{NULL},"S_mpv955_INVALID_NUMBER_OF_CHANNELS", (char *) S_mpv955_INVALID_NUMBER_OF_CHANNELS,0},
    {{NULL},"S_mpv955_INVALID_WAVEFORM_SIZE", (char *) S_mpv955_INVALID_WAVEFORM_SIZE,0},
    {{NULL},"S_mpv955_RETURNING_NULL_CHANNEL_POINTER", (char *) S_mpv955_RETURNING_NULL_CHANNEL_POINTER,0},
    {{NULL},"S_mpv955_ZERO_OR_NEGATIVE_PERIOD", (char *) S_mpv955_ZERO_OR_NEGATIVE_PERIOD,0},
    {{NULL},"S_mpv955_PERIOD_ADJUSTED", (char *) S_mpv955_PERIOD_ADJUSTED,0},
    {{NULL},"S_mpv955_ENTERING_CONSTRUCTOR", (char *) S_mpv955_ENTERING_CONSTRUCTOR,0},
    {{NULL},"S_mpv955_DONE_CONSTRUCTING", (char *) S_mpv955_DONE_CONSTRUCTING,0},
    {{NULL},"S_mpv955_ENTERING_SOFTINIT", (char *) S_mpv955_ENTERING_SOFTINIT,0},
    {{NULL},"S_mpv955_INITIALIZED_SOFTLY", (char *) S_mpv955_INITIALIZED_SOFTLY,0},
    {{NULL},"S_mpv955_ENTERING_HARDINIT", (char *) S_mpv955_ENTERING_HARDINIT,0},
    {{NULL},"S_mpv955_INITIALIZED_HARDLY", (char *) S_mpv955_INITIALIZED_HARDLY,0},
    {{NULL},"S_mpv955_ENTERING_CHANNELBANK_INITIALIZE", (char *) S_mpv955_ENTERING_CHANNELBANK_INITIALIZE,0},
    {{NULL},"S_mpv955_CHANNELBANK_INITIALIZED", (char *) S_mpv955_CHANNELBANK_INITIALIZED,0},
    {{NULL},"S_mpv955_ENTERING_CHANNEL_INITIALIZE", (char *) S_mpv955_ENTERING_CHANNEL_INITIALIZE,0},
    {{NULL},"S_mpv955_CHANNEL_INITIALIZED", (char *) S_mpv955_CHANNEL_INITIALIZED,0},
    {{NULL},"S_mpv955_SETTING_SAMPLE_PERIOD", (char *) S_mpv955_SETTING_SAMPLE_PERIOD,0},
    {{NULL},"S_mpv955_SAMPLE_PERIOD_SET", (char *) S_mpv955_SAMPLE_PERIOD_SET,0},
    {{NULL},"S_mpv955_START_STOP_ADDRESSES_SET", (char *) S_mpv955_START_STOP_ADDRESSES_SET,0},
    {{NULL},"S_mpv906_CHANNEL_BANK_NOT_INITIALIZED", (char *) S_mpv906_CHANNEL_BANK_NOT_INITIALIZED,0},
    {{NULL},"S_mpv906_CHANNEL_NUMBER_OUT_OF_RANGE", (char *) S_mpv906_CHANNEL_NUMBER_OUT_OF_RANGE,0},
    {{NULL},"S_mpv906_INVALID_GAIN", (char *) S_mpv906_INVALID_GAIN,0},
    {{NULL},"S_mpv906_INVALID_START_CHANNEL_VALUE", (char *) S_mpv906_INVALID_START_CHANNEL_VALUE,0},
    {{NULL},"S_mpv906_INVALID_SCAN_MODE", (char *) S_mpv906_INVALID_SCAN_MODE,0},
    {{NULL},"S_mpv906_INVALID_TRIGGER_SELECT_VALUE", (char *) S_mpv906_INVALID_TRIGGER_SELECT_VALUE,0},
    {{NULL},"S_mpv906_CANNOT_STOP_MPV906_SCAN", (char *) S_mpv906_CANNOT_STOP_MPV906_SCAN,0},
    {{NULL},"S_mpv906_INVALID_NUMBER_OF_CHANNELS", (char *) S_mpv906_INVALID_NUMBER_OF_CHANNELS,0},
    {{NULL},"S_mpv906_ENTERING_CONSTRUCTOR", (char *) S_mpv906_ENTERING_CONSTRUCTOR,0},
    {{NULL},"S_mpv906_DONE_CONSTRUCTING", (char *) S_mpv906_DONE_CONSTRUCTING,0},
    {{NULL},"S_mpv906_ENTERING_SOFTINIT", (char *) S_mpv906_ENTERING_SOFTINIT,0},
    {{NULL},"S_mpv906_INITIALIZED_SOFTLY", (char *) S_mpv906_INITIALIZED_SOFTLY,0},
    {{NULL},"S_mpv906_ENTERING_HARDINIT", (char *) S_mpv906_ENTERING_HARDINIT,0},
    {{NULL},"S_mpv906_INITIALZED_HARDLY", (char *) S_mpv906_INITIALZED_HARDLY,0},
    {{NULL},"S_mpv906_ENTERING_CHANNELBANK_INITIALIZE", (char *) S_mpv906_ENTERING_CHANNELBANK_INITIALIZE,0},
    {{NULL},"S_mpv906_DONE_INITIALIZING_CHANNELBANK", (char *) S_mpv906_DONE_INITIALIZING_CHANNELBANK,0},
    {{NULL},"S_mpv906_ENTERING_CHANNEL_INITIALIZE", (char *) S_mpv906_ENTERING_CHANNEL_INITIALIZE,0},
    {{NULL},"S_mpv906_DONE_INITIALIZING_CHANNEL", (char *) S_mpv906_DONE_INITIALIZING_CHANNEL,0},
    {{NULL},"S_dvme626_RETURNING_NULL_CHANNEL_POINTER", (char *) S_dvme626_RETURNING_NULL_CHANNEL_POINTER,0},
    {{NULL},"S_dvme626_ENTERING_CONSTRUCTOR", (char *) S_dvme626_ENTERING_CONSTRUCTOR,0},
    {{NULL},"S_dvme626_FINISHED_CONSTRUCTING", (char *) S_dvme626_FINISHED_CONSTRUCTING,0},
    {{NULL},"S_dvme626_ENTERING_SOFTINIT", (char *) S_dvme626_ENTERING_SOFTINIT,0},
    {{NULL},"S_dvme626_INITIALIZED_SOFTLY", (char *) S_dvme626_INITIALIZED_SOFTLY,0},
    {{NULL},"S_dvme626_ENTERING_HARDINIT", (char *) S_dvme626_ENTERING_HARDINIT,0},
    {{NULL},"S_dvme626_INITIALIZED_HARDLY", (char *) S_dvme626_INITIALIZED_HARDLY,0},
    {{NULL},"S_dvme626_ENTERING_CHANNEL_INITIALIZE", (char *) S_dvme626_ENTERING_CHANNEL_INITIALIZE,0},
    {{NULL},"S_dvme626_CHANNEL_INITIALIZED", (char *) S_dvme626_CHANNEL_INITIALIZED,0},
    {{NULL},"S_dvme626_INVALID_NUMBER_OF_CHANNELS", (char *) S_dvme626_INVALID_NUMBER_OF_CHANNELS,0},
    {{NULL},"S_mm6216_MEMORY_SIZE_NOT_4_BYTE_ALIGNED", (char *) S_mm6216_MEMORY_SIZE_NOT_4_BYTE_ALIGNED,0},
    {{NULL},"S_mm6216_ENTERING_CONSTRUCTOR", (char *) S_mm6216_ENTERING_CONSTRUCTOR,0},
    {{NULL},"S_mm6216_DONE_CONSTRUCING", (char *) S_mm6216_DONE_CONSTRUCING,0},
    {{NULL},"S_mm6216_ENTERING_SOFTINIT", (char *) S_mm6216_ENTERING_SOFTINIT,0},
    {{NULL},"S_mm6216_INITIALIZED_SOFTLY", (char *) S_mm6216_INITIALIZED_SOFTLY,0},
    {{NULL},"S_mm6216_ENTERING_HARDINIT", (char *) S_mm6216_ENTERING_HARDINIT,0},
    {{NULL},"S_mm6216_INITIALZED_HARDLY", (char *) S_mm6216_INITIALZED_HARDLY,0},
    {{NULL},"S_tVip640aFullImageChannel_CHANNEL_ALREADY_INITIALIZED", (char *) S_tVip640aFullImageChannel_CHANNEL_ALREADY_INITIALIZED,0},
    {{NULL},"S_tVip640aFullImageChannel_CHANNEL_NOT_INITIALIZED", (char *) S_tVip640aFullImageChannel_CHANNEL_NOT_INITIALIZED,0},
    {{NULL},"S_tVip640aFullImageChannel_CHANNEL_CAPTURE_NOT_STARTED", (char *) S_tVip640aFullImageChannel_CHANNEL_CAPTURE_NOT_STARTED,0},
    {{NULL},"S_tVip640aFullImageChannel_CHANNEL_CAPTURE_TIMEOUT", (char *) S_tVip640aFullImageChannel_CHANNEL_CAPTURE_TIMEOUT,0},
    {{NULL},"S_tVip640aBoard_BOARD_NOT_INITIALIZED", (char *) S_tVip640aBoard_BOARD_NOT_INITIALIZED,0},
    {{NULL},"S_tVip640aBoard_RETURNING_NULL_CHANNEL_POINTER", (char *) S_tVip640aBoard_RETURNING_NULL_CHANNEL_POINTER,0},
    {{NULL},"S_tImage_BUFFER_SIZE_DOES_NOT_MATCH", (char *) S_tImage_BUFFER_SIZE_DOES_NOT_MATCH,0},
    {{NULL},"S_tImage_IMAGE_NOT_YET_LOADED", (char *) S_tImage_IMAGE_NOT_YET_LOADED,0},
    {{NULL},"S_tImage_IMAGE_MEMORY_ALLOCATION_FAILED", (char *) S_tImage_IMAGE_MEMORY_ALLOCATION_FAILED,0},
    {{NULL},"S_tImage_INVALID_DIMENSIONS", (char *) S_tImage_INVALID_DIMENSIONS,0},
    {{NULL},"S_tImage_INVALID_POINT", (char *) S_tImage_INVALID_POINT,0},
    {{NULL},"S_tImage_DONE_CONSTRUCTING", (char *) S_tImage_DONE_CONSTRUCTING,0},
    {{NULL},"S_tImage_DONE_DESTRUCTING", (char *) S_tImage_DONE_DESTRUCTING,0},
    {{NULL},"S_tImage_IMAGE_LOADED", (char *) S_tImage_IMAGE_LOADED,0},
    {{NULL},"S_tImage_RESIZING_IMAGE", (char *) S_tImage_RESIZING_IMAGE,0},
    {{NULL},"S_tImage_IMAGE_COPIED", (char *) S_tImage_IMAGE_COPIED,0},
    {{NULL},"S_tImage_ENSURING_IMAGE_BUFFER_EXIST", (char *) S_tImage_ENSURING_IMAGE_BUFFER_EXIST,0},
    {{NULL},"S_ipQuad_INVALID_NUMBER_OF_CHANNELS", (char *) S_ipQuad_INVALID_NUMBER_OF_CHANNELS,0},
    {{NULL},"S_ipQuad_RETURNING_NULL_CHANNEL_POINTER", (char *) S_ipQuad_RETURNING_NULL_CHANNEL_POINTER,0},
    {{NULL},"S_ipQuad_INVALID_BOARD_NUM", (char *) S_ipQuad_INVALID_BOARD_NUM,0},
    {{NULL},"S_ipQuad_ENTERING_CONSTRUCTOR", (char *) S_ipQuad_ENTERING_CONSTRUCTOR,0},
    {{NULL},"S_ipQuad_FINISHED_CONSTRUCTING", (char *) S_ipQuad_FINISHED_CONSTRUCTING,0},
    {{NULL},"S_ipQuad_ENTERING_SOFTINIT", (char *) S_ipQuad_ENTERING_SOFTINIT,0},
    {{NULL},"S_ipQuad_INITIALIZED_SOFTLY", (char *) S_ipQuad_INITIALIZED_SOFTLY,0},
    {{NULL},"S_ipQuad_ENTERING_HARDINIT", (char *) S_ipQuad_ENTERING_HARDINIT,0},
    {{NULL},"S_ipQuad_INITIALIZED_HARDLY", (char *) S_ipQuad_INITIALIZED_HARDLY,0},
    {{NULL},"S_ipQuad_ENTERING_CHANNEL_INITIALIZE", (char *) S_ipQuad_ENTERING_CHANNEL_INITIALIZE,0},
    {{NULL},"S_ipQuad_CHANNEL_INITIALIZED", (char *) S_ipQuad_CHANNEL_INITIALIZED,0},
    {{NULL},"S_ip16Dac_INVALID_NUMBER_OF_CHANNELS", (char *) S_ip16Dac_INVALID_NUMBER_OF_CHANNELS,0},
    {{NULL},"S_ip16Dac_RETURNING_NULL_CHANNEL_POINTER", (char *) S_ip16Dac_RETURNING_NULL_CHANNEL_POINTER,0},
    {{NULL},"S_ip16Dac_INVALID_BOARD_NUM", (char *) S_ip16Dac_INVALID_BOARD_NUM,0},
    {{NULL},"S_ip16Dac_INVALID_BOARD_ID", (char *) S_ip16Dac_INVALID_BOARD_ID,0},
    {{NULL},"S_ip16Dac_ENTERING_CONSTRUCTOR", (char *) S_ip16Dac_ENTERING_CONSTRUCTOR,0},
    {{NULL},"S_ip16Dac_FINISHED_CONSTRUCTING", (char *) S_ip16Dac_FINISHED_CONSTRUCTING,0},
    {{NULL},"S_ip16Dac_ENTERING_SOFTINIT", (char *) S_ip16Dac_ENTERING_SOFTINIT,0},
    {{NULL},"S_ip16Dac_INITIALIZED_SOFTLY", (char *) S_ip16Dac_INITIALIZED_SOFTLY,0},
    {{NULL},"S_ip16Dac_ENTERING_HARDINIT", (char *) S_ip16Dac_ENTERING_HARDINIT,0},
    {{NULL},"S_ip16Dac_INITIALIZED_HARDLY", (char *) S_ip16Dac_INITIALIZED_HARDLY,0},
    {{NULL},"S_ip16Dac_ENTERING_CHANNEL_INITIALIZE", (char *) S_ip16Dac_ENTERING_CHANNEL_INITIALIZE,0},
    {{NULL},"S_ip16Dac_CHANNEL_INITIALIZED", (char *) S_ip16Dac_CHANNEL_INITIALIZED,0},
    {{NULL},"S_ip16Dac_ENTERING_VERIFIER", (char *) S_ip16Dac_ENTERING_VERIFIER,0},
    {{NULL},"S_ip16Dac_FINISHED_VERIFYING", (char *) S_ip16Dac_FINISHED_VERIFYING,0},
    {{NULL},"S_ip16Dac_BOARD_ID", (char *) S_ip16Dac_BOARD_ID,0},
    {{NULL},"S_tim_BOARD_ALREADY_INITIALIZED", (char *) S_tim_BOARD_ALREADY_INITIALIZED,0},
    {{NULL},"S_tim_CHANNEL_NOT_INITIALIZED", (char *) S_tim_CHANNEL_NOT_INITIALIZED,0},
    {{NULL},"S_tim_RETURNING_NULL_CHANNEL_POINTER", (char *) S_tim_RETURNING_NULL_CHANNEL_POINTER,0},
    {{NULL},"S_tim_CREATE_CHANNEL_ATTEMPTED", (char *) S_tim_CREATE_CHANNEL_ATTEMPTED,0},
    {{NULL},"S_tim_TIME_IS_JUMPING_BY_MORE_THAN_ONE_SEC", (char *) S_tim_TIME_IS_JUMPING_BY_MORE_THAN_ONE_SEC,0},
    {{NULL},"S_tim_NULL_BOARD_POINTER_PASSED_TO_INITIALIZE", (char *) S_tim_NULL_BOARD_POINTER_PASSED_TO_INITIALIZE,0},
    {{NULL},"S_tim_ENTERING_CONSTRUCTOR", (char *) S_tim_ENTERING_CONSTRUCTOR,0},
    {{NULL},"S_tim_DONE_CONSTRUCTING", (char *) S_tim_DONE_CONSTRUCTING,0},
    {{NULL},"S_tim_ENTERING_SOFTINIT", (char *) S_tim_ENTERING_SOFTINIT,0},
    {{NULL},"S_tim_INITIALIZED_SOFTLY", (char *) S_tim_INITIALIZED_SOFTLY,0},
    {{NULL},"S_tim_ENTERING_HARDINIT", (char *) S_tim_ENTERING_HARDINIT,0},
    {{NULL},"S_tim_INITIALIZED_HARDLY", (char *) S_tim_INITIALIZED_HARDLY,0},
    {{NULL},"S_imagestatus_INCORRECT_IMAGE_SIZE", (char *) S_imagestatus_INCORRECT_IMAGE_SIZE,0},
    {{NULL},"S_inputSource_TSENSOR_CONSTRUCTOR", (char *) S_inputSource_TSENSOR_CONSTRUCTOR,0},
    {{NULL},"S_inputSource_TSENSOR_PHYSICAL_UNITS_PER_COUNT", (char *) S_inputSource_TSENSOR_PHYSICAL_UNITS_PER_COUNT,0},
    {{NULL},"S_inputSource_TSENSOR_RESET", (char *) S_inputSource_TSENSOR_RESET,0},
    {{NULL},"S_inputSource_TMODULATIONSOURCE_CONSTRUCTOR", (char *) S_inputSource_TMODULATIONSOURCE_CONSTRUCTOR,0},
    {{NULL},"S_inputSource_TMODULATIONSOURCE_SET_MODULATION_PARAMETERS", (char *) S_inputSource_TMODULATIONSOURCE_SET_MODULATION_PARAMETERS,0},
    {{NULL},"S_inputSource_TMODULATIONSOURCE_GET_MODULATION_PARAMETERS", (char *) S_inputSource_TMODULATIONSOURCE_GET_MODULATION_PARAMETERS,0},
    {{NULL},"S_inputSource_TMODULATIONSOURCE_RESET", (char *) S_inputSource_TMODULATIONSOURCE_RESET,0},
    {{NULL},"S_inputSource_TMODULATEDSENSOR_CONSTRUCTOR", (char *) S_inputSource_TMODULATEDSENSOR_CONSTRUCTOR,0},
    {{NULL},"S_inputSource_TMODULATEDSENSOR_SET_MODULATION", (char *) S_inputSource_TMODULATEDSENSOR_SET_MODULATION,0},
    {{NULL},"S_inputSource_TMODULATEDSENSOR_GET_MODULATION", (char *) S_inputSource_TMODULATEDSENSOR_GET_MODULATION,0},
    {{NULL},"S_instcds_UNRECOGNIZED_COMMAND", (char *) S_instcds_UNRECOGNIZED_COMMAND,0},
    {{NULL},"S_instcds_CANT_ALLOCATE_TARGET_BUFFERS", (char *) S_instcds_CANT_ALLOCATE_TARGET_BUFFERS,0},
    {{NULL},"S_instcds_GIZMO_NOT_INITIALIZED", (char *) S_instcds_GIZMO_NOT_INITIALIZED,0},
    {{NULL},"S_instcds_INVALID_DELAY_LINE_ID", (char *) S_instcds_INVALID_DELAY_LINE_ID,0},
    {{NULL},"S_instcds_GIZMO_NOT_SHUT_DOWN", (char *) S_instcds_GIZMO_NOT_SHUT_DOWN,0},
    {{NULL},"S_instcds_GIZMO_ALREADY_SHUTDOWN", (char *) S_instcds_GIZMO_ALREADY_SHUTDOWN,0},
    {{NULL},"S_instcds_GIZMO_ALREADY_INITIALIZED", (char *) S_instcds_GIZMO_ALREADY_INITIALIZED,0},
    {{NULL},"S_instcds_MANUAL_TARGET_SET", (char *) S_instcds_MANUAL_TARGET_SET,0},
    {{NULL},"S_instcds_OPEN_LOOP_TARGET_SET", (char *) S_instcds_OPEN_LOOP_TARGET_SET,0},
    {{NULL},"S_ping_INSTRUMENT_CDS_ALIVE", (char *) S_ping_INSTRUMENT_CDS_ALIVE,0},
    {{NULL},"S_instcds_TIME_SET", (char *) S_instcds_TIME_SET,0},
    {{NULL},"S_gizmoInfo_BAD_DYNAMIC_DOWNCAST", (char *) S_gizmoInfo_BAD_DYNAMIC_DOWNCAST,0},
    {{NULL},"S_ipc_CANT_CREATE_LOCAL_MEMORY_POOL", (char *) S_ipc_CANT_CREATE_LOCAL_MEMORY_POOL,0},
    {{NULL},"S_ipc_CANT_CREATE_SHARED_MEMORY_POOL", (char *) S_ipc_CANT_CREATE_SHARED_MEMORY_POOL,0},
    {{NULL},"S_ipc_CANT_CREATE_TOKEN_CLIENT", (char *) S_ipc_CANT_CREATE_TOKEN_CLIENT,0},
    {{NULL},"S_ipc_UNKNOWN_MEMORY_TYPE", (char *) S_ipc_UNKNOWN_MEMORY_TYPE,0},
    {{NULL},"S_ipc_CANT_ALLOCATE_LOCAL_OBJECT", (char *) S_ipc_CANT_ALLOCATE_LOCAL_OBJECT,0},
    {{NULL},"S_ipc_CANT_ALLOCATE_SHARED_MEMORY_OBJECT", (char *) S_ipc_CANT_ALLOCATE_SHARED_MEMORY_OBJECT,0},
    {{NULL},"S_ipc_INSUFFICIENT_LOCAL_MEMORY", (char *) S_ipc_INSUFFICIENT_LOCAL_MEMORY,0},
    {{NULL},"S_ipc_INSUFFICIENT_SHARED_MEMORY", (char *) S_ipc_INSUFFICIENT_SHARED_MEMORY,0},
    {{NULL},"S_ipc_LOCAL_MEMORY_NOT_INITIALIZED", (char *) S_ipc_LOCAL_MEMORY_NOT_INITIALIZED,0},
    {{NULL},"S_ipc_OBJECT_MISMATCH", (char *) S_ipc_OBJECT_MISMATCH,0},
    {{NULL},"S_ipc_TOKEN_SERVER_SPAWN_FAILED", (char *) S_ipc_TOKEN_SERVER_SPAWN_FAILED,0},
    {{NULL},"S_ipc_UNTYPED_GET_INTERNAL_ERROR", (char *) S_ipc_UNTYPED_GET_INTERNAL_ERROR,0},
    {{NULL},"S_ipc_MULTI_TYPE_FIFO_GET_NO_DATA", (char *) S_ipc_MULTI_TYPE_FIFO_GET_NO_DATA,0},
    {{NULL},"S_ipc_INTERNAL_PUT_ERROR", (char *) S_ipc_INTERNAL_PUT_ERROR,0},
    {{NULL},"S_ipc_OBJECT_NOT_ENABLED", (char *) S_ipc_OBJECT_NOT_ENABLED,0},
    {{NULL},"S_ipc_UNSUPPORTED_GET_OPERATION", (char *) S_ipc_UNSUPPORTED_GET_OPERATION,0},
    {{NULL},"S_ipc_UNSUPPORTED_PUT_OPERATION", (char *) S_ipc_UNSUPPORTED_PUT_OPERATION,0},
    {{NULL},"S_ipc_BUFFER_EMPTY", (char *) S_ipc_BUFFER_EMPTY,0},
    {{NULL},"S_ipc_FIFO_EMPTY", (char *) S_ipc_FIFO_EMPTY,0},
    {{NULL},"S_ipc_FIFO_FULL", (char *) S_ipc_FIFO_FULL,0},
    {{NULL},"S_ipc_TOO_FEW_ELEMENTS_IN_FIFO", (char *) S_ipc_TOO_FEW_ELEMENTS_IN_FIFO,0},
    {{NULL},"S_ipc_TOO_MANY_ELEMENTS_IN_FIFO", (char *) S_ipc_TOO_MANY_ELEMENTS_IN_FIFO,0},
    {{NULL},"S_ipc_LOCAL_MEMORY_ALREADY_INTIALIZED", (char *) S_ipc_LOCAL_MEMORY_ALREADY_INTIALIZED,0},
    {{NULL},"S_ipc_SHUTTING_DOWN_MEMORY", (char *) S_ipc_SHUTTING_DOWN_MEMORY,0},
    {{NULL},"S_object_CREATING_ATOM", (char *) S_object_CREATING_ATOM,0},
    {{NULL},"S_object_CREATING_DOUBLE_BUFFER", (char *) S_object_CREATING_DOUBLE_BUFFER,0},
    {{NULL},"S_object_CREATING_FIFO", (char *) S_object_CREATING_FIFO,0},
    {{NULL},"S_ipc_LOCAL_OBJECT_ALLOCATE_START", (char *) S_ipc_LOCAL_OBJECT_ALLOCATE_START,0},
    {{NULL},"S_ipc_LOCAL_OBJECT_ALLOCATE_DONE", (char *) S_ipc_LOCAL_OBJECT_ALLOCATE_DONE,0},
    {{NULL},"S_ipc_SHARED_OBJECT_ALLOCATE_START", (char *) S_ipc_SHARED_OBJECT_ALLOCATE_START,0},
    {{NULL},"S_ipc_SHARED_OBJECT_ALLOCATION_DONE", (char *) S_ipc_SHARED_OBJECT_ALLOCATION_DONE,0},
    {{NULL},"S_ipc_MEMORY_ALREADY_INITIALIZED", (char *) S_ipc_MEMORY_ALREADY_INITIALIZED,0},
    {{NULL},"S_ipc_MEMORY_ALREADY_SHUTDOWN", (char *) S_ipc_MEMORY_ALREADY_SHUTDOWN,0},
    {{NULL},"S_rte_INSUFFICIENT_MEMORY", (char *) S_rte_INSUFFICIENT_MEMORY,0},
    {{NULL},"S_initmgr_HB_TIMEOUT", (char *) S_initmgr_HB_TIMEOUT,0},
    {{NULL},"S_initmgr_CPU_NUMBER_OUT_OF_RANGE", (char *) S_initmgr_CPU_NUMBER_OUT_OF_RANGE,0},
    {{NULL},"S_initmgr_RTE_NUMBER_OUT_OF_RANGE", (char *) S_initmgr_RTE_NUMBER_OUT_OF_RANGE,0},
    {{NULL},"S_general_NOT_IMPLEMENTED", (char *) S_general_NOT_IMPLEMENTED,0},
    {{NULL},"S_inputSource_LASERMETROLOGYSENSOR_OPD_UNITS_PER_COUNT", (char *) S_inputSource_LASERMETROLOGYSENSOR_OPD_UNITS_PER_COUNT,0},
    {{NULL},"S_modLib_INVALID_MOD_TYPE", (char *) S_modLib_INVALID_MOD_TYPE,0},
    {{NULL},"S_modLib_INVALID_MOD_FREQ", (char *) S_modLib_INVALID_MOD_FREQ,0},
    {{NULL},"S_mutexUser_MUTEX_TASK_PRIORITY_TOO_HIGH", (char *) S_mutexUser_MUTEX_TASK_PRIORITY_TOO_HIGH,0},
    {{NULL},"S_mutexUser_ABORT_ATTEMPTED_ON_INACTIVE_MUTEX_USER_OBJECT", (char *) S_mutexUser_ABORT_ATTEMPTED_ON_INACTIVE_MUTEX_USER_OBJECT,0},
    {{NULL},"S_outputDest_TACTUATOR_CONSTRUCTOR", (char *) S_outputDest_TACTUATOR_CONSTRUCTOR,0},
    {{NULL},"S_outputDest_TACTUATOR_PHYSICAL_UNITS_PER_COUNT", (char *) S_outputDest_TACTUATOR_PHYSICAL_UNITS_PER_COUNT,0},
    {{NULL},"S_outputDest_TMODULATEDACTUATOR_CONSTRUCTOR", (char *) S_outputDest_TMODULATEDACTUATOR_CONSTRUCTOR,0},
    {{NULL},"S_outputDest_TMODULATEDACTUATOR_RESET_MODULATION", (char *) S_outputDest_TMODULATEDACTUATOR_RESET_MODULATION,0},
    {{NULL},"S_outputDest_TMODULATEDACTUATOR_SET_MODULATION", (char *) S_outputDest_TMODULATEDACTUATOR_SET_MODULATION,0},
    {{NULL},"S_outputDest_TMOD_ACCEL_ACTUATOR_CONSTRUCTOR", (char *) S_outputDest_TMOD_ACCEL_ACTUATOR_CONSTRUCTOR,0},
    {{NULL},"S_outputDest_GET_MAX_ACCEL", (char *) S_outputDest_GET_MAX_ACCEL,0},
    {{NULL},"S_outputDest_TMOD_VEL_ACTUATOR_CONSTRUCTOR", (char *) S_outputDest_TMOD_VEL_ACTUATOR_CONSTRUCTOR,0},
    {{NULL},"S_outputDest_GET_MAX_VEL", (char *) S_outputDest_GET_MAX_VEL,0},
    {{NULL},"S_outputDest_TMOD_POSITION_ACTUATOR_CONSTRUCTOR", (char *) S_outputDest_TMOD_POSITION_ACTUATOR_CONSTRUCTOR,0},
    {{NULL},"S_outputDest_GET_MIN_POSITION", (char *) S_outputDest_GET_MIN_POSITION,0},
    {{NULL},"S_outputDest_GET_MAX_POSITION", (char *) S_outputDest_GET_MAX_POSITION,0},
    {{NULL},"S_realtime_gizmo_SHUTTING_DOWN_GIZMO", (char *) S_realtime_gizmo_SHUTTING_DOWN_GIZMO,0},
    {{NULL},"S_realtime_gizmo_ALREADY_SHUTDOWN", (char *) S_realtime_gizmo_ALREADY_SHUTDOWN,0},
    {{NULL},"S_realtime_gizmo_ALREADY_RUNNING", (char *) S_realtime_gizmo_ALREADY_RUNNING,0},
    {{NULL},"S_realtime_gizmo_CONSTRUCTOR_START", (char *) S_realtime_gizmo_CONSTRUCTOR_START,0},
    {{NULL},"S_realtime_gizmo_CONTRUCTOR_COMPLETE", (char *) S_realtime_gizmo_CONTRUCTOR_COMPLETE,0},
    {{NULL},"S_realtime_gizmo_START_TASKS_COMPLETE", (char *) S_realtime_gizmo_START_TASKS_COMPLETE,0},
    {{NULL},"S_realtime_gizmo_DESTRUCTOR_START", (char *) S_realtime_gizmo_DESTRUCTOR_START,0},
    {{NULL},"S_realtime_gizmo_DESTRUCTOR_COMPLETE", (char *) S_realtime_gizmo_DESTRUCTOR_COMPLETE,0},
    {{NULL},"S_realtime_gizmo_RESTART_START", (char *) S_realtime_gizmo_RESTART_START,0},
    {{NULL},"S_realtime_gizmo_RESTART_COMPLETE", (char *) S_realtime_gizmo_RESTART_COMPLETE,0},
    {{NULL},"S_realtime_gizmo_SHUTDOWN_START", (char *) S_realtime_gizmo_SHUTDOWN_START,0},
    {{NULL},"S_realtime_gizmo_SHUTDOWN_COMPLETE", (char *) S_realtime_gizmo_SHUTDOWN_COMPLETE,0},
    {{NULL},"S_relayStream_SENDER_NOT_INITIALIZED", (char *) S_relayStream_SENDER_NOT_INITIALIZED,0},
    {{NULL},"S_relayStream_RECEIVER_NOT_INITIALIZED", (char *) S_relayStream_RECEIVER_NOT_INITIALIZED,0},
    {{NULL},"S_relayStream_ALREADY_INITIALIZED", (char *) S_relayStream_ALREADY_INITIALIZED,0},
    {{NULL},"S_relayStream_ALREADY_SHUTDOWN", (char *) S_relayStream_ALREADY_SHUTDOWN,0},
    {{NULL},"S_relayStream_SENDER_ALREADY_INITIALIZED", (char *) S_relayStream_SENDER_ALREADY_INITIALIZED,0},
    {{NULL},"S_relayStream_SENDER_ALREADY_SHUTDOWN", (char *) S_relayStream_SENDER_ALREADY_SHUTDOWN,0},
    {{NULL},"S_relayStream_RECEIVER_ALREADY_INITIALIZED", (char *) S_relayStream_RECEIVER_ALREADY_INITIALIZED,0},
    {{NULL},"S_relayStream_RECEIVER_ALREADY_SHUTDOWN", (char *) S_relayStream_RECEIVER_ALREADY_SHUTDOWN,0},
    {{NULL},"S_relayStream_SHUTTING_DOWN", (char *) S_relayStream_SHUTTING_DOWN,0},
    {{NULL},"S_relayStream_SHUTTING_DOWN_SENDER", (char *) S_relayStream_SHUTTING_DOWN_SENDER,0},
    {{NULL},"S_relayStream_SHUTTING_DOWN_RECEIVER", (char *) S_relayStream_SHUTTING_DOWN_RECEIVER,0},
    {{NULL},"S_relayStream_INIT_COMPLETE", (char *) S_relayStream_INIT_COMPLETE,0},
    {{NULL},"S_relayStream_REINIT_COMPLETE", (char *) S_relayStream_REINIT_COMPLETE,0},
    {{NULL},"S_relayStream_SHUTDOWN_COMPLETE", (char *) S_relayStream_SHUTDOWN_COMPLETE,0},
    {{NULL},"S_relayStream_SENDER_INIT_COMPLETE", (char *) S_relayStream_SENDER_INIT_COMPLETE,0},
    {{NULL},"S_relayStream_SENDER_REINIT_COMPLETE", (char *) S_relayStream_SENDER_REINIT_COMPLETE,0},
    {{NULL},"S_relayStream_SENDER_SHUTDOWN_COMPLETE", (char *) S_relayStream_SENDER_SHUTDOWN_COMPLETE,0},
    {{NULL},"S_relayStream_RECEIVER_INIT_COMPLETE", (char *) S_relayStream_RECEIVER_INIT_COMPLETE,0},
    {{NULL},"S_relayStream_RECEIVER_REINIT_COMPLETE", (char *) S_relayStream_RECEIVER_REINIT_COMPLETE,0},
    {{NULL},"S_relayStream_RECEIVER_SHUTDOWN_COMPLETE", (char *) S_relayStream_RECEIVER_SHUTDOWN_COMPLETE,0},
    {{NULL},"S_relayer_CANT_ALLOCATE_ERROR_STREAMS", (char *) S_relayer_CANT_ALLOCATE_ERROR_STREAMS,0},
    {{NULL},"S_relayer_CANT_ALLOCATE_DATA_STREAMS", (char *) S_relayer_CANT_ALLOCATE_DATA_STREAMS,0},
    {{NULL},"S_relayer_CANT_ALLOCATE_STATUS_STREAMS", (char *) S_relayer_CANT_ALLOCATE_STATUS_STREAMS,0},
    {{NULL},"S_relayer_CANT_ALLOCATE_DATA_HEADERS", (char *) S_relayer_CANT_ALLOCATE_DATA_HEADERS,0},
    {{NULL},"S_relayer_CANT_ALLOCATE_STATUS_HEADERS", (char *) S_relayer_CANT_ALLOCATE_STATUS_HEADERS,0},
    {{NULL},"S_relayer_UI_NOT_ATTACHED", (char *) S_relayer_UI_NOT_ATTACHED,0},
    {{NULL},"S_relayer_INITIALIZED_ERROR_DATA_AND_STATUS_STREAMS", (char *) S_relayer_INITIALIZED_ERROR_DATA_AND_STATUS_STREAMS,0},
    {{NULL},"S_relayer_INTERNAL_ERROR", (char *) S_relayer_INTERNAL_ERROR,0},
    {{NULL},"S_setcallback_INVALID_GIZMO", (char *) S_setcallback_INVALID_GIZMO,0},
    {{NULL},"S_relayer_ALREADY_INITIALIZED", (char *) S_relayer_ALREADY_INITIALIZED,0},
    {{NULL},"S_relayer_ALREADY_SHUTDOWN", (char *) S_relayer_ALREADY_SHUTDOWN,0},
    {{NULL},"S_relayer_NOT_SHUTDOWN", (char *) S_relayer_NOT_SHUTDOWN,0},
    {{NULL},"S_relayer_SENDING_ERROR_TO_UI", (char *) S_relayer_SENDING_ERROR_TO_UI,0},
    {{NULL},"S_relayer_SENDING_DATA_TO_UI", (char *) S_relayer_SENDING_DATA_TO_UI,0},
    {{NULL},"S_relayer_SENDING_STATUS_TO_UI", (char *) S_relayer_SENDING_STATUS_TO_UI,0},
    {{NULL},"S_relayer_ENTERING_RELAYER_INIT", (char *) S_relayer_ENTERING_RELAYER_INIT,0},
    {{NULL},"S_relayer_INITIALIZED_ERROR_STREAMS", (char *) S_relayer_INITIALIZED_ERROR_STREAMS,0},
    {{NULL},"S_relayer_INITIALIZED_DATA_AND_STATUS_STREAMS", (char *) S_relayer_INITIALIZED_DATA_AND_STATUS_STREAMS,0},
    {{NULL},"S_relayer_CREATED_MSGQS_AND_SPAWNED_MSGQ_TASKS", (char *) S_relayer_CREATED_MSGQS_AND_SPAWNED_MSGQ_TASKS,0},
    {{NULL},"S_relayer_LEAVING_RELAYER_INIT", (char *) S_relayer_LEAVING_RELAYER_INIT,0},
    {{NULL},"S_relayer_TRELAYER_RELAY", (char *) S_relayer_TRELAYER_RELAY,0},
    {{NULL},"S_rte_GIZMO_CREATION_ERROR", (char *) S_rte_GIZMO_CREATION_ERROR,0},
    {{NULL},"S_rte_GIZMO_NOT_ON_THIS_RTE", (char *) S_rte_GIZMO_NOT_ON_THIS_RTE,0},
    {{NULL},"S_rte_INVALID_GIZMO_NUMBER", (char *) S_rte_INVALID_GIZMO_NUMBER,0},
    {{NULL},"S_rte_UNABLE_TO_CREATE_IPC", (char *) S_rte_UNABLE_TO_CREATE_IPC,0},
    {{NULL},"S_rte_UNABLE_TO_CREATE_SCHEDULER", (char *) S_rte_UNABLE_TO_CREATE_SCHEDULER,0},
    {{NULL},"S_rte_UNABLE_TO_CREATE_ERROR_STREAM", (char *) S_rte_UNABLE_TO_CREATE_ERROR_STREAM,0},
    {{NULL},"S_rte_UNABLE_TO_CREATE_DATA_STREAM", (char *) S_rte_UNABLE_TO_CREATE_DATA_STREAM,0},
    {{NULL},"S_rte_UNABLE_TO_CREATE_STATUS_STREAM", (char *) S_rte_UNABLE_TO_CREATE_STATUS_STREAM,0},
    {{NULL},"S_rte_INVALID_RTE_GIZMO_INDEX", (char *) S_rte_INVALID_RTE_GIZMO_INDEX,0},
    {{NULL},"S_rte_ENTERING_TRTE_INIT", (char *) S_rte_ENTERING_TRTE_INIT,0},
    {{NULL},"S_rte_IPC_INITIALIZED", (char *) S_rte_IPC_INITIALIZED,0},
    {{NULL},"S_rte_INTERRUPT_INITIALIZED", (char *) S_rte_INTERRUPT_INITIALIZED,0},
    {{NULL},"S_rte_SCHEDULER_INITIALIZED", (char *) S_rte_SCHEDULER_INITIALIZED,0},
    {{NULL},"S_rte_HB_EKG_EMT_TASKS_SCHEDULED", (char *) S_rte_HB_EKG_EMT_TASKS_SCHEDULED,0},
    {{NULL},"S_rte_CREATING_NEW_GIZMO", (char *) S_rte_CREATING_NEW_GIZMO,0},
    {{NULL},"S_rte_TRTE_INIT_COMPLETED", (char *) S_rte_TRTE_INIT_COMPLETED,0},
    {{NULL},"S_rte_ENTERING_RTEINIT", (char *) S_rte_ENTERING_RTEINIT,0},
    {{NULL},"S_rte_EXITING_RTEINIT", (char *) S_rte_EXITING_RTEINIT,0},
    {{NULL},"S_rte_HEARTBEAT_TICKED", (char *) S_rte_HEARTBEAT_TICKED,0},
    {{NULL},"S_rte_EKG_TICKED", (char *) S_rte_EKG_TICKED,0},
    {{NULL},"S_rte_EMT_TICKED", (char *) S_rte_EMT_TICKED,0},
    {{NULL},"S_rte_ERROR_STREAM_INITIALIZED", (char *) S_rte_ERROR_STREAM_INITIALIZED,0},
    {{NULL},"S_rte_DATA_STREAM_INITIALIZED", (char *) S_rte_DATA_STREAM_INITIALIZED,0},
    {{NULL},"S_rte_STATUS_STREAM_INITIALIZED", (char *) S_rte_STATUS_STREAM_INITIALIZED,0},
    {{NULL},"S_servo_COULD_NOT_ALLOCATE_SERVO_TASK_ARRAY", (char *) S_servo_COULD_NOT_ALLOCATE_SERVO_TASK_ARRAY,0},
    {{NULL},"S_servo_INVALID_SERVO_MODE_REQUESTED", (char *) S_servo_INVALID_SERVO_MODE_REQUESTED,0},
    {{NULL},"S_servo_REQUESTED_TASK_PERIOD_MODIFIED", (char *) S_servo_REQUESTED_TASK_PERIOD_MODIFIED,0},
    {{NULL},"S_servo_UNABLE_TO_ALLOCATE_SERVO_TASK_INFO_ARRAY", (char *) S_servo_UNABLE_TO_ALLOCATE_SERVO_TASK_INFO_ARRAY,0},
    {{NULL},"S_servo_INVALID_PARTITION", (char *) S_servo_INVALID_PARTITION,0},
    {{NULL},"S_tservotask_TASK_ALREADY_RUNNING", (char *) S_tservotask_TASK_ALREADY_RUNNING,0},
    {{NULL},"S_tservotask_TASK_ALREADY_SHUTDOWN", (char *) S_tservotask_TASK_ALREADY_SHUTDOWN,0},
    {{NULL},"S_tservo_ALREADY_RUNNING", (char *) S_tservo_ALREADY_RUNNING,0},
    {{NULL},"S_tservo_ALREADY_SHUTDOWN", (char *) S_tservo_ALREADY_SHUTDOWN,0},
    {{NULL},"S_servotask_CONSTRUCTOR", (char *) S_servotask_CONSTRUCTOR,0},
    {{NULL},"S_servotask_ADDED_SERVO_TASK", (char *) S_servotask_ADDED_SERVO_TASK,0},
    {{NULL},"S_servotask_DESTRUCTOR", (char *) S_servotask_DESTRUCTOR,0},
    {{NULL},"S_servotask_DOSERVO", (char *) S_servotask_DOSERVO,0},
    {{NULL},"S_servotask_EXITING_DOSERVO", (char *) S_servotask_EXITING_DOSERVO,0},
    {{NULL},"S_servo_CONSTRUCTOR_BEGIN", (char *) S_servo_CONSTRUCTOR_BEGIN,0},
    {{NULL},"S_servo_TASK_ARRAY_CONSTRUCTOR_COMPLETE", (char *) S_servo_TASK_ARRAY_CONSTRUCTOR_COMPLETE,0},
    {{NULL},"S_servo_SELECT_MODE", (char *) S_servo_SELECT_MODE,0},
    {{NULL},"S_servotask_DELETED_SERVO_TASK", (char *) S_servotask_DELETED_SERVO_TASK,0},
    {{NULL},"S_servo_TASK_ARRAY_ALLOCATED", (char *) S_servo_TASK_ARRAY_ALLOCATED,0},
    {{NULL},"S_servoinfo_UNABLE_TO_ALLOCATE_SERVO_TASK_INFO_ARRAY", (char *) S_servoinfo_UNABLE_TO_ALLOCATE_SERVO_TASK_INFO_ARRAY,0},
    {{NULL},"S_servoinfo_INVALID_PARTITION", (char *) S_servoinfo_INVALID_PARTITION,0},
    {{NULL},"S_ipc_TOKEN_SERVER_COULD_NOT_BE_CREATED", (char *) S_ipc_TOKEN_SERVER_COULD_NOT_BE_CREATED,0},
    {{NULL},"S_gui_STARTING_TCPSERVER", (char *) S_gui_STARTING_TCPSERVER,0},
    {{NULL},"S_gui_PROCESSING_CMD", (char *) S_gui_PROCESSING_CMD,0},
    {{NULL},"S_stactuator_INVALID_STAR_IMAGE_SIZE", (char *) S_stactuator_INVALID_STAR_IMAGE_SIZE,0},
    {{NULL},"S_stgizmo_COULD_NOT_CREATE_COMMAND_ENGINE", (char *) S_stgizmo_COULD_NOT_CREATE_COMMAND_ENGINE,0},
    {{NULL},"S_stgizmo_UNRECOGNIZED_COMMAND", (char *) S_stgizmo_UNRECOGNIZED_COMMAND,0},
    {{NULL},"S_stgizmo_UNABLE_TO_SEND_STATUS", (char *) S_stgizmo_UNABLE_TO_SEND_STATUS,0},
    {{NULL},"S_stgizmo_GIZMO_INFO_NOT_ST", (char *) S_stgizmo_GIZMO_INFO_NOT_ST,0},
    {{NULL},"S_stgizmo_INVALID_NUMBER_OF_SERVO_MODES", (char *) S_stgizmo_INVALID_NUMBER_OF_SERVO_MODES,0},
    {{NULL},"S_stgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS", (char *) S_stgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS,0},
    {{NULL},"S_stgizmo_CANT_CONSTRUCT_IO_OR_CTLR_SET", (char *) S_stgizmo_CANT_CONSTRUCT_IO_OR_CTLR_SET,0},
    {{NULL},"S_stgizmo_ERROR_UPDATING_STAR_SENSOR", (char *) S_stgizmo_ERROR_UPDATING_STAR_SENSOR,0},
    {{NULL},"S_stgizmo_TRANSFORM_UNDEFINED", (char *) S_stgizmo_TRANSFORM_UNDEFINED,0},
    {{NULL},"S_stgizmo_ENTERING_ST_GIZMO_CONSTRUCTOR", (char *) S_stgizmo_ENTERING_ST_GIZMO_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_ASSIGNING_CTLR_GROUPS_TO_MODES", (char *) S_stgizmo_ASSIGNING_CTLR_GROUPS_TO_MODES,0},
    {{NULL},"S_stgizmo_ASSIGNING_CTLRS_TO_PARTITIONS", (char *) S_stgizmo_ASSIGNING_CTLRS_TO_PARTITIONS,0},
    {{NULL},"S_stgizmo_ENABLING_BASE_CLASS_TASKS", (char *) S_stgizmo_ENABLING_BASE_CLASS_TASKS,0},
    {{NULL},"S_stgizmo_LEAVING_ST_GIZMO_CONSTRUCTOR", (char *) S_stgizmo_LEAVING_ST_GIZMO_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_ST_GIZMO_DESTRUCTOR", (char *) S_stgizmo_ST_GIZMO_DESTRUCTOR,0},
    {{NULL},"S_stgizmo_RESTART", (char *) S_stgizmo_RESTART,0},
    {{NULL},"S_stgizmo_SHUTDOWN", (char *) S_stgizmo_SHUTDOWN,0},
    {{NULL},"S_stgizmo_ENTERING_COLLECTSTATUS", (char *) S_stgizmo_ENTERING_COLLECTSTATUS,0},
    {{NULL},"S_stgizmo_GETTING_IMAGE_STATUS", (char *) S_stgizmo_GETTING_IMAGE_STATUS,0},
    {{NULL},"S_stgizmo_SENDING_STATUS_BLOCK", (char *) S_stgizmo_SENDING_STATUS_BLOCK,0},
    {{NULL},"S_stgizmo_SENDING_STATUS_IMAGE", (char *) S_stgizmo_SENDING_STATUS_IMAGE,0},
    {{NULL},"S_stgizmo_LEAVING_COLLECTSTATUS", (char *) S_stgizmo_LEAVING_COLLECTSTATUS,0},
    {{NULL},"S_stgizmo_ENTERING_DISPATCH", (char *) S_stgizmo_ENTERING_DISPATCH,0},
    {{NULL},"S_stgizmo_LEAVING_DISPATCH", (char *) S_stgizmo_LEAVING_DISPATCH,0},
    {{NULL},"S_stgizmo_PING", (char *) S_stgizmo_PING,0},
    {{NULL},"S_stgizmo_ENTERING_OFF_METHOD", (char *) S_stgizmo_ENTERING_OFF_METHOD,0},
    {{NULL},"S_stgizmo_LEAVING_OFF_METHOD", (char *) S_stgizmo_LEAVING_OFF_METHOD,0},
    {{NULL},"S_stgizmo_ENTERING_TRACK_METHOD", (char *) S_stgizmo_ENTERING_TRACK_METHOD,0},
    {{NULL},"S_stgizmo_LEAVING_TRACK_METHOD", (char *) S_stgizmo_LEAVING_TRACK_METHOD,0},
    {{NULL},"S_stgizmo_ST_COMPLETE_IO_SET_CONSTRUCTOR", (char *) S_stgizmo_ST_COMPLETE_IO_SET_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_ST_COMPLETE_IO_SET_DESTRUCTOR", (char *) S_stgizmo_ST_COMPLETE_IO_SET_DESTRUCTOR,0},
    {{NULL},"S_stgizmo_ENTERING_ST_GIZMOINFO_CONSTRUCTOR", (char *) S_stgizmo_ENTERING_ST_GIZMOINFO_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_LEAVING_ST_GIZMOINFO_CONSTRUCTOR", (char *) S_stgizmo_LEAVING_ST_GIZMOINFO_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_STAR_SENSOR_CONSTRUCTOR", (char *) S_stgizmo_STAR_SENSOR_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_STAR_SENSOR_UPDATE", (char *) S_stgizmo_STAR_SENSOR_UPDATE,0},
    {{NULL},"S_stgizmo_ST_CONTROLLER_DATA_CONSTRUCTOR", (char *) S_stgizmo_ST_CONTROLLER_DATA_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_ST_CONTROLLER_CONSTRUCTOR", (char *) S_stgizmo_ST_CONTROLLER_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_ST_CONTROLLER_DESTRUCTOR", (char *) S_stgizmo_ST_CONTROLLER_DESTRUCTOR,0},
    {{NULL},"S_stgizmo_ST_OFF_CONTROLLER_CONSTRUCTOR", (char *) S_stgizmo_ST_OFF_CONTROLLER_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_ENTERING_ST_OFF_CONTROLLER_INIT", (char *) S_stgizmo_ENTERING_ST_OFF_CONTROLLER_INIT,0},
    {{NULL},"S_stgizmo_LEAVING_ST_OFF_CONTROLLER_INIT", (char *) S_stgizmo_LEAVING_ST_OFF_CONTROLLER_INIT,0},
    {{NULL},"S_stgizmo_ST_TRACK_CONTROLLER_CONSTRUCTOR", (char *) S_stgizmo_ST_TRACK_CONTROLLER_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_ST_TRACK_CONTROLLER_DESTRUCTOR", (char *) S_stgizmo_ST_TRACK_CONTROLLER_DESTRUCTOR,0},
    {{NULL},"S_stgizmo_ENTERING_ST_TRACK_CONTROLLER_CALCULATE", (char *) S_stgizmo_ENTERING_ST_TRACK_CONTROLLER_CALCULATE,0},
    {{NULL},"S_stgizmo_UPDATE_STAR_SENSOR", (char *) S_stgizmo_UPDATE_STAR_SENSOR,0},
    {{NULL},"S_stgizmo_CALCULATE_CENTROID", (char *) S_stgizmo_CALCULATE_CENTROID,0},
    {{NULL},"S_stgizmo_UPDATE_CONTROLLER_DATA_BLOCK", (char *) S_stgizmo_UPDATE_CONTROLLER_DATA_BLOCK,0},
    {{NULL},"S_stgizmo_LEAVING_ST_TRACK_CONTROLLER_CALCULATE", (char *) S_stgizmo_LEAVING_ST_TRACK_CONTROLLER_CALCULATE,0},
    {{NULL},"S_stgizmo_ENTERING_CALCULATE_CENTROID", (char *) S_stgizmo_ENTERING_CALCULATE_CENTROID,0},
    {{NULL},"S_stgizmo_LEAVING_CALCULATE_CENTROID", (char *) S_stgizmo_LEAVING_CALCULATE_CENTROID,0},
    {{NULL},"S_stgizmo_ST_COMPLETE_CONTROLLER_SET_CONSTRUCTOR", (char *) S_stgizmo_ST_COMPLETE_CONTROLLER_SET_CONSTRUCTOR,0},
    {{NULL},"S_stgizmo_ENTERING_CALIBRATE_METHOD", (char *) S_stgizmo_ENTERING_CALIBRATE_METHOD,0},
    {{NULL},"S_stgizmo_LEAVING_CALIBRATE_METHOD", (char *) S_stgizmo_LEAVING_CALIBRATE_METHOD,0},
    {{NULL},"S_stgizmo_ENTERING_HOME_METHOD", (char *) S_stgizmo_ENTERING_HOME_METHOD,0},
    {{NULL},"S_stgizmo_LEAVING_HOME_METHOD", (char *) S_stgizmo_LEAVING_HOME_METHOD,0},
    {{NULL},"S_stgizmo_ENTERING_SSP_METHOD", (char *) S_stgizmo_ENTERING_SSP_METHOD,0},
    {{NULL},"S_stgizmo_LEAVING_SSP_METHOD", (char *) S_stgizmo_LEAVING_SSP_METHOD,0},
    {{NULL},"S_stgizmo_ENTERING_ST_CONTROLLER_CALCULATE", (char *) S_stgizmo_ENTERING_ST_CONTROLLER_CALCULATE,0},
    {{NULL},"S_stgizmo_LEAVING_ST_CONTROLLER_CALCULATE", (char *) S_stgizmo_LEAVING_ST_CONTROLLER_CALCULATE,0},
    {{NULL},"S_stgizmo_ST_COMPLETE_CONTROLLER_SET_DESTRUCTOR", (char *) S_stgizmo_ST_COMPLETE_CONTROLLER_SET_DESTRUCTOR,0},
    {{NULL},"S_stgizmo_STAR_TRACKER_ALIVE", (char *) S_stgizmo_STAR_TRACKER_ALIVE,0},
    {{NULL},"S_stgizmo_SETTING_SERVO_PARAMETERS", (char *) S_stgizmo_SETTING_SERVO_PARAMETERS,0},
    {{NULL},"S_stgizmo_SERVO_PARAMETERS_SET", (char *) S_stgizmo_SERVO_PARAMETERS_SET,0},
    {{NULL},"S_stgizmo_OFF_START", (char *) S_stgizmo_OFF_START,0},
    {{NULL},"S_stgizmo_OFF_COMPLETE", (char *) S_stgizmo_OFF_COMPLETE,0},
    {{NULL},"S_stgizmo_TRACK_START", (char *) S_stgizmo_TRACK_START,0},
    {{NULL},"S_stgizmo_TRACK_IN_PROGRESS", (char *) S_stgizmo_TRACK_IN_PROGRESS,0},
    {{NULL},"S_stgizmo_TRACK_ABORTED", (char *) S_stgizmo_TRACK_ABORTED,0},
    {{NULL},"S_stgizmo_CALIBRATE_IN_PROGRESS", (char *) S_stgizmo_CALIBRATE_IN_PROGRESS,0},
    {{NULL},"S_telemetry_UNKNOWN_ITEM", (char *) S_telemetry_UNKNOWN_ITEM,0},
    {{NULL},"S_telemetry_UNKNOWN_TELEMETRY_TYPE", (char *) S_telemetry_UNKNOWN_TELEMETRY_TYPE,0},
    {{NULL},"S_token_CLIENT_DOESNT_OWN_TOKEN", (char *) S_token_CLIENT_DOESNT_OWN_TOKEN,0},
    {{NULL},"S_token_CLIENT_ALREADY_OWNS_TOKEN", (char *) S_token_CLIENT_ALREADY_OWNS_TOKEN,0},
    {{NULL},"S_token_CLIENT_TIME_OUT", (char *) S_token_CLIENT_TIME_OUT,0},
    {{NULL},"S_token_CLIENT_OUT_OF_RANGE", (char *) S_token_CLIENT_OUT_OF_RANGE,0},
    {{NULL},"S_token_SERVER_TIME_OUT", (char *) S_token_SERVER_TIME_OUT,0},
    {{NULL},"S_token_SERVER_ALREADY_RUNNING", (char *) S_token_SERVER_ALREADY_RUNNING,0},
    {{NULL},"S_token_SERVER_NOT_RUNNING", (char *) S_token_SERVER_NOT_RUNNING,0},
    {{NULL},"S_token_CLIENT_NOT_INITIALIZED", (char *) S_token_CLIENT_NOT_INITIALIZED,0},
    {{NULL},"S_token_CLIENT_ALREADY_INITIALIZED", (char *) S_token_CLIENT_ALREADY_INITIALIZED,0},
    {{NULL},"S_token_CLIENT_ALREADY_SHUTDOWN", (char *) S_token_CLIENT_ALREADY_SHUTDOWN,0},
    {{NULL},"S_ts_SUCCESSFULLY_COMPLETED_SERVER_INIT", (char *) S_ts_SUCCESSFULLY_COMPLETED_SERVER_INIT,0},
    {{NULL},"S_ts_SUCCESSFULLY_COMPLETED_SERVER_DESTRUCTOR", (char *) S_ts_SUCCESSFULLY_COMPLETED_SERVER_DESTRUCTOR,0},
    {{NULL},"S_ts_SUCCESSFULLY_COMPLETED_SERVER_REINIT", (char *) S_ts_SUCCESSFULLY_COMPLETED_SERVER_REINIT,0},
    {{NULL},"S_ts_SUCCESSFULLY_COMPLETED_SERVER_SHUTDOWN", (char *) S_ts_SUCCESSFULLY_COMPLETED_SERVER_SHUTDOWN,0},
    {{NULL},"S_ts_START_OF_POLL", (char *) S_ts_START_OF_POLL,0},
    {{NULL},"S_ts_END_OF_POLL", (char *) S_ts_END_OF_POLL,0},
    {{NULL},"S_ts_REQUEST_GRANTED", (char *) S_ts_REQUEST_GRANTED,0},
    {{NULL},"S_ts_RETURN_ACCEPTED", (char *) S_ts_RETURN_ACCEPTED,0},
    {{NULL},"S_tc_SUCCESSFULLY_COMPLETED_CLIENT_INIT", (char *) S_tc_SUCCESSFULLY_COMPLETED_CLIENT_INIT,0},
    {{NULL},"S_tc_SUCCESSFULLY_COMPLETED_CLIENT_REINIT", (char *) S_tc_SUCCESSFULLY_COMPLETED_CLIENT_REINIT,0},
    {{NULL},"S_tc_SUCCESSFULLY_COMPLETED_CLIENT_SHUTDOWN", (char *) S_tc_SUCCESSFULLY_COMPLETED_CLIENT_SHUTDOWN,0},
    {{NULL},"S_tc_SUCCESSFULLY_COMPLETED_TOKEN_REQUEST", (char *) S_tc_SUCCESSFULLY_COMPLETED_TOKEN_REQUEST,0},
    {{NULL},"S_tc_SUCCESSFULLY_COMPLETED_TOKEN_RETURN", (char *) S_tc_SUCCESSFULLY_COMPLETED_TOKEN_RETURN,0},
    {{NULL},"S_tracedump_QUEUE_ERROR", (char *) S_tracedump_QUEUE_ERROR,0},
    {{NULL},"S_vector_BAD_VECTOR_OPERATION", (char *) S_vector_BAD_VECTOR_OPERATION,0},
    {{NULL},"S_vector_BAD_MATRIX_OPERATION", (char *) S_vector_BAD_MATRIX_OPERATION,0},
    {{NULL},"S_wapgizmo_COULD_NOT_CREATE_COMMAND_ENGINE", (char *) S_wapgizmo_COULD_NOT_CREATE_COMMAND_ENGINE,0},
    {{NULL},"S_wapgizmo_UNRECOGNIZED_COMMAND", (char *) S_wapgizmo_UNRECOGNIZED_COMMAND,0},
    {{NULL},"S_wapgizmo_UNABLE_TO_SEND_STATUS", (char *) S_wapgizmo_UNABLE_TO_SEND_STATUS,0},
    {{NULL},"S_wapgizmo_GIZMO_INFO_NOT_WAP", (char *) S_wapgizmo_GIZMO_INFO_NOT_WAP,0},
    {{NULL},"S_wapgizmo_INVALID_NUMBER_OF_SERVO_MODES", (char *) S_wapgizmo_INVALID_NUMBER_OF_SERVO_MODES,0},
    {{NULL},"S_wapgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS", (char *) S_wapgizmo_INVALID_NUMBER_OF_SERVO_PARTITIONS,0},
    {{NULL},"S_wapgizmo_CANT_CONSTRUCT_IO_OR_CTLR_SET", (char *) S_wapgizmo_CANT_CONSTRUCT_IO_OR_CTLR_SET,0},
    {{NULL},"S_wapgizmo_ERROR_UPDATING_STAR_SENSOR", (char *) S_wapgizmo_ERROR_UPDATING_STAR_SENSOR,0},
    {{NULL},"S_wapgizmo_TRANSFORM_UNDEFINED", (char *) S_wapgizmo_TRANSFORM_UNDEFINED,0},
    {{NULL},"S_wapgizmo_TASK_DELAY_FAILED", (char *) S_wapgizmo_TASK_DELAY_FAILED,0},
    {{NULL},"S_wapgizmo_DIVIDE_BY_ZERO", (char *) S_wapgizmo_DIVIDE_BY_ZERO,0},
    {{NULL},"S_wapgizmo_ENTERING_WAP_GIZMO_CONSTRUCTOR", (char *) S_wapgizmo_ENTERING_WAP_GIZMO_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_ASSIGNING_CTLR_GROUPS_TO_MODES", (char *) S_wapgizmo_ASSIGNING_CTLR_GROUPS_TO_MODES,0},
    {{NULL},"S_wapgizmo_ASSIGNING_CTLRS_TO_PARTITIONS", (char *) S_wapgizmo_ASSIGNING_CTLRS_TO_PARTITIONS,0},
    {{NULL},"S_wapgizmo_ENABLING_BASE_CLASS_TASKS", (char *) S_wapgizmo_ENABLING_BASE_CLASS_TASKS,0},
    {{NULL},"S_wapgizmo_LEAVING_WAP_GIZMO_CONSTRUCTOR", (char *) S_wapgizmo_LEAVING_WAP_GIZMO_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_WAP_GIZMO_DESTRUCTOR", (char *) S_wapgizmo_WAP_GIZMO_DESTRUCTOR,0},
    {{NULL},"S_wapgizmo_RESTART", (char *) S_wapgizmo_RESTART,0},
    {{NULL},"S_wapgizmo_SHUTDOWN", (char *) S_wapgizmo_SHUTDOWN,0},
    {{NULL},"S_wapgizmo_ENTERING_COLLECTSTATUS", (char *) S_wapgizmo_ENTERING_COLLECTSTATUS,0},
    {{NULL},"S_wapgizmo_GETTING_IMAGE_STATUS", (char *) S_wapgizmo_GETTING_IMAGE_STATUS,0},
    {{NULL},"S_wapgizmo_SENDING_STATUS_BLOCK", (char *) S_wapgizmo_SENDING_STATUS_BLOCK,0},
    {{NULL},"S_wapgizmo_SENDING_STATUS_IMAGE", (char *) S_wapgizmo_SENDING_STATUS_IMAGE,0},
    {{NULL},"S_wapgizmo_LEAVING_COLLECTSTATUS", (char *) S_wapgizmo_LEAVING_COLLECTSTATUS,0},
    {{NULL},"S_wapgizmo_ENTERING_DISPATCH", (char *) S_wapgizmo_ENTERING_DISPATCH,0},
    {{NULL},"S_wapgizmo_LEAVING_DISPATCH", (char *) S_wapgizmo_LEAVING_DISPATCH,0},
    {{NULL},"S_wapgizmo_PING", (char *) S_wapgizmo_PING,0},
    {{NULL},"S_wapgizmo_ENTERING_OFF_METHOD", (char *) S_wapgizmo_ENTERING_OFF_METHOD,0},
    {{NULL},"S_wapgizmo_LEAVING_OFF_METHOD", (char *) S_wapgizmo_LEAVING_OFF_METHOD,0},
    {{NULL},"S_wapgizmo_ENTERING_TRACK_METHOD", (char *) S_wapgizmo_ENTERING_TRACK_METHOD,0},
    {{NULL},"S_wapgizmo_LEAVING_TRACK_METHOD", (char *) S_wapgizmo_LEAVING_TRACK_METHOD,0},
    {{NULL},"S_wapgizmo_WAP_COMPLETE_IO_SET_CONSTRUCTOR", (char *) S_wapgizmo_WAP_COMPLETE_IO_SET_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_WAP_COMPLETE_IO_SET_DESTRUCTOR", (char *) S_wapgizmo_WAP_COMPLETE_IO_SET_DESTRUCTOR,0},
    {{NULL},"S_wapgizmo_ENTERING_WAP_GIZMOINFO_CONSTRUCTOR", (char *) S_wapgizmo_ENTERING_WAP_GIZMOINFO_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_LEAVING_WAP_GIZMOINFO_CONSTRUCTOR", (char *) S_wapgizmo_LEAVING_WAP_GIZMOINFO_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_STAR_SENSOR_CONSTRUCTOR", (char *) S_wapgizmo_STAR_SENSOR_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_STAR_SENSOR_UPDATE", (char *) S_wapgizmo_STAR_SENSOR_UPDATE,0},
    {{NULL},"S_wapgizmo_WAP_CONTROLLER_DATA_CONSTRUCTOR", (char *) S_wapgizmo_WAP_CONTROLLER_DATA_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_WAP_CONTROLLER_CONSTRUCTOR", (char *) S_wapgizmo_WAP_CONTROLLER_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_WAP_CONTROLLER_DESTRUCTOR", (char *) S_wapgizmo_WAP_CONTROLLER_DESTRUCTOR,0},
    {{NULL},"S_wapgizmo_WAP_OFF_CONTROLLER_CONSTRUCTOR", (char *) S_wapgizmo_WAP_OFF_CONTROLLER_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_ENTERING_WAP_OFF_CONTROLLER_INIT", (char *) S_wapgizmo_ENTERING_WAP_OFF_CONTROLLER_INIT,0},
    {{NULL},"S_wapgizmo_LEAVING_WAP_OFF_CONTROLLER_INIT", (char *) S_wapgizmo_LEAVING_WAP_OFF_CONTROLLER_INIT,0},
    {{NULL},"S_wapgizmo_WAP_TRACK_CONTROLLER_CONSTRUCTOR", (char *) S_wapgizmo_WAP_TRACK_CONTROLLER_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_WAP_TRACK_CONTROLLER_DESTRUCTOR", (char *) S_wapgizmo_WAP_TRACK_CONTROLLER_DESTRUCTOR,0},
    {{NULL},"S_wapgizmo_ENTERING_WAP_TRACK_CONTROLLER_CALCULATE", (char *) S_wapgizmo_ENTERING_WAP_TRACK_CONTROLLER_CALCULATE,0},
    {{NULL},"S_wapgizmo_UPDATE_STAR_SENSOR", (char *) S_wapgizmo_UPDATE_STAR_SENSOR,0},
    {{NULL},"S_wapgizmo_CALCULATE_CENTROID", (char *) S_wapgizmo_CALCULATE_CENTROID,0},
    {{NULL},"S_wapgizmo_UPDATE_CONTROLLER_DATA_BLOCK", (char *) S_wapgizmo_UPDATE_CONTROLLER_DATA_BLOCK,0},
    {{NULL},"S_wapgizmo_LEAVING_WAP_TRACK_CONTROLLER_CALCULATE", (char *) S_wapgizmo_LEAVING_WAP_TRACK_CONTROLLER_CALCULATE,0},
    {{NULL},"S_wapgizmo_ENTERING_CALCULATE_CENTROID", (char *) S_wapgizmo_ENTERING_CALCULATE_CENTROID,0},
    {{NULL},"S_wapgizmo_LEAVING_CALCULATE_CENTROID", (char *) S_wapgizmo_LEAVING_CALCULATE_CENTROID,0},
    {{NULL},"S_wapgizmo_WAP_COMPLETE_CONTROLLER_SET_CONSTRUCTOR", (char *) S_wapgizmo_WAP_COMPLETE_CONTROLLER_SET_CONSTRUCTOR,0},
    {{NULL},"S_wapgizmo_ENTERING_CALIBRATE_METHOD", (char *) S_wapgizmo_ENTERING_CALIBRATE_METHOD,0},
    {{NULL},"S_wapgizmo_LEAVING_CALIBRATE_METHOD", (char *) S_wapgizmo_LEAVING_CALIBRATE_METHOD,0},
    {{NULL},"S_wapgizmo_ENTERING_HOME_METHOD", (char *) S_wapgizmo_ENTERING_HOME_METHOD,0},
    {{NULL},"S_wapgizmo_LEAVING_HOME_METHOD", (char *) S_wapgizmo_LEAVING_HOME_METHOD,0},
    {{NULL},"S_wapgizmo_ENTERING_SSP_METHOD", (char *) S_wapgizmo_ENTERING_SSP_METHOD,0},
    {{NULL},"S_wapgizmo_LEAVING_SSP_METHOD", (char *) S_wapgizmo_LEAVING_SSP_METHOD,0},
    {{NULL},"S_wapgizmo_ENTERING_WAP_CONTROLLER_CALCULATE", (char *) S_wapgizmo_ENTERING_WAP_CONTROLLER_CALCULATE,0},
    {{NULL},"S_wapgizmo_LEAVING_WAP_CONTROLLER_CALCULATE", (char *) S_wapgizmo_LEAVING_WAP_CONTROLLER_CALCULATE,0},
    {{NULL},"S_wapgizmo_WAP_COMPLETE_CONTROLLER_SET_DESTRUCTOR", (char *) S_wapgizmo_WAP_COMPLETE_CONTROLLER_SET_DESTRUCTOR,0},
    {{NULL},"S_wapgizmo_ENTERING_SLEW_METHOD", (char *) S_wapgizmo_ENTERING_SLEW_METHOD,0},
    {{NULL},"S_wapgizmo_LEAVING_SLEW_METHOD", (char *) S_wapgizmo_LEAVING_SLEW_METHOD,0},
    {{NULL},"S_wapgizmo_ENTERING_MOVE_METHOD", (char *) S_wapgizmo_ENTERING_MOVE_METHOD,0},
    {{NULL},"S_wapgizmo_LEAVING_MOVE_METHOD", (char *) S_wapgizmo_LEAVING_MOVE_METHOD,0},
    {{NULL},"S_wapgizmo_WAP_CONTROLLER_RESET", (char *) S_wapgizmo_WAP_CONTROLLER_RESET,0},
    {{NULL},"S_wapgizmo_WAP_ALIVE", (char *) S_wapgizmo_WAP_ALIVE,0},
    {{NULL},"S_wapgizmo_SETTING_SERVO_PARAMETERS", (char *) S_wapgizmo_SETTING_SERVO_PARAMETERS,0},
    {{NULL},"S_wapgizmo_SERVO_PARAMETERS_SET", (char *) S_wapgizmo_SERVO_PARAMETERS_SET,0},
    {{NULL},"S_wapgizmo_SLEW_START", (char *) S_wapgizmo_SLEW_START,0},
    {{NULL},"S_wapgizmo_SLEW_COMPLETE", (char *) S_wapgizmo_SLEW_COMPLETE,0},
    {{NULL},"S_wapgizmo_OFF_COMPLETE", (char *) S_wapgizmo_OFF_COMPLETE,0},
    {{NULL},"S_wapgizmo_TRACK_START", (char *) S_wapgizmo_TRACK_START,0},
    {{NULL},"S_wapgizmo_TRACK_IN_PROGRESS", (char *) S_wapgizmo_TRACK_IN_PROGRESS,0},
    {{NULL},"S_wapgizmo_TRACK_ABORTED", (char *) S_wapgizmo_TRACK_ABORTED,0},
    {{NULL},"S_wapgizmo_CALIBRATE_IN_PROGRESS", (char *) S_wapgizmo_CALIBRATE_IN_PROGRESS,0},
    {{NULL},"S_watchDog_ALREADY_INITIALIZED", (char *) S_watchDog_ALREADY_INITIALIZED,0},
    {{NULL},"S_watchDog_NULL_FUNCTION_POINTER", (char *) S_watchDog_NULL_FUNCTION_POINTER,0},
    {{NULL},"S_watchDog_INVALID_TIMEOUT_VALUE", (char *) S_watchDog_INVALID_TIMEOUT_VALUE,0},
    {{NULL},"S_watchDog_NOT_INITIALIZED", (char *) S_watchDog_NOT_INITIALIZED,0},
    {{NULL},"S_arpLib_INVALID_ARGUMENT", (char *) S_arpLib_INVALID_ARGUMENT,0},
    {{NULL},"S_arpLib_INVALID_ENET_ADDRESS", (char *) S_arpLib_INVALID_ENET_ADDRESS,0},
    {{NULL},"S_arpLib_INVALID_FLAG", (char *) S_arpLib_INVALID_FLAG,0},
    {{NULL},"S_bootLoadLib_ROUTINE_NOT_INSTALLED", (char *) S_bootLoadLib_ROUTINE_NOT_INSTALLED,0},
    {{NULL},"S_bootpLib_INVALID_ARGUMENT", (char *) S_bootpLib_INVALID_ARGUMENT,0},
    {{NULL},"S_bootpLib_INVALID_COOKIE", (char *) S_bootpLib_INVALID_COOKIE,0},
    {{NULL},"S_bootpLib_NO_BROADCASTS", (char *) S_bootpLib_NO_BROADCASTS,0},
    {{NULL},"S_bootpLib_PARSE_ERROR", (char *) S_bootpLib_PARSE_ERROR,0},
    {{NULL},"S_bootpLib_INVALID_TAG", (char *) S_bootpLib_INVALID_TAG,0},
    {{NULL},"S_bootpLib_TIME_OUT", (char *) S_bootpLib_TIME_OUT,0},
    {{NULL},"S_cacheLib_INVALID_CACHE", (char *) S_cacheLib_INVALID_CACHE,0},
    {{NULL},"S_classLib_CLASS_ID_ERROR", (char *) S_classLib_CLASS_ID_ERROR,0},
    {{NULL},"S_classLib_NO_CLASS_DESTROY", (char *) S_classLib_NO_CLASS_DESTROY,0},
    {{NULL},"S_dosFsLib_VOLUME_NOT_AVAILABLE", (char *) S_dosFsLib_VOLUME_NOT_AVAILABLE,0},
    {{NULL},"S_dosFsLib_DISK_FULL", (char *) S_dosFsLib_DISK_FULL,0},
    {{NULL},"S_dosFsLib_FILE_NOT_FOUND", (char *) S_dosFsLib_FILE_NOT_FOUND,0},
    {{NULL},"S_dosFsLib_NO_FREE_FILE_DESCRIPTORS", (char *) S_dosFsLib_NO_FREE_FILE_DESCRIPTORS,0},
    {{NULL},"S_dosFsLib_INVALID_NUMBER_OF_BYTES", (char *) S_dosFsLib_INVALID_NUMBER_OF_BYTES,0},
    {{NULL},"S_dosFsLib_FILE_ALREADY_EXISTS", (char *) S_dosFsLib_FILE_ALREADY_EXISTS,0},
    {{NULL},"S_dosFsLib_ILLEGAL_NAME", (char *) S_dosFsLib_ILLEGAL_NAME,0},
    {{NULL},"S_dosFsLib_CANT_DEL_ROOT", (char *) S_dosFsLib_CANT_DEL_ROOT,0},
    {{NULL},"S_dosFsLib_NOT_FILE", (char *) S_dosFsLib_NOT_FILE,0},
    {{NULL},"S_dosFsLib_NOT_DIRECTORY", (char *) S_dosFsLib_NOT_DIRECTORY,0},
    {{NULL},"S_dosFsLib_NOT_SAME_VOLUME", (char *) S_dosFsLib_NOT_SAME_VOLUME,0},
    {{NULL},"S_dosFsLib_READ_ONLY", (char *) S_dosFsLib_READ_ONLY,0},
    {{NULL},"S_dosFsLib_ROOT_DIR_FULL", (char *) S_dosFsLib_ROOT_DIR_FULL,0},
    {{NULL},"S_dosFsLib_DIR_NOT_EMPTY", (char *) S_dosFsLib_DIR_NOT_EMPTY,0},
    {{NULL},"S_dosFsLib_BAD_DISK", (char *) S_dosFsLib_BAD_DISK,0},
    {{NULL},"S_dosFsLib_NO_LABEL", (char *) S_dosFsLib_NO_LABEL,0},
    {{NULL},"S_dosFsLib_INVALID_PARAMETER", (char *) S_dosFsLib_INVALID_PARAMETER,0},
    {{NULL},"S_dosFsLib_NO_CONTIG_SPACE", (char *) S_dosFsLib_NO_CONTIG_SPACE,0},
    {{NULL},"S_dosFsLib_CANT_CHANGE_ROOT", (char *) S_dosFsLib_CANT_CHANGE_ROOT,0},
    {{NULL},"S_dosFsLib_FD_OBSOLETE", (char *) S_dosFsLib_FD_OBSOLETE,0},
    {{NULL},"S_dosFsLib_DELETED", (char *) S_dosFsLib_DELETED,0},
    {{NULL},"S_dosFsLib_NO_BLOCK_DEVICE", (char *) S_dosFsLib_NO_BLOCK_DEVICE,0},
    {{NULL},"S_dosFsLib_BAD_SEEK", (char *) S_dosFsLib_BAD_SEEK,0},
    {{NULL},"S_dosFsLib_INTERNAL_ERROR", (char *) S_dosFsLib_INTERNAL_ERROR,0},
    {{NULL},"S_dosFsLib_WRITE_ONLY", (char *) S_dosFsLib_WRITE_ONLY,0},
    {{NULL},"S_errnoLib_NO_STAT_SYM_TBL", (char *) S_errnoLib_NO_STAT_SYM_TBL,0},
    {{NULL},"S_hashLib_KEY_CLASH", (char *) S_hashLib_KEY_CLASH,0},
    {{NULL},"S_hostLib_UNKNOWN_HOST", (char *) S_hostLib_UNKNOWN_HOST,0},
    {{NULL},"S_hostLib_HOST_ALREADY_ENTERED", (char *) S_hostLib_HOST_ALREADY_ENTERED,0},
    {{NULL},"S_icmpLib_TIMEOUT", (char *) S_icmpLib_TIMEOUT,0},
    {{NULL},"S_icmpLib_NO_BROADCAST", (char *) S_icmpLib_NO_BROADCAST,0},
    {{NULL},"S_icmpLib_INVALID_INTERFACE", (char *) S_icmpLib_INVALID_INTERFACE,0},
    {{NULL},"S_if_sl_INVALID_UNIT_NUMBER", (char *) S_if_sl_INVALID_UNIT_NUMBER,0},
    {{NULL},"S_if_sl_UNIT_UNINITIALIZED", (char *) S_if_sl_UNIT_UNINITIALIZED,0},
    {{NULL},"S_if_sl_UNIT_ALREADY_INITIALIZED", (char *) S_if_sl_UNIT_ALREADY_INITIALIZED,0},
    {{NULL},"S_inetLib_ILLEGAL_INTERNET_ADDRESS", (char *) S_inetLib_ILLEGAL_INTERNET_ADDRESS,0},
    {{NULL},"S_inetLib_ILLEGAL_NETWORK_NUMBER", (char *) S_inetLib_ILLEGAL_NETWORK_NUMBER,0},
    {{NULL},"S_intLib_NOT_ISR_CALLABLE", (char *) S_intLib_NOT_ISR_CALLABLE,0},
    {{NULL},"S_intLib_VEC_TABLE_WP_UNAVAILABLE", (char *) S_intLib_VEC_TABLE_WP_UNAVAILABLE,0},
    {{NULL},"S_ioLib_NO_DRIVER", (char *) S_ioLib_NO_DRIVER,0},
    {{NULL},"S_ioLib_UNKNOWN_REQUEST", (char *) S_ioLib_UNKNOWN_REQUEST,0},
    {{NULL},"S_ioLib_DEVICE_ERROR", (char *) S_ioLib_DEVICE_ERROR,0},
    {{NULL},"S_ioLib_DEVICE_TIMEOUT", (char *) S_ioLib_DEVICE_TIMEOUT,0},
    {{NULL},"S_ioLib_WRITE_PROTECTED", (char *) S_ioLib_WRITE_PROTECTED,0},
    {{NULL},"S_ioLib_DISK_NOT_PRESENT", (char *) S_ioLib_DISK_NOT_PRESENT,0},
    {{NULL},"S_ioLib_NO_FILENAME", (char *) S_ioLib_NO_FILENAME,0},
    {{NULL},"S_ioLib_CANCELLED", (char *) S_ioLib_CANCELLED,0},
    {{NULL},"S_ioLib_NO_DEVICE_NAME_IN_PATH", (char *) S_ioLib_NO_DEVICE_NAME_IN_PATH,0},
    {{NULL},"S_ioLib_NAME_TOO_LONG", (char *) S_ioLib_NAME_TOO_LONG,0},
    {{NULL},"S_ioLib_UNFORMATED", (char *) S_ioLib_UNFORMATED,0},
    {{NULL},"S_iosLib_DEVICE_NOT_FOUND", (char *) S_iosLib_DEVICE_NOT_FOUND,0},
    {{NULL},"S_iosLib_DRIVER_GLUT", (char *) S_iosLib_DRIVER_GLUT,0},
    {{NULL},"S_iosLib_INVALID_FILE_DESCRIPTOR", (char *) S_iosLib_INVALID_FILE_DESCRIPTOR,0},
    {{NULL},"S_iosLib_TOO_MANY_OPEN_FILES", (char *) S_iosLib_TOO_MANY_OPEN_FILES,0},
    {{NULL},"S_iosLib_CONTROLLER_NOT_PRESENT", (char *) S_iosLib_CONTROLLER_NOT_PRESENT,0},
    {{NULL},"S_iosLib_DUPLICATE_DEVICE_NAME", (char *) S_iosLib_DUPLICATE_DEVICE_NAME,0},
    {{NULL},"S_iosLib_INVALID_ETHERNET_ADDRESS", (char *) S_iosLib_INVALID_ETHERNET_ADDRESS,0},
    {{NULL},"S_loadAoutLib_TOO_MANY_SYMBOLS", (char *) S_loadAoutLib_TOO_MANY_SYMBOLS,0},
    {{NULL},"S_loadLib_FILE_READ_ERROR", (char *) S_loadLib_FILE_READ_ERROR,0},
    {{NULL},"S_loadLib_REALLOC_ERROR", (char *) S_loadLib_REALLOC_ERROR,0},
    {{NULL},"S_loadLib_JMPADDR_ERROR", (char *) S_loadLib_JMPADDR_ERROR,0},
    {{NULL},"S_loadLib_NO_REFLO_PAIR", (char *) S_loadLib_NO_REFLO_PAIR,0},
    {{NULL},"S_loadLib_GPREL_REFERENCE", (char *) S_loadLib_GPREL_REFERENCE,0},
    {{NULL},"S_loadLib_UNRECOGNIZED_RELOCENTRY", (char *) S_loadLib_UNRECOGNIZED_RELOCENTRY,0},
    {{NULL},"S_loadLib_REFHALF_OVFL", (char *) S_loadLib_REFHALF_OVFL,0},
    {{NULL},"S_loadLib_FILE_ENDIAN_ERROR", (char *) S_loadLib_FILE_ENDIAN_ERROR,0},
    {{NULL},"S_loadLib_UNEXPECTED_SYM_CLASS", (char *) S_loadLib_UNEXPECTED_SYM_CLASS,0},
    {{NULL},"S_loadLib_UNRECOGNIZED_SYM_CLASS", (char *) S_loadLib_UNRECOGNIZED_SYM_CLASS,0},
    {{NULL},"S_loadLib_HDR_READ", (char *) S_loadLib_HDR_READ,0},
    {{NULL},"S_loadLib_OPTHDR_READ", (char *) S_loadLib_OPTHDR_READ,0},
    {{NULL},"S_loadLib_SCNHDR_READ", (char *) S_loadLib_SCNHDR_READ,0},
    {{NULL},"S_loadLib_READ_SECTIONS", (char *) S_loadLib_READ_SECTIONS,0},
    {{NULL},"S_loadLib_LOAD_SECTIONS", (char *) S_loadLib_LOAD_SECTIONS,0},
    {{NULL},"S_loadLib_RELOC_READ", (char *) S_loadLib_RELOC_READ,0},
    {{NULL},"S_loadLib_SYMHDR_READ", (char *) S_loadLib_SYMHDR_READ,0},
    {{NULL},"S_loadLib_EXTSTR_READ", (char *) S_loadLib_EXTSTR_READ,0},
    {{NULL},"S_loadLib_EXTSYM_READ", (char *) S_loadLib_EXTSYM_READ,0},
    {{NULL},"S_loadEcoffLib_HDR_READ", (char *) S_loadEcoffLib_HDR_READ,0},
    {{NULL},"S_loadEcoffLib_OPTHDR_READ", (char *) S_loadEcoffLib_OPTHDR_READ,0},
    {{NULL},"S_loadEcoffLib_SCNHDR_READ", (char *) S_loadEcoffLib_SCNHDR_READ,0},
    {{NULL},"S_loadEcoffLib_READ_SECTIONS", (char *) S_loadEcoffLib_READ_SECTIONS,0},
    {{NULL},"S_loadEcoffLib_LOAD_SECTIONS", (char *) S_loadEcoffLib_LOAD_SECTIONS,0},
    {{NULL},"S_loadEcoffLib_RELOC_READ", (char *) S_loadEcoffLib_RELOC_READ,0},
    {{NULL},"S_loadEcoffLib_SYMHDR_READ", (char *) S_loadEcoffLib_SYMHDR_READ,0},
    {{NULL},"S_loadEcoffLib_EXTSTR_READ", (char *) S_loadEcoffLib_EXTSTR_READ,0},
    {{NULL},"S_loadEcoffLib_EXTSYM_READ", (char *) S_loadEcoffLib_EXTSYM_READ,0},
    {{NULL},"S_loadEcoffLib_GPREL_REFERENCE", (char *) S_loadEcoffLib_GPREL_REFERENCE,0},
    {{NULL},"S_loadEcoffLib_JMPADDR_ERROR", (char *) S_loadEcoffLib_JMPADDR_ERROR,0},
    {{NULL},"S_loadEcoffLib_NO_REFLO_PAIR", (char *) S_loadEcoffLib_NO_REFLO_PAIR,0},
    {{NULL},"S_loadEcoffLib_UNRECOGNIZED_RELOCENTRY", (char *) S_loadEcoffLib_UNRECOGNIZED_RELOCENTRY,0},
    {{NULL},"S_loadEcoffLib_REFHALF_OVFL", (char *) S_loadEcoffLib_REFHALF_OVFL,0},
    {{NULL},"S_loadEcoffLib_UNEXPECTED_SYM_CLASS", (char *) S_loadEcoffLib_UNEXPECTED_SYM_CLASS,0},
    {{NULL},"S_loadEcoffLib_UNRECOGNIZED_SYM_CLASS", (char *) S_loadEcoffLib_UNRECOGNIZED_SYM_CLASS,0},
    {{NULL},"S_loadEcoffLib_FILE_READ_ERROR", (char *) S_loadEcoffLib_FILE_READ_ERROR,0},
    {{NULL},"S_loadEcoffLib_FILE_ENDIAN_ERROR", (char *) S_loadEcoffLib_FILE_ENDIAN_ERROR,0},
    {{NULL},"S_loadElfLib_HDR_READ", (char *) S_loadElfLib_HDR_READ,0},
    {{NULL},"S_loadElfLib_HDR_ERROR", (char *) S_loadElfLib_HDR_ERROR,0},
    {{NULL},"S_loadElfLib_PHDR_MALLOC", (char *) S_loadElfLib_PHDR_MALLOC,0},
    {{NULL},"S_loadElfLib_PHDR_READ", (char *) S_loadElfLib_PHDR_READ,0},
    {{NULL},"S_loadElfLib_SHDR_MALLOC", (char *) S_loadElfLib_SHDR_MALLOC,0},
    {{NULL},"S_loadElfLib_SHDR_READ", (char *) S_loadElfLib_SHDR_READ,0},
    {{NULL},"S_loadElfLib_READ_SECTIONS", (char *) S_loadElfLib_READ_SECTIONS,0},
    {{NULL},"S_loadElfLib_LOAD_SECTIONS", (char *) S_loadElfLib_LOAD_SECTIONS,0},
    {{NULL},"S_loadElfLib_LOAD_PROG", (char *) S_loadElfLib_LOAD_PROG,0},
    {{NULL},"S_loadElfLib_SYMTAB", (char *) S_loadElfLib_SYMTAB,0},
    {{NULL},"S_loadElfLib_RELA_SECTION", (char *) S_loadElfLib_RELA_SECTION,0},
    {{NULL},"S_loadElfLib_SCN_READ", (char *) S_loadElfLib_SCN_READ,0},
    {{NULL},"S_loadElfLib_SDA_MALLOC", (char *) S_loadElfLib_SDA_MALLOC,0},
    {{NULL},"S_loadElfLib_SST_READ", (char *) S_loadElfLib_SST_READ,0},
    {{NULL},"S_loadElfLib_JMPADDR_ERROR", (char *) S_loadElfLib_JMPADDR_ERROR,0},
    {{NULL},"S_loadElfLib_GPREL_REFERENCE", (char *) S_loadElfLib_GPREL_REFERENCE,0},
    {{NULL},"S_loadElfLib_UNRECOGNIZED_RELOCENTRY", (char *) S_loadElfLib_UNRECOGNIZED_RELOCENTRY,0},
    {{NULL},"S_loadElfLib_RELOC", (char *) S_loadElfLib_RELOC,0},
    {{NULL},"S_loadElfLib_UNSUPPORTED", (char *) S_loadElfLib_UNSUPPORTED,0},
    {{NULL},"S_loadElfLib_REL_SECTION", (char *) S_loadElfLib_REL_SECTION,0},
    {{NULL},"S_loadLib_ROUTINE_NOT_INSTALLED", (char *) S_loadLib_ROUTINE_NOT_INSTALLED,0},
    {{NULL},"S_loadLib_TOO_MANY_SYMBOLS", (char *) S_loadLib_TOO_MANY_SYMBOLS,0},
    {{NULL},"S_loginLib_UNKNOWN_USER", (char *) S_loginLib_UNKNOWN_USER,0},
    {{NULL},"S_loginLib_USER_ALREADY_EXISTS", (char *) S_loginLib_USER_ALREADY_EXISTS,0},
    {{NULL},"S_loginLib_INVALID_PASSWORD", (char *) S_loginLib_INVALID_PASSWORD,0},
    {{NULL},"S_m2Lib_INVALID_PARAMETER", (char *) S_m2Lib_INVALID_PARAMETER,0},
    {{NULL},"S_m2Lib_ENTRY_NOT_FOUND", (char *) S_m2Lib_ENTRY_NOT_FOUND,0},
    {{NULL},"S_m2Lib_TCPCONN_FD_NOT_FOUND", (char *) S_m2Lib_TCPCONN_FD_NOT_FOUND,0},
    {{NULL},"S_m2Lib_INVALID_VAR_TO_SET", (char *) S_m2Lib_INVALID_VAR_TO_SET,0},
    {{NULL},"S_m2Lib_CANT_CREATE_SYS_SEM", (char *) S_m2Lib_CANT_CREATE_SYS_SEM,0},
    {{NULL},"S_m2Lib_CANT_CREATE_IF_SEM", (char *) S_m2Lib_CANT_CREATE_IF_SEM,0},
    {{NULL},"S_m2Lib_CANT_CREATE_ROUTE_SEM", (char *) S_m2Lib_CANT_CREATE_ROUTE_SEM,0},
    {{NULL},"S_m2Lib_ARP_PHYSADDR_NOT_SPECIFIED", (char *) S_m2Lib_ARP_PHYSADDR_NOT_SPECIFIED,0},
    {{NULL},"S_m2Lib_IF_TBL_IS_EMPTY", (char *) S_m2Lib_IF_TBL_IS_EMPTY,0},
    {{NULL},"S_m2Lib_IF_CNFG_CHANGED", (char *) S_m2Lib_IF_CNFG_CHANGED,0},
    {{NULL},"S_mbufLib_ID_INVALID", (char *) S_mbufLib_ID_INVALID,0},
    {{NULL},"S_mbufLib_ID_EMPTY", (char *) S_mbufLib_ID_EMPTY,0},
    {{NULL},"S_mbufLib_SEGMENT_NOT_FOUND", (char *) S_mbufLib_SEGMENT_NOT_FOUND,0},
    {{NULL},"S_mbufLib_LENGTH_INVALID", (char *) S_mbufLib_LENGTH_INVALID,0},
    {{NULL},"S_mbufLib_OFFSET_INVALID", (char *) S_mbufLib_OFFSET_INVALID,0},
    {{NULL},"S_memLib_NOT_ENOUGH_MEMORY", (char *) S_memLib_NOT_ENOUGH_MEMORY,0},
    {{NULL},"S_memLib_INVALID_NBYTES", (char *) S_memLib_INVALID_NBYTES,0},
    {{NULL},"S_memLib_BLOCK_ERROR", (char *) S_memLib_BLOCK_ERROR,0},
    {{NULL},"S_memLib_NO_PARTITION_DESTROY", (char *) S_memLib_NO_PARTITION_DESTROY,0},
    {{NULL},"S_memLib_PAGE_SIZE_UNAVAILABLE", (char *) S_memLib_PAGE_SIZE_UNAVAILABLE,0},
    {{NULL},"S_mmuLib_INVALID_PAGE_SIZE", (char *) S_mmuLib_INVALID_PAGE_SIZE,0},
    {{NULL},"S_mmuLib_NO_DESCRIPTOR", (char *) S_mmuLib_NO_DESCRIPTOR,0},
    {{NULL},"S_mmuLib_INVALID_DESCRIPTOR", (char *) S_mmuLib_INVALID_DESCRIPTOR,0},
    {{NULL},"S_mmuLib_OUT_OF_PMEGS", (char *) S_mmuLib_OUT_OF_PMEGS,0},
    {{NULL},"S_mmuLib_VIRT_ADDR_OUT_OF_BOUNDS", (char *) S_mmuLib_VIRT_ADDR_OUT_OF_BOUNDS,0},
    {{NULL},"S_moduleLib_MODULE_NOT_FOUND", (char *) S_moduleLib_MODULE_NOT_FOUND,0},
    {{NULL},"S_moduleLib_HOOK_NOT_FOUND", (char *) S_moduleLib_HOOK_NOT_FOUND,0},
    {{NULL},"S_moduleLib_BAD_CHECKSUM", (char *) S_moduleLib_BAD_CHECKSUM,0},
    {{NULL},"S_moduleLib_MAX_MODULES_LOADED", (char *) S_moduleLib_MAX_MODULES_LOADED,0},
    {{NULL},"S_mountLib_ILLEGAL_MODE", (char *) S_mountLib_ILLEGAL_MODE,0},
    {{NULL},"S_msgQLib_INVALID_MSG_LENGTH", (char *) S_msgQLib_INVALID_MSG_LENGTH,0},
    {{NULL},"S_msgQLib_NON_ZERO_TIMEOUT_AT_INT_LEVEL", (char *) S_msgQLib_NON_ZERO_TIMEOUT_AT_INT_LEVEL,0},
    {{NULL},"S_msgQLib_INVALID_QUEUE_TYPE", (char *) S_msgQLib_INVALID_QUEUE_TYPE,0},
    {{NULL},"S_netDrv_INVALID_NUMBER_OF_BYTES", (char *) S_netDrv_INVALID_NUMBER_OF_BYTES,0},
    {{NULL},"S_netDrv_SEND_ERROR", (char *) S_netDrv_SEND_ERROR,0},
    {{NULL},"S_netDrv_RECV_ERROR", (char *) S_netDrv_RECV_ERROR,0},
    {{NULL},"S_netDrv_UNKNOWN_REQUEST", (char *) S_netDrv_UNKNOWN_REQUEST,0},
    {{NULL},"S_netDrv_BAD_SEEK", (char *) S_netDrv_BAD_SEEK,0},
    {{NULL},"S_netDrv_SEEK_PAST_EOF_ERROR", (char *) S_netDrv_SEEK_PAST_EOF_ERROR,0},
    {{NULL},"S_netDrv_BAD_EOF_POSITION", (char *) S_netDrv_BAD_EOF_POSITION,0},
    {{NULL},"S_netDrv_SEEK_FATAL_ERROR", (char *) S_netDrv_SEEK_FATAL_ERROR,0},
    {{NULL},"S_netDrv_WRITE_ONLY_CANNOT_READ", (char *) S_netDrv_WRITE_ONLY_CANNOT_READ,0},
    {{NULL},"S_netDrv_READ_ONLY_CANNOT_WRITE", (char *) S_netDrv_READ_ONLY_CANNOT_WRITE,0},
    {{NULL},"S_netDrv_READ_ERROR", (char *) S_netDrv_READ_ERROR,0},
    {{NULL},"S_netDrv_WRITE_ERROR", (char *) S_netDrv_WRITE_ERROR,0},
    {{NULL},"S_netDrv_NO_SUCH_FILE_OR_DIR", (char *) S_netDrv_NO_SUCH_FILE_OR_DIR,0},
    {{NULL},"S_netDrv_PERMISSION_DENIED", (char *) S_netDrv_PERMISSION_DENIED,0},
    {{NULL},"S_netDrv_IS_A_DIRECTORY", (char *) S_netDrv_IS_A_DIRECTORY,0},
    {{NULL},"S_netDrv_UNIX_FILE_ERROR", (char *) S_netDrv_UNIX_FILE_ERROR,0},
    {{NULL},"S_nfsDrv_INVALID_NUMBER_OF_BYTES", (char *) S_nfsDrv_INVALID_NUMBER_OF_BYTES,0},
    {{NULL},"S_nfsDrv_BAD_FLAG_MODE", (char *) S_nfsDrv_BAD_FLAG_MODE,0},
    {{NULL},"S_nfsDrv_CREATE_NO_FILE_NAME", (char *) S_nfsDrv_CREATE_NO_FILE_NAME,0},
    {{NULL},"S_nfsDrv_FATAL_ERR_FLUSH_INVALID_CACHE", (char *) S_nfsDrv_FATAL_ERR_FLUSH_INVALID_CACHE,0},
    {{NULL},"S_nfsDrv_WRITE_ONLY_CANNOT_READ", (char *) S_nfsDrv_WRITE_ONLY_CANNOT_READ,0},
    {{NULL},"S_nfsDrv_READ_ONLY_CANNOT_WRITE", (char *) S_nfsDrv_READ_ONLY_CANNOT_WRITE,0},
    {{NULL},"S_nfsDrv_NOT_AN_NFS_DEVICE", (char *) S_nfsDrv_NOT_AN_NFS_DEVICE,0},
    {{NULL},"S_nfsDrv_NO_HOST_NAME_SPECIFIED", (char *) S_nfsDrv_NO_HOST_NAME_SPECIFIED,0},
    {{NULL},"S_nfsLib_NFS_AUTH_UNIX_FAILED", (char *) S_nfsLib_NFS_AUTH_UNIX_FAILED,0},
    {{NULL},"S_nfsLib_NFS_INAPPLICABLE_FILE_TYPE", (char *) S_nfsLib_NFS_INAPPLICABLE_FILE_TYPE,0},
    {{NULL},"S_nfsLib_NFS_OK", (char *) S_nfsLib_NFS_OK,0},
    {{NULL},"S_nfsLib_NFSERR_PERM", (char *) S_nfsLib_NFSERR_PERM,0},
    {{NULL},"S_nfsLib_NFSERR_NOENT", (char *) S_nfsLib_NFSERR_NOENT,0},
    {{NULL},"S_nfsLib_NFSERR_IO", (char *) S_nfsLib_NFSERR_IO,0},
    {{NULL},"S_nfsLib_NFSERR_NXIO", (char *) S_nfsLib_NFSERR_NXIO,0},
    {{NULL},"S_nfsLib_NFSERR_ACCES", (char *) S_nfsLib_NFSERR_ACCES,0},
    {{NULL},"S_nfsLib_NFSERR_EXIST", (char *) S_nfsLib_NFSERR_EXIST,0},
    {{NULL},"S_nfsLib_NFSERR_NODEV", (char *) S_nfsLib_NFSERR_NODEV,0},
    {{NULL},"S_nfsLib_NFSERR_NOTDIR", (char *) S_nfsLib_NFSERR_NOTDIR,0},
    {{NULL},"S_nfsLib_NFSERR_ISDIR", (char *) S_nfsLib_NFSERR_ISDIR,0},
    {{NULL},"S_nfsLib_NFSERR_FBIG", (char *) S_nfsLib_NFSERR_FBIG,0},
    {{NULL},"S_nfsLib_NFSERR_NOSPC", (char *) S_nfsLib_NFSERR_NOSPC,0},
    {{NULL},"S_nfsLib_NFSERR_ROFS", (char *) S_nfsLib_NFSERR_ROFS,0},
    {{NULL},"S_nfsLib_NFSERR_NAMETOOLONG", (char *) S_nfsLib_NFSERR_NAMETOOLONG,0},
    {{NULL},"S_nfsLib_NFSERR_NOTEMPTY", (char *) S_nfsLib_NFSERR_NOTEMPTY,0},
    {{NULL},"S_nfsLib_NFSERR_DQUOT", (char *) S_nfsLib_NFSERR_DQUOT,0},
    {{NULL},"S_nfsLib_NFSERR_STALE", (char *) S_nfsLib_NFSERR_STALE,0},
    {{NULL},"S_nfsLib_NFSERR_WFLUSH", (char *) S_nfsLib_NFSERR_WFLUSH,0},
    {{NULL},"S_objLib_OBJ_ID_ERROR", (char *) S_objLib_OBJ_ID_ERROR,0},
    {{NULL},"S_objLib_OBJ_UNAVAILABLE", (char *) S_objLib_OBJ_UNAVAILABLE,0},
    {{NULL},"S_objLib_OBJ_DELETED", (char *) S_objLib_OBJ_DELETED,0},
    {{NULL},"S_objLib_OBJ_TIMEOUT", (char *) S_objLib_OBJ_TIMEOUT,0},
    {{NULL},"S_objLib_OBJ_NO_METHOD", (char *) S_objLib_OBJ_NO_METHOD,0},
    {{NULL},"S_pingLib_NOT_INITIALIZED", (char *) S_pingLib_NOT_INITIALIZED,0},
    {{NULL},"S_pingLib_TIMEOUT", (char *) S_pingLib_TIMEOUT,0},
    {{NULL},"S_proxyArpLib_INVALID_PARAMETER", (char *) S_proxyArpLib_INVALID_PARAMETER,0},
    {{NULL},"S_proxyArpLib_INVALID_INTERFACE", (char *) S_proxyArpLib_INVALID_INTERFACE,0},
    {{NULL},"S_proxyArpLib_INVALID_PROXY_NET", (char *) S_proxyArpLib_INVALID_PROXY_NET,0},
    {{NULL},"S_proxyArpLib_INVALID_CLIENT", (char *) S_proxyArpLib_INVALID_CLIENT,0},
    {{NULL},"S_proxyArpLib_INVALID_ADDRESS", (char *) S_proxyArpLib_INVALID_ADDRESS,0},
    {{NULL},"S_proxyArpLib_TIMEOUT", (char *) S_proxyArpLib_TIMEOUT,0},
    {{NULL},"S_qLib_Q_CLASS_ID_ERROR", (char *) S_qLib_Q_CLASS_ID_ERROR,0},
    {{NULL},"S_qPriBMapLib_NULL_BMAP_LIST", (char *) S_qPriBMapLib_NULL_BMAP_LIST,0},
    {{NULL},"S_qPriHeapLib_NULL_HEAP_ARRAY", (char *) S_qPriHeapLib_NULL_HEAP_ARRAY,0},
    {{NULL},"S_rawFsLib_VOLUME_NOT_AVAILABLE", (char *) S_rawFsLib_VOLUME_NOT_AVAILABLE,0},
    {{NULL},"S_rawFsLib_END_OF_DEVICE", (char *) S_rawFsLib_END_OF_DEVICE,0},
    {{NULL},"S_rawFsLib_NO_FREE_FILE_DESCRIPTORS", (char *) S_rawFsLib_NO_FREE_FILE_DESCRIPTORS,0},
    {{NULL},"S_rawFsLib_INVALID_NUMBER_OF_BYTES", (char *) S_rawFsLib_INVALID_NUMBER_OF_BYTES,0},
    {{NULL},"S_rawFsLib_ILLEGAL_NAME", (char *) S_rawFsLib_ILLEGAL_NAME,0},
    {{NULL},"S_rawFsLib_NOT_FILE", (char *) S_rawFsLib_NOT_FILE,0},
    {{NULL},"S_rawFsLib_READ_ONLY", (char *) S_rawFsLib_READ_ONLY,0},
    {{NULL},"S_rawFsLib_FD_OBSOLETE", (char *) S_rawFsLib_FD_OBSOLETE,0},
    {{NULL},"S_rawFsLib_NO_BLOCK_DEVICE", (char *) S_rawFsLib_NO_BLOCK_DEVICE,0},
    {{NULL},"S_rawFsLib_BAD_SEEK", (char *) S_rawFsLib_BAD_SEEK,0},
    {{NULL},"S_remLib_ALL_PORTS_IN_USE", (char *) S_remLib_ALL_PORTS_IN_USE,0},
    {{NULL},"S_remLib_RSH_ERROR", (char *) S_remLib_RSH_ERROR,0},
    {{NULL},"S_remLib_IDENTITY_TOO_BIG", (char *) S_remLib_IDENTITY_TOO_BIG,0},
    {{NULL},"S_routeLib_ILLEGAL_INTERNET_ADDRESS", (char *) S_routeLib_ILLEGAL_INTERNET_ADDRESS,0},
    {{NULL},"S_routeLib_ILLEGAL_NETWORK_NUMBER", (char *) S_routeLib_ILLEGAL_NETWORK_NUMBER,0},
    {{NULL},"S_rpcLib_RPC_SUCCESS", (char *) S_rpcLib_RPC_SUCCESS,0},
    {{NULL},"S_rpcLib_RPC_CANTENCODEARGS", (char *) S_rpcLib_RPC_CANTENCODEARGS,0},
    {{NULL},"S_rpcLib_RPC_CANTDECODERES", (char *) S_rpcLib_RPC_CANTDECODERES,0},
    {{NULL},"S_rpcLib_RPC_CANTSEND", (char *) S_rpcLib_RPC_CANTSEND,0},
    {{NULL},"S_rpcLib_RPC_CANTRECV", (char *) S_rpcLib_RPC_CANTRECV,0},
    {{NULL},"S_rpcLib_RPC_TIMEDOUT", (char *) S_rpcLib_RPC_TIMEDOUT,0},
    {{NULL},"S_rpcLib_RPC_VERSMISMATCH", (char *) S_rpcLib_RPC_VERSMISMATCH,0},
    {{NULL},"S_rpcLib_RPC_AUTHERROR", (char *) S_rpcLib_RPC_AUTHERROR,0},
    {{NULL},"S_rpcLib_RPC_PROGUNAVAIL", (char *) S_rpcLib_RPC_PROGUNAVAIL,0},
    {{NULL},"S_rpcLib_RPC_PROGVERSMISMATCH", (char *) S_rpcLib_RPC_PROGVERSMISMATCH,0},
    {{NULL},"S_rpcLib_RPC_PROCUNAVAIL", (char *) S_rpcLib_RPC_PROCUNAVAIL,0},
    {{NULL},"S_rpcLib_RPC_CANTDECODEARGS", (char *) S_rpcLib_RPC_CANTDECODEARGS,0},
    {{NULL},"S_rpcLib_RPC_SYSTEMERROR", (char *) S_rpcLib_RPC_SYSTEMERROR,0},
    {{NULL},"S_rpcLib_RPC_UNKNOWNHOST", (char *) S_rpcLib_RPC_UNKNOWNHOST,0},
    {{NULL},"S_rpcLib_RPC_PMAPFAILURE", (char *) S_rpcLib_RPC_PMAPFAILURE,0},
    {{NULL},"S_rpcLib_RPC_PROGNOTREGISTERED", (char *) S_rpcLib_RPC_PROGNOTREGISTERED,0},
    {{NULL},"S_rpcLib_RPC_FAILED", (char *) S_rpcLib_RPC_FAILED,0},
    {{NULL},"S_rt11FsLib_VOLUME_NOT_AVAILABLE", (char *) S_rt11FsLib_VOLUME_NOT_AVAILABLE,0},
    {{NULL},"S_rt11FsLib_DISK_FULL", (char *) S_rt11FsLib_DISK_FULL,0},
    {{NULL},"S_rt11FsLib_FILE_NOT_FOUND", (char *) S_rt11FsLib_FILE_NOT_FOUND,0},
    {{NULL},"S_rt11FsLib_NO_FREE_FILE_DESCRIPTORS", (char *) S_rt11FsLib_NO_FREE_FILE_DESCRIPTORS,0},
    {{NULL},"S_rt11FsLib_INVALID_NUMBER_OF_BYTES", (char *) S_rt11FsLib_INVALID_NUMBER_OF_BYTES,0},
    {{NULL},"S_rt11FsLib_FILE_ALREADY_EXISTS", (char *) S_rt11FsLib_FILE_ALREADY_EXISTS,0},
    {{NULL},"S_rt11FsLib_BEYOND_FILE_LIMIT", (char *) S_rt11FsLib_BEYOND_FILE_LIMIT,0},
    {{NULL},"S_rt11FsLib_INVALID_DEVICE_PARAMETERS", (char *) S_rt11FsLib_INVALID_DEVICE_PARAMETERS,0},
    {{NULL},"S_rt11FsLib_NO_MORE_FILES_ALLOWED_ON_DISK", (char *) S_rt11FsLib_NO_MORE_FILES_ALLOWED_ON_DISK,0},
    {{NULL},"S_rt11FsLib_ENTRY_NUMBER_TOO_BIG", (char *) S_rt11FsLib_ENTRY_NUMBER_TOO_BIG,0},
    {{NULL},"S_rt11FsLib_NO_BLOCK_DEVICE", (char *) S_rt11FsLib_NO_BLOCK_DEVICE,0},
    {{NULL},"S_scsiLib_DEV_NOT_READY", (char *) S_scsiLib_DEV_NOT_READY,0},
    {{NULL},"S_scsiLib_WRITE_PROTECTED", (char *) S_scsiLib_WRITE_PROTECTED,0},
    {{NULL},"S_scsiLib_MEDIUM_ERROR", (char *) S_scsiLib_MEDIUM_ERROR,0},
    {{NULL},"S_scsiLib_HARDWARE_ERROR", (char *) S_scsiLib_HARDWARE_ERROR,0},
    {{NULL},"S_scsiLib_ILLEGAL_REQUEST", (char *) S_scsiLib_ILLEGAL_REQUEST,0},
    {{NULL},"S_scsiLib_BLANK_CHECK", (char *) S_scsiLib_BLANK_CHECK,0},
    {{NULL},"S_scsiLib_ABORTED_COMMAND", (char *) S_scsiLib_ABORTED_COMMAND,0},
    {{NULL},"S_scsiLib_VOLUME_OVERFLOW", (char *) S_scsiLib_VOLUME_OVERFLOW,0},
    {{NULL},"S_scsiLib_UNIT_ATTENTION", (char *) S_scsiLib_UNIT_ATTENTION,0},
    {{NULL},"S_scsiLib_SELECT_TIMEOUT", (char *) S_scsiLib_SELECT_TIMEOUT,0},
    {{NULL},"S_scsiLib_LUN_NOT_PRESENT", (char *) S_scsiLib_LUN_NOT_PRESENT,0},
    {{NULL},"S_scsiLib_ILLEGAL_BUS_ID", (char *) S_scsiLib_ILLEGAL_BUS_ID,0},
    {{NULL},"S_scsiLib_NO_CONTROLLER", (char *) S_scsiLib_NO_CONTROLLER,0},
    {{NULL},"S_scsiLib_REQ_SENSE_ERROR", (char *) S_scsiLib_REQ_SENSE_ERROR,0},
    {{NULL},"S_scsiLib_DEV_UNSUPPORTED", (char *) S_scsiLib_DEV_UNSUPPORTED,0},
    {{NULL},"S_scsiLib_ILLEGAL_PARAMETER", (char *) S_scsiLib_ILLEGAL_PARAMETER,0},
    {{NULL},"S_scsiLib_EARLY_PHASE_CHANGE", (char *) S_scsiLib_EARLY_PHASE_CHANGE,0},
    {{NULL},"S_scsiLib_PHASE_CHANGE_TIMEOUT", (char *) S_scsiLib_PHASE_CHANGE_TIMEOUT,0},
    {{NULL},"S_scsiLib_ILLEGAL_OPERATION", (char *) S_scsiLib_ILLEGAL_OPERATION,0},
    {{NULL},"S_scsiLib_DEVICE_EXIST", (char *) S_scsiLib_DEVICE_EXIST,0},
    {{NULL},"S_scsiLib_SYNC_UNSUPPORTED", (char *) S_scsiLib_SYNC_UNSUPPORTED,0},
    {{NULL},"S_scsiLib_SYNC_VAL_UNSUPPORTED", (char *) S_scsiLib_SYNC_VAL_UNSUPPORTED,0},
    {{NULL},"S_scsiLib_DATA_TRANSFER_TIMEOUT", (char *) S_scsiLib_DATA_TRANSFER_TIMEOUT,0},
    {{NULL},"S_scsiLib_UNKNOWN_PHASE", (char *) S_scsiLib_UNKNOWN_PHASE,0},
    {{NULL},"S_scsiLib_DEV_NOT_READY", (char *) S_scsiLib_DEV_NOT_READY,0},
    {{NULL},"S_scsiLib_WRITE_PROTECTED", (char *) S_scsiLib_WRITE_PROTECTED,0},
    {{NULL},"S_scsiLib_MEDIUM_ERROR", (char *) S_scsiLib_MEDIUM_ERROR,0},
    {{NULL},"S_scsiLib_HARDWARE_ERROR", (char *) S_scsiLib_HARDWARE_ERROR,0},
    {{NULL},"S_scsiLib_ILLEGAL_REQUEST", (char *) S_scsiLib_ILLEGAL_REQUEST,0},
    {{NULL},"S_scsiLib_BLANK_CHECK", (char *) S_scsiLib_BLANK_CHECK,0},
    {{NULL},"S_scsiLib_ABORTED_COMMAND", (char *) S_scsiLib_ABORTED_COMMAND,0},
    {{NULL},"S_scsiLib_VOLUME_OVERFLOW", (char *) S_scsiLib_VOLUME_OVERFLOW,0},
    {{NULL},"S_scsiLib_UNIT_ATTENTION", (char *) S_scsiLib_UNIT_ATTENTION,0},
    {{NULL},"S_scsiLib_SELECT_TIMEOUT", (char *) S_scsiLib_SELECT_TIMEOUT,0},
    {{NULL},"S_scsiLib_LUN_NOT_PRESENT", (char *) S_scsiLib_LUN_NOT_PRESENT,0},
    {{NULL},"S_scsiLib_ILLEGAL_BUS_ID", (char *) S_scsiLib_ILLEGAL_BUS_ID,0},
    {{NULL},"S_scsiLib_NO_CONTROLLER", (char *) S_scsiLib_NO_CONTROLLER,0},
    {{NULL},"S_scsiLib_REQ_SENSE_ERROR", (char *) S_scsiLib_REQ_SENSE_ERROR,0},
    {{NULL},"S_scsiLib_DEV_UNSUPPORTED", (char *) S_scsiLib_DEV_UNSUPPORTED,0},
    {{NULL},"S_scsiLib_ILLEGAL_PARAMETER", (char *) S_scsiLib_ILLEGAL_PARAMETER,0},
    {{NULL},"S_scsiLib_INVALID_PHASE", (char *) S_scsiLib_INVALID_PHASE,0},
    {{NULL},"S_scsiLib_ABORTED", (char *) S_scsiLib_ABORTED,0},
    {{NULL},"S_scsiLib_ILLEGAL_OPERATION", (char *) S_scsiLib_ILLEGAL_OPERATION,0},
    {{NULL},"S_scsiLib_DEVICE_EXIST", (char *) S_scsiLib_DEVICE_EXIST,0},
    {{NULL},"S_scsiLib_DISCONNECTED", (char *) S_scsiLib_DISCONNECTED,0},
    {{NULL},"S_scsiLib_BUS_RESET", (char *) S_scsiLib_BUS_RESET,0},
    {{NULL},"S_scsiLib_INVALID_TAG_TYPE", (char *) S_scsiLib_INVALID_TAG_TYPE,0},
    {{NULL},"S_scsiLib_SOFTWARE_ERROR", (char *) S_scsiLib_SOFTWARE_ERROR,0},
    {{NULL},"S_scsiLib_NO_MORE_THREADS", (char *) S_scsiLib_NO_MORE_THREADS,0},
    {{NULL},"S_scsiLib_UNKNOWN_SENSE_DATA", (char *) S_scsiLib_UNKNOWN_SENSE_DATA,0},
    {{NULL},"S_scsiLib_INVALID_BLOCK_SIZE", (char *) S_scsiLib_INVALID_BLOCK_SIZE,0},
    {{NULL},"S_selectLib_NO_SELECT_SUPPORT_IN_DRIVER", (char *) S_selectLib_NO_SELECT_SUPPORT_IN_DRIVER,0},
    {{NULL},"S_semLib_INVALID_STATE", (char *) S_semLib_INVALID_STATE,0},
    {{NULL},"S_semLib_INVALID_OPTION", (char *) S_semLib_INVALID_OPTION,0},
    {{NULL},"S_semLib_INVALID_QUEUE_TYPE", (char *) S_semLib_INVALID_QUEUE_TYPE,0},
    {{NULL},"S_semLib_INVALID_OPERATION", (char *) S_semLib_INVALID_OPERATION,0},
    {{NULL},"S_smLib_MEMORY_ERROR", (char *) S_smLib_MEMORY_ERROR,0},
    {{NULL},"S_smLib_INVALID_CPU_NUMBER", (char *) S_smLib_INVALID_CPU_NUMBER,0},
    {{NULL},"S_smLib_NOT_ATTACHED", (char *) S_smLib_NOT_ATTACHED,0},
    {{NULL},"S_smLib_NO_REGIONS", (char *) S_smLib_NO_REGIONS,0},
    {{NULL},"S_smNameLib_NOT_INITIALIZED", (char *) S_smNameLib_NOT_INITIALIZED,0},
    {{NULL},"S_smNameLib_NAME_TOO_LONG", (char *) S_smNameLib_NAME_TOO_LONG,0},
    {{NULL},"S_smNameLib_NAME_NOT_FOUND", (char *) S_smNameLib_NAME_NOT_FOUND,0},
    {{NULL},"S_smNameLib_VALUE_NOT_FOUND", (char *) S_smNameLib_VALUE_NOT_FOUND,0},
    {{NULL},"S_smNameLib_NAME_ALREADY_EXIST", (char *) S_smNameLib_NAME_ALREADY_EXIST,0},
    {{NULL},"S_smNameLib_DATABASE_FULL", (char *) S_smNameLib_DATABASE_FULL,0},
    {{NULL},"S_smNameLib_INVALID_WAIT_TYPE", (char *) S_smNameLib_INVALID_WAIT_TYPE,0},
    {{NULL},"S_smObjLib_NOT_INITIALIZED", (char *) S_smObjLib_NOT_INITIALIZED,0},
    {{NULL},"S_smObjLib_NOT_A_GLOBAL_ADRS", (char *) S_smObjLib_NOT_A_GLOBAL_ADRS,0},
    {{NULL},"S_smObjLib_NOT_A_LOCAL_ADRS", (char *) S_smObjLib_NOT_A_LOCAL_ADRS,0},
    {{NULL},"S_smObjLib_SHARED_MEM_TOO_SMALL", (char *) S_smObjLib_SHARED_MEM_TOO_SMALL,0},
    {{NULL},"S_smObjLib_TOO_MANY_CPU", (char *) S_smObjLib_TOO_MANY_CPU,0},
    {{NULL},"S_smObjLib_LOCK_TIMEOUT", (char *) S_smObjLib_LOCK_TIMEOUT,0},
    {{NULL},"S_smObjLib_NO_OBJECT_DESTROY", (char *) S_smObjLib_NO_OBJECT_DESTROY,0},
    {{NULL},"S_smPktLib_SHARED_MEM_TOO_SMALL", (char *) S_smPktLib_SHARED_MEM_TOO_SMALL,0},
    {{NULL},"S_smPktLib_MEMORY_ERROR", (char *) S_smPktLib_MEMORY_ERROR,0},
    {{NULL},"S_smPktLib_DOWN", (char *) S_smPktLib_DOWN,0},
    {{NULL},"S_smPktLib_NOT_ATTACHED", (char *) S_smPktLib_NOT_ATTACHED,0},
    {{NULL},"S_smPktLib_INVALID_PACKET", (char *) S_smPktLib_INVALID_PACKET,0},
    {{NULL},"S_smPktLib_PACKET_TOO_BIG", (char *) S_smPktLib_PACKET_TOO_BIG,0},
    {{NULL},"S_smPktLib_INVALID_CPU_NUMBER", (char *) S_smPktLib_INVALID_CPU_NUMBER,0},
    {{NULL},"S_smPktLib_DEST_NOT_ATTACHED", (char *) S_smPktLib_DEST_NOT_ATTACHED,0},
    {{NULL},"S_smPktLib_INCOMPLETE_BROADCAST", (char *) S_smPktLib_INCOMPLETE_BROADCAST,0},
    {{NULL},"S_smPktLib_LIST_FULL", (char *) S_smPktLib_LIST_FULL,0},
    {{NULL},"S_smPktLib_LOCK_TIMEOUT", (char *) S_smPktLib_LOCK_TIMEOUT,0},
    {{NULL},"S_snmpdLib_VIEW_CREATE_FAILURE", (char *) S_snmpdLib_VIEW_CREATE_FAILURE,0},
    {{NULL},"S_snmpdLib_VIEW_INSTALL_FAILURE", (char *) S_snmpdLib_VIEW_INSTALL_FAILURE,0},
    {{NULL},"S_snmpdLib_VIEW_MASK_FAILURE", (char *) S_snmpdLib_VIEW_MASK_FAILURE,0},
    {{NULL},"S_snmpdLib_VIEW_DEINSTALL_FAILURE", (char *) S_snmpdLib_VIEW_DEINSTALL_FAILURE,0},
    {{NULL},"S_snmpdLib_VIEW_LOOKUP_FAILURE", (char *) S_snmpdLib_VIEW_LOOKUP_FAILURE,0},
    {{NULL},"S_snmpdLib_MIB_ADDITION_FAILURE", (char *) S_snmpdLib_MIB_ADDITION_FAILURE,0},
    {{NULL},"S_snmpdLib_NODE_NOT_FOUND", (char *) S_snmpdLib_NODE_NOT_FOUND,0},
    {{NULL},"S_snmpdLib_INVALID_SNMP_VERSION", (char *) S_snmpdLib_INVALID_SNMP_VERSION,0},
    {{NULL},"S_snmpdLib_TRAP_CREATE_FAILURE", (char *) S_snmpdLib_TRAP_CREATE_FAILURE,0},
    {{NULL},"S_snmpdLib_TRAP_BIND_FAILURE", (char *) S_snmpdLib_TRAP_BIND_FAILURE,0},
    {{NULL},"S_snmpdLib_TRAP_ENCODE_FAILURE", (char *) S_snmpdLib_TRAP_ENCODE_FAILURE,0},
    {{NULL},"S_snmpdLib_INVALID_OID_SYNTAX", (char *) S_snmpdLib_INVALID_OID_SYNTAX,0},
    {{NULL},"S_strmLib_DUPLICATE_PROVIDER", (char *) S_strmLib_DUPLICATE_PROVIDER,0},
    {{NULL},"S_strmLib_INVALID_OPEN_STYLE", (char *) S_strmLib_INVALID_OPEN_STYLE,0},
    {{NULL},"S_strmLib_INVALID_SYNC_LEVEL", (char *) S_strmLib_INVALID_SYNC_LEVEL,0},
    {{NULL},"S_symLib_SYMBOL_NOT_FOUND", (char *) S_symLib_SYMBOL_NOT_FOUND,0},
    {{NULL},"S_symLib_NAME_CLASH", (char *) S_symLib_NAME_CLASH,0},
    {{NULL},"S_symLib_TABLE_NOT_EMPTY", (char *) S_symLib_TABLE_NOT_EMPTY,0},
    {{NULL},"S_symLib_SYMBOL_STILL_IN_TABLE", (char *) S_symLib_SYMBOL_STILL_IN_TABLE,0},
    {{NULL},"S_tapeFsLib_NO_SEQ_DEV", (char *) S_tapeFsLib_NO_SEQ_DEV,0},
    {{NULL},"S_tapeFsLib_ILLEGAL_TAPE_CONFIG_PARM", (char *) S_tapeFsLib_ILLEGAL_TAPE_CONFIG_PARM,0},
    {{NULL},"S_tapeFsLib_SERVICE_NOT_AVAILABLE", (char *) S_tapeFsLib_SERVICE_NOT_AVAILABLE,0},
    {{NULL},"S_tapeFsLib_INVALID_BLOCK_SIZE", (char *) S_tapeFsLib_INVALID_BLOCK_SIZE,0},
    {{NULL},"S_tapeFsLib_ILLEGAL_FILE_SYSTEM_NAME", (char *) S_tapeFsLib_ILLEGAL_FILE_SYSTEM_NAME,0},
    {{NULL},"S_tapeFsLib_ILLEGAL_FLAGS", (char *) S_tapeFsLib_ILLEGAL_FLAGS,0},
    {{NULL},"S_tapeFsLib_FILE_DESCRIPTOR_BUSY", (char *) S_tapeFsLib_FILE_DESCRIPTOR_BUSY,0},
    {{NULL},"S_tapeFsLib_VOLUME_NOT_AVAILABLE", (char *) S_tapeFsLib_VOLUME_NOT_AVAILABLE,0},
    {{NULL},"S_tapeFsLib_BLOCK_SIZE_MISMATCH", (char *) S_tapeFsLib_BLOCK_SIZE_MISMATCH,0},
    {{NULL},"S_tapeFsLib_INVALID_NUMBER_OF_BYTES", (char *) S_tapeFsLib_INVALID_NUMBER_OF_BYTES,0},
    {{NULL},"S_taskLib_NAME_NOT_FOUND", (char *) S_taskLib_NAME_NOT_FOUND,0},
    {{NULL},"S_taskLib_TASK_HOOK_TABLE_FULL", (char *) S_taskLib_TASK_HOOK_TABLE_FULL,0},
    {{NULL},"S_taskLib_TASK_HOOK_NOT_FOUND", (char *) S_taskLib_TASK_HOOK_NOT_FOUND,0},
    {{NULL},"S_taskLib_TASK_SWAP_HOOK_REFERENCED", (char *) S_taskLib_TASK_SWAP_HOOK_REFERENCED,0},
    {{NULL},"S_taskLib_TASK_SWAP_HOOK_SET", (char *) S_taskLib_TASK_SWAP_HOOK_SET,0},
    {{NULL},"S_taskLib_TASK_SWAP_HOOK_CLEAR", (char *) S_taskLib_TASK_SWAP_HOOK_CLEAR,0},
    {{NULL},"S_taskLib_TASK_VAR_NOT_FOUND", (char *) S_taskLib_TASK_VAR_NOT_FOUND,0},
    {{NULL},"S_taskLib_TASK_UNDELAYED", (char *) S_taskLib_TASK_UNDELAYED,0},
    {{NULL},"S_taskLib_ILLEGAL_PRIORITY", (char *) S_taskLib_ILLEGAL_PRIORITY,0},
    {{NULL},"S_tftpLib_INVALID_ARGUMENT", (char *) S_tftpLib_INVALID_ARGUMENT,0},
    {{NULL},"S_tftpLib_INVALID_DESCRIPTOR", (char *) S_tftpLib_INVALID_DESCRIPTOR,0},
    {{NULL},"S_tftpLib_INVALID_COMMAND", (char *) S_tftpLib_INVALID_COMMAND,0},
    {{NULL},"S_tftpLib_INVALID_MODE", (char *) S_tftpLib_INVALID_MODE,0},
    {{NULL},"S_tftpLib_UNKNOWN_HOST", (char *) S_tftpLib_UNKNOWN_HOST,0},
    {{NULL},"S_tftpLib_NOT_CONNECTED", (char *) S_tftpLib_NOT_CONNECTED,0},
    {{NULL},"S_tftpLib_TIMED_OUT", (char *) S_tftpLib_TIMED_OUT,0},
    {{NULL},"S_tftpLib_TFTP_ERROR", (char *) S_tftpLib_TFTP_ERROR,0},
    {{NULL},"S_unldLib_MODULE_NOT_FOUND", (char *) S_unldLib_MODULE_NOT_FOUND,0},
    {{NULL},"S_unldLib_TEXT_IN_USE", (char *) S_unldLib_TEXT_IN_USE,0},
    {{NULL},"S_usrLib_NOT_ENOUGH_ARGS", (char *) S_usrLib_NOT_ENOUGH_ARGS,0},
    {{NULL},"S_vmLib_NOT_PAGE_ALIGNED", (char *) S_vmLib_NOT_PAGE_ALIGNED,0},
    {{NULL},"S_vmLib_BAD_STATE_PARAM", (char *) S_vmLib_BAD_STATE_PARAM,0},
    {{NULL},"S_vmLib_BAD_MASK_PARAM", (char *) S_vmLib_BAD_MASK_PARAM,0},
    {{NULL},"S_vmLib_ADDR_IN_GLOBAL_SPACE", (char *) S_vmLib_ADDR_IN_GLOBAL_SPACE,0},
    {{NULL},"S_vmLib_TEXT_PROTECTION_UNAVAILABLE", (char *) S_vmLib_TEXT_PROTECTION_UNAVAILABLE,0},
    };

ULONG statTblSize = NELEMENTS (statTbl);
